﻿#NoTrayIcon
#Region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_Icon=Images\logo-128x128.ico
#AutoIt3Wrapper_UseX64=y
#AutoIt3Wrapper_Res_Comment=Media-Buddy V1.3
#AutoIt3Wrapper_Res_Description=Media-Buddy V1.3
#AutoIt3Wrapper_Res_Fileversion=1.3.0.13
#AutoIt3Wrapper_Res_Fileversion_AutoIncrement=y
#AutoIt3Wrapper_Res_ProductName=Media-Buddy
#AutoIt3Wrapper_Res_ProductVersion=1.3.0
#AutoIt3Wrapper_Res_LegalCopyright=Lehmden 2024
#AutoIt3Wrapper_Res_Language=1031
#EndRegion ;**** Directives created by AutoIt3Wrapper_GUI ****

#Region ;Legal stuff
#comments-start

	Media-Buddy
	by Lehmden 2024

	Licence:
	This program is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.
	You should have received a copy of the GNU General Public License
	along with this program.  If not, see <http://www.gnu.org/licenses/>.


	Dieses Programm ist Freie Software: Sie können es unter den Bedingungen
	der GNU General Public License, wie von der Free Software Foundation,
	Version 3 der Lizenz oder (nach Ihrer Wahl) jeder neueren
	veröffentlichten Version, weiterverbreiten und/oder modifizieren.

	Dieses Programm wird in der Hoffnung, dass es nützlich sein wird, aber
	OHNE JEde GEWÄHRLEISTUNG, bereitgestellt; sogar ohne die implizite
	Gewährleistung der MARKTFÄHIGKEIT oder EIGNUNG FÜR EINEN BESTIMMTEN ZWECK.
	Siehe die GNU General Public License für weitere Details.

	Sie sollten eine Kopie der GNU General Public License zusammen mit diesem
	Programm erhalten haben. Wenn nicht, siehe <http://www.gnu.org/licenses/>.

#comments-end
#EndRegion ;Legal stuff

#Region ;Splash Image

	If @Compiled = 1 Then SplashImageOn("", @ScriptDir & "\Images\Media-Buddy_Splash.jpg", 700, 300, -1, -1, 1)

#EndRegion

#Region ;Includes

#include <GUIConstants.au3>
#Include <string.au3>
#include <Date.au3>
#include <GuiListView.au3>
#include <GDIPlus.au3>
#include <Array.au3>
#include <File.au3>
#include <SQLite.au3>
#include <MySQL.au3>
#include <Crypt.au3>
#include <WinAPI.au3>
#include <Timers.au3>
#include <Constants.au3>
#include <ButtonConstants.au3>
#include <GuiListView.au3>
#include <listviewconstants.au3>
#include <ListBoxConstants.au3>
#include <GUIConstantsEx.au3>
#include <JSON.au3>
#include <FileConstants.au3>
#include <forceutf8.au3>
#include <GuiListBox.au3>


#EndRegion ;Includes

#Region ;Log File Handling

DirCreate(@ScriptDir & "\Log")

If FileExists(@ScriptDir & "\Log\Media-Buddy_3.log") Then

	FileMove(@ScriptDir & "\Log\Media-Buddy_3.log", @ScriptDir & "\Log\Media-Buddy_4.log", 1)

EndIf
If FileExists(@ScriptDir & "\Log\Media-Buddy_2.log") Then

	FileMove(@ScriptDir & "\Log\Media-Buddy_2.log", @ScriptDir & "\Log\Media-Buddy_3.log", 1)

EndIf
If FileExists(@ScriptDir & "\Log\Media-Buddy_1.log") Then

	FileMove(@ScriptDir & "\Log\Media-Buddy_1.log", @ScriptDir & "\Log\Media-Buddy_2.log", 1)

EndIf
If FileExists(@ScriptDir & "\Log\Media-Buddy.log") Then

	FileMove(@ScriptDir & "\Log\Media-Buddy.log", @ScriptDir & "\Log\Media-Buddy_1.log", 1)

EndIf

_WriteLog("*  Starting Media-Buddy  *")

#EndRegion

#Region ;Ini Read Config

; Folders

	Global $ini_3d_inputfolder = IniRead(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_3d_inputfolder", @MyDocumentsDir)
	Global $ini_append_outputfolder = IniRead(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_append_outputfolder", @MyDocumentsDir)
	Global $ini_append_inputfolder = IniRead(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_append_inputfolder", @MyDocumentsDir)
	Global $ini_anorm_inputfolder = IniRead(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_anorm_inputfolder", @MyDocumentsDir)
	Global $ini_anorm_outputfolder = IniRead(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_anorm_outputfolder", @MyDocumentsDir)
	Global $ini_arecode_inputfolder = IniRead(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_arecode_inputfolder", @MyDocumentsDir)
	Global $ini_arecode_outputfolder = IniRead(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_arecode_outputfolder", @MyDocumentsDir)
	Global $ini_artistfolder = IniRead(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_artistfolder", @MyDocumentsDir)
	Global $ini_audio_correction_inputfolder = IniRead(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_audio_correction_inputfolder", @MyDocumentsDir)
	Global $ini_audio_metadata_inputfolder = IniRead(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_audio_metadata_inputfolder", @MyDocumentsDir)
	Global $ini_audiotools_inputfolder = IniRead(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_audiotools_inputfolder", @MyDocumentsDir)
	Global $ini_audiotools_outputfolder = IniRead(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_audiotools_outputfolder", @MyDocumentsDir)
	Global $ini_extract_inputfolder = IniRead(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_extract_inputfolder", @MyDocumentsDir)
	Global $ini_fanart_inputfolder = IniRead(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_fanart_inputfolder", @MyDocumentsDir)
	Global $ini_fix_inputfolder = IniRead(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_fix_inputfolder", @MyDocumentsDir)
	Global $ini_fix_outputfolder = IniRead(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_fix_outputfolder", @MyDocumentsDir)
	Global $ini_graphics_metadata_inputfolder = IniRead(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_graphics_metadata_inputfolder", @MyDocumentsDir)
	Global $ini_graphics_metadata_outputfolder = IniRead(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_graphics_metadata_outputfolder", @MyDocumentsDir)
	Global $ini_kodidot_inputfolder = IniRead(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_kodidot_inputfolder", @MyDocumentsDir)
	Global $ini_kodi19_inputfolder = IniRead(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_kodi19_inputfolder", @MyDocumentsDir)
	Global $ini_kodi19_inputfolder1 = IniRead(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_kodi19_inputfolder1", @MyDocumentsDir)
	Global $ini_koditools_audiofolder = IniRead(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_koditools_audiofolder", @MyDocumentsDir)
	Global $ini_koditools_inputfolder = IniRead(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_koditools_inputfolder", @MyDocumentsDir)
	Global $ini_mediastub_outputfolder = IniRead(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_mediastub_outputfolder", @MyDocumentsDir)
	Global $ini_moviesetfolder = IniRead(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_moviesetfolder", @MyDocumentsDir)
	Global $ini_movies_correction_inputfolder = IniRead(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_movies_correction_inputfolder", @MyDocumentsDir)
	Global $ini_movies_metadata_inputfolder = IniRead(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_movies_metadata_inputfolder", @MyDocumentsDir)
	Global $ini_recode_inputfolder = IniRead(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_recode_inputfolder", @MyDocumentsDir)
	Global $ini_recode_outputfolder = IniRead(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_recode_outputfolder", @MyDocumentsDir)
	Global $ini_remux_inputfolder = IniRead(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_remux_inputfolder", @MyDocumentsDir)
	Global $ini_remux_outputfolder = IniRead(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_remux_outputfolder", @MyDocumentsDir)
	Global $ini_graphics_inputfolder = IniRead(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_graphics_inputfolder", @MyDocumentsDir)
	Global $ini_series_correction_inputfolder = IniRead(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_series_correction_inputfolder", @MyDocumentsDir)
	Global $ini_series_metadata_inputfolder = IniRead(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_series_metadata_inputfolder", @MyDocumentsDir)
	Global $ini_videos_correction_inputfolder = IniRead(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_videos_correction_inputfolder", @MyDocumentsDir)
	Global $ini_videos_metadata_inputfolder = IniRead(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_videos_metadata_inputfolder", @MyDocumentsDir)
	Global $ini_wizard_audio_outputfolder = IniRead(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_wizard_audio_outputfolder", @MyDocumentsDir)
	Global $ini_wizard_audio_inputfolder = IniRead(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_wizard_audio_inputfolder", @MyDocumentsDir)
	Global $ini_wizard_movies_outputfolder = IniRead(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_wizard_movies_outputfolder", @MyDocumentsDir)
	Global $ini_wizard_movies_inputfolder = IniRead(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_wizard_movies_inputfolder", @MyDocumentsDir)
	Global $ini_wizard_series_outputfolder = IniRead(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_wizard_series_outputfolder", @MyDocumentsDir)
	Global $ini_wizard_series_inputfolder = IniRead(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_wizard_series_inputfolder", @MyDocumentsDir)
	Global $ini_wizard_videos_outputfolder = IniRead(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_wizard_videos_outputfolder", @MyDocumentsDir)
	Global $ini_wizard_videos_inputfolder = IniRead(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_wizard_videos_inputfolder", @MyDocumentsDir)


; Program- Path

	Global $ini_ffmpeg_path = IniRead(@ScriptDir & "\Media-Buddy.ini", "path", "ini_ffmpeg_path", @ScriptDir & "\ffmpeg.exe")
	Global $ini_mkvextract_path = IniRead(@ScriptDir & "\Media-Buddy.ini", "path", "ini_mkvextract_path", @ScriptDir & "\mkvextract.exe")
	Global $ini_mkvmerge_path = IniRead(@ScriptDir & "\Media-Buddy.ini", "path", "ini_mkvmerge_path", @ScriptDir & "\mkvmerge.exe")
	Global $ini_mkvpropedit_path = IniRead(@ScriptDir & "\Media-Buddy.ini", "path", "ini_mkvpropedit_path", @ScriptDir & "\mkvpropedit.exe")
	Global $ini_workingdrive = IniRead(@ScriptDir & "\Media-Buddy.ini", "path", "ini_workingdrive", "c:")


; General Settings Config

	Global $ini_artist = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_artist", "1")
	Global $ini_audiolanguages = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_audiolanguages", "en")
	Global $ini_channelovercodec = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_channelovercodec", "1")
	Global $ini_codec = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_codec", "AAC")
	If $ini_codec = "AC3" then $ini_codec = "AC-3"
	Global $ini_codec1 = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_codec1", "DTS")
	Global $ini_codec2 = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_codec2", "TrueHD")
	Global $ini_codec3 = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_codec3", "AC-3")
	Global $ini_codec4 = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_codec4", "AAC")
	Global $ini_codec5 = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_codec5", "MP3")
	Global $ini_deleteorg = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_deleteorg", "4")
	Global $ini_DontSleep = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_DontSleep", "4")
	Global $ini_DontSleep_shutdown = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_DontSleep_shutdown", "4")
	Global $ini_DontSleep_standby = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_DontSleep_standby", "4")
	Global $ini_fanart_background = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_fanart_background", "{movie}-fanart.jpg")
	Global $ini_fanart_cover = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_fanart_cover", "{movie}-poster.jpg")
	Global $ini_gen_folder = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_gen_folder", "1")
	Global $ini_h264 = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_h264", "1")
	Global $ini_h265 = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_h265", "1")
	Global $ini_jpg_compression = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_jpg_compression", "2")
	Global $ini_KeepFileDate = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_KeepFileDate", "4")
	Global $ini_language = IniRead(@ScriptDir & "\Media-Buddy.ini", "languages", "ini_language", "English")
	Global $ini_language_flag = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_language_flag", @ScriptDir & "\Images\Flags\English.jpg")
	Global $ini_language_flag_all = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_language_flag_all", @ScriptDir & "\Images\Flags\English.jpg")
	Global $ini_lastmodule = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_lastmodule", "1-1")
	Global $ini_meta_flag = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_meta_flag", @ScriptDir & "\Images\Flags\en.jpg")
	Global $ini_moviesetfolderuse = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_moviesetfolderuse", "1")
	Global $ini_mux_external = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_mux_external", "4")
	Global $ini_naming_default = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_naming_default", "1")
	Global $ini_naming_emby = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_naming_emby", "4")
	Global $ini_naming_mp1 = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_naming_mp1", "4")
	Global $ini_ratings = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_ratings", "1")
	Global $ini_ren_movies = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_ren_movies", "1")
	Global $ini_ren_series = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_ren_series", "1")
	Global $ini_space_attach = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_space_attach", "1")
	Global $ini_stub = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_stub", "*.stub")

	Global $ini_sublanguages = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_sublanguages", "en")
	Global $ini_hwcodec = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_hwcodec", "1")
	Global $ini_tagging = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_tagging", "1")
	Global $ini_tracksperlanguage_audio = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_tracksperlanguage_audio", "1")
	Global $ini_tracksperlanguage_forced = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_tracksperlanguage_forced", "1")
	Global $ini_tracksperlanguage_sub = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_tracksperlanguage_sub", "0")
	Global $ini_tracks_video = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_tracks_video", "1")
	Global $ini_transcode_all = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_transcode_all", "1")
	Global $ini_transcode_allaudio = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_transcode_allaudio", "1")
	Global $ini_transcode_hdr = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_transcode_hdr", "4")
	Global $ini_useoptimizer = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_useoptimizer", "1")
	Global $ini_useoptimizer_subs = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_useoptimizer_subs", "1")
	Global $ini_useoptimizer_video = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_useoptimizer_video", "1")
	Global $ini_zerocode = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_zerocode", "1")
	Global $ini_simplemux = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_simplemux", "4")


; Module Settings

	;Audio Recode Config
	Global $ini_arecode_bitrate_mp3 = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_arecode_bitrate_mp3", "128")
	Global $ini_arecode_bitrate_flac = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_arecode_bitrate_flac", "10")
	Global $ini_arecode_bitrate_opus = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_arecode_bitrate_opus", "128")
	Global $ini_arecode_container = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_arecode_container", "flac")
	Global $ini_arecode_quality_opus = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_arecode_quality_opus", "3")
	Global $ini_arecode_samplingrate_mp3 = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_arecode_samplingrate_mp3", "48000")
	Global $ini_arecode_samplingrate_flac = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_arecode_samplingrate_flac", "48000")
	Global $ini_arecode_samplingrate_wav = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_arecode_samplingrate_wav", "44100")

	;Graphics Config

	Global $ini_gfx_color = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_gfx_color", "1")
	Global $ini_gfx_optjpg = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_gfx_optjpg", "1")
	Global $ini_gfx_optpng = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_gfx_optpng", "1")
	Global $ini_gfx_moveorg = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_gfx_moveorg", "1")
	Global $ini_gfx_optorg = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_gfx_optorg", "4")
	Global $ini_gfx_rotate = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_gfx_rotate", "1")
	Global $ini_gfx4k = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_gfx4k", "1")
	Global $ini_gfx1080 = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_gfx1080", "4")
	Global $ini_gfx720 = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_gfx720", "4")
	Global $ini_gfx600 = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_gfx600", "1")
	Global $ini_gfxfree = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_gfxfree", "4")
	Global $ini_gfxorg = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_gfxorg", "4")
	Global $ini_gfxnormalize = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_gfxnormalize", "1")
	Global $ini_gfxnormalize_type = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_gfxnormalize_type", "1")
	Global $ini_gfxunsharp = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_gfxunsharp", "1")
	Global $ini_gfx_value_unsharp = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_gfx_value_unsharp", "2")
	Global $ini_gfx_freesize = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_gfx_freesize", "1280x1024")
	Global $ini_gfx_format_4k = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_gfx_format_4k", "jpg")
	Global $ini_gfx_format_1080 = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_gfx_format_1080", "jpg")
	Global $ini_gfx_format_720 = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_gfx_format_720", "jpg")
	Global $ini_gfx_format_600 = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_gfx_format_600", "jpg")
	Global $ini_gfx_format_free = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_gfx_format_free", "jpg")
	Global $ini_gfx_format_org = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_gfx_format_org", "png")

	;Video Normalize Config
	Global $ini_audio_compression = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_audio_compression", "2")
	Global $ini_audio_db = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_audio_db", "0,95")
	Global $ini_audio_normalize = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_audio_normalize", "1")
	Global $ini_normalize_audiocodec = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_normalize_audiocodec", "6")

	;Audio Normalize Config
	Global $ini_aaudio_compression = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_aaudio_compression", "0")
	Global $ini_aaudio_db = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_aaudio_db", "0,95")
	Global $ini_aaudio_normalize = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_aaudio_normalize", "0")

	;Audio Wizard Config
	Global $ini_audio_not_flac = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_audio_not_flac", "1")
	Global $ini_audio_not_mp3 = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_audio_not_mp3", "1")
	Global $ini_audio_not_opus = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_audio_not_opus", "1")
	Global $ini_audio_not_wav = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_audio_not_wav", "4")

	;Extract Config
	Global $ini_extract_attachments = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_extract_attachments", "1")
	Global $ini_extract_audio = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_extract_audio", "1")
	Global $ini_extract_chapter = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_extract_chapter", "1")
	Global $ini_extract_subs = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_extract_subs", "1")
	Global $ini_extract_video = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_extract_video", "1")

	;Kodi Tools Config
	Global $ini_kodi_dot = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_kodi_dot", "1")
	Global $ini_kodi_database = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_kodi_database", "SQlite")
	Global $ini_kodi_MySQL_database = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_kodi_MySQL_database", "MyVideos116")
	Global $ini_kodi_MySQL_pass = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_kodi_MySQL_pass", "kodi")
	Global $ini_kodi_MySQL_port = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_kodi_MySQL_port", "3306")
	Global $ini_kodi_MySQL_server = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_kodi_MySQL_server", "localhost")
	Global $ini_kodi_MySQL_user = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_kodi_MySQL_user", "kodi")
	Global $ini_kodi_SQLite_database = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_kodi_SQLite_database", @UserProfileDir & "\Roaming\Kodi\userdata\Database\MyVideos116.db")
	Global $ini_remove_sorttitle = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_remove_sorttitle", "4")

	;MetaData Corrction Config
	Global $ini_meta_corrction_folder = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_meta_corrction_folder", $ini_wizard_series_outputfolder)
	Global $ini_meta_corrction_type = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_meta_corrction_type", "series")

	;MetaData Audio Config
	Global $ini_album_nfo = "4"
	Global $ini_album_nfo = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_album_nfo", "4")

	Global $ini_audiotools_copy = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_audiotools_copy", "1")
	Global $ini_artistfolderoverwrite = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_artistfolderoverwrite", "4")
	Global $ini_artistfolderuse = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_artistfolderuse", "1")
	Global $ini_Music_FolderStructure_MultipleDisc = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_Music_FolderStructure_MultipleDisc", "{Year} - {Album}\{Disc}")
	Global $ini_Music_FolderStructure = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_Music_FolderStructure", "{Year} - {Album}")
	Global $ini_Music_Renaming = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_Music_Renaming", "{Track} - {Title}")
	Global $ini_Music_Renaming_VariousArtists = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_Music_Renaming_VariousArtists", "{Track} - {Title} ({Artist})")
	Global $ini_Music_Renaming_MultiDisc = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_Music_Renaming_MultiDisc", "CD")

	;MetaData Movies Config
	Global $ini_meta_movies_refresh_gfx = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_meta_movies_refresh_gfx", "1")
	Global $ini_meta_movies_refresh_nfo = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_meta_movies_refresh_nfo", "1")

	;MetaData Series Config
	Global $ini_meta_series_refresh_gfx = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_meta_series_refresh_gfx", "1")
	Global $ini_meta_series_refresh_nfo = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_meta_series_refresh_nfo", "1")

	;MetaData Videos Config
	Global $ini_fanart_backgroundtemplate = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_fanart_backdroptemplate", "---------")
	Global $ini_fanart_bordercolor = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_fanart_bordercolor", "IndianRed4")
	Global $ini_fanart_bordertemplate = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_fanart_bordertemplate", "---------")
	Global $ini_fanart_covermanual = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_fanart_covermanual", "4")
	Global $ini_fanart_covertemplate = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_fanart_covertemplate", "---------")
	Global $ini_fanart_design = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_fanart_design", "1-6")
	Global $ini_fanart_font = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_fanart_font", "Comic-Sans-MS-Bold")
	Global $ini_fanart_genre = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_fanart_genre", "")
	Global $ini_fanart_genrefolder = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_fanart_genrefolder", "1")
	Global $ini_fanart_mediainfo = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_fanart_mediainfo", "1")
	Global $ini_fanart_nobackdrop = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_fanart_nobackdrop", "4")
	Global $ini_fanart_nocover = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_fanart_nocover", "4")
	Global $ini_fanart_nonfo = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_fanart_nonfo", "4")
	Global $ini_fanart_plot = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_fanart_plot", "")

	;Recode Config
	Global $ini_recode_audiocodec = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_recode_audiocodec", "6")
	Global $ini_recode_container = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_recode_container", "mkv")
	Global $ini_recode_quality_720 = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_recode_quality_720", "20")
	Global $ini_recode_quality_1080 = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_recode_quality_1080", "18")
	Global $ini_recode_quality_4k = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_recode_quality_4k", "16")
	Global $ini_recode_quality_sd = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_recode_quality_sd", "24")
	Global $ini_recode_videocodec_720 = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_recode_videocodec_720", "h264 AVC")
	Global $ini_recode_videocodec_1080 = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_recode_videocodec_1080", "h264 AVC")
	Global $ini_recode_videocodec_4K = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_recode_videocodec_4K", "h265 HEVC")
	Global $ini_recode_videocodec_SD = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_recode_videocodec_SD", "h264 AVC")

	;Tag 3D Config
	Global $ini_3d_mode = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_3d_mode", "mono")
	Global $ini_3d_kodinaming = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_3d_kodinaming", "4")
	Global $ini_3d_rename = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_3d_rename", "4")
	Global $ini_3d_renamenfo = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_3d_renamenfo", "1")

	;Wizard Movies Config
	Global $ini_wizard_movies_bitrate_720 = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_wizard_movies_bitrate_720", "7000")
	Global $ini_wizard_movies_bitrate_1080 = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_wizard_movies_bitrate_1080", "12000")
	Global $ini_wizard_movies_bitrate_4k = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_wizard_movies_bitrate_4k", "20000")
	Global $ini_wizard_movies_bitrate_sd = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_wizard_movies_bitrate_sd", "2500")
	Global $ini_wizard_movies_refresh_gfx = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_wizard_movies_refresh_gfx", "0")
	Global $ini_wizard_movies_refresh_nfo = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_wizard_movies_refresh_nfo", "0")

	;Wizard Series Config
	Global $ini_wizard_series_bitrate_720 = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_wizard_series_bitrate_720", "6000")
	Global $ini_wizard_series_bitrate_1080 = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_wizard_series_bitrate_1080", "10000")
	Global $ini_wizard_series_bitrate_4k = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_wizard_series_bitrate_4k", "20000")
	Global $ini_wizard_series_bitrate_sd = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_wizard_series_bitrate_sd", "2000")
	Global $ini_wizard_series_refresh_gfx = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_wizard_series_refresh_gfx", "0")
	Global $ini_wizard_series_refresh_nfo = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_wizard_series_refresh_nfo", "0")

	;Wizard Videos Config
	Global $ini_wizard_videos_bitrate_720 = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_wizard_videos_bitrate_720", "6000")
	Global $ini_wizard_videos_bitrate_1080 = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_wizard_videos_bitrate_1080", "10000")
	Global $ini_wizard_videos_bitrate_4k = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_wizard_videos_bitrate_4k", "20000")
	Global $ini_wizard_videos_bitrate_sd = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_wizard_videos_bitrate_sd", "2000")
	Global $ini_wizard_videos_refresh_gfx = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_wizard_videos_refresh_gfx", "0")
	Global $ini_wizard_videos_refresh_nfo = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_wizard_videos_refresh_nfo", "0")

#EndRegion ;Ini Read Config

#Region ;Read JSON

	Global $json, $json_File_Ignore_Strings, $json_FileExtensions, $json_Folder_Ignore, $json_TVShow_SeriesIgnoreEpisodeNames, $json_Music_FileExtensions
	Global $json_TVShow_Image_Episode, $json_IdentifyLanguage_WordsToIdentifyEnglish, $json_FileExtensions
	Global $ArrayMediaStub[1], $arating
	Global $json_artist_folder = $ini_artistfolder

	; Read allowed MediaStub file extentions
	$MediaStub_file = FileOpen(@ScriptDir & "\MediaStub.txt", 0)
	If $MediaStub_file = -1 Then

		_WriteLog("Error - Failed to open MediaStub.txt")

		_Exit()

	EndIf

	While 1

		$MediaStub_line = FileReadLine($MediaStub_file)
		If @error = -1 Then ExitLoop
		_ArrayAdd($ArrayMediaStub, $MediaStub_line)

	WEnd

	If Not FileExists(@ScriptDir & "\nfo4HTPCv2.Settings.json") Then ShellExecuteWait(@ScriptDir & "\nfo4HTPCv2.exe","","","", @SW_HIDE)

	$fle_hwnd = FileOpen(@ScriptDir & "\nfo4HTPCv2.Settings.json")

	Global $j_String = FileRead($fle_hwnd)

	FileClose($fle_hwnd)

;Possible Array settings

	$j_Object = _JSON_Parse($j_String)

	$json = _JSON_Get($j_Object, "FileIgnoreStrings")

	If IsArray($json) Then

		$json_File_Ignore_Strings = $json[0]

		For $i = 1 To UBound($json) - 1

			$json_File_Ignore_Strings = $json_File_Ignore_Strings & "|" & $json[$i]

		Next

	Else

		$json_File_Ignore_Strings = $json

	EndIf


	$json = _JSON_Get($j_Object, "FileExtensions")


	If Not IsArray($json) Then

		Local $split = StringSplit($json, "|", 2)

		If IsArray($split) Then

			$json_FileExtensions = $split

		Else

			_ArrayAdd($json_FileExtensions, $json)

		EndIf

	Else

		$json_FileExtensions = _JSON_Get($j_Object, "FileExtensions")

	EndIf


	For $i = 1 To UBound($ArrayMediaStub) - 1

		$y = _ArraySearch($json_FileExtensions, $ArrayMediaStub[$i])

		If _ElementExists($json_FileExtensions, $y) Then _ArrayDelete($json_FileExtensions, $y)

	Next

	$json = _JSON_Get($j_Object, "FolderIgnore")

	If IsArray($json) Then

		$json_Folder_Ignore = $json[0]

		For $i = 1 To UBound($json) - 1

			$json_Folder_Ignore = $json_Folder_Ignore & "|" & $json[$i]

		Next

	Else

		$json_Folder_Ignore = $json

	EndIf


 	$json = _JSON_Get($j_Object, "TVShow.SeriesIgnoreEpisodeNames")

	If IsArray($json) Then

		$json_TVShow_SeriesIgnoreEpisodeNames = $json[0]

		For $i = 1 To UBound($json) - 1

			$json_TVShow_SeriesIgnoreEpisodeNames = $json_TVShow_SeriesIgnoreEpisodeNames & "|" & $json[$i]

		Next

	Else

		$json_TVShow_SeriesIgnoreEpisodeNames = $json

	EndIf

	$json = _JSON_Get($j_Object, "Music.FileExtensions")

	If Not IsArray($json) Then

		Local $split = StringSplit($json, "|", 2)

		If IsArray($split) Then

			$json_Music_FileExtensions = $split

		Else

			_ArrayAdd($json_Music_FileExtensions, $json)

		EndIf

	Else

		$json_Music_FileExtensions = _JSON_Get($j_Object, "Music.FileExtensions")

	EndIf


; Non Array settings

	Global $json_Language = _JSON_Get($j_Object, "Language")
	Global $json_Language3 = _JSON_Get($j_Object, "Language_ThreeLetter")
	Global $json_Download_Images = _JSON_Get($j_Object, "Download_Images")
	Global $json_use_uniqueID = _JSON_Get($j_Object, "use_uniqueID")
	Global $json_OverwriteRating = _JSON_Get($j_Object, "Rating.OverwriteRating")


	Global $json_Movies_Image_Poster = _JSON_Get($j_Object, "Movies.Image_Poster")
	Global $json_Movies_Image_Thumb = _JSON_Get($j_Object, "Movies.Image_Thumb")
	Global $json_Movies_Image_Backdrop = _JSON_Get($j_Object, "Movies.Image_Backdrop")
	Global $json_Movies_Image_ClearLogo = _JSON_Get($j_Object, "Movies.Image_ClearLogo")
	Global $json_Movies_Image_MovieSetFanart = _JSON_Get($j_Object, "Movies.Image_MovieSetFanart")
	Global $json_Trailer_Download = _JSON_Get($j_Object, "Movies.Trailer_Download")


	Global $json_TVShow_Image_Fanart = _JSON_Get($j_Object, "TVShow.Image_Fanart")
	Global $json_TVShow_Image_Poster = _JSON_Get($j_Object, "TVShow.Image_Poster")
	Global $json_TVShow_Image_Banner = _JSON_Get($j_Object, "TVShow.Image_Banner")
	Global $json_TVShow_Image_Episode = _JSON_Get($j_Object, "TVShow.Image_Episode")
	Global $json_TVShow_Image_SeasonPoster = _JSON_Get($j_Object, "TVShow.Image_SeasonPoster")
	Global $json_TVShow_Image_ClearLogo = _JSON_Get($j_Object, "TVShow.Image_ClearLogo")
	Global $json_TVShow_FolderSeason = _JSON_Get($j_Object, "TVShow.FolderSeason")
	Global $json_TVShow_FolderSeasonSpecial = _JSON_Get($j_Object, "TVShow.FolderSeasonSpecial")
	Global $json_TVShow_Create_Episode_NFO_On_Missing_Info = _JSON_Get($j_Object, "TVShow.Create_Episode_NFO_On_Missing_Info")
	Global $json_TVShow_DefaultGrabber = _JSON_Get($j_Object, ".TVShow.Default_Grabber")



	Global $json_Image_Resize = _JSON_Get($j_Object, "Image.Resize")
	Global $json_Image_Resize_Backdrop = _JSON_Get($j_Object, "Image.Resize_Backdrop")
	Global $json_Image_Resize_Poster = _JSON_Get($j_Object, "Image.Resize_Poster")
	Global $json_Image_Resize_Thumb = _JSON_Get($j_Object, "Image.Resize_Thumb")

	Global $json_Music_Image_Banner = _JSON_Get($j_Object, "Music.Image_Banner")
	Global $json_Music_Image_Background = _JSON_Get($j_Object, "Music.Image_Background")
	Global $json_Music_Image_CDArt = _JSON_Get($j_Object, "Music.Image_CDArt")
	Global $json_Music_Image_AlbumCover = _JSON_Get($j_Object, "Music.Image_AlbumCover")
	Global $json_Music_Image_ArtistThumb = _JSON_Get($j_Object, "Music.Image_ArtistThumb")
	Global $json_Music_Image_ClearLogo = _JSON_Get($j_Object, "Music.Image_ClearLogo")
	Global $json_Music_FolderStructure = _JSON_Get($j_Object, "Music.FolderStructure")

	Global $json_Chapter_GrabChapter = _JSON_Get($j_Object, "Chapter.GrabChapter")

	Global $json_Filenaming_Movie_Image_Poster = _JSON_Get($j_Object, "Filenaming.Movie.Image_Poster")
	Global $json_Filenaming_Movie_Image_Thumb = _JSON_Get($j_Object, "Filenaming.Movie.Image_Thumb")
	Global $json_Filenaming_Movie_Image_Banner = _JSON_Get($j_Object, "Filenaming.Movie.Image_Banner")
	Global $json_Filenaming_Movie_Image_Fanart = _JSON_Get($j_Object, "Filenaming.Movie.Image_Fanart")
	Global $json_Filenaming_Movie_Image_ClearLogo = _JSON_Get($j_Object, "Filenaming.Movie.Image_ClearLogo")
	Global $json_Filenaming_Movie_Image_ClearArt = _JSON_Get($j_Object, "Filenaming.Movie.Image_ClearArt")
	Global $json_Filenaming_Movie_Image_Disc = _JSON_Get($j_Object, "Filenaming.Movie.Image_Disc")
	Global $json_Filenaming_Movie_File_NFO = _JSON_Get($j_Object, "Filenaming.Movie.File_NFO")

	Global $json_Filenaming_Movie_Image_MovieSetPoster = _JSON_Get($j_Object, "Filenaming.Movie.Image_MovieSetPoster")
	Global $json_Filenaming_Movie_Image_MovieSetFanart = _JSON_Get($j_Object, "Filenaming.Movie.Image_MovieSetFanart")
	Global $json_Filenaming_Movie_Image_MovieSetBanner = _JSON_Get($j_Object, "Filenaming.Movie.Image_MovieSetBanner")
	Global $json_Filenaming_Movie_Image_MovieSetClearLogo = _JSON_Get($j_Object, "Filenaming.Movie.Image_MovieSetClearLogo")
	Global $json_Filenaming_Movie_Image_MovieSetClearArt = _JSON_Get($j_Object, "Filenaming.Movie.Image_MovieSetClearArt")
	Global $json_Filenaming_Movie_Image_MovieSetThumb = _JSON_Get($j_Object, "Filenaming.Movie.Image_MovieSetThumb")

	Global $json_Filenaming_TVShow_Image_Fanart = _JSON_Get($j_Object, "Filenaming.TVShow.Image_Fanart")
	Global $json_Filenaming_TVShow_Image_Poster = _JSON_Get($j_Object, "Filenaming.TVShow.Image_Poster")
	Global $json_Filenaming_TVShow_Image_Banner = _JSON_Get($j_Object, "Filenaming.TVShow.Image_Banner")
	Global $json_Filenaming_TVShow_Image_ClearLogo = _JSON_Get($j_Object, "Filenaming.TVShow.Image_ClearLogo")
	Global $json_Filenaming_TVShow_Image_ClearArt = _JSON_Get($j_Object, "Filenaming.TVShow.Image_ClearArt")
	Global $json_Filenaming_TVShow_Image_Episode = _JSON_Get($j_Object, "Filenaming.TVShow.Image_Episode")
	Global $json_Filenaming_TVShow_Image_Season_Poster = _JSON_Get($j_Object, "Filenaming.TVShow.Image_Season_Poster")
	Global $json_Filenaming_TVShow_Image_Season_Banner = _JSON_Get($j_Object, "Filenaming.TVShow.Image_Season_Banner")

	Global $json_Rename_Movie = _JSON_Get($j_Object, "Rename.Movie")
	Global $json_Rename_TvShow = _JSON_Get($j_Object, "Rename.TvShow")
	Global $json_Rename_TvShowEpisodeChar = _JSON_Get($j_Object, "Rename.TvShowEpisodeChar")
	Global $json_Rename_RenameFiles = _JSON_Get($j_Object, "Rename.RenameFiles")
	Global $json_Rename_Music = _JSON_Get($j_Object, "Rename.Music")

	$backsize = StringSplit($json_Image_Resize_Backdrop, ", ")
	$covsize = StringSplit($json_Image_Resize_Poster, ", ")
	$thumbsize = StringSplit($json_Image_Resize_Thumb, ", ")

	If _ElementExists($backsize, 3) Then

		Global $Image_Resize_Backdrop_Width = $backsize[1]
		Global $Image_Resize_Backdrop_Height = $backsize[3]
		Global $Image_Resize_Poster_Width = $covsize[1]
		Global $Image_Resize_Poster_Height = $covsize[3]
		Global $Image_Resize_Thumb_Width = $thumbsize[1]
		Global $Image_Resize_Thumb_Height = $thumbsize[3]

	Else

		MsgBox($MB_SYSTEMMODAL, "Error", "nfo4HTPCv2.Settings.json is not valid")
		Exit

	EndIf

#EndRegion

#Region ;Ini Read Localized Strings

Global $lng_1080mat = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_1080mat", "1080p material")
Global $lng_3D = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_3D", "3D-Video options")
Global $lng_3Dmode = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_3Dmode", "Select stereo mode")
Global $lng_3d_naming = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_3D_naming", "Use 3D-mode filename extensions?")
Global $lng_3Drename = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_3Drename", "Rename to")
Global $lng_3dtag = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_3dtag", "Tag 3D videos")
Global $lng_4kmat = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_4kmat", "4K material")
Global $lng_720mat = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_720mat", "720p material")
Global $lng_about = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_about", "About")
Global $lng_acustomfiletypes = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_acustomfiletypes", "Audio Filetypes")
Global $lng_after = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_after", "Start correcton")
Global $lng_album = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_album", "Album")
Global $lng_album_disc = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_album_disc", "Generate Album- Discart?")
Global $lng_album_fanart = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_album_fanart", "Download Album- Fanart?")
Global $lng_album_folder = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_album_folder", "Generate Album- Folder?")
Global $lng_album_nfo = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_album_nfo", "Generate Album- .nfo?")
Global $lng_album_poster = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_album_poster", "Download Album- Cover?")
Global $lng_always = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_always", "Always")
Global $lng_append = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_append", "Append stacked Video")
Global $lng_artist = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_artist", "Artist")
Global $lng_artistinfofolder = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_artistinfofolder", "Central artist information folder")
Global $lng_artist_banner = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_artist_banner", "Download Artist- Banner?")
Global $lng_artist_clearart = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_artist_clearart", "Download Artist- Logo?")
Global $lng_artist_fanart = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_artist_fanart", "Download Artist- Fanart?")
Global $lng_artist_folder = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_artist_folder", "Generate Artist- Folder?")
Global $lng_artist_nfo = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_artist_nfo", "Generate Artist- .nfo?")
Global $lng_artist_poster = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_artist_poster", "Download Artist- Poster?")
Global $lng_arecode = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_arecode", "Recode Audio:")
Global $lng_areyousure= IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_areyousure", "Are you sure?")
Global $lng_artfolder = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_artfolder", "Central artwork folder")
Global $lng_attachspace = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_attachspace", "Space before Season#")
Global $lng_audio = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_audio", "Audio")
Global $lng_audionorm = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_audionorm", "Audio normalization")
Global $lng_audionormalize = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_audionormalize", "normalize audio")
Global $lng_audiocompress = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_audiocompress", "Dynamic compression")
Global $lng_audiocompress0 = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_audiocompress0", "Off")
Global $lng_audiocompress1 = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_audiocompress1", "Low")
Global $lng_audiocompress2 = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_audiocompress2", "Medium")
Global $lng_audiocompress3 = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_audiocompress3", "High")
Global $lng_audiocompress4 = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_audiocompress4", "Extreme")
Global $lng_audiocopy = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_audiocopy", "Copy or move audio files?")
Global $lng_audiohint = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_audiohint", "Media-Buddy is no replacement for an ID3 tagging program like MPTagThat or MP3Tag. Indeed Media_Buddy expects propperly tagged audio files as it only adds the missing fanart and metadata that can not be stored inside ID3 tags. This way you can import your Audio files into your HTPC tool like Kodi, MediaPortal, Emby,.. without any online lookups at all.")
Global $lng_audiolanguages = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_audiolanguages", "Audio- languages")
Global $lng_autoend1 = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_autoend1", "Media-Buddy is closing in some seconds.")
Global $lng_autoend2 = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_autoend2", "Do you want this?")
Global $lng_autoend4 = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_autoend4", "Media-Buddy is shutting down the computer in some seconds!")
Global $lng_autoend5 = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_autoend5", "Media-Buddy is sending the computer into standby in some seconds!")
Global $lng_autoend6 = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_autoend6", "Media-Buddy is sending the computer into hibernate in some seconds!")
Global $lng_back = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_back", "Back")
Global $lng_backdrop = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_backdrop", "Backdrop")
Global $lng_backdroptemplate = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_backdroptemplate", "Backdrop template")
Global $lng_backup = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_backup", "Backup")
Global $lng_bio = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_bio", "Biography")
Global $lng_bitrate = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_bitrate", "Bitrate / Quality")
Global $lng_bitrates = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_bitrates", "Constant Quality")
Global $lng_black = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_black", "Black and white")
Global $lng_bordercolor = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_bordercolor", "Border colour")
Global $lng_bordertemplate = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_bordertemplate", "Border template")
Global $lng_born = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_born", "Born")
Global $lng_cancel = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_cancel", "Cancel")
Global $lng_cancel1 = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_cancel1", "Abort recent Action.")
Global $lng_cancel2 = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_cancel2", "Yes -> Finish recent file and abort.")
Global $lng_cancel3 = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_cancel3", "No -> Do nothing.")
Global $lng_cancel4 = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_cancel4", "Cancel -> Abort now!")
Global $lng_canvariable = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_canvariable", "Every useful tag from .nfo could be used as {variable}")
Global $lng_extended = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_extended", "Extended")
Global $lng_change = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_change", "Save Changes")
Global $lng_channels = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_channels", " Channels")
Global $lng_close = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_close", "Exit Media-Buddy")
Global $lng_choose = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_choose", "Choose")
Global $lng_compression = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_compression", "Samplingrate / Quality")
Global $lng_config = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_config", "Configuration")
Global $lng_color = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_color", "Color")
Global $lng_compatible = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_compatible", "make Kodi 19 compatible")
Global $lng_container = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_container", "Container")
Global $lng_conversion = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_conversion", "Conversion")
Global $lng_conversiontext1 = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_conversiontext1", "By pressing OK all files in")
Global $lng_conversiontext2 = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_conversiontext2", "\ will be processed. It may take a while.")
Global $lng_conversiontext3 = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_conversiontext3", "By pressing Delete Originals all previously processed input- files are irrecoverably deleted. This only should be done after a thoroughly inspection of the resulted files.")
Global $lng_copy = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_copy", "Copy")
Global $lng_copy_artist = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_copy_artist", "Copy music artist fanart")
Global $lng_country = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_country", "Coutry")
Global $lng_covernew = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_covernew", "Recreate cover ?")
Global $lng_covertemplate = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_covertemplate", "Cover template")
Global $lng_customfiletypes = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_customfiletypes", "Video Filetypes")
Global $lng_dbtype = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_dbtype", "Select Database type")
Global $lng_default = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_default", "Default")
Global $lng_default_datasource = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_default_datasource", "Default data source")
Global $lng_delete = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_delete", "Delete")
Global $lng_delgfx = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_delgfx", "Graphics")
Global $lng_delorg = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_delorg", "Delete Originals?")
Global $lng_design = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_design", "Design")
Global $lng_died = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_died", "Died")
Global $lng_disambiguation = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_disambiguation", "Disambiguation")
Global $lng_disbanded = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_disbanded", "Disbanded")
Global $lng_doafter = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_doafter", "After current operation do:")
Global $lng_dontconvert = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_dontconvert", "Do not convert:")
Global $lng_dontsleep = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_dontsleep", "Enable")
Global $lng_dontsleep_options = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_dontsleep_options", "Don't Sleep options")
Global $lng_dontsleep_standby = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_dontsleep_standby", "Prevent standby")
Global $lng_dontsleep_shutdown = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_dontsleep_shutdown", "Prevent shutdown")
Global $lng_download_chapters = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_download_chapters", "Download chapters")
Global $lng_download_images = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_download_images", "Download graphics")
Global $lng_dvd = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_dvd", "ISO/DVD/BluRay")
Global $lng_edit = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_edit", "Edit")
Global $lng_editalbum = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_editalbum", "Edit Albums")
Global $lng_editepisodes = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_editepisodes", "Edit episodes")
Global $lng_empty_nfo = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_empty_nfo", "Generate .nfo for Series- Episodes, wich are not available online?")
Global $lng_episode = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_episode", "Episode")
Global $lng_episodes = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_episodes", "Episodes")
Global $lng_elapsed = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_elapsed", "Elapsed")
Global $lng_errmsg = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_errmsg", "An error occured")
Global $lng_error = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_error", "Error")
Global $lng_excerpt = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_excerpt", "Excerpt")
Global $lng_exiftext = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_exiftext", "Copies Exif metadata from images in source folder to images in destination folder. Images must have the same name excerpt for file extension")
Global $lng_exit = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_exit", "Exit")
Global $lng_extract = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_extract", "Extract Tracks")
Global $lng_extractmissing = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_extractmissing", "Extract missing covers")
Global $lng_fallback = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_fallback", "Fallback Audio Codec")
Global $lng_fanart = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_fanart", "Generate Fanart")
Global $lng_fanart1 = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_fanart1", "Fanart")
Global $lng_fanartnew = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_fanartnew", "Recreate fanart ?")
Global $lng_file_ignore = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_file_ignore", "Ignore name parts")
Global $lng_filename = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_filename", "File name")
Global $lng_filenames = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_filenames", "File names")
Global $lng_filenames_nfo = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_filenames_nfo", "Filename presets for fanart and nfo")
Global $lng_files = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_files", "File")
Global $lng_fix = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_fix", "Fix MKV")
Global $lng_fixnotation = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_fixnotation", "Change decimal notation")
Global $lng_folder_ignore = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_folder_ignore", "Ignore folder")
Global $lng_folder_structure = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_folder_structure", "Folder structure")
Global $lng_fonttype = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_fonttype", "Font")
Global $lng_formed = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_formed", "Formed")
Global $lng_free = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_free", "Free")
Global $lng_from = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_from", "From")
Global $lng_front = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_front", "Front")
Global $lng_forced = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_forced", "Forced")
Global $lng_gcustomfiletypes = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_gcustomfiletypes", "Graphics Filetypes")
Global $lng_grab = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_grab", "Grab")
Global $lng_grey = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_grey", "Grey")
Global $lng_graphics = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_graphics", "Graphics")
Global $lng_gender = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_gender", "Gender")
Global $lng_generic = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_generic", "Generic")
Global $lng_genre = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_genre", "Genre")
Global $lng_genrefallback = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_genrefallback", "Default- genre:")
Global $lng_genrefolder = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_genrefolder", "Set genre from folder")
Global $lng_german = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_german", "German")
Global $lng_height = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_height", "Height")
Global $lng_help = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_help", "Help")
Global $lng_hibernate = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_hibernate", "Hibernate PC")
Global $lng_hint = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_hint", "Hint:")
Global $lng_ignoreepisode = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_ignoreepisode", "Episode title to ignore:")
Global $lng_image = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_image", "Image")
Global $lng_imageresize = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_imageresize", "Scale down Images:")
Global $lng_imageselect = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_imageselect", "Select images?")
Global $lng_individual = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_individual", "Individual")
Global $lng_input = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_input", "Input")
Global $lng_inputfoldertext = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_inputfoldertext", "Choose source directory (with files to process)")
Global $lng_keep = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_keep", "Keep")
Global $lng_keep_file_date = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_keep_file_date", "Keep file date")
Global $lng_kodihelper = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_kodihelper", "Kodi helper tools")
Global $lng_kodi19nfo = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_kodi19nfo", "generate Kodi19++ compatible .nfo files")
Global $lng_kodi19nfo1 = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_kodi19nfo1", "Since Kodi19 <id> is no longer used for TMDB-ID or IMDB-ID.")
Global $lng_kodionly = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_kodionly", "Kodi specific")
Global $lng_langchange = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_langchange", "You need to restart Media-Buddy to activate changes. Restart now?")
Global $lng_langselect = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_langselect", "Select GUI language")
Global $lng_loadingalbum = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_loadingalbum", "Loading metadata for album:")
Global $lng_loadingartist = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_loadingartist", "Loading metadata for artist:")
Global $lng_makebackdrop = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_makebackdrop", "Assemble backdrop")
Global $lng_makecover = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_makecover", "Assemble cover")
Global $lng_makethumb = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_makethumb", "Create thumb")
Global $lng_makestills = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_makestills", "Generate still picture number:")
Global $lng_manual = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_manual", "Manual")
Global $lng_mediainfoplot = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_mediainfoplot", "MediaInfo as summary")
Global $lng_mediastub = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_mediastub", "Generate MediaStub Files")
Global $lng_mediastub_filename = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_mediastub_filename", "Filename (Required)")
Global $lng_message = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_message", "Message")
Global $lng_media_type = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_media_type", "Media type")
Global $lng_metadata = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_metadata", "Metadata")
Global $lng_metadata_correction = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_metadata_correction", "Correction")
Global $lng_metadata_language = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_metadata_language", "Metadata language")
Global $lng_move = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_move", "Move")
Global $lng_moveorg = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_moveorg", "Move originals to Original/RAW folder")
Global $lng_movies = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_movies", "Movies")
Global $lng_movieset = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_movieset", "Movieset")
Global $lng_moviesetartfolder = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_moviesetartfolder", "Central Movieset- artwork folder")
Global $lng_moviesetfanart = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_moviesetfanart", "Refresh movieset fanart")
Global $lng_moviesethint = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_moviesethint", "On clicking OK Media-Buddy replaces/corrects movieset fanart entries in Kodi DB. Those etries are not set properly by Kodi itself. For this Media-Buddy nees to have access to the Kodi databases (SQLite or MySQL/MariaDB)")
Global $lng_mpaa = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_mpaa", "Rating")
Global $lng_mpaa1 = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_mpaa1", "Name of Rating class?")
Global $lng_mpaa2 = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_mpaa2", "Value for Rating class")
Global $lng_mpaa3 = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_mpaa3", 'Enclose the value in "" and separate multiple value by ,')
Global $lng_mpaa4 = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_mpaa4", "Wildcards * ? ... are possible")
Global $lng_musicbrainz =  IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_musicbrainz", "MusicBrainz Artist ID")
Global $lng_mux_external = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_mux_external", "Mux external .srt Subtitles into MKV?")
Global $lng_MySQLdb = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_MySQLdb", "MySQL Video Database")
Global $lng_MySQLserver = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_MySQLserver", "MySQL Database Server")
Global $lng_name = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_name", "Name")
Global $lng_names = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_names", "Names")
Global $lng_necessary = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_necessary", "If necessary")
Global $lng_never = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_never", "Never")
Global $lng_noalbums = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_noalbums", "No albums found for this artist")
Global $lng_noartist = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_noartist", "No Artist Folder defined.")
Global $lng_nobackdrop = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_nobackdrop", "No backdrop")
Global $lng_nocover = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_nocover", "No cover")
Global $lng_nofilename = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_nofilename", "No Filename specified")
Global $lng_nofiles = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_nofiles", "No (AV-) files found in Source Directory")
Global $lng_nofolders = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_nofolders", "No (necessary) folders found in Source Directory")
Global $lng_nonfo = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_nonfo", "No NFO")
Global $lng_nothing = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_nothing", "Nothing")
Global $lng_notimplemented = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_notimplemented", "This part is not jet integrated.")
Global $lng_nounc = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_nounc", "No UNC path, please change this")
Global $lng_OK = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_OK", "OK")
Global $lng_oneperline = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_oneperline", "One entry per line")
Global $lng_optimizer = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_optimizer", "Optimizer")
Global $lng_options = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_options", "Options")
Global $lng_optorg = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_optorg", "Optimize Originals")
Global $lng_outputfoldertext = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_outputfoldertext", "Choose destination directory (for processed files)")
Global $lng_overwrite = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_overwrite", "Overwrite existing data?")
Global $lng_ownid = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_ownid", "Own ID:")
Global $lng_path_ffmpeg = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_path_ffmpeg", "Path to FFMpeg.exe")
Global $lng_path_mkvextract = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_path_mkvextract", "Path to mkvextract.exe")
Global $lng_path_mkvmerge = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_path_mkvmerge", "Path to mkvmerge.exe")
Global $lng_path_mkvpropedit = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_path_mkvpropedit", "Path to mkvpropedit.exe")
Global $lng_play = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_play", "Play")
Global $lng_pleasewait = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_pleasewait", "Please wait")
Global $lng_plot = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_plot", "Plot")
Global $lng_preferchannels = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_preferchannels", "Prefer multiple channels")
Global $lng_prepare = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_prepare", "Prepare Metadata")
Global $lng_program = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_program", "Program")
Global $lng_progress = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_progress", "Progress")
Global $lng_quality = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_quality", "Quality")
Global $lng_quality1 = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_quality1", "With this option .png and/or .jpg files are compressed without any loss of quality")
Global $lng_random = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_random", "Random")
Global $lng_rating = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_rating", "Rating")
Global $lng_ratings = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_ratings", "Change Ratings")
Global $lng_rcustomfiletypes = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_rcustomfiletypes", "Camera-RAW Filetypes")
Global $lng_readmeta = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_readmeta", "Read metatags from")
Global $lng_recoding = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_recoding", "Recoding")
Global $lng_refresh = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_refresh", "Refresh")
Global $lng_refreshgfx = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_refreshgfx", "Refresh graphics")
Global $lng_refreshnfo = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_refreshnfo", "Refresh .nfo")
Global $lng_removeST = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_removeST", "Remove Sorttitle")
Global $lng_remux = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_remux", "Remuxing")
Global $lng_remuxafter = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_remuxafter", "Remux after tagging")
Global $lng_remuxlimit = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_remuxlimit", "Remux limits")
Global $lng_rename = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_rename", "rename")
Global $lng_renamenfo = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_renamenfo", "rename *.nfo?")
Global $lng_renamingscheme = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_renamingscheme", "Renaming scheme")
Global $lng_restore = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_restore", "Restore")
Global $lng_rework = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_rework", "Rework")
Global $lng_rotate = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_rotate", "Rotate image with exif value")
Global $lng_save = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_save", "Save")
Global $lng_saveconfig = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_saveconfig", "Save Settings")
Global $lng_saveexit = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_saveexit", "Yes -> Save and exit")
Global $lng_savelanguages = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_savelanguages", "All languages settings are changed to")
Global $lng_savelanguages1 = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_savelanguages1", "and Media-Buddy wil restart.")
Global $lng_savenotexit = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_savenotexit", "No -> Save")
Global $lng_savenot = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_savenot", "Cancel -> Don't save")
Global $lng_scaleoptions = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_scaleoptions", "Resize- Options")
Global $lng_scustomfiletypes = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_sustomfiletypes", "MediaStub Filetypes")
Global $lng_sdmat = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_sdmat", "SD material")
Global $lng_search = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_search", "Search")
Global $lng_season = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_season", "Season")
Global $lng_seasonfolder = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_seasonfolder", "Generate season folder")
Global $lng_seasonposter = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_seasonposter", "Season poster")
Global $lng_selectSQLite = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_selectSQLite", "Choose SQlite Database")
Global $lng_series = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_series", "Series")
Global $lng_set_all = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_set_all", "Set All:")
Global $lng_set_all_to = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_set_all_to", "Set all to:")
Global $lng_set_extract = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_set_extract", "Elements to extract:")
Global $lng_set_video = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_set_video", "Video tracks")
Global $lng_set_audio = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_set_audio", "Audio tracks")
Global $lng_set_subs = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_set_subs", "Subtitle tracks")
Global $lng_set_chapter = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_set_chapter", "Chapters")
Global $lng_set_attach = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_set_attach", "Attachments")
Global $lng_settingssave = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_settingssave", "Save settings before continue?")
Global $lng_simplemux = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_simplemux", "Meant to repair slightly damaged videos. Without any optimisations or checks.")
Global $lng_shouldattach = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_shouldattach", "Attach gfx to MKV?")
Global $lng_shouldnfoattach = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_shouldnfoattach", "Attach metadata to MKV?")
Global $lng_shouldrename = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_shouldrename", "Rename files")
Global $lng_showtitle = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_showtitle", "Showtitle")
Global $lng_shutdown = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_shutdown", "Shutdown PC")
Global $lng_sorttitle = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_sorttitle", "Sorttitle")
Global $lng_specific = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_specific", "Specific")
Global $lng_SRT = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_SRT", "Use SRT subtitle files")
Global $lng_standby = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_standby", "Standby")
Global $lng_start = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_start", "Start")
Global $lng_status = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_status", "Status")
Global $lng_stills = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_stills", "Still Image")
Global $lng_stills_generate = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_stills_generate", "Generating stills")
Global $lng_studio = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_studio", "Studio")
Global $lng_sublanguages = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_sublanguages", "Subtitle- languages")
Global $lng_subtitle = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_subtitle", "Subtitle")
Global $lng_sucess = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_sucess", "Processing sucessfully completed")
Global $lng_summary = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_summary", "Default- summary")
Global $lng_tag = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_tag", "Tag")
Global $lng_tagline = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_tagline", "Tagline")
Global $lng_tagnew = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_tagnew", "Tag again")
Global $lng_thumb = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_thumb", "Thumbnail")
Global $lng_title = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_title", "Title")
Global $lng_title_original = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_title_original", "Original title")
Global $lng_to = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_to", "To")
Global $lng_tools = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_tools", "Tools")
Global $lng_total = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_total", "Total")
Global $lng_tracks = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_tracks", "Tracks")
Global $lng_tracksperlanguage = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_tracksperlanguage", "Tracks per language")
Global $lng_transcode_all = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_transcode_all", "Transcode everything")
Global $lng_type = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_type", "Type")
Global $lng_unc = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_unc", "Path needs to be in UNC format (\\Server\folder\). If the target system has a static IP adress, the name should be replaced by this IP adress.")
Global $lng_unchanged = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_unchanged", "Unchanged")
Global $lng_useoptimizer = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_useoptimizer", "Use optimizer")
Global $lng_use_seasonposter = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_use_seasonposter", "Use seasonposter")
Global $lng_use_seasonbanner = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_use_seasonbanner", "Use seasonbanner")
Global $lng_value = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_value", "Value")
Global $lng_video = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_video", "Video")
Global $lng_VideoCodec = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_VideoCodec", "Video Codec")
Global $lng_videos = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_videos", "Videos")
Global $lng_waiting = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_waiting", "Waiting")
Global $lng_watched = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_watched", "Backup/Restore of watched flags")
Global $lng_whichgfx = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_whichgfx", "What graphics to load?")
Global $lng_width = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_width", "Width")
Global $lng_wizards = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_wizards", "Wizards")
Global $lng_working = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_working", "I am working")
Global $lng_workingdrive = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_workingdrive", "Working drive:")
Global $lng_workingon = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_workingon", "Working on:")
Global $lng_year = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_year", "Year")
Global $lng_zerocoding = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_zerocoding", "Always recode bitrate 0")

#EndRegion ;Ini Read Localized Strings

#Region ;Declare Global Variables

If @Compiled = 1 Then

	$Version = FileGetVersion(@ScriptFullPath)

Else

	$file = FileOpen(@ScriptFullPath, 0)

	If $file = -1 Then
		MsgBox(0, "Error", "Unable to open file.")
		Exit
	EndIf

	While 1

		Local $line = FileReadLine($file)
		If @error = -1 Then ExitLoop
		If StringInStr($line, "#AutoIt3Wrapper_Res_Fileversion=") Then
			$ver = StringSplit($line, "=")
			$Version = $ver[2]
			ExitLoop
		EndIf

	WEnd

	FileClose($file)

EndIf

Global $BannerArray, $PosterArray, $ThumbsArray, $KodiArtArray, $audioonlycode = 0
Global $Clock = "00:00"
Global $Lastmodule, $listitem_100_01 = "", $listitem_110_01 = "", $listitem_120_01 = "", $listitem_130_01 = "", $listitem_140_01 = "", $listitem_150_01 = ""
Global $DriveArray = DriveGetDrive( "fixed" )
Global $Title = "Media-Buddy " & $Version
Global $box, $timer, $stubext, $count, $dotreturn
Global $tempdir = $ini_workingdrive & "\Media-Buddy-Temp"
Global $ArrayVideoWhitelist[1]
Global $ArrayAudioWhitelist[1]
Global $ArrayGraphics[1]
Global $ArrayRaw[1]



_WriteLog("*********************************")
_WriteLog("*                               *")
_WriteLog("*  Starting " & $Title & "  *")
_WriteLog("*                               *")
_WriteLog("*********************************")
_WriteLog(" ")
_WriteLog("Info - Read Localized Strings")
_WriteLog("Info - Read Configuration From Ini")
_WriteLog("Info - Declared Global Variables")

#EndRegion ;Declare Global Variables

#Region ;Initial preparations

FileDelete(@ScriptDir & "\*.pid")

DirCreate($tempdir)
If @error Then
		_WriteLog("Error - Failure While Creating Working Directory " & $tempdir)

Else

	_WriteLog("Info - Created Working Directory " & $tempdir)

EndIf

;Start Don't Sleep

If not ProcessExists("DontSleep_x64.exe") Then

	Local $opt = "hide"

	If $ini_DontSleep = 1 Then

		If $ini_DontSleep_standby = 1 Then $opt = $opt & " block_standby=1"

		If $ini_DontSleep_shutdown = 1 Then $opt = $opt & " block_shutdown=1"

		ShellExecute(@ScriptDir & "\DontSleep_x64.exe", $opt)

		_WriteLog("Info - DontSleep Started")

	EndIf

EndIf

HttpSetUserAgent($Title)

;Read Unicode List Array

_WriteLog("Info - Read Allowed Unicode Chars")

Global $ArrayUnicode[0]

$Unicode_file = FileOpen(@ScriptDir & "\unicode_codes.txt", 0)
If $Unicode_file = -1 Then

	_WriteLog("Error - Failed to open unicode_codes.txt")

	_Exit()

EndIf

While 1

	$Unicode_line = FileReadLine($Unicode_file)

	If @error = -1 Then ExitLoop

	_ArrayAdd($ArrayUnicode, StringStripWS($Unicode_line,8))

WEnd

;Read _VariousArtists List String

_WriteLog("Info - Read Various Artitst String")

Global $String_VariousArtists

$VariousArtists = FileOpen(@ScriptDir & "\VariousArtists.txt", 0)

If $VariousArtists = -1 Then

	_WriteLog("Error - Failed to open VariousArtists.txt")

	_Exit()

EndIf

While 1

	$Various = FileReadLine($VariousArtists)

	If @error = -1 Then ExitLoop

	$String_VariousArtists = $String_VariousArtists & @CRLF & $Various

WEnd

;Read Font List Array

Global $ArrayFont[1]

$Font_file = FileOpen(@ScriptDir & "\fonts.txt", 0)
If $Font_file = -1 Then

	_WriteLog("Error - Failed to open fonts.txt")

	_Exit()

EndIf

While 1

	$Font_line = FileReadLine($Font_file)
	If @error = -1 Then ExitLoop
	_ArrayAdd($ArrayFont, $Font_line)

WEnd

;Read Video Whitelist Array

$VideoWhitelist_file = FileOpen(@ScriptDir & "\VideoWhitelist.txt", 0)
If $VideoWhitelist_file = -1 Then

	_WriteLog("Error - Failed to open VideoWhitelist.txt")

	_Exit()

EndIf

While 1

	$VideoWhitelist_line = FileReadLine($VideoWhitelist_file)
	If @error = -1 Then ExitLoop
	_ArrayAdd($ArrayVideoWhitelist, $VideoWhitelist_line)

WEnd

;~ ;Read Audio Whitelist Array
	$AudioWhitelist_file = FileOpen(@ScriptDir & "\AudioWhitelist.txt", 0)
	If $AudioWhitelist_file = -1 Then

		_WriteLog("Error - Failed to open AudioWhitelist.txt")

		_Exit()

	EndIf

	While 1

		$AudioWhitelist_line = FileReadLine($AudioWhitelist_file)
		If @error = -1 Then ExitLoop
		_ArrayAdd($ArrayAudioWhitelist, $AudioWhitelist_line)

	WEnd

; Read allowed video file extentions
	If IsArray($json_FileExtensions) Then

		$extstring = $json_FileExtensions[0]

		For $i = 1 To UBound($json_FileExtensions) - 1

			$extstring = $extstring & ";" & $json_FileExtensions[$i]

		Next

	Else

		$extstring = $json_FileExtensions

	EndIf

	$extstring2  = $extstring

	For $i = 1 To UBound($ArrayMediaStub) - 1

		$extstring2 = $extstring2 & ";" & $ArrayMediaStub[$i]

	Next

	$stubext  = ""

	If _ElementExists($ArrayMediaStub, 1) Then

		$stubext  = $ArrayMediaStub[1]

		If UBound($ArrayMediaStub) > 2 Then

			For $i = 2 To UBound($ArrayMediaStub) - 1

				$stubext = $stubext & ";" & $ArrayMediaStub[$i]

			Next

		EndIf

	EndIf

; Read graphics file arrays

	_WriteLog("Info - Read Graphics Array")

	$Graphics = FileOpen(@ScriptDir & "\Graphics.txt", 0)

	If $Graphics = -1 Then

		_WriteLog("Error - Failed to open Graphics.txt")

		_Exit()

	EndIf

	While 1

		$graph = FileReadLine($Graphics)

		If @error = -1 Then ExitLoop

		_ArrayAdd($ArrayGraphics,$graph)

	WEnd

	; Read allowed camera-raw file extentions

	_WriteLog("Info - Read Camera-Raw Array")

	$raw = FileOpen(@ScriptDir & "\camera-raw.txt", 0)

	If $raw = -1 Then

		_WriteLog("Error - Failed to open camera-raw.txt")

		_Exit()

	EndIf

	While 1

		$graph = FileReadLine($raw)

		If @error = -1 Then ExitLoop

		_ArrayAdd($ArrayRaw,$graph)

WEnd

; Read allowed graphics file extentions

	$gextstring = "*." & $ArrayGraphics[1]

	For $i = 2 To UBound($ArrayGraphics) - 1

		$gextstring = $gextstring & ";*." & $ArrayGraphics[$i]

	Next

	For $i = 1 To UBound($ArrayRaw) - 1

		$gextstring = $gextstring & ";*." & $ArrayRaw[$i]

	Next

	_WriteLog("Info - Read Allowed Graphics File Extentions = " & $gextstring)

; Read allowed audio file extentions
	If IsArray($json_Music_FileExtensions) Then

		$aextstring = $json_Music_FileExtensions[0]

		For $i = 1 To UBound($json_Music_FileExtensions) - 1

			$aextstring = $aextstring & ";" & $json_Music_FileExtensions[$i]

		Next

	Else

		$aextstring = $json_Music_FileExtensions

	EndIf

	_WriteLog("Info - Read Allowed Audio File Extentions = " & $aextstring)


;Get sorted Audio Codecs
	Dim $CodecArray[0]

	_ArrayAdd($CodecArray, $ini_codec1)
	_ArrayAdd($CodecArray, $ini_codec2)
	_ArrayAdd($CodecArray, $ini_codec3)
	_ArrayAdd($CodecArray, $ini_codec4)
	_ArrayAdd($CodecArray, $ini_codec5)

	;Get available languages
	Global $Arraylng[1]
	$search1 = FileFindFirstFile(@ScriptDir & "\Language\*.lng")
	If $search1 = -1 Then
		MsgBox(0, $lng_error, $lng_errmsg)
		Exit
	EndIf

	While 1
		$file = FileFindNextFile($search1)
		If @error Then Exitloop
		_ArrayAdd($Arraylng, $file)
	WEnd
	FileClose($search1)

	_WriteLog("Info - Read Available Languages")

	;Get available Cover Templates
	Global $ArrayCover[1]
	$search2 = FileFindFirstFile(@ScriptDir & "\Templates\Cover\*.png")

	While 1
		$file = FileFindNextFile($search2)
		If @error Then Exitloop
		_ArrayAdd($ArrayCover, $file)
	WEnd

	FileClose($search2)

	$search2a = FileFindFirstFile(@ScriptDir & "\Templates\Cover\*.jpg")

	While 1
		$filea = FileFindNextFile($search2a)
		If @error Then Exitloop
		_ArrayAdd($ArrayCover, $filea)
	WEnd

	FileClose($search2a)

	_WriteLog("Info - Read Available Cover Templates")

	;Get available Backdrop Templates
	Global $ArrayBackdrop[1]
	$search3 = FileFindFirstFile(@ScriptDir & "\Templates\Backdrop\*.png")

	While 1
		$file = FileFindNextFile($search3)
		If @error Then Exitloop
		_ArrayAdd($ArrayBackdrop, $file)
	WEnd

	FileClose($search3)

	$search3a = FileFindFirstFile(@ScriptDir & "\Templates\Backdrop\*.jpg")

	While 1
		$filea = FileFindNextFile($search3a)
		If @error Then Exitloop
		_ArrayAdd($ArrayBackdrop, $filea)
	WEnd

	FileClose($search3a)

	_WriteLog("Info - Read Available Backdrop Templates")

	;Get available Border Templates
	Global $ArrayBorder[1]
	$search4 = FileFindFirstFile(@ScriptDir & "\Templates\Border\*.png")

	While 1
		$file = FileFindNextFile($search4)
		If @error Then Exitloop
		_ArrayAdd($ArrayBorder, $file)
	WEnd

	FileClose($search4)

	_WriteLog("Info - Read Available Border Templates")

	;Check if at least one naming scheme is selected and if not, select the default scheme.
	If $ini_naming_default <> "1" Then

		If $ini_naming_emby <> "1" Then

			If $ini_naming_mp1 <> "1" Then

				$ini_naming_default = "1"

				IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_naming_default", "1")

			EndIf

		EndIf

	EndIf

	;Startup SQLite
	_SQLite_Startup()
	If @error Then
		MsgBox($MB_SYSTEMMODAL, "SQLite Error", "No SQlite3.dll found")
		Exit -1
	EndIf

	_SQLite_Open(@ScriptDir & "\Media-Buddy.s3db")

	If @error Then
		MsgBox($MB_SYSTEMMODAL, "SQLite Error", "Could Not Create Database")
		Exit -1
	EndIf

	_WriteLog("Info - SQlite Started")


#EndRegion ;Initial preparations

#Region ;Main Window

#Region ;Generate Header And Footer

	$style = $WS_SYSMENU + $WS_CAPTION + $WS_MINIMIZEBOX + $WS_EX_ACCEPTFILES + $BS_PUSHLIKE

	Global $Mainwindow = GUICreate($Title, 1000, 680, -1, -1, $style, $WS_EX_COMPOSITED)
	GUISetState(@SW_HIde, $Mainwindow)

	GUISetBkColor("0xffffff")

	Global $Pic01 = GUICtrlCreatePic (@ScriptDir & "\Images\Media-Buddy_Header.jpg", 0, 0, 999, 111)

	Global $Pic02 = GUICtrlCreatePic (@ScriptDir & "\Images\Line_1.jpg", 0, 111, 1000, 1)

	Global $Label01 = GUICtrlCreateLabel($Title, 1, 632, 999, 28, $SS_ETCHEDFRAME)

	Global $Label02 = GUICtrlCreateLabel($lng_waiting, 10, 639, 950, 18, $SS_LEFTNOWORDWRAP)

	Global $Label03 = GUICtrlCreateLabel($Clock, 935, 639, 50, 18, $SS_RIGHT)

	Dim $Array_GUI_Elements_[1]
	_ArrayAdd($Array_GUI_Elements_, $Label01)
	_ArrayAdd($Array_GUI_Elements_, $Label02)
	_ArrayAdd($Array_GUI_Elements_, $Label03)
	_ArrayAdd($Array_GUI_Elements_, $Pic01)
	_ArrayAdd($Array_GUI_Elements_, $Pic02)

#EndRegion

#Region ;Generate Main Menu

	Global $Filemenu = GUICtrlCreateMenu($lng_files)
	Global $Exititem = GUICtrlCreateMenuItem($lng_exit, $filemenu)

#EndRegion

#Region ;Generate Help Menu

	Global $Helpmenu = GUICtrlCreateMenu("?")
	Global $Infoitem = GUICtrlCreateMenuItem($lng_about, $helpmenu)
	Global $Docitem = GUICtrlCreateMenuItem($lng_manual, $helpmenu)

#EndRegion

#Region ;Generate Main Navigation

	Global $Navigation_Button_01 = GUICtrlCreateButton($lng_wizards, 2, 112, 150, 25)
	GUICtrlSetFont(-1, 10, 0, 0, "Verdana")

	Global $Navigation_Button_02 = GUICtrlCreateButton("Medien- " & $lng_conversion, 152, 112, 150, 25, $BS_FLAT)
	GUICtrlSetFont(-1, 10, 0, 0, "Verdana")

	Global $Navigation_Button_03 = GUICtrlCreateButton($lng_metadata, 302, 112, 150, 25)
	GUICtrlSetFont(-1, 10, 0, 0, "Verdana")

	Global $Navigation_Button_04 = GUICtrlCreateButton($lng_metadata_correction, 452, 112, 150, 25)
	GUICtrlSetFont(-1, 10, 0, 0, "Verdana")

	Global $Navigation_Button_05 = GUICtrlCreateButton($lng_tools, 602, 112, 150, 25)
	GUICtrlSetFont(-1, 10, 0, 0, "Verdana")

	Global $Navigation_Button_06 = GUICtrlCreateButton($lng_config, 752, 112, 150, 25)
	GUICtrlSetFont(-1, 10, 0, 0, "Verdana")

	Dim $Array_GUI_Elements_01[1]
	_ArrayAdd($Array_GUI_Elements_01, $Navigation_Button_01)
	_ArrayAdd($Array_GUI_Elements_01, $Navigation_Button_02)
	_ArrayAdd($Array_GUI_Elements_01, $Navigation_Button_03)
	_ArrayAdd($Array_GUI_Elements_01, $Navigation_Button_05)
	_ArrayAdd($Array_GUI_Elements_01, $Navigation_Button_06)
	_ArrayAdd($Array_GUI_Elements_01, $Navigation_Button_04)

#EndRegion

#Region ;Generate Optimizer GUI Elements (90)

	Global $label_90_01 = GUICtrlCreateLabel($lng_optimizer & "- " & $lng_options, 770, 400)

	Global $label_90_04 = GUICtrlCreateLabel($lng_tracksperlanguage, 795, 503, 100, 20)

	Global $input_90_04 = GUICtrlCreateInput($ini_tracksperlanguage_audio, 770, 500, 20, 20, $ES_RIGHT)

	Global $label_90_05 = GUICtrlCreateLabel($lng_forced & " " & $lng_tracksperlanguage, 795, 588, 200, 20)

	Global $input_90_05 = GUICtrlCreateInput($ini_tracksperlanguage_forced, 770, 585, 20, 20, $ES_RIGHT)

	Global $label_90_06 = GUICtrlCreateLabel($lng_tracksperlanguage, 795, 610, 100, 15)

	Global $input_90_06 = GUICtrlCreateInput($ini_tracksperlanguage_sub, 770, 607, 20, 20, $ES_RIGHT)

	Global $label_90_10 = GUICtrlCreateLabel($lng_audiolanguages & ":", 770, 483, 100, 20)

	Global $input_90_10 = GUICtrlCreateInput($ini_audiolanguages, 880, 480, 70, 20)

	Global $label_90_11 = GUICtrlCreateLabel($lng_sublanguages & ":", 770, 563, 100, 20)

	Global $input_90_11 = GUICtrlCreateInput($ini_sublanguages, 880, 560, 70, 20)

	Global $check_90_01 = GUICtrlCreateCheckbox($lng_audio & " " & $lng_useoptimizer, 770, 460)

	Global $check_90_02 = GUICtrlCreateCheckbox($lng_subtitle & " " & $lng_useoptimizer, 770, 535)

	Global $check_90_12 = GUICtrlCreateCheckbox($lng_video & " " & $lng_useoptimizer, 770, 423)

	Global $input_90_12 = GUICtrlCreateInput($ini_tracks_video, 880, 423, 20, 20, $ES_RIGHT)

	Global $label_90_12 = GUICtrlCreateLabel($lng_tracks, 910, 427, 100, 20)


	If $ini_useoptimizer = "1" Then
		GUICtrlSetState($check_90_01, $GUI_CHECKED)
	Else
		GUICtrlSetState($check_90_01, $GUI_UNCHECKED)
	EndIf

	If $ini_useoptimizer_subs = "1" Then
		GUICtrlSetState($check_90_02, $GUI_CHECKED)
	Else
		GUICtrlSetState($check_90_02, $GUI_UNCHECKED)
	EndIf

	If $ini_useoptimizer_video = "1" Then
		GUICtrlSetState($check_90_12, $GUI_CHECKED)
	Else
		GUICtrlSetState($check_90_12, $GUI_UNCHECKED)
	EndIf

#EndRegion

#Region ;Generate Series Graphics GUI Elements (91)

	Global $label_91_01 = GUICtrlCreateLabel($lng_whichgfx, 320, 400, 120, 20)

	Global $check_91_01 = GUICtrlCreateCheckbox("Background/Fanart", 320, 430)

	Global $check_91_02 = GUICtrlCreateCheckbox("Banner", 320, 460)

	Global $check_91_03 = GUICtrlCreateCheckbox("Poster/Cover", 320, 490)

	Global $check_91_04 = GUICtrlCreateCheckbox("Clearart/Logo", 320, 520)

	Global $check_91_05 = GUICtrlCreateCheckbox("Thumbnail", 320, 550)

	Global $check_91_06 = GUICtrlCreateCheckbox($lng_season & "Poster/Banner", 320, 580)


	If $json_TVShow_Image_Fanart = "True" Then
		GUICtrlSetState($check_91_01, $GUI_CHECKED)
	Else
		GUICtrlSetState($check_91_01, $GUI_UNCHECKED)
	EndIf

	If $json_TVShow_Image_Banner = "True" Then
		GUICtrlSetState($check_91_02, $GUI_CHECKED)
	Else
		GUICtrlSetState($check_91_02, $GUI_UNCHECKED)
	EndIf

	If $json_TVShow_Image_Poster = "True" Then
		GUICtrlSetState($check_91_03, $GUI_CHECKED)
	Else
		GUICtrlSetState($check_91_03, $GUI_UNCHECKED)
	EndIf

	If $json_TVShow_Image_ClearLogo = "True" Then
		GUICtrlSetState($check_91_04, $GUI_CHECKED)
	Else
		GUICtrlSetState($check_91_04, $GUI_UNCHECKED)
	EndIf

	If $json_TVShow_Image_Episode = "True" Then
		GUICtrlSetState($check_91_05, $GUI_CHECKED)
	Else
		GUICtrlSetState($check_91_05, $GUI_UNCHECKED)
	EndIf

	If $json_TVShow_Image_SeasonPoster = "True" Then
		GUICtrlSetState($check_91_06, $GUI_CHECKED)
	Else
		GUICtrlSetState($check_91_06, $GUI_UNCHECKED)
	EndIf


#EndRegion

#Region ;Generate Tagging GUI Elements (92)

	Global $label_92_01 = GUICtrlCreateLabel($lng_options, 50, 400, 180, 20)

	Global $check_92_01 = GUICtrlCreateCheckbox($lng_download_images, 50, 430)

	Global $check_92_03 = GUICtrlCreateCheckbox($lng_shouldnfoattach, 50, 460)

	Global $check_92_05 = GUICtrlCreateCheckbox($lng_refreshgfx, 50, 490)

	Global $check_92_06 = GUICtrlCreateCheckbox($lng_refreshnfo, 50, 520)

	Global $check_92_15 = GUICtrlCreateCheckbox($lng_refreshgfx, 50, 490)

	Global $check_92_16 = GUICtrlCreateCheckbox($lng_refreshnfo, 50, 520)

	Global $label_92_02 = GUICtrlCreateLabel($lng_default_datasource, 50, 550, 180, 20)


	GUIStartGroup()

	Global $radio_92_01 = GUICtrlCreateRadio(" TVDB", 50, 570, 150, 20)

	Global $radio_92_02 = GUICtrlCreateRadio(" TMDB", 50, 590, 150, 20)


	If $json_Download_Images = "True" Then
		GUICtrlSetState($check_92_01, $GUI_CHECKED)
	Else
		GUICtrlSetState($check_92_01, $GUI_UNCHECKED)
	EndIf

	If $ini_tagging = 1 Then
		GUICtrlSetState($check_92_03, $GUI_CHECKED)
	Else
		GUICtrlSetState($check_92_03, $GUI_UNCHECKED)
	EndIf

	If $ini_meta_series_refresh_gfx = "1" Then
		GUICtrlSetState($check_92_05, $GUI_CHECKED)
	Else
		GUICtrlSetState($check_92_05, $GUI_UNCHECKED)
	EndIf

	If $ini_meta_series_refresh_nfo = "1" Then
		GUICtrlSetState($check_92_06, $GUI_CHECKED)
	Else
		GUICtrlSetState($check_92_06, $GUI_UNCHECKED)
	EndIf

	If $ini_meta_movies_refresh_gfx = "1" Then
		GUICtrlSetState($check_92_15, $GUI_CHECKED)
	Else
		GUICtrlSetState($check_92_15, $GUI_UNCHECKED)
	EndIf

	If $ini_meta_movies_refresh_nfo = "1" Then
		GUICtrlSetState($check_92_16, $GUI_CHECKED)
	Else
		GUICtrlSetState($check_92_16, $GUI_UNCHECKED)
	EndIf

	If $json_TVShow_DefaultGrabber = "TVDB" Then GUICtrlSetState($radio_92_01, $GUI_CHECKED)

	If $json_TVShow_DefaultGrabber = "TMDB" Then GUICtrlSetState($radio_92_02, $GUI_CHECKED)


#EndRegion

#Region ;Generate Movies Graphics GUI Elements (93)

	Global $label_93_01 = GUICtrlCreateLabel($lng_whichgfx, 320, 400, 130, 20)

	Global $check_93_01 = GUICtrlCreateCheckbox("Fanart", 320, 430)

	Global $check_93_02 = GUICtrlCreateCheckbox("Cover", 320, 460)

	Global $check_93_03 = GUICtrlCreateCheckbox($lng_movieset & "-Fanart", 320, 490)

	Global $check_93_04 = GUICtrlCreateCheckbox("Banner - Thumb", 320, 520)

	Global $check_93_05 = GUICtrlCreateCheckbox("ClearArt", 320, 550)

	Global $check_93_06 = GUICtrlCreateCheckbox($lng_download_chapters, 50, 550)

	Global $check_93_07 = GUICtrlCreateCheckbox("Trailer", 320, 580)

	If $json_Movies_Image_Backdrop = "True" Then
		GUICtrlSetState($check_93_01, $GUI_CHECKED)
	Else
		GUICtrlSetState($check_93_01, $GUI_UNCHECKED)
	EndIf

	If $json_Movies_Image_Poster = "True" Then
		GUICtrlSetState($check_93_02, $GUI_CHECKED)
	Else
		GUICtrlSetState($check_93_02, $GUI_UNCHECKED)
	EndIf

	If $json_Movies_Image_MovieSetFanart = "True" Then
		GUICtrlSetState($check_93_03, $GUI_CHECKED)
	Else
		GUICtrlSetState($check_93_03, $GUI_UNCHECKED)
	EndIf

	If $json_Movies_Image_Thumb = "True" Then
		GUICtrlSetState($check_93_04, $GUI_CHECKED)
	Else
		GUICtrlSetState($check_93_04, $GUI_UNCHECKED)
	EndIf

	If $json_Movies_Image_ClearLogo = "True" Then
		GUICtrlSetState($check_93_05, $GUI_CHECKED)
	Else
		GUICtrlSetState($check_93_05, $GUI_UNCHECKED)
	EndIf

	If  $json_Chapter_GrabChapter = "True" Then
		GUICtrlSetState($check_93_06, $GUI_CHECKED)
	Else
		GUICtrlSetState($check_93_06, $GUI_UNCHECKED)
	EndIf

	If  $json_Trailer_Download = "True" Then
		GUICtrlSetState($check_93_07, $GUI_CHECKED)
	Else
		GUICtrlSetState($check_93_07, $GUI_UNCHECKED)
	EndIf

#EndRegion

#Region ;Generate Metadata GUI Elements (94)

	Global $label_94_01 = GUICtrlCreateLabel($lng_metadata_language, 600, 400, 350, 20)

	Global $input_94_01 = GUICtrlCreateCombo("", 600, 420, 100, 20)
;~ 	GUICtrlSetData($input_94_01, "cn|cz|dk|de|en|es|fi|fr|gr|he|hr|hu|it|jp|kr|nl|no|pl|pt|ru|se|sl|tr", $json_Language)
	GUICtrlSetData($input_94_01, "cs|da|de|el|en|es|fi|fr|he|hr|hu|it|ja|ko|nl|no|pl|pt|sv|sl|tr|zh", $json_Language)

	Global $pic_94_01 = GUICtrlCreatePic($ini_meta_flag, 750, 421, 68, 40)
	GUICtrlSetState($pic_94_01, $GUI_HIDE)

	Global $pic_94_01a = GUICtrlCreatePic(@ScriptDir & "\Images\Flags\black.jpg", 749, 420, 70, 42)
	GUICtrlSetState($pic_94_01a, $GUI_HIDE)

	Global $input_94_04 = GUICtrlCreateInput($json_Language3, 600, 460, 100, 20)

	Global $label_94_02 = GUICtrlCreateLabel($lng_folder_ignore, 600, 500, 350, 20)

	Global $input_94_02 = GUICtrlCreateInput($json_Folder_Ignore, 600, 520, 350, 20)

	Global $label_94_03 = GUICtrlCreateLabel($lng_file_ignore, 600, 550, 350, 20)

	Global $input_94_03 = GUICtrlCreateInput($json_File_Ignore_Strings, 600, 570, 350, 20)

#EndRegion

#Region ;Generate Video- Metadata GUI Elements (95)

	Global $check_95_01 = GUICtrlCreateCheckbox($lng_nocover, 50, 560)

	Global $check_95_02 = GUICtrlCreateCheckbox($lng_nobackdrop, 50, 580)

	Global $check_95_03 = GUICtrlCreateCheckbox($lng_nonfo, 50, 600)

	Global $label_95_26 = GUICtrlCreateLabel($lng_design, 250, 400, 100, 20)

	Global $combo_95_01 = GUICtrlCreateCombo("", 250, 420, 150)
	GUICtrlSetData(-1, "1-2|1-3|1-4|1-5|1-6|2-2|2-3|2-4|2-5|2-6", $ini_fanart_design)

	Global $label_95_27 = GUICtrlCreateLabel($lng_fonttype, 250, 450, 100, 20)

	Global $combo_95_02 = GUICtrlCreateCombo("", 250, 470, 150)

	For $I = 1 to UBound($ArrayFont)-1
		GUICtrlSetData($combo_95_02, $ArrayFont[$I], $ini_fanart_font)
	Next

	Global $label_95_31 = GUICtrlCreateLabel($lng_genrefallback, 250, 500, 100, 20)

	Global $input_95_08 = GUICtrlCreateInput($ini_fanart_genre, 250, 520, 150, 20)

	Global $check_95_04 = GUICtrlCreateCheckbox($lng_genrefolder, 250, 560)

	Global $check_95_05 = GUICtrlCreateCheckbox($lng_mediainfoplot, 250, 580, 150)

	Global $label_95_28 = GUICtrlCreateLabel($lng_covertemplate, 420, 400, 100, 20)

	Global $combo_95_03 = GUICtrlCreateCombo($ini_fanart_covertemplate, 420, 420, 150)

	GUICtrlSetData($combo_95_03, "---------", $ini_fanart_covertemplate)

	For $I = 1 to UBound($ArrayCover)-1
		GUICtrlSetData($combo_95_03, $ArrayCover[$I], $ini_fanart_covertemplate)
	Next

	Global $label_95_29 = GUICtrlCreateLabel($lng_backdroptemplate, 420, 450, 100, 20)

	Global $combo_95_04 = GUICtrlCreateCombo($ini_fanart_backgroundtemplate, 420, 470, 150)

	GUICtrlSetData($combo_95_04, "---------", $ini_fanart_backgroundtemplate)

	For $I = 1 to UBound($ArrayBackdrop)-1
		GUICtrlSetData($combo_95_04, $ArrayBackdrop[$I], $ini_fanart_backgroundtemplate)
	Next

	Global $label_95_30 = GUICtrlCreateLabel($lng_bordertemplate, 590, 400, 100, 20)

	Global $combo_95_05 = GUICtrlCreateCombo($ini_fanart_bordertemplate, 590, 420, 150)

	GUICtrlSetData($combo_95_05, "---------", $ini_fanart_bordertemplate)
	GUICtrlSetData($combo_95_05, $lng_color, $ini_fanart_bordertemplate)
	GUICtrlSetData($combo_95_05, $lng_random, $ini_fanart_bordertemplate)

	For $I = 1 to UBound($ArrayBorder)-1
		GUICtrlSetData($combo_95_05, $ArrayBorder[$I], $ini_fanart_bordertemplate)
	Next

	Global $label_95_06 = GUICtrlCreateLabel($lng_bordercolor, 590, 450, 100, 20)

	Global $input_95_07 = GUICtrlCreateInput($ini_fanart_bordercolor, 590, 470, 150, 20)

	Global $label_95_32 = GUICtrlCreateLabel($lng_summary, 420, 500, 100, 20)

	Global $edit_95_01 = GUICtrlCreateEdit($ini_fanart_plot, 420, 520, 320, 100, $ES_AUTOVSCROLL + $WS_VSCROLL)


#EndRegion

#Region ;Generate Video- Normalize GUI Elements (97)

	Global $label_97_01 = GUICtrlCreateLabel($lng_audionorm, 550, 400, 100, 20)

	Global $check_97_01 = GUICtrlCreateCheckbox($lng_audionormalize, 550, 430)

	Global $input_97_01 = GUICtrlCreateInput($ini_audio_db, 550, 460, 50, 20)

	Global $label_97_03 = GUICtrlCreateLabel("Peak (0-1)", 605, 463)

	Global $label_97_02 = GUICtrlCreateLabel($lng_audiocompress, 550, 500)

	$ini_audio_compression = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_audio_compression", "2")

	Global $audiocompress

	If $ini_audio_compression = 0 Then $audiocompress = "0 - " & $lng_audiocompress0
	If $ini_audio_compression = 1 Then $audiocompress = "1 - " & $lng_audiocompress1
	If $ini_audio_compression = 2 Then $audiocompress = "2 - " & $lng_audiocompress2
	If $ini_audio_compression = 3 Then $audiocompress = "3 - " & $lng_audiocompress3
	If $ini_audio_compression = 4 Then $audiocompress = "4 - " & $lng_audiocompress4

	Global $combo_97_01 = GUICtrlCreateCombo("", 550, 530, 100)
	GUICtrlSetData(-1, "0 - " & $lng_audiocompress0 & "|1 - " & $lng_audiocompress1 & "|2 - " & $lng_audiocompress2 & "|3 - " & $lng_audiocompress3 & "|4 - " & $lng_audiocompress4, $audiocompress)

#EndRegion

#Region ;Generate Audio- Normalize GUI Elements (98)

	Global $label_98_01 = GUICtrlCreateLabel($lng_audionorm, 550, 400, 100, 20)

	Global $check_98_01 = GUICtrlCreateCheckbox($lng_audionormalize, 550, 430)

	Global $input_98_01 = GUICtrlCreateInput($ini_aaudio_db, 550, 460, 50, 20)

	Global $label_98_03 = GUICtrlCreateLabel("Peak (0-1)", 605, 463)

	Global $label_98_02 = GUICtrlCreateLabel($lng_audiocompress, 550, 500)

	$ini_aaudio_compression = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_aaudio_compression", "0")

	Global $audiocompress

	If $ini_aaudio_compression = 0 Then $audiocompress = "0 - " & $lng_audiocompress0
	If $ini_aaudio_compression = 1 Then $audiocompress = "1 - " & $lng_audiocompress1
	If $ini_aaudio_compression = 2 Then $audiocompress = "2 - " & $lng_audiocompress2
	If $ini_aaudio_compression = 3 Then $audiocompress = "3 - " & $lng_audiocompress3
	If $ini_aaudio_compression = 4 Then $audiocompress = "4 - " & $lng_audiocompress4

	Global $combo_98_01 = GUICtrlCreateCombo("", 550, 530, 100)
	GUICtrlSetData(-1, "0 - " & $lng_audiocompress0 & "|1 - " & $lng_audiocompress1 & "|2 - " & $lng_audiocompress2 & "|3 - " & $lng_audiocompress3 & "|4 - " & $lng_audiocompress4, $audiocompress)

#EndRegion

#Region ;Generate Dynamic GUI Elements (99)

	Global $label_f99_04 = GUICtrlCreateLabel($lng_doafter, 50, 480, 600, 26, $SS_LEFTNOWORDWRAP)
	GUICtrlSetFont(-1, 12)

	GUIStartGroup()
		Global $radio_f99_01 = GUICtrlCreateRadio($lng_nothing, 50, 510, 200, 20)

		Global $radio_f99_02 = GUICtrlCreateRadio($lng_after, 50, 540, 200, 20)

		Global $radio_f99_03 = GUICtrlCreateRadio($lng_close, 50, 570, 200, 20)

		Global $radio_f99_04 = GUICtrlCreateRadio($lng_shutdown, 270, 510, 200, 20)

		Global $radio_f99_05 = GUICtrlCreateRadio($lng_standby, 270, 540, 200, 20)

		Global $radio_f99_06 = GUICtrlCreateRadio($lng_hibernate, 270, 570, 200, 20)



	GUICtrlSetState($radio_f99_01, $GUI_CHECKED)

	Dim $Array_FUNC_99[1]

	_ArrayAdd($Array_FUNC_99, $label_f99_04)

	_ArrayAdd($Array_FUNC_99, $radio_f99_01)
	_ArrayAdd($Array_FUNC_99, $radio_f99_02)
	_ArrayAdd($Array_FUNC_99, $radio_f99_03)
	_ArrayAdd($Array_FUNC_99, $radio_f99_04)
	_ArrayAdd($Array_FUNC_99, $radio_f99_05)
	_ArrayAdd($Array_FUNC_99, $radio_f99_06)

	_ClearGUI($Array_FUNC_99)


#EndRegion

#Region ;Generate Dynamic Series Wizard GUI Elements (f11)

	Global $label_f11_01 = GUICtrlCreateLabel($lng_pleasewait, 50, 240, 600, 26)
	GUICtrlSetFont(-1, 12)

	Global $label_f11_02 = GUICtrlCreateLabel("", 50, 280, 800, 26, $SS_LEFTNOWORDWRAP)
	GUICtrlSetFont(-1, 12)

	Global $label_f11_03 = GUICtrlCreateLabel("", 50, 400, 800, 26, $SS_LEFTNOWORDWRAP)
	GUICtrlSetFont(-1, 12)

	Global $progressbar_f11_01 = GUICtrlCreateProgress(50, 320, 900, 20)

	Global $progressbar_f11_02 = GUICtrlCreateProgress(50, 440, 900, 20)

	Global $button_f11_01 = GUICtrlCreateButton($lng_cancel, 900, 593, 90)
	GUICtrlSetState(-1, $GUI_deFBUTTON)

	Dim $Array_FUNC_11[1]

	_ArrayAdd($Array_FUNC_11, $button_f11_01)

	_ArrayAdd($Array_FUNC_11, $label_f11_01)
	_ArrayAdd($Array_FUNC_11, $label_f11_02)
	_ArrayAdd($Array_FUNC_11, $label_f11_03)

	_ArrayAdd($Array_FUNC_11, $progressbar_f11_01)
	_ArrayAdd($Array_FUNC_11, $progressbar_f11_02)

	_ClearGUI($Array_FUNC_11)

#EndRegion

#Region ;Generate Series Wizard GUI (1-1)

	Global $label_11_01 = GUICtrlCreateLabel($lng_wizards & ":  " & $lng_series & "- " & $lng_rework, 20, 180, 600, 50)
	GUICtrlSetFont(-1, 20, 700, 0, "Georgia")

	Global $button_11_02 = GUICtrlCreateButton($lng_search, 460, 257, 60)

	Global $label_11_02 = GUICtrlCreateLabel($lng_inputfoldertext, 50, 240, 400, 20)

	Global $input_11_01 = GUICtrlCreateInput($ini_wizard_series_inputfolder, 50, 260, 400, 20)

	Global $button_11_03 = GUICtrlCreateButton($lng_search, 460, 317, 60)

	Global $label_11_03 = GUICtrlCreateLabel($lng_outputfoldertext, 50, 300, 400, 20)

	Global $input_11_02 = GUICtrlCreateInput($ini_wizard_series_outputfolder, 50, 320, 400, 20)

	Global $label_11_04 = GUICtrlCreateLabel($lng_conversiontext1 & " " & $ini_wizard_series_inputfolder & $lng_conversiontext2, 50, 360, 800, 26, $SS_LEFTNOWORDWRAP)

	Global $button_11_01 = GUICtrlCreateButton($lng_start, 900, 353, 90)
	GUICtrlSetState(-1, $GUI_deFBUTTON)

	Global $button_11_04 = GUICtrlCreateButton($lng_delorg, 870, 253, 120)

	Global $label_11_25 = GUICtrlCreateLabel($lng_conversiontext3, 735, 180, 250, 70, $SS_RIGHT)

	Global $label_11_05 = GUICtrlCreateLabel($lng_remuxlimit, 530, 400, 100, 20)

	Global $label_11_06 = GUICtrlCreateLabel("Bitrate (Kbps)", 660, 400, 180, 20)

	Global $input_11_03 = GUICtrlCreateInput($ini_wizard_series_bitrate_sd, 660, 430, 50, 20)

	Global $label_11_13 = GUICtrlCreateLabel($lng_sdmat, 530, 430, 100, 28)

	Global $input_11_04 = GUICtrlCreateInput($ini_wizard_series_bitrate_720, 660, 460, 50, 20)

	Global $label_11_14 = GUICtrlCreateLabel($lng_720mat, 530, 460, 100, 28)

	Global $input_11_05 = GUICtrlCreateInput($ini_wizard_series_bitrate_1080, 660, 490, 50, 20)

	Global $label_11_15 = GUICtrlCreateLabel($lng_1080mat, 530, 490, 100, 28)

	Global $input_11_06 = GUICtrlCreateInput($ini_wizard_series_bitrate_4k, 660, 520, 50, 20)

	Global $label_11_16 = GUICtrlCreateLabel($lng_4kmat, 530, 520, 100, 28)

	Global $Pic_11_01 = GUICtrlCreatePic (@ScriptDir & "\Images\Line_1.jpg", 1, 389, 996, 2)


	Dim $Array_GUI_Elements_11[1]

	_ArrayAdd($Array_GUI_Elements_11, $button_11_01)
	_ArrayAdd($Array_GUI_Elements_11, $button_11_02)
	_ArrayAdd($Array_GUI_Elements_11, $button_11_03)
	_ArrayAdd($Array_GUI_Elements_11, $button_11_04)

	_ArrayAdd($Array_GUI_Elements_11, $input_11_01)
	_ArrayAdd($Array_GUI_Elements_11, $input_11_02)
	_ArrayAdd($Array_GUI_Elements_11, $input_11_03)
	_ArrayAdd($Array_GUI_Elements_11, $input_11_04)
	_ArrayAdd($Array_GUI_Elements_11, $input_11_05)
	_ArrayAdd($Array_GUI_Elements_11, $input_11_06)

	_ArrayAdd($Array_GUI_Elements_11, $label_11_01)
	_ArrayAdd($Array_GUI_Elements_11, $label_11_02)
	_ArrayAdd($Array_GUI_Elements_11, $label_11_03)
	_ArrayAdd($Array_GUI_Elements_11, $label_11_04)
	_ArrayAdd($Array_GUI_Elements_11, $label_11_05)
	_ArrayAdd($Array_GUI_Elements_11, $label_11_06)
	_ArrayAdd($Array_GUI_Elements_11, $label_11_13)
	_ArrayAdd($Array_GUI_Elements_11, $label_11_14)
	_ArrayAdd($Array_GUI_Elements_11, $label_11_15)
	_ArrayAdd($Array_GUI_Elements_11, $label_11_16)
	_ArrayAdd($Array_GUI_Elements_11, $label_11_25)

	_ArrayAdd($Array_GUI_Elements_11, $Pic_11_01)

	_ArrayAdd($Array_GUI_Elements_11, $check_90_01)
	_ArrayAdd($Array_GUI_Elements_11, $check_90_02)
	_ArrayAdd($Array_GUI_Elements_11, $check_90_12)
	_ArrayAdd($Array_GUI_Elements_11, $input_90_04)
	_ArrayAdd($Array_GUI_Elements_11, $input_90_05)
	_ArrayAdd($Array_GUI_Elements_11, $input_90_06)
	_ArrayAdd($Array_GUI_Elements_11, $input_90_10)
	_ArrayAdd($Array_GUI_Elements_11, $input_90_11)
	_ArrayAdd($Array_GUI_Elements_11, $input_90_12)
	_ArrayAdd($Array_GUI_Elements_11, $label_90_01)
	_ArrayAdd($Array_GUI_Elements_11, $label_90_04)
	_ArrayAdd($Array_GUI_Elements_11, $label_90_05)
	_ArrayAdd($Array_GUI_Elements_11, $label_90_06)
	_ArrayAdd($Array_GUI_Elements_11, $label_90_10)
	_ArrayAdd($Array_GUI_Elements_11, $label_90_11)
	_ArrayAdd($Array_GUI_Elements_11, $label_90_12)

	_ArrayAdd($Array_GUI_Elements_11, $label_91_01)
	_ArrayAdd($Array_GUI_Elements_11, $check_91_01)
	_ArrayAdd($Array_GUI_Elements_11, $check_91_02)
	_ArrayAdd($Array_GUI_Elements_11, $check_91_03)
	_ArrayAdd($Array_GUI_Elements_11, $check_91_04)
	_ArrayAdd($Array_GUI_Elements_11, $check_91_05)
	_ArrayAdd($Array_GUI_Elements_11, $check_91_06)

	_ArrayAdd($Array_GUI_Elements_11, $check_92_01)
	_ArrayAdd($Array_GUI_Elements_11, $check_92_03)
	_ArrayAdd($Array_GUI_Elements_11, $check_92_05)
	_ArrayAdd($Array_GUI_Elements_11, $check_92_06)
	_ArrayAdd($Array_GUI_Elements_11, $label_92_01)
	_ArrayAdd($Array_GUI_Elements_11, $label_92_02)

	_ArrayAdd($Array_GUI_Elements_11, $radio_92_01)
	_ArrayAdd($Array_GUI_Elements_11, $radio_92_02)

#EndRegion

#Region ;Generate Dynamic Movies Wizard GUI Elements (f12)

	Global $label_f12_01 = GUICtrlCreateLabel($lng_pleasewait, 50, 240, 600, 26)
	GUICtrlSetFont(-1, 12)

	Global $label_f12_02 = GUICtrlCreateLabel("", 50, 280, 800, 26, $SS_LEFTNOWORDWRAP)
	GUICtrlSetFont(-1, 12)

	Global $label_f12_03 = GUICtrlCreateLabel("", 50, 400, 800, 26, $SS_LEFTNOWORDWRAP)
	GUICtrlSetFont(-1, 12)

	Global $progressbar_f12_01 = GUICtrlCreateProgress(50, 320, 900, 20)

	Global $progressbar_f12_02 = GUICtrlCreateProgress(50, 440, 900, 20)

	Global $button_f12_01 = GUICtrlCreateButton($lng_cancel, 900, 593, 90)
	GUICtrlSetState(-1, $GUI_deFBUTTON)

	Dim $Array_FUNC_12[1]

	_ArrayAdd($Array_FUNC_12, $button_f12_01)

	_ArrayAdd($Array_FUNC_12, $label_f12_01)
	_ArrayAdd($Array_FUNC_12, $label_f12_02)
	_ArrayAdd($Array_FUNC_12, $label_f12_03)

	_ArrayAdd($Array_FUNC_12, $progressbar_f12_01)
	_ArrayAdd($Array_FUNC_12, $progressbar_f12_02)

	_ClearGUI($Array_FUNC_12)

#EndRegion

#Region ;Generate Movies Wizard GUI (1-2)

	Global $label_12_01 = GUICtrlCreateLabel($lng_wizards & ":  " & $lng_movies & "- " & $lng_rework, 20, 180, 600, 50)
	GUICtrlSetFont(-1, 20, 700, 0, "Georgia")

	Global $button_12_02 = GUICtrlCreateButton($lng_search, 460, 257, 60)

	Global $label_12_02 = GUICtrlCreateLabel($lng_inputfoldertext, 50, 240, 400, 20)

	Global $input_12_01 = GUICtrlCreateInput($ini_wizard_movies_inputfolder, 50, 260, 400, 20)

	Global $button_12_03 = GUICtrlCreateButton($lng_search, 460, 317, 60)

	Global $label_12_03 = GUICtrlCreateLabel($lng_outputfoldertext, 50, 300, 400, 20)

	Global $input_12_02 = GUICtrlCreateInput($ini_wizard_movies_outputfolder, 50, 320, 400, 20)

	Global $label_12_04 = GUICtrlCreateLabel($lng_conversiontext1 & " " & $ini_wizard_movies_inputfolder & $lng_conversiontext2, 50, 360, 800, 26, $SS_LEFTNOWORDWRAP)

	Global $button_12_01 = GUICtrlCreateButton($lng_start, 900, 353, 90)
	GUICtrlSetState(-1, $GUI_deFBUTTON)

	Global $button_12_04 = GUICtrlCreateButton($lng_delorg, 870, 253, 120)

	Global $label_12_25 = GUICtrlCreateLabel($lng_conversiontext3, 735, 180, 250, 70, $SS_RIGHT)

	Global $label_12_05 = GUICtrlCreateLabel($lng_remuxlimit, 530, 400, 100, 20)

	Global $label_12_06 = GUICtrlCreateLabel("Bitrate (Kbps)", 660, 400, 180, 20)

	Global $input_12_03 = GUICtrlCreateInput($ini_wizard_movies_bitrate_sd, 660, 430, 50, 20)

	Global $label_12_13 = GUICtrlCreateLabel($lng_sdmat, 530, 430, 100, 28)

	Global $input_12_04 = GUICtrlCreateInput($ini_wizard_movies_bitrate_720, 660, 460, 50, 20)

	Global $label_12_14 = GUICtrlCreateLabel($lng_720mat, 530, 460, 100, 28)

	Global $input_12_05 = GUICtrlCreateInput($ini_wizard_movies_bitrate_1080, 660, 490, 50, 20)

	Global $label_12_15 = GUICtrlCreateLabel($lng_1080mat, 530, 490, 100, 28)

	Global $input_12_06 = GUICtrlCreateInput($ini_wizard_movies_bitrate_4k, 660, 520, 50, 20)

	Global $label_12_16 = GUICtrlCreateLabel($lng_4kmat, 530, 520, 100, 28)

	Global $Pic_12_01 = GUICtrlCreatePic (@ScriptDir & "\Images\Line_1.jpg", 1, 389, 996, 2)


	Dim $Array_GUI_Elements_12[1]

	_ArrayAdd($Array_GUI_Elements_12, $button_12_01)
	_ArrayAdd($Array_GUI_Elements_12, $button_12_02)
	_ArrayAdd($Array_GUI_Elements_12, $button_12_03)
	_ArrayAdd($Array_GUI_Elements_12, $button_12_04)

	_ArrayAdd($Array_GUI_Elements_12, $input_12_01)
	_ArrayAdd($Array_GUI_Elements_12, $input_12_02)
	_ArrayAdd($Array_GUI_Elements_12, $input_12_03)
	_ArrayAdd($Array_GUI_Elements_12, $input_12_04)
	_ArrayAdd($Array_GUI_Elements_12, $input_12_05)
	_ArrayAdd($Array_GUI_Elements_12, $input_12_06)

	_ArrayAdd($Array_GUI_Elements_12, $label_12_01)
	_ArrayAdd($Array_GUI_Elements_12, $label_12_02)
	_ArrayAdd($Array_GUI_Elements_12, $label_12_03)
	_ArrayAdd($Array_GUI_Elements_12, $label_12_04)
	_ArrayAdd($Array_GUI_Elements_12, $label_12_05)
	_ArrayAdd($Array_GUI_Elements_12, $label_12_06)
	_ArrayAdd($Array_GUI_Elements_12, $label_12_13)
	_ArrayAdd($Array_GUI_Elements_12, $label_12_14)
	_ArrayAdd($Array_GUI_Elements_12, $label_12_15)
	_ArrayAdd($Array_GUI_Elements_12, $label_12_16)
	_ArrayAdd($Array_GUI_Elements_12, $label_12_25)

	_ArrayAdd($Array_GUI_Elements_12, $Pic_12_01)

	_ArrayAdd($Array_GUI_Elements_12, $check_90_01)
	_ArrayAdd($Array_GUI_Elements_12, $check_90_02)
	_ArrayAdd($Array_GUI_Elements_12, $check_90_12)
	_ArrayAdd($Array_GUI_Elements_12, $input_90_04)
	_ArrayAdd($Array_GUI_Elements_12, $input_90_05)
	_ArrayAdd($Array_GUI_Elements_12, $input_90_06)
	_ArrayAdd($Array_GUI_Elements_12, $input_90_10)
	_ArrayAdd($Array_GUI_Elements_12, $input_90_11)
	_ArrayAdd($Array_GUI_Elements_12, $input_90_12)
	_ArrayAdd($Array_GUI_Elements_12, $label_90_01)
	_ArrayAdd($Array_GUI_Elements_12, $label_90_04)
	_ArrayAdd($Array_GUI_Elements_12, $label_90_05)
	_ArrayAdd($Array_GUI_Elements_12, $label_90_06)
	_ArrayAdd($Array_GUI_Elements_12, $label_90_10)
	_ArrayAdd($Array_GUI_Elements_12, $label_90_11)
	_ArrayAdd($Array_GUI_Elements_12, $label_90_12)

	_ArrayAdd($Array_GUI_Elements_12, $check_92_01)
	_ArrayAdd($Array_GUI_Elements_12, $check_92_03)
	_ArrayAdd($Array_GUI_Elements_12, $check_92_15)
	_ArrayAdd($Array_GUI_Elements_12, $check_92_16)
	_ArrayAdd($Array_GUI_Elements_12, $label_92_01)

	_ArrayAdd($Array_GUI_Elements_12, $check_93_01)
	_ArrayAdd($Array_GUI_Elements_12, $check_93_02)
	_ArrayAdd($Array_GUI_Elements_12, $check_93_03)
	_ArrayAdd($Array_GUI_Elements_12, $check_93_04)
	_ArrayAdd($Array_GUI_Elements_12, $check_93_05)
	_ArrayAdd($Array_GUI_Elements_12, $check_93_06)
	_ArrayAdd($Array_GUI_Elements_12, $check_93_07)
	_ArrayAdd($Array_GUI_Elements_12, $label_93_01)


#EndRegion

#Region ;Generate Dynamic Videos Wizard GUI Elements (f13)

	Global $label_f13_01 = GUICtrlCreateLabel($lng_pleasewait, 50, 240, 600, 26)
	GUICtrlSetFont(-1, 12)

	Global $label_f13_02 = GUICtrlCreateLabel("", 50, 280, 800, 26, $SS_LEFTNOWORDWRAP)
	GUICtrlSetFont(-1, 12)

	Global $label_f13_03 = GUICtrlCreateLabel("", 50, 400, 800, 26, $SS_LEFTNOWORDWRAP)
	GUICtrlSetFont(-1, 12)

	Global $progressbar_f13_01 = GUICtrlCreateProgress(50, 320, 900, 20)

	Global $progressbar_f13_02 = GUICtrlCreateProgress(50, 440, 900, 20)

	Global $button_f13_01 = GUICtrlCreateButton($lng_cancel, 900, 593, 90)
	GUICtrlSetState(-1, $GUI_deFBUTTON)

	Dim $Array_FUNC_13[1]

	_ArrayAdd($Array_FUNC_13, $button_f13_01)

	_ArrayAdd($Array_FUNC_13, $label_f13_01)
	_ArrayAdd($Array_FUNC_13, $label_f13_02)
	_ArrayAdd($Array_FUNC_13, $label_f13_03)

	_ArrayAdd($Array_FUNC_13, $progressbar_f13_01)
	_ArrayAdd($Array_FUNC_13, $progressbar_f13_02)

	_ClearGUI($Array_FUNC_13)

#EndRegion

#Region ;Generate Videos Wizard GUI (1-3)

	Global $label_13_01 = GUICtrlCreateLabel($lng_wizards & ":  " & $lng_video & "- " & $lng_rework, 20, 180, 600, 50)
	GUICtrlSetFont(-1, 20, 700, 0, "Georgia")

	Global $button_13_04 = GUICtrlCreateButton($lng_delorg, 870, 253, 120)

	Global $button_13_02 = GUICtrlCreateButton($lng_search, 460, 257, 60)

	Global $label_13_02 = GUICtrlCreateLabel($lng_inputfoldertext, 50, 240, 400, 20)

	Global $input_13_01 = GUICtrlCreateInput($ini_wizard_videos_inputfolder, 50, 260, 400, 20)

	Global $button_13_03 = GUICtrlCreateButton($lng_search, 460, 317, 60)

	Global $label_13_03 = GUICtrlCreateLabel($lng_outputfoldertext, 50, 300, 400, 20)

	Global $input_13_02 = GUICtrlCreateInput($ini_wizard_videos_outputfolder, 50, 320, 400, 20)

	Global $label_13_04 = GUICtrlCreateLabel($lng_conversiontext1 & " " & $ini_wizard_videos_inputfolder & $lng_conversiontext2, 50, 360, 800, 26, $SS_LEFTNOWORDWRAP)

	Global $button_13_01 = GUICtrlCreateButton($lng_start, 900, 353, 90)
	GUICtrlSetState(-1, $GUI_deFBUTTON)

	Global $label_13_25 = GUICtrlCreateLabel($lng_conversiontext3, 735, 180, 250, 70, $SS_RIGHT)

	Global $label_13_05 = GUICtrlCreateLabel($lng_remuxlimit, 50, 400, 180, 20)

	Global $input_13_03 = GUICtrlCreateInput($ini_wizard_videos_bitrate_sd, 150, 430, 50, 20)

	Global $label_13_13 = GUICtrlCreateLabel($lng_sdmat, 50, 430, 100, 28)

	Global $input_13_04 = GUICtrlCreateInput($ini_wizard_videos_bitrate_720, 150, 460, 50, 20)

	Global $label_13_14 = GUICtrlCreateLabel($lng_720mat, 50, 460, 100, 28)

	Global $input_13_05 = GUICtrlCreateInput($ini_wizard_videos_bitrate_1080, 150, 490, 50, 20)

	Global $label_13_15 = GUICtrlCreateLabel($lng_1080mat, 50, 490, 100, 28)

	Global $input_13_06 = GUICtrlCreateInput($ini_wizard_videos_bitrate_4k, 150, 520, 50, 20)

	Global $label_13_16 = GUICtrlCreateLabel($lng_4kmat, 50, 520, 100, 28)

	Global $Pic_13_01 = GUICtrlCreatePic (@ScriptDir & "\Images\Line_1.jpg", 1, 389, 996, 2)


	Dim $Array_GUI_Elements_13[1]

	_ArrayAdd($Array_GUI_Elements_13, $button_13_01)
	_ArrayAdd($Array_GUI_Elements_13, $button_13_02)
	_ArrayAdd($Array_GUI_Elements_13, $button_13_03)
	_ArrayAdd($Array_GUI_Elements_13, $button_13_04)

	_ArrayAdd($Array_GUI_Elements_13, $check_90_01)
	_ArrayAdd($Array_GUI_Elements_13, $check_90_02)
	_ArrayAdd($Array_GUI_Elements_13, $check_90_12)
	_ArrayAdd($Array_GUI_Elements_13, $check_95_01)
	_ArrayAdd($Array_GUI_Elements_13, $check_95_02)
	_ArrayAdd($Array_GUI_Elements_13, $check_95_03)
	_ArrayAdd($Array_GUI_Elements_13, $check_95_04)
	_ArrayAdd($Array_GUI_Elements_13, $check_95_05)

	_ArrayAdd($Array_GUI_Elements_13, $combo_95_01)
	_ArrayAdd($Array_GUI_Elements_13, $combo_95_02)
	_ArrayAdd($Array_GUI_Elements_13, $combo_95_03)
	_ArrayAdd($Array_GUI_Elements_13, $combo_95_04)
	_ArrayAdd($Array_GUI_Elements_13, $combo_95_05)

	_ArrayAdd($Array_GUI_Elements_13, $edit_95_01)

	_ArrayAdd($Array_GUI_Elements_13, $input_13_01)
	_ArrayAdd($Array_GUI_Elements_13, $input_13_02)
	_ArrayAdd($Array_GUI_Elements_13, $input_13_03)
	_ArrayAdd($Array_GUI_Elements_13, $input_13_04)
	_ArrayAdd($Array_GUI_Elements_13, $input_13_05)
	_ArrayAdd($Array_GUI_Elements_13, $input_13_06)
	_ArrayAdd($Array_GUI_Elements_13, $input_95_07)
	_ArrayAdd($Array_GUI_Elements_13, $input_95_08)

	_ArrayAdd($Array_GUI_Elements_13, $label_13_01)
	_ArrayAdd($Array_GUI_Elements_13, $label_13_02)
	_ArrayAdd($Array_GUI_Elements_13, $label_13_03)
	_ArrayAdd($Array_GUI_Elements_13, $label_13_04)
	_ArrayAdd($Array_GUI_Elements_13, $label_13_05)
	_ArrayAdd($Array_GUI_Elements_13, $label_95_06)
	_ArrayAdd($Array_GUI_Elements_13, $label_13_13)
	_ArrayAdd($Array_GUI_Elements_13, $label_13_14)
	_ArrayAdd($Array_GUI_Elements_13, $label_13_15)
	_ArrayAdd($Array_GUI_Elements_13, $label_13_16)
	_ArrayAdd($Array_GUI_Elements_13, $label_13_25)
	_ArrayAdd($Array_GUI_Elements_13, $label_95_26)
	_ArrayAdd($Array_GUI_Elements_13, $label_95_27)
	_ArrayAdd($Array_GUI_Elements_13, $label_95_28)
	_ArrayAdd($Array_GUI_Elements_13, $label_95_29)
	_ArrayAdd($Array_GUI_Elements_13, $label_95_30)
	_ArrayAdd($Array_GUI_Elements_13, $label_95_31)
	_ArrayAdd($Array_GUI_Elements_13, $label_95_32)

	_ArrayAdd($Array_GUI_Elements_13, $Pic_13_01)

	_ArrayAdd($Array_GUI_Elements_13, $input_90_04)
	_ArrayAdd($Array_GUI_Elements_13, $input_90_05)
	_ArrayAdd($Array_GUI_Elements_13, $input_90_06)
	_ArrayAdd($Array_GUI_Elements_13, $input_90_10)
	_ArrayAdd($Array_GUI_Elements_13, $input_90_11)
	_ArrayAdd($Array_GUI_Elements_13, $input_90_12)
	_ArrayAdd($Array_GUI_Elements_13, $label_90_01)
	_ArrayAdd($Array_GUI_Elements_13, $label_90_04)
	_ArrayAdd($Array_GUI_Elements_13, $label_90_05)
	_ArrayAdd($Array_GUI_Elements_13, $label_90_06)
	_ArrayAdd($Array_GUI_Elements_13, $label_90_10)
	_ArrayAdd($Array_GUI_Elements_13, $label_90_11)
	_ArrayAdd($Array_GUI_Elements_13, $label_90_12)

#EndRegion

#Region ;Generate Dynamic Audio Wizard GUI Elements (f14)

	Global $label_f14_01 = GUICtrlCreateLabel($lng_pleasewait, 50, 240, 600, 26)
	GUICtrlSetFont(-1, 12)

	Global $label_f14_02 = GUICtrlCreateLabel("", 50, 280, 800, 26, $SS_LEFTNOWORDWRAP)
	GUICtrlSetFont(-1, 12)

	Global $progressbar_f14_01 = GUICtrlCreateProgress(50, 420, 900, 20)

	Global $progressbar_f14_02 = GUICtrlCreateProgress(50, 320, 900, 20)

	Global $button_f14_01 = GUICtrlCreateButton($lng_cancel, 900, 593, 90)
	GUICtrlSetState(-1, $GUI_deFBUTTON)

	Dim $Array_FUNC_14[1]

	_ArrayAdd($Array_FUNC_14, $button_f14_01)

	_ArrayAdd($Array_FUNC_14, $label_f14_01)
	_ArrayAdd($Array_FUNC_14, $label_f14_02)

	_ArrayAdd($Array_FUNC_14, $progressbar_f14_01)
	_ArrayAdd($Array_FUNC_14, $progressbar_f14_02)

	_ClearGUI($Array_FUNC_14)

#EndRegion

#Region ;Generate Audio Wizard GUI (1-4)

	Global $label_14_01 = GUICtrlCreateLabel($lng_wizards & ":  " & $lng_audio & "- " & $lng_rework, 20, 180, 600, 50)
	GUICtrlSetFont(-1, 20, 700, 0, "Georgia")

	Global $button_14_02 = GUICtrlCreateButton($lng_search, 460, 257, 60)

	Global $label_14_02 = GUICtrlCreateLabel($lng_inputfoldertext, 50, 240, 400, 20)

	Global $input_14_01 = GUICtrlCreateInput($ini_wizard_audio_inputfolder, 50, 260, 400, 20)

	Global $button_14_03 = GUICtrlCreateButton($lng_search, 460, 317, 60)

	Global $label_14_03 = GUICtrlCreateLabel($lng_outputfoldertext, 50, 300, 400, 20)

	Global $input_14_02 = GUICtrlCreateInput($ini_wizard_audio_outputfolder, 50, 320, 400, 20)

	Global $label_14_04 = GUICtrlCreateLabel($lng_conversiontext1 & " " & $ini_arecode_inputfolder & $lng_conversiontext2, 50, 360, 800, 26)

	Global $button_14_01 = GUICtrlCreateButton($lng_start, 900, 353, 90)
	GUICtrlSetState(-1, $GUI_deFBUTTON)

	Global $button_14_04 = GUICtrlCreateButton($lng_delorg, 870, 253, 120)

	Global $label_14_05 = GUICtrlCreateLabel($lng_conversiontext3, 735, 180, 250, 70, $SS_RIGHT)

	Global $Pic_14_01 = GUICtrlCreatePic (@ScriptDir & "\Images\Line_1.jpg", 1, 389, 996, 2)

	Global $label_14_11 = GUICtrlCreateLabel("Format:  ", 50, 400, 50, 20)

	Global $label_14_21 = GUICtrlCreateLabel($lng_bitrate & ":", 120, 400, 130, 20)

	Global $combo_14_21 = GUICtrlCreateCombo("", 120, 430, 100, 20)
	GUICtrlSetData(-1, "96|112|128|160|192|224|256|320", $ini_arecode_bitrate_mp3)

	Global $combo_14_22 = GUICtrlCreateCombo("", 120, 470, 100, 20)
	GUICtrlSetData(-1, "0|1|2|3|4|5|6|7|8|9|10|11|12",$ini_arecode_bitrate_flac)

	Global $label_14_23 = GUICtrlCreateLabel("----------------" & ":  ", 120, 510, 130, 20)

	Global $combo_14_24 = GUICtrlCreateCombo("", 120, 550, 100, 20)
	GUICtrlSetData(-1, "96|112|128|160|192|224|256|320", $ini_arecode_bitrate_opus)

	Global $label_14_31 = GUICtrlCreateLabel($lng_compression & ":", 250, 400, 130, 20)

	Global $combo_14_31 = GUICtrlCreateCombo("", 250, 430, 100, 20)
	GUICtrlSetData(-1, "11025|22050|32000|44100|48000", $ini_arecode_samplingrate_mp3)

	Global $combo_14_32 = GUICtrlCreateCombo("", 250, 470, 100, 20)
	GUICtrlSetData(-1, "11025|22050|32000|44100|48000|88000|96000|176000|192000|384000", $ini_arecode_samplingrate_flac)

	Global $combo_14_33 = GUICtrlCreateCombo("", 250, 510, 100, 20)
	GUICtrlSetData(-1, "11025|22050|32000|44100|48000", $ini_arecode_samplingrate_wav)

	Global $combo_14_34 = GUICtrlCreateCombo("", 250, 550, 100, 20)
	GUICtrlSetData(-1, "1|2|3|4|5|6|7|8|9|10",$ini_arecode_quality_opus)

	Global $label_14_61 = GUICtrlCreateLabel($lng_dontconvert, 750, 400, 100, 20)

	Global $check_14_61 = GUICtrlCreateCheckbox("mp3 ", 750, 430)

	Global $check_14_62 = GUICtrlCreateCheckbox("flac ", 750, 470)

	Global $check_14_63 = GUICtrlCreateCheckbox("wav ", 750, 510)

	Global $check_14_64 = GUICtrlCreateCheckbox("opus ", 750, 550)

	If $ini_audio_not_mp3 = "1" Then
		GUICtrlSetState($check_14_61, $GUI_CHECKED)
	Else
		GUICtrlSetState($check_14_61, $GUI_UNCHECKED)
	EndIf

	If $ini_audio_not_flac = "1" Then
		GUICtrlSetState($check_14_62, $GUI_CHECKED)
	Else
		GUICtrlSetState($check_14_62, $GUI_UNCHECKED)
	EndIf

	If $ini_audio_not_wav = "1" Then
		GUICtrlSetState($check_14_63, $GUI_CHECKED)
	Else
		GUICtrlSetState($check_14_63, $GUI_UNCHECKED)
	EndIf

	If $ini_audio_not_opus = "1" Then
		GUICtrlSetState($check_14_64, $GUI_CHECKED)
	Else
		GUICtrlSetState($check_14_64, $GUI_UNCHECKED)
	EndIf


	GUIStartGroup()
		Global $radio_14_11 = GUICtrlCreateRadio("mp3", 50, 430, 50, 20)

		Global $radio_14_21 = GUICtrlCreateRadio("flac", 50, 470, 50, 20)

		Global $radio_14_31 = GUICtrlCreateRadio("wav", 50, 510, 50, 20)

		Global $radio_14_41 = GUICtrlCreateRadio("opus", 50, 550, 50, 20)


	If $ini_arecode_container = "mp3" Then GUICtrlSetState($radio_14_11, $GUI_CHECKED)

	If $ini_arecode_container = "flac" Then GUICtrlSetState($radio_14_21, $GUI_CHECKED)

	If $ini_arecode_container = "wav" Then GUICtrlSetState($radio_14_31, $GUI_CHECKED)

	If $ini_arecode_container = "ogg" Then GUICtrlSetState($radio_14_41, $GUI_CHECKED)

	Dim $Array_GUI_Elements_14[1]

	_ArrayAdd($Array_GUI_Elements_14, $button_14_01)
	_ArrayAdd($Array_GUI_Elements_14, $button_14_02)
	_ArrayAdd($Array_GUI_Elements_14, $button_14_03)
	_ArrayAdd($Array_GUI_Elements_14, $button_14_04)

	_ArrayAdd($Array_GUI_Elements_14, $check_14_61)
	_ArrayAdd($Array_GUI_Elements_14, $check_14_62)
	_ArrayAdd($Array_GUI_Elements_14, $check_14_63)
	_ArrayAdd($Array_GUI_Elements_14, $check_14_64)

	_ArrayAdd($Array_GUI_Elements_14, $combo_14_21)
	_ArrayAdd($Array_GUI_Elements_14, $combo_14_22)
	_ArrayAdd($Array_GUI_Elements_14, $combo_14_24)
	_ArrayAdd($Array_GUI_Elements_14, $combo_14_31)
	_ArrayAdd($Array_GUI_Elements_14, $combo_14_32)
	_ArrayAdd($Array_GUI_Elements_14, $combo_14_33)
	_ArrayAdd($Array_GUI_Elements_14, $combo_14_34)

	_ArrayAdd($Array_GUI_Elements_14, $input_14_01)
	_ArrayAdd($Array_GUI_Elements_14, $input_14_02)

	_ArrayAdd($Array_GUI_Elements_14, $label_14_01)
	_ArrayAdd($Array_GUI_Elements_14, $label_14_02)
	_ArrayAdd($Array_GUI_Elements_14, $label_14_03)
	_ArrayAdd($Array_GUI_Elements_14, $label_14_04)
	_ArrayAdd($Array_GUI_Elements_14, $label_14_05)
	_ArrayAdd($Array_GUI_Elements_14, $label_14_11)
	_ArrayAdd($Array_GUI_Elements_14, $label_14_21)
	_ArrayAdd($Array_GUI_Elements_14, $label_14_23)
	_ArrayAdd($Array_GUI_Elements_14, $label_14_31)
	_ArrayAdd($Array_GUI_Elements_14, $label_14_61)

	_ArrayAdd($Array_GUI_Elements_14, $Pic_14_01)

	_ArrayAdd($Array_GUI_Elements_14, $radio_14_11)
	_ArrayAdd($Array_GUI_Elements_14, $radio_14_21)
	_ArrayAdd($Array_GUI_Elements_14, $radio_14_31)
	_ArrayAdd($Array_GUI_Elements_14, $radio_14_41)

#EndRegion

#Region ;Generate Wizards GUI (1)

	Global $Select_Button_11 = GUICtrlCreateButton($lng_series & "- " & $lng_rework, 2, 140, 150, 25)

	Global $Select_Button_12 = GUICtrlCreateButton($lng_movies & "- " & $lng_rework, 152, 140, 150, 25)

	Global $Select_Button_13 = GUICtrlCreateButton($lng_video & "- " & $lng_rework, 302, 140, 150, 25)

 	Global $Select_Button_14 = GUICtrlCreateButton($lng_audio & "- " & $lng_rework, 452, 140, 150, 25)

	Global $Select_Label_11 = GUICtrlCreateLabel($lng_wizards & ":  " & $lng_series & " - " & $lng_rework, 20, 180, 800, 100)
	GUICtrlSetFont(-1, 20, 700, 0, "Georgia")

	Global $Select_Pic_11 = GUICtrlCreatePic (@ScriptDir & "\Images\Line_2.jpg", 2, 135, 150, 10)

	Global $Select_Label_12 = GUICtrlCreateLabel("", 1, 111, 152, 29, $SS_ETCHEDFRAME)

	Global $Select_Label_13 = GUICtrlCreateLabel("", 1, 137, 998, 494, $SS_ETCHEDFRAME)

	Dim $Array_GUI_Elements_01[1]
	_ArrayAdd($Array_GUI_Elements_01, $Select_Button_11)
	_ArrayAdd($Array_GUI_Elements_01, $Select_Button_12)
	_ArrayAdd($Array_GUI_Elements_01, $Select_Button_13)
 	_ArrayAdd($Array_GUI_Elements_01, $Select_Button_14)

	_ArrayAdd($Array_GUI_Elements_01, $Select_Label_11)
	_ArrayAdd($Array_GUI_Elements_01, $Select_Label_12)
	_ArrayAdd($Array_GUI_Elements_01, $Select_Label_13)

	_ArrayAdd($Array_GUI_Elements_01, $Select_Pic_11)

#EndRegion

#Region ;Generate Transcode GUI (2-1)

	Global $label_21_01 = GUICtrlCreateLabel($lng_videos & ":  " & $lng_recoding, 20, 180, 600, 50)
	GUICtrlSetFont(-1, 20, 700, 0, "Georgia")

	Global $button_21_02 = GUICtrlCreateButton($lng_search, 460, 257, 60)

	Global $label_21_02 = GUICtrlCreateLabel($lng_inputfoldertext, 50, 240, 400, 20)

	Global $input_21_01 = GUICtrlCreateInput($ini_recode_inputfolder, 50, 260, 400, 20)

	Global $button_21_03 = GUICtrlCreateButton($lng_search, 460, 317, 60)

	Global $label_21_03 = GUICtrlCreateLabel($lng_outputfoldertext, 50, 300, 400, 20)

	Global $input_21_02 = GUICtrlCreateInput($ini_recode_outputfolder, 50, 320, 400, 20)

	Global $label_21_04 = GUICtrlCreateLabel($lng_conversiontext1 & " " & $ini_recode_inputfolder & $lng_conversiontext2, 50, 360, 800, 26)

	Global $button_21_01 = GUICtrlCreateButton($lng_start, 900, 353, 90)
	GUICtrlSetState(-1, $GUI_deFBUTTON)

	Global $button_21_04 = GUICtrlCreateButton($lng_delorg, 870, 253, 120)

	Global $label_21_25 = GUICtrlCreateLabel($lng_conversiontext3, 735, 180, 250, 70, $SS_RIGHT)

	Global $label_21_05 = GUICtrlCreateLabel($lng_bitrates, 50, 400, 180, 20)

	Global $label_21_06 = GUICtrlCreateLabel("Audio Codec", 400, 400)

	Global $label_21_08 = GUICtrlCreateLabel($lng_VideoCodec, 250, 400)

	Global $label_21_09 = GUICtrlCreateLabel($lng_container, 50, 570)

	Global $input_21_03 = GUICtrlCreateInput($ini_recode_quality_sd, 150, 430, 50, 20)

	Global $label_21_13 = GUICtrlCreateLabel($lng_sdmat, 50, 430, 100, 28)

	Global $input_21_04 = GUICtrlCreateInput($ini_recode_quality_720, 150, 460, 50, 20)

	Global $label_21_14 = GUICtrlCreateLabel("720p", 50, 460, 100, 28)

	Global $input_21_06 = GUICtrlCreateInput($ini_recode_quality_1080, 150, 490, 50, 20)

	Global $label_21_16 = GUICtrlCreateLabel("1080p", 50, 490, 100, 28)

	Global $label_21_18 = GUICtrlCreateLabel("4K / UHD", 50, 520, 100, 28)

	Global $input_21_08 = GUICtrlCreateInput($ini_recode_quality_4k, 150, 520, 50, 20)

	$combo_21_01 = GUICtrlCreateCombo("h264 AVC", 250, 430, 110)
	GUICtrlSetData(-1, "h265 HEVC", $ini_recode_videocodec_SD)

	$combo_21_02 = GUICtrlCreateCombo("h264 AVC", 250, 460, 110)
	GUICtrlSetData(-1, "h265 HEVC", $ini_recode_videocodec_720)

	$combo_21_04 = GUICtrlCreateCombo("h264 AVC", 250, 490, 110)
	GUICtrlSetData(-1, "h265 HEVC", $ini_recode_videocodec_1080)

	$combo_21_06 = GUICtrlCreateCombo("h264 AVC", 250, 520, 110)
	GUICtrlSetData(-1, "h265 HEVC", $ini_recode_videocodec_4k)


	GUIStartGroup()
		Global $radio_21_04 = GUICtrlCreateRadio("mkv", 50, 590, 50, 20)

		Global $radio_21_05 = GUICtrlCreateRadio("mp4", 100, 590, 50, 20)

	If $ini_recode_container = "mkv" Then GUICtrlSetState($radio_21_04, $GUI_CHECKED)

	If $ini_recode_container = "mp4" Then GUICtrlSetState($radio_21_05, $GUI_CHECKED)

	GUIStartGroup()
		Global $radio_21_06 = GUICtrlCreateRadio("AC-3", 400, 420, 120, 20)

		Global $radio_21_07 = GUICtrlCreateRadio("AAC", 400, 445, 120, 20)

		Global $radio_21_08 = GUICtrlCreateRadio("MP3", 400, 470, 120, 20)

		Global $radio_21_09 = GUICtrlCreateRadio("FLAC", 400, 495, 120, 20)

		Global $radio_21_10 = GUICtrlCreateRadio("OPUS", 400, 520, 120, 20)

		Global $radio_21_12 = GUICtrlCreateRadio("DTS", 400, 545, 120, 20)

		Global $radio_21_13 = GUICtrlCreateRadio("TrueHD", 400, 570, 120, 20)

		Global $radio_21_11 = GUICtrlCreateRadio($lng_copy, 400, 600, 120, 20)

	If $ini_recode_audiocodec = 1 Then GUICtrlSetState($radio_21_06, $GUI_CHECKED)

	If $ini_recode_audiocodec = 2 Then GUICtrlSetState($radio_21_07, $GUI_CHECKED)

	If $ini_recode_audiocodec = 3 Then GUICtrlSetState($radio_21_08, $GUI_CHECKED)

	If $ini_recode_audiocodec = 4 Then GUICtrlSetState($radio_21_09, $GUI_CHECKED)

	If $ini_recode_audiocodec = 5 Then GUICtrlSetState($radio_21_10, $GUI_CHECKED)

	If $ini_recode_audiocodec = 6 Then GUICtrlSetState($radio_21_11, $GUI_CHECKED)

	If $ini_recode_audiocodec = 7 Then GUICtrlSetState($radio_21_12, $GUI_CHECKED)

	If $ini_audio_normalize = 1 Then
		GUICtrlSetState($check_97_01, $GUI_CHECKED)
	Else
		GUICtrlSetState($check_97_01, $GUI_UNCHECKED)
	EndIf

	Global $Pic_21_01 = GUICtrlCreatePic (@ScriptDir & "\Images\Line_1.jpg", 1, 389, 996, 2)

	Dim $Array_GUI_Elements_21[1]

	_ArrayAdd($Array_GUI_Elements_21, $button_21_01)
	_ArrayAdd($Array_GUI_Elements_21, $button_21_02)
	_ArrayAdd($Array_GUI_Elements_21, $button_21_03)
	_ArrayAdd($Array_GUI_Elements_21, $button_21_04)

	_ArrayAdd($Array_GUI_Elements_21, $combo_21_01)
	_ArrayAdd($Array_GUI_Elements_21, $combo_21_02)
	_ArrayAdd($Array_GUI_Elements_21, $combo_21_04)
	_ArrayAdd($Array_GUI_Elements_21, $combo_21_06)

	_ArrayAdd($Array_GUI_Elements_21, $input_21_01)
	_ArrayAdd($Array_GUI_Elements_21, $input_21_02)
	_ArrayAdd($Array_GUI_Elements_21, $input_21_03)
	_ArrayAdd($Array_GUI_Elements_21, $input_21_04)
	_ArrayAdd($Array_GUI_Elements_21, $input_21_06)
	_ArrayAdd($Array_GUI_Elements_21, $input_21_08)

	_ArrayAdd($Array_GUI_Elements_21, $label_21_01)
	_ArrayAdd($Array_GUI_Elements_21, $label_21_02)
	_ArrayAdd($Array_GUI_Elements_21, $label_21_03)
	_ArrayAdd($Array_GUI_Elements_21, $label_21_04)
	_ArrayAdd($Array_GUI_Elements_21, $label_21_05)
	_ArrayAdd($Array_GUI_Elements_21, $label_21_06)
	_ArrayAdd($Array_GUI_Elements_21, $label_21_08)
	_ArrayAdd($Array_GUI_Elements_21, $label_21_09)
	_ArrayAdd($Array_GUI_Elements_21, $label_21_13)
	_ArrayAdd($Array_GUI_Elements_21, $label_21_14)
	_ArrayAdd($Array_GUI_Elements_21, $label_21_16)
	_ArrayAdd($Array_GUI_Elements_21, $label_21_18)
	_ArrayAdd($Array_GUI_Elements_21, $label_21_25)

	_ArrayAdd($Array_GUI_Elements_21, $Pic_21_01)

	_ArrayAdd($Array_GUI_Elements_21, $radio_21_04)
	_ArrayAdd($Array_GUI_Elements_21, $radio_21_05)
	_ArrayAdd($Array_GUI_Elements_21, $radio_21_06)
	_ArrayAdd($Array_GUI_Elements_21, $radio_21_07)
	_ArrayAdd($Array_GUI_Elements_21, $radio_21_08)
	_ArrayAdd($Array_GUI_Elements_21, $radio_21_09)
	_ArrayAdd($Array_GUI_Elements_21, $radio_21_10)
	_ArrayAdd($Array_GUI_Elements_21, $radio_21_11)
	_ArrayAdd($Array_GUI_Elements_21, $radio_21_12)
	_ArrayAdd($Array_GUI_Elements_21, $radio_21_13)

	_ArrayAdd($Array_GUI_Elements_21, $check_90_01)
	_ArrayAdd($Array_GUI_Elements_21, $check_90_02)
	_ArrayAdd($Array_GUI_Elements_21, $check_90_12)

	_ArrayAdd($Array_GUI_Elements_21, $input_90_04)
	_ArrayAdd($Array_GUI_Elements_21, $input_90_05)
	_ArrayAdd($Array_GUI_Elements_21, $input_90_06)
	_ArrayAdd($Array_GUI_Elements_21, $input_90_10)
	_ArrayAdd($Array_GUI_Elements_21, $input_90_11)
	_ArrayAdd($Array_GUI_Elements_21, $input_90_12)

	_ArrayAdd($Array_GUI_Elements_21, $label_90_01)
	_ArrayAdd($Array_GUI_Elements_21, $label_90_04)
	_ArrayAdd($Array_GUI_Elements_21, $label_90_05)
	_ArrayAdd($Array_GUI_Elements_21, $label_90_06)
	_ArrayAdd($Array_GUI_Elements_21, $label_90_10)
	_ArrayAdd($Array_GUI_Elements_21, $label_90_11)
	_ArrayAdd($Array_GUI_Elements_21, $label_90_12)

	_ArrayAdd($Array_GUI_Elements_21, $label_97_01)
	_ArrayAdd($Array_GUI_Elements_21, $label_97_02)
	_ArrayAdd($Array_GUI_Elements_21, $label_97_03)
	_ArrayAdd($Array_GUI_Elements_21, $check_97_01)
	_ArrayAdd($Array_GUI_Elements_21, $combo_97_01)
	_ArrayAdd($Array_GUI_Elements_21, $input_97_01)


#EndRegion

#Region ;Generate Dynamic Recode GUI Elements (f21)

	Global $label_f21_01 = GUICtrlCreateLabel($lng_pleasewait, 50, 240, 600, 26)
	GUICtrlSetFont(-1, 12)

	Global $label_f21_02 = GUICtrlCreateLabel("", 50, 280, 800, 26, $SS_LEFTNOWORDWRAP)
	GUICtrlSetFont(-1, 12)

	Global $label_f21_03 = GUICtrlCreateLabel("", 50, 400, 800, 26, $SS_LEFTNOWORDWRAP)
	GUICtrlSetFont(-1, 12)

	Global $progressbar_f21_01 = GUICtrlCreateProgress(50, 320, 900, 20)

	Global $progressbar_f21_02 = GUICtrlCreateProgress(50, 440, 900, 20)

	Global $button_f21_01 = GUICtrlCreateButton($lng_cancel, 900, 593, 90)
	GUICtrlSetState(-1, $GUI_deFBUTTON)

	Dim $Array_FUNC_21[1]

	_ArrayAdd($Array_FUNC_21, $button_f21_01)

	_ArrayAdd($Array_FUNC_21, $label_f21_01)
	_ArrayAdd($Array_FUNC_21, $label_f21_02)
	_ArrayAdd($Array_FUNC_21, $label_f21_03)

	_ArrayAdd($Array_FUNC_21, $progressbar_f21_01)
	_ArrayAdd($Array_FUNC_21, $progressbar_f21_02)

	_ClearGUI($Array_FUNC_21)

#EndRegion

#Region ;Generate Remuxx GUI (2-2)

	Global $label_22_01 = GUICtrlCreateLabel($lng_videos & ":  " & $lng_remux, 20, 180, 600, 50)
	GUICtrlSetFont(-1, 20, 700, 0, "Georgia")

	Global $button_22_02 = GUICtrlCreateButton($lng_search, 460, 257, 60)

	Global $label_22_02 = GUICtrlCreateLabel($lng_inputfoldertext, 50, 240, 400, 20)

	Global $input_22_01 = GUICtrlCreateInput($ini_remux_inputfolder, 50, 260, 400, 20)

	Global $button_22_03 = GUICtrlCreateButton($lng_search, 460, 317, 60)

	Global $label_22_03 = GUICtrlCreateLabel($lng_outputfoldertext, 50, 300, 400, 20)

	Global $input_22_02 = GUICtrlCreateInput($ini_remux_outputfolder, 50, 320, 400, 20)

	Global $label_22_04 = GUICtrlCreateLabel($lng_conversiontext1 & " " & $ini_remux_inputfolder & $lng_conversiontext2, 50, 360, 800, 26, $SS_LEFTNOWORDWRAP)

	Global $button_22_01 = GUICtrlCreateButton($lng_start, 900, 353, 90)
	GUICtrlSetState(-1, $GUI_deFBUTTON)

	Global $button_22_04 = GUICtrlCreateButton($lng_delorg, 870, 253, 120)

	Global $label_22_25 = GUICtrlCreateLabel($lng_conversiontext3, 735, 180, 250, 70, $SS_RIGHT)

	Global $Pic_22_01 = GUICtrlCreatePic (@ScriptDir & "\Images\Line_1.jpg", 1, 389, 996, 2)

	Global $check_22_01 = GUICtrlCreateCheckbox("Simple- " & $lng_remux, 50, 420)

	Global $label_22_05 = GUICtrlCreateLabel($lng_simplemux, 50, 450, 300, 70)

	If $ini_simplemux = 1 Then
		GUICtrlSetState($check_22_01, $GUI_CHECKED)
	Else
		GUICtrlSetState($check_22_01, $GUI_UNCHECKED)
	EndIf


	Dim $Array_GUI_Elements_22[1]

	_ArrayAdd($Array_GUI_Elements_22, $button_22_01)
	_ArrayAdd($Array_GUI_Elements_22, $button_22_02)
	_ArrayAdd($Array_GUI_Elements_22, $button_22_03)
	_ArrayAdd($Array_GUI_Elements_22, $button_22_04)

	_ArrayAdd($Array_GUI_Elements_22, $check_22_01)

	_ArrayAdd($Array_GUI_Elements_22, $input_22_01)
	_ArrayAdd($Array_GUI_Elements_22, $input_22_02)

	_ArrayAdd($Array_GUI_Elements_22, $label_22_01)
	_ArrayAdd($Array_GUI_Elements_22, $label_22_02)
	_ArrayAdd($Array_GUI_Elements_22, $label_22_03)
	_ArrayAdd($Array_GUI_Elements_22, $label_22_04)
	_ArrayAdd($Array_GUI_Elements_22, $label_22_05)
	_ArrayAdd($Array_GUI_Elements_22, $label_22_25)

	_ArrayAdd($Array_GUI_Elements_22, $Pic_22_01)

	_ArrayAdd($Array_GUI_Elements_22, $check_90_01)
	_ArrayAdd($Array_GUI_Elements_22, $check_90_02)
	_ArrayAdd($Array_GUI_Elements_22, $check_90_12)

	_ArrayAdd($Array_GUI_Elements_22, $input_90_04)
	_ArrayAdd($Array_GUI_Elements_22, $input_90_05)
	_ArrayAdd($Array_GUI_Elements_22, $input_90_06)
	_ArrayAdd($Array_GUI_Elements_22, $input_90_10)
	_ArrayAdd($Array_GUI_Elements_22, $input_90_11)
	_ArrayAdd($Array_GUI_Elements_22, $input_90_12)

	_ArrayAdd($Array_GUI_Elements_22, $label_90_01)
	_ArrayAdd($Array_GUI_Elements_22, $label_90_04)
	_ArrayAdd($Array_GUI_Elements_22, $label_90_05)
	_ArrayAdd($Array_GUI_Elements_22, $label_90_06)
	_ArrayAdd($Array_GUI_Elements_22, $label_90_10)
	_ArrayAdd($Array_GUI_Elements_22, $label_90_11)
	_ArrayAdd($Array_GUI_Elements_22, $label_90_12)


#EndRegion

#Region ;Generate Dynamic Remuxx GUI Elements (f22)

	Global $label_f22_01 = GUICtrlCreateLabel($lng_pleasewait, 50, 240, 600, 26)
	GUICtrlSetFont(-1, 12)

	Global $label_f22_02 = GUICtrlCreateLabel("", 50, 280, 800, 26, $SS_LEFTNOWORDWRAP)
	GUICtrlSetFont(-1, 12)

	Global $label_f22_03 = GUICtrlCreateLabel("", 50, 400, 800, 26, $SS_LEFTNOWORDWRAP)
	GUICtrlSetFont(-1, 12)

	Global $progressbar_f22_01 = GUICtrlCreateProgress(50, 320, 900, 20)

	Global $progressbar_f22_02 = GUICtrlCreateProgress(50, 440, 900, 20)

	Global $button_f22_01 = GUICtrlCreateButton($lng_cancel, 900, 593, 90)
	GUICtrlSetState(-1, $GUI_deFBUTTON)

	Dim $Array_FUNC_22[1]

	_ArrayAdd($Array_FUNC_22, $button_f22_01)

	_ArrayAdd($Array_FUNC_22, $label_f22_01)
	_ArrayAdd($Array_FUNC_22, $label_f22_02)
	_ArrayAdd($Array_FUNC_22, $label_f22_03)

	_ArrayAdd($Array_FUNC_22, $progressbar_f22_01)
	_ArrayAdd($Array_FUNC_22, $progressbar_f22_02)

	_ClearGUI($Array_FUNC_22)

#EndRegion

#Region ;Generate Append Videos GUI (2-3)

	Global $label_23_01 = GUICtrlCreateLabel($lng_videos & ":  " & $lng_append, 20, 180, 600, 50)
	GUICtrlSetFont(-1, 20, 700, 0, "Georgia")

	Global $button_23_02 = GUICtrlCreateButton($lng_search, 460, 257, 60)

	Global $label_23_02 = GUICtrlCreateLabel($lng_inputfoldertext, 50, 240, 400, 20)

	Global $input_23_01 = GUICtrlCreateInput($ini_append_inputfolder, 50, 260, 400, 20)

	Global $button_23_03 = GUICtrlCreateButton($lng_search, 460, 317, 60)

	Global $label_23_03 = GUICtrlCreateLabel($lng_outputfoldertext, 50, 300, 400, 20)

	Global $input_23_02 = GUICtrlCreateInput($ini_append_outputfolder, 50, 320, 400, 20)

	Global $button_23_04 = GUICtrlCreateButton($lng_delorg, 870, 253, 120)

	Global $label_23_25 = GUICtrlCreateLabel($lng_conversiontext3, 735, 180, 250, 70, $SS_RIGHT)

	Global $label_23_04 = GUICtrlCreateLabel($lng_conversiontext1 & " " & $ini_append_inputfolder & $lng_conversiontext2, 50, 360, 800, 26, $SS_LEFTNOWORDWRAP)

	Global $button_23_01 = GUICtrlCreateButton($lng_start, 900, 353, 90)
	GUICtrlSetState(-1, $GUI_deFBUTTON)

	Global $Pic_23_01 = GUICtrlCreatePic (@ScriptDir & "\Images\Line_1.jpg", 1, 389, 996, 2)

	Dim $Array_GUI_Elements_23[1]

	_ArrayAdd($Array_GUI_Elements_23, $button_23_01)
	_ArrayAdd($Array_GUI_Elements_23, $button_23_02)
	_ArrayAdd($Array_GUI_Elements_23, $button_23_03)
	_ArrayAdd($Array_GUI_Elements_23, $button_23_04)

	_ArrayAdd($Array_GUI_Elements_23, $input_23_01)
	_ArrayAdd($Array_GUI_Elements_23, $input_23_02)

	_ArrayAdd($Array_GUI_Elements_23, $label_23_01)
	_ArrayAdd($Array_GUI_Elements_23, $label_23_02)
	_ArrayAdd($Array_GUI_Elements_23, $label_23_03)
	_ArrayAdd($Array_GUI_Elements_23, $label_23_04)
	_ArrayAdd($Array_GUI_Elements_23, $label_23_25)

	_ArrayAdd($Array_GUI_Elements_23, $Pic_23_01)

#EndRegion

#Region ;Generate Dynamic Append GUI Elements (f23)

	Global $label_f23_01 = GUICtrlCreateLabel($lng_pleasewait, 50, 240, 600, 26)
	GUICtrlSetFont(-1, 12)

	Global $label_f23_02 = GUICtrlCreateLabel("", 50, 280, 800, 26, $SS_LEFTNOWORDWRAP)
	GUICtrlSetFont(-1, 12)

	Global $label_f23_03 = GUICtrlCreateLabel("", 50, 400, 800, 26, $SS_LEFTNOWORDWRAP)
	GUICtrlSetFont(-1, 12)

	Global $progressbar_f23_01 = GUICtrlCreateProgress(50, 320, 900, 20)

	Global $progressbar_f23_02 = GUICtrlCreateProgress(50, 440, 900, 20)

	Global $button_f23_01 = GUICtrlCreateButton($lng_cancel, 900, 593, 90)
	GUICtrlSetState(-1, $GUI_deFBUTTON)

	Dim $Array_FUNC_23[1]

	_ArrayAdd($Array_FUNC_23, $button_f23_01)

	_ArrayAdd($Array_FUNC_23, $label_f23_01)
	_ArrayAdd($Array_FUNC_23, $label_f23_02)
	_ArrayAdd($Array_FUNC_23, $label_f23_03)

	_ArrayAdd($Array_FUNC_23, $progressbar_f23_01)
	_ArrayAdd($Array_FUNC_23, $progressbar_f23_02)

	_ClearGUI($Array_FUNC_23)

#EndRegion

#Region ;Generate Audio Transcode GUI (2-4)

	Global $label_24_01 = GUICtrlCreateLabel($lng_audio & ":  " & $lng_recoding, 20, 180, 600, 50)
	GUICtrlSetFont(-1, 20, 700, 0, "Georgia")

	Global $button_24_02 = GUICtrlCreateButton($lng_search, 460, 257, 60)

	Global $label_24_02 = GUICtrlCreateLabel($lng_inputfoldertext, 50, 240, 400, 20)

	Global $input_24_01 = GUICtrlCreateInput($ini_arecode_inputfolder, 50, 260, 400, 20)

	Global $button_24_03 = GUICtrlCreateButton($lng_search, 460, 317, 60)

	Global $label_24_03 = GUICtrlCreateLabel($lng_outputfoldertext, 50, 300, 400, 20)

	Global $input_24_02 = GUICtrlCreateInput($ini_arecode_outputfolder, 50, 320, 400, 20)

	Global $label_24_04 = GUICtrlCreateLabel($lng_conversiontext1 & " " & $ini_arecode_inputfolder & $lng_conversiontext2, 50, 360, 800, 26)

	Global $button_24_01 = GUICtrlCreateButton($lng_start, 900, 353, 90)
	GUICtrlSetState(-1, $GUI_deFBUTTON)

	Global $button_24_04 = GUICtrlCreateButton($lng_delorg, 870, 253, 120)

	Global $label_24_05 = GUICtrlCreateLabel($lng_conversiontext3, 735, 180, 250, 70, $SS_RIGHT)

	Global $Pic_24_01 = GUICtrlCreatePic (@ScriptDir & "\Images\Line_1.jpg", 1, 389, 996, 2)

	If $ini_audio_normalize = 1 Then
		GUICtrlSetState($check_97_01, $GUI_CHECKED)
	Else
		GUICtrlSetState($check_97_01, $GUI_UNCHECKED)
	EndIf

	Dim $Array_GUI_Elements_24[1]

	_ArrayAdd($Array_GUI_Elements_24, $button_24_01)
	_ArrayAdd($Array_GUI_Elements_24, $button_24_02)
	_ArrayAdd($Array_GUI_Elements_24, $button_24_03)
	_ArrayAdd($Array_GUI_Elements_24, $button_24_04)

	_ArrayAdd($Array_GUI_Elements_24, $combo_14_21)
	_ArrayAdd($Array_GUI_Elements_24, $combo_14_22)
	_ArrayAdd($Array_GUI_Elements_24, $combo_14_24)
	_ArrayAdd($Array_GUI_Elements_24, $combo_14_31)
	_ArrayAdd($Array_GUI_Elements_24, $combo_14_32)
	_ArrayAdd($Array_GUI_Elements_24, $combo_14_33)
	_ArrayAdd($Array_GUI_Elements_24, $combo_14_34)

	_ArrayAdd($Array_GUI_Elements_24, $input_24_01)
	_ArrayAdd($Array_GUI_Elements_24, $input_24_02)

	_ArrayAdd($Array_GUI_Elements_24, $label_24_01)
	_ArrayAdd($Array_GUI_Elements_24, $label_24_02)
	_ArrayAdd($Array_GUI_Elements_24, $label_24_03)
	_ArrayAdd($Array_GUI_Elements_24, $label_24_04)
	_ArrayAdd($Array_GUI_Elements_24, $label_14_11)
	_ArrayAdd($Array_GUI_Elements_24, $label_14_21)
	_ArrayAdd($Array_GUI_Elements_24, $label_14_23)
	_ArrayAdd($Array_GUI_Elements_24, $label_14_31)
	_ArrayAdd($Array_GUI_Elements_24, $label_24_05)

	_ArrayAdd($Array_GUI_Elements_24, $Pic_24_01)

	_ArrayAdd($Array_GUI_Elements_24, $radio_14_11)
	_ArrayAdd($Array_GUI_Elements_24, $radio_14_21)
	_ArrayAdd($Array_GUI_Elements_24, $radio_14_31)
	_ArrayAdd($Array_GUI_Elements_24, $radio_14_41)

	_ArrayAdd($Array_GUI_Elements_24, $label_98_01)
	_ArrayAdd($Array_GUI_Elements_24, $label_98_02)
	_ArrayAdd($Array_GUI_Elements_24, $label_98_03)
	_ArrayAdd($Array_GUI_Elements_24, $check_98_01)
	_ArrayAdd($Array_GUI_Elements_24, $combo_98_01)
	_ArrayAdd($Array_GUI_Elements_24, $input_98_01)


#EndRegion

#Region ;Generate Dynamic Audio Recode GUI Elements (f24)

	Global $label_f24_01 = GUICtrlCreateLabel($lng_pleasewait, 50, 240, 600, 26)
	GUICtrlSetFont(-1, 12)

	Global $label_f24_02 = GUICtrlCreateLabel("", 50, 280, 800, 26, $SS_LEFTNOWORDWRAP)
	GUICtrlSetFont(-1, 12)

	Global $label_f24_03 = GUICtrlCreateLabel("", 50, 340, 800, 26, $SS_LEFTNOWORDWRAP)
	GUICtrlSetFont(-1, 12)

	Global $progressbar_f24_01 = GUICtrlCreateProgress(50, 400, 900, 20)

	Global $button_f24_01 = GUICtrlCreateButton($lng_cancel, 900, 593, 90)
	GUICtrlSetState(-1, $GUI_deFBUTTON)

	Dim $Array_FUNC_24[1]

	_ArrayAdd($Array_FUNC_24, $button_f24_01)

	_ArrayAdd($Array_FUNC_24, $label_f24_01)
	_ArrayAdd($Array_FUNC_24, $label_f24_02)
	_ArrayAdd($Array_FUNC_24, $label_f24_03)

	_ArrayAdd($Array_FUNC_24, $progressbar_f24_01)

	_ClearGUI($Array_FUNC_24)

#EndRegion

#Region ;Generate Normalize GUI (2-5)

	Global $label_25_01 = GUICtrlCreateLabel($lng_audionorm, 20, 180, 600, 50)
	GUICtrlSetFont(-1, 20, 700, 0, "Georgia")

	Global $button_25_02 = GUICtrlCreateButton($lng_search, 460, 257, 60)

	Global $label_25_02 = GUICtrlCreateLabel($lng_inputfoldertext, 50, 240, 400, 20)

	Global $input_25_01 = GUICtrlCreateInput($ini_anorm_inputfolder, 50, 260, 400, 20)

	Global $button_25_03 = GUICtrlCreateButton($lng_search, 460, 317, 60)

	Global $label_25_03 = GUICtrlCreateLabel($lng_outputfoldertext, 50, 300, 400, 20)

	Global $input_25_02 = GUICtrlCreateInput($ini_anorm_outputfolder, 50, 320, 400, 20)

	Global $label_25_04 = GUICtrlCreateLabel($lng_conversiontext1 & " " & $ini_anorm_inputfolder & $lng_conversiontext2, 50, 360, 800, 26)

	Global $button_25_01 = GUICtrlCreateButton($lng_start, 900, 353, 90)
	GUICtrlSetState(-1, $GUI_deFBUTTON)

	Global $button_25_04 = GUICtrlCreateButton($lng_delorg, 870, 253, 120)

	Global $label_25_25 = GUICtrlCreateLabel($lng_conversiontext3, 735, 180, 250, 70, $SS_RIGHT)

	Global $label_25_05 = GUICtrlCreateLabel("Audio Codec", 50, 400)

	GUIStartGroup()
		Global $radio_25_06 = GUICtrlCreateRadio("AC-3", 50, 420, 120, 20)

		Global $radio_25_07 = GUICtrlCreateRadio("AAC", 50, 445, 120, 20)

		Global $radio_25_08 = GUICtrlCreateRadio("MP3", 50, 470, 120, 20)

		Global $radio_25_09 = GUICtrlCreateRadio("FLAC", 50, 495, 120, 20)

		Global $radio_25_10 = GUICtrlCreateRadio("OPUS", 50, 520, 120, 20)

		Global $radio_25_12 = GUICtrlCreateRadio("DTS", 50, 545, 120, 20)

		Global $radio_25_13 = GUICtrlCreateRadio("TrueHD", 50, 570, 120, 20)

		Global $radio_25_11 = GUICtrlCreateRadio($lng_keep, 50, 595, 120, 20)

	If $ini_normalize_audiocodec = 1 Then GUICtrlSetState($radio_25_06, $GUI_CHECKED)

	If $ini_normalize_audiocodec = 2 Then GUICtrlSetState($radio_25_07, $GUI_CHECKED)

	If $ini_normalize_audiocodec = 3 Then GUICtrlSetState($radio_25_08, $GUI_CHECKED)

	If $ini_normalize_audiocodec = 4 Then GUICtrlSetState($radio_25_09, $GUI_CHECKED)

	If $ini_normalize_audiocodec = 5 Then GUICtrlSetState($radio_25_10, $GUI_CHECKED)

	If $ini_normalize_audiocodec = 6 Then GUICtrlSetState($radio_25_11, $GUI_CHECKED)

	If $ini_normalize_audiocodec = 7 Then GUICtrlSetState($radio_25_12, $GUI_CHECKED)

	Global $Pic_25_01 = GUICtrlCreatePic (@ScriptDir & "\Images\Line_1.jpg", 1, 389, 996, 2)

	Dim $Array_GUI_Elements_25[1]

	_ArrayAdd($Array_GUI_Elements_25, $button_25_01)
	_ArrayAdd($Array_GUI_Elements_25, $button_25_02)
	_ArrayAdd($Array_GUI_Elements_25, $button_25_03)
	_ArrayAdd($Array_GUI_Elements_25, $button_25_04)

	_ArrayAdd($Array_GUI_Elements_25, $input_25_01)
	_ArrayAdd($Array_GUI_Elements_25, $input_25_02)

	_ArrayAdd($Array_GUI_Elements_25, $label_25_01)
	_ArrayAdd($Array_GUI_Elements_25, $label_25_02)
	_ArrayAdd($Array_GUI_Elements_25, $label_25_03)
	_ArrayAdd($Array_GUI_Elements_25, $label_25_04)
	_ArrayAdd($Array_GUI_Elements_25, $label_25_05)
	_ArrayAdd($Array_GUI_Elements_25, $label_25_25)

	_ArrayAdd($Array_GUI_Elements_25, $Pic_25_01)

	_ArrayAdd($Array_GUI_Elements_25, $radio_25_06)
	_ArrayAdd($Array_GUI_Elements_25, $radio_25_07)
	_ArrayAdd($Array_GUI_Elements_25, $radio_25_08)
	_ArrayAdd($Array_GUI_Elements_25, $radio_25_09)
	_ArrayAdd($Array_GUI_Elements_25, $radio_25_10)
	_ArrayAdd($Array_GUI_Elements_25, $radio_25_11)
	_ArrayAdd($Array_GUI_Elements_25, $radio_25_12)
	_ArrayAdd($Array_GUI_Elements_25, $radio_25_13)

	_ArrayAdd($Array_GUI_Elements_25, $label_97_01)
	_ArrayAdd($Array_GUI_Elements_25, $label_97_02)
	_ArrayAdd($Array_GUI_Elements_25, $label_97_03)
	_ArrayAdd($Array_GUI_Elements_25, $combo_97_01)
	_ArrayAdd($Array_GUI_Elements_25, $input_97_01)


#EndRegion

#Region ;Generate Dynamic Audio Normalize GUI Elements (f25)

	Global $label_f25_01 = GUICtrlCreateLabel($lng_pleasewait, 50, 240, 600, 26)
	GUICtrlSetFont(-1, 12)

	Global $label_f25_02 = GUICtrlCreateLabel("", 50, 280, 800, 26, $SS_LEFTNOWORDWRAP)
	GUICtrlSetFont(-1, 12)

	Global $label_f25_03 = GUICtrlCreateLabel("", 50, 400, 800, 26, $SS_LEFTNOWORDWRAP)
	GUICtrlSetFont(-1, 12)

	Global $progressbar_f25_01 = GUICtrlCreateProgress(50, 320, 900, 20)

	Global $progressbar_f25_02 = GUICtrlCreateProgress(50, 440, 900, 20)

	Global $button_f25_01 = GUICtrlCreateButton($lng_cancel, 900, 593, 90)
	GUICtrlSetState(-1, $GUI_deFBUTTON)

	Dim $Array_FUNC_25[1]

	_ArrayAdd($Array_FUNC_25, $button_f25_01)

	_ArrayAdd($Array_FUNC_25, $label_f25_01)
	_ArrayAdd($Array_FUNC_25, $label_f25_02)
	_ArrayAdd($Array_FUNC_25, $label_f25_03)

	_ArrayAdd($Array_FUNC_25, $progressbar_f25_01)
	_ArrayAdd($Array_FUNC_25, $progressbar_f25_02)

	_ClearGUI($Array_FUNC_25)

#EndRegion

#Region ;Generate Graphics GUI (2-6)

	Global $label_26_01 = GUICtrlCreateLabel($lng_graphics & "- " & $lng_rework, 20, 180, 600, 50)
	GUICtrlSetFont(-1, 20, 700, 0, "Georgia")

	Global $button_26_02 = GUICtrlCreateButton($lng_search, 460, 267, 60)

	Global $label_26_02 = GUICtrlCreateLabel($lng_inputfoldertext, 50, 240, 400, 20)

	Global $input_26_01 = GUICtrlCreateInput($ini_graphics_inputfolder, 50, 270, 400, 20)

	Global $label_26_04 = GUICtrlCreateLabel($lng_conversiontext1 & " " & $ini_graphics_inputfolder & $lng_conversiontext2, 50, 360, 800, 26, $SS_LEFTNOWORDWRAP)


	Global $label_26_11 = GUICtrlCreateLabel($lng_optimizer & "- " & $lng_options, 770, 400)

	Global $check_26_11 = GUICtrlCreateCheckbox("PNG- " & $lng_useoptimizer, 770, 423)

	Global $check_26_12 = GUICtrlCreateCheckbox("JPG- " & $lng_useoptimizer, 770, 463)

	Global $label_26_12 = GUICtrlCreateLabel($lng_quality1, 770, 500, 180, 60)

	Global $label_26_21 = GUICtrlCreateLabel($lng_scaleoptions, 50, 400)

	Global $check_26_21 = GUICtrlCreateCheckbox("4K - UHD", 50, 453)

	Global $check_26_22 = GUICtrlCreateCheckbox("1080p - FullHD", 50, 483)

	Global $check_26_23 = GUICtrlCreateCheckbox("720p - HDReady", 50, 513)

	Global $check_26_24 = GUICtrlCreateCheckbox("800x600 - Internet", 50, 543)

	Global $check_26_25 = GUICtrlCreateCheckbox($lng_free, 50, 573)

	Global $check_26_26 = GUICtrlCreateCheckbox($lng_unchanged, 50, 423)

	Global $input_26_25 = GUICtrlCreateInput($ini_gfx_freesize, 95, 573, 80, 20)


	Global $combo_26_21 = GUICtrlCreateCombo("", 200, 453, 50)
	GUICtrlSetData(-1, "jpg|png|tif|psd", $ini_gfx_format_4k)

	Global $combo_26_22 = GUICtrlCreateCombo("", 200, 483, 50)
	GUICtrlSetData(-1, "jpg|png|tif|psd", $ini_gfx_format_1080)

	Global $combo_26_23 = GUICtrlCreateCombo("", 200, 513, 50)
	GUICtrlSetData(-1, "jpg|png|tif|psd",$ini_gfx_format_720)

	Global $combo_26_24 = GUICtrlCreateCombo("", 200, 543, 50)
	GUICtrlSetData(-1, "jpg|png|tif|psd", $ini_gfx_format_600)

	Global $combo_26_25 = GUICtrlCreateCombo("", 200, 573, 50)
	GUICtrlSetData(-1, "jpg|png|tif|psd", $ini_gfx_format_free)

	Global $combo_26_26 = GUICtrlCreateCombo("", 200, 423, 50)
	GUICtrlSetData(-1, "jpg|png|tif|psd", $ini_gfx_format_org)

	Global $label_26_31 = GUICtrlCreateLabel("Filter- " & $lng_options, 400, 400)

	Global $check_26_31 = GUICtrlCreateCheckbox("Normalize", 600, 397)

	Global $check_26_32 = GUICtrlCreateCheckbox("UnsharpMask", 400, 423)

	Global $label_26_32 = GUICtrlCreateLabel($lng_color & "- " & $lng_options, 400, 480)

	Global $combo_26_32 = GUICtrlCreateCombo("", 500, 423, 50)
	GUICtrlSetData(-1, "1|2|3|4|5", $ini_gfx_value_unsharp)



	Global $button_26_01 = GUICtrlCreateButton($lng_start, 900, 353, 90)
	GUICtrlSetState(-1, $GUI_deFBUTTON)

	Global $Pic_26_01 = GUICtrlCreatePic (@ScriptDir & "\Images\Line_1.jpg", 1, 389, 996, 2)

	If $ini_gfx_optjpg = "1" Then
		GUICtrlSetState($check_26_12, $GUI_CHECKED)
	Else
		GUICtrlSetState($check_26_12, $GUI_UNCHECKED)
	EndIf

	If $ini_gfx_optpng = "1" Then
		GUICtrlSetState($check_26_11, $GUI_CHECKED)
	Else
		GUICtrlSetState($check_26_11, $GUI_UNCHECKED)
	EndIf

	If $ini_gfx4k = "1" Then
		GUICtrlSetState($check_26_21, $GUI_CHECKED)
	Else
		GUICtrlSetState($check_26_21, $GUI_UNCHECKED)
	EndIf

	If  $ini_gfx1080 = "1" Then
		GUICtrlSetState($check_26_22, $GUI_CHECKED)
	Else
		GUICtrlSetState($check_26_22, $GUI_UNCHECKED)
	EndIf

	If  $ini_gfx720 = "1" Then
		GUICtrlSetState($check_26_23, $GUI_CHECKED)
	Else
		GUICtrlSetState($check_26_23, $GUI_UNCHECKED)
	EndIf

	If  $ini_gfx600 = "1" Then
		GUICtrlSetState($check_26_24, $GUI_CHECKED)
	Else
		GUICtrlSetState($check_26_24, $GUI_UNCHECKED)
	EndIf

	If  $ini_gfxfree = "1" Then
		GUICtrlSetState($check_26_25, $GUI_CHECKED)
	Else
		GUICtrlSetState($check_26_25, $GUI_UNCHECKED)
	EndIf

	If  $ini_gfxorg = "1" Then
		GUICtrlSetState($check_26_26, $GUI_CHECKED)
	Else
		GUICtrlSetState($check_26_26, $GUI_UNCHECKED)
	EndIf

	If  $ini_gfxnormalize = "1" Then
		GUICtrlSetState($check_26_31, $GUI_CHECKED)
	Else
		GUICtrlSetState($check_26_31, $GUI_UNCHECKED)
	EndIf

	If   $ini_gfxunsharp = "1" Then
		GUICtrlSetState($check_26_32, $GUI_CHECKED)
	Else
		GUICtrlSetState($check_26_32, $GUI_UNCHECKED)
	EndIf

	GUIStartGroup()
		Global $radio_26_11 = GUICtrlCreateRadio("Nature", 600, 425, 120, 20)
		Global $radio_26_12 = GUICtrlCreateRadio("Studio", 600, 455, 120, 20)

	GUIStartGroup()
		Global $radio_26_31 = GUICtrlCreateRadio($lng_color, 400, 510, 120, 20)
		Global $radio_26_32 = GUICtrlCreateRadio($lng_color & " + " & $lng_black, 400, 540, 150, 20)
		Global $radio_26_33 = GUICtrlCreateRadio($lng_color & " + Sepia", 400, 570, 120, 20)
		Global $radio_26_34 = GUICtrlCreateRadio($lng_color & " + " & $lng_black & " + Sepia", 400, 600, 200, 20)
		Global $radio_26_35 = GUICtrlCreateRadio($lng_black, 600, 510, 160, 20)
		Global $radio_26_36 = GUICtrlCreateRadio("Sepia", 600, 540, 160, 20)
		Global $radio_26_37 = GUICtrlCreateRadio($lng_black & " + Sepia", 600, 570, 200, 20)

	If $ini_gfx_color = "1" Then GUICtrlSetState($radio_26_31, $GUI_CHECKED)
	If $ini_gfx_color = "1|2" Then GUICtrlSetState($radio_26_32, $GUI_CHECKED)
	If $ini_gfx_color = "1|3" Then GUICtrlSetState($radio_26_33, $GUI_CHECKED)
	If $ini_gfx_color = "1|2|3" Then GUICtrlSetState($radio_26_34, $GUI_CHECKED)
	If $ini_gfx_color = "2" Then GUICtrlSetState($radio_26_35, $GUI_CHECKED)
	If $ini_gfx_color = "3" Then GUICtrlSetState($radio_26_36, $GUI_CHECKED)
	If $ini_gfx_color = "2|3" Then GUICtrlSetState($radio_26_37, $GUI_CHECKED)


	If $ini_gfxnormalize_type = "1" Then GUICtrlSetState($radio_26_11, $GUI_CHECKED)
	If $ini_gfxnormalize_type = "2" Then GUICtrlSetState($radio_26_12, $GUI_CHECKED)

	Dim $Array_GUI_Elements_26[1]

	_ArrayAdd($Array_GUI_Elements_26, $button_26_01)
	_ArrayAdd($Array_GUI_Elements_26, $button_26_02)

	_ArrayAdd($Array_GUI_Elements_26, $check_26_11)
	_ArrayAdd($Array_GUI_Elements_26, $check_26_12)
	_ArrayAdd($Array_GUI_Elements_26, $check_26_21)
	_ArrayAdd($Array_GUI_Elements_26, $check_26_22)
	_ArrayAdd($Array_GUI_Elements_26, $check_26_23)
	_ArrayAdd($Array_GUI_Elements_26, $check_26_24)
	_ArrayAdd($Array_GUI_Elements_26, $check_26_25)
	_ArrayAdd($Array_GUI_Elements_26, $check_26_26)
	_ArrayAdd($Array_GUI_Elements_26, $check_26_31)
	_ArrayAdd($Array_GUI_Elements_26, $check_26_32)

	_ArrayAdd($Array_GUI_Elements_26, $combo_26_21)
	_ArrayAdd($Array_GUI_Elements_26, $combo_26_22)
	_ArrayAdd($Array_GUI_Elements_26, $combo_26_23)
	_ArrayAdd($Array_GUI_Elements_26, $combo_26_24)
	_ArrayAdd($Array_GUI_Elements_26, $combo_26_25)
	_ArrayAdd($Array_GUI_Elements_26, $combo_26_26)
	_ArrayAdd($Array_GUI_Elements_26, $combo_26_32)


	_ArrayAdd($Array_GUI_Elements_26, $input_26_01)
	_ArrayAdd($Array_GUI_Elements_26, $input_26_25)

	_ArrayAdd($Array_GUI_Elements_26, $label_26_01)
	_ArrayAdd($Array_GUI_Elements_26, $label_26_02)
	_ArrayAdd($Array_GUI_Elements_26, $label_26_04)
	_ArrayAdd($Array_GUI_Elements_26, $label_26_11)
	_ArrayAdd($Array_GUI_Elements_26, $label_26_12)
	_ArrayAdd($Array_GUI_Elements_26, $label_26_21)
	_ArrayAdd($Array_GUI_Elements_26, $label_26_31)
	_ArrayAdd($Array_GUI_Elements_26, $label_26_32)

	_ArrayAdd($Array_GUI_Elements_26, $Pic_26_01)

	_ArrayAdd($Array_GUI_Elements_26, $radio_26_11)
	_ArrayAdd($Array_GUI_Elements_26, $radio_26_12)
	_ArrayAdd($Array_GUI_Elements_26, $radio_26_31)
	_ArrayAdd($Array_GUI_Elements_26, $radio_26_32)
	_ArrayAdd($Array_GUI_Elements_26, $radio_26_33)
	_ArrayAdd($Array_GUI_Elements_26, $radio_26_34)
	_ArrayAdd($Array_GUI_Elements_26, $radio_26_35)
	_ArrayAdd($Array_GUI_Elements_26, $radio_26_36)
	_ArrayAdd($Array_GUI_Elements_26, $radio_26_37)

#EndRegion

#Region ;Generate Conversion GUI (2)

	Global $Select_Button_21 = GUICtrlCreateButton($lng_videos & " " & $lng_recoding, 2, 140, 150, 25)

	Global $Select_Button_22 = GUICtrlCreateButton($lng_videos & " " & $lng_remux, 152, 140, 150, 25)

	Global $Select_Button_23 = GUICtrlCreateButton($lng_append, 302, 140, 150, 25)

	Global $Select_Button_24 = GUICtrlCreateButton($lng_audio & " " & $lng_recoding, 452, 140, 150, 25)

	Global $Select_Button_25 = GUICtrlCreateButton($lng_audionorm, 602, 140, 150, 25)

	Global $Select_Button_26 = GUICtrlCreateButton($lng_graphics & "- " & $lng_rework, 752, 140, 150, 25)

	Global $Select_Label_21 = GUICtrlCreateLabel($lng_video & "-" & $lng_conversion & ":  " & $lng_videos & " " & $lng_recoding, 20, 180, 800, 100, $SS_LEFTNOWORDWRAP)
	GUICtrlSetFont(-1, 20, 700, 0, "Georgia")

	Global $Select_Pic_21 = GUICtrlCreatePic (@ScriptDir & "\Images\Line_2.jpg", 151, 135, 151, 10)

	Global $Select_Label_22 = GUICtrlCreateLabel("", 151, 111, 152, 29, $SS_ETCHEDFRAME)

	Global $Select_Label_23 = GUICtrlCreateLabel("", 1, 137, 998, 494, $SS_ETCHEDFRAME)

	Dim $Array_GUI_Elements_02[1]
	_ArrayAdd($Array_GUI_Elements_02, $Select_Button_21)
	_ArrayAdd($Array_GUI_Elements_02, $Select_Button_22)
	_ArrayAdd($Array_GUI_Elements_02, $Select_Button_23)
	_ArrayAdd($Array_GUI_Elements_02, $Select_Button_24)
	_ArrayAdd($Array_GUI_Elements_02, $Select_Button_25)
	_ArrayAdd($Array_GUI_Elements_02, $Select_Button_26)

	_ArrayAdd($Array_GUI_Elements_02, $Select_Label_21)
	_ArrayAdd($Array_GUI_Elements_02, $Select_Label_22)
	_ArrayAdd($Array_GUI_Elements_02, $Select_Label_23)

	_ArrayAdd($Array_GUI_Elements_02, $Select_Pic_21)

#EndRegion

#Region ;Generate Series Metadata GUI (3-1)

	Global $label_31_01 = GUICtrlCreateLabel($lng_metadata & ": " & $lng_series, 20, 180, 800, 50)
	GUICtrlSetFont(-1, 20, 700, 0, "Georgia")

	Global $button_31_02 = GUICtrlCreateButton($lng_search, 460, 267, 60)

	Global $label_31_02 = GUICtrlCreateLabel($lng_inputfoldertext, 50, 250, 400, 20)

	Global $input_31_01 = GUICtrlCreateInput($ini_series_metadata_inputfolder, 50, 270, 400, 20)

	Global $label_31_05 = GUICtrlCreateLabel($lng_conversiontext1 & " " & $ini_series_metadata_inputfolder & $lng_conversiontext2, 50, 360, 800, 26, $SS_LEFTNOWORDWRAP)

	Global $button_31_01 = GUICtrlCreateButton($lng_start, 900, 353, 90)
	GUICtrlSetState(-1, $GUI_deFBUTTON)

	Global $label_31_07 = GUICtrlCreateLabel($lng_options, 50, 400, 180, 20)

	Global $Pic_31_01 = GUICtrlCreatePic (@ScriptDir & "\Images\Line_1.jpg", 1, 389, 996, 2)

	Dim $Array_GUI_Elements_31[1]

	_ArrayAdd($Array_GUI_Elements_31, $button_31_01)
	_ArrayAdd($Array_GUI_Elements_31, $button_31_02)

	_ArrayAdd($Array_GUI_Elements_31, $label_31_01)
	_ArrayAdd($Array_GUI_Elements_31, $label_31_02)
	_ArrayAdd($Array_GUI_Elements_31, $label_31_05)
	_ArrayAdd($Array_GUI_Elements_31, $label_31_07)

	_ArrayAdd($Array_GUI_Elements_31, $input_31_01)

	_ArrayAdd($Array_GUI_Elements_31, $Pic_31_01)

	_ArrayAdd($Array_GUI_Elements_31, $label_91_01)
	_ArrayAdd($Array_GUI_Elements_31, $check_91_01)
	_ArrayAdd($Array_GUI_Elements_31, $check_91_02)
	_ArrayAdd($Array_GUI_Elements_31, $check_91_03)
	_ArrayAdd($Array_GUI_Elements_31, $check_91_04)
	_ArrayAdd($Array_GUI_Elements_31, $check_91_05)
	_ArrayAdd($Array_GUI_Elements_31, $check_91_06)

	_ArrayAdd($Array_GUI_Elements_31, $check_92_01)
	_ArrayAdd($Array_GUI_Elements_31, $check_92_03)
	_ArrayAdd($Array_GUI_Elements_31, $check_92_05)
	_ArrayAdd($Array_GUI_Elements_31, $check_92_06)
	_ArrayAdd($Array_GUI_Elements_31, $label_92_01)
	_ArrayAdd($Array_GUI_Elements_31, $label_92_02)
	_ArrayAdd($Array_GUI_Elements_31, $radio_92_01)
	_ArrayAdd($Array_GUI_Elements_31, $radio_92_02)

	_ArrayAdd($Array_GUI_Elements_31, $label_94_01)
	_ArrayAdd($Array_GUI_Elements_31, $label_94_02)
	_ArrayAdd($Array_GUI_Elements_31, $label_94_03)
	_ArrayAdd($Array_GUI_Elements_31, $input_94_01)
	_ArrayAdd($Array_GUI_Elements_31, $input_94_02)
	_ArrayAdd($Array_GUI_Elements_31, $input_94_03)
	_ArrayAdd($Array_GUI_Elements_31, $input_94_04)
	_ArrayAdd($Array_GUI_Elements_31, $pic_94_01)
	_ArrayAdd($Array_GUI_Elements_31, $pic_94_01a)

#EndRegion

#Region ;Generate Dynamic Series Metadata GUI Elements (f31)

	Global $label_f31_01 = GUICtrlCreateLabel($lng_pleasewait, 50, 240, 600, 26)
	GUICtrlSetFont(-1, 12)

	Global $label_f31_02 = GUICtrlCreateLabel("", 50, 280, 800, 26, $SS_LEFTNOWORDWRAP)
	GUICtrlSetFont(-1, 12)

	Global $label_f31_03 = GUICtrlCreateLabel("", 50, 320, 800, 26, $SS_LEFTNOWORDWRAP)
	GUICtrlSetFont(-1, 12)

	Global $progressbar_f31_01 = GUICtrlCreateProgress(50, 390, 900, 20)

	Global $button_f31_01 = GUICtrlCreateButton($lng_cancel, 900, 593, 90)
	GUICtrlSetState(-1, $GUI_deFBUTTON)

	Dim $Array_FUNC_31[1]

	_ArrayAdd($Array_FUNC_31, $button_f31_01)

	_ArrayAdd($Array_FUNC_31, $label_f31_01)
	_ArrayAdd($Array_FUNC_31, $label_f31_02)
	_ArrayAdd($Array_FUNC_31, $label_f31_03)

	_ArrayAdd($Array_FUNC_31, $progressbar_f31_01)

	_ClearGUI($Array_FUNC_31)

#EndRegion

#Region ;Generate Movies Metadata GUI (3-2)

	Global $label_32_01 = GUICtrlCreateLabel($lng_metadata & ":  " & $lng_movies, 20, 180, 800, 50)
	GUICtrlSetFont(-1, 20, 700, 0, "Georgia")

	Global $button_32_02 = GUICtrlCreateButton($lng_search, 460, 267, 60)

	Global $label_32_02 = GUICtrlCreateLabel($lng_inputfoldertext, 50, 250, 400, 20)

	Global $input_32_01 = GUICtrlCreateInput($ini_movies_metadata_inputfolder, 50, 270, 400, 20)

	Global $label_32_05 = GUICtrlCreateLabel($lng_conversiontext1 & " " & $ini_movies_metadata_inputfolder & $lng_conversiontext2, 50, 360, 800, 26, $SS_LEFTNOWORDWRAP)

	Global $button_32_01 = GUICtrlCreateButton($lng_start, 900, 353, 90)
	GUICtrlSetState(-1, $GUI_deFBUTTON)

	Global $label_32_06 = GUICtrlCreateLabel($lng_options, 50, 400, 180, 20)

	Global $Pic_32_01 = GUICtrlCreatePic (@ScriptDir & "\Images\Line_1.jpg", 1, 389, 996, 2)

	Dim $Array_GUI_Elements_32[1]

	_ArrayAdd($Array_GUI_Elements_32, $button_32_01)
	_ArrayAdd($Array_GUI_Elements_32, $button_32_02)

	_ArrayAdd($Array_GUI_Elements_32, $label_32_01)
	_ArrayAdd($Array_GUI_Elements_32, $label_32_02)
	_ArrayAdd($Array_GUI_Elements_32, $label_32_05)
	_ArrayAdd($Array_GUI_Elements_32, $label_32_06)

	_ArrayAdd($Array_GUI_Elements_32, $input_32_01)

	_ArrayAdd($Array_GUI_Elements_32, $Pic_32_01)

	_ArrayAdd($Array_GUI_Elements_32, $check_92_01)
	_ArrayAdd($Array_GUI_Elements_32, $check_92_03)
	_ArrayAdd($Array_GUI_Elements_32, $check_92_15)
	_ArrayAdd($Array_GUI_Elements_32, $check_92_16)
	_ArrayAdd($Array_GUI_Elements_32, $label_92_01)

	_ArrayAdd($Array_GUI_Elements_32, $check_93_01)
	_ArrayAdd($Array_GUI_Elements_32, $check_93_02)
	_ArrayAdd($Array_GUI_Elements_32, $check_93_03)
	_ArrayAdd($Array_GUI_Elements_32, $check_93_04)
	_ArrayAdd($Array_GUI_Elements_32, $check_93_05)
	_ArrayAdd($Array_GUI_Elements_32, $check_93_06)
	_ArrayAdd($Array_GUI_Elements_32, $check_93_07)
	_ArrayAdd($Array_GUI_Elements_32, $label_93_01)

	_ArrayAdd($Array_GUI_Elements_32, $label_94_01)
	_ArrayAdd($Array_GUI_Elements_32, $label_94_02)
	_ArrayAdd($Array_GUI_Elements_32, $label_94_03)
	_ArrayAdd($Array_GUI_Elements_32, $input_94_01)
	_ArrayAdd($Array_GUI_Elements_32, $input_94_02)
	_ArrayAdd($Array_GUI_Elements_32, $input_94_03)
	_ArrayAdd($Array_GUI_Elements_32, $pic_94_01)
	_ArrayAdd($Array_GUI_Elements_32, $pic_94_01a)


#EndRegion

#Region ;Generate Dynamic Movies Metadata GUI Elements (f32)

	Global $label_f32_01 = GUICtrlCreateLabel($lng_pleasewait, 50, 240, 600, 26)
	GUICtrlSetFont(-1, 12)

	Global $label_f32_02 = GUICtrlCreateLabel("", 50, 280, 800, 26, $SS_LEFTNOWORDWRAP)
	GUICtrlSetFont(-1, 12)

	Global $label_f32_03 = GUICtrlCreateLabel("", 50, 320, 800, 26, $SS_LEFTNOWORDWRAP)
	GUICtrlSetFont(-1, 12)

	Global $progressbar_f32_01 = GUICtrlCreateProgress(50, 390, 900, 20)

	Global $button_f32_01 = GUICtrlCreateButton($lng_cancel, 900, 593, 90)
	GUICtrlSetState(-1, $GUI_deFBUTTON)

	Dim $Array_FUNC_32[1]

	_ArrayAdd($Array_FUNC_32, $button_f32_01)

	_ArrayAdd($Array_FUNC_32, $label_f32_01)
	_ArrayAdd($Array_FUNC_32, $label_f32_02)
	_ArrayAdd($Array_FUNC_32, $label_f32_03)

	_ArrayAdd($Array_FUNC_32, $progressbar_f32_01)

	_ClearGUI($Array_FUNC_32)

#EndRegion

#Region ;Generate Videos Metadata GUI (3-3)

	Global $label_33_01 = GUICtrlCreateLabel($lng_metadata & ":  " & $lng_video, 20, 180, 800, 50)
	GUICtrlSetFont(-1, 20, 700, 0, "Georgia")

	Global $button_33_02 = GUICtrlCreateButton($lng_search, 460, 267, 60)

	Global $label_33_02 = GUICtrlCreateLabel($lng_inputfoldertext, 50, 250, 400, 20)

	Global $input_33_01 = GUICtrlCreateInput($ini_videos_metadata_inputfolder, 50, 270, 400, 20)

	Global $label_33_05 = GUICtrlCreateLabel($lng_conversiontext1 & " " & $ini_videos_metadata_inputfolder & $lng_conversiontext2, 50, 360, 800, 26, $SS_LEFTNOWORDWRAP)

	Global $button_33_01 = GUICtrlCreateButton($lng_start, 900, 353, 90)
	GUICtrlSetState(-1, $GUI_deFBUTTON)

	Global $Pic_33_01 = GUICtrlCreatePic (@ScriptDir & "\Images\Line_1.jpg", 1, 389, 996, 2)

	If $ini_fanart_nocover = "1" Then
		GUICtrlSetState($check_95_01, $GUI_CHECKED)
	Else
		GUICtrlSetState($check_95_01, $GUI_UNCHECKED)
	EndIf

	If $ini_fanart_nobackdrop = "1" Then
		GUICtrlSetState($check_95_02, $GUI_CHECKED)
	Else
		GUICtrlSetState($check_95_02, $GUI_UNCHECKED)
	EndIf

	If $ini_fanart_nonfo = "1" Then
		GUICtrlSetState($check_95_03, $GUI_CHECKED)
	Else
		GUICtrlSetState($check_95_03, $GUI_UNCHECKED)
	EndIf

	If $ini_fanart_genrefolder = "1" Then
		GUICtrlSetState($check_95_04, $GUI_CHECKED)
	Else
		GUICtrlSetState($check_95_04, $GUI_UNCHECKED)
	EndIf
	If $ini_fanart_mediainfo = "1" Then
		GUICtrlSetState($check_95_05, $GUI_CHECKED)
	Else
		GUICtrlSetState($check_95_05, $GUI_UNCHECKED)
	EndIf

	Dim $Array_GUI_Elements_33[1]

	_ArrayAdd($Array_GUI_Elements_33, $button_33_01)
	_ArrayAdd($Array_GUI_Elements_33, $button_33_02)

	_ArrayAdd($Array_GUI_Elements_33, $check_95_04)
	_ArrayAdd($Array_GUI_Elements_33, $check_95_05)
	_ArrayAdd($Array_GUI_Elements_33, $check_95_01)
	_ArrayAdd($Array_GUI_Elements_33, $check_95_02)
	_ArrayAdd($Array_GUI_Elements_33, $check_95_03)

	_ArrayAdd($Array_GUI_Elements_33, $combo_95_01)
	_ArrayAdd($Array_GUI_Elements_33, $combo_95_02)
	_ArrayAdd($Array_GUI_Elements_33, $combo_95_03)
	_ArrayAdd($Array_GUI_Elements_33, $combo_95_04)
	_ArrayAdd($Array_GUI_Elements_33, $combo_95_05)

	_ArrayAdd($Array_GUI_Elements_33, $edit_95_01)

	_ArrayAdd($Array_GUI_Elements_33, $label_33_01)
	_ArrayAdd($Array_GUI_Elements_33, $label_33_02)
	_ArrayAdd($Array_GUI_Elements_33, $label_95_26)
	_ArrayAdd($Array_GUI_Elements_33, $label_95_27)
	_ArrayAdd($Array_GUI_Elements_33, $label_33_05)
	_ArrayAdd($Array_GUI_Elements_33, $label_95_28)
	_ArrayAdd($Array_GUI_Elements_33, $label_95_29)
	_ArrayAdd($Array_GUI_Elements_33, $label_95_30)
	_ArrayAdd($Array_GUI_Elements_33, $label_95_06)
	_ArrayAdd($Array_GUI_Elements_33, $label_95_31)
	_ArrayAdd($Array_GUI_Elements_33, $label_95_32)

	_ArrayAdd($Array_GUI_Elements_33, $input_33_01)
	_ArrayAdd($Array_GUI_Elements_33, $input_95_07)
	_ArrayAdd($Array_GUI_Elements_33, $input_95_08)

	_ArrayAdd($Array_GUI_Elements_33, $Pic_33_01)

#EndRegion

#Region ;Generate Dynamic Video Metadata GUI Elements (f33)

	Global $label_f33_01 = GUICtrlCreateLabel($lng_pleasewait, 50, 240, 600, 26)
	GUICtrlSetFont(-1, 12)

	Global $label_f33_02 = GUICtrlCreateLabel("", 50, 280, 800, 26, $SS_LEFTNOWORDWRAP)
	GUICtrlSetFont(-1, 12)

	Global $label_f33_03 = GUICtrlCreateLabel("", 50, 400, 800, 26, $SS_LEFTNOWORDWRAP)
	GUICtrlSetFont(-1, 12)

	Global $progressbar_f33_01 = GUICtrlCreateProgress(50, 330, 900, 20)

	Global $progressbar_f33_02 = GUICtrlCreateProgress(50, 440, 900, 20)

	Dim $Array_FUNC_33[1]

	_ArrayAdd($Array_FUNC_33, $label_f33_01)
	_ArrayAdd($Array_FUNC_33, $label_f33_02)
	_ArrayAdd($Array_FUNC_33, $label_f33_03)

	_ArrayAdd($Array_FUNC_33, $progressbar_f33_01)
	_ArrayAdd($Array_FUNC_33, $progressbar_f33_02)

	_ClearGUI($Array_FUNC_33)

#EndRegion

#Region ;Generate Audio Metadata GUI (3-4)

	Global $label_34_01 = GUICtrlCreateLabel($lng_metadata & ":  " & $lng_audio, 20, 180, 800, 50)
	GUICtrlSetFont(-1, 20, 700, 0, "Georgia")

	Global $button_34_02 = GUICtrlCreateButton($lng_search, 460, 267, 60)

	Global $label_34_02 = GUICtrlCreateLabel($lng_inputfoldertext, 50, 250, 400, 20)

	Global $input_34_01 = GUICtrlCreateInput($ini_audio_metadata_inputfolder, 50, 270, 400, 20)

	Global $label_34_05 = GUICtrlCreateLabel($lng_conversiontext1 & " " & $ini_audio_metadata_inputfolder & $lng_conversiontext2, 50, 360, 800, 26, $SS_LEFTNOWORDWRAP)

	Global $button_34_01 = GUICtrlCreateButton($lng_start, 900, 353, 90)
	GUICtrlSetState(-1, $GUI_deFBUTTON)

	Global $Pic_34_01 = GUICtrlCreatePic (@ScriptDir & "\Images\Line_1.jpg", 1, 389, 996, 2)

	Global $label_34_21 = GUICtrlCreateLabel($lng_hint, 50, 410, 300, 20)

	Global $label_34_22 = GUICtrlCreateLabel($lng_audiohint, 50, 440, 300, 180)


	Dim $Array_GUI_Elements_34[1]

	_ArrayAdd($Array_GUI_Elements_34, $button_34_01)
	_ArrayAdd($Array_GUI_Elements_34, $button_34_02)

	_ArrayAdd($Array_GUI_Elements_34, $input_34_01)

	_ArrayAdd($Array_GUI_Elements_34, $label_34_01)
	_ArrayAdd($Array_GUI_Elements_34, $label_34_02)
	_ArrayAdd($Array_GUI_Elements_34, $label_34_05)
	_ArrayAdd($Array_GUI_Elements_34, $label_34_21)
	_ArrayAdd($Array_GUI_Elements_34, $label_34_22)

	_ArrayAdd($Array_GUI_Elements_34, $Pic_34_01)


#EndRegion

#Region ;Generate Dynamic Audio Metadata GUI Elements (f34)

	Global $label_f34_01 = GUICtrlCreateLabel($lng_pleasewait, 50, 240, 600, 26)
	GUICtrlSetFont(-1, 12)

	Global $label_f34_02 = GUICtrlCreateLabel("", 50, 280, 800, 26, $SS_LEFTNOWORDWRAP)
	GUICtrlSetFont(-1, 12)

	Global $label_f34_03 = GUICtrlCreateLabel("", 50, 400, 800, 26, $SS_LEFTNOWORDWRAP)
	GUICtrlSetFont(-1, 12)

	Global $progressbar_f34_01 = GUICtrlCreateProgress(50, 330, 900, 20)

	Dim $Array_FUNC_34[1]

	_ArrayAdd($Array_FUNC_34, $label_f34_01)
	_ArrayAdd($Array_FUNC_34, $label_f34_02)
	_ArrayAdd($Array_FUNC_34, $label_f34_03)

	_ArrayAdd($Array_FUNC_34, $progressbar_f34_01)

	_ClearGUI($Array_FUNC_34)

#EndRegion

#Region ;Generate Graphics Metadata GUI (3-5)

	Global $label_35_01 = GUICtrlCreateLabel($lng_metadata & ":  " & $lng_graphics, 20, 180, 800, 50)
	GUICtrlSetFont(-1, 20, 700, 0, "Georgia")

	Global $button_35_02 = GUICtrlCreateButton($lng_search, 460, 257, 60)

	Global $label_35_02 = GUICtrlCreateLabel($lng_inputfoldertext, 50, 240, 400, 20)

	Global $input_35_01 = GUICtrlCreateInput($ini_graphics_metadata_inputfolder, 50, 260, 400, 20)

	Global $button_35_03 = GUICtrlCreateButton($lng_search, 460, 317, 60)

	Global $label_35_03 = GUICtrlCreateLabel($lng_outputfoldertext, 50, 300, 400, 20)

	Global $input_35_02 = GUICtrlCreateInput($ini_graphics_metadata_outputfolder, 50, 320, 400, 20)

	Global $label_35_04 = GUICtrlCreateLabel($lng_conversiontext1 & " " & $ini_graphics_metadata_inputfolder & $lng_conversiontext2, 50, 360, 800, 26)

	Global $label_35_05 = GUICtrlCreateLabel($lng_exiftext, 50, 420, 800, 26)

	Global $button_35_01 = GUICtrlCreateButton($lng_start, 900, 353, 90)
	GUICtrlSetState(-1, $GUI_deFBUTTON)

	Global $Pic_35_01 = GUICtrlCreatePic (@ScriptDir & "\Images\Line_1.jpg", 1, 389, 996, 2)

	Dim $Array_GUI_Elements_35[1]

	_ArrayAdd($Array_GUI_Elements_35, $button_35_01)
	_ArrayAdd($Array_GUI_Elements_35, $button_35_02)
	_ArrayAdd($Array_GUI_Elements_35, $button_35_03)

	_ArrayAdd($Array_GUI_Elements_35, $input_35_01)
	_ArrayAdd($Array_GUI_Elements_35, $input_35_02)

	_ArrayAdd($Array_GUI_Elements_35, $label_35_01)
	_ArrayAdd($Array_GUI_Elements_35, $label_35_02)
	_ArrayAdd($Array_GUI_Elements_35, $label_35_03)
	_ArrayAdd($Array_GUI_Elements_35, $label_35_04)
	_ArrayAdd($Array_GUI_Elements_35, $label_35_05)

	_ArrayAdd($Array_GUI_Elements_35, $Pic_35_01)

#EndRegion

#Region ;Generate Prepare GUI (3-6)

	Global $label_36_01 = GUICtrlCreateLabel($lng_prepare, 20, 180, 600, 50)
	GUICtrlSetFont(-1, 20, 700, 0, "Georgia")

	Global $button_36_02 = GUICtrlCreateButton($lng_search, 460, 257, 60)

	Global $label_36_02 = GUICtrlCreateLabel($lng_movies & " - " & $lng_outputfoldertext, 50, 240, 400, 20)

	Global $input_36_01 = GUICtrlCreateInput($ini_movies_metadata_inputfolder, 50, 260, 400, 20)

	Global $button_36_03 = GUICtrlCreateButton($lng_search, 460, 317, 60)

	Global $label_36_03 = GUICtrlCreateLabel($lng_series & " - " & $lng_outputfoldertext, 50, 300, 400, 20)

	Global $input_36_02 = GUICtrlCreateInput($ini_series_metadata_inputfolder, 50, 320, 400, 20)

	Global $button_36_01 = GUICtrlCreateButton($lng_start, 550, 590, 90)
	GUICtrlSetState(-1, $GUI_deFBUTTON)

	Global $button_36_04 = GUICtrlCreateButton($lng_start, 50, 590, 90)

	Global $Pic_36_01 = GUICtrlCreatePic (@ScriptDir & "\Images\Line_1.jpg", 1, 389, 996, 2)

	Global $label_36_10 = GUICtrlCreateLabel($lng_movies, 50, 410, 100, 20)

	Global $label_36_11 = GUICtrlCreateLabel($lng_title, 50, 430, 100, 20)

	Global $input_36_11 = GUICtrlCreateInput($lng_movies, 50, 450, 150, 20)

	Global $label_36_12 = GUICtrlCreateLabel($lng_year, 50, 480, 100, 20)

	Global $input_36_12 = GUICtrlCreateInput("1900", 50, 500, 150, 20)

	Global $label_36_13 = GUICtrlCreateLabel("ID", 50, 530, 100, 20)

	Global $input_36_13 = GUICtrlCreateInput("", 50, 550, 70, 20)

	Global $input_36_14 = GUICtrlCreateInput("", 130, 550, 70, 20)

	Global $label_36_20 = GUICtrlCreateLabel($lng_series, 550, 410, 100, 20)

	Global $label_36_21 = GUICtrlCreateLabel($lng_title, 550, 430, 100, 20)

	Global $input_36_21 = GUICtrlCreateInput($lng_series, 550, 450, 150, 20)

	Global $label_36_22 = GUICtrlCreateLabel($lng_year, 550, 480, 100, 20)

	Global $input_36_22 = GUICtrlCreateInput("1900", 550, 500, 150, 20)

	Global $label_36_23 = GUICtrlCreateLabel("ID", 550, 530, 100, 20)

	Global $input_36_23 = GUICtrlCreateInput("", 550, 550, 70, 20)

	Global $input_36_24 = GUICtrlCreateInput("", 630, 550, 70, 20)

	Global $label_36_30 = GUICtrlCreateLabel($lng_season, 750, 410, 100, 20)

	Global $label_36_31 = GUICtrlCreateLabel($lng_from, 750, 430, 70, 20)

	Global $input_36_31 = GUICtrlCreateInput("1", 750, 450, 70, 20)

	Global $label_36_32 = GUICtrlCreateLabel($lng_to, 830, 430, 70, 20)

	Global $input_36_32 = GUICtrlCreateInput("1", 830, 450, 70, 20)

	Global $label_36_40 = GUICtrlCreateLabel($lng_episodes, 750, 510, 100, 20)

	Global $label_36_41 = GUICtrlCreateLabel($lng_from, 750, 530, 70, 20)

	Global $input_36_41 = GUICtrlCreateInput("1", 750, 550, 70, 20)

	Global $label_36_42 = GUICtrlCreateLabel($lng_to, 830, 530, 70, 20)

	Global $input_36_42 = GUICtrlCreateInput("1", 830, 550, 70, 20)

	Dim $Array_GUI_Elements_36[1]

	_ArrayAdd($Array_GUI_Elements_36, $button_36_01)
	_ArrayAdd($Array_GUI_Elements_36, $button_36_02)
	_ArrayAdd($Array_GUI_Elements_36, $button_36_03)
	_ArrayAdd($Array_GUI_Elements_36, $button_36_04)


	_ArrayAdd($Array_GUI_Elements_36, $input_36_01)
	_ArrayAdd($Array_GUI_Elements_36, $input_36_02)
	_ArrayAdd($Array_GUI_Elements_36, $input_36_11)
	_ArrayAdd($Array_GUI_Elements_36, $input_36_12)
	_ArrayAdd($Array_GUI_Elements_36, $input_36_13)
	_ArrayAdd($Array_GUI_Elements_36, $input_36_14)
	_ArrayAdd($Array_GUI_Elements_36, $input_36_21)
	_ArrayAdd($Array_GUI_Elements_36, $input_36_22)
	_ArrayAdd($Array_GUI_Elements_36, $input_36_23)
	_ArrayAdd($Array_GUI_Elements_36, $input_36_24)
	_ArrayAdd($Array_GUI_Elements_36, $input_36_31)
	_ArrayAdd($Array_GUI_Elements_36, $input_36_32)
	_ArrayAdd($Array_GUI_Elements_36, $input_36_41)
	_ArrayAdd($Array_GUI_Elements_36, $input_36_42)


	_ArrayAdd($Array_GUI_Elements_36, $label_36_01)
	_ArrayAdd($Array_GUI_Elements_36, $label_36_02)
	_ArrayAdd($Array_GUI_Elements_36, $label_36_03)
	_ArrayAdd($Array_GUI_Elements_36, $label_36_10)
	_ArrayAdd($Array_GUI_Elements_36, $label_36_11)
	_ArrayAdd($Array_GUI_Elements_36, $label_36_12)
	_ArrayAdd($Array_GUI_Elements_36, $label_36_13)
	_ArrayAdd($Array_GUI_Elements_36, $label_36_20)
	_ArrayAdd($Array_GUI_Elements_36, $label_36_21)
	_ArrayAdd($Array_GUI_Elements_36, $label_36_22)
	_ArrayAdd($Array_GUI_Elements_36, $label_36_23)
	_ArrayAdd($Array_GUI_Elements_36, $label_36_30)
	_ArrayAdd($Array_GUI_Elements_36, $label_36_31)
	_ArrayAdd($Array_GUI_Elements_36, $label_36_32)
	_ArrayAdd($Array_GUI_Elements_36, $label_36_40)
	_ArrayAdd($Array_GUI_Elements_36, $label_36_41)
	_ArrayAdd($Array_GUI_Elements_36, $label_36_42)


	_ArrayAdd($Array_GUI_Elements_36, $Pic_36_01)



#EndRegion

#Region ;Generate Metadata GUI (3)

	Global $Select_Button_31 = GUICtrlCreateButton($lng_series, 2, 140, 150, 25)

	Global $Select_Button_32 = GUICtrlCreateButton($lng_movies, 152, 140, 150, 25)

	Global $Select_Button_33 = GUICtrlCreateButton($lng_videos, 302, 140, 150, 25)

 	Global $Select_Button_34 = GUICtrlCreateButton($lng_audio, 452, 140, 150, 25)

 	Global $Select_Button_35 = GUICtrlCreateButton($lng_graphics, 602, 140, 150, 25)

 	Global $Select_Button_36 = GUICtrlCreateButton($lng_prepare, 752, 140, 150, 25)

	Global $Select_Pic_31 = GUICtrlCreatePic (@ScriptDir & "\Images\Line_2.jpg", 301, 135, 151, 10)

	Global $Select_Label_32 = GUICtrlCreateLabel("", 301, 111, 152, 29, $SS_ETCHEDFRAME)

	Global $Select_Label_33 = GUICtrlCreateLabel("", 1, 137, 998, 494, $SS_ETCHEDFRAME)

	Dim $Array_GUI_Elements_03[1]
	_ArrayAdd($Array_GUI_Elements_03, $Select_Button_31)
	_ArrayAdd($Array_GUI_Elements_03, $Select_Button_32)
	_ArrayAdd($Array_GUI_Elements_03, $Select_Button_33)
 	_ArrayAdd($Array_GUI_Elements_03, $Select_Button_34)
 	_ArrayAdd($Array_GUI_Elements_03, $Select_Button_35)
	_ArrayAdd($Array_GUI_Elements_03, $Select_Button_36)

	_ArrayAdd($Array_GUI_Elements_03, $Select_Label_32)
	_ArrayAdd($Array_GUI_Elements_03, $Select_Label_33)

	_ArrayAdd($Array_GUI_Elements_03, $Select_Pic_31)

#EndRegion

#Region ;Generate Repair GUI (4-1)

	Global $label_41_01 = GUICtrlCreateLabel($lng_tools & ":  " & $lng_fix, 20, 180, 600, 50)
	GUICtrlSetFont(-1, 20, 700, 0, "Georgia")

	Global $button_41_02 = GUICtrlCreateButton($lng_search, 460, 257, 60)

	Global $label_41_02 = GUICtrlCreateLabel($lng_inputfoldertext, 50, 240, 400, 20)

	Global $input_41_01 = GUICtrlCreateInput($ini_fix_inputfolder, 50, 260, 400, 20)

	Global $button_41_03 = GUICtrlCreateButton($lng_search, 460, 317, 60)

	Global $label_41_03 = GUICtrlCreateLabel($lng_outputfoldertext, 50, 300, 400, 20)

	Global $input_41_02 = GUICtrlCreateInput($ini_fix_outputfolder, 50, 320, 400, 20)

	Global $label_41_04 = GUICtrlCreateLabel($lng_conversiontext1 & " " & $ini_fix_inputfolder & $lng_conversiontext2, 50, 360, 800, 26, $SS_LEFTNOWORDWRAP)

	Global $button_41_01 = GUICtrlCreateButton($lng_start, 900, 353, 90)
	GUICtrlSetState(-1, $GUI_deFBUTTON)

	Global $button_41_04 = GUICtrlCreateButton($lng_delorg, 870, 253, 120)

	Global $label_41_25 = GUICtrlCreateLabel($lng_conversiontext3, 735, 180, 250, 70, $SS_RIGHT)

	Global $Pic_41_01 = GUICtrlCreatePic (@ScriptDir & "\Images\Line_1.jpg", 1, 389, 996, 2)

	Dim $Array_GUI_Elements_41[1]

	_ArrayAdd($Array_GUI_Elements_41, $button_41_01)
	_ArrayAdd($Array_GUI_Elements_41, $button_41_02)
	_ArrayAdd($Array_GUI_Elements_41, $button_41_03)
	_ArrayAdd($Array_GUI_Elements_41, $button_41_04)

	_ArrayAdd($Array_GUI_Elements_41, $input_41_01)
	_ArrayAdd($Array_GUI_Elements_41, $input_41_02)

	_ArrayAdd($Array_GUI_Elements_41, $label_41_01)
	_ArrayAdd($Array_GUI_Elements_41, $label_41_02)
	_ArrayAdd($Array_GUI_Elements_41, $label_41_03)
	_ArrayAdd($Array_GUI_Elements_41, $label_41_04)
	_ArrayAdd($Array_GUI_Elements_41, $label_41_25)

	_ArrayAdd($Array_GUI_Elements_41, $Pic_41_01)

#EndRegion

#Region ;Generate Dynamic Repair GUI Elements (f41)

	Global $label_f41_01 = GUICtrlCreateLabel($lng_pleasewait, 50, 240, 600, 26)
	GUICtrlSetFont(-1, 12)

	Global $label_f41_02 = GUICtrlCreateLabel("", 50, 280, 800, 26, $SS_LEFTNOWORDWRAP)
	GUICtrlSetFont(-1, 12)

	Global $label_f41_03 = GUICtrlCreateLabel("", 50, 400, 800, 26, $SS_LEFTNOWORDWRAP)
	GUICtrlSetFont(-1, 12)

	Global $progressbar_f41_01 = GUICtrlCreateProgress(50, 320, 900, 20)

	Global $progressbar_f41_02 = GUICtrlCreateProgress(50, 440, 900, 20)

	Global $button_f41_01 = GUICtrlCreateButton($lng_cancel, 900, 593, 90)
	GUICtrlSetState(-1, $GUI_deFBUTTON)

	Dim $Array_FUNC_41[1]

	_ArrayAdd($Array_FUNC_41, $button_f41_01)

	_ArrayAdd($Array_FUNC_41, $label_f41_01)
	_ArrayAdd($Array_FUNC_41, $label_f41_02)
	_ArrayAdd($Array_FUNC_41, $label_f41_03)

	_ArrayAdd($Array_FUNC_41, $progressbar_f41_01)
	_ArrayAdd($Array_FUNC_41, $progressbar_f41_02)

	_ClearGUI($Array_FUNC_41)

#EndRegion

#Region ;Generate 3D GUI (4-2)

	Global $label_42_01 = GUICtrlCreateLabel($lng_tools & ":  " & $lng_3D, 20, 180, 800, 50)
	GUICtrlSetFont(-1, 20, 700, 0, "Georgia")

	Global $button_42_02 = GUICtrlCreateButton($lng_search, 460, 267, 60)

	Global $label_42_02 = GUICtrlCreateLabel($lng_inputfoldertext, 50, 250, 400, 20)

	Global $input_42_01 = GUICtrlCreateInput($ini_3d_inputfolder, 50, 270, 400, 20)

	Global $label_42_03 = GUICtrlCreateLabel($lng_3Dmode, 350, 417, 300, 20)

	Global $label_42_04 = GUICtrlCreateLabel($lng_options, 50, 417, 200, 20)

	Global $check_42_01 = GUICtrlCreateCheckbox($lng_3Drename & " *.mk3d", 50, 450, 200)

	Global $check_42_02 = GUICtrlCreateCheckbox($lng_3d_naming, 50, 480, 250)

	Global $check_42_03 = GUICtrlCreateCheckbox($lng_renamenfo, 50, 510, 200)

	Global $combo_42_01 = GUICtrlCreateCombo("mono",350, 440)
    GUICtrlSetData(-1, "side_by_side_left_first|top_bottom_right_first|top_bottom_left_first|checkerboard_right_first|checkerboard_left_first|row_interleaved_right_first|row_interleaved_left_first|column_interleaved_right_first|column_interleaved_left_first|anaglyph_cyan_red|side_by_side_right_first|anaglyph_green_magenta|both_eyes_laced_left_first|both_eyes_laced_right_first", $ini_3d_mode)

	Global $label_42_05 = GUICtrlCreateLabel($lng_conversiontext1 & " " & $ini_3d_inputfolder & $lng_conversiontext2, 50, 360, 800, 26, $SS_LEFTNOWORDWRAP)

	Global $button_42_01 = GUICtrlCreateButton($lng_start, 900, 353, 90)
	GUICtrlSetState(-1, $GUI_deFBUTTON)

	If $ini_3d_rename = "1" Then
		GUICtrlSetState($check_42_01, $GUI_CHECKED)
	Else
		GUICtrlSetState($check_42_01, $GUI_UNCHECKED)
	EndIf

	If $ini_3d_kodinaming = "1" Then
		GUICtrlSetState($check_42_02, $GUI_CHECKED)
	Else
		GUICtrlSetState($check_42_02, $GUI_UNCHECKED)
	EndIf

	If $ini_3d_renamenfo = "1" Then
		GUICtrlSetState($check_42_03, $GUI_CHECKED)
	Else
		GUICtrlSetState($check_42_03, $GUI_UNCHECKED)
	EndIf

	Global $Pic_42_01 = GUICtrlCreatePic (@ScriptDir & "\Images\Line_1.jpg", 1, 389, 996, 2)

	Dim $Array_GUI_Elements_42[1]

	_ArrayAdd($Array_GUI_Elements_42, $button_42_01)
	_ArrayAdd($Array_GUI_Elements_42, $button_42_02)

	_ArrayAdd($Array_GUI_Elements_42, $check_42_01)
	_ArrayAdd($Array_GUI_Elements_42, $check_42_02)
	_ArrayAdd($Array_GUI_Elements_42, $check_42_03)

	_ArrayAdd($Array_GUI_Elements_42, $combo_42_01)

	_ArrayAdd($Array_GUI_Elements_42, $input_42_01)

	_ArrayAdd($Array_GUI_Elements_42, $label_42_01)
	_ArrayAdd($Array_GUI_Elements_42, $label_42_02)
	_ArrayAdd($Array_GUI_Elements_42, $label_42_03)
	_ArrayAdd($Array_GUI_Elements_42, $label_42_04)
	_ArrayAdd($Array_GUI_Elements_42, $label_42_05)

	_ArrayAdd($Array_GUI_Elements_42, $Pic_42_01)

#EndRegion

#Region ;Generate Dynamic 3D GUI Elements (f42)

	Global $label_f42_01 = GUICtrlCreateLabel($lng_pleasewait, 50, 240, 600, 26)
	GUICtrlSetFont(-1, 12)

	Global $label_f42_02 = GUICtrlCreateLabel("", 50, 280, 800, 26, $SS_LEFTNOWORDWRAP)
	GUICtrlSetFont(-1, 12)

	Global $label_f42_03 = GUICtrlCreateLabel("", 50, 400, 800, 26, $SS_LEFTNOWORDWRAP)
	GUICtrlSetFont(-1, 12)

	Global $progressbar_f42_01 = GUICtrlCreateProgress(50, 320, 900, 20)

	Dim $Array_FUNC_42[1]

	_ArrayAdd($Array_FUNC_42, $label_f42_01)
	_ArrayAdd($Array_FUNC_42, $label_f42_02)
	_ArrayAdd($Array_FUNC_42, $label_f42_03)

	_ArrayAdd($Array_FUNC_42, $progressbar_f42_01)

	_ClearGUI($Array_FUNC_42)

#EndRegion

#Region ;Generate Extract GUI (4-3)

	Global $label_43_01 = GUICtrlCreateLabel($lng_tools & ":  " & $lng_extract, 20, 180, 800, 50)
	GUICtrlSetFont(-1, 20, 700, 0, "Georgia")

	Global $button_43_02 = GUICtrlCreateButton($lng_search, 460, 267, 60)

	Global $label_43_02 = GUICtrlCreateLabel($lng_inputfoldertext, 50, 250, 400, 20)

	Global $input_43_01 = GUICtrlCreateInput($ini_extract_inputfolder, 50, 270, 400, 20)

	Global $label_43_05 = GUICtrlCreateLabel($lng_conversiontext1 & " " & $ini_extract_inputfolder & $lng_conversiontext2, 50, 360, 800, 26, $SS_LEFTNOWORDWRAP)

	Global $button_43_01 = GUICtrlCreateButton($lng_start, 900, 353, 90)
	GUICtrlSetState(-1, $GUI_deFBUTTON)

	Global $check_43_01 = GUICtrlCreateCheckbox($lng_set_video, 60, 440)

	Global $check_43_02 = GUICtrlCreateCheckbox($lng_set_audio, 180, 440)

	Global $check_43_03 = GUICtrlCreateCheckbox($lng_set_subs, 300, 440)

	Global $check_43_04 = GUICtrlCreateCheckbox($lng_set_chapter, 420, 440)

	Global $check_43_05 = GUICtrlCreateCheckbox($lng_set_attach, 540, 440)

	Global $label_43_03 = GUICtrlCreateLabel($lng_set_extract, 60, 417, 300, 20)

	If $ini_extract_video = "1" Then
		GUICtrlSetState($check_43_01, $GUI_CHECKED)
	Else
		GUICtrlSetState($check_43_01, $GUI_UNCHECKED)
	EndIf
	If $ini_extract_audio = "1" Then
		GUICtrlSetState($check_43_02, $GUI_CHECKED)
	Else
		GUICtrlSetState($check_43_02, $GUI_UNCHECKED)
	EndIf
	If $ini_extract_subs = "1" Then
		GUICtrlSetState($check_43_03, $GUI_CHECKED)
	Else
		GUICtrlSetState($check_43_03, $GUI_UNCHECKED)
	EndIf
	If $ini_extract_chapter = "1" Then
		GUICtrlSetState($check_43_04, $GUI_CHECKED)
	Else
		GUICtrlSetState($check_43_04, $GUI_UNCHECKED)
	EndIf
	If $ini_extract_attachments = "1" Then
		GUICtrlSetState($check_43_05, $GUI_CHECKED)
	Else
		GUICtrlSetState($check_43_05, $GUI_UNCHECKED)
	EndIf

	Global $Pic_43_01 = GUICtrlCreatePic (@ScriptDir & "\Images\Line_1.jpg", 1, 389, 996, 2)

	Dim $Array_GUI_Elements_43[1]

	_ArrayAdd($Array_GUI_Elements_43, $button_43_01)
	_ArrayAdd($Array_GUI_Elements_43, $button_43_02)

	_ArrayAdd($Array_GUI_Elements_43, $check_43_01)
	_ArrayAdd($Array_GUI_Elements_43, $check_43_02)
	_ArrayAdd($Array_GUI_Elements_43, $check_43_03)
	_ArrayAdd($Array_GUI_Elements_43, $check_43_04)
	_ArrayAdd($Array_GUI_Elements_43, $check_43_05)

	_ArrayAdd($Array_GUI_Elements_43, $input_43_01)

	_ArrayAdd($Array_GUI_Elements_43, $label_43_01)
	_ArrayAdd($Array_GUI_Elements_43, $label_43_02)
	_ArrayAdd($Array_GUI_Elements_43, $label_43_03)
	_ArrayAdd($Array_GUI_Elements_43, $label_43_05)

	_ArrayAdd($Array_GUI_Elements_43, $Pic_43_01)

#EndRegion

#Region ;Generate Dynamic Extract GUI Elements (f43)

	Global $label_f43_01 = GUICtrlCreateLabel($lng_pleasewait, 50, 240, 600, 26)
	GUICtrlSetFont(-1, 12)

	Global $label_f43_02 = GUICtrlCreateLabel("", 50, 280, 800, 26, $SS_LEFTNOWORDWRAP)
	GUICtrlSetFont(-1, 12)

	Global $label_f43_03 = GUICtrlCreateLabel("", 50, 400, 800, 26, $SS_LEFTNOWORDWRAP)
	GUICtrlSetFont(-1, 12)

	Global $progressbar_f43_01 = GUICtrlCreateProgress(50, 320, 900, 20)

	Global $progressbar_f43_02 = GUICtrlCreateProgress(50, 440, 900, 20)

	Global $button_f43_01 = GUICtrlCreateButton($lng_cancel, 900, 593, 90)
	GUICtrlSetState(-1, $GUI_deFBUTTON)

	Dim $Array_FUNC_43[1]

	_ArrayAdd($Array_FUNC_43, $button_f43_01)

	_ArrayAdd($Array_FUNC_43, $label_f43_01)
	_ArrayAdd($Array_FUNC_43, $label_f43_02)
	_ArrayAdd($Array_FUNC_43, $label_f43_03)

	_ArrayAdd($Array_FUNC_43, $progressbar_f43_01)
	_ArrayAdd($Array_FUNC_43, $progressbar_f43_02)

	_ClearGUI($Array_FUNC_43)

#EndRegion

#Region ;Generate Kodi Helper Tools GUI (4-4)

	Global $label_44_01 = GUICtrlCreateLabel($lng_tools & ": Kodi- Tools", 20, 180, 800, 25)
	GUICtrlSetFont(-1, 20, 700, 0, "Georgia")

	Global $button_44_02 = GUICtrlCreateButton($lng_search, 360, 267, 60)

	Global $label_44_02 = GUICtrlCreateLabel($lng_moviesetfanart & ":", 50, 220, 400, 20)
	GUICtrlSetFont(-1, 10, 700, 0, "Georgia")

	Global $label_44_03 = GUICtrlCreateLabel($lng_inputfoldertext, 50, 250, 300, 20)

	Global $input_44_01 = GUICtrlCreateInput($ini_koditools_inputfolder, 50, 270, 300, 20)

	Global $button_44_01 = GUICtrlCreateButton($lng_start, 430, 267, 60)

	Global $label_44_05 = GUICtrlCreateLabel($lng_copy_artist & ":", 50, 310, 300, 20)
	GUICtrlSetFont(-1, 10, 700, 0, "Georgia")

	Global $label_44_06 = GUICtrlCreateLabel($lng_inputfoldertext, 50, 330, 300, 20)

	Global $input_44_02 = GUICtrlCreateInput($ini_koditools_audiofolder, 50, 350, 300, 20)

	Global $button_44_03 = GUICtrlCreateButton($lng_start, 430, 347, 60)

	Global $button_44_04 = GUICtrlCreateButton($lng_search, 360, 347, 60)

	Global $label_44_30 = GUICtrlCreateLabel("movie.nfo " & $lng_compatible, 600, 220, 300, 20)
	GUICtrlSetFont(-1, 10, 700, 0, "Georgia")

	Global $label_44_31 = GUICtrlCreateLabel($lng_inputfoldertext, 600, 240, 300, 20)

	Global $input_44_30 = GUICtrlCreateInput($ini_kodi19_inputfolder1, 600, 260, 300, 20)

	Global $button_44_30 = GUICtrlCreateButton($lng_start, 910, 217, 60)

	Global $button_44_31 = GUICtrlCreateButton($lng_search, 910, 257, 60)


	Global $label_44_20 = GUICtrlCreateLabel("Tvshow.nfo " & $lng_compatible, 600, 310, 300, 20)
	GUICtrlSetFont(-1, 10, 700, 0, "Georgia")

	Global $label_44_21 = GUICtrlCreateLabel($lng_inputfoldertext, 600, 330, 300, 20)

	Global $input_44_20 = GUICtrlCreateInput($ini_kodi19_inputfolder, 600, 350, 300, 20)

	Global $button_44_20 = GUICtrlCreateButton($lng_start, 910, 307, 60)

	Global $button_44_21 = GUICtrlCreateButton($lng_search, 910, 347, 60)

	Global $check_44_40 = GUICtrlCreateCheckbox($lng_fixnotation, 600, 430, 300, 20)
	GUICtrlSetFont(-1, 10, 700, 0, "Georgia")

	Global $label_44_41 = GUICtrlCreateLabel($lng_inputfoldertext, 600, 460, 300, 20)

	Global $input_44_40 = GUICtrlCreateInput($ini_kodidot_inputfolder, 600, 480, 300, 20)

	Global $button_44_40 = GUICtrlCreateButton($lng_start, 910, 517, 60)

	Global $button_44_41 = GUICtrlCreateButton($lng_search, 910, 477, 60)



	Global $Pic_44_01 = GUICtrlCreatePic (@ScriptDir & "\Images\Line_1.jpg", 1, 389, 996, 2)

	Global $label_44_11 = GUICtrlCreateLabel($lng_dbtype, 50, 430, 190, 20)
	GUICtrlSetFont(-1, 10, 700, 0, "Georgia")

	Global $label_44_12 = GUICtrlCreateLabel($lng_selectSQLite, 50, 460, 190, 20)

	Global $button_44_12 = GUICtrlCreateButton($lng_search, 370, 477, 60)

	Global $input_44_12 = GUICtrlCreateInput($ini_kodi_SQLite_database, 50, 480, 310, 20)

	Global $label_44_13 = GUICtrlCreateLabel($lng_MySQLserver, 50, 530, 140, 20)

	Global $input_44_13 = GUICtrlCreateInput($ini_kodi_MySQL_server, 190, 527, 90, 20)

	Global $label_44_14 = GUICtrlCreateLabel("Port", 300, 530, 40, 20)

	Global $input_44_14 = GUICtrlCreateInput($ini_kodi_MySQL_port, 340, 527, 90, 20)

	Global $label_44_15 = GUICtrlCreateLabel("User", 50, 560, 120, 20)

	Global $input_44_15 = GUICtrlCreateInput($ini_kodi_MySQL_user, 190, 557, 90, 20)

	Global $label_44_16 = GUICtrlCreateLabel("Pass", 300, 560, 40, 20)

	Global $input_44_16 = GUICtrlCreateInput($ini_kodi_MySQL_pass, 340, 557, 90, 20, $ES_PASSWORD)

	Global $label_44_17 = GUICtrlCreateLabel($lng_MySQLdb, 50, 590, 140, 20)

	Global $input_44_17 = GUICtrlCreateInput($ini_kodi_MySQL_database, 190, 587, 90, 20)

	GUIStartGroup()

		Global $radio_44_01 = GUICtrlCreateRadio("SQLite", 280, 430, 70, 20)

		Global $radio_44_02 = GUICtrlCreateRadio("MYSQL", 375, 430, 70, 20)

	If $ini_kodi_database = "SQlite" Then GUICtrlSetState($radio_44_01, $GUI_CHECKED)

	If $ini_kodi_database = "MySQL" Then GUICtrlSetState($radio_44_02, $GUI_CHECKED)

	If $ini_kodi_dot = "1" Then
		GUICtrlSetState($check_44_40, $GUI_CHECKED)
	Else
		GUICtrlSetState($check_44_40, $GUI_UNCHECKED)
	EndIf


	Dim $Array_GUI_Elements_44[1]

	_ArrayAdd($Array_GUI_Elements_44, $button_44_01)
	_ArrayAdd($Array_GUI_Elements_44, $button_44_02)
	_ArrayAdd($Array_GUI_Elements_44, $button_44_03)
	_ArrayAdd($Array_GUI_Elements_44, $button_44_04)
	_ArrayAdd($Array_GUI_Elements_44, $button_44_12)
	_ArrayAdd($Array_GUI_Elements_44, $button_44_20)
	_ArrayAdd($Array_GUI_Elements_44, $button_44_21)
	_ArrayAdd($Array_GUI_Elements_44, $button_44_30)
	_ArrayAdd($Array_GUI_Elements_44, $button_44_31)
	_ArrayAdd($Array_GUI_Elements_44, $button_44_40)
	_ArrayAdd($Array_GUI_Elements_44, $button_44_41)

	_ArrayAdd($Array_GUI_Elements_44, $check_44_40)

	_ArrayAdd($Array_GUI_Elements_44,  $input_44_01)
	_ArrayAdd($Array_GUI_Elements_44,  $input_44_02)
	_ArrayAdd($Array_GUI_Elements_44,  $input_44_12)
	_ArrayAdd($Array_GUI_Elements_44,  $input_44_13)
	_ArrayAdd($Array_GUI_Elements_44,  $input_44_14)
	_ArrayAdd($Array_GUI_Elements_44,  $input_44_15)
	_ArrayAdd($Array_GUI_Elements_44,  $input_44_16)
	_ArrayAdd($Array_GUI_Elements_44,  $input_44_17)
	_ArrayAdd($Array_GUI_Elements_44,  $input_44_20)
	_ArrayAdd($Array_GUI_Elements_44,  $input_44_30)
	_ArrayAdd($Array_GUI_Elements_44,  $input_44_40)

	_ArrayAdd($Array_GUI_Elements_44, $label_44_01)
	_ArrayAdd($Array_GUI_Elements_44, $label_44_02)
	_ArrayAdd($Array_GUI_Elements_44, $label_44_03)
	_ArrayAdd($Array_GUI_Elements_44, $label_44_05)
	_ArrayAdd($Array_GUI_Elements_44, $label_44_06)
	_ArrayAdd($Array_GUI_Elements_44, $label_44_11)
	_ArrayAdd($Array_GUI_Elements_44, $label_44_12)
	_ArrayAdd($Array_GUI_Elements_44, $label_44_13)
	_ArrayAdd($Array_GUI_Elements_44, $label_44_14)
	_ArrayAdd($Array_GUI_Elements_44, $label_44_15)
	_ArrayAdd($Array_GUI_Elements_44, $label_44_16)
	_ArrayAdd($Array_GUI_Elements_44, $label_44_17)
	_ArrayAdd($Array_GUI_Elements_44, $label_44_20)
	_ArrayAdd($Array_GUI_Elements_44, $label_44_21)
	_ArrayAdd($Array_GUI_Elements_44, $label_44_30)
	_ArrayAdd($Array_GUI_Elements_44, $label_44_31)
	_ArrayAdd($Array_GUI_Elements_44, $label_44_41)


	_ArrayAdd($Array_GUI_Elements_44, $Pic_44_01)

	_ArrayAdd($Array_GUI_Elements_44, $radio_44_01)
	_ArrayAdd($Array_GUI_Elements_44, $radio_44_02)

#EndRegion

#Region ;Generate Stub GUI (4-7)

	Global $label_47_00 = GUICtrlCreateLabel($lng_tools & ":  " & $lng_mediastub, 20, 180, 800, 50)
	GUICtrlSetFont(-1, 20, 700, 0, "Georgia")

	Global $button_47_02 = GUICtrlCreateButton($lng_search, 460, 267, 60)

	Global $label_47_01 = GUICtrlCreateLabel($lng_outputfoldertext, 50, 250, 400, 20)

	Global $input_47_01 = GUICtrlCreateInput($ini_mediastub_outputfolder, 50, 270, 400, 20)

	Global $button_47_01 = GUICtrlCreateButton($lng_start, 900, 353, 90)
	GUICtrlSetState(-1, $GUI_deFBUTTON)

	Global $Pic_47_01 = GUICtrlCreatePic (@ScriptDir & "\Images\Line_1.jpg", 1, 389, 996, 2)

	Global $label_47_02 = GUICtrlCreateLabel($lng_mediastub_filename & ":", 50, 420, 400, 20)

	Global $input_47_02 = GUICtrlCreateInput("", 50, 440, 300, 20)

	$s = ""

	If _ElementExists($ArrayMediaStub, 1) Then $s = StringTrimLeft($ArrayMediaStub[1], 1)

	Global $combo_47_02 = GUICtrlCreateCombo($s, 370, 440, 80)

	For $i = 1 to UBound($ArrayMediaStub)-1

		GUICtrlSetData($combo_47_02, StringTrimLeft($ArrayMediaStub[$i], 1), StringTrimLeft($ini_stub, 1))

	Next

	Global $label_47_03 = GUICtrlCreateLabel($lng_title & ":", 50, 470, 400, 20)

	Global $input_47_03 = GUICtrlCreateInput("", 50, 490, 400, 20)

	Global $label_47_04 = GUICtrlCreateLabel($lng_message & ":", 50, 520, 400, 20)

	Global $edit_47_04 = GUICtrlCreateEdit("", 50, 540, 400, 70, $ES_AUTOVSCROLL + $WS_VSCROLL)


	Dim $Array_GUI_Elements_47[1]

	_ArrayAdd($Array_GUI_Elements_47, $button_47_01)
	_ArrayAdd($Array_GUI_Elements_47, $button_47_02)

	_ArrayAdd($Array_GUI_Elements_47, $combo_47_02)

	_ArrayAdd($Array_GUI_Elements_47, $edit_47_04)

	_ArrayAdd($Array_GUI_Elements_47, $input_47_01)
	_ArrayAdd($Array_GUI_Elements_47, $input_47_02)
	_ArrayAdd($Array_GUI_Elements_47, $input_47_03)

	_ArrayAdd($Array_GUI_Elements_47, $label_47_00)
	_ArrayAdd($Array_GUI_Elements_47, $label_47_01)
	_ArrayAdd($Array_GUI_Elements_47, $label_47_02)
	_ArrayAdd($Array_GUI_Elements_47, $label_47_03)
	_ArrayAdd($Array_GUI_Elements_47, $label_47_04)

	_ArrayAdd($Array_GUI_Elements_47, $Pic_47_01)

#EndRegion

#Region ;Generate Audiotools GUI (4-8)

	Global $label_48_00 = GUICtrlCreateLabel($lng_tools & ":  " & $lng_artist & "- " & $lng_folder_structure, 20, 180, 600, 50)
	GUICtrlSetFont(-1, 20, 700, 0, "Georgia")

	Global $button_48_02 = GUICtrlCreateButton($lng_search, 460, 257, 60)

	Global $label_48_02 = GUICtrlCreateLabel($lng_inputfoldertext, 50, 240, 400, 20)

	Global $input_48_01 = GUICtrlCreateInput($ini_audiotools_inputfolder, 50, 260, 400, 20)

	Global $button_48_03 = GUICtrlCreateButton($lng_search, 460, 317, 60)

	Global $label_48_03 = GUICtrlCreateLabel($lng_outputfoldertext, 50, 300, 400, 20)

	Global $input_48_02 = GUICtrlCreateInput($ini_audiotools_outputfolder, 50, 320, 400, 20)

	Global $label_48_04 = GUICtrlCreateLabel($lng_conversiontext1 & " " & $ini_audiotools_inputfolder & $lng_conversiontext2, 50, 360, 800, 26)

	Global $button_48_01 = GUICtrlCreateButton($lng_start, 900, 353, 90)
	GUICtrlSetState(-1, $GUI_deFBUTTON)

	Global $Pic_48_01 = GUICtrlCreatePic (@ScriptDir & "\Images\Line_1.jpg", 1, 389, 996, 2)

	Global $label_48_11 = GUICtrlCreateLabel($lng_audiocopy, 50, 430, 390, 20)
	GUICtrlSetFont(-1, 10, 700, 0, "Georgia")

	GUIStartGroup()

		Global $radio_48_01 = GUICtrlCreateRadio($lng_copy, 50, 470, 100, 20)

		Global $radio_48_02 = GUICtrlCreateRadio($lng_move, 50, 500, 100, 20)


	If $ini_audiotools_copy = "1" Then GUICtrlSetState($radio_48_01, $GUI_CHECKED)

	If $ini_audiotools_copy = "4" Then GUICtrlSetState($radio_48_02, $GUI_CHECKED)


	Dim $Array_GUI_Elements_48[1]

	_ArrayAdd($Array_GUI_Elements_48, $button_48_01)
	_ArrayAdd($Array_GUI_Elements_48, $button_48_02)
	_ArrayAdd($Array_GUI_Elements_48, $button_48_03)

	_ArrayAdd($Array_GUI_Elements_48, $input_48_01)
	_ArrayAdd($Array_GUI_Elements_48, $input_48_02)

	_ArrayAdd($Array_GUI_Elements_48, $label_48_00)
	_ArrayAdd($Array_GUI_Elements_48, $label_48_02)
	_ArrayAdd($Array_GUI_Elements_48, $label_48_03)
	_ArrayAdd($Array_GUI_Elements_48, $label_48_04)
	_ArrayAdd($Array_GUI_Elements_48, $label_48_11)

	_ArrayAdd($Array_GUI_Elements_48, $Pic_48_01)

	_ArrayAdd($Array_GUI_Elements_48, $radio_48_01)
	_ArrayAdd($Array_GUI_Elements_48, $radio_48_02)



#EndRegion

#Region ;Generate Tools GUI (4)

	Global $Select_Button_41 = GUICtrlCreateButton($lng_fix, 2, 140, 150, 25)

	Global $Select_Button_42 = GUICtrlCreateButton($lng_3D, 152, 140, 150, 25)

	Global $Select_Button_43 = GUICtrlCreateButton($lng_extract, 302, 140, 150, 25)

	Global $Select_Button_44 = GUICtrlCreateButton("Kodi- Tools", 452, 140, 150, 25)

	Global $Select_Button_45 = GUICtrlCreateButton("MediaStub- Tools", 602, 140, 150, 25)

	Global $Select_Button_46 = GUICtrlCreateButton("Audio- Tools", 752, 140, 150, 25)

	Global $Select_Pic_41 = GUICtrlCreatePic (@ScriptDir & "\Images\Line_2.jpg", 601, 135, 151, 10)

	Global $Select_Label_41 = GUICtrlCreateLabel("", 601, 111, 152, 29, $SS_ETCHEDFRAME)

	Global $Select_Label_42 = GUICtrlCreateLabel("", 1, 137, 998, 494, $SS_ETCHEDFRAME)

	Dim $Array_GUI_Elements_04[1]
	_ArrayAdd($Array_GUI_Elements_04, $Select_Button_41)
	_ArrayAdd($Array_GUI_Elements_04, $Select_Button_42)
	_ArrayAdd($Array_GUI_Elements_04, $Select_Button_43)
	_ArrayAdd($Array_GUI_Elements_04, $Select_Button_44)
	_ArrayAdd($Array_GUI_Elements_04, $Select_Button_45)
	_ArrayAdd($Array_GUI_Elements_04, $Select_Button_46)

	_ArrayAdd($Array_GUI_Elements_04, $Select_Label_41)
	_ArrayAdd($Array_GUI_Elements_04, $Select_Label_42)

	_ArrayAdd($Array_GUI_Elements_04, $Select_Pic_41)

#EndRegion

#Region ;Generate Program Settings GUI (5-1)

	Global $label_51_01 = GUICtrlCreateLabel($lng_config & ":  " & $lng_program & " - " & $lng_options, 20, 180, 800, 50)
	GUICtrlSetFont(-1, 20, 700, 0, "Georgia")

	Global $label_51_03 = GUICtrlCreateLabel($lng_path_ffmpeg, 350, 250, 400)
	GUICtrlSetFont(-1, 10, 700, 0, "Verdana")

	Global $input_51_03 = GUICtrlCreateInput($ini_ffmpeg_path, 350, 275, 300, 20)

	Global $button_51_03 = GUICtrlCreateButton($lng_search, 660, 273, 60)

	Global $label_51_04 = GUICtrlCreateLabel($lng_path_mkvmerge, 350, 310, 400)
	GUICtrlSetFont(-1, 10, 700, 0, "Verdana")

	Global $input_51_04 = GUICtrlCreateInput($ini_mkvmerge_path, 350, 335, 300, 20)

	Global $button_51_04 = GUICtrlCreateButton($lng_search, 660, 333, 60)

	Global $label_51_05 = GUICtrlCreateLabel($lng_path_mkvpropedit, 350, 370, 400)
	GUICtrlSetFont(-1, 10, 700, 0, "Verdana")

	Global $input_51_05 = GUICtrlCreateInput($ini_mkvpropedit_path, 350, 395, 300, 20)

	Global $button_51_05 = GUICtrlCreateButton($lng_search, 660, 393, 60)

	Global $label_51_06 = GUICtrlCreateLabel($lng_path_mkvextract, 350, 430, 400)
	GUICtrlSetFont(-1, 10, 700, 0, "Verdana")

	Global $input_51_06 = GUICtrlCreateInput($ini_mkvextract_path, 350, 455, 300, 20)

	Global $button_51_06 = GUICtrlCreateButton($lng_search, 660, 453, 60)

	Global $label_51_08 = GUICtrlCreateLabel($lng_workingdrive, 800, 250, 190, 20)
	GUICtrlSetFont(-1, 10, 700, 0, "Verdana")

	Global $combo_51_08 = GUICtrlCreateCombo($ini_workingdrive, 800, 280, 130)

	Global $label_51_09 = GUICtrlCreateLabel($lng_langselect, 20, 250, 230)
	GUICtrlSetFont(-1, 10, 700, 0, "Verdana")

	Global $combo_51_09 = GUICtrlCreateCombo($ini_language, 20, 280, 100)

	Global $button_51 = GUICtrlCreateButton($lng_save, 900, 593, 90)

	Global $label_51_07 = GUICtrlCreateLabel($lng_set_all_to, 20, 350, 230)
	GUICtrlSetFont(-1, 10, 700, 0, "Verdana")

	Global $combo_51_07 = GUICtrlCreateCombo($ini_language, 20, 380, 100)

	Global $button_51_01 = GUICtrlCreateButton($lng_set_all, 20, 420, 90)

	Global $label_51_10 = GUICtrlCreateLabel($lng_dontsleep_options, 800, 350, 190, 20)
	GUICtrlSetFont(-1, 10, 700, 0, "Verdana")

	Global $check_51_11 = GUICtrlCreateCheckbox($lng_dontsleep, 800, 380)

	Global $check_51_12 = GUICtrlCreateCheckbox($lng_dontsleep_standby, 800, 410)

	Global $check_51_13 = GUICtrlCreateCheckbox($lng_dontsleep_shutdown, 800, 440)

	Global $label_51_15 = GUICtrlCreateLabel($lng_files & "- " & $lng_options, 800, 500, 190, 20)
	GUICtrlSetFont(-1, 10, 700, 0, "Verdana")

	Global $check_51_15 = GUICtrlCreateCheckbox($lng_keep_file_date, 800, 530)


	Global $pic_51_01 = GUICtrlCreatePic($ini_language_flag, 150, 281, 68, 40)
	GUICtrlSetState(-1, $GUI_HIDE)

	Global $pic_51_03 = GUICtrlCreatePic(@ScriptDir & "\Images\Flags\black.jpg", 149, 280, 70, 42)
	GUICtrlSetState(-1, $GUI_HIDE)

	Global $pic_51_02 = GUICtrlCreatePic($ini_language_flag_all, 150, 381, 68, 40)
	GUICtrlSetState(-1, $GUI_HIDE)

	Global $pic_51_04 = GUICtrlCreatePic(@ScriptDir & "\Images\Flags\black.jpg", 149, 380, 70, 42)
	GUICtrlSetState(-1, $GUI_HIDE)

	If $ini_DontSleep = "1" Then
		GUICtrlSetState($check_51_11, $GUI_CHECKED)
	Else
		GUICtrlSetState($check_51_11, $GUI_UNCHECKED)
	EndIf

	If $ini_DontSleep_standby = "1" Then
		GUICtrlSetState($check_51_12, $GUI_CHECKED)
	Else
		GUICtrlSetState($check_51_12, $GUI_UNCHECKED)
	EndIf

	If $ini_DontSleep_shutdown = "1" Then
		GUICtrlSetState($check_51_13, $GUI_CHECKED)
	Else
		GUICtrlSetState($check_51_13, $GUI_UNCHECKED)
	EndIf

	If $ini_KeepFileDate  = "1" Then
		GUICtrlSetState($check_51_15, $GUI_CHECKED)
	Else
		GUICtrlSetState($check_51_15, $GUI_UNCHECKED)
	EndIf

	For $I = 1 to _ArrayMaxIndex($Arraylng)
		GUICtrlSetData($combo_51_09, StringTrimRight($Arraylng[$I], 4), $ini_language)
	Next

	For $I = 1 to _ArrayMaxIndex($Arraylng)
		GUICtrlSetData($combo_51_07, StringTrimRight($Arraylng[$I], 4), $ini_language)
	Next

	For $I = 1 to $DriveArray[0]
		GUICtrlSetData($combo_51_08, $DriveArray[$I], $ini_workingdrive)
	Next

	Dim $Array_GUI_Elements_51[1]

	_ArrayAdd($Array_GUI_Elements_51, $button_51_01)
	_ArrayAdd($Array_GUI_Elements_51, $button_51_03)
	_ArrayAdd($Array_GUI_Elements_51, $button_51_04)
	_ArrayAdd($Array_GUI_Elements_51, $button_51_05)
	_ArrayAdd($Array_GUI_Elements_51, $button_51_06)

	_ArrayAdd($Array_GUI_Elements_51, $check_51_11)
	_ArrayAdd($Array_GUI_Elements_51, $check_51_12)
	_ArrayAdd($Array_GUI_Elements_51, $check_51_13)
	_ArrayAdd($Array_GUI_Elements_51, $check_51_15)


	_ArrayAdd($Array_GUI_Elements_51, $combo_51_07)
	_ArrayAdd($Array_GUI_Elements_51, $combo_51_08)
	_ArrayAdd($Array_GUI_Elements_51, $combo_51_09)

	_ArrayAdd($Array_GUI_Elements_51, $input_51_03)
	_ArrayAdd($Array_GUI_Elements_51, $input_51_04)
	_ArrayAdd($Array_GUI_Elements_51, $input_51_05)
	_ArrayAdd($Array_GUI_Elements_51, $input_51_06)

	_ArrayAdd($Array_GUI_Elements_51, $label_51_01)
	_ArrayAdd($Array_GUI_Elements_51, $label_51_03)
	_ArrayAdd($Array_GUI_Elements_51, $label_51_04)
	_ArrayAdd($Array_GUI_Elements_51, $label_51_05)
	_ArrayAdd($Array_GUI_Elements_51, $label_51_06)
	_ArrayAdd($Array_GUI_Elements_51, $label_51_07)
	_ArrayAdd($Array_GUI_Elements_51, $label_51_08)
	_ArrayAdd($Array_GUI_Elements_51, $label_51_09)
	_ArrayAdd($Array_GUI_Elements_51, $label_51_10)
	_ArrayAdd($Array_GUI_Elements_51, $label_51_15)

	_ArrayAdd($Array_GUI_Elements_51, $pic_51_01)
	_ArrayAdd($Array_GUI_Elements_51, $pic_51_02)
	_ArrayAdd($Array_GUI_Elements_51, $pic_51_03)
	_ArrayAdd($Array_GUI_Elements_51, $pic_51_04)


#EndRegion

#Region ;Generate Video Settings GUI (5-2)

	$CFT = ""

	For $i = 0 To UBound($json_FileExtensions) - 1

		$CFT = $CFT & $json_FileExtensions[$i] & @CRLF

	Next

	$SFT = ""

	For $i = 1 To UBound($ArrayMediaStub) - 1

		$SFT = $SFT & $ArrayMediaStub[$i] & @CRLF

	Next

	$VWL = ""

	For $i = 1 To UBound($ArrayVideoWhitelist) - 1

		$VWL = $VWL & $ArrayVideoWhitelist[$i] & @CRLF

	Next

	$AWL = ""

	For $i = 1 To UBound($ArrayAudioWhitelist) - 1

		$AWL = $AWL & $ArrayAudioWhitelist[$i] & @CRLF

	Next

	Global $label_52_01 = GUICtrlCreateLabel($lng_config & ":  " & $lng_video & " - " & $lng_options, 20, 180, 800, 30)
	GUICtrlSetFont(-1, 20, 700, 0, "Georgia")

	Global $label_52_02 = GUICtrlCreateLabel($lng_wizards & "- " & $lng_options & ":", 20, 250, 200, 20)
	GUICtrlSetFont(-1, 10, 700, 0, "Verdana")

	Global $check_52_02 = GUICtrlCreateCheckbox($lng_zerocoding, 20, 280)

	Global $check_52_03 = GUICtrlCreateCheckbox($lng_transcode_all & ": Video", 20, 310)

	Global $label_52_03 = GUICtrlCreateLabel($lng_excerpt & " Video Codec: ", 20, 340, 200, 20)

	Global $label_52_13 = GUICtrlCreateLabel($lng_VideoCodec & ":", 520, 250, 200, 20)
	GUICtrlSetFont(-1, 10, 700, 0, "Verdana")

	Global $edit_52_01 = GUICtrlCreateEdit($VWL, 20, 360, 200, 70, $ES_MULTILINE + $ES_WANTRETURN + $ES_AUTOVSCROLL + $WS_VSCROLL)

	Global $check_52_04 = GUICtrlCreateCheckbox($lng_transcode_all & ": Audio", 20, 440)

	Global $label_52_04 = GUICtrlCreateLabel($lng_excerpt & " Audio Codec: ", 20, 470, 200, 20)

	Global $edit_52_02 = GUICtrlCreateEdit($AWL, 20, 490, 200, 60, $ES_MULTILINE + $ES_WANTRETURN + $ES_AUTOVSCROLL + $WS_VSCROLL)

	Global $label_52_11 = GUICtrlCreateLabel($lng_customfiletypes & ":", 280, 250, 180, 20)
	GUICtrlSetFont(-1, 10, 700, 0, "Verdana")

	Global $label_52_05 = GUICtrlCreateLabel($lng_fallback, 20, 560, 200, 20)

	Global $combo_52_05 = GUICtrlCreateCombo($ini_codec, 20, 580, 100, 20)
	GUICtrlSetData($combo_52_05, "AAC", $ini_codec)
	GUICtrlSetData($combo_52_05, "AC-3", $ini_codec)
	GUICtrlSetData($combo_52_05, "DTS", $ini_codec)
	GUICtrlSetData($combo_52_05, "FLAC", $ini_codec)
	GUICtrlSetData($combo_52_05, "MP3", $ini_codec)
	GUICtrlSetData($combo_52_05, "OPUS", $ini_codec)
	GUICtrlSetData($combo_52_05, "TrueHD", $ini_codec)

	Global $label_52_12 = GUICtrlCreateLabel($lng_oneperline, 280, 275, 180, 20)

	Global $edit_52_11 = GUICtrlCreateEdit($CFT, 280, 300, 180, 175, $ES_MULTILINE + $ES_WANTRETURN + $ES_AUTOVSCROLL + $WS_VSCROLL)

	Global $label_52_21 = GUICtrlCreateLabel($lng_optimizer & "- " & $lng_options & ":", 750, 250, 200, 20)
	GUICtrlSetFont(-1, 10, 700, 0, "Verdana")

	Global $check_52_21 = GUICtrlCreateCheckbox($lng_preferchannels, 750, 280)

	Global $label_52_22 = GUICtrlCreateLabel($lng_audio & "- " & "Codecs " & ":", 750, 310, 200, 20)

	Global $label_52_23 = GUICtrlCreateLabel("1.", 750, 332, 30, 20)

	Global $combo_52_23 = GUICtrlCreateCombo($ini_codec1, 780, 330, 100, 20)
	GUICtrlSetData($combo_52_23, "DTS", $ini_codec1)
	GUICtrlSetData($combo_52_23, "TrueHD", $ini_codec1)
	GUICtrlSetData($combo_52_23, "AC-3", $ini_codec1)
	GUICtrlSetData($combo_52_23, "AAC", $ini_codec1)
	GUICtrlSetData($combo_52_23, "MP3", $ini_codec1)
	GUICtrlSetData($combo_52_23, "---", $ini_codec1)

	Global $label_52_24 = GUICtrlCreateLabel("2.", 750, 357, 30, 20)

	Global $combo_52_24 = GUICtrlCreateCombo($ini_codec2, 780, 355, 100, 20)
	GUICtrlSetData($combo_52_24, "DTS", $ini_codec2)
	GUICtrlSetData($combo_52_24, "TrueHD", $ini_codec2)
	GUICtrlSetData($combo_52_24, "AC-3", $ini_codec2)
	GUICtrlSetData($combo_52_24, "AAC", $ini_codec2)
	GUICtrlSetData($combo_52_24, "MP3", $ini_codec2)
	GUICtrlSetData($combo_52_24, "---", $ini_codec2)

	Global $label_52_25 = GUICtrlCreateLabel("3.", 750, 382, 30, 20)

	Global $combo_52_25 = GUICtrlCreateCombo($ini_codec3, 780, 380, 100, 20)
	GUICtrlSetData($combo_52_25, "DTS", $ini_codec3)
	GUICtrlSetData($combo_52_25, "TrueHD", $ini_codec3)
	GUICtrlSetData($combo_52_25, "AC-3", $ini_codec3)
	GUICtrlSetData($combo_52_25, "AAC", $ini_codec3)
	GUICtrlSetData($combo_52_25, "MP3", $ini_codec3)
	GUICtrlSetData($combo_52_25, "---", $ini_codec3)

	Global $label_52_26 = GUICtrlCreateLabel("4.", 750, 407, 30, 20)

	Global $combo_52_26 = GUICtrlCreateCombo($ini_codec4, 780, 405, 100, 20)
	GUICtrlSetData($combo_52_26, "DTS", $ini_codec4)
	GUICtrlSetData($combo_52_26, "TrueHD", $ini_codec4)
	GUICtrlSetData($combo_52_26, "AC-3", $ini_codec4)
	GUICtrlSetData($combo_52_26, "AAC", $ini_codec4)
	GUICtrlSetData($combo_52_26, "MP3", $ini_codec4)
	GUICtrlSetData($combo_52_26, "---", $ini_codec4)

	Global $label_52_27 = GUICtrlCreateLabel("5.", 750, 432, 30, 20)

	Global $combo_52_27 = GUICtrlCreateCombo($ini_codec5, 780, 430, 100, 20)
	GUICtrlSetData($combo_52_27, "DTS", $ini_codec5)
	GUICtrlSetData($combo_52_27, "TrueHD", $ini_codec5)
	GUICtrlSetData($combo_52_27, "AC-3", $ini_codec5)
	GUICtrlSetData($combo_52_27, "AAC", $ini_codec5)
	GUICtrlSetData($combo_52_27, "MP3", $ini_codec5)
	GUICtrlSetData($combo_52_27, "---", $ini_codec5)


	Global $label_52_28 = GUICtrlCreateLabel($lng_subtitle & "- " & $lng_options & ":", 750, 480, 200, 20)
	GUICtrlSetFont(-1, 10, 700, 0, "Verdana")

	Global $check_52_28 = GUICtrlCreateCheckbox($lng_mux_external, 750, 510)

	Global $label_52_31 = GUICtrlCreateLabel($lng_scustomfiletypes & ":", 280, 490, 180, 20)
	GUICtrlSetFont(-1, 10, 700, 0, "Verdana")

	Global $label_52_32 = GUICtrlCreateLabel($lng_oneperline, 280, 515, 180, 20)

	Global $edit_52_31 = GUICtrlCreateEdit($SFT, 280, 540, 180, 60, $ES_MULTILINE + $ES_WANTRETURN + $ES_AUTOVSCROLL + $WS_VSCROLL)

	GUIStartGroup()

	Global $radio_52_01 = GUICtrlCreateRadio(" Software", 520, 280, 150, 20)

	Global $radio_52_02 = GUICtrlCreateRadio(" AMD AMF", 520, 310, 150, 20)

	Global $radio_52_03 = GUICtrlCreateRadio(" Intel Quick Sync", 520, 340, 150, 20)

	Global $radio_52_04 = GUICtrlCreateRadio(" Nvidia Nvenc", 520, 370, 150, 20)

	If $ini_hwcodec = "1" Then GUICtrlSetState($radio_52_01, $GUI_CHECKED)

	If $ini_hwcodec = "2" Then GUICtrlSetState($radio_52_02, $GUI_CHECKED)

	If $ini_hwcodec = "3" Then GUICtrlSetState($radio_52_03, $GUI_CHECKED)

	If $ini_hwcodec = "4" Then GUICtrlSetState($radio_52_04, $GUI_CHECKED)

	If $ini_channelovercodec = "1" Then
		GUICtrlSetState( $check_52_21, $GUI_CHECKED)
	Else
		GUICtrlSetState( $check_52_21, $GUI_UNCHECKED)
	EndIf

	If $ini_zerocode = "1" Then
		GUICtrlSetState($check_52_02, $GUI_CHECKED)
	Else
		GUICtrlSetState($check_52_02, $GUI_UNCHECKED)
	EndIf

	If $ini_transcode_all = "1" Then
		GUICtrlSetState($check_52_03, $GUI_CHECKED)
	Else
		GUICtrlSetState($check_52_03, $GUI_UNCHECKED)
	EndIf

	If $ini_transcode_allaudio = "1" Then
		GUICtrlSetState($check_52_04, $GUI_CHECKED)
	Else
		GUICtrlSetState($check_52_04, $GUI_UNCHECKED)
	EndIf

	If $ini_mux_external = "1" Then
		GUICtrlSetState($check_52_28, $GUI_CHECKED)
	Else
		GUICtrlSetState($check_52_28, $GUI_UNCHECKED)
	EndIf

	Dim $Array_GUI_Elements_52[1]

	_ArrayAdd($Array_GUI_Elements_52, $check_52_02)
	_ArrayAdd($Array_GUI_Elements_52, $check_52_03)
	_ArrayAdd($Array_GUI_Elements_52, $check_52_04)
	_ArrayAdd($Array_GUI_Elements_52, $check_52_21)
	_ArrayAdd($Array_GUI_Elements_52, $check_52_28)

	_ArrayAdd($Array_GUI_Elements_52, $combo_52_05)
	_ArrayAdd($Array_GUI_Elements_52, $combo_52_23)
	_ArrayAdd($Array_GUI_Elements_52, $combo_52_24)
	_ArrayAdd($Array_GUI_Elements_52, $combo_52_25)
	_ArrayAdd($Array_GUI_Elements_52, $combo_52_26)
	_ArrayAdd($Array_GUI_Elements_52, $combo_52_27)

	_ArrayAdd($Array_GUI_Elements_52, $edit_52_01)
	_ArrayAdd($Array_GUI_Elements_52, $edit_52_02)
	_ArrayAdd($Array_GUI_Elements_52, $edit_52_11)
	_ArrayAdd($Array_GUI_Elements_52, $edit_52_31)

	_ArrayAdd($Array_GUI_Elements_52, $label_52_01)
	_ArrayAdd($Array_GUI_Elements_52, $label_52_02)
	_ArrayAdd($Array_GUI_Elements_52, $label_52_03)
	_ArrayAdd($Array_GUI_Elements_52, $label_52_04)
	_ArrayAdd($Array_GUI_Elements_52, $label_52_05)
	_ArrayAdd($Array_GUI_Elements_52, $label_52_11)
	_ArrayAdd($Array_GUI_Elements_52, $label_52_13)
	_ArrayAdd($Array_GUI_Elements_52, $label_52_21)
	_ArrayAdd($Array_GUI_Elements_52, $label_52_23)
	_ArrayAdd($Array_GUI_Elements_52, $label_52_24)
	_ArrayAdd($Array_GUI_Elements_52, $label_52_25)
	_ArrayAdd($Array_GUI_Elements_52, $label_52_26)
	_ArrayAdd($Array_GUI_Elements_52, $label_52_27)
	_ArrayAdd($Array_GUI_Elements_52, $label_52_28)
	_ArrayAdd($Array_GUI_Elements_52, $label_52_12)
	_ArrayAdd($Array_GUI_Elements_52, $label_52_22)
	_ArrayAdd($Array_GUI_Elements_52, $label_52_31)
	_ArrayAdd($Array_GUI_Elements_52, $label_52_32)

	_ArrayAdd($Array_GUI_Elements_52, $radio_52_01)
	_ArrayAdd($Array_GUI_Elements_52, $radio_52_02)
	_ArrayAdd($Array_GUI_Elements_52, $radio_52_03)
	_ArrayAdd($Array_GUI_Elements_52, $radio_52_04)

#EndRegion

#Region ;Generate Metadata Settings GUI (5-3)

	Global $label_53_01 = GUICtrlCreateLabel($lng_config & ":  " & $lng_metadata & " - " & $lng_options, 20, 180, 800, 50)
	GUICtrlSetFont(-1, 20, 700, 0, "Georgia")

	Global $check_53_01 = GUICtrlCreateCheckbox($lng_shouldrename, 20, 247, 200, 25)
	GUICtrlSetFont(-1, 12, 700, 0)

	;Movies Renaming
	Global $label_53_13 = GUICtrlCreateLabel($lng_movies & "- " & $lng_renamingscheme & ":", 20, 280, 350, 20)
	GUICtrlSetFont(-1, 10, 700, 0)

	Global $label_53_14 = GUICtrlCreateLabel($lng_canvariable, 20, 310, 350, 20)

	Global $input_53_14 = GUICtrlCreateInput($json_Rename_Movie, 20, 340, 350, 20)

	;Series Renaming
	Global $label_53_02 = GUICtrlCreateLabel($lng_series & "- " & $lng_renamingscheme & ":", 20, 390, 300, 20)
	GUICtrlSetFont(-1, 10, 700, 0)

	Global $label_53_04 = GUICtrlCreateLabel($lng_canvariable, 20, 410, 450, 20)

	Global $input_53_04 = GUICtrlCreateInput($json_Rename_TvShow, 20, 440, 400, 20)

	Global $check_53_02 = GUICtrlCreateCheckbox($lng_seasonfolder, 20, 470)

	Global $input_53_03 = GUICtrlCreateInput($json_TVShow_FolderSeason, 190, 470, 130, 20)

	Global $check_53_03 = GUICtrlCreateCheckbox($lng_attachspace, 20, 497)

	Global $check_53_04 = GUICtrlCreateCheckbox($lng_empty_nfo, 20, 532)

	Global $input_53_05 = GUICtrlCreateInput($json_TVShow_SeriesIgnoreEpisodeNames, 190, 570, 230, 20)

	Global $label_53_09 = GUICtrlCreateLabel($lng_ignoreepisode, 20, 575, 150, 20)

	;Image Resize
	Global $check_53_20 = GUICtrlCreateCheckbox($lng_imageresize, 480, 247, 200)
	GUICtrlSetFont(-1, 12, 700, 0)

	Global $label_53_21 = GUICtrlCreateLabel("Background:", 480, 280)

	Global $label_53_22 = GUICtrlCreateLabel("Cover/Poster:", 480, 310)

	Global $label_53_23 = GUICtrlCreateLabel("Episode-Thumb:", 480, 340)

	Global $input_53_21 = GUICtrlCreateInput($Image_Resize_Backdrop_Width, 570, 277, 40, 20)

	Global $input_53_22 = GUICtrlCreateInput($Image_Resize_Poster_Width, 570, 307, 40, 20)

	Global $input_53_23 = GUICtrlCreateInput($Image_Resize_Thumb_Width, 570, 337, 40, 20)

	Global $label_53_24 = GUICtrlCreateLabel(" x ", 615, 280, 10)

	Global $label_53_25 = GUICtrlCreateLabel(" x ", 615, 310, 10)

	Global $label_53_26 = GUICtrlCreateLabel(" x ", 615, 340, 10)

	Global $input_53_24 = GUICtrlCreateInput($Image_Resize_Backdrop_Height, 630, 277, 40, 20)

	Global $input_53_25 = GUICtrlCreateInput($Image_Resize_Poster_Height, 630, 307, 40, 20)

	Global $input_53_26 = GUICtrlCreateInput($Image_Resize_Thumb_Height, 630, 337, 40, 20)

	;Ratings
	Global $label_53_40 = GUICtrlCreateLabel($lng_ratings, 720, 250, 200)
	GUICtrlSetFont(-1, 12, 700, 0)


	Global $check_53_34 = GUICtrlCreateCheckbox($lng_removeST, 7200, 367, 500, 20)

	;Movieset Folder
	Global $check_53_32 = GUICtrlCreateCheckbox($lng_moviesetartfolder & " Kodi 19++ / MP2.2++", 480, 400, 500, 20)
	GUICtrlSetFont(-1, 10, 700, 0)


	Global $check_53_33 = GUICtrlCreateCheckbox($lng_kodi19nfo, 480, 532, 500, 20)


	Global $input_53_32 = GUICtrlCreateInput($ini_moviesetfolder, 480, 440, 200, 20)

	Global $label_53_32 = GUICtrlCreateLabel($lng_unc, 480, 480, 300, 50)

	Global $label_53_33 = GUICtrlCreateLabel($lng_kodi19nfo1, 480, 560, 300, 50)

	Global $button_53_32 = GUICtrlCreateButton($lng_search, 715, 437, 60)

	Global $button_53_42 = GUICtrlCreateButton($lng_edit, 890, 307, 60)

	GUIStartGroup()

	Global $radio_53_41 = GUICtrlCreateRadio(" " & $lng_unchanged, 720, 280, 150, 20)

	Global $radio_53_42 = GUICtrlCreateRadio(" " & $lng_individual, 720, 310, 150, 20)

	Global $radio_53_43 = GUICtrlCreateRadio(" " & $lng_german, 720, 340, 150, 20)

	If $ini_ratings = "1" Then GUICtrlSetState($radio_53_41, $GUI_CHECKED)

	If $ini_ratings = "2" Then GUICtrlSetState($radio_53_42, $GUI_CHECKED)

	If $ini_ratings = "3" Then GUICtrlSetState($radio_53_43, $GUI_CHECKED)


	If $json_Rename_RenameFiles = "True" Then
		GUICtrlSetState($check_53_01, $GUI_CHECKED)
	Else
		GUICtrlSetState($check_53_01, $GUI_UNCHECKED)
	EndIf

	If $ini_gen_folder = "1" Then
		GUICtrlSetState($check_53_02, $GUI_CHECKED)
	Else
		GUICtrlSetState($check_53_02, $GUI_UNCHECKED)
	EndIf

	If $ini_space_attach = "1" Then
		GUICtrlSetState($check_53_03, $GUI_CHECKED)
	Else
		GUICtrlSetState($check_53_03, $GUI_UNCHECKED)
	EndIf

	If $json_TVShow_Create_Episode_NFO_On_Missing_Info = "1" Then
		GUICtrlSetState($check_53_04, $GUI_CHECKED)
	Else
		GUICtrlSetState($check_53_04, $GUI_UNCHECKED)
	EndIf

	If $json_Image_Resize = "1" Then
		GUICtrlSetState($check_53_20, $GUI_CHECKED)
	Else
		GUICtrlSetState($check_53_20, $GUI_UNCHECKED)
	EndIf

	If $ini_moviesetfolderuse = "1" Then
		GUICtrlSetState($check_53_32, $GUI_CHECKED)
	Else
		GUICtrlSetState($check_53_32, $GUI_UNCHECKED)
	EndIf

	If $json_Image_Resize = "1" Then
		GUICtrlSetState($check_53_20, $GUI_CHECKED)
	Else
		GUICtrlSetState($check_53_20, $GUI_UNCHECKED)
	EndIf

	If $json_use_uniqueID = "True" Then
		GUICtrlSetState($check_53_33, $GUI_CHECKED)
	Else
		GUICtrlSetState($check_53_33, $GUI_UNCHECKED)
	EndIf

	If $ini_remove_sorttitle = "1" Then
		GUICtrlSetState($check_53_34, $GUI_CHECKED)
	Else
		GUICtrlSetState($check_53_34, $GUI_UNCHECKED)
	EndIf

	Dim $Array_GUI_Elements_53[1]

	_ArrayAdd($Array_GUI_Elements_53, $button_53_32)
	_ArrayAdd($Array_GUI_Elements_53, $button_53_42)

	_ArrayAdd($Array_GUI_Elements_53, $check_53_01)
	_ArrayAdd($Array_GUI_Elements_53, $check_53_02)
	_ArrayAdd($Array_GUI_Elements_53, $check_53_03)
	_ArrayAdd($Array_GUI_Elements_53, $check_53_04)
	_ArrayAdd($Array_GUI_Elements_53, $check_53_20)
	_ArrayAdd($Array_GUI_Elements_53, $check_53_32)
	_ArrayAdd($Array_GUI_Elements_53, $check_53_33)
	_ArrayAdd($Array_GUI_Elements_53, $check_53_34)

	_ArrayAdd($Array_GUI_Elements_53, $input_53_03)
	_ArrayAdd($Array_GUI_Elements_53, $input_53_04)
	_ArrayAdd($Array_GUI_Elements_53, $input_53_05)
	_ArrayAdd($Array_GUI_Elements_53, $input_53_14)
	_ArrayAdd($Array_GUI_Elements_53, $input_53_21)
	_ArrayAdd($Array_GUI_Elements_53, $input_53_22)
	_ArrayAdd($Array_GUI_Elements_53, $input_53_23)
	_ArrayAdd($Array_GUI_Elements_53, $input_53_24)
	_ArrayAdd($Array_GUI_Elements_53, $input_53_25)
	_ArrayAdd($Array_GUI_Elements_53, $input_53_26)
	_ArrayAdd($Array_GUI_Elements_53, $input_53_32)

	_ArrayAdd($Array_GUI_Elements_53, $label_53_01)
	_ArrayAdd($Array_GUI_Elements_53, $label_53_02)
	_ArrayAdd($Array_GUI_Elements_53, $label_53_04)
	_ArrayAdd($Array_GUI_Elements_53, $label_53_09)
	_ArrayAdd($Array_GUI_Elements_53, $label_53_13)
	_ArrayAdd($Array_GUI_Elements_53, $label_53_14)
	_ArrayAdd($Array_GUI_Elements_53, $label_53_21)
	_ArrayAdd($Array_GUI_Elements_53, $label_53_22)
	_ArrayAdd($Array_GUI_Elements_53, $label_53_23)
	_ArrayAdd($Array_GUI_Elements_53, $label_53_24)
	_ArrayAdd($Array_GUI_Elements_53, $label_53_25)
	_ArrayAdd($Array_GUI_Elements_53, $label_53_26)
	_ArrayAdd($Array_GUI_Elements_53, $label_53_32)
	_ArrayAdd($Array_GUI_Elements_53, $label_53_33)
	_ArrayAdd($Array_GUI_Elements_53, $label_53_40)

	_ArrayAdd($Array_GUI_Elements_53, $radio_53_41)
	_ArrayAdd($Array_GUI_Elements_53, $radio_53_42)
	_ArrayAdd($Array_GUI_Elements_53, $radio_53_43)


#EndRegion

#Region ;Generate Filename Settings GUI (5-4)

	Global $label_54_01 = GUICtrlCreateLabel($lng_config & ":  " & $lng_filenames & " - " & $lng_options, 20, 180, 800, 50)
	GUICtrlSetFont(-1, 20, 700, 0, "Georgia")

	Global $label_54_02 = GUICtrlCreateLabel($lng_filenames_nfo, 20, 250, 400, 50)
	GUICtrlSetFont(-1, 12, 700, 0)

	Global $check_54_01 = GUICtrlCreateCheckbox($lng_default & " - Kodi,MediaPortal,NextPVR,...", 20, 300, 400, 25)
	GUICtrlSetFont(-1, 10, 700, 0)

	Global $check_54_02 = GUICtrlCreateCheckbox("Emby", 20, 350, 200, 25)
	GUICtrlSetFont(-1, 10, 700, 0)

	Global $check_54_03 = GUICtrlCreateCheckbox("MediaPortal 1 (My Videos)", 20, 400, 200, 25)
	GUICtrlSetFont(-1, 10, 700, 0)

	If $ini_naming_default = "1" Then
		GUICtrlSetState($check_54_01, $GUI_CHECKED)
	Else
		GUICtrlSetState($check_54_01, $GUI_UNCHECKED)
	EndIf

	If $ini_naming_emby = "1" Then
		GUICtrlSetState($check_54_02, $GUI_CHECKED)
	Else
		GUICtrlSetState($check_54_02, $GUI_UNCHECKED)
	EndIf

	If $ini_naming_mp1 = "1" Then
		GUICtrlSetState($check_54_03, $GUI_CHECKED)
	Else
		GUICtrlSetState($check_54_03, $GUI_UNCHECKED)
	EndIf

	;Video Metadata
	Global $label_54_16 = GUICtrlCreateLabel("{movie} = "  & $lng_video & "- " & $lng_names, 480, 280, 200, 20)
	GUICtrlSetFont(-1, 10, 700, 0)

	Global $label_54_05 = GUICtrlCreateLabel($lng_video & "-Fanart " & $lng_filenames & ":", 480, 250, 200, 20)
	GUICtrlSetFont(-1, 12, 700, 0)

	Global $label_54_07 = GUICtrlCreateLabel("Background:", 480, 310, 100, 20)

	Global $input_54_07 = GUICtrlCreateInput($ini_fanart_background, 480, 330, 130, 20)

	Global $label_54_08 = GUICtrlCreateLabel("Cover/Poster:", 480, 360, 100, 20)

	Global $input_54_08 = GUICtrlCreateInput($ini_fanart_cover, 480, 380, 130, 20)

	Dim $Array_GUI_Elements_54[1]

	_ArrayAdd($Array_GUI_Elements_54, $check_54_01)
	_ArrayAdd($Array_GUI_Elements_54, $check_54_02)
	_ArrayAdd($Array_GUI_Elements_54, $check_54_03)

	_ArrayAdd($Array_GUI_Elements_54, $label_54_01)
	_ArrayAdd($Array_GUI_Elements_54, $label_54_02)
	_ArrayAdd($Array_GUI_Elements_54, $label_54_05)
	_ArrayAdd($Array_GUI_Elements_54, $label_54_07)
	_ArrayAdd($Array_GUI_Elements_54, $label_54_08)
	_ArrayAdd($Array_GUI_Elements_54, $label_54_16)

	_ArrayAdd($Array_GUI_Elements_54, $input_54_07)
	_ArrayAdd($Array_GUI_Elements_54, $input_54_08)


#EndRegion

#Region ;Generate Audio Settings GUI (5-6)

	$AFT = ""

	For $i = 0 To UBound($json_Music_FileExtensions) - 1

		$AFT = $AFT & $json_Music_FileExtensions[$i] & @CRLF

	Next

	Global $label_56_01 = GUICtrlCreateLabel($lng_config & ":  " & $lng_audio & " - " & $lng_options, 20, 180, 800, 30)
	GUICtrlSetFont(-1, 20, 700, 0, "Georgia")

	Global $label_56_03 = GUICtrlCreateLabel($lng_acustomfiletypes & ":", 20, 250, 200, 20)
	GUICtrlSetFont(-1, 10, 700, 0, "Verdana")

	Global $label_56_02 = GUICtrlCreateLabel($lng_oneperline, 20, 275, 200, 20)

	Global $edit_56_03 = GUICtrlCreateEdit($AFT, 20, 300, 200, 210, $ES_MULTILINE + $ES_WANTRETURN + $ES_AUTOVSCROLL + $WS_VSCROLL)

	Global $label_56_04 = GUICtrlCreateLabel("Album Artist / Artist?", 20, 530, 200, 20)
	GUICtrlSetFont(-1, 10, 700, 0, "Verdana")

	Global $label_56_11 = GUICtrlCreateLabel($lng_renamingscheme & " " & $lng_album & ":", 250, 250, 200, 20)
	GUICtrlSetFont(-1, 10, 700, 0, "Verdana")

	Global $input_56_11 = GUICtrlCreateInput($ini_Music_FolderStructure, 250, 280, 230, 20)

	Global $label_56_12 = GUICtrlCreateLabel($lng_renamingscheme & " " & $lng_album & " Multi:", 250, 320, 250, 20)
	GUICtrlSetFont(-1, 10, 700, 0, "Verdana")

	Global $input_56_12 = GUICtrlCreateInput($ini_Music_FolderStructure_MultipleDisc, 250, 350, 230, 20)

	Global $label_56_13 = GUICtrlCreateLabel("Multidisk " & $lng_name & ":", 250, 390, 200, 20)
	GUICtrlSetFont(-1, 10, 700, 0, "Verdana")

	Global $input_56_13 = GUICtrlCreateInput($ini_Music_Renaming_MultiDisc, 250, 420, 230, 20)

	Global $label_56_14 = GUICtrlCreateLabel($lng_renamingscheme & " Track:", 250, 460, 200, 20)
	GUICtrlSetFont(-1, 10, 700, 0, "Verdana")

	Global $input_56_14 = GUICtrlCreateInput($ini_Music_Renaming, 250, 490, 230, 20)

	Global $label_56_15 = GUICtrlCreateLabel("Various Artists:", 250, 530, 200, 20)
	GUICtrlSetFont(-1, 10, 700, 0, "Verdana")

	Global $input_56_15 = GUICtrlCreateInput($ini_Music_Renaming_VariousArtists, 250, 560, 230, 20)

	;Artist Information Folder
	Global $check_56_32 = GUICtrlCreateCheckbox($lng_artistinfofolder & " - Kodi 18++", 530, 250, 450, 20)
	GUICtrlSetFont(-1, 10, 700, 0)

	Global $input_56_32 = GUICtrlCreateInput($json_artist_folder, 530, 280, 280, 20)

	Global $label_56_32 = GUICtrlCreateLabel($lng_unc, 530, 310, 440, 30)

	;Artist Information Folder
	Global $check_56_33 = GUICtrlCreateCheckbox($lng_overwrite, 530, 350, 450, 20)

	Global $label_56_33 = GUICtrlCreateLabel("Various Artists "  & $lng_name, 530, 460, 200, 20)
	GUICtrlSetFont(-1, 10, 700, 0, "Verdana")

	Global $label_56_34 = GUICtrlCreateLabel($lng_oneperline, 530, 485, 200, 20)

	Global $edit_56_33 = GUICtrlCreateEdit(StringStripWS($String_VariousArtists,1), 530, 510, 200, 70, $ES_MULTILINE + $ES_WANTRETURN + $ES_AUTOVSCROLL + $WS_VSCROLL)

	Global $button_56_32 = GUICtrlCreateButton($lng_search, 825, 277, 60)

	If $ini_artistfolderuse = "1" Then
		GUICtrlSetState($check_56_32, $GUI_CHECKED)
	Else
		GUICtrlSetState($check_56_32, $GUI_UNCHECKED)
	EndIf

	If $ini_artistfolderoverwrite = "1" Then
		GUICtrlSetState($check_56_33, $GUI_CHECKED)
	Else
		GUICtrlSetState($check_56_33, $GUI_UNCHECKED)
	EndIf

	GUIStartGroup()

	Global $radio_56_01 = GUICtrlCreateRadio(" Album Artist", 20, 560, 90, 20)

	Global $radio_56_02 = GUICtrlCreateRadio(" Artist", 120, 560, 100, 20)

	If $ini_artist = "1" Then GUICtrlSetState($radio_56_01, $GUI_CHECKED)

	If $ini_artist = "2" Then GUICtrlSetState($radio_56_02, $GUI_CHECKED)



	Dim $Array_GUI_Elements_56[1]

	_ArrayAdd($Array_GUI_Elements_56, $button_56_32)

	_ArrayAdd($Array_GUI_Elements_56, $check_56_32)
	_ArrayAdd($Array_GUI_Elements_56, $check_56_33)

	_ArrayAdd($Array_GUI_Elements_56, $edit_56_03)
	_ArrayAdd($Array_GUI_Elements_56, $edit_56_33)

	_ArrayAdd($Array_GUI_Elements_56, $input_56_11)
	_ArrayAdd($Array_GUI_Elements_56, $input_56_12)
	_ArrayAdd($Array_GUI_Elements_56, $input_56_13)
	_ArrayAdd($Array_GUI_Elements_56, $input_56_14)
	_ArrayAdd($Array_GUI_Elements_56, $input_56_15)
	_ArrayAdd($Array_GUI_Elements_56, $input_56_32)

	_ArrayAdd($Array_GUI_Elements_56, $label_56_01)
	_ArrayAdd($Array_GUI_Elements_56, $label_56_02)
	_ArrayAdd($Array_GUI_Elements_56, $label_56_03)
	_ArrayAdd($Array_GUI_Elements_56, $label_56_04)
	_ArrayAdd($Array_GUI_Elements_56, $label_56_11)
	_ArrayAdd($Array_GUI_Elements_56, $label_56_12)
	_ArrayAdd($Array_GUI_Elements_56, $label_56_13)
	_ArrayAdd($Array_GUI_Elements_56, $label_56_14)
	_ArrayAdd($Array_GUI_Elements_56, $label_56_15)
	_ArrayAdd($Array_GUI_Elements_56, $label_56_32)
	_ArrayAdd($Array_GUI_Elements_56, $label_56_33)
	_ArrayAdd($Array_GUI_Elements_56, $label_56_34)

	_ArrayAdd($Array_GUI_Elements_56, $radio_56_01)
	_ArrayAdd($Array_GUI_Elements_56, $radio_56_02)


#EndRegion

#Region ;Generate Graphics Settings GUI (5-7)

	$GFT = ""

	For $i = 1 To UBound($ArrayGraphics) - 1

		$GFT = $GFT & $ArrayGraphics[$i] & @CRLF

	Next

	$RFT = ""

	For $i = 1 To UBound($ArrayRaw) - 1

		$RFT = $RFT & $ArrayRaw[$i] & @CRLF

	Next

	Global $label_57_01 = GUICtrlCreateLabel($lng_config & ":  " & $lng_graphics & " - " & $lng_options, 20, 180, 800, 30)
	GUICtrlSetFont(-1, 20, 700, 0, "Georgia")

	Global $label_57_02 = GUICtrlCreateLabel($lng_gcustomfiletypes & ":", 20, 250, 200, 20)
	GUICtrlSetFont(-1, 10, 700, 0, "Verdana")

	Global $label_57_03 = GUICtrlCreateLabel($lng_oneperline, 20, 275, 200, 20)

	Global $edit_57_01 = GUICtrlCreateEdit($GFT, 20, 300, 200, 210, $ES_MULTILINE + $ES_WANTRETURN + $ES_AUTOVSCROLL + $WS_VSCROLL)


	Global $label_57_12 = GUICtrlCreateLabel($lng_rcustomfiletypes & ":", 350, 250, 200, 20)
	GUICtrlSetFont(-1, 10, 700, 0, "Verdana")

	Global $label_57_13 = GUICtrlCreateLabel($lng_oneperline, 350, 275, 200, 20)

	Global $edit_57_11 = GUICtrlCreateEdit($RFT, 350, 300, 200, 210, $ES_MULTILINE + $ES_WANTRETURN + $ES_AUTOVSCROLL + $WS_VSCROLL)

	Global $label_57_22 = GUICtrlCreateLabel($lng_options & ":", 650, 250, 200, 20)
	GUICtrlSetFont(-1, 10, 700, 0, "Verdana")

	Global $check_57_21 = GUICtrlCreateCheckbox($lng_moveorg, 650, 300, 350, 20)

	Global $check_57_22 = GUICtrlCreateCheckbox($lng_optorg, 650, 400, 350, 20)

	Global $check_57_23 = GUICtrlCreateCheckbox($lng_rotate, 650, 350, 350, 20)

	If $ini_gfx_moveorg = "1" Then
		GUICtrlSetState($check_57_21, $GUI_CHECKED)
	Else
		GUICtrlSetState($check_57_21, $GUI_UNCHECKED)
	EndIf

	If $ini_gfx_optorg = "1" Then
		GUICtrlSetState($check_57_22, $GUI_CHECKED)
	Else
		GUICtrlSetState($check_57_22, $GUI_UNCHECKED)
	EndIf

	If $ini_gfx_rotate = "1" Then
		GUICtrlSetState($check_57_23, $GUI_CHECKED)
	Else
		GUICtrlSetState($check_57_23, $GUI_UNCHECKED)
	EndIf


	Dim $Array_GUI_Elements_57[1]

	_ArrayAdd($Array_GUI_Elements_57, $check_57_21)
	_ArrayAdd($Array_GUI_Elements_57, $check_57_22)
	_ArrayAdd($Array_GUI_Elements_57, $check_57_23)

	_ArrayAdd($Array_GUI_Elements_57, $label_57_01)
	_ArrayAdd($Array_GUI_Elements_57, $label_57_02)
	_ArrayAdd($Array_GUI_Elements_57, $label_57_03)
	_ArrayAdd($Array_GUI_Elements_57, $label_57_12)
	_ArrayAdd($Array_GUI_Elements_57, $label_57_13)
	_ArrayAdd($Array_GUI_Elements_57, $label_57_22)


	_ArrayAdd($Array_GUI_Elements_57, $edit_57_01)
	_ArrayAdd($Array_GUI_Elements_57, $edit_57_11)

#EndRegion

#Region ;Generate Settings GUI (5)

	Global $Select_Button_51 = GUICtrlCreateButton($lng_program & "- " & $lng_options, 2, 140, 150, 25)

	Global $Select_Button_52 = GUICtrlCreateButton($lng_video & "- " & $lng_options, 152, 140, 150, 25)

	Global $Select_Button_53 = GUICtrlCreateButton($lng_metadata & "- " & $lng_options , 302, 140, 150, 25)

	Global $Select_Button_54 = GUICtrlCreateButton($lng_filenames & "- " & $lng_options , 452, 140, 150, 25)

	Global $Select_Button_56 = GUICtrlCreateButton($lng_audio & "- " & $lng_options, 602, 140, 150, 25)

	Global $Select_Button_57 = GUICtrlCreateButton($lng_graphics & "- " & $lng_options, 752, 140, 150, 25)

	Global $Select_Pic_51 = GUICtrlCreatePic (@ScriptDir & "\Images\Line_2.jpg", 751, 135, 151, 10)

	Global $Select_Label_51 = GUICtrlCreateLabel("", 751, 111, 152, 29, $SS_ETCHEDFRAME)

	Global $Select_Label_52 = GUICtrlCreateLabel("", 1, 137, 998, 494, $SS_ETCHEDFRAME)

	Dim $Array_GUI_Elements_05[1]

	_ArrayAdd($Array_GUI_Elements_05, $Button_51)

	_ArrayAdd($Array_GUI_Elements_05, $Select_Button_51)
	_ArrayAdd($Array_GUI_Elements_05, $Select_Button_52)
	_ArrayAdd($Array_GUI_Elements_05, $Select_Button_53)
	_ArrayAdd($Array_GUI_Elements_05, $Select_Button_54)
	_ArrayAdd($Array_GUI_Elements_05, $Select_Button_56)
	_ArrayAdd($Array_GUI_Elements_05, $Select_Button_57)

	_ArrayAdd($Array_GUI_Elements_05, $Select_Label_51)
	_ArrayAdd($Array_GUI_Elements_05, $Select_Label_52)

	_ArrayAdd($Array_GUI_Elements_05, $Select_Pic_51)

#EndRegion

#Region ;Generate Series Metadata Correction GUI (6-1)

	Global $label_61_00 = GUICtrlCreateLabel($lng_series & " - " & $lng_metadata_correction, 20, 180, 700, 50)
	GUICtrlSetFont(-1, 20, 700, 0, "Georgia")

	Global $button_61_01 = GUICtrlCreateButton($lng_search, 460, 267, 60)

	Global $label_61_01 = GUICtrlCreateLabel($lng_inputfoldertext, 50, 250, 400, 20)

	Global $input_61_01 = GUICtrlCreateInput($ini_series_correction_inputfolder, 50, 270, 400, 20)

	Global $button_61_00 = GUICtrlCreateButton($lng_start, 900, 353, 90)
	GUICtrlSetState(-1, $GUI_deFBUTTON)

	Global $button_61_02 = GUICtrlCreateButton("Update .nfo", 50, 353, 90)

	Global $button_61_04 = GUICtrlCreateButton($lng_delorg, 870, 253, 120)

	Global $label_61_25 = GUICtrlCreateLabel($lng_conversiontext3, 735, 180, 250, 70, $SS_RIGHT)

	Dim $Array_GUI_Elements_61[1]

	_ArrayAdd($Array_GUI_Elements_61, $button_61_00)
	_ArrayAdd($Array_GUI_Elements_61, $button_61_01)
	_ArrayAdd($Array_GUI_Elements_61, $button_61_02)
	_ArrayAdd($Array_GUI_Elements_61, $button_61_04)

	_ArrayAdd($Array_GUI_Elements_61, $input_61_01)

	_ArrayAdd($Array_GUI_Elements_61, $label_61_00)
	_ArrayAdd($Array_GUI_Elements_61, $label_61_01)
	_ArrayAdd($Array_GUI_Elements_61, $label_61_25)

#EndRegion

#Region ;Generate Movies Metadata Correction GUI (6-2)

	Global $label_62_00 = GUICtrlCreateLabel($lng_movies & " - " & $lng_metadata_correction, 20, 180, 700, 50)
	GUICtrlSetFont(-1, 20, 700, 0, "Georgia")

	Global $button_62_01 = GUICtrlCreateButton($lng_search, 460, 267, 60)

	Global $label_62_01 = GUICtrlCreateLabel($lng_inputfoldertext, 50, 250, 400, 20)

	Global $input_62_01 = GUICtrlCreateInput($ini_movies_correction_inputfolder, 50, 270, 400, 20)

	Global $button_62_00 = GUICtrlCreateButton($lng_start, 900, 353, 90)
	GUICtrlSetState(-1, $GUI_deFBUTTON)

	Global $button_62_04 = GUICtrlCreateButton($lng_delorg, 870, 253, 120)

	Global $label_62_25 = GUICtrlCreateLabel($lng_conversiontext3, 735, 180, 250, 70, $SS_RIGHT)

;~ 	Global $check_62_01 = GUICtrlCreateCheckbox("Pfade korrigieren?", 650, 300, 350, 20)

	Dim $Array_GUI_Elements_62[1]

	_ArrayAdd($Array_GUI_Elements_62, $button_62_00)
	_ArrayAdd($Array_GUI_Elements_62, $button_62_01)
	_ArrayAdd($Array_GUI_Elements_62, $button_62_04)

;~ 	_ArrayAdd($Array_GUI_Elements_62, $check_62_01)

	_ArrayAdd($Array_GUI_Elements_62, $input_62_01)

	_ArrayAdd($Array_GUI_Elements_62, $label_62_00)
	_ArrayAdd($Array_GUI_Elements_62, $label_62_01)
	_ArrayAdd($Array_GUI_Elements_62, $label_62_25)

#EndRegion

#Region ;Generate Videos Metadata Correction GUI (6-3)

	Global $label_63_00 = GUICtrlCreateLabel($lng_videos & " - " & $lng_metadata_correction, 20, 180, 700, 50)
	GUICtrlSetFont(-1, 20, 700, 0, "Georgia")

	Global $button_63_01 = GUICtrlCreateButton($lng_search, 460, 267, 60)

	Global $label_63_01 = GUICtrlCreateLabel($lng_inputfoldertext, 50, 250, 400, 20)

	Global $input_63_01 = GUICtrlCreateInput($ini_videos_correction_inputfolder, 50, 270, 400, 20)

	Global $button_63_00 = GUICtrlCreateButton($lng_start, 900, 353, 90)
	GUICtrlSetState(-1, $GUI_deFBUTTON)

	Global $button_63_04 = GUICtrlCreateButton($lng_delorg, 870, 253, 120)

	Global $label_63_25 = GUICtrlCreateLabel($lng_conversiontext3, 735, 180, 250, 70, $SS_RIGHT)

	Dim $Array_GUI_Elements_63[1]

	_ArrayAdd($Array_GUI_Elements_63, $button_63_00)
	_ArrayAdd($Array_GUI_Elements_63, $button_63_01)
	_ArrayAdd($Array_GUI_Elements_63, $button_63_04)

	_ArrayAdd($Array_GUI_Elements_63, $input_63_01)

	_ArrayAdd($Array_GUI_Elements_63, $label_63_00)
	_ArrayAdd($Array_GUI_Elements_63, $label_63_01)
	_ArrayAdd($Array_GUI_Elements_63, $label_63_25)

#EndRegion

#Region ;Generate Audio Metadata Correction GUI (6-4)

	Global $label_64_00 = GUICtrlCreateLabel($lng_audio & " - " & $lng_metadata_correction, 20, 180, 700, 50)
	GUICtrlSetFont(-1, 20, 700, 0, "Georgia")

	Global $button_64_01 = GUICtrlCreateButton($lng_search, 460, 267, 60)

	Global $label_64_01 = GUICtrlCreateLabel($lng_inputfoldertext, 50, 250, 400, 20)

	Global $input_64_01 = GUICtrlCreateInput($ini_audio_correction_inputfolder, 50, 270, 400, 20)

	Global $button_64_00 = GUICtrlCreateButton($lng_start, 900, 353, 90)
	GUICtrlSetState(-1, $GUI_deFBUTTON)

	Global $button_64_04 = GUICtrlCreateButton($lng_delorg, 870, 253, 120)

	Global $label_64_02 = GUICtrlCreateLabel($lng_conversiontext3, 735, 180, 250, 70, $SS_RIGHT)

	Dim $Array_GUI_Elements_64[1]

	_ArrayAdd($Array_GUI_Elements_64, $button_64_00)
	_ArrayAdd($Array_GUI_Elements_64, $button_64_01)
	_ArrayAdd($Array_GUI_Elements_64, $button_64_04)

	_ArrayAdd($Array_GUI_Elements_64, $input_64_01)

	_ArrayAdd($Array_GUI_Elements_64, $label_64_00)
	_ArrayAdd($Array_GUI_Elements_64, $label_64_01)
	_ArrayAdd($Array_GUI_Elements_64, $label_64_02)

#EndRegion

#Region ;Generate Metadata Correction GUI (6)

	Global $label_06_00 = GUICtrlCreateLabel($lng_metadata & " - " & $lng_metadata_correction, 20, 180, 600, 50)
	GUICtrlSetFont(-1, 20, 700, 0, "Georgia")

	Global $Select_Button_61 = GUICtrlCreateButton($lng_series, 2, 140, 150, 25)

	Global $Select_Button_62 = GUICtrlCreateButton($lng_movies, 152, 140, 150, 25)

	Global $Select_Button_63 = GUICtrlCreateButton($lng_videos, 302, 140, 150, 25)

	Global $Select_Button_64 = GUICtrlCreateButton($lng_audio, 452, 140, 150, 25)

	Global $Pic_06_01 = GUICtrlCreatePic (@ScriptDir & "\Images\Line_1.jpg", 1, 389, 996, 2)

	Global $Pic_06_02 = GUICtrlCreatePic (@ScriptDir & "\Images\Line_2.jpg", 451, 135, 151, 10)

	Global $label_06_01 = GUICtrlCreateLabel("", 451, 111, 152, 29, $SS_ETCHEDFRAME)

	Global $label_06_02 = GUICtrlCreateLabel("", 1, 137, 998, 494, $SS_ETCHEDFRAME)

	Dim $Array_GUI_Elements_06[1]

	_ArrayAdd($Array_GUI_Elements_06, $label_06_00)
	_ArrayAdd($Array_GUI_Elements_06, $label_06_01)
	_ArrayAdd($Array_GUI_Elements_06, $label_06_02)

	_ArrayAdd($Array_GUI_Elements_06, $pic_06_01)
	_ArrayAdd($Array_GUI_Elements_06, $pic_06_02)

	_ArrayAdd($Array_GUI_Elements_06, $Select_Button_61)
	_ArrayAdd($Array_GUI_Elements_06, $Select_Button_62)
	_ArrayAdd($Array_GUI_Elements_06, $Select_Button_63)
	_ArrayAdd($Array_GUI_Elements_06, $Select_Button_64)


#EndRegion

#EndRegion ;Generate Main Window

#Region ;Afterwork Window

#Region ;Generate Afterwork Header And Footer (190)

	$style = $WS_SYSMENU + $WS_CAPTION + $WS_MAXIMIZEBOX + $WS_MINIMIZEBOX + $WS_EX_ACCEPTFILES + $WS_SIZEBOX + $BS_PUSHLIKE

	Global $Afterworkwindow = GUICreate($Title, 1000, 680, -1, -1, $style, $WS_EX_COMPOSITED)
	GUISetState(@SW_HIde, $Afterworkwindow)

	GUISetBkColor("0xffffff")


	Global $Pic191 = GUICtrlCreatePic (@ScriptDir & "\Images\Media-Buddy_Header.jpg", 0, 0, 999, 111)

	Global $Pic192 = GUICtrlCreatePic (@ScriptDir & "\Images\Blue.jpg", 0, 0, 998, 111)

	Global $Pic193 = GUICtrlCreatePic (@ScriptDir & "\Images\Line_1.jpg", 0, 111, 1000, 1)

	Global $Label191 = GUICtrlCreateLabel($Title, 1, 632, 999, 28, $SS_ETCHEDFRAME)

	Global $Label192 = GUICtrlCreateLabel($lng_waiting, 10, 639, 900, 18)

	Global $Label193 = GUICtrlCreateLabel($Clock, 935, 639, 50, 18, $SS_RIGHT)

	Dim $Array_GUI_Elements_190[1]

	_ArrayAdd($Array_GUI_Elements_190, $Label191)
	_ArrayAdd($Array_GUI_Elements_190, $Label192)
	_ArrayAdd($Array_GUI_Elements_190, $Label193)

	_ArrayAdd($Array_GUI_Elements_190, $Pic191)
	_ArrayAdd($Array_GUI_Elements_190, $Pic192)
	_ArrayAdd($Array_GUI_Elements_190, $Pic193)

#EndRegion

#Region ;Generate Afterwork Main Menu

	Global $Filemenu100 = GUICtrlCreateMenu($lng_files)
	Global $Exititem100 = GUICtrlCreateMenuItem($lng_exit, $Filemenu100)

#EndRegion

#Region ;Generate Afterwork Help Menu

	Global $Helpmenu100 = GUICtrlCreateMenu("?")
	Global $Infoitem100 = GUICtrlCreateMenuItem($lng_about, $Helpmenu100)
	Global $Docitem100 = GUICtrlCreateMenuItem($lng_manual, $Helpmenu100)

#EndRegion

#Region ;Generate Afterwork Series GUI (100)

	Global $Label_100_00 = GUICtrlCreateLabel($lng_metadata_correction & ":", 20, 120, 350, 30)
	GUICtrlSetFont(-1, 20, 700, 0, "Georgia")

	Global $Label_100_01 = GUICtrlCreateLabel($lng_series, 20, 160, 350, 30)
	GUICtrlSetFont(-1, 20, 700, 0, "Georgia")

	Global $listview_100_01 = GUICtrlCreateList("", 20, 230, 260, 400, $LBS_DISABLENOSCROLL + $WS_BORdeR + $WS_VSCROLL, $ES_READONLY)

	Global $Label_100_02 = GUICtrlCreateLabel($lng_title, 300, 230, 250, 20)

	Global $input_100_01 = GUICtrlCreateInput("", 300, 250, 250, 20)

	Global $Label_100_05a = GUICtrlCreateLabel("TVDB-ID", 300, 280, 70, 20)

	Global $Label_100_05b = GUICtrlCreateLabel("TMDB-ID", 390, 280, 70, 20)

	Global $Label_100_05c = GUICtrlCreateLabel("IMDB-ID", 480, 280, 70, 20)

	Global $input_100_05 = GUICtrlCreateInput("", 300, 300, 70, 20)

	Global $input_100_05a = GUICtrlCreateInput("", 390, 300, 70, 20)

	Global $input_100_05b = GUICtrlCreateInput("", 480, 300, 70, 20)

	Global $Label_100_03 = GUICtrlCreateLabel($lng_sorttitle, 300, 480, 100, 20)

	Global $input_100_02 = GUICtrlCreateInput("", 300, 500, 125, 20)

	Global $Label_100_04 = GUICtrlCreateLabel($lng_genre, 300, 430, 125, 20)

	Global $input_100_03 = GUICtrlCreateInput("", 300, 450, 125, 20)

	Global $Label_100_05 = GUICtrlCreateLabel($lng_mpaa, 480, 380, 70, 20)

	Global $input_100_04 = GUICtrlCreateInput("", 480, 400, 70, 20)

	Global $Label_100_16 = GUICtrlCreateLabel($lng_year, 300, 380, 70, 20)

	Global $input_100_16 = GUICtrlCreateInput("", 300, 400, 70, 20)

	Global $Label_100_17 = GUICtrlCreateLabel($lng_status, 450, 480, 100, 20)

	Global $input_100_17 = GUICtrlCreateInput("", 450, 500, 100, 20)

	Global $Label_100_18 = GUICtrlCreateLabel($lng_rating, 390, 380, 70, 20)

	Global $input_100_18 = GUICtrlCreateInput("", 390, 400, 70, 20)

	Global $Label_100_20 = GUICtrlCreateLabel($lng_ownid & " " & $lng_type, 300, 330, 125, 20)

	Global $input_100_20 = GUICtrlCreateInput("", 300, 350, 125, 20)

	Global $Label_100_21 = GUICtrlCreateLabel($lng_ownid & " " & $lng_value, 450, 330, 100, 20)

	Global $input_100_21 = GUICtrlCreateInput("", 450, 350, 100, 20)

	Global $Label_100_19 = GUICtrlCreateLabel($lng_studio, 450, 430, 100, 20)

	Global $input_100_19 = GUICtrlCreateInput("", 450, 450, 100, 20)

	Global $Label_100_06 = GUICtrlCreateLabel($lng_plot, 300, 530, 250, 20)

	Global $edit_100_04 = GUICtrlCreateEdit("", 300, 550, 250, 70, $ES_MULTILINE + $ES_WANTRETURN + $ES_AUTOVSCROLL + $WS_VSCROLL)

	Global $Pic_100_01 = GUICtrlCreatePic (@ScriptDir & "\Images\img_banner.jpg", 450, 120, 540, 100)

	Global $Label_100_07 = GUICtrlCreateLabel("Poster:", 840, 230, 150, 20)

	Global $Pic_100_02 = GUICtrlCreatePic (@ScriptDir & "\Images\img_poster.jpg", 840, 250, 150, 230)

	Global $Label_100_08 = GUICtrlCreateLabel("Fanart:", 570, 230, 150, 20)

	Global $Pic_100_03 = GUICtrlCreatePic (@ScriptDir & "\Images\img_background.jpg", 570, 250, 250, 140)

	Global $Label_100_09 = GUICtrlCreateLabel("Clearart:", 570, 430, 150, 20)

	Global $Pic_100_04 = GUICtrlCreatePic(_Display_PNG(@ScriptDir & "\Images\img_clearart.png"), 567, 450, 200, 125)

	Global $Label_100_10 = GUICtrlCreateLabel("Logo:", 790, 470, 50, 20)

	Global $Pic_100_05 = GUICtrlCreatePic(_Display_PNG(@ScriptDir & "\Images\img_clearart.png"), 790, 493, 200, 95)

	Global $button_100_00 = GUICtrlCreateButton($lng_tagnew, 740, 595, 120)
	GUICtrlSetState(-1, $GUI_deFBUTTON)

	Global $button_100_01 = GUICtrlCreateButton($lng_editepisodes, 565, 595, 120)

	Global $button_100_02 = GUICtrlCreateButton($lng_back, 870, 595, 120)

	Dim $Array_GUI_Elements_100[1]

	_ArrayAdd($Array_GUI_Elements_100, $button_100_00)
	_ArrayAdd($Array_GUI_Elements_100, $button_100_01)
	_ArrayAdd($Array_GUI_Elements_100, $button_100_02)

	_ArrayAdd($Array_GUI_Elements_100, $edit_100_04)

	_ArrayAdd($Array_GUI_Elements_100, $input_100_01)
	_ArrayAdd($Array_GUI_Elements_100, $input_100_02)
	_ArrayAdd($Array_GUI_Elements_100, $input_100_03)
	_ArrayAdd($Array_GUI_Elements_100, $input_100_04)
	_ArrayAdd($Array_GUI_Elements_100, $input_100_05)
	_ArrayAdd($Array_GUI_Elements_100, $input_100_05a)
	_ArrayAdd($Array_GUI_Elements_100, $input_100_05b)
	_ArrayAdd($Array_GUI_Elements_100, $input_100_16)
	_ArrayAdd($Array_GUI_Elements_100, $input_100_17)
	_ArrayAdd($Array_GUI_Elements_100, $input_100_18)
	_ArrayAdd($Array_GUI_Elements_100, $input_100_19)
	_ArrayAdd($Array_GUI_Elements_100, $input_100_20)
	_ArrayAdd($Array_GUI_Elements_100, $input_100_21)

	_ArrayAdd($Array_GUI_Elements_100, $Label_100_00)
	_ArrayAdd($Array_GUI_Elements_100, $Label_100_01)
	_ArrayAdd($Array_GUI_Elements_100, $Label_100_02)
	_ArrayAdd($Array_GUI_Elements_100, $Label_100_03)
	_ArrayAdd($Array_GUI_Elements_100, $Label_100_04)
	_ArrayAdd($Array_GUI_Elements_100, $Label_100_05)
	_ArrayAdd($Array_GUI_Elements_100, $Label_100_05a)
	_ArrayAdd($Array_GUI_Elements_100, $Label_100_05b)
	_ArrayAdd($Array_GUI_Elements_100, $Label_100_05c)
	_ArrayAdd($Array_GUI_Elements_100, $Label_100_06)
	_ArrayAdd($Array_GUI_Elements_100, $Label_100_07)
	_ArrayAdd($Array_GUI_Elements_100, $Label_100_08)
	_ArrayAdd($Array_GUI_Elements_100, $Label_100_09)
	_ArrayAdd($Array_GUI_Elements_100, $Label_100_10)
	_ArrayAdd($Array_GUI_Elements_100, $Label_100_16)
	_ArrayAdd($Array_GUI_Elements_100, $Label_100_17)
	_ArrayAdd($Array_GUI_Elements_100, $Label_100_18)
	_ArrayAdd($Array_GUI_Elements_100, $Label_100_19)
	_ArrayAdd($Array_GUI_Elements_100, $Label_100_20)
	_ArrayAdd($Array_GUI_Elements_100, $Label_100_21)

	_ArrayAdd($Array_GUI_Elements_100, $listview_100_01)

	_ArrayAdd($Array_GUI_Elements_100, $Pic_100_01)
	_ArrayAdd($Array_GUI_Elements_100, $Pic_100_02)
	_ArrayAdd($Array_GUI_Elements_100, $Pic_100_03)
	_ArrayAdd($Array_GUI_Elements_100, $Pic_100_04)
	_ArrayAdd($Array_GUI_Elements_100, $Pic_100_05)

#EndRegion

#Region ;Generate Afterwork Episodes GUI (110)

	Global $Label_110_00 = GUICtrlCreateLabel($lng_metadata_correction & ":", 20, 120, 350, 30)
	GUICtrlSetFont(-1, 20, 700, 0, "Georgia")

	Global $Label_110_00a = GUICtrlCreateLabel($lng_episodes, 20, 160, 350, 30)
	GUICtrlSetFont(-1, 20, 700, 0, "Georgia")

	Global $listview_110_01 = GUICtrlCreateList("", 20, 230, 260, 380, $LBS_DISABLENOSCROLL + $WS_BORdeR + $WS_VSCROLL, $ES_READONLY)

	Global $Label_110_01 = GUICtrlCreateLabel($lng_title, 300, 230, 250, 20)

	Global $input_110_01 = GUICtrlCreateInput("", 300, 250, 250, 20)

	Global $Label_110_05 = GUICtrlCreateLabel($lng_showtitle, 300, 280, 250, 20)

	Global $input_110_05 = GUICtrlCreateInput("", 300, 300, 250, 20)

	Global $Label_110_04a = GUICtrlCreateLabel($lng_season, 300, 330, 100, 20)

	Global $input_110_04 = GUICtrlCreateInput("", 300, 350, 100, 20)

	Global $Label_110_04b = GUICtrlCreateLabel($lng_episode, 450, 330, 100, 20)

	Global $input_110_04a = GUICtrlCreateInput("", 450, 350, 100, 20)

	Global $Label_110_06 = GUICtrlCreateLabel($lng_year, 300, 380, 250, 20)

	Global $input_110_06 = GUICtrlCreateInput("", 300, 400, 250, 20)

	Global $Label_110_04 = GUICtrlCreateLabel($lng_plot, 570, 230, 100, 20)

	Global $edit_110_04 = GUICtrlCreateEdit("", 570, 250, 180, 330, $ES_MULTILINE + $ES_WANTRETURN + $ES_AUTOVSCROLL + $WS_VSCROLL)

	Global $Pic_110_01 = GUICtrlCreatePic (@ScriptDir & "\Images\img_banner.jpg", 450, 120, 540, 100)

	Global $Label_110_15 = GUICtrlCreateLabel($lng_seasonposter & ":", 760, 230, 150, 20)

	Global $Pic_110_02 = GUICtrlCreatePic (@ScriptDir & "\Images\img_poster.jpg", 760, 250, 230, 330)

	Global $Label_110_16 = GUICtrlCreateLabel($lng_thumb & ":", 300, 450, 150, 20)

	Global $Pic_110_03 = GUICtrlCreatePic (@ScriptDir & "\Images\img_background.jpg", 300, 470, 250, 140)

	Global $button_110_01 = GUICtrlCreateButton($lng_play, 715, 585, 120)

	Global $button_110_02 = GUICtrlCreateButton($lng_makethumb, 565, 585, 120)

	Global $button_110_00 = GUICtrlCreateButton($lng_back, 870, 585, 120)
	GUICtrlSetState(-1, $GUI_deFBUTTON)

	Dim $Array_GUI_Elements_110[1]

	_ArrayAdd($Array_GUI_Elements_110, $button_110_00)
	_ArrayAdd($Array_GUI_Elements_110, $button_110_01)
	_ArrayAdd($Array_GUI_Elements_110, $button_110_02)

	_ArrayAdd($Array_GUI_Elements_110, $edit_110_04)

	_ArrayAdd($Array_GUI_Elements_110, $input_110_01)
	_ArrayAdd($Array_GUI_Elements_110, $input_110_04)
	_ArrayAdd($Array_GUI_Elements_110, $input_110_04a)
	_ArrayAdd($Array_GUI_Elements_110, $input_110_04)
	_ArrayAdd($Array_GUI_Elements_110, $input_110_05)
	_ArrayAdd($Array_GUI_Elements_110, $input_110_06)

	_ArrayAdd($Array_GUI_Elements_110, $Label_110_00)
	_ArrayAdd($Array_GUI_Elements_110, $Label_110_00a)
	_ArrayAdd($Array_GUI_Elements_110, $Label_110_01)
	_ArrayAdd($Array_GUI_Elements_110, $Label_110_04)
	_ArrayAdd($Array_GUI_Elements_110, $Label_110_04a)
	_ArrayAdd($Array_GUI_Elements_110, $Label_110_04b)
	_ArrayAdd($Array_GUI_Elements_110, $Label_110_05)
	_ArrayAdd($Array_GUI_Elements_110, $Label_110_06)
	_ArrayAdd($Array_GUI_Elements_110, $Label_110_15)
	_ArrayAdd($Array_GUI_Elements_110, $Label_110_16)

	_ArrayAdd($Array_GUI_Elements_110, $listview_110_01)

	_ArrayAdd($Array_GUI_Elements_110, $Pic_110_01)
	_ArrayAdd($Array_GUI_Elements_110, $Pic_110_02)
	_ArrayAdd($Array_GUI_Elements_110, $Pic_110_03)

#EndRegion

#Region ;Generate Afterwork Movies GUI (120)

	Global $Label_120_00 = GUICtrlCreateLabel($lng_metadata_correction & ":", 20, 120, 250, 30)
	GUICtrlSetFont(-1, 20, 700, 0, "Georgia")

	Global $Label_120_00a = GUICtrlCreateLabel($lng_movies, 20, 160, 250, 30)
	GUICtrlSetFont(-1, 20, 700, 0, "Georgia")

	Global $Label_120_00b = GUICtrlCreateLabel($lng_metadata, 740, 500, 250, 20, $SS_CENTER)
	GUICtrlSetFont(-1, 12, 700, 0, "Georgia")

	Global $listview_120_01 = GUICtrlCreateList("", 20, 230, 260, 380, $LBS_DISABLENOSCROLL + $WS_BORdeR + $WS_VSCROLL, $ES_READONLY)

	Global $Pic_120_00 = GUICtrlCreatePic (@ScriptDir & "\Images\img_poster.jpg", 740, 120, 250, 360)

	Global $button_120_01 = GUICtrlCreateButton($lng_metadata, 740, 530, 80)

	Global $button_120_02 = GUICtrlCreateButton("Fanart", 825, 530, 80)

	Global $button_120_03 = GUICtrlCreateButton($lng_movieset, 910, 530, 80)

	Global $button_120_04 = GUICtrlCreateButton($lng_tagnew, 740, 585, 80)
	GUICtrlSetState(-1, $GUI_deFBUTTON)

	Global $button_120_06 = GUICtrlCreateButton($lng_play, 825, 585, 80)

	Global $button_120_05 = GUICtrlCreateButton($lng_back, 910, 585, 80)

; Metadata Area

	Global $Label_120_01 = GUICtrlCreateLabel($lng_title, 300, 130, 250, 20)

	Global $input_120_01 = GUICtrlCreateInput("", 300, 150, 250, 20)

	Global $Label_120_02 = GUICtrlCreateLabel($lng_sorttitle, 300, 180, 250, 20)

	Global $input_120_02 = GUICtrlCreateInput("", 300, 200, 250, 20)

	Global $Label_120_03 = GUICtrlCreateLabel($lng_title_original, 300, 230, 250, 20)

	Global $input_120_03 = GUICtrlCreateInput("", 300, 250, 250, 20)

	Global $Label_120_04 = GUICtrlCreateLabel($lng_tagline, 300, 280, 250, 20)

	Global $input_120_04 = GUICtrlCreateInput("", 300, 300, 250, 20)

	Global $Label_120_05 = GUICtrlCreateLabel($lng_movieset, 300, 330, 250, 20)

	Global $input_120_05 = GUICtrlCreateInput("", 300, 350, 250, 20)

	Global $Label_120_06 = GUICtrlCreateLabel($lng_genre, 300, 380, 250, 20)

	Global $input_120_06 = GUICtrlCreateInput("", 300, 400, 250, 20)

	Global $Label_120_07 = GUICtrlCreateLabel($lng_studio, 300, 430, 250, 20)

	Global $input_120_07 = GUICtrlCreateInput("", 300, 450, 250, 20)

	Global $Label_120_08 = GUICtrlCreateLabel($lng_plot, 300, 480, 250, 20)

	Global $edit_120_08 = GUICtrlCreateEdit("", 300, 500, 425, 110, $ES_MULTILINE + $ES_WANTRETURN + $ES_AUTOVSCROLL + $WS_VSCROLL)

	Global $Label_120_11 = GUICtrlCreateLabel("IMDB-ID", 565, 130, 160, 20)

	Global $input_120_11 = GUICtrlCreateInput("", 565, 150, 160, 20)

	Global $Label_120_12 = GUICtrlCreateLabel("TMDB-ID", 565, 180, 160, 20)

	Global $input_120_12 = GUICtrlCreateInput("", 565, 200, 160, 20)

	Global $Label_120_13 = GUICtrlCreateLabel($lng_mpaa, 565, 230, 160, 20)

	Global $input_120_13 = GUICtrlCreateInput("", 565, 250, 160, 20)

	Global $Label_120_14 = GUICtrlCreateLabel($lng_country, 565, 280, 160, 20)

	Global $input_120_14 = GUICtrlCreateInput("", 565, 300, 160, 20)

	Global $Label_120_15 = GUICtrlCreateLabel($lng_year, 565, 330, 160, 20)

	Global $input_120_15 = GUICtrlCreateInput("", 565, 350, 160, 20)

	Global $Label_120_16 = GUICtrlCreateLabel($lng_rating, 565, 380, 160, 20)

	Global $input_120_16 = GUICtrlCreateInput("", 565, 400, 160, 20)

	Global $Label_120_17 = GUICtrlCreateLabel($lng_status, 565, 430, 160, 20)

	Global $input_120_17 = GUICtrlCreateInput("", 565, 450, 160, 20)

; Movieset Fanart Area

	Global $Pic_120_30 = GUICtrlCreatePic (@ScriptDir & "\Images\img_poster.jpg", 740, 120, 250, 360)

	Global $Label_120_31 = GUICtrlCreateLabel("Banner:", 290, 120, 150, 20)

	Global $Pic_120_31 = GUICtrlCreatePic (@ScriptDir & "\Images\img_banner.jpg", 290, 140, 440, 80)

	Global $Label_120_32 = GUICtrlCreateLabel("Fanart:", 290, 230, 150, 20)

	Global $Pic_120_32 = GUICtrlCreatePic (@ScriptDir & "\Images\img_background.jpg", 290, 250, 280, 160)

	Global $Label_120_34 = GUICtrlCreateLabel("Clearart:", 580, 230, 150, 20)

	Global $Pic_120_34 = GUICtrlCreatePic(_Display_PNG(@ScriptDir & "\Images\img_clearart.png"), 580, 250, 150, 70)

	Global $Label_120_35 = GUICtrlCreateLabel("Clearlogo:", 580, 325, 150, 20)

	Global $Pic_120_35 = GUICtrlCreatePic(_Display_PNG(@ScriptDir & "\Images\img_clearart.png"), 580, 340, 150, 70)

	Global $Label_120_36 = GUICtrlCreateLabel("Thumb/Landscape:", 290, 430, 93, 20)

	Global $Pic_120_36 = GUICtrlCreatePic (@ScriptDir & "\Images\img_background.jpg", 290, 450, 280, 160)

; Fanart Area

	Global $Pic_120_20 = GUICtrlCreatePic (@ScriptDir & "\Images\img_poster.jpg", 740, 120, 250, 360)

	Global $Label_120_21 = GUICtrlCreateLabel("Banner:", 290, 120, 150, 20)

	Global $Pic_120_21 = GUICtrlCreatePic (@ScriptDir & "\Images\img_banner.jpg", 290, 140, 440, 80)

	Global $Label_120_22 = GUICtrlCreateLabel("Fanart:", 290, 230, 150, 20)

	Global $Pic_120_22 = GUICtrlCreatePic (@ScriptDir & "\Images\img_background.jpg", 290, 250, 280, 160)

	Global $Label_120_23 = GUICtrlCreateLabel("Disc:", 580, 430, 150, 20)

	Global $Pic_120_23 = GUICtrlCreatePic(_Display_PNG(@ScriptDir & "\Images\img_disc.png"), 580, 450, 150, 150)

	Global $Label_120_24 = GUICtrlCreateLabel("Clearart:", 580, 230, 150, 20)

	Global $Pic_120_24 = GUICtrlCreatePic(_Display_PNG(@ScriptDir & "\Images\img_clearart.png"), 580, 250, 150, 70)

	Global $Label_120_25 = GUICtrlCreateLabel("Clearlogo:", 580, 325, 150, 20)

	Global $Pic_120_25 = GUICtrlCreatePic(_Display_PNG(@ScriptDir & "\Images\img_clearart.png"), 580, 340, 150, 70)

	Global $Label_120_26 = GUICtrlCreateLabel("Thumb/Landscape:", 290, 430, 93, 20)

	Global $Pic_120_26 = GUICtrlCreatePic (@ScriptDir & "\Images\img_background.jpg", 290, 450, 280, 160)


	Dim $Array_GUI_Elements_120[1]

	_ArrayAdd($Array_GUI_Elements_120, $button_120_01)
	_ArrayAdd($Array_GUI_Elements_120, $button_120_02)
	_ArrayAdd($Array_GUI_Elements_120, $button_120_03)
	_ArrayAdd($Array_GUI_Elements_120, $button_120_04)
	_ArrayAdd($Array_GUI_Elements_120, $button_120_05)
	_ArrayAdd($Array_GUI_Elements_120, $button_120_06)

	_ArrayAdd($Array_GUI_Elements_120, $Label_120_00)
	_ArrayAdd($Array_GUI_Elements_120, $Label_120_00a)
	_ArrayAdd($Array_GUI_Elements_120, $Label_120_00b)

	_ArrayAdd($Array_GUI_Elements_120, $listview_120_01)

	Dim $Array_GUI_Elements_121[1]

	_ArrayAdd($Array_GUI_Elements_121, $edit_120_08)

	_ArrayAdd($Array_GUI_Elements_121, $input_120_01)
	_ArrayAdd($Array_GUI_Elements_121, $input_120_02)
	_ArrayAdd($Array_GUI_Elements_121, $input_120_03)
	_ArrayAdd($Array_GUI_Elements_121, $input_120_04)
	_ArrayAdd($Array_GUI_Elements_121, $input_120_05)
	_ArrayAdd($Array_GUI_Elements_121, $input_120_06)
	_ArrayAdd($Array_GUI_Elements_121, $input_120_07)
	_ArrayAdd($Array_GUI_Elements_121, $input_120_11)
	_ArrayAdd($Array_GUI_Elements_121, $input_120_12)
	_ArrayAdd($Array_GUI_Elements_121, $input_120_13)
	_ArrayAdd($Array_GUI_Elements_121, $input_120_14)
	_ArrayAdd($Array_GUI_Elements_121, $input_120_15)
	_ArrayAdd($Array_GUI_Elements_121, $input_120_16)
	_ArrayAdd($Array_GUI_Elements_121, $input_120_17)

	_ArrayAdd($Array_GUI_Elements_121, $Label_120_01)
	_ArrayAdd($Array_GUI_Elements_121, $Label_120_02)
	_ArrayAdd($Array_GUI_Elements_121, $Label_120_03)
	_ArrayAdd($Array_GUI_Elements_121, $Label_120_04)
	_ArrayAdd($Array_GUI_Elements_121, $Label_120_05)
	_ArrayAdd($Array_GUI_Elements_121, $Label_120_06)
	_ArrayAdd($Array_GUI_Elements_121, $Label_120_07)
	_ArrayAdd($Array_GUI_Elements_121, $Label_120_08)
	_ArrayAdd($Array_GUI_Elements_121, $Label_120_11)
	_ArrayAdd($Array_GUI_Elements_121, $Label_120_12)
	_ArrayAdd($Array_GUI_Elements_121, $Label_120_13)
	_ArrayAdd($Array_GUI_Elements_121, $Label_120_14)
	_ArrayAdd($Array_GUI_Elements_121, $Label_120_15)
	_ArrayAdd($Array_GUI_Elements_121, $Label_120_16)
	_ArrayAdd($Array_GUI_Elements_121, $Label_120_17)

	_ArrayAdd($Array_GUI_Elements_121, $Pic_120_00)

	Dim $Array_GUI_Elements_122[1]

	_ArrayAdd($Array_GUI_Elements_122, $Label_120_21)
	_ArrayAdd($Array_GUI_Elements_122, $Label_120_22)
	_ArrayAdd($Array_GUI_Elements_122, $Label_120_23)
	_ArrayAdd($Array_GUI_Elements_122, $Label_120_24)
	_ArrayAdd($Array_GUI_Elements_122, $Label_120_25)
	_ArrayAdd($Array_GUI_Elements_122, $Label_120_26)

	_ArrayAdd($Array_GUI_Elements_122, $Pic_120_20)
	_ArrayAdd($Array_GUI_Elements_122, $Pic_120_21)
	_ArrayAdd($Array_GUI_Elements_122, $Pic_120_22)
	_ArrayAdd($Array_GUI_Elements_122, $Pic_120_23)
	_ArrayAdd($Array_GUI_Elements_122, $Pic_120_24)
	_ArrayAdd($Array_GUI_Elements_122, $Pic_120_25)
	_ArrayAdd($Array_GUI_Elements_122, $Pic_120_26)

	Dim $Array_GUI_Elements_123[1]

	_ArrayAdd($Array_GUI_Elements_123, $Label_120_31)
	_ArrayAdd($Array_GUI_Elements_123, $Label_120_32)
	_ArrayAdd($Array_GUI_Elements_123, $Label_120_34)
	_ArrayAdd($Array_GUI_Elements_123, $Label_120_35)
	_ArrayAdd($Array_GUI_Elements_123, $Label_120_36)

	_ArrayAdd($Array_GUI_Elements_123, $Pic_120_30)
	_ArrayAdd($Array_GUI_Elements_123, $Pic_120_31)
	_ArrayAdd($Array_GUI_Elements_123, $Pic_120_32)
	_ArrayAdd($Array_GUI_Elements_123, $Pic_120_34)
	_ArrayAdd($Array_GUI_Elements_123, $Pic_120_35)
	_ArrayAdd($Array_GUI_Elements_123, $Pic_120_36)

#EndRegion

#Region ;Generate Afterwork Videos GUI (130)

	Global $Label_130_00 = GUICtrlCreateLabel($lng_metadata_correction & ":", 20, 130, 250, 30)
	GUICtrlSetFont(-1, 20, 700, 0, "Georgia")

	Global $Label_130_00a = GUICtrlCreateLabel($lng_videos, 20, 160, 250, 30)
	GUICtrlSetFont(-1, 20, 700, 0, "Georgia")

	Global $listview_130_01 = GUICtrlCreateList("", 20, 230, 260, 380, $LBS_DISABLENOSCROLL + $WS_BORdeR + $WS_VSCROLL, $ES_READONLY)

	Global $Pic_130_01 = GUICtrlCreatePic (@ScriptDir & "\Images\img_background.jpg", 300, 130, 430, 240)

	Global $Pic_130_02 = GUICtrlCreatePic (@ScriptDir & "\Images\img_poster.jpg", 745, 130, 240, 370)

	Global $Label_130_01 = GUICtrlCreateLabel($lng_title, 300, 380, 200, 20)

	Global $input_130_01 = GUICtrlCreateInput("", 300, 400, 200, 20)

	Global $Label_130_02 = GUICtrlCreateLabel($lng_sorttitle, 300, 430, 200, 20)

	Global $input_130_02 = GUICtrlCreateInput("", 300, 450, 200, 20)

	Global $Label_130_05 = GUICtrlCreateLabel($lng_plot, 300, 480, 200, 20)

	Global $edit_130_05 = GUICtrlCreateEdit("", 300, 500, 430, 110, $ES_MULTILINE + $ES_WANTRETURN + $ES_AUTOVSCROLL + $WS_VSCROLL)

	Global $Label_130_03 = GUICtrlCreateLabel($lng_genre, 530, 380, 200, 20)

	Global $input_130_03 = GUICtrlCreateInput("", 530, 400, 200, 20)

	Global $Label_130_04 = GUICtrlCreateLabel($lng_year, 530, 430, 200, 20)

	Global $input_130_04 = GUICtrlCreateInput("", 530, 450, 200, 20)

	Global $check_130_01 = GUICtrlCreateCheckbox($lng_covernew, 745, 515)

	Global $check_130_02 = GUICtrlCreateCheckbox($lng_fanartnew, 745, 545)

	Global $check_130_11 = GUICtrlCreateCheckbox($lng_imageselect, 875, 515)

	Global $button_130_01 = GUICtrlCreateButton($lng_refresh, 875, 545, 110)

	Global $button_130_03 = GUICtrlCreateButton($lng_play, 745, 585, 110)

	Global $button_130_02 = GUICtrlCreateButton($lng_back, 875, 585, 110)

	If $ini_fanart_covermanual = "1" Then
		GUICtrlSetState($check_130_11, $GUI_CHECKED)
	Else
		GUICtrlSetState($check_130_11, $GUI_UNCHECKED)
	EndIf

	Dim $Array_GUI_Elements_130[1]

	_ArrayAdd($Array_GUI_Elements_130, $button_130_01)
	_ArrayAdd($Array_GUI_Elements_130, $button_130_02)
	_ArrayAdd($Array_GUI_Elements_130, $button_130_03)

	_ArrayAdd($Array_GUI_Elements_130, $check_130_01)
	_ArrayAdd($Array_GUI_Elements_130, $check_130_02)
	_ArrayAdd($Array_GUI_Elements_130, $check_130_11)

	_ArrayAdd($Array_GUI_Elements_130, $edit_130_05)

	_ArrayAdd($Array_GUI_Elements_130, $input_130_01)
	_ArrayAdd($Array_GUI_Elements_130, $input_130_02)
	_ArrayAdd($Array_GUI_Elements_130, $input_130_03)
	_ArrayAdd($Array_GUI_Elements_130, $input_130_04)

	_ArrayAdd($Array_GUI_Elements_130, $Label_130_00)
	_ArrayAdd($Array_GUI_Elements_130, $Label_130_00a)
	_ArrayAdd($Array_GUI_Elements_130, $Label_130_01)
	_ArrayAdd($Array_GUI_Elements_130, $Label_130_02)
	_ArrayAdd($Array_GUI_Elements_130, $Label_130_03)
	_ArrayAdd($Array_GUI_Elements_130, $Label_130_04)
	_ArrayAdd($Array_GUI_Elements_130, $Label_130_05)

	_ArrayAdd($Array_GUI_Elements_130, $listview_130_01)

	_ArrayAdd($Array_GUI_Elements_130, $Pic_130_01)
	_ArrayAdd($Array_GUI_Elements_130, $Pic_130_02)

#EndRegion

#Region ;Generate Afterwork Audio GUI (140)

	Global $Label_140_00 = GUICtrlCreateLabel($lng_metadata_correction & ":", 20, 130, 200, 30)
	GUICtrlSetFont(-1, 20, 700, 0, "Georgia")

	Global $Label_140_00a = GUICtrlCreateLabel($lng_artist, 20, 160, 200, 30)
	GUICtrlSetFont(-1, 20, 700, 0, "Georgia")

	Global $listview_140_01 = GUICtrlCreateList("", 20, 230, 260, 340, $LBS_DISABLENOSCROLL + $WS_BORdeR + $WS_VSCROLL, $ES_READONLY)

	Global $Label_140_02 = GUICtrlCreateLabel($lng_name, 300, 230, 250, 20)

	Global $input_140_01 = GUICtrlCreateInput("", 300, 250, 250, 20)

	Global $Label_140_03 = GUICtrlCreateLabel($lng_musicbrainz, 300, 280, 250, 20)

	Global $input_140_02 = GUICtrlCreateInput("", 300, 300, 250, 20)

	Global $Label_140_04 = GUICtrlCreateLabel($lng_born, 300, 330, 120, 20)

	Global $input_140_03 = GUICtrlCreateInput("", 300, 350, 120, 20)

	Global $Label_140_14 = GUICtrlCreateLabel($lng_died, 430, 330, 120, 20)

	Global $input_140_13 = GUICtrlCreateInput("", 430, 350, 120, 20)

	Global $Label_140_05 = GUICtrlCreateLabel($lng_formed, 300, 380, 120, 20)

	Global $input_140_04 = GUICtrlCreateInput("", 300, 400, 120, 20)

	Global $Label_140_15 = GUICtrlCreateLabel($lng_disbanded, 430, 380, 120, 20)

	Global $input_140_14 = GUICtrlCreateInput("", 430, 400, 120, 20)

	Global $Label_140_07 = GUICtrlCreateLabel($lng_genre, 300, 430, 120, 20)

	Global $input_140_07 = GUICtrlCreateInput("", 300, 450, 120, 20)

	Global $Label_140_08 = GUICtrlCreateLabel($lng_gender, 430, 430, 120, 20)

	Global $input_140_08 = GUICtrlCreateInput("", 430, 450, 120, 20)

	Global $Label_140_09 = GUICtrlCreateLabel($lng_disambiguation, 300, 480, 120, 20)

	Global $input_140_09 = GUICtrlCreateInput("", 300, 500, 250, 20)

	Global $Label_140_06 = GUICtrlCreateLabel($lng_bio, 300, 530, 250, 20)

	Global $edit_140_04 = GUICtrlCreateEdit("", 300, 550, 250, 60, $ES_MULTILINE + $ES_WANTRETURN + $ES_AUTOVSCROLL + $WS_VSCROLL)

	Global $Pic_140_01 = GUICtrlCreatePic (@ScriptDir & "\Images\img_banner.jpg", 220, 120, 540, 100)

	Global $Pic_140_02 = GUICtrlCreatePic (@ScriptDir & "\Images\img_poster.jpg", 770, 120, 220, 220)

	Global $Pic_140_03 = GUICtrlCreatePic (@ScriptDir & "\Images\img_background.jpg", 570, 350, 420, 220)

	Global $Pic_140_04 = GUICtrlCreatePic (@ScriptDir & "\Images\img_clearart.jpg", 570, 230, 190, 110)

	Global $button_140_01 = GUICtrlCreateButton($lng_editalbum, 565, 585, 120)
	GUICtrlSetState(-1, $GUI_DISABLE)

	Global $button_140_02 = GUICtrlCreateButton($lng_back, 870, 585, 120)

	Global $button_140_03 = GUICtrlCreateButton("Fanart " & $lng_copy, 715, 585, 120)

	Global $button_140_04 = GUICtrlCreateButton("Wikipedia", 20, 585, 120)

	Global $button_140_05 = GUICtrlCreateButton("Discogs", 160, 585, 120)

	Dim $Array_GUI_Elements_140[1]

	_ArrayAdd($Array_GUI_Elements_140, $button_140_01)
	_ArrayAdd($Array_GUI_Elements_140, $button_140_02)
	_ArrayAdd($Array_GUI_Elements_140, $button_140_03)
	_ArrayAdd($Array_GUI_Elements_140, $button_140_04)
	_ArrayAdd($Array_GUI_Elements_140, $button_140_05)

	_ArrayAdd($Array_GUI_Elements_140, $edit_140_04)

	_ArrayAdd($Array_GUI_Elements_140, $Label_140_00)
	_ArrayAdd($Array_GUI_Elements_140, $Label_140_00a)
	_ArrayAdd($Array_GUI_Elements_140, $Label_140_02)
	_ArrayAdd($Array_GUI_Elements_140, $Label_140_03)
	_ArrayAdd($Array_GUI_Elements_140, $Label_140_04)
	_ArrayAdd($Array_GUI_Elements_140, $Label_140_05)
	_ArrayAdd($Array_GUI_Elements_140, $Label_140_06)
	_ArrayAdd($Array_GUI_Elements_140, $Label_140_07)
	_ArrayAdd($Array_GUI_Elements_140, $Label_140_08)
	_ArrayAdd($Array_GUI_Elements_140, $Label_140_09)
	_ArrayAdd($Array_GUI_Elements_140, $Label_140_14)
	_ArrayAdd($Array_GUI_Elements_140, $Label_140_15)

	_ArrayAdd($Array_GUI_Elements_140, $input_140_01)
	_ArrayAdd($Array_GUI_Elements_140, $input_140_02)
	_ArrayAdd($Array_GUI_Elements_140, $input_140_03)
	_ArrayAdd($Array_GUI_Elements_140, $input_140_04)
	_ArrayAdd($Array_GUI_Elements_140, $input_140_07)
	_ArrayAdd($Array_GUI_Elements_140, $input_140_08)
	_ArrayAdd($Array_GUI_Elements_140, $input_140_09)
	_ArrayAdd($Array_GUI_Elements_140, $input_140_13)
	_ArrayAdd($Array_GUI_Elements_140, $input_140_14)

	_ArrayAdd($Array_GUI_Elements_140, $listview_140_01)

	_ArrayAdd($Array_GUI_Elements_140, $Pic_140_01)
	_ArrayAdd($Array_GUI_Elements_140, $Pic_140_02)
	_ArrayAdd($Array_GUI_Elements_140, $Pic_140_03)
	_ArrayAdd($Array_GUI_Elements_140, $Pic_140_04)


#EndRegion

#Region ;Generate Afterwork Album GUI (150)

	Global $Label_150_00 = GUICtrlCreateLabel($lng_metadata_correction & ":", 20, 120, 200, 30)
	GUICtrlSetFont(-1, 20, 700, 0, "Georgia")

	Global $Label_150_00a = GUICtrlCreateLabel($lng_album, 20, 160, 200, 30)
	GUICtrlSetFont(-1, 20, 700, 0, "Georgia")

	Global $listview_150_01 = GUICtrlCreateList("", 20, 230, 260, 380, $LBS_DISABLENOSCROLL + $WS_BORdeR + $WS_VSCROLL, $ES_READONLY)

	Global $input_150_01 = GUICtrlCreateInput("", 300, 123, 440, 40)
	GUICtrlSetFont(-1, 20, 700, 0, "Georgia")

	Global $Label_150_02 = GUICtrlCreateLabel("Album Artist:", 300, 180, 200, 20)

	Global $input_150_02 = GUICtrlCreateInput("", 300, 200, 200, 20)

	Global $Label_150_03 = GUICtrlCreateLabel("Theme:", 300, 230, 200, 20)

	Global $input_150_03 = GUICtrlCreateInput("", 300, 250, 200, 20)

	Global $Label_150_04 = GUICtrlCreateLabel("Style:", 300, 280, 200, 20)

	Global $input_150_04 = GUICtrlCreateInput("", 300, 300, 200, 20)

	Global $Label_150_05 = GUICtrlCreateLabel($lng_year, 300, 330, 50, 20)

	Global $input_150_05 = GUICtrlCreateInput("", 300, 350, 40, 20)

	Global $Label_150_06 = GUICtrlCreateLabel("Review:", 300, 380, 100, 15)

	Global $Edit_150_06 = GUICtrlCreateEdit("", 300, 397, 460, 80, $WS_BORdeR + $WS_VSCROLL + $ES_WANTRETURN + $ES_AUTOVSCROLL, $ES_MULTILINE)

	Global $Label_150_07 = GUICtrlCreateLabel("Tracklist:", 300, 485, 100, 15)

	Global $Edit_150_07 = GUICtrlCreateEdit("", 300, 502, 460, 110, $WS_BORdeR + $WS_VSCROLL + $ES_WANTRETURN + $ES_AUTOVSCROLL, $ES_MULTILINE + $ES_READONLY)

	Global $Label_150_12 = GUICtrlCreateLabel($lng_musicbrainz, 540, 180, 200, 20)

	Global $input_150_12 = GUICtrlCreateInput("", 540, 200, 200, 20)

	Global $Label_150_13 = GUICtrlCreateLabel("Genre:", 540, 230, 200, 20)

	Global $input_150_13 = GUICtrlCreateInput("", 540, 250, 200, 20)

	Global $Label_150_14 = GUICtrlCreateLabel("Mood:", 540, 280, 200, 20)

	Global $input_150_14 = GUICtrlCreateInput("", 540, 300, 200, 20)

	Global $Label_150_15 = GUICtrlCreateLabel("Label:", 540, 330, 200, 20)

	Global $input_150_15 = GUICtrlCreateInput("", 540, 350, 200, 20)

	Global $Pic_150_01 = GUICtrlCreatePic (@ScriptDir & "\Images\img_poster.jpg", 770, 123, 220, 220)

	Global $Pic_150_02 = GUICtrlCreatePic(_Display_PNG(@ScriptDir & "\Images\img_disc.png"), 770, 358, 220, 220)

	Global $button_150_01 = GUICtrlCreateButton($lng_back, 870, 585, 120)

	Dim $Array_GUI_Elements_150[1]

	_ArrayAdd($Array_GUI_Elements_150, $button_150_01)

	_ArrayAdd($Array_GUI_Elements_150, $Edit_150_06)
	_ArrayAdd($Array_GUI_Elements_150, $Edit_150_07)

	_ArrayAdd($Array_GUI_Elements_150, $input_150_01)
	_ArrayAdd($Array_GUI_Elements_150, $input_150_02)
	_ArrayAdd($Array_GUI_Elements_150, $input_150_03)
	_ArrayAdd($Array_GUI_Elements_150, $input_150_04)
	_ArrayAdd($Array_GUI_Elements_150, $input_150_05)
	_ArrayAdd($Array_GUI_Elements_150, $input_150_12)
	_ArrayAdd($Array_GUI_Elements_150, $input_150_13)
	_ArrayAdd($Array_GUI_Elements_150, $input_150_14)
	_ArrayAdd($Array_GUI_Elements_150, $input_150_15)

	_ArrayAdd($Array_GUI_Elements_150, $Label_150_00)
	_ArrayAdd($Array_GUI_Elements_150, $Label_150_00a)
	_ArrayAdd($Array_GUI_Elements_150, $Label_150_02)
	_ArrayAdd($Array_GUI_Elements_150, $Label_150_03)
	_ArrayAdd($Array_GUI_Elements_150, $Label_150_04)
	_ArrayAdd($Array_GUI_Elements_150, $Label_150_05)
	_ArrayAdd($Array_GUI_Elements_150, $Label_150_06)
	_ArrayAdd($Array_GUI_Elements_150, $Label_150_07)
	_ArrayAdd($Array_GUI_Elements_150, $Label_150_12)
	_ArrayAdd($Array_GUI_Elements_150, $Label_150_13)
	_ArrayAdd($Array_GUI_Elements_150, $Label_150_14)
	_ArrayAdd($Array_GUI_Elements_150, $Label_150_15)

	_ArrayAdd($Array_GUI_Elements_150, $listview_150_01)

	_ArrayAdd($Array_GUI_Elements_150, $Pic_150_01)
	_ArrayAdd($Array_GUI_Elements_150, $Pic_150_02)


#EndRegion

#EndRegion

#Region ;Manual Cover Window

	$style = $WS_SYSMENU + $WS_CAPTION + $WS_MAXIMIZEBOX + $WS_MINIMIZEBOX + $BS_PUSHLIKE

	Global $Coverwindow = GUICreate($Title, 1000, 680, -1, -1, $style, $WS_EX_TOPMOST + $WS_EX_COMPOSITED)
	GUISetState(@SW_HIde, $Coverwindow)

	GUISetBkColor("0xffffff")

	Global $Cover_Label_01 = GUICtrlCreateLabel($lng_image & " #01:", 20, 10, 200, 20)

	Global $Cover_Pic_01 = GUICtrlCreatePic (@ScriptDir & "\Images\img_background.jpg", 20, 30, 215, 120)

	Global $Cover_Label_02 = GUICtrlCreateLabel($lng_image & " #02:", 270, 10, 200, 20)

	Global $Cover_Pic_02 = GUICtrlCreatePic (@ScriptDir & "\Images\img_background.jpg", 270, 30, 215, 120)

	Global $Cover_Label_03 = GUICtrlCreateLabel($lng_image & " #03:", 520, 10, 200, 20)

	Global $Cover_Pic_03 = GUICtrlCreatePic (@ScriptDir & "\Images\img_background.jpg", 520, 30, 215, 120)

	Global $Cover_Label_04 = GUICtrlCreateLabel($lng_image & " #04:", 770, 10, 200, 20)

	Global $Cover_Pic_04 = GUICtrlCreatePic (@ScriptDir & "\Images\img_background.jpg", 770, 30, 215, 120)

	Global $Cover_Label_05 = GUICtrlCreateLabel($lng_image & " #05:", 20, 170, 200, 20)

	Global $Cover_Pic_05 = GUICtrlCreatePic (@ScriptDir & "\Images\img_background.jpg", 20, 190, 215, 120)

	Global $Cover_Label_06 = GUICtrlCreateLabel($lng_image & " #06:", 270, 170, 200, 20)

	Global $Cover_Pic_06 = GUICtrlCreatePic (@ScriptDir & "\Images\img_background.jpg", 270, 190, 215, 120)

	Global $Cover_Label_07 = GUICtrlCreateLabel($lng_image & " #07:", 520, 170, 200, 20)

	Global $Cover_Pic_07 = GUICtrlCreatePic (@ScriptDir & "\Images\img_background.jpg", 520, 190, 215, 120)

	Global $Cover_Label_08 = GUICtrlCreateLabel($lng_image & " #08:", 770, 170, 200, 20)

	Global $Cover_Pic_08 = GUICtrlCreatePic (@ScriptDir & "\Images\img_background.jpg", 770, 190, 215, 120)

	Global $Cover_Label_09 = GUICtrlCreateLabel($lng_image & " #09:", 20, 330, 200, 20)

	Global $Cover_Pic_09 = GUICtrlCreatePic (@ScriptDir & "\Images\img_background.jpg", 20, 350, 215, 120)

	Global $Cover_Label_10 = GUICtrlCreateLabel($lng_image & " #10:", 270, 330, 200, 20)

	Global $Cover_Pic_10 = GUICtrlCreatePic (@ScriptDir & "\Images\img_background.jpg", 270, 350, 215, 120)

	Global $Cover_Label_11 = GUICtrlCreateLabel($lng_image & " #11:", 520, 330, 200, 20)

	Global $Cover_Pic_11 = GUICtrlCreatePic (@ScriptDir & "\Images\img_background.jpg", 520, 350, 215, 120)

	Global $Cover_Label_12 = GUICtrlCreateLabel($lng_image & " #12:", 770, 330, 200, 20)

	Global $Cover_Pic_12 = GUICtrlCreatePic (@ScriptDir & "\Images\img_background.jpg", 770, 350, 215, 120)

	Global $Cover_Label_13 = GUICtrlCreateLabel($lng_image & " #13:", 20, 490, 200, 20)

	Global $Cover_Pic_13 = GUICtrlCreatePic (@ScriptDir & "\Images\img_background.jpg", 20, 510, 215, 120)

	Global $Cover_Label_14 = GUICtrlCreateLabel($lng_image & " #14:", 270, 490, 200, 20)

	Global $Cover_Pic_14 = GUICtrlCreatePic (@ScriptDir & "\Images\img_background.jpg", 270, 510, 215, 120)

	Global $Cover_Label_15 = GUICtrlCreateLabel($lng_image & " #15:", 520, 490, 200, 20)

	Global $Cover_Pic_15 = GUICtrlCreatePic (@ScriptDir & "\Images\img_background.jpg", 520, 510, 215, 120)

	Global $Cover_Label_16 = GUICtrlCreateLabel($lng_image & " #16:", 770, 490, 200, 20)

	Global $Cover_Pic_16 = GUICtrlCreatePic (@ScriptDir & "\Images\img_background.jpg", 770, 510, 215, 120)

	$design = StringSplit($ini_fanart_design, "-")

	Global $Cover_Combo_Label_01 = GUICtrlCreateLabel($lng_image & " - " & $lng_front & " 1", 135, 651, 100, 20, $SS_RIGHT)

	Global $Cover_Combo_01 = GUICtrlCreateCombo("1", 245, 648, 130)
	GUICtrlSetData(-1, "2|3|4|5|6|7|8|9|10|11|12|13|14|15|16", "1")

	Global $Cover_Combo_Label_02 = GUICtrlCreateLabel($lng_image & " - " & $lng_front & " 2", 380, 651, 100, 20, $SS_RIGHT)
	If $design[1] = 1 Then GUICtrlSetState(-1, $GUI_DISABLE)

	Global $Cover_Combo_02 = GUICtrlCreateCombo("1", 495, 648, 130)
	GUICtrlSetData(-1, "2|3|4|5|6|7|8|9|10|11|12|13|14|15|16", "1")
	If $design[1] = 1 Then GUICtrlSetState(-1, $GUI_DISABLE)

	Global $Cover_Combo_Label_03 = GUICtrlCreateLabel($lng_backdrop, 620, 651, 100, 20, $SS_RIGHT)

	Global $Cover_Combo_03 = GUICtrlCreateCombo("1", 730, 648, 130)
	GUICtrlSetData(-1, "2|3|4|5|6|7|8|9|10|11|12|13|14|15|16", "1")

	Global $Cover_Progress_01 = GUICtrlCreateProgress(150, 648, 710, 20)
	GUICtrlSetState(-1, $GUI_HIDE)

	Global $Cover_Button_01 = GUICtrlCreateButton($lng_makecover, 20, 645, 110)

	Global $Cover_Button_02 = GUICtrlCreateButton($lng_back, 875, 645, 110)


#EndRegion

#Region ;Progress Windows

	$style = $WS_SYSMENU + $WS_CAPTION + $WS_MAXIMIZEBOX + $WS_MINIMIZEBOX + $BS_PUSHLIKE

	Global $Progresswindow = GUICreate("Media-Buddy - " & $lng_progress, 500, 314, -1, -1, $style, $WS_EX_TOPMOST + $WS_EX_COMPOSITED)
	GUISetState(@SW_HIde, $Progresswindow)

	GUISetBkColor("0xffffff")

	Global $PR_Pic01 = GUICtrlCreatePic (@ScriptDir & "\Images\logo-big.bmp", 0, 0, 164, 314)

	Global $PR_label_01 = GUICtrlCreateLabel($lng_workingon, 180, 20, 290, 40, $SS_CENTER)
	GUICtrlSetFont(-1, 20, 0, 0, "Verdana")

	Global $PR_label_02 = GUICtrlCreateLabel($lng_series & " - Taggen", 180, 70, 290, 40, $SS_CENTER)
	GUICtrlSetFont(-1, 20, 0, 0, "Verdana")

	Global $PR_label_03 = GUICtrlCreateLabel("", 170, 130, 310, 30, $SS_CENTER)
	GUICtrlSetFont(-1, 10, 0, 0, "Verdana")

	Global $PR_label_04 = GUICtrlCreateLabel("", 170, 170, 310, 30, $SS_CENTER)
	GUICtrlSetFont(-1, 10, 0, 0, "Verdana")

	Global $PR_label_05 = GUICtrlCreateLabel("", 170, 210, 310, 95, $SS_CENTER)
	GUICtrlSetFont(-1, 10, 0, 0, "Verdana")

#EndRegion

#Region ;Show Main Windows

If @Compiled = 1 Then SplashOff()

_LastModule()

_WriteLog("Info - Generated Main Window")

GUISetState(@SW_SHOW, $Mainwindow)

_WriteLog("Info - Started Media-Buddy")
_WriteLog("------------------")


;~ _EditRatings()

;~ _KodiRefreshClearartMySQL()

;~ _CopyClearlogo("Z:\Serien\")

;~ _FixNotation("d:\Media-Buddy_Arbeit\Ausgang\Serien\")

_GUI_Main()

#EndRegion ;Show Main Windows

#Region ;Afterwork Functions

;Function to capture mouseclicks in Album afterwork list. (150)
Func _GetListAlbum($in_artist, $WorkArray)

	If $listitem_150_01 = GUICtrlRead($listview_150_01) Then

		Return

	Else

		If $listitem_150_01 <> "" Then _WriteData_150($listitem_150_01, $in_artist)

		$listitem_150_01 = GUICtrlRead($listview_150_01)

		_SetData_150($in_artist, $listitem_150_01)

		Return

	EndIf

Return

EndFunc

;Function to capture mouseclicks in Audio afterwork list. (140)
Func _GetListAudio()

	If $listitem_140_01 = GUICtrlRead($listview_140_01) Then

		Return

	Else

		If $listitem_140_01 <> "" Then _WriteData_140($listitem_140_01)

		$listitem_140_01 = GUICtrlRead($listview_140_01)

		_SetData_140($listitem_140_01)

		Return

	EndIf

Return

EndFunc

;Function to capture mouseclicks in Episodes afterwork list. (110)
Func _GetListEpisodes($in_series)

	If $listitem_110_01 = GUICtrlRead($listview_110_01) Then

		Return

	Else

		_WriteLog("_GetListEpisodes - " & $listitem_110_01)

		_WriteLog("_GetListEpisodes - " & GUICtrlRead($listview_110_01))

		If $listitem_110_01 <> GUICtrlRead($listview_110_01) Then

			If $listitem_110_01 <> "" Then _WriteData_110($listitem_110_01, $in_series)

			$listitem_110_01 = GUICtrlRead($listview_110_01)

			_SetData_110($in_series, $listitem_110_01)

			Return

		EndIf

	EndIf

Return

EndFunc

;Function to capture mouseclicks in Movies afterwork list. (120)
Func _GetListMovies($WorkArray)

	If $listitem_120_01 = GUICtrlRead($listview_120_01) Then

		Return

	Else

		If $listitem_120_01 <> "" Then _WriteData_120($listitem_120_01)

		$listitem_120_01 = GUICtrlRead($listview_120_01)

		_SetData_120($listitem_120_01)

		Return

	EndIf

Return

EndFunc

;Function to capture mouseclicks in Series afterwork list. (100)
Func _GetListSeries()

	If $listitem_100_01 = GUICtrlRead($listview_100_01) Then

		Return

	Else

		If $listitem_100_01 <> "" Then _WriteData_100($listitem_100_01)

		$listitem_100_01 = GUICtrlRead($listview_100_01)

		_SetData_100($listitem_100_01)

		Return

	EndIf

Return

EndFunc

;Function to capture mouseclicks in Videos afterwork list. (130)
Func _GetListVideos($WorkArray)

	If $listitem_130_01 = GUICtrlRead($listview_130_01) Then

		Return

	Else

		If $listitem_130_01 <> "" Then _WriteData_130($listitem_130_01)

		$listitem_130_01 = GUICtrlRead($listview_130_01)

		_SetData_130($listitem_130_01)

		Return

	EndIf

Return

EndFunc

;Function to Generate Cover
Func _Make_Cover_Manual($InFile)

	_WriteLog("Make_Cover_Manual - Started")

	Local $width, $height, $sDrive, $sDir, $sFilename, $sExtension, $vRow, $t, $skip
	Local $length, $hour, $minutes, $second, $time, $peri, $per, $ss, $option

	Dim $index[0]

	$skip = _Mediainfo($InFile)

	If $skip = "skip" Then Return

	_SQLite_QuerySingleRow(-1,"SELECT * FROM Video LIMIT 1;",$vRow)

	GUISetState(@SW_SHOW, $Progresswindow)

	_SetLabel($PR_label_02, $lng_stills_generate)

	$t = 16

	$length = $vRow[3] / 1000

	$hour = Floor($length / 3600)

	$minutes = Floor($length / 60) - ($hour * 60)

	$second = Round($length - ($minutes * 60) - ($hour * 3600))

	$time = StringFormat("%02s", $hour) & ':' & StringFormat("%02s", $minutes)

	$peri = Round($length / ($t + 1))

	For $i = 1 to $t

		_SetLabel($PR_label_04, $lng_stills & " #" & $i)

		_ArrayAdd($index, $i)

		$per = $peri * $i

		$hour = Floor($per / 3600)

		$minutes = Floor($per / 60) - ($hour * 60)

		$second = $per - ($minutes * 60) - ($hour * 3600)

		$ss = ' -ss ' & StringFormat("%02s", $hour) & ':' & StringFormat("%02s", $minutes) & ':' & StringFormat("%02s", $second) & '.000'

		$option = $ss & ' -i "' & $InFile & '" -y -frames:v 1 "' & $tempdir & '\fanart_' & $i & '.jpg"'

		ShellExecuteWait($ini_ffmpeg_path, $option, "", "", @SW_HIde)

	Next

	If FileExists($tempdir & "\fanart_1.jpg") Then GUICtrlSetImage($Cover_Pic_01,  $tempdir & "\fanart_1.jpg")
	If FileExists($tempdir & "\fanart_2.jpg") Then GUICtrlSetImage($Cover_Pic_02,  $tempdir & "\fanart_2.jpg")
	If FileExists($tempdir & "\fanart_3.jpg") Then GUICtrlSetImage($Cover_Pic_03,  $tempdir & "\fanart_3.jpg")
	If FileExists($tempdir & "\fanart_4.jpg") Then GUICtrlSetImage($Cover_Pic_04,  $tempdir & "\fanart_4.jpg")
	If FileExists($tempdir & "\fanart_5.jpg") Then GUICtrlSetImage($Cover_Pic_05,  $tempdir & "\fanart_5.jpg")
	If FileExists($tempdir & "\fanart_6.jpg") Then GUICtrlSetImage($Cover_Pic_06,  $tempdir & "\fanart_6.jpg")
	If FileExists($tempdir & "\fanart_7.jpg") Then GUICtrlSetImage($Cover_Pic_07,  $tempdir & "\fanart_7.jpg")
	If FileExists($tempdir & "\fanart_8.jpg") Then GUICtrlSetImage($Cover_Pic_08,  $tempdir & "\fanart_8.jpg")
	If FileExists($tempdir & "\fanart_9.jpg") Then GUICtrlSetImage($Cover_Pic_09,  $tempdir & "\fanart_9.jpg")
	If FileExists($tempdir & "\fanart_10.jpg") Then GUICtrlSetImage($Cover_Pic_10,  $tempdir & "\fanart_10.jpg")
	If FileExists($tempdir & "\fanart_11.jpg") Then GUICtrlSetImage($Cover_Pic_11,  $tempdir & "\fanart_11.jpg")
	If FileExists($tempdir & "\fanart_12.jpg") Then GUICtrlSetImage($Cover_Pic_12,  $tempdir & "\fanart_12.jpg")
	If FileExists($tempdir & "\fanart_13.jpg") Then GUICtrlSetImage($Cover_Pic_13,  $tempdir & "\fanart_13.jpg")
	If FileExists($tempdir & "\fanart_14.jpg") Then GUICtrlSetImage($Cover_Pic_14,  $tempdir & "\fanart_14.jpg")
	If FileExists($tempdir & "\fanart_15.jpg") Then GUICtrlSetImage($Cover_Pic_15,  $tempdir & "\fanart_15.jpg")
	If FileExists($tempdir & "\fanart_16.jpg") Then GUICtrlSetImage($Cover_Pic_16,  $tempdir & "\fanart_16.jpg")

	GUISetState(@SW_HIde, $Progresswindow)

	_SetLabel($PR_label_02, $lng_series & " - Taggen")

	Sleep(20)

	GUISetState(@SW_SHOW, $Coverwindow)

;Gui Loop
	While 1

		_GetTime()

		Local $msg1 = GUIGetMsg(1)
		Select

			Case $msg1[0] = $Cover_Button_01

				_Make_Cover($InFile, $time)

				ExitLoop


			Case $msg1[0] = $Cover_Button_02

				ExitLoop


			Case $msg1[0] = $GUI_EVENT_CLOSE
				_WriteLog("Make_Cover_Manual - Finished")
				_Exit()

		EndSelect

		Sleep(20)

	WEnd

	GUISetState(@SW_HIde, $Coverwindow)

	GUISetState(@SW_SHOW, $Afterworkwindow)

	Return

EndFunc

;Function to Generate Episodes Thumbs
Func _Make_Thumb_Manual($InFile1);, $ext = ".mkv")

	_WriteLog("Make_Thumb_Manual - Started")

	Local $width, $height, $sDrive, $sDir, $sFilename, $sExtension, $vRow, $t, $skip, $pathsplit
	Local $length, $hour, $minutes, $second, $time, $peri, $per, $ss, $option, $design, $InFile, $ext

	Dim $index[0]

	$skip = _Mediainfo($InFile1); & $ext)

	$pathsplit = _PathSplit($InFile1, $sDrive, $sDir, $sFilename, $sExtension)

	$InFile = $pathsplit[1] & $pathsplit[2] & $pathsplit[3]

	$ext = $pathsplit[4]

	If $skip = "skip" Then Return

	_SQLite_QuerySingleRow(-1,"SELECT * FROM Video LIMIT 1;",$vRow)

	GUISetState(@SW_SHOW, $Progresswindow)

	_SetLabel($PR_label_02, $lng_stills_generate)

	$t = 16

	$length = $vRow[3] / 1000

	$hour = Floor($length / 3600)

	$minutes = Floor($length / 60) - ($hour * 60)

	$second = Round($length - ($minutes * 60) - ($hour * 3600))

	$time = StringFormat("%02s", $hour) & ':' & StringFormat("%02s", $minutes)

	$peri = Round($length / ($t + 1))

	For $i = 1 to $t

		_SetLabel($PR_label_04, $lng_stills & " #" & $i)

		_ArrayAdd($index, $i)

		$per = $peri * $i

		$hour = Floor($per / 3600)

		$minutes = Floor($per / 60) - ($hour * 60)

		$second = $per - ($minutes * 60) - ($hour * 3600)

		$ss = ' -ss ' & StringFormat("%02s", $hour) & ':' & StringFormat("%02s", $minutes) & ':' & StringFormat("%02s", $second) & '.000'

		$option = $ss & ' -i "' & $InFile & $ext & '" -y -frames:v 1 "' & $tempdir & '\fanart_' & $i & '.jpg"'

		ShellExecuteWait($ini_ffmpeg_path, $option, "", "", @SW_HIde)

	Next

	If FileExists($tempdir & "\fanart_1.jpg") Then GUICtrlSetImage($Cover_Pic_01,  $tempdir & "\fanart_1.jpg")
	If FileExists($tempdir & "\fanart_2.jpg") Then GUICtrlSetImage($Cover_Pic_02,  $tempdir & "\fanart_2.jpg")
	If FileExists($tempdir & "\fanart_3.jpg") Then GUICtrlSetImage($Cover_Pic_03,  $tempdir & "\fanart_3.jpg")
	If FileExists($tempdir & "\fanart_4.jpg") Then GUICtrlSetImage($Cover_Pic_04,  $tempdir & "\fanart_4.jpg")
	If FileExists($tempdir & "\fanart_5.jpg") Then GUICtrlSetImage($Cover_Pic_05,  $tempdir & "\fanart_5.jpg")
	If FileExists($tempdir & "\fanart_6.jpg") Then GUICtrlSetImage($Cover_Pic_06,  $tempdir & "\fanart_6.jpg")
	If FileExists($tempdir & "\fanart_7.jpg") Then GUICtrlSetImage($Cover_Pic_07,  $tempdir & "\fanart_7.jpg")
	If FileExists($tempdir & "\fanart_8.jpg") Then GUICtrlSetImage($Cover_Pic_08,  $tempdir & "\fanart_8.jpg")
	If FileExists($tempdir & "\fanart_9.jpg") Then GUICtrlSetImage($Cover_Pic_09,  $tempdir & "\fanart_9.jpg")
	If FileExists($tempdir & "\fanart_10.jpg") Then GUICtrlSetImage($Cover_Pic_10,  $tempdir & "\fanart_10.jpg")
	If FileExists($tempdir & "\fanart_11.jpg") Then GUICtrlSetImage($Cover_Pic_11,  $tempdir & "\fanart_11.jpg")
	If FileExists($tempdir & "\fanart_12.jpg") Then GUICtrlSetImage($Cover_Pic_12,  $tempdir & "\fanart_12.jpg")
	If FileExists($tempdir & "\fanart_13.jpg") Then GUICtrlSetImage($Cover_Pic_13,  $tempdir & "\fanart_13.jpg")
	If FileExists($tempdir & "\fanart_14.jpg") Then GUICtrlSetImage($Cover_Pic_14,  $tempdir & "\fanart_14.jpg")
	If FileExists($tempdir & "\fanart_15.jpg") Then GUICtrlSetImage($Cover_Pic_15,  $tempdir & "\fanart_15.jpg")
	If FileExists($tempdir & "\fanart_16.jpg") Then GUICtrlSetImage($Cover_Pic_16,  $tempdir & "\fanart_16.jpg")

	GUISetState(@SW_HIde, $Progresswindow)

	Sleep(20)

	_SetLabel($Cover_Combo_Label_01, $lng_image & " - Thumb")

	_SetLabel($Cover_Button_01, $lng_makethumb)

	GUICtrlSetState($Cover_Combo_02, $GUI_DISABLE)

	GUICtrlSetState($Cover_Combo_03, $GUI_DISABLE)

	GUICtrlSetState($Cover_Combo_Label_02, $GUI_DISABLE)

	GUICtrlSetState($Cover_Combo_Label_03, $GUI_DISABLE)

	GUISetState(@SW_SHOW, $Coverwindow)

;Gui Loop
	While 1

		_GetTime()

		Local $msg1 = GUIGetMsg(1)
		Select

			Case $msg1[0] = $Cover_Button_01

				$a = GUICtrlRead($Cover_Combo_01)

				$option = '"' & $tempdir & '\fanart_' & $a & '.jpg" -resize 640x360^ -background black -compose Copy \ -gravity center -extent 640x360 -normalize -unsharp 0x1 -quality 92 "' & $InFile & '-thumb.jpg"'

				ShellExecuteWait(@ScriptDir & '\convert.exe', $option, "", "", @SW_HIde)

				_Optimize_Graphics_File($InFile & '-thumb.jpg')

				GUICtrlSetImage($Pic_110_03, $InFile & '-thumb.jpg')

				ExitLoop

			Case $msg1[0] = $Cover_Button_02

				ExitLoop


			Case $msg1[0] = $GUI_EVENT_CLOSE

				_WriteLog("Make_Thumb_Manual - Finished")

				_Exit()


		EndSelect

		Sleep(20)

	WEnd

	GUISetState(@SW_HIde, $Coverwindow)

	GUISetState(@SW_SHOW, $Afterworkwindow)

	_SetLabel($Cover_Combo_Label_01, $lng_image & " - " & $lng_front & " 1")

	_SetLabel($Cover_Button_01, $lng_makecover)

	GUICtrlSetState($Cover_Combo_03, $GUI_ENABLE)

	GUICtrlSetState($Cover_Combo_Label_03, $GUI_ENABLE)

	$design = StringSplit($ini_fanart_design, "-")

	If $design[1] = 2 Then

		GUICtrlSetState($Cover_Combo_02, $GUI_ENABLE)
		GUICtrlSetState($Cover_Combo_Label_02, $GUI_ENABLE)

	EndIf

	_WriteLog("Make_Thumb_Manual - Finished")

	Return

EndFunc

;Function to show Movies Metadata Correction Window
Func _Metadata_Correction_Audio()

	_WriteLog("Audio Metadata Manual Modification - Started")

	GUISetState(@SW_HIde, $Mainwindow)

	_ClearGUI($Array_GUI_Elements_100)
	_ClearGUI($Array_GUI_Elements_110)
	_ClearGUI($Array_GUI_Elements_120)
	_ClearGUI($Array_GUI_Elements_121)
	_ClearGUI($Array_GUI_Elements_122)
	_ClearGUI($Array_GUI_Elements_130)

	GUICtrlSetImage($Pic_140_01, @ScriptDir & "\Images\img_banner.jpg")
	GUICtrlSetImage($Pic_140_02, @ScriptDir & "\Images\img_poster.jpg")
	GUICtrlSetImage($Pic_140_03, @ScriptDir & "\Images\img_background.jpg")
	GUICtrlSetImage($Pic_140_04, _Display_PNG(@ScriptDir & "\Images\img_clearart.png"))

	GUISetState(@SW_SHOW, $Afterworkwindow)

	Dim $PathSplit[1]

	Local $WorkArray[1] = [0]

	Local $InDir = GUICtrlRead($input_64_01)

	If $ini_artist = "2" Then $WorkArray = _FileListToArrayRec($InDir, "*", 2, 0, 1)

	If $ini_artist = "1" Then $WorkArray = _FileListToArrayRec($InDir, $aextstring, 1, 1, 1)

	If Not IsArray($WorkArray) Then

		MsgBox(0, "", $lng_nofiles)

		GUISetState(@SW_SHOW, $Mainwindow)

		GUISetState(@SW_HIde, $Afterworkwindow)

 		_LastModule()
		Return

	EndIf

	_GUI_Show_Corection_Audio()
	_Corection_Audio($WorkArray)

	_WriteLog("Audio Metadata Manual Modification - Finished")

	GUISetState(@SW_HIde, $Afterworkwindow)
	GUISetState(@SW_SHOW, $Mainwindow)

EndFunc

; Function to show Album Correction Window
Func _Corection_Album($in_artist)

	Local $nfo, $Ifile, $cInfo, $InputFile, $tvshow, $iFileExists,$InDir, $artistpath
	Local $iPathSplit, $sDrive, $sDir, $sFilename, $sExtension, $artists, $fanartfolder

	Local $InDir = GUICtrlRead($input_64_01), $i, $cInfo, $albumpath

	Dim $WorkArray[1] = [0]

	Dim $album[0]

	_GUI_Show_Corection_Album()

	GUICtrlSetData($listview_150_01, "")

	$WorkArray = _FileListToArrayRec($InDir & "\" & $in_artist, "*", 2, 0, 0)

	If IsArray($WorkArray) Then

		_GUICtrlListView_BeginUpdate($listview_150_01)

		For $i = 1 To UBound($WorkArray) - 1

			If $WorkArray[$i] = "extrafanart" Then

			Else

			GUICtrlSetData($listview_150_01, $WorkArray[$i], $WorkArray[1])

			_ArrayAdd($album, $WorkArray[$i])

			EndIf

		Next

		_GUICtrlListView_EndUpdate($listview_150_01)

	Else

		MsgBox(0, "", $lng_noalbums)

		_GUI_Show_Corection_Audio()

		Return

	EndIf


;Gui Loop
	While 1

		_GetTime()

		_GetListAlbum($in_artist, $WorkArray)

		$i = _ArraySearch($album, GUICtrlRead($listview_150_01))

		$albumpath = $InDir & "\" & $in_artist & "\" & $album[$i]

		Local $msg1 = GUIGetMsg(1)
		Select

			Case $msg1[0] = $infoitem100
				MsgBox(0, $lng_about & " " & $Title, "Media-Buddy" & @CRLF & @CRLF & "(C) 2020 Lehmden" & @CRLF & @CRLF & "Version: " & $version)


			Case $msg1[0] = $button_150_01

 				_WriteData_150(GUICtrlRead($listview_150_01), $in_artist)
				_GUI_Show_Corection_Audio()

				Return

			Case $msg1[0] = $GUI_EVENT_PRIMARYDOWN

				$cInfo = GUIGetCursorInfo($Afterworkwindow)
				If IsArray($cInfo) Then

					If $cInfo[2] = 1 AND $cInfo[4] = $Pic_150_01 Then

						$ini_fanart_inputfolder = IniRead(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_fanart_inputfolder", @MyDocumentsDir)

						$InputFile = FileOpenDialog($lng_choose, $ini_fanart_inputfolder, "Images (*.jpg)")

						If $InputFile <> "" Then

							$fanartfolder = _PathSplit($InputFile, $sDrive, $sDir, $sFilename, $sExtension)

							IniWrite(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_fanart_inputfolder", $fanartfolder[1] & $fanartfolder[2])

							FileCopy($InputFile,$albumpath & "\folder.jpg", 1)

							GUICtrlSetImage($Pic_150_01, $albumpath & "\folder.jpg")

						EndIf

					EndIf

					If $cInfo[2] = 1 AND $cInfo[4] = $Pic_150_02 Then

						$ini_fanart_inputfolder = IniRead(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_fanart_inputfolder", @MyDocumentsDir)

						$InputFile = FileOpenDialog($lng_choose, $ini_fanart_inputfolder, "Images (*.png)")

						If $InputFile <> "" Then

							$fanartfolder = _PathSplit($InputFile, $sDrive, $sDir, $sFilename, $sExtension)

							IniWrite(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_fanart_inputfolder", $fanartfolder[1] & $fanartfolder[2])

							FileCopy($InputFile, $albumpath & "\discart.png", 1)

							GUICtrlSetImage($Pic_150_02, _Display_PNG($albumpath & "\discart.png"))

						EndIf

					EndIf

				EndIf


			Case $msg1[0] = $GUI_EVENT_CLOSE Or $msg1[0] = $Exititem100
				_WriteLog("Corection_Audio - Finished")
				_Exit()

				Return

		EndSelect

		Sleep(20)

	WEnd

	_WriteLog("Corection_Audio - Finished")

	Return

	_WriteLog("Audio Metadata Manual Modification - Finished")

	GUISetState(@SW_HIde, $Afterworkwindow)
	GUISetState(@SW_SHOW, $Mainwindow)

EndFunc

; Function to show Audio Correction Window
Func _Corection_Audio($WorkArray)

	_WriteLog("Corection_Audio - Started")

	Local $nfo, $Ifile, $cInfo, $InputFile, $tvshow, $iFileExists,$InDir, $artistpath
	Local $iPathSplit, $sDrive, $sDir, $sFilename, $sExtension, $artists, $fanartfolder
	Dim $artist[1]

	$InDir = GUICtrlRead($input_64_01)

	For $i = 1 To UBound($WorkArray) - 1

		If $ini_artist = "1" Then

				$iPathSplit = _PathSplit($WorkArray[$i], $sDrive, $sDir, $sFilename, $sExtension)

				$artists = StringSplit($sDir, "\", 1)

				_ArrayAdd($artist, $artists[1])

		EndIf

		If $ini_artist = "2" Then

				_ArrayAdd($artist, $WorkArray[$i])

		EndIf


	Next

	_ArrayUnique($artist)

	_ArraySort($artist)

	GUICtrlDelete($listview_140_01)

	$listview_140_01 = GUICtrlCreateList("", 20, 230, 260, 340, $LBS_DISABLENOSCROLL + $WS_BORdeR + $WS_VSCROLL, $ES_READONLY)

	_GUICtrlListView_BeginUpdate($listview_140_01)

	For $i = 1 To UBound($artist) - 1

		GUICtrlSetData($listview_140_01, $artist[$i])

	Next

	GUICtrlSetData($listview_140_01, $artist[1])

	_GUICtrlListView_EndUpdate($listview_140_01)


;Gui Loop
	While 1

		_GetTime()

		_GetListAudio()

		$i = _ArraySearch($artist, GUICtrlRead($listview_140_01))

		$artistpath = $InDir & "\" & $artist[$i]

		Local $msg1 = GUIGetMsg(1)
		Select

			Case $msg1[0] = $infoitem100
				MsgBox(0, $lng_about & " " & $Title, "Media-Buddy" & @CRLF & @CRLF & "(C) 2020 Lehmden" & @CRLF & @CRLF & "Version: " & $version)


			Case $msg1[0] = $button_140_01

				_WriteData_140(GUICtrlRead($listview_140_01))

				_Corection_Album(GUICtrlRead($listview_140_01))


			Case $msg1[0] = $button_140_02

				_WriteData_140(GUICtrlRead($listview_140_01))

				Return


			Case $msg1[0] = $button_140_03

				If $ini_artistfolderuse = "1" Then

					_CopyArtistFanart($InDir)

					MsgBox(0, "", $lng_sucess, 3)

				Else

					MsgBox(0, "", $lng_noartist, 3)

				EndIf


			Case $msg1[0] = $button_140_04

				ShellExecute("https://" & $json_Language & ".wikipedia.org/wiki/" & GUICtrlRead($listview_140_01))


			Case $msg1[0] = $button_140_05

				ShellExecute("https://www.discogs.com/artist/" & GUICtrlRead($listview_140_01))


			Case $msg1[0] = $GUI_EVENT_PRIMARYDOWN

				$cInfo = GUIGetCursorInfo($Afterworkwindow)
				If IsArray($cInfo) Then

					If $cInfo[2] = 1 AND $cInfo[4] = $Pic_140_01 Then

						$ini_fanart_inputfolder = IniRead(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_fanart_inputfolder", @MyDocumentsDir)

						$InputFile = FileOpenDialog($lng_choose, $ini_fanart_inputfolder, "Images (*.jpg)")

						If $InputFile <> "" Then

							$fanartfolder = _PathSplit($InputFile, $sDrive, $sDir, $sFilename, $sExtension)

							IniWrite(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_fanart_inputfolder", $fanartfolder[1] & $fanartfolder[2])

							FileCopy($InputFile, $artistpath & "\banner.jpg", 1)

							GUICtrlSetImage($Pic_140_01, $artistpath & "\banner.jpg")

						EndIf

					EndIf

					If $cInfo[2] = 1 AND $cInfo[4] = $Pic_140_02 Then

						$ini_fanart_inputfolder = IniRead(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_fanart_inputfolder", @MyDocumentsDir)

						$InputFile = FileOpenDialog($lng_choose, $ini_fanart_inputfolder, "Images (*.jpg)")

						If $InputFile <> "" Then

							$fanartfolder = _PathSplit($InputFile, $sDrive, $sDir, $sFilename, $sExtension)

							IniWrite(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_fanart_inputfolder", $fanartfolder[1] & $fanartfolder[2])

							FileCopy($InputFile, $artistpath & "\folder.jpg", 1)

							GUICtrlSetImage($Pic_140_02, $artistpath & "\folder.jpg")

						EndIf

					EndIf

					If $cInfo[2] = 1 AND $cInfo[4] = $Pic_140_03 Then

						$ini_fanart_inputfolder = IniRead(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_fanart_inputfolder", @MyDocumentsDir)

						$InputFile = FileOpenDialog($lng_choose, $ini_fanart_inputfolder, "Images (*.jpg)")

						If $InputFile <> "" Then

							$fanartfolder = _PathSplit($InputFile, $sDrive, $sDir, $sFilename, $sExtension)

							IniWrite(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_fanart_inputfolder", $fanartfolder[1] & $fanartfolder[2])

							FileCopy($InputFile, $artistpath & "\fanart.jpg", 1)

							GUICtrlSetImage($Pic_140_03, $artistpath & "\fanart.jpg")

						EndIf

					EndIf

					If $cInfo[2] = 1 AND $cInfo[4] = $Pic_140_04 Then

						$ini_fanart_inputfolder = IniRead(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_fanart_inputfolder", @MyDocumentsDir)

						$InputFile = FileOpenDialog($lng_choose, $ini_fanart_inputfolder, "Images (*.png)")

						If $InputFile <> "" Then

							$fanartfolder = _PathSplit($InputFile, $sDrive, $sDir, $sFilename, $sExtension)

							IniWrite(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_fanart_inputfolder", $fanartfolder[1] & $fanartfolder[2])

							FileCopy($InputFile, $artistpath & "\clearlogo.png", 1)

							GUICtrlSetImage($Pic_140_04, _Display_PNG($artistpath & "\clearlogo.png"))

						EndIf

					EndIf

				EndIf

			Case $msg1[0] = $GUI_EVENT_CLOSE Or $msg1[0] = $Exititem100
				_WriteLog("Corection_Audio - Finished")
				_Exit()

				Return

		EndSelect

		Sleep(20)

	WEnd

	_WriteLog("Corection_Audio - Finished")

	Return

EndFunc

;Function to show Movies Metadata Correction Window
Func _Metadata_Correction_Movies()

	_WriteLog("Movies Metadata Manual Modification - Started")

	GUISetState(@SW_HIde, $Mainwindow)

	_ClearGUI($Array_GUI_Elements_100)
	_ClearGUI($Array_GUI_Elements_110)
	_ClearGUI($Array_GUI_Elements_120)
	_ClearGUI($Array_GUI_Elements_121)
	_ClearGUI($Array_GUI_Elements_122)
	_ClearGUI($Array_GUI_Elements_130)
	_ClearGUI($Array_GUI_Elements_140)

	GUICtrlSetImage($Pic_120_00, @ScriptDir & "\Images\img_poster.jpg")
	GUICtrlSetImage($Pic_120_20, @ScriptDir & "\Images\img_poster.jpg")
	GUICtrlSetImage($Pic_120_30, @ScriptDir & "\Images\img_poster.jpg")
	GUICtrlSetImage($Pic_120_21, @ScriptDir & "\Images\img_banner.jpg")
	GUICtrlSetImage($Pic_120_31, @ScriptDir & "\Images\img_banner.jpg")
	GUICtrlSetImage($Pic_120_22, @ScriptDir & "\Images\img_background.jpg")
	GUICtrlSetImage($Pic_120_26, @ScriptDir & "\Images\img_background.jpg")
	GUICtrlSetImage($Pic_120_32, @ScriptDir & "\Images\img_background.jpg")
	GUICtrlSetImage($Pic_120_36, @ScriptDir & "\Images\img_background.jpg")
	GUICtrlSetImage($Pic_120_24, _Display_PNG(@ScriptDir & "\Images\img_clearart.png"))
	GUICtrlSetImage($Pic_120_25, _Display_PNG(@ScriptDir & "\Images\img_clearart.png"))
	GUICtrlSetImage($Pic_120_34, _Display_PNG(@ScriptDir & "\Images\img_clearart.png"))
	GUICtrlSetImage($Pic_120_35, _Display_PNG(@ScriptDir & "\Images\img_clearart.png"))
	GUICtrlSetImage($Pic_120_23, _Display_PNG(@ScriptDir & "\Images\img_disc.png"))

	GUISetState(@SW_SHOW, $Afterworkwindow)

	Dim $PathSplit[1]

	Local $InDir = GUICtrlRead($input_62_01)

	Local $WorkArray = _FileListToArrayRec($InDir, $extstring2, 1, 1,1)

	If Not IsArray($WorkArray) Then

		MsgBox(0, "", $lng_nofiles)

		GUISetState(@SW_SHOW, $Mainwindow)

		GUISetState(@SW_HIde, $Afterworkwindow)

		_LastModule()

		Return

	EndIf

	_GUI_Show_Corection_Movies()
	_Corection_Movies()

	_WriteLog("Movies Metadata Manual Modification - Finished")

	GUISetState(@SW_HIde, $Afterworkwindow)
	GUISetState(@SW_SHOW, $Mainwindow)

EndFunc

; Function to Movie Path Correction
Func _Corection_Moviepath()

	Local $tvnfo, $Ifile, $cInfo, $InputFile, $tvshow, $iFileExists, $InDir, $fanartfolder, $title, $jahr
	Local $iPathSplit, $sDrive, $sDir, $sFilename, $sExtension, $moviepath, $i, $moviesetpath, $year
	Dim $movie[1]
	Dim $movieext[1]
	Dim $moviefolder[1]

	Local $InDir = GUICtrlRead($input_62_01)

	Local $WorkArray = _FileListToArrayRec($InDir, $extstring2, 1, 1, 1)

	For $i = 1 To UBound($WorkArray) - 1

		$iPathSplit = _PathSplit($WorkArray[$i], $sDrive, $sDir, $sFilename, $sExtension)

		_ArrayAdd($movie, $iPathSplit[3])

		_ArrayAdd($movieext, $iPathSplit[4])

		_ArrayAdd($moviefolder, $iPathSplit[2])

	Next

	For $i = 1 To UBound($WorkArray) - 1

		_SetLabel($Label192, $lng_workingon & " " & $moviefolder[$i])

		$moviepath = $InDir & "\" & $moviefolder[$i]

		$nfo = $moviepath & $movie[$i] & ".nfo"

		$iFileExists = FileExists($nfo)

		If $iFileExists = 1 Then

			$Ifile = FileOpen($nfo, 128)

			$tvnfo = FileRead($Ifile)

			FileClose($Ifile)

			$title = _StringBetween($tvnfo, "<title>", "</title>",0)

			$year = _StringBetween($tvnfo, "<year>", "</year>",0)

			If  _ElementExists($year, 0) Then

				$jahr = $year[0]

			Else

				$jahr = "0000"

			EndIf


			If  _ElementExists($title, 0) Then

				If _FixPath($title[0]) = $movie[$i] Then

				Else

					FileMove($nfo, $moviepath & _FixPath($title[0]) & ".nfo")

					FileMove($moviepath  & $movie[$i] & $movieext[$i], $moviepath & _FixPath($title[0]) & $movieext[$i])

				EndIf

				If _FixPath($title[0]) = StringTrimRight($moviefolder[$i],8) Then

				Else

					Sleep(100)

					DirMove($moviepath, $InDir & "\" & _FixPath($title[0]) & " (" & $jahr & ")")

				EndIf

			EndIf

		EndIf

	Next

_SetLabel($Label192, $lng_waiting)

EndFunc

; Function to show Movies Correction Window
Func _Corection_Movies()

	_WriteLog("Corection_Movies - Started")

	Local $tvnfo, $Ifile, $cInfo, $InputFile, $tvshow, $iFileExists, $InDir, $fanartfolder
	Local $iPathSplit, $sDrive, $sDir, $sFilename, $sExtension, $moviepath, $i, $moviesetpath
	Dim $movie[1]
	Dim $movieext[1]
	Dim $moviefolder[1]

	Local $InDir = GUICtrlRead($input_62_01)

	Local $WorkArray = _FileListToArrayRec($InDir, $extstring2, 1, 1, 1)

	For $i = 1 To UBound($WorkArray) - 1

		$iPathSplit = _PathSplit($WorkArray[$i], $sDrive, $sDir, $sFilename, $sExtension)

		If StringInStr($iPathSplit[3], "-trailer",0) < 1  Then

			_ArrayAdd($movie, $iPathSplit[3])

			_ArrayAdd($movieext, $iPathSplit[4])

			_ArrayAdd($moviefolder, $iPathSplit[2])

		EndIf

	Next

	GUICtrlDelete($listview_120_01)

	$listview_120_01 = GUICtrlCreateList("", 20, 230, 260, 380, $LBS_DISABLENOSCROLL + $WS_BORdeR + $WS_VSCROLL, $ES_READONLY)

	For $i = 1 To UBound($movie) - 1

		GUICtrlSetData($listview_120_01, $movie[$i])

	Next

	GUICtrlSetData($listview_120_01, $movie[1])


;Gui Loop
	While 1

		_GetTime()

		_GetListMovies($WorkArray)

		$i = _ArraySearch($movie, _FixPath(GUICtrlRead($listview_120_01)))

;~ 		MsgBox(0,"", $i)

;~ 		_ArrayDisplay($moviefolder)

;~ 		If $i = -1 Then $moviepath = $InDir & "\" & _FixPath($moviefolder[$i])

;~ 		MsgBox(0,"", $moviepath & @CRLF & $moviefolder[$i])

		If $i > 0 Then

			$moviepath = $InDir & "\" & $moviefolder[$i]

;~ 			MsgBox(0,"", $i & @CRLF & $moviepath & @CRLF & $moviefolder[$i])

			$nfo = $moviepath & $movie[$i] & ".nfo"

			$iFileExists = FileExists($nfo)

			If $iFileExists = 1 Then

				$Ifile = FileOpen($nfo, 128)

				$tvnfo = FileRead($Ifile)

				FileClose($Ifile)

				$set = _StringBetween($tvnfo, "<set>", "</set>",0)

				If  _ElementExists($set, 0) Then

					If $ini_moviesetfolderuse = "1" Then

						$moviesetpath = $ini_moviesetfolder & "\" & $set[0] & "\"

					Else

						$moviesetpath = $moviepath & "movieset-"

					EndIf

				EndIf

			EndIf

		EndIf

		Local $msg1 = GUIGetMsg(1)

		Select

			Case $msg1[0] = $infoitem100

				MsgBox(0, $lng_about & " " & $Title, "Media-Buddy" & @CRLF & @CRLF & "(C) 2020 Lehmden" & @CRLF & @CRLF & "Version: " & $version)


			Case $msg1[0] = $button_120_01

				_GUI_Show_Corection_Movies()
				_SetData($Label_120_00b, $lng_metadata)


			Case $msg1[0] = $button_120_02

				_GUI_Show_Corection_Movies_Fanart()
				_SetData($Label_120_00b, "Fanart")


			Case $msg1[0] = $button_120_03

				_GUI_Show_Corection_Movieset_Fanart()
				_SetData($Label_120_00b, $lng_movieset)


			Case $msg1[0] = $button_120_04

				_WriteData_120(GUICtrlRead($listview_120_01))

;~ 				_Tag_Again("movies")
				_Tagmovies($InDir)

				Return


			Case $msg1[0] = $button_120_05

				_WriteData_120(GUICtrlRead($listview_120_01))

				Return

			Case $msg1[0] = $button_120_06

				ShellExecuteWait(@ScriptDir & '\mpv.exe', '"' & $moviepath & $movie[$i] & $movieext[$i] & '"', "", "Open", @SW_MAXIMIZE)


			Case $msg1[0] = $GUI_EVENT_PRIMARYDOWN

				$cInfo = GUIGetCursorInfo($Afterworkwindow)

				If IsArray($cInfo) Then

						If $cInfo[2] = 1 AND $cInfo[4] = $Pic_120_00 Then

							$ini_fanart_inputfolder = IniRead(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_fanart_inputfolder", @MyDocumentsDir)

							$InputFile = FileOpenDialog($lng_choose, $ini_fanart_inputfolder, "Images (*.jpg)")

							If $InputFile <> "" Then

								$fanartfolder = _PathSplit($InputFile, $sDrive, $sDir, $sFilename, $sExtension)

								IniWrite(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_fanart_inputfolder", $fanartfolder[1] & $fanartfolder[2])

								If $ini_naming_mp1 = "1" Then FileCopy($InputFile, $moviepath & "\folder.jpg",1)

 								If $ini_naming_default = "1" Or $ini_naming_emby = "1" Then

									FileCopy($InputFile, $moviepath & "\poster.jpg",1)

								EndIf

								If $ini_naming_mp1 = "1" Then

									GUICtrlSetImage($Pic_120_00, $moviepath & "\folder.jpg")

								Else

									GUICtrlSetImage($Pic_120_00, $moviepath & "\poster.jpg")

								EndIf

							EndIf

						EndIf

						If $cInfo[2] = 1 AND $cInfo[4] = $Pic_120_20 Then

							$ini_fanart_inputfolder = IniRead(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_fanart_inputfolder", @MyDocumentsDir)

							$InputFile = FileOpenDialog($lng_choose, $ini_fanart_inputfolder, "Images (*.jpg)")

							If $InputFile <> "" Then

								$fanartfolder = _PathSplit($InputFile, $sDrive, $sDir, $sFilename, $sExtension)

								IniWrite(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_fanart_inputfolder", $fanartfolder[1] & $fanartfolder[2])

								If $ini_naming_mp1 = "1" Then FileCopy($InputFile, $moviepath & "\folder.jpg",1)

 								If $ini_naming_default = "1" Or $ini_naming_emby = "1" Then

									FileCopy($InputFile, $moviepath & "\poster.jpg",1)

								EndIf

								If $ini_naming_mp1 = "1" Then

									GUICtrlSetImage($Pic_120_20, $moviepath & "\folder.jpg")

								Else

									GUICtrlSetImage($Pic_120_20, $moviepath & "\poster.jpg")

								EndIf

							EndIf

						EndIf

						If $cInfo[2] = 1 AND $cInfo[4] = $Pic_120_21 Then

							$ini_fanart_inputfolder = IniRead(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_fanart_inputfolder", @MyDocumentsDir)

							$InputFile = FileOpenDialog($lng_choose, $ini_fanart_inputfolder, "Images (*.jpg)")

							If $InputFile <> "" Then

								$fanartfolder = _PathSplit($InputFile, $sDrive, $sDir, $sFilename, $sExtension)

								IniWrite(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_fanart_inputfolder", $fanartfolder[1] & $fanartfolder[2])

								FileCopy($InputFile, $moviepath & "banner.jpg", 1)

								GUICtrlSetImage($Pic_120_21, $moviepath & "banner.jpg")

							EndIf

						EndIf

						If $cInfo[2] = 1 AND $cInfo[4] = $Pic_120_22 Then

							$ini_fanart_inputfolder = IniRead(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_fanart_inputfolder", @MyDocumentsDir)

							$InputFile = FileOpenDialog($lng_choose, $ini_fanart_inputfolder, "Images (*.jpg)")

							If $InputFile <> "" Then

								$fanartfolder = _PathSplit($InputFile, $sDrive, $sDir, $sFilename, $sExtension)

								IniWrite(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_fanart_inputfolder", $fanartfolder[1] & $fanartfolder[2])

								FileCopy($InputFile, $moviepath & $json_Filenaming_Movie_Image_Fanart, 1)

								GUICtrlSetImage($Pic_120_22, $moviepath & $json_Filenaming_Movie_Image_Fanart)

							EndIf

						EndIf

						If $cInfo[2] = 1 AND $cInfo[4] = $Pic_120_23 Then

							$ini_fanart_inputfolder = IniRead(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_fanart_inputfolder", @MyDocumentsDir)

							$InputFile = FileOpenDialog($lng_choose, $ini_fanart_inputfolder, "Images (*.png)")

							If $InputFile <> "" Then

								$fanartfolder = _PathSplit($InputFile, $sDrive, $sDir, $sFilename, $sExtension)

								IniWrite(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_fanart_inputfolder", $fanartfolder[1] & $fanartfolder[2])

								If $ini_naming_emby = "1" Then FileCopy($InputFile, $moviepath & "\disc.png",1)

 								If $ini_naming_default = "1" Or $ini_naming_mp1 = "1" Then

									FileCopy($InputFile, $moviepath & "\discart.png",1)

								EndIf

								If $ini_naming_emby = "1" Then

									GUICtrlSetImage($Pic_120_23, _Display_PNG($moviepath & "\disc.png"))

								Else

									GUICtrlSetImage($Pic_120_23, _Display_PNG($moviepath & "\discart.png"))

								EndIf


							EndIf

						EndIf

						If $cInfo[2] = 1 AND $cInfo[4] = $Pic_120_24 Then

							$ini_fanart_inputfolder = IniRead(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_fanart_inputfolder", @MyDocumentsDir)

							$InputFile = FileOpenDialog($lng_choose, $ini_fanart_inputfolder, "Images (*.png)")

							If $InputFile <> "" Then

								$fanartfolder = _PathSplit($InputFile, $sDrive, $sDir, $sFilename, $sExtension)

								IniWrite(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_fanart_inputfolder", $fanartfolder[1] & $fanartfolder[2])

								FileCopy($InputFile, $moviepath & "clearart.png",1)

								GUICtrlSetImage($Pic_120_24, _Display_PNG($moviepath & "clearart.png"))

							EndIf

						EndIf

						If $cInfo[2] = 1 AND $cInfo[4] = $Pic_120_25 Then

							$ini_fanart_inputfolder = IniRead(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_fanart_inputfolder", @MyDocumentsDir)

							$InputFile = FileOpenDialog($lng_choose, $ini_fanart_inputfolder, "Images (*.png)")

							If $InputFile <> "" Then

								$fanartfolder = _PathSplit($InputFile, $sDrive, $sDir, $sFilename, $sExtension)

								IniWrite(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_fanart_inputfolder", $fanartfolder[1] & $fanartfolder[2])

								If $ini_naming_emby = "1" Then FileCopy($InputFile, $moviepath & "\logo.png",1)

 								If $ini_naming_default = "1" Or $ini_naming_mp1 = "1" Then

									FileCopy($InputFile, $moviepath & "\clearlogo.png",1)

								EndIf

								If $ini_naming_emby = "1" Then

									GUICtrlSetImage($Pic_120_25, _Display_PNG($moviepath & "\logo.png"))

								Else

									GUICtrlSetImage($Pic_120_25, _Display_PNG($moviepath & "\clearlogo.png"))

								EndIf

							EndIf

						EndIf

						If $cInfo[2] = 1 AND $cInfo[4] = $Pic_120_26 Then

							$ini_fanart_inputfolder = IniRead(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_fanart_inputfolder", @MyDocumentsDir)

							$InputFile = FileOpenDialog($lng_choose, $ini_fanart_inputfolder, "Images (*.jpg)")

							If $InputFile <> "" Then

								$fanartfolder = _PathSplit($InputFile, $sDrive, $sDir, $sFilename, $sExtension)

								IniWrite(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_fanart_inputfolder", $fanartfolder[1] & $fanartfolder[2])

								FileCopy($InputFile, $moviepath & "landscape.jpg", 1)

								GUICtrlSetImage($Pic_120_26, $moviepath & "landscape.jpg")

							EndIf

						EndIf

						If $cInfo[2] = 1 AND $cInfo[4] = $Pic_120_30 Then

							$ini_fanart_inputfolder = IniRead(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_fanart_inputfolder", @MyDocumentsDir)

							$InputFile = FileOpenDialog($lng_choose, $ini_fanart_inputfolder, "Images (*.jpg)")

							If $InputFile <> "" Then

								$fanartfolder = _PathSplit($InputFile, $sDrive, $sDir, $sFilename, $sExtension)

								IniWrite(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_fanart_inputfolder", $fanartfolder[1] & $fanartfolder[2])

								If $ini_naming_mp1 = "1" Then FileCopy($InputFile, $moviesetpath & "folder.jpg",1)

 								If $ini_naming_default = "1" Or $ini_naming_emby = "1" Then

									FileCopy($InputFile, $moviesetpath & "poster.jpg",1)

								EndIf

								If $ini_naming_mp1 = "1" Then

									GUICtrlSetImage($Pic_120_30, $moviesetpath & "folder.jpg")

								Else

									GUICtrlSetImage($Pic_120_30, $moviesetpath & "poster.jpg")

								EndIf

							EndIf

						EndIf

						If $cInfo[2] = 1 AND $cInfo[4] = $Pic_120_31 Then

							$ini_fanart_inputfolder = IniRead(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_fanart_inputfolder", @MyDocumentsDir)

							$InputFile = FileOpenDialog($lng_choose, $ini_fanart_inputfolder, "Images (*.jpg)")

							If $InputFile <> "" Then

								$fanartfolder = _PathSplit($InputFile, $sDrive, $sDir, $sFilename, $sExtension)

								IniWrite(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_fanart_inputfolder", $fanartfolder[1] & $fanartfolder[2])

								FileCopy($InputFile, $moviesetpath & "banner.jpg", 1)

								GUICtrlSetImage($Pic_120_31, $moviesetpath & "banner.jpg")

							EndIf

						EndIf

						If $cInfo[2] = 1 AND $cInfo[4] = $Pic_120_32 Then

							$ini_fanart_inputfolder = IniRead(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_fanart_inputfolder", @MyDocumentsDir)

							$InputFile = FileOpenDialog($lng_choose, $ini_fanart_inputfolder, "Images (*.jpg)")

							If $InputFile <> "" Then

								$fanartfolder = _PathSplit($InputFile, $sDrive, $sDir, $sFilename, $sExtension)

								IniWrite(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_fanart_inputfolder", $fanartfolder[1] & $fanartfolder[2])

								FileCopy($InputFile, $moviesetpath & $json_Filenaming_Movie_Image_Fanart, 1)

								GUICtrlSetImage($Pic_120_32, $moviesetpath & $json_Filenaming_Movie_Image_Fanart)

							EndIf

						EndIf

						If $cInfo[2] = 1 AND $cInfo[4] = $Pic_120_34 Then

							$ini_fanart_inputfolder = IniRead(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_fanart_inputfolder", @MyDocumentsDir)

							$InputFile = FileOpenDialog($lng_choose, $ini_fanart_inputfolder, "Images (*.png)")

							If $InputFile <> "" Then

								$fanartfolder = _PathSplit($InputFile, $sDrive, $sDir, $sFilename, $sExtension)

								IniWrite(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_fanart_inputfolder", $fanartfolder[1] & $fanartfolder[2])

								FileCopy($InputFile, $moviesetpath & "clearart.png",1)

								GUICtrlSetImage($Pic_120_34, _Display_PNG($moviesetpath & "clearart.png"))

							EndIf

						EndIf

						If $cInfo[2] = 1 AND $cInfo[4] = $Pic_120_35 Then

							$ini_fanart_inputfolder = IniRead(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_fanart_inputfolder", @MyDocumentsDir)

							$InputFile = FileOpenDialog($lng_choose, $ini_fanart_inputfolder, "Images (*.png)")

							If $InputFile <> "" Then

								$fanartfolder = _PathSplit($InputFile, $sDrive, $sDir, $sFilename, $sExtension)

								IniWrite(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_fanart_inputfolder", $fanartfolder[1] & $fanartfolder[2])

								If $ini_naming_emby = "1" Then FileCopy($InputFile, $moviesetpath & "logo.png",1)

 								If $ini_naming_default = "1" Or $ini_naming_mp1 = "1" Then

									FileCopy($InputFile, $moviesetpath & "clearlogo.png",1)

								EndIf

								If $ini_naming_emby = "1" Then

									GUICtrlSetImage($Pic_120_35, _Display_PNG($moviesetpath & "logo.png"))

								Else

									GUICtrlSetImage($Pic_120_35, _Display_PNG($moviesetpath & "clearlogo.png"))

								EndIf

							EndIf

						EndIf

						If $cInfo[2] = 1 AND $cInfo[4] = $Pic_120_36 Then

							$ini_fanart_inputfolder = IniRead(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_fanart_inputfolder", @MyDocumentsDir)

							$InputFile = FileOpenDialog($lng_choose, $ini_fanart_inputfolder, "Images (*.jpg)")

							If $InputFile <> "" Then

								$fanartfolder = _PathSplit($InputFile, $sDrive, $sDir, $sFilename, $sExtension)

								IniWrite(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_fanart_inputfolder", $fanartfolder[1] & $fanartfolder[2])

								FileCopy($InputFile, $moviesetpath & "landscape.jpg", 1)

								GUICtrlSetImage($Pic_120_36, $moviesetpath & "landscape.jpg")

							EndIf

						EndIf


				EndIf


			Case $msg1[0] = $GUI_EVENT_CLOSE Or $msg1[0] = $Exititem100

				_Exit()

		EndSelect

		Sleep(20)

	WEnd

	_WriteLog("Corection_Movies - Finished")

	Return

EndFunc

;Function to show Series Metadata Correction Window
Func _Metadata_Correction_Series()

	_WriteLog("Series Metadata Manual Modification - Started")

	GUISetState(@SW_HIde, $Mainwindow)

	_ClearGUI($Array_GUI_Elements_100)
	_ClearGUI($Array_GUI_Elements_110)
	_ClearGUI($Array_GUI_Elements_120)
	_ClearGUI($Array_GUI_Elements_121)
	_ClearGUI($Array_GUI_Elements_122)
	_ClearGUI($Array_GUI_Elements_130)
	_ClearGUI($Array_GUI_Elements_140)
	_ClearGUI($Array_GUI_Elements_150)

	GUICtrlSetImage($Pic_100_01, @ScriptDir & "\Images\img_banner.jpg")
	GUICtrlSetImage($Pic_100_02, @ScriptDir & "\Images\img_poster.jpg")
	GUICtrlSetImage($Pic_100_03, @ScriptDir & "\Images\img_background.jpg")
	GUICtrlSetImage($Pic_100_04, _Display_PNG(@ScriptDir & "\Images\img_clearart.png"))
	GUICtrlSetImage($Pic_100_05, _Display_PNG(@ScriptDir & "\Images\img_clearart.png"))

	GUISetState(@SW_SHOW, $Afterworkwindow)

	Dim $PathSplit[1]

	Local $WorkArray[1] = [0]

	Local $InDir = GUICtrlRead($input_61_01)

	IniWrite(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_series_correction_inputfolder", $InDir)

	$ini_series_correction_inputfolder = IniRead(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_series_correction_inputfolder", @MyDocumentsDir)

	$WorkArray = _FileListToArrayRec($InDir, $extstring2, 1, 1, 1)

	If Not IsArray($WorkArray) Then

		MsgBox(0, "", $lng_nofiles)

		GUISetState(@SW_SHOW, $Mainwindow)

		GUISetState(@SW_HIde, $Afterworkwindow)

		_LastModule()

		Return

	EndIf

	_GUI_Show_Corection_Series()
	_Corection_Series($WorkArray)

	_WriteLog("Series Metadata Manual Modification - Finished")

	GUISetState(@SW_HIde, $Afterworkwindow)
	GUISetState(@SW_SHOW, $Mainwindow)

EndFunc

; Function to show Episodes Correction Window
Func _Corection_Episodes($in_series);, $WorkArray1)

	Local $InDir = GUICtrlRead($input_61_01), $tvnfo, $Ifile, $cInfo, $InputFile, $split, $split1, $season, $t
	Local $iPathSplit, $sDrive, $sDir, $sFilename, $sExtension, $episodes, $tvshow, $iFileExists, $folder, $fanartfolder
	Dim $WorkArray[1] = [0]
	Dim $seasonfolder[1]
	Dim $seasonfolder1[1]

	If $ini_space_attach = "1" Then

		$folder = $json_TVShow_FolderSeason & " "

	Else

		$folder = $json_TVShow_FolderSeason

	EndIf

	_GUI_Show_Corection_Episodes()

	GUICtrlSetData($listview_110_01, "")

	$WorkArray = _FileListToArrayRec($InDir & "\" & $in_series, $extstring2, 1, 1, 1)

	_GUICtrlListView_BeginUpdate($listview_110_01)

	For $i = 1 To UBound($WorkArray) - 1

		$iPathSplit = _PathSplit($WorkArray[$i], $sDrive, $sDir, $sFilename, $sExtension)

		If $ini_gen_folder = "1" Then

			_ArrayAdd($seasonfolder, $iPathSplit[2])

		EndIf

		GUICtrlSetData($listview_110_01, $WorkArray[$i], $WorkArray[1])

	_GUICtrlListView_EndUpdate($listview_110_01)

	Next

	For $i = 1 To UBound($WorkArray) - 1

		$iPathSplit = _PathSplit($WorkArray[$i], $sDrive, $sDir, $sFilename, $sExtension)

 		If StringInStr($extstring, $iPathSplit[4], 0) Then

			If NOT FileExists ($InDir & "\" & $in_series & "\" & $iPathSplit[2] & $iPathSplit[3] & "-thumb.jpg") Then

				$option = ' -ss 00:02:00.000 -i "' & $InDir & "\" & $in_series & "\" & $iPathSplit[2] & $iPathSplit[3] & $iPathSplit[4] & '" -y -frames:v 1 "' & $tempdir & '\thumb.jpg"'

				ShellExecuteWait($ini_ffmpeg_path, $option, "", "", @SW_HIde)

				$option = '"' & $tempdir & '\thumb.jpg" -resize 640x360^ -background black -compose Copy \ -gravity center -extent 640x360 -normalize -unsharp 0x1 -quality 92 "' & $InDir & "\" & $in_series & "\" & $iPathSplit[2] & $iPathSplit[3] & '-thumb.jpg"'

				ShellExecuteWait(@ScriptDir & '\convert.exe', $option, "", "", @SW_HIde)

				_Optimize_Graphics_File($InDir & "\" & $in_series & "\" & $iPathSplit[2] & $iPathSplit[3] & '-thumb.jpg')

				GUICtrlSetImage($Pic_110_03, $InDir & "\" & $in_series & "\" & $iPathSplit[2] & $iPathSplit[3] & '-thumb.jpg')

			EndIf

		EndIf

	Next

;Gui Loop
	While 1

		_GetTime()

		_GetListEpisodes($in_series)

		Local $msg1 = GUIGetMsg(1)

		Select

			Case $msg1[0] = $infoitem100

				MsgBox(0, $lng_about & " " & $Title, "Media-Buddy" & @CRLF & @CRLF & "(C) 2022 Lehmden" & @CRLF & @CRLF & "Version: " & $version)


			Case $msg1[0] = $Button_110_00

				_WriteData_110(GUICtrlRead($listview_110_01), $in_series)

				GUICtrlSetData($Label_110_00a, $lng_episodes)

				_GUI_Show_Corection_Series()

				Return


			Case $msg1[0] = $button_110_01

				ShellExecuteWait(@ScriptDir & '\mpv.exe', '"' & $InDir & "\" & $in_series & "\" & GUICtrlRead($listview_110_01) & '"', "", "Open", @SW_MAXIMIZE)


			Case $msg1[0] = $button_110_02

				_Make_Thumb_Manual($InDir & "\" & $in_series & "\" & GUICtrlRead($listview_110_01))


			Case $msg1[0] = $GUI_EVENT_PRIMARYDOWN

				$cInfo = GUIGetCursorInfo($Afterworkwindow)
				If IsArray($cInfo) Then

						If $cInfo[2] = 1 AND $cInfo[4] = $Pic_110_02 Then

							$ini_fanart_inputfolder = IniRead(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_fanart_inputfolder", @MyDocumentsDir)

							$InputFile = FileOpenDialog($lng_choose, $ini_fanart_inputfolder, "Images (*.jpg)")

							If $InputFile <> "" Then

								$fanartfolder = _PathSplit($InputFile, $sDrive, $sDir, $sFilename, $sExtension)

								IniWrite(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_fanart_inputfolder", $fanartfolder[1] & $fanartfolder[2])

								$split = StringSplit(GUICtrlRead($listview_110_01), ".", 0)

								$split1 = StringSplit($split[1], "\", 0)

								$season = StringReplace($split1[1], $folder, "")

								If $season = "00" Then $season = "-specials"

								FileCopy($InputFile, $InDir & "\" & $in_series & "\season" & $season & "-poster.jpg", 1)

								GUICtrlSetImage($Pic_110_02, $InDir & "\" & $in_series & "\season" & $season & "-poster.jpg")

							EndIf

						EndIf


						If $cInfo[2] = 1 AND $cInfo[4] = $Pic_110_01 Then

							$ini_fanart_inputfolder = IniRead(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_fanart_inputfolder", @MyDocumentsDir)

							$InputFile = FileOpenDialog($lng_choose, $ini_fanart_inputfolder, "Images (*.jpg)")

							If $InputFile <> "" Then

								$fanartfolder = _PathSplit($InputFile, $sDrive, $sDir, $sFilename, $sExtension)

								IniWrite(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_fanart_inputfolder", $fanartfolder[1] & $fanartfolder[2])

								$split = StringSplit(GUICtrlRead($listview_110_01), ".", 0)

								$split1 = StringSplit($split[1], "\", 0)

								$season = StringReplace($split1[1], $folder, "")

								If $season = "00" Then $season = "-specials"

								FileCopy($InputFile, $InDir & "\" & $in_series & "\season" & $season & "-banner.jpg", 9)

								GUICtrlSetImage($Pic_110_01, $InDir & "\" & $in_series & "\season" & $season & "-banner.jpg")

							EndIf

						EndIf

						If $cInfo[2] = 1 AND $cInfo[4] = $Pic_110_03 Then

							$ini_fanart_inputfolder = IniRead(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_fanart_inputfolder", @MyDocumentsDir)

							$InputFile = FileOpenDialog($lng_choose, $ini_fanart_inputfolder, "Images (*.jpg;*.jpeg;*.jfif;*.avif;*.webp;*.png;*.bmp;*.tif)")

							If $InputFile <> "" Then

								$fanartfolder = _PathSplit($InputFile, $sDrive, $sDir, $sFilename, $sExtension)

								If $fanartfolder[4] = ".jpg" Or $fanartfolder[4] = ".jpeg" Or $fanartfolder[4] = ".jfif" Then

									IniWrite(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_fanart_inputfolder", $fanartfolder[1] & $fanartfolder[2])

									$split = _PathSplit($InDir & "\" & $in_series & "\" & GUICtrlRead($listview_110_01), $sDrive, $sDir, $sFilename, $sExtension)

									FileCopy($InputFile, $split[1] & $split[2] & $split[3] & '-thumb.jpg', 1)

									GUICtrlSetImage($Pic_110_03, $split[1] & $split[2] & $split[3] & '-thumb.jpg')

								Else

									IniWrite(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_fanart_inputfolder", $fanartfolder[1] & $fanartfolder[2])

									$split = _PathSplit($InDir & "\" & $in_series & "\" & GUICtrlRead($listview_110_01), $sDrive, $sDir, $sFilename, $sExtension)

									FileDelete($split[1] & $split[2] & $split[3] & '-thumb.jpg')

									$option = ' -out jpeg -o "' & $split[1] & $split[2] & $split[3] & '-thumb.jpg" "' & $InputFile & '"'

									ShellExecuteWait(@ScriptDir & '\nconvert.exe', $option, @ScriptDir, "", @SW_HIDE)

									GUICtrlSetImage($Pic_110_03, $split[1] & $split[2] & $split[3] & '-thumb.jpg')

								EndIf

							EndIf

						EndIf

				EndIf


			Case $msg1[0] = $GUI_EVENT_CLOSE Or $msg1[0] = $Exititem100

				_Exit()


		EndSelect

		Sleep(20)

	WEnd

	Return

EndFunc

; Function to show Series Correction Window
Func _Corection_Series($WorkArray)

	_WriteLog("Corection_Series - Started")

	Local $tvnfo, $Ifile, $cInfo, $InputFile, $tvshow, $iFileExists,$InDir, $listitem
	Local $iPathSplit, $sDrive, $sDir, $sFilename, $sExtension, $series, $fanartfolder
	Dim $serie1[0], $serie1[0]

	$InDir = GUICtrlRead($input_61_01)

	For $i = 1 To UBound($WorkArray) - 1

		$iPathSplit = _PathSplit($WorkArray[$i], $sDrive, $sDir, $sFilename, $sExtension)

		$series = StringSplit($sDir, "\", 1)

		_ArrayAdd($serie1, $series[1])

	Next

	$serie = _ArrayUnique($serie1,0,0,0,0)

	_ArraySort($serie)

	GUICtrlDelete($listview_100_01)

	$listview_100_01 = GUICtrlCreateList("", 20, 230, 260, 400, $LBS_DISABLENOSCROLL + $WS_BORdeR + $WS_VSCROLL, $ES_READONLY)

	_GUICtrlListView_BeginUpdate($listview_100_01)

	GUICtrlSetData($listview_100_01, $serie[0])

	If UBound($serie) > 1 Then

		For $i = 1 To UBound($serie) - 1

			GUICtrlSetData($listview_100_01, $serie[$i])

		Next

	EndIf

	_GUICtrlListView_EndUpdate($listview_100_01)

	_SetData($progressbar_f23_01, 0)

;~ 	_SetData_100($serie[0])

;Gui Loop
	While 1

		_GetTime()

		_GetListSeries()

		Local $msg1 = GUIGetMsg(1)
		Select

			Case $msg1[0] = $infoitem100
				MsgBox(0, $lng_about & " " & $Title, "Media-Buddy" & @CRLF & @CRLF & "(C) 2020 Lehmden" & @CRLF & @CRLF & "Version: " & $version)


			Case $msg1[0] = $Button_100_00

				_WriteData_100(GUICtrlRead($listview_100_01))

				_TagSeries(GUICtrlRead($listview_100_01),"1")


			Case $msg1[0] = $button_100_01

				_Corection_Episodes(GUICtrlRead($listview_100_01))


			Case $msg1[0] = $Button_100_02

				_WriteData_100(GUICtrlRead($listview_100_01))

				Return


			Case $msg1[0] = $GUI_EVENT_CLOSE Or $msg1[0] = $Exititem100

				_Exit()


			Case $msg1[0] = $GUI_EVENT_PRIMARYDOWN

				$cInfo = GUIGetCursorInfo($Afterworkwindow)
				If IsArray($cInfo) Then

						If $cInfo[2] = 1 AND $cInfo[4] = $Pic_100_01 Then

							$ini_fanart_inputfolder = IniRead(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_fanart_inputfolder", @MyDocumentsDir)

							$InputFile = FileOpenDialog($lng_choose, $ini_fanart_inputfolder, "Images (*.jpg)")

							If $InputFile <> "" Then

								$fanartfolder = _PathSplit($InputFile, $sDrive, $sDir, $sFilename, $sExtension)

								IniWrite(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_fanart_inputfolder", $fanartfolder[1] & $fanartfolder[2])

								FileCopy($InputFile, $InDir & "\" & GUICtrlRead($listview_100_01) & "\banner.jpg", 1)

								GUICtrlSetImage($Pic_100_01, $InDir & "\" & GUICtrlRead($listview_100_01) & "\banner.jpg")

							EndIf

						EndIf

						If $cInfo[2] = 1 AND $cInfo[4] = $Pic_100_02 Then

							$ini_fanart_inputfolder = IniRead(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_fanart_inputfolder", @MyDocumentsDir)

							$InputFile = FileOpenDialog($lng_choose, $ini_fanart_inputfolder, "Images (*.jpg)")

							If $InputFile <> "" Then

								$fanartfolder = _PathSplit($InputFile, $sDrive, $sDir, $sFilename, $sExtension)

								IniWrite(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_fanart_inputfolder", $fanartfolder[1] & $fanartfolder[2])

								FileCopy($InputFile, $InDir & "\" & GUICtrlRead($listview_100_01) & "\poster.jpg", 1)

								GUICtrlSetImage($Pic_100_02, $InDir & "\" & GUICtrlRead($listview_100_01) & "\poster.jpg")

							EndIf

						EndIf

						If $cInfo[2] = 1 AND $cInfo[4] = $Pic_100_03 Then

							$ini_fanart_inputfolder = IniRead(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_fanart_inputfolder", @MyDocumentsDir)

							$InputFile = FileOpenDialog($lng_choose, $ini_fanart_inputfolder, "Images (*.jpg)")

							If $InputFile <> "" Then

								$fanartfolder = _PathSplit($InputFile, $sDrive, $sDir, $sFilename, $sExtension)

								IniWrite(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_fanart_inputfolder", $fanartfolder[1] & $fanartfolder[2])

								FileCopy($InputFile, $InDir & "\" & GUICtrlRead($listview_100_01) & "\fanart.jpg", 1)

								GUICtrlSetImage($Pic_100_03, $InDir & "\" & GUICtrlRead($listview_100_01) & "\fanart.jpg")

							EndIf


						EndIf

						If $cInfo[2] = 1 AND $cInfo[4] = $Pic_100_04 Then

							$ini_fanart_inputfolder = IniRead(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_fanart_inputfolder", @MyDocumentsDir)

							$InputFile = FileOpenDialog($lng_choose, $ini_fanart_inputfolder, "Images (*.png)")

							If $InputFile <> "" Then

								$fanartfolder = _PathSplit($InputFile, $sDrive, $sDir, $sFilename, $sExtension)

								IniWrite(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_fanart_inputfolder", $fanartfolder[1] & $fanartfolder[2])

								FileCopy($InputFile, $InDir & "\" & GUICtrlRead($listview_100_01) & "\clearart.png",1)

								GUICtrlSetImage($Pic_100_04, _Display_PNG($InDir & "\" & GUICtrlRead($listview_100_01) & "\clearart.png"))

							EndIf

						EndIf

						If $cInfo[2] = 1 AND $cInfo[4] = $Pic_100_05 Then

							$ini_fanart_inputfolder = IniRead(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_fanart_inputfolder", @MyDocumentsDir)

							$InputFile = FileOpenDialog($lng_choose, $ini_fanart_inputfolder, "Images (*.png)")

							If $InputFile <> "" Then

								$fanartfolder = _PathSplit($InputFile, $sDrive, $sDir, $sFilename, $sExtension)

								IniWrite(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_fanart_inputfolder", $fanartfolder[1] & $fanartfolder[2])

 								If $ini_naming_default = "1" Then FileCopy($InputFile, $InDir & "\" & GUICtrlRead($listview_100_01) & "\clearlogo.png",1)

								If $ini_naming_emby = "1" Then FileCopy($InputFile, $InDir & "\" & GUICtrlRead($listview_100_01) & "\logo.png",1)

								If $ini_naming_default = "1" Then

									GUICtrlSetImage($Pic_100_05, _Display_PNG($InDir & "\" & GUICtrlRead($listview_100_01) & "\clearlogo.png"))

								ElseIf $ini_naming_emby = "1" Then

									GUICtrlSetImage($Pic_100_05, _Display_PNG($InDir & "\" & GUICtrlRead($listview_100_01) & "\logo.png"))

								Else

									GUICtrlSetImage($Pic_100_05, _Display_PNG($InDir & "\" & GUICtrlRead($listview_100_01) & "\clearlogo.png"))

								EndIf

							EndIf

						EndIf

				EndIf


		EndSelect

		Sleep(20)

	WEnd

	_WriteLog("Corection_Series - Finished")

	Return

EndFunc

;Function to show Movies Metadata Correction Window
Func _Metadata_Correction_Videos()

	_WriteLog("Videos Metadata Manual Modification - Started")

	GUISetState(@SW_HIde, $Mainwindow)

	_ClearGUI($Array_GUI_Elements_100)
	_ClearGUI($Array_GUI_Elements_110)
	_ClearGUI($Array_GUI_Elements_120)
	_ClearGUI($Array_GUI_Elements_121)
	_ClearGUI($Array_GUI_Elements_122)
	_ClearGUI($Array_GUI_Elements_130)
	_ClearGUI($Array_GUI_Elements_140)

	GUICtrlSetImage($Pic_130_02, @ScriptDir & "\Images\img_poster.jpg")
	GUICtrlSetImage($Pic_130_01, @ScriptDir & "\Images\img_background.jpg")

	GUISetState(@SW_SHOW, $Afterworkwindow)

	Dim $PathSplit[1]

	Local $WorkArray[1] = [0]

	Local $InDir = GUICtrlRead($input_63_01)

	$WorkArray = _FileListToArrayRec($InDir, $extstring, 1, 1, 1)

	If Not IsArray($WorkArray) Then

		MsgBox(0, "", $lng_nofiles)

		GUISetState(@SW_SHOW, $Mainwindow)

		GUISetState(@SW_HIde, $Afterworkwindow)

		_LastModule()
		Return

	EndIf

	_GUI_Show_Corection_Videos()
	_Corection_Videos()

	_WriteLog("Videos Metadata Manual Modification - Finished")

	GUISetState(@SW_HIde, $Afterworkwindow)
	GUISetState(@SW_SHOW, $Mainwindow)

EndFunc

; Function to show Videos Correction Window
Func _Corection_Videos()

	_WriteLog("Corection_Videos - Started")

	Local $tvnfo, $Ifile, $cInfo, $InputFile, $tvshow, $iFileExists, $InDir
	Local $iPathSplit, $sDrive, $sDir, $sFilename, $sExtension, $moviepath, $i
	Local $fanart, $cover, $file, $InDir, $fanartfolder
	Dim $movie[1]
	Dim $movieext[1]
	Dim $moviefolder[1]
	Dim $WorkArray[1]

	$InDir = GUICtrlRead($input_63_01)

	$WorkArray = _FileListToArrayRec($InDir, $extstring2, 1, 1, 1)

	For $i = 1 To UBound($WorkArray) - 1

		$iPathSplit = _PathSplit($WorkArray[$i], $sDrive, $sDir, $sFilename, $sExtension)

		_ArrayAdd($movie, $iPathSplit[3])

		_ArrayAdd($movieext, $iPathSplit[4])

		_ArrayAdd($moviefolder, $iPathSplit[2])

	Next

	$listitem_130_01 = GUICtrlRead($listview_130_01)

	GUICtrlDelete($listview_130_01)

	$listview_130_01 = GUICtrlCreateList("", 20, 230, 260, 380, $LBS_DISABLENOSCROLL + $WS_BORdeR + $WS_VSCROLL, $ES_READONLY)

	For $i = 1 To UBound($movie) - 1

		GUICtrlSetData($listview_130_01, $movie[$i])

	Next

	_SetData_130($listitem_130_01)

	GUICtrlSetData($listview_130_01, $movie[1])


;Gui Loop
	While 1

		_GetTime()

		_GetListVideos($WorkArray)

		$i = _ArraySearch($movie, GUICtrlRead($listview_130_01))

		$moviepath = $InDir & "\" & $moviefolder[$i]

		Local $msg1 = GUIGetMsg(1)
		Select

			Case $msg1[0] = $infoitem100
				MsgBox(0, $lng_about & " " & $Title, "Media-Buddy" & @CRLF & @CRLF & "(C) 2020 Lehmden" & @CRLF & @CRLF & "Version: " & $version)

			Case $msg1[0] = $GUI_EVENT_PRIMARYDOWN
				$cInfo = GUIGetCursorInfo($Afterworkwindow)
				If IsArray($cInfo) Then

						If $cInfo[2] = 1 AND $cInfo[4] = $Pic_130_02 Then

							$ini_fanart_inputfolder = IniRead(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_fanart_inputfolder", @MyDocumentsDir)

							$InputFile = FileOpenDialog($lng_choose, $ini_fanart_inputfolder, "Images (*.jpg)")

							$i = _ArraySearch($movie, GUICtrlRead($listview_130_01))

							$moviepath = $InDir & "\" & $moviefolder[$i]

							$cover = StringReplace($ini_fanart_cover, "{movie}", $movie[$i])

							If $InputFile <> "" Then

								$fanartfolder = _PathSplit($InputFile, $sDrive, $sDir, $sFilename, $sExtension)

								IniWrite(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_fanart_inputfolder", $fanartfolder[1] & $fanartfolder[2])

								FileCopy($InputFile, $moviepath & $cover, 1)

								GUICtrlSetImage($Pic_130_02, $moviepath & $cover)

							EndIf

						EndIf

						If $cInfo[2] = 1 AND $cInfo[4] = $Pic_130_01 Then

							$ini_fanart_inputfolder = IniRead(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_fanart_inputfolder", @MyDocumentsDir)

							$InputFile = FileOpenDialog($lng_choose, $ini_fanart_inputfolder, "Images (*.jpg)")

							$i = _ArraySearch($movie, GUICtrlRead($listview_130_01))

							$moviepath = $InDir & "\" & $moviefolder[$i]

							$fanart = StringReplace($ini_fanart_background, "{movie}", $movie[$i])

							If $InputFile <> "" Then

								$fanartfolder = _PathSplit($InputFile, $sDrive, $sDir, $sFilename, $sExtension)

								IniWrite(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_fanart_inputfolder", $fanartfolder[1] & $fanartfolder[2])

								FileCopy($InputFile, $moviepath & $fanart, 1)

								GUICtrlSetImage($Pic_130_01, $moviepath & $fanart)

							EndIf

						EndIf


				EndIf

			Case $msg1[0] = $Button_130_01

				$file = _WriteData_130(GUICtrlRead($listview_130_01))
 				_Tag_Again("videos", $file)
				_SetData_130($listitem_130_01)

			Case $msg1[0] = $Button_130_02

				_WriteData_130(GUICtrlRead($listview_130_01))
				Return

			Case $msg1[0] = $button_130_03

				ShellExecuteWait(@ScriptDir & '\mpv.exe', '"' & $moviepath & $movie[$i] & $movieext[$i] & '"', "", "Open", @SW_MAXIMIZE)


			Case $msg1[0] = $GUI_EVENT_CLOSE Or $msg1[0] = $Exititem100
				_WriteLog("Corection_Videos - Finished")
				_Exit()

		EndSelect

		Sleep(20)

	WEnd

	_WriteLog("Corection_Videos - Finished")

	Return

EndFunc

;Function to Set Data in Afterwork Window
Func _SetData_100($listitem)

	Local $InDir = GUICtrlRead($input_61_01), $tvnfo, $Ifile, $year, $ownID, $ownValue, $TestID
	Local $iPathSplit, $sDrive, $sDir, $sFilename, $sExtension, $series, $tvshow, $iFileExists
	Local $title, $sorttitle, $genre, $genre1, $plot, $mpaa, $tvdb, $tmdb, $imdb, $id, $i

	$tvshow = StringReplace($InDir & "\" & $listitem & "\tvshow.nfo", "–", "-")

	$iFileExists = FileExists($tvshow)

	If $iFileExists = 1 Then

		$Ifile = FileOpen($tvshow, 128)

		$tvnfo = FileRead($Ifile)

		FileClose($Ifile)

		$title = _StringBetween($tvnfo, "<title>", "</title>",0)

		$sorttitle = _StringBetween($tvnfo, "<sorttitle>", "</sorttitle>",0)

		$genre1 = _StringBetween($tvnfo, "<genre>", "</genre>",0)

		$genre = ""

		If IsArray($genre1) Then

			If UBound($genre1) > 1 Then

				$genre = $genre1[0]

				For $i = 1 to UBound($genre1) - 1

					$genre = $genre & "|" & $genre1[$i]

				Next

			Else

				$genre = $genre1[0]

			EndIf

		EndIf

		$plot = _StringBetween($tvnfo, "<plot>", "</plot>",0)

		$mpaa = _StringBetween($tvnfo, "<mpaa>", "</mpaa>",0)

		$status = _StringBetween($tvnfo, "<status>", "</status>",0)

		$year = _StringBetween($tvnfo, "<year>", "</year>",0)

		$rating = _StringBetween($tvnfo, "<rating>", "</rating>",0)

		$studio = _StringBetween($tvnfo, "<studio>", "</studio>",0)

		If $json_use_uniqueID = "true" Then

			$tvdb = _StringBetween($tvnfo, '<uniqueid type="tvdb">', '</uniqueid>',0)

			$tmdb = _StringBetween($tvnfo, '<uniqueid type="tmdb">', '</uniqueid>',0)

			$imdb = _StringBetween($tvnfo, '<uniqueid type="imdb">', '</uniqueid>',0)

			$TestID = _StringBetween($tvnfo, '<uniqueid type="', '"',0)

			If IsArray($TestID) Then

				For $i = 0 To UBound($TestID) - 1

					$ownID = $TestID[$i]

					If $TestID[$i] = "tmdb" Then $ownID = ""

					If $TestID[$i] = "tvdb" Then $ownID = ""

					If $TestID[$i] = "imdb" Then $ownID = ""

				Next

			EndIf

			$ownValue = _StringBetween($tvnfo, '<uniqueid type="' & $ownID & '">', '</uniqueid>',0)

		Else

			$tvdb = _StringBetween($tvnfo, '<tvdbid>', '</tvdbid>',0)

			$tmdb = _StringBetween($tvnfo, '<tmdbid>', '</tmdbid>',0)

			$imdb = _StringBetween($tvnfo, '<imdbid>', '</imdbid>',0)

			$ownID = ""

			$ownValue = ""

		EndIf

		GUICtrlSetData($input_100_20, $ownID)

		If  _ElementExists( $ownValue, 0) Then

			GUICtrlSetData($input_100_21, $ownValue[0])

		Else

			GUICtrlSetData($input_100_21, "")

		EndIf


		If  _ElementExists($title, 0) Then

			GUICtrlSetData($input_100_01, $title[0])

		Else

			GUICtrlSetData($input_100_01, "")

		EndIf

		If  _ElementExists($sorttitle, 0) Then

			GUICtrlSetData($input_100_02, $sorttitle[0])

		Else

			GUICtrlSetData($input_100_02, "")

		EndIf

		GUICtrlSetData($input_100_03, $genre)

		If  _ElementExists($mpaa, 0) Then

			GUICtrlSetData($input_100_04, $mpaa[0])

		Else

			GUICtrlSetData($input_100_04, "")

		EndIf

		If  _ElementExists($mpaa, 0) Then

			GUICtrlSetData($input_100_04, $mpaa[0])

		Else

			GUICtrlSetData($input_100_04, "")

		EndIf

		If  _ElementExists($year, 0) Then

			GUICtrlSetData($input_100_16, $year[0])

		Else

			GUICtrlSetData($input_100_16, "")

		EndIf

		If  _ElementExists($tvdb, 0) Then

			GUICtrlSetData($input_100_05, $tvdb[0])

		Else

			GUICtrlSetData($input_100_05, "")

		EndIf

		If  _ElementExists($tmdb, 0) Then

			GUICtrlSetData($input_100_05a, $tmdb[0])

		Else

			GUICtrlSetData($input_100_05a, "")

		EndIf

		If  _ElementExists($imdb, 0) Then

			GUICtrlSetData($input_100_05b, $imdb[0])

		Else

			GUICtrlSetData($input_100_05b, "")

		EndIf

		If  _ElementExists($status, 0) Then

			GUICtrlSetData($input_100_17, $status[0])

		Else

			GUICtrlSetData($input_100_17, "")

		EndIf



		If  _ElementExists($plot, 0) Then

			GUICtrlSetData($edit_100_04, $plot[0])

		Else

			GUICtrlSetData($edit_100_04, "")

		EndIf

		If  _ElementExists($studio, 0) Then

			GUICtrlSetData($input_100_19, $studio[0])

		Else

			GUICtrlSetData($input_100_19, "")

		EndIf

		If  _ElementExists($rating, 0) Then

			GUICtrlSetData($input_100_18, $rating[0])

		Else

			GUICtrlSetData($input_100_18, "")

		EndIf

		If FileExists($InDir & "\" & $listitem & "\banner.jpg") Then

			GUICtrlSetImage($Pic_100_01, $InDir & "\" & $listitem & "\banner.jpg")

		Else

			GUICtrlSetImage($Pic_100_01, @ScriptDir & "\Images\img_banner.jpg")

		EndIf

		If FileExists($InDir & "\" & $listitem & "\poster.jpg") Then

			GUICtrlSetImage($Pic_100_02, $InDir & "\" & $listitem & "\poster.jpg")

		Else

			GUICtrlSetImage($Pic_100_02, @ScriptDir & "\Images\img_poster.jpg")

		EndIf

		If FileExists($InDir & "\" & $listitem & "\fanart.jpg") Then

			GUICtrlSetImage($Pic_100_03, $InDir & "\" & $listitem & "\fanart.jpg")

		Else

			GUICtrlSetImage($Pic_100_03, @ScriptDir & "\Images\img_banner.jpg")

		EndIf

		If FileExists($InDir & "\" & $listitem & "\clearart.png") Then

			GUICtrlSetImage($Pic_100_04, _Display_PNG($InDir & "\" & $listitem & "\clearart.png"))

		Else

			GUICtrlSetImage($Pic_100_04, _Display_PNG(@ScriptDir & "\Images\img_clearart.png"))

		EndIf

		If FileExists($InDir & "\" & $listitem & "\clearlogo.png") Then

			GUICtrlSetImage($Pic_100_05, _Display_PNG($InDir & "\" & $listitem & "\clearlogo.png"))

		Elseif FileExists($InDir & "\" & $listitem & "\logo.png") Then

			GUICtrlSetImage($Pic_100_05, _Display_PNG($InDir & "\" & $listitem & "\logo.png"))

		Else

			GUICtrlSetImage($Pic_100_05, _Display_PNG(@ScriptDir & "\Images\img_clearart.png"))

		EndIf

	Else

		_WriteLog("Corection_Series - No tvshow.nfo found")

	EndIf

	Return

EndFunc

;Function to Set Data in Afterwork Window
Func _SetData_110($in_series, $listitem)

	Local $InDir = GUICtrlRead($input_61_01), $tvnfo, $tvnfo1, $Ifile, $season1
	Local $iPathSplit, $sDrive, $sDir, $sFilename, $sExtension, $series, $episodenfo, $iFileExists
	Local $title, $status, $genre, $plot, $showtitle, $year, $rating, $studio, $season, $episode

	$iPathSplit = _PathSplit($InDir & "\" & $in_series & "\" & $listitem, $sDrive, $sDir, $sFilename, $sExtension)

 	$episodenfo =  StringReplace($iPathSplit[1] & $iPathSplit[2] & $iPathSplit[3] & ".nfo", "–", "-")

	$iFileExists = FileExists($episodenfo)

	If $ini_space_attach = "1" Then

		$folder = $json_TVShow_FolderSeason & " "

	Else

		$folder = $json_TVShow_FolderSeason

	EndIf

	If $iFileExists = 1 Then

		$Ifile = FileOpen($episodenfo, 128)

		$tvnfo = FileRead($Ifile)

		FileClose($Ifile)

		$title = _StringBetween($tvnfo, "<title>", "</title>",0)

		$showtitle = _StringBetween($tvnfo, "<showtitle>", "</showtitle>",0)

		$genre = _StringBetween($tvnfo, "<genre>", "</genre>",0)

		$plot = _StringBetween($tvnfo, "<plot>", "</plot>",0)

		$status = _StringBetween($tvnfo, "<status>", "</status>",0)

		$year = _StringBetween($tvnfo, "<year>", "</year>",0)

		$rating = _StringBetween($tvnfo, "<rating>", "</rating>",0)

		$studio = _StringBetween($tvnfo, "<studio>", "</studio>",0)

		$season = _StringBetween($tvnfo, "<season>", "</season>",0)

		$episode = _StringBetween($tvnfo, "<episode>", "</episode>",0)

		If  _ElementExists($title, 0) Then

			GUICtrlSetData($input_110_01, $title[0])

		Else

			GUICtrlSetData($input_110_01, "")

		EndIf

		If  _ElementExists($showtitle, 0) Then

			GUICtrlSetData($input_110_05, $showtitle[0])

		Else

			GUICtrlSetData($input_110_05, "")

		EndIf

		If  _ElementExists($season, 0) Then

			GUICtrlSetData($input_110_04, $season[0])

		Else

			GUICtrlSetData($input_110_04, "")

		EndIf

		If  _ElementExists($episode, 0) Then

			GUICtrlSetData($input_110_04a, $episode[0])

		Else

			GUICtrlSetData($input_110_04a, "")

		EndIf

		If  _ElementExists($year, 0) Then

			GUICtrlSetData($input_110_06, $year[0])

		Else

			GUICtrlSetData($input_110_06, "")

		EndIf

		If  _ElementExists($plot, 0) Then

			GUICtrlSetData($edit_110_04, $plot[0])

		Else

			GUICtrlSetData($edit_110_04, "")

		EndIf

		If $season[0] = "0" Then

			$season1 = "-specials"

		Else

			$season1 = StringFormat("%02i", $season[0])

		EndIf

	EndIf


	If FileExists( $InDir & "\" & $in_series & "\" & "season" & $season1 & "-poster.jpg") Then

		GUICtrlSetImage($Pic_110_02,  $InDir & "\" & $in_series & "\" & "season" & $season1 & "-poster.jpg")

	ElseIf FileExists($InDir & "\" & $in_series & "\poster.jpg") Then

		GUICtrlSetImage($Pic_110_02, $InDir & "\" & $in_series & "\poster.jpg")

	Else

		GUICtrlSetImage($Pic_110_02, @ScriptDir & "\Images\img_poster.jpg")

	EndIf

	If FileExists($iPathSplit[1] & $iPathSplit[2] & $iPathSplit[3] & "-thumb.jpg") Then

		GUICtrlSetImage($Pic_110_03, $iPathSplit[1] & $iPathSplit[2] & $iPathSplit[3] & "-thumb.jpg")

	Else

		GUICtrlSetImage($Pic_110_03, @ScriptDir & "\Images\img_background.jpg")

	EndIf

	If FileExists($InDir & "\" & $in_series & "\" & "season" & $season1 & "banner.jpg") Then

		GUICtrlSetImage($Pic_110_01, $InDir & "\" & $in_series & "\" & "season" & $season1 & "banner.jpg")

	ElseIf FileExists($InDir & "\" & $in_series & "\banner.jpg") Then

		GUICtrlSetImage($Pic_110_01, $InDir & "\" & $in_series & "\banner.jpg")

	Else

		GUICtrlSetImage($Pic_110_01, @ScriptDir & "\Images\img_banner.jpg")

	EndIf

	Return

EndFunc

;Function to Set Data in Afterwork Window
Func _SetData_120($listitem)

	Local $InDir = GUICtrlRead($input_62_01), $nfo, $tvnfo1, $Ifile, $i, $moviepath, $set1
	Local $iPathSplit, $sDrive, $sDir, $sFilename, $sExtension, $series, $episodenfo, $iFileExists
	Local $title, $status, $genre, $plot, $showtitle, $year, $rating, $studio, $value, $setnew = 0
	Local $id, $tmdbid, $originaltitle, $tagline, $set, $country, $moviesetpath
	Dim $movie[1]
	Dim $moviefolder[1]

	$WorkArray = _FileListToArrayRec($InDir, $extstring2, 1, 1, 1)

	For $i = 1 To UBound($WorkArray) - 1

		$iPathSplit = _PathSplit($WorkArray[$i], $sDrive, $sDir, $sFilename, $sExtension)

		If StringInStr($iPathSplit[3], "-trailer",0) < 1  Then

			_ArrayAdd($movie, $iPathSplit[3])

			_ArrayAdd($moviefolder, $iPathSplit[2])

		EndIf

	Next

	$i = _ArraySearch($movie, $listitem)

	If $i > -1 Then

		$nfo = StringReplace($InDir & "\" & $moviefolder[$i] & $movie[$i] & ".nfo", "–", "-")

		$moviepath = $InDir & "\" & $moviefolder[$i]

		$iFileExists = FileExists($nfo)

		If $iFileExists = 1 Then

	; Metadata

			$Ifile = FileOpen($nfo, 128)

			$tvnfo = FileRead($Ifile)

			FileClose($Ifile)

			$title = _StringBetween($tvnfo, "<title>", "</title>",0)

			$sorttitle = _StringBetween($tvnfo, "<sorttitle>", "</sorttitle>",0)

			$genre = _StringBetween($tvnfo, "<genre>", "</genre>",0)

			$plot = _StringBetween($tvnfo, "<plot>", "</plot>",0)

			$mpaa = _StringBetween($tvnfo, "<mpaa>", "</mpaa>",0)

			$id = _StringBetween($tvnfo, "<id>", "</id>",0)

			If $json_use_uniqueID = "true" Then

				$tmdb = _StringBetween($tvnfo, '<uniqueid type="tmdb">', '</uniqueid>',0)

				$imdb = _StringBetween($tvnfo, '<uniqueid type="imdb">', '</uniqueid>',0)

			Else

				$tmdb = _StringBetween($tvnfo, '<tmdbid>', '</tmdbid>',0)

				$imdb = _StringBetween($tvnfo, '<imdbid>', '</imdbid>',0)

			EndIf

			$originaltitle = _StringBetween($tvnfo, "<originaltitle>", "</originaltitle>",0)

			$tagline = _StringBetween($tvnfo, "<tagline>", "</tagline>",0)

			$set1 = _StringBetween($tvnfo, "<set>", "</set>")

			If _ElementExists($set1,0) Then

				If StringInStr($set1[0], "<name>") Then

					$setnew = 1

					$set = _StringBetween($set1[0], "<name>", "</name>",0)

				Else

					$set = $set1

				EndIf

			EndIf

			$studio = _StringBetween($tvnfo, "<studio>", "</studio>",0)

			$country = _StringBetween($tvnfo, "<country>", "</country>",0)

			$year = _StringBetween($tvnfo, "<year>", "</year>",0)

			$rating = _StringBetween($tvnfo, "<rating>", "</rating>",0)

			$status = _StringBetween($tvnfo, "<status>", "</status>",0)

			If FileExists($moviepath & "poster.jpg") Then

				GUICtrlSetImage($Pic_120_00, $moviepath & "poster.jpg")

			ElseIf FileExists($moviepath & "folder.jpg") Then

				GUICtrlSetImage($Pic_120_00, $moviepath & "folder.jpg")

			Else

				GUICtrlSetImage($Pic_120_00, @ScriptDir & "\Images\img_poster.jpg")

			EndIf

			If  _ElementExists($title, 0) Then

				GUICtrlSetData($input_120_01, $title[0])

			Else

				GUICtrlSetData($input_120_01, "")

			EndIf

			If  _ElementExists($sorttitle, 0) Then

				GUICtrlSetData($input_120_02, $sorttitle[0])

			Else

				GUICtrlSetData($input_120_02, "")

			EndIf

			If  _ElementExists($originaltitle, 0) Then

				GUICtrlSetData($input_120_03, $originaltitle[0])

			Else

				GUICtrlSetData($input_120_03, "")

			EndIf

			If  _ElementExists($tagline, 0) Then

				GUICtrlSetData($input_120_04, $tagline[0])

			Else

				GUICtrlSetData($input_120_04, "")

			EndIf

			If  _ElementExists($set, 0) Then

				GUICtrlSetData($input_120_05, $set[0])

			Else

				GUICtrlSetData($input_120_05, "")

			EndIf

			If  _ElementExists($genre, 0) Then

				$value = $genre[0]

				For $i = 1 To UBound($genre) - 1

					$value = $value & "|" & $genre[$i]

				Next

				GUICtrlSetData($input_120_06, $value)

			Else

				GUICtrlSetData($input_120_06, "")

			EndIf

			If  _ElementExists($studio, 0) Then

				$value = $studio[0]

				For $i = 1 To UBound($studio) - 1

					$value = $value & "|" & $studio[$i]

				Next

				GUICtrlSetData($input_120_07, $value)

			Else

				GUICtrlSetData($input_120_07, "")

			EndIf

			If  _ElementExists($plot, 0) Then

				GUICtrlSetData($edit_120_08, $plot[0])

			Else

				GUICtrlSetData($edit_120_08, "")

			EndIf

			If  _ElementExists($imdb, 0) Then

				GUICtrlSetData($input_120_11, $imdb[0])

			Else

				GUICtrlSetData($input_120_11, "")

			EndIf

			If  _ElementExists($tmdb, 0) Then

				GUICtrlSetData($input_120_12, $tmdb[0])

			Else

				GUICtrlSetData($input_120_12, "")

			EndIf

			If  _ElementExists($mpaa, 0) Then

				GUICtrlSetData($input_120_13, $mpaa[0])

			Else

				GUICtrlSetData($input_120_13, "")

			EndIf

			If  _ElementExists($country, 0) Then

				$value = $country[0]

				For $i = 1 To UBound($country) - 1

					$value = $value & "|" & $country[$i]

				Next

				GUICtrlSetData($input_120_14, $value)

			Else

				GUICtrlSetData($input_120_14, "")

			EndIf

			If  _ElementExists($year, 0) Then

				GUICtrlSetData($input_120_15, $year[0])

			Else

				GUICtrlSetData($input_120_15, "")

			EndIf

			If  _ElementExists($rating, 0) Then

				GUICtrlSetData($input_120_16, $rating[0])

			Else

				GUICtrlSetData($input_120_16, "")

			EndIf

			If  _ElementExists($status, 0) Then

				GUICtrlSetData($input_120_17, $status[0])

			Else

				GUICtrlSetData($input_120_17, "")

			EndIf

	; fanart

			If FileExists($moviepath & "poster.jpg") Then

				GUICtrlSetImage($Pic_120_20, $moviepath & "poster.jpg")

			ElseIf FileExists($moviepath & "folder.jpg") Then

				GUICtrlSetImage($Pic_120_20, $moviepath & "folder.jpg")

			Else

				GUICtrlSetImage($Pic_120_20, @ScriptDir & "\Images\img_poster.jpg")

			EndIf

			If FileExists($moviepath & "fanart.jpg") Then

				GUICtrlSetImage($Pic_120_22, $moviepath & "fanart.jpg")

			Else

				GUICtrlSetImage($Pic_120_22, @ScriptDir & "\Images\img_background.jpg")

			EndIf

			If FileExists($moviepath & "banner.jpg") Then

				GUICtrlSetImage($Pic_120_21, $moviepath & "banner.jpg")

			Else

				GUICtrlSetImage($Pic_120_21, @ScriptDir & "\Images\img_banner.jpg")

			EndIf

			If FileExists($moviepath & "landscape.jpg") Then

				GUICtrlSetImage($Pic_120_26, $moviepath & "landscape.jpg")

			Else

				GUICtrlSetImage($Pic_120_26, @ScriptDir & "\Images\img_background.jpg")

			EndIf

			If FileExists($moviepath & "clearart.png") Then

				GUICtrlSetImage($Pic_120_24, _Display_PNG($moviepath & "clearart.png"))

			Else

				GUICtrlSetImage($Pic_120_24, _Display_PNG(@ScriptDir & "\Images\img_clearart.png"))

			EndIf

			If FileExists($moviepath & "clearlogo.png") Then

				GUICtrlSetImage($Pic_120_25, _Display_PNG($moviepath & "clearlogo.png"))

			ElseIf FileExists($moviepath & "logo.png") Then

				GUICtrlSetImage($Pic_120_25, _Display_PNG($moviepath & "logo.png"))

			Else

				GUICtrlSetImage($Pic_120_25, _Display_PNG(@ScriptDir & "\Images\img_clearart.png"))

			EndIf

			If FileExists($moviepath & "discart.png") Then

				GUICtrlSetImage($Pic_120_23, _Display_PNG($moviepath & "discart.png"))

			ElseIf FileExists($moviepath & "disc.png") Then

				GUICtrlSetImage($Pic_120_23, _Display_PNG($moviepath & "disc.png"))

			Else

				GUICtrlSetImage($Pic_120_23, _Display_PNG(@ScriptDir & "\Images\img_disc.png"))

			EndIf

	; movieset fanart

			If  _ElementExists($set, 0) Then

				If $ini_moviesetfolderuse = "1" Then

					$moviesetpath = $ini_moviesetfolder & "\" & $set[0] & "\"

					If FileExists($moviesetpath & "banner.jpg") Then

						GUICtrlSetImage($Pic_120_31, $moviesetpath & "banner.jpg")

					Else

						GUICtrlSetImage($Pic_120_31, @ScriptDir & "\Images\img_banner.jpg")

					EndIf

					If FileExists($moviesetpath & "fanart.jpg") Then

						GUICtrlSetImage($Pic_120_32, $moviesetpath & "fanart.jpg")

					Else

						GUICtrlSetImage($Pic_120_32, @ScriptDir & "\Images\img_background.jpg")

					EndIf

					If FileExists($moviesetpath & "poster.jpg") Then

						GUICtrlSetImage($Pic_120_30, $moviesetpath & "poster.jpg")

					Else

						GUICtrlSetImage($Pic_120_30, @ScriptDir & "\Images\img_poster.jpg")

					EndIf

					If FileExists($moviesetpath & "landscape.jpg") Then

						GUICtrlSetImage($Pic_120_36, $moviesetpath & "landscape.jpg")

					Else

						GUICtrlSetImage($Pic_120_36, @ScriptDir & "\Images\img_background.jpg")

					EndIf

					If FileExists($moviesetpath & "clearart.png") Then

						GUICtrlSetImage($Pic_120_34, _Display_PNG($moviesetpath & "clearart.png"))

					Else

						GUICtrlSetImage($Pic_120_34, _Display_PNG(@ScriptDir & "\Images\img_clearart.png"))

					EndIf

					If FileExists($moviesetpath & "clearlogo.png") Then

						GUICtrlSetImage($Pic_120_35, _Display_PNG($moviesetpath & "clearlogo.png"))

					ElseIf FileExists($moviesetpath & "logo.png") Then

						GUICtrlSetImage($Pic_120_35, _Display_PNG($moviesetpath & "logo.png"))

					Else

						GUICtrlSetImage($Pic_120_35, _Display_PNG(@ScriptDir & "\Images\img_clearart.png"))

					EndIf

				Else

					If FileExists($moviepath & "movieset-fanart.jpg") Then

						GUICtrlSetImage($Pic_120_32, $moviepath & "movieset-fanart.jpg")

					Else

						GUICtrlSetImage($Pic_120_32, @ScriptDir & "\Images\img_background.jpg")

					EndIf

					If FileExists($moviepath & "movieset-poster.jpg") Then

						GUICtrlSetImage($Pic_120_30, $moviepath & "movieset-poster.jpg")

					Else

						GUICtrlSetImage($Pic_120_30, @ScriptDir & "\Images\img_poster.jpg")

					EndIf

					If FileExists($moviepath & "movieset-banner.jpg") Then

						GUICtrlSetImage($Pic_120_31, $moviepath & "movieset-banner.jpg")

					Else

						GUICtrlSetImage($Pic_120_31, @ScriptDir & "\Images\img_banner.jpg")

					EndIf

					If FileExists($moviepath & "movieset-landscape.jpg") Then

						GUICtrlSetImage($Pic_120_36, $moviepath & "movieset-landscape.jpg")

					Else

						GUICtrlSetImage($Pic_120_36, @ScriptDir & "\Images\img_background.jpg")

					EndIf

					If FileExists($moviepath & "movieset-clearart.png") Then

						GUICtrlSetImage($Pic_120_34, _Display_PNG($moviepath & "movieset-clearart.png"))

					Else

						GUICtrlSetImage($Pic_120_34, _Display_PNG(@ScriptDir & "\Images\img_clearart.png"))

					EndIf

					If FileExists($moviepath & "movieset-clearlogo.png") Then

						GUICtrlSetImage($Pic_120_35, _Display_PNG($moviepath & "movieset-clearlogo.png"))

					ElseIf FileExists($moviepath & "movieset-logo.png") Then

						GUICtrlSetImage($Pic_120_35, _Display_PNG($moviepath & "movieset-logo.png"))

					Else

						GUICtrlSetImage($Pic_120_35, _Display_PNG(@ScriptDir & "\Images\img_clearart.png"))

					EndIf

				EndIf

			EndIf

		Else

			_WriteLog("Corection_Movies - No nfo found")

		EndIf

	EndIf

	Return

EndFunc

;Function to Set Data in Afterwork Window
Func _SetData_130($listitem)

	Local $InDir = GUICtrlRead($input_63_01), $nfo, $tvnfo1, $Ifile, $i, $moviepath
	Local $iPathSplit, $sDrive, $sDir, $sFilename, $sExtension, $series, $episodenfo, $iFileExists
	Local $id, $tmdbid, $originaltitle, $title,$genre, $plot, $year, $value
	Local $fanart, $cover
	Dim $movie[1]
	Dim $moviefolder[1]

	$WorkArray = _FileListToArrayRec($InDir, $extstring2, 1, 1, 1)

	For $i = 1 To UBound($WorkArray) - 1

		$iPathSplit = _PathSplit($WorkArray[$i], $sDrive, $sDir, $sFilename, $sExtension)

		_ArrayAdd($movie, $iPathSplit[3])

		_ArrayAdd($moviefolder, $iPathSplit[2])

	Next

	$i = _ArraySearch($movie, $listitem)

	If $i > -1 Then

		$nfo = StringReplace($InDir & "\" & $moviefolder[$i] & $movie[$i] & ".nfo", "–", "-")

		$moviepath = $InDir & "\" & $moviefolder[$i]

		$cover = StringReplace($moviepath & $ini_fanart_cover, "{movie}", $movie[$i])

		$fanart = StringReplace($moviepath & $ini_fanart_background, "{movie}", $movie[$i])

		$iFileExists = FileExists($cover)

		If $iFileExists = 1 Then

			$cover = StringReplace($moviepath & $ini_fanart_cover, "{movie}", $movie[$i])

		Else

			$cover = $moviepath & $movie[$i] & ".jpg"

		EndIf

		$iFileExists = FileExists($fanart)

		If $iFileExists = 1 Then

			$fanart = StringReplace($moviepath & $ini_fanart_background, "{movie}", $movie[$i])

		Else

			$fanart = $moviepath & $movie[$i] & "-fanart.jpg"

		EndIf

		$iFileExists = FileExists($nfo)

		If $iFileExists = 1 Then

			$Ifile = FileOpen($nfo, 128)

			$tvnfo = FileRead($Ifile)

			FileClose($Ifile)

			$title = _StringBetween($tvnfo, "<title>", "</title>",0)

			$sorttitle = _StringBetween($tvnfo, "<sorttitle>", "</sorttitle>",0)

			$genre = _StringBetween($tvnfo, "<genre>", "</genre>",0)

			$plot = _StringBetween($tvnfo, "<plot>", "</plot>",0)

			$id = _StringBetween($tvnfo, "<id>", "</id>",0)

			$tmdbid = _StringBetween($tvnfo, "<tmdbid>", "</tmdbid>",0)

			$originaltitle = _StringBetween($tvnfo, "<originaltitle>", "</originaltitle>",0)

			$year = _StringBetween($tvnfo, "<year>", "</year>",0)

			If  _ElementExists($title, 0) Then

				GUICtrlSetData($input_130_01, $title[0])

			Else

				GUICtrlSetData($input_130_01, "")

			EndIf

			If  _ElementExists($sorttitle, 0) Then

				GUICtrlSetData($input_130_02, $sorttitle[0])

			Else

				GUICtrlSetData($input_130_02, "")

			EndIf

			If  _ElementExists($genre, 0) Then

				$value = $genre[0]

				For $i = 1 To UBound($genre) - 1

					$value = $value & "|" & $genre[$i]

				Next

				GUICtrlSetData($input_130_03, $value)

			Else

				GUICtrlSetData($input_130_03, "")

			EndIf

			If  _ElementExists($plot, 0) Then

				GUICtrlSetData($edit_130_05, $plot[0])

			Else

				GUICtrlSetData($edit_130_05, "")

			EndIf

			If  _ElementExists($year, 0) Then

				GUICtrlSetData($input_130_04, $year[0])

			Else

				GUICtrlSetData($input_130_04, "")

			EndIf

		EndIf

		GUICtrlSetImage($Pic_130_02, @ScriptDir & "\Images\img_poster.jpg")

		If FileExists($cover) Then

			GUICtrlSetImage($Pic_130_02, $cover)

		EndIf

		GUICtrlSetImage($Pic_130_01, @ScriptDir & "\Images\img_background.jpg")

		If FileExists($fanart) Then

			GUICtrlSetImage($Pic_130_01, $fanart)

		EndIf

	EndIf

	Return

EndFunc

;Function to Set Data in Afterwork Window
Func _SetData_140($listitem)

	Local $InDir = GUICtrlRead($input_64_01), $nfo, $Ifile, $disambiguation
	Local $name, $mbid, $born, $bio, $formed, $died, $disbanded, $genre,  $artist, $iFileExists

	$artist = $InDir & "\" & $listitem & "\artist.nfo"

	$iFileExists = FileExists($artist)

	If $iFileExists = 1 Then

		$Ifile = FileOpen( $artist, 128)

		$nfo = FileRead($Ifile)

		FileClose($Ifile)

		$name = _StringBetween($nfo, "<name>", "</name>",0)

		$mbid = _StringBetween($nfo, "<musicBrainzArtistID>", "</musicBrainzArtistID>",0)

		$born = _StringBetween($nfo, "<born>", "</born>",0)

		$bio = _StringBetween($nfo, "<biography>", "</biography>",0)

		$formed = _StringBetween($nfo, "<formed>", "</formed>",0)

		$died = _StringBetween($nfo, "died>", "</died>",0)

		$disbanded = _StringBetween($nfo, "<disbanded>", "</disbanded>",0)

		$disambiguation = _StringBetween($nfo, "<disambiguation>", "</disambiguation>",0)

		$genre = _StringBetween($nfo, "<genre>", "</genre>",0)

		$gender = _StringBetween($nfo, "<gender>", "</gender>",0)

		If  _ElementExists($name, 0) Then

			GUICtrlSetData($input_140_01, $name[0])

		Else

			GUICtrlSetData($input_140_01, "")

		EndIf

		If  _ElementExists($mbid, 0) Then

			GUICtrlSetData($input_140_02, $mbid[0])

		Else

			GUICtrlSetData($input_140_02, "")

		EndIf

		If  _ElementExists($born, 0) Then

			GUICtrlSetData($input_140_03, $born[0])

		Else

			GUICtrlSetData($input_140_03, "")

		EndIf

		If  _ElementExists($formed, 0) Then

			GUICtrlSetData($input_140_04, $formed[0])

		Else

			GUICtrlSetData($input_140_04, "")

		EndIf

		If  _ElementExists($died, 0) Then

			GUICtrlSetData($input_140_13, $died[0])

		Else

			GUICtrlSetData($input_140_13, "")

		EndIf

		If  _ElementExists($disbanded, 0) Then

			GUICtrlSetData($input_140_14, $disbanded[0])

		Else

			GUICtrlSetData($input_140_14, "")

		EndIf

		If  _ElementExists($disambiguation, 0) Then

			GUICtrlSetData($input_140_09, $disambiguation[0])

		Else

			GUICtrlSetData($input_140_09, "")

		EndIf

		If  _ElementExists($genre, 0) Then

			GUICtrlSetData($input_140_07, $genre[0])

		Else

			GUICtrlSetData($input_140_07, "")

		EndIf

	If  _ElementExists($gender, 0) Then

		GUICtrlSetData($input_140_08, $gender[0])

	Else

		GUICtrlSetData($input_140_08, "")

	EndIf



		If  _ElementExists($bio, 0) Then

			GUICtrlSetData($edit_140_04, $bio[0])

		Else

			GUICtrlSetData($edit_140_04, "")

		EndIf

	Else

		_WriteLog("Corection_Artist - No artist.nfo found")

		GUICtrlSetData($input_140_01, "")
		GUICtrlSetData($input_140_02, "")
		GUICtrlSetData($input_140_03, "")
		GUICtrlSetData($input_140_04, "")
		GUICtrlSetData($input_140_07, "")
		GUICtrlSetData($input_140_09, "")
		GUICtrlSetData($input_140_13, "")
		GUICtrlSetData($input_140_14, "")
		GUICtrlSetData($edit_140_04, "")

	EndIf

	If FileExists($InDir & "\" & $listitem & "\banner.jpg") Then

		GUICtrlSetImage($Pic_140_01, $InDir & "\" & $listitem & "\banner.jpg")

	Else

		GUICtrlSetImage($Pic_140_01, @ScriptDir & "\Images\img_banner.jpg")

	EndIf

	If FileExists($InDir & "\" & $listitem & "\folder.jpg") Then

		GUICtrlSetImage($Pic_140_02, $InDir & "\" & $listitem & "\folder.jpg")

	Else

		GUICtrlSetImage($Pic_140_02, @ScriptDir & "\Images\img_poster.jpg")

	EndIf

	If FileExists($InDir & "\" & $listitem & "\fanart.jpg") Then

		GUICtrlSetImage($Pic_140_03, $InDir & "\" & $listitem & "\fanart.jpg")

	Else

		GUICtrlSetImage($Pic_140_03, @ScriptDir & "\Images\img_banner.jpg")

	EndIf

	If FileExists($InDir & "\" & $listitem & "\clearlogo.png") Then

		GUICtrlSetImage($Pic_140_04, _Display_PNG($InDir & "\" & $listitem & "\clearlogo.png"))

	Elseif FileExists($InDir & "\" & $listitem & "\logo.png") Then

		GUICtrlSetImage($Pic_140_04, _Display_PNG($InDir & "\" & $listitem & "\logo.png"))

	Else

		GUICtrlSetImage($Pic_140_04, _Display_PNG(@ScriptDir & "\Images\img_clearart.png"))

	EndIf

	Return

EndFunc

;Function to Set Data in Afterwork Window
Func _SetData_150($in_artist, $listitem)

	Local $InDir = GUICtrlRead($input_64_01), $nfo, $Ifile, $WorkArray, $folder, $album, $iFileExists, $albumtrack
	local $title, $albumartist, $theme, $style, $year, $compilation, $genre, $mood, $label, $review, $mbid_artist, $list
	Local $PathSplit, $sDrive, $sDir, $sFilename, $sExtension, $gender

	$album = $InDir & "\" & $in_artist & "\" & $listitem & "\album.nfo"

	$WorkArray = _FileListToArrayRec($InDir & "\" & $in_artist & "\" & $listitem, $aextstring, 1, 1, 1, 2)


	GUICtrlSetData($Edit_150_07, "")

	_GUICtrlListView_BeginUpdate($Edit_150_07)

	For $i = 1 To UBound($WorkArray) - 1

		$PathSplit = _PathSplit($WorkArray[$i], $sDrive, $sDir, $sFilename, $sExtension)

		If $i = UBound($WorkArray) - 1 Then

			$list = $list & $PathSplit[3] & $PathSplit[4]

		Else

			$list = $list & $PathSplit[3] & $PathSplit[4] & @CRLF

		EndIf

	Next

	GUICtrlSetData($Edit_150_07, $list)

	_GUICtrlListView_EndUpdate($Edit_150_07)


	$iFileExists = FileExists($album)

	If $iFileExists = 1 Then

		$Ifile = FileOpen($album, 128)

		$nfo = FileRead($Ifile)

		FileClose($Ifile)

		$title = _StringBetween($nfo, "<title>", "</title>",0)

		$albumartist = _StringBetween($nfo, "<artist>", "</artist>",0)

		$theme = _StringBetween($nfo, "<theme>", "</theme>",0)

		$mbid_artist = _StringBetween($nfo, "<musicBrainzArtistID>", "</musicBrainzArtistID>",0)

		$style = _StringBetween($nfo, "<style>", "</style>",0)

		$year = _StringBetween($nfo, "<year>", "</year>",0)

		$compilation = _StringBetween($nfo, "<compilation>", "</compilation>",0)

		$genre = _StringBetween($nfo, "<genre>", "</genre>",0)

		$mood = _StringBetween($nfo, "<mood>", "</mood>",0)

		$label = _StringBetween($nfo, "<label>", "</label>",0)

		$review = _StringBetween($nfo, "<review>", "</review>",0)


	EndIf

	If  _ElementExists($title, 0) Then

		GUICtrlSetData($input_150_01, $title[0])

	Else

		GUICtrlSetData($input_150_01, $listitem)

	EndIf

	If  _ElementExists($albumartist, 0) Then

		GUICtrlSetData($input_150_02, $albumartist[0])

	Else

		GUICtrlSetData($input_150_02, $in_artist)

	EndIf

	If  _ElementExists($theme, 0) Then

		GUICtrlSetData($input_150_03, $theme[0])

	Else

		GUICtrlSetData($input_150_03, "")

	EndIf

	If  _ElementExists($style, 0) Then

		GUICtrlSetData($input_150_04, $style[0])

	Else

		GUICtrlSetData($input_150_04, "")

	EndIf

	If  _ElementExists($year, 0) Then

		GUICtrlSetData($input_150_05, $year[0])

	Else

		GUICtrlSetData($input_150_05, "")

	EndIf

	If  _ElementExists($mbid_artist, 0) Then

		GUICtrlSetData($input_150_12, $mbid_artist[0])

	Else

		GUICtrlSetData($input_150_12, "")

	EndIf

	If  _ElementExists($genre, 0) Then

		GUICtrlSetData($input_150_13, $genre[0])

	Else

		GUICtrlSetData($input_150_13, "")

	EndIf

	If  _ElementExists($mood, 0) Then

		GUICtrlSetData($input_150_14, $mood[0])

	Else

		GUICtrlSetData($input_150_14, "")

	EndIf

	If  _ElementExists($label, 0) Then

		GUICtrlSetData($input_150_15, $label[0])

	Else

		GUICtrlSetData($input_150_15, "")

	EndIf

	If  _ElementExists($review, 0) Then

		GUICtrlSetData($Edit_150_06, $review[0])

	Else

		GUICtrlSetData($Edit_150_06, "")

	EndIf


 	$folder = $InDir & "\" & $in_artist & "\" & $listitem & "\folder.jpg"

	If FileExists($folder) Then

		GUICtrlSetImage($Pic_150_01, $folder)

	Else

		$option = ' -i "' & $File & '" -y -c:v copy "' & $folder & '"'

		ShellExecuteWait($ini_ffmpeg_path, $option, "", "", @SW_HIde)

		If FileExists($folder) Then

			GUICtrlSetImage($Pic_150_01, $folder)

		Else

			GUICtrlSetImage($Pic_150_01, @ScriptDir & "\Images\img_poster.jpg")

		EndIf


	EndIf

	If FileExists($InDir & "\" & $in_artist & "\" & $listitem & "\discart.png") Then

		GUICtrlSetImage($Pic_150_02, _Display_PNG($InDir & "\" & $in_artist & "\" & $listitem & "\discart.png"))

	Else

		GUICtrlSetImage($Pic_150_02, _Display_PNG(@ScriptDir & "\Images\img_disc.png"))

	EndIf


	$iFileExists = FileExists($album)

	If $iFileExists = 1 Then

		$Ifile = FileOpen($album, 128)

		$nfo = FileRead($Ifile)

		FileClose($Ifile)

	EndIf


	Return

EndFunc

;Function to Write Edited Data in Afterwork Window
Func _UpdateGenres($indir)

	Local $seriesarray, $i, $j, $k, $iFileExists, $iFile, $tvsnfo, $seriesnfo, $WorkArray
	Local $iPathSplit, $sDrive, $sDir, $sFilename, $sExtension, $tvnfo
	Local $genre, $status, $rating, $studio, $mpaa, $episodenfo, $array
	Local $genre1, $rating1, $studio1, $mpaa1, $status1, $Ifile1
	Local $tmdb, $tvdb, $imdb, $tmdb1, $tvdb1, $imdb1

	$seriesarray = _FileListToArrayRec($InDir, "*", 2)

	If _ElementExists($seriesarray,0) Then

		For $i = 1 To $seriesarray[0]

			$seriesnfo = $indir & "\" & $seriesarray[$i] & "\tvshow.nfo"

			$iFileExists = FileExists($seriesnfo)

			If $iFileExists = 1 Then

				_SetLabel($Label02, $lng_workingon & "; " & $seriesarray[$i])

				$Ifile = FileOpen($seriesnfo, 0)

				$tvsnfo = FileRead($Ifile)

				FileClose($Ifile)

				$genre1 = _StringBetween($tvsnfo, "<genre>", "</genre>",0)

				$array = _StringBetween($tvsnfo, "<status>", "</status>",0)

				If _ElementExists($array, 0) Then

				$status1 = $array[0]

				Else

					$status1 = ""

				EndIf

				$array = _StringBetween($tvsnfo, "<rating>", "</rating>",0)

				If _ElementExists($array, 0) Then

				$rating1 = $array[0]

				Else

					$rating1 = ""

				EndIf

				$array = _StringBetween($tvsnfo, "<studio>", "</studio>",0)

				If _ElementExists($array, 0) Then

				$studio1 = $array[0]

				Else

					$studio1 = ""

				EndIf

				$array = _StringBetween($tvsnfo, "<mpaa>", "</mpaa>",0)

				If _ElementExists($array, 0) Then

				$mpaa1 = $array[0]

				Else

					$mpaa1 = ""

				EndIf

				If $json_use_uniqueID = "true" Then

					$array = _StringBetween($tvsnfo, '<uniqueid type="tvdb">', '</uniqueid>',0)

					If _ElementExists($array, 0) Then

						$tvdb1 = $array[0]

					Else

						$tvdb1 = ""

					EndIf

					$array = _StringBetween($tvsnfo, '<uniqueid type="tmdb">', '</uniqueid>',0)

					If _ElementExists($array, 0) Then

						$tmdb1 = $array[0]

					Else

						$tmdb1 = ""

					EndIf

					$array = _StringBetween($tvsnfo, '<uniqueid type="imdb">', '</uniqueid>',0)

					If _ElementExists($array, 0) Then

						$imdb1 = $array[0]

					Else

						$imdb1 = ""

					EndIf

				Else

					$array = _StringBetween($tvsnfo, '<tvdbid>', '</tvdbid>',0)

					If _ElementExists($array, 0) Then

						$tvdb1 = $array[0]

					Else

						$tvdb1 = ""

					EndIf

					$array = _StringBetween($tvsnfo, '<tmdbid>', '</tmdbid>',0)

					If _ElementExists($array, 0) Then

						$tmdb1 = $array[0]

					Else

						$tmdb1 = ""

					EndIf

					$array = _StringBetween($tvsnfo, '<imdbid>', '</imdbid>',0)

					If _ElementExists($array, 0) Then

						$imdb1 = $array[0]

					Else

						$imdb1 = ""

					EndIf

				EndIf

				$WorkArray = _FileListToArrayRec($InDir & "\" & $seriesarray[$i], $extstring2, 1, 1, 1)

				If _ElementExists($WorkArray,0) Then

					For $j = 1 To $WorkArray[0]

						$iPathSplit = _PathSplit($InDir & "\" &  $seriesarray[$i] & "\" & $WorkArray[$j], $sDrive, $sDir, $sFilename, $sExtension)

						$episodenfo = $iPathSplit[1] & $iPathSplit[2] & $iPathSplit[3] & ".nfo"

						$iFileExists = FileExists($episodenfo)

						If $iFileExists = 1 Then

							$Ifile = FileOpen($episodenfo, 0)

							$tvnfo = FileRead($Ifile)

							FileClose($Ifile)

							$genre = _StringBetween($tvnfo, "<genre>", "</genre>",0)

							$status = _StringBetween($tvnfo, "<status>", "</status>",0)

							$rating = _StringBetween($tvnfo, "<rating>", "</rating>",0)

							$studio = _StringBetween($tvnfo, "<studio>", "</studio>",0)

							$mpaa = _StringBetween($tvnfo, "<mpaa>", "</mpaa>",0)

							If $json_use_uniqueID = "true" Then

								$tvdb = _StringBetween($tvnfo, '<uniqueid type="tvdb">', '</uniqueid>',0)

								$tmdb = _StringBetween($tvnfo, '<uniqueid type="tmdb">', '</uniqueid>',0)

								$imdb = _StringBetween($tvnfo, '<uniqueid type="imdb">', '</uniqueid>',0)

							Else

								$tvdb = _StringBetween($tvnfo, '<tvdbid>', '</tvdbid>',0)

								$tmdb = _StringBetween($tvnfo, '<tmdbid>', '</tmdbid>',0)

								$imdb = _StringBetween($tvnfo, '<imdbid>', '</imdbid>',0)

							EndIf

							For $k = 0 To UBound($genre1) - 1

								If  _ElementExists($genre, $k) Then

									$tvnfo = StringReplace($tvnfo, "<genre>" & $genre[$k] & "</genre>", "<genre>" & $genre1[$k] & "</genre>", 0, 0)

								Else

									$tvnfo = StringReplace($tvnfo, "</episodedetails>", "<genre>" & $genre1[$k] & "</genre>" & @CRLF & "</episodedetails>", 0, 0)

								EndIf

							Next

							If  _ElementExists($status, 0) Then

								$tvnfo = StringReplace($tvnfo, "<status>" & $status[0] & "</status>", "<status>" & $status1 & "</status>", 0, 0)

							Else

								$tvnfo = StringReplace($tvnfo, "</episodedetails>", "<status>" & $status1 & "</status>" & @CRLF & "</episodedetails>", 0, 0)

							EndIf


							If  _ElementExists($studio, 0) Then

								$tvnfo = StringReplace($tvnfo, "<studio>" & $studio[0] & "</studio>", "<studio>" & $studio1 & "</studio>", 0, 0)

							Else

								$tvnfo = StringReplace($tvnfo, "</episodedetails>", "<studio>" & $studio1 & "</studio>" & @CRLF & "</episodedetails>", 0, 0)

							EndIf

							If  _ElementExists($rating, 0) Then

								$tvnfo = StringReplace($tvnfo, "<rating>" & $rating[0] & "</rating>", "<rating>" & $rating1 & "</rating>", 0, 0)

							Else

								$tvnfo = StringReplace($tvnfo, "</episodedetails>", "<rating>" & $rating1 & "</rating>" & @CRLF & "</episodedetails>", 0, 0)

							EndIf

							If  _ElementExists($mpaa, 0) Then

								$tvnfo = StringReplace($tvnfo, "<mpaa>" & $mpaa[0] & "</mpaa>", "<mpaa>" & $mpaa1 & "</mpaa>", 0, 0)

							Else

								$tvnfo = StringReplace($tvnfo, "</episodedetails>", "<mpaa>" & $mpaa1 & "</mpaa>" & @CRLF & "</episodedetails>", 0, 0)

							EndIf

							If $json_use_uniqueID = "true" Then

								If  _ElementExists($tvdb, 0) Then

									$tvnfo = StringReplace($tvnfo, '<uniqueid type="tvdb">' & $tvdb[0] & '</uniqueid>', '<uniqueid type="tvdb">' & $tvdb1 & '</uniqueid>', 0, 0)

								Else

									$tvnfo = StringReplace($tvnfo, "</episodedetails>",'<uniqueid type="tvdb">' & $tvdb1 & '</uniqueid>' & @CRLF & "</episodedetails>", 0, 0)

								EndIf

								If  _ElementExists($tmdb, 0) Then

									$tvnfo = StringReplace($tvnfo, '<uniqueid type="tmdb">' & $tmdb[0] & '</uniqueid>', '<uniqueid type="tmdb">' & $tmdb1 & '</uniqueid>', 0, 0)

								Else

									$tvnfo = StringReplace($tvnfo, "</episodedetails>",'<uniqueid type="tmdb">' & $tmdb1 & '</uniqueid>' & @CRLF & "</episodedetails>", 0, 0)

								EndIf

								If  _ElementExists($imdb, 0) Then

									$tvnfo = StringReplace($tvnfo, '<uniqueid type="imdb">' & $imdb[0] & '</uniqueid>', '<uniqueid type="imdb">' & $imdb1 & '</uniqueid>', 0, 0)

								Else

									$tvnfo = StringReplace($tvnfo, "</episodedetails>",'<uniqueid type="imdb">' & $imdb1 & '</uniqueid>' & @CRLF & "</episodedetails>", 0, 0)

								EndIf

							Else

								If  _ElementExists($tvdb, 0) Then

									$tvnfo = StringReplace($tvnfo, '<tvdbid>' & $tvdb[0] & '</tvdbid>', '<tvdbid>' & $tvdb1 & '</tvdbid>', 0, 0)

								Else

									$tvnfo = StringReplace($tvnfo, "</episodedetails>",'<tvdbid>' & $tvdb1 & '</tvdbid>' & @CRLF & "</episodedetails>", 0, 0)

								EndIf

								If  _ElementExists($tmdb, 0) Then

									$tvnfo = StringReplace($tvnfo, '<tmdbid>' & $tmdb[0] & '</tmdbid>', '<tmdbid>' & $tmdb1 & '</tmdbid>', 0, 0)

								Else

									$tvnfo = StringReplace($tvnfo, "</episodedetails>",'<tmdbid>' & $tmdb1 & '</tmdbid>' & @CRLF & "</episodedetails>", 0, 0)

								EndIf

								If  _ElementExists($imdb, 0) Then

									$tvnfo = StringReplace($tvnfo, '<imdbid>' & $imdb[0] & '</imdbid>', '<imdbid>' & $imdb1 & '</imdbid>', 0, 0)

								Else

									$tvnfo = StringReplace($tvnfo, "</episodedetails>",'<imdbid>' & $imdb1 & '</imdbid>' & @CRLF & "</episodedetails>", 0, 0)

								EndIf

							EndIf


							$tvnfo = StringReplace($tvnfo, "&amp;", "&")

							$Ifile1 = FileOpen($episodenfo, 2)

							FileWrite($Ifile1, $tvnfo)

							FileClose($Ifile1)

						EndIf

					Next

				EndIf

			EndIf

		Next

	EndIf

	_SetLabel($Label02, $lng_waiting)

	Return

EndFunc

;Function to Write Edited Data in Afterwork Window
Func _WriteData_100($listitem)

	Local $InDir = GUICtrlRead($input_61_01), $tvnfo, $Ifile, $Ifile1, $status, $year, $studio, $own, $value
	Local $iPathSplit, $sDrive, $sDir, $sFilename, $sExtension, $series, $tvshow, $iFileExists, $tvnfo1
	Local $title, $title1, $sorttitle, $mpaa, $genre, $genre1, $plot, $genrearray, $rating, $ownID, $ownValue

	$tvshow = $InDir & "\" & $listitem & "\tvshow.nfo"

	$iFileExists = FileExists($tvshow)

	If $iFileExists = 1 Then

		$Ifile = FileOpen($tvshow, 0)

		$tvnfo = FileRead($Ifile)

		FileClose($Ifile)

		$title = _StringBetween($tvnfo, "<title>", "</title>",0)

		$sorttitle = _StringBetween($tvnfo, "<sorttitle>", "</sorttitle>",0)

		$genre = _StringBetween($tvnfo, "<genre>", "</genre>",0)

		$plot = _StringBetween($tvnfo, "<plot>", "</plot>",0)

		$mpaa = _StringBetween($tvnfo, "<mpaa>", "</mpaa>",0)

		$status = _StringBetween($tvnfo, "<status>", "</status>",0)

		$year = _StringBetween($tvnfo, "<year>", "</year>",0)

		$rating = _StringBetween($tvnfo, "<rating>", "</rating>",0)

		$studio = _StringBetween($tvnfo, "<studio>", "</studio>",0)


		If $json_use_uniqueID = "true" Then

			$tvdb = _StringBetween($tvnfo, '<uniqueid type="tvdb">', '</uniqueid>',0)

			$tmdb = _StringBetween($tvnfo, '<uniqueid type="tmdb">', '</uniqueid>',0)

			$imdb = _StringBetween($tvnfo, '<uniqueid type="imdb">', '</uniqueid>',0)

			If GUICtrlRead($input_100_20) = "" Then

				$own = ""

			Else

				$ownID = _StringBetween($tvnfo, '<uniqueid type="' & GUICtrlRead($input_100_20), '">',0)

				If IsArray($ownID) Then

					$own = $ownID[0]

				Else

					$own = ""

				EndIf


			EndIf

			If $own = "" Then

				$value = ""

			Else

				$ownValue = _StringBetween($tvnfo, '<uniqueid type="' & $own & '">', '</uniqueid>',0)

				$value = $ownValue[0]

			EndIf


		Else

			$tvdb = _StringBetween($tvnfo, '<tvdbid>', '</tvdbid>',0)

			$tmdb = _StringBetween($tvnfo, '<tmdbid>', '</tmdbid>',0)

			$imdb = _StringBetween($tvnfo, '<imdbid>', '</imdbid>',0)

		EndIf


		If  _ElementExists($title, 0) Then

			$tvnfo = StringReplace($tvnfo, "<title>" & $title[0] & "</title>", "<title>" & GUICtrlRead($input_100_01) & "</title>", 0, 0)

		Else

			$tvnfo = StringReplace($tvnfo, "</tvshow>", "<title>" & GUICtrlRead($input_100_01) & "</title>" & @CRLF & "</tvshow>", 0, 0)

		EndIf

		If  _ElementExists($sorttitle, 0) Then

			$tvnfo = StringReplace($tvnfo, "<sorttitle>" & $sorttitle[0] & "</sorttitle>", "<sorttitle>" & GUICtrlRead($input_100_02) & "</sorttitle>", 0, 0)

		Else

			$tvnfo = StringReplace($tvnfo, "</tvshow>", "<sorttitle>" & GUICtrlRead($input_100_02) & "</sorttitle>" & @CRLF & "</tvshow>", 0, 0)

		EndIf

		$genrearray = StringSplit(GUICtrlRead($input_100_03), "|")

		For $i = 1 To $genrearray[0]

			If  _ElementExists($genre, $i - 1) Then

				$tvnfo = StringReplace($tvnfo, "<genre>" & $genre[$i - 1] & "</genre>", "<genre>" & $genrearray[$i] & "</genre>", 0, 0)

			Else

				$tvnfo = StringReplace($tvnfo, "</tvshow>", "<genre>" & $genrearray[$i] & "</genre>" & @CRLF & "</tvshow>", 0, 0)

			EndIf

		Next

		If  _ElementExists($mpaa, 0) Then

			$tvnfo = StringReplace($tvnfo, "<mpaa>" & $mpaa[0] & "</mpaa>", "<mpaa>" & GUICtrlRead($input_100_04) & "</mpaa>", 0, 0)

		Else

			$tvnfo = StringReplace($tvnfo, "</tvshow>", "<mpaa>" & GUICtrlRead($input_100_04) & "</mpaa>" & @CRLF & "</tvshow>", 0, 0)

		EndIf

		If  _ElementExists($status, 0) Then

			$tvnfo = StringReplace($tvnfo, "<status>" & $status[0] & "</status>", "<status>" & GUICtrlRead($input_100_17) & "</status>", 0, 0)

		Else

			$tvnfo = StringReplace($tvnfo, "</tvshow>", "<status>" & GUICtrlRead($input_100_17) & "</status>" & @CRLF & "</tvshow>", 0, 0)

		EndIf

		If  _ElementExists($year, 0) Then

			$tvnfo = StringReplace($tvnfo, "<year>" & $year[0] & "</year>", "<year>" & GUICtrlRead($input_100_16) & "</year>", 0, 0)

		Else

			$tvnfo = StringReplace($tvnfo, "</tvshow>", "<year>" & GUICtrlRead($input_100_16) & "</year>" & @CRLF & "</tvshow>", 0, 0)

		EndIf


		If  _ElementExists($studio, 0) Then

			$tvnfo = StringReplace($tvnfo, "<studio>" & $studio[0] & "</studio>", "<studio>" & GUICtrlRead($input_100_19) & "</studio>", 0, 0)

		Else

			$tvnfo = StringReplace($tvnfo, "</tvshow>", "<studio>" & GUICtrlRead($input_100_19) & "</studio>" & @CRLF & "</tvshow>", 0, 0)

		EndIf

		If  _ElementExists($rating, 0) Then

			$tvnfo = StringReplace($tvnfo, "<rating>" & $rating[0] & "</rating>", "<rating>" & GUICtrlRead($input_100_18) & "</rating>", 0, 0)

		Else

			$tvnfo = StringReplace($tvnfo, "</tvshow>", "<rating>" & GUICtrlRead($input_100_18) & "</rating>" & @CRLF & "</tvshow>", 0, 0)

		EndIf

		If $json_use_uniqueID = "true" Then

			If  _ElementExists($tvdb, 0) Then

				$tvnfo = StringReplace($tvnfo, '<uniqueid type="tvdb">' & $tvdb[0] & '</uniqueid>', '<uniqueid type="tvdb">' & GUICtrlRead($input_100_05) & '</uniqueid>', 0, 0)

			Else

				$tvnfo = StringReplace($tvnfo, "</tvshow>",'<uniqueid type="tvdb">' & GUICtrlRead($input_100_05) & '</uniqueid>' & @CRLF & "</tvshow>", 0, 0)

			EndIf

			If  _ElementExists($tmdb, 0) Then

				$tvnfo = StringReplace($tvnfo, '<uniqueid type="tmdb">' & $tmdb[0] & '</uniqueid>', '<uniqueid type="tmdb">' & GUICtrlRead($input_100_05a) & '</uniqueid>', 0, 0)

			Else

				$tvnfo = StringReplace($tvnfo, "</tvshow>",'<uniqueid type="tmdb">' & GUICtrlRead($input_100_05a) & '</uniqueid>' & @CRLF & "</tvshow>", 0, 0)

			EndIf

			If  _ElementExists($imdb, 0) Then

				$tvnfo = StringReplace($tvnfo, '<uniqueid type="imdb">' & $imdb[0] & '</uniqueid>', '<uniqueid type="imdb">' & GUICtrlRead($input_100_05b) & '</uniqueid>', 0, 0)

			Else

				$tvnfo = StringReplace($tvnfo, "</tvshow>",'<uniqueid type="imdb">' & GUICtrlRead($input_100_05b) & '</uniqueid>' & @CRLF & "</tvshow>", 0, 0)

			EndIf

;~ MsgBox(0,"", $own)

			If NOT GUICtrlRead($input_100_20) = "" Then

				$ownID = _StringBetween($tvnfo, '<uniqueid type="', '">',0)

				If IsArray($ownID) Then

					$own = $ownID[0]

				Else

					$own = ""

				EndIf

MsgBox(0,"", $own)

				If Not $own = ""  Then

					$tvnfo = StringReplace($tvnfo, '<uniqueid type="' & $own & '">' & $Value & '</uniqueid>', '<uniqueid type="' & GUICtrlRead($input_100_20) & '">' & GUICtrlRead($input_100_21) & '</uniqueid>', 0, 0)

				Else

					$tvnfo = StringReplace($tvnfo, "</tvshow>",'<uniqueid type="' & GUICtrlRead($input_100_20) & '">' & GUICtrlRead($input_100_21) & '</uniqueid>' & @CRLF & "</tvshow>", 0, 0)

				EndIf

			EndIf

		Else

			If  _ElementExists($tvdb, 0) Then

				$tvnfo = StringReplace($tvnfo, '<tvdbid>' & $tvdb[0] & '</tvdbid>', '<tvdbid>' & GUICtrlRead($input_100_05) & '</tvdbid>', 0, 0)

			Else

				$tvnfo = StringReplace($tvnfo, "</tvshow>",'<tvdbid>' & GUICtrlRead($input_100_05) & '</tvdbid>' & @CRLF & "</tvshow>", 0, 0)

			EndIf

			If  _ElementExists($tmdb, 0) Then

				$tvnfo = StringReplace($tvnfo, '<tmdbid>' & $tmdb[0] & '</tmdbid>', '<tmdbid>' & GUICtrlRead($input_100_05a) & '</tmdbid>', 0, 0)

			Else

				$tvnfo = StringReplace($tvnfo, "</tvshow>",'<tmdbid>' & GUICtrlRead($input_100_05a) & '</tmdbid>' & @CRLF & "</tvshow>", 0, 0)

			EndIf

			If  _ElementExists($imdb, 0) Then

				$tvnfo = StringReplace($tvnfo, '<imdbid>' & $imdb[0] & '</imdbid>', '<imdbid>' & GUICtrlRead($input_100_05b) & '</imdbid>', 0, 0)

			Else

				$tvnfo = StringReplace($tvnfo, "</tvshow>",'<imdbid>' & GUICtrlRead($input_100_05b) & '</imdbid>' & @CRLF & "</tvshow>", 0, 0)

			EndIf

		EndIf

		If  _ElementExists($plot, 0) Then

			$tvnfo = StringReplace($tvnfo, "<plot>" & $plot[0] & "</plot>", "<plot>" & GUICtrlRead($edit_100_04) & "</plot>", 0, 0)

		Else

			$tvnfo = StringReplace($tvnfo, "</tvshow>", "<plot>" & GUICtrlRead($edit_100_04) & "</plot>" & @CRLF & "</tvshow>", 0, 0)

		EndIf

		Sleep(100)

		$Ifile1 = FileOpen($tvshow, 2)

		FileWrite($Ifile1, $tvnfo)

		FileClose($Ifile1)

	EndIf

	Return

EndFunc

;Function to Write Edited Data in Afterwork Window
Func _WriteData_110($listitem, $in_series)

	Local $InDir = GUICtrlRead($input_61_01), $tvnfo, $Ifile, $Ifile1, $titlenew, $Rename, $Rename1, $Rename2
	Local $iPathSplit, $sSplit, $sDrive, $sDir, $sFilename, $sExtension, $series, $episodenfo, $iFileExists, $state
	Local $title, $status, $genre, $plot, $showtitle, $year, $rating, $studio, $season, $episode, $tvsnfo, $genrearray
	Local $title1, $genre1, $showtitle1, $year1, $studio1, $season1, $episode1, $mpaa, $seriesnfo, $mpab
	Local $tmdb, $tvdb, $imdb

	Dim $WorkArray[1] = [0]
	Dim $seasonfolder[1]

	$Rename = $json_Rename_TvShow

	$iPathSplit = _PathSplit($InDir & "\" & $in_series & "\" & $listitem, $sDrive, $sDir, $sFilename, $sExtension)

	$sSplit = StringSplit($iPathSplit[2], "\")

	$seriesnfo = $iPathSplit[1] & "\" & $sSplit[2] & "\" &  $sSplit[3] & "\tvshow.nfo"

	$iFileExists = FileExists($seriesnfo)

	If $iFileExists = 1 Then

		$Ifile = FileOpen($seriesnfo, 0)

		$tvsnfo = FileRead($Ifile)

		FileClose($Ifile)

		$mpaa = _StringBetween($tvsnfo, "<mpaa>", "</mpaa>",0)

	EndIf

 	$episodenfo = $iPathSplit[1] & $iPathSplit[2] & $iPathSplit[3] & ".nfo"

	$iFileExists = FileExists($episodenfo)

	If $iFileExists = 1 Then

		$Ifile = FileOpen($episodenfo, 0)

		$tvnfo = FileRead($Ifile)

		FileClose($Ifile)

		$title = _StringBetween($tvnfo, "<title>", "</title>",0)

		$showtitle = _StringBetween($tvnfo, "<showtitle>", "</showtitle>",0)

		$genre = _StringBetween($tvnfo, "<genre>", "</genre>",0)

		$plot = _StringBetween($tvnfo, "<plot>", "</plot>",0)

		$status = _StringBetween($tvnfo, "<status>", "</status>",0)

		$year = _StringBetween($tvnfo, "<year>", "</year>",0)

		$rating = _StringBetween($tvnfo, "<rating>", "</rating>",0)

		$studio = _StringBetween($tvnfo, "<studio>", "</studio>",0)

		$season = _StringBetween($tvnfo, "<season>", "</season>",0)

		$episode = _StringBetween($tvnfo, "<episode>", "</episode>",0)

		If $json_use_uniqueID = "true" Then

			$tvdb = _StringBetween($tvnfo, '<uniqueid type="tvdb">', '</uniqueid>',0)

			$tmdb = _StringBetween($tvnfo, '<uniqueid type="tmdb">', '</uniqueid>',0)

			$imdb = _StringBetween($tvnfo, '<uniqueid type="imdb">', '</uniqueid>',0)

		Else

			$tvdb = _StringBetween($tvnfo, '<tvdbid>', '</tvdbid>',0)

			$tmdb = _StringBetween($tvnfo, '<tmdbid>', '</tmdbid>',0)

			$imdb = _StringBetween($tvnfo, '<imdbid>', '</imdbid>',0)

		EndIf

		If  _ElementExists($title, 0) Then

			$tvnfo = StringReplace($tvnfo, "<title>" & $title[0] & "</title>", "<title>" & GUICtrlRead($input_110_01) & "</title>", 0, 0)

		Else

			$tvnfo = StringReplace($tvnfo, "</episodedetails>", "<title>" & GUICtrlRead($input_110_01) & "</title>" & @CRLF & "</episodedetails>", 0, 0)

		EndIf

		If  _ElementExists($showtitle, 0) Then

			$tvnfo = StringReplace($tvnfo, "<showtitle>" & $showtitle[0] & "</showtitle>", "<showtitle>" & GUICtrlRead($input_110_05) & "</showtitle>", 0, 0)

		Else

			$tvnfo = StringReplace($tvnfo, "</episodedetails>", "<showtitle>" & GUICtrlRead($input_110_05) & "</showtitle>" & @CRLF & "</episodedetails>", 0, 0)

		EndIf

		If  _ElementExists($season, 0) Then

			$tvnfo = StringReplace($tvnfo, "<season>" & $season[0] & "</season>", "<season>" & GUICtrlRead($input_110_04) & "</season>", 0, 0)

		Else

			$tvnfo = StringReplace($tvnfo, "</episodedetails>", "<season>" & GUICtrlRead($input_110_04) & "</season>" & @CRLF & "</episodedetails>", 0, 0)

		EndIf

		If  _ElementExists($episode, 0) Then

			$tvnfo = StringReplace($tvnfo, "<episode>" & $episode[0] & "</episode>", "<episode>" & GUICtrlRead($input_110_04a) & "</episode>", 0, 0)

		Else

			$tvnfo = StringReplace($tvnfo, "</episodedetails>", "<episode>" & GUICtrlRead($input_110_04a) & "</episode>" & @CRLF & "</episodedetails>", 0, 0)

		EndIf

		$genrearray = StringSplit(GUICtrlRead($input_100_03), "|")

		For $i = 1 To $genrearray[0]

			If  _ElementExists($genre, $i - 1) Then

				$tvnfo = StringReplace($tvnfo, "<genre>" & $genre[$i - 1] & "</genre>", "<genre>" & $genrearray[$i] & "</genre>", 0, 0)

			Else

				$tvnfo = StringReplace($tvnfo, "</tvshow>", "<genre>" & $genrearray[$i] & "</genre>" & @CRLF & "</tvshow>", 0, 0)

			EndIf

		Next

		If  _ElementExists($status, 0) Then

			$tvnfo = StringReplace($tvnfo, "<status>" & $status[0] & "</status>", "<status>" & GUICtrlRead($input_100_17) & "</status>", 0, 0)

		Else

			$tvnfo = StringReplace($tvnfo, "</episodedetails>", "<status>" & GUICtrlRead($input_100_17) & "</status>" & @CRLF & "</episodedetails>", 0, 0)

		EndIf

		If $json_use_uniqueID = "true" Then

			If  _ElementExists($tvdb, 0) Then

				$tvnfo = StringReplace($tvnfo, '<uniqueid type="tvdb">' & $tvdb[0] & '</uniqueid>', '<uniqueid type="tvdb">' & GUICtrlRead($input_100_05) & '</uniqueid>', 0, 0)

			Else

				$tvnfo = StringReplace($tvnfo, "</tvshow>",'<uniqueid type="tvdb">' & GUICtrlRead($input_100_05) & '</uniqueid>' & @CRLF & "</tvshow>", 0, 0)

			EndIf

			If  _ElementExists($tmdb, 0) Then

				$tvnfo = StringReplace($tvnfo, '<uniqueid type="tmdb">' & $tmdb[0] & '</uniqueid>', '<uniqueid type="tmdb">' & GUICtrlRead($input_100_05a) & '</uniqueid>', 0, 0)

			Else

				$tvnfo = StringReplace($tvnfo, "</tvshow>",'<uniqueid type="tmdb">' & GUICtrlRead($input_100_05a) & '</uniqueid>' & @CRLF & "</tvshow>", 0, 0)

			EndIf

			If  _ElementExists($imdb, 0) Then

				$tvnfo = StringReplace($tvnfo, '<uniqueid type="imdb">' & $imdb[0] & '</uniqueid>', '<uniqueid type="imdb">' & GUICtrlRead($input_100_05b) & '</uniqueid>', 0, 0)

			Else

				$tvnfo = StringReplace($tvnfo, "</tvshow>",'<uniqueid type="imdb">' & GUICtrlRead($input_100_05b) & '</uniqueid>' & @CRLF & "</tvshow>", 0, 0)

			EndIf

		Else

			If  _ElementExists($tvdb, 0) Then

				$tvnfo = StringReplace($tvnfo, '<tvdbid>' & $tvdb[0] & '</tvdbid>', '<tvdbid>' & GUICtrlRead($input_100_05) & '</tvdbid>', 0, 0)

			Else

				$tvnfo = StringReplace($tvnfo, "</tvshow>",'<tvdbid>' & GUICtrlRead($input_100_05) & '</tvdbid>' & @CRLF & "</tvshow>", 0, 0)

			EndIf

			If  _ElementExists($tmdb, 0) Then

				$tvnfo = StringReplace($tvnfo, '<tmdbid>' & $tmdb[0] & '</tmdbid>', '<tmdbid>' & GUICtrlRead($input_100_05a) & '</tmdbid>', 0, 0)

			Else

				$tvnfo = StringReplace($tvnfo, "</tvshow>",'<tmdbid>' & GUICtrlRead($input_100_05a) & '</tmdbid>' & @CRLF & "</tvshow>", 0, 0)

			EndIf

			If  _ElementExists($imdb, 0) Then

				$tvnfo = StringReplace($tvnfo, '<imdbid>' & $imdb[0] & '</imdbid>', '<imdbid>' & GUICtrlRead($input_100_05b) & '</imdbid>', 0, 0)

			Else

				$tvnfo = StringReplace($tvnfo, "</tvshow>",'<imdbid>' & GUICtrlRead($input_100_05b) & '</imdbid>' & @CRLF & "</tvshow>", 0, 0)

			EndIf

		EndIf

		If  _ElementExists($plot, 0) Then

			$tvnfo = StringReplace($tvnfo, "<plot>" & $plot[0] & "</plot>", "<plot>" & GUICtrlRead($edit_110_04) & "</plot>", 0, 0)

		Else

			$tvnfo = StringReplace($tvnfo, "</episodedetails>", "<plot>" & GUICtrlRead($edit_110_04) & "</plot>" & @CRLF & "</episodedetails>", 0, 0)

		EndIf

		If  _ElementExists($year, 0) Then

			$tvnfo = StringReplace($tvnfo, "<year>" & $year[0] & "</year>", "<year>" & GUICtrlRead($input_110_06) & "</year>", 0, 0)

		Else

			$tvnfo = StringReplace($tvnfo, "</episodedetails>", "<year>" & GUICtrlRead($input_110_06) & "</year>" & @CRLF & "</episodedetails>", 0, 0)

		EndIf


		If  _ElementExists($studio, 0) Then

			$tvnfo = StringReplace($tvnfo, "<studio>" & $studio[0] & "</studio>", "<studio>" & GUICtrlRead($input_100_19) & "</studio>", 0, 0)

		Else

			$tvnfo = StringReplace($tvnfo, "</episodedetails>", "<studio>" & GUICtrlRead($input_100_19) & "</studio>" & @CRLF & "</episodedetails>", 0, 0)

		EndIf

		If  _ElementExists($rating, 0) Then

			$tvnfo = StringReplace($tvnfo, "<rating>" & $rating[0] & "</rating>", "<rating>" & GUICtrlRead($input_100_18) & "</rating>", 0, 0)

		Else

			$tvnfo = StringReplace($tvnfo, "</episodedetails>", "<rating>" & GUICtrlRead($input_100_18) & "</rating>" & @CRLF & "</episodedetails>", 0, 0)

		EndIf

		If  StringInStr($tvnfo, "<mpaa>") Then

			$mpab = _StringBetween($tvnfo, "<mpaa>", "</mpaa>",0)

			If  _ElementExists($mpab, 0) Then

				$tvnfo = StringReplace($tvnfo, "<mpaa>" & $mpab[0] & "</mpaa>", "<mpaa>" & GUICtrlRead($input_100_04) & "</mpaa>", 0, 0)

			Else

				$tvnfo = StringReplace($tvnfo, "<mpaa></mpaa>", "<mpaa>" & GUICtrlRead($input_100_04) & "</mpaa>", 0, 0)

			EndIf

		Else

			$tvnfo = StringReplace($tvnfo, "</episodedetails>", "<mpaa>" & GUICtrlRead($input_100_04) & "</mpaa>" & @CRLF & "</episodedetails>", 0, 0)

		EndIf

		$title1 = _StringBetween($tvnfo, "<title>", "</title>",0)

		$season1 = _StringBetween($tvnfo, "<season>", "</season>",0)

		$episode1 = _StringBetween($tvnfo, "<episode>", "</episode>",0)

		$showtitle1 = _StringBetween($tvnfo, "<showtitle>", "</showtitle>",0)

		$genre1 = _StringBetween($tvnfo, "<genre>", "</genre>",0)

		$plot1 = _StringBetween($tvnfo, "<plot>", "</plot>",0)

		$status1 = _StringBetween($tvnfo, "<status>", "</status>",0)

		$year1 = _StringBetween($tvnfo, "<year>", "</year>",0)

		$studio1 = _StringBetween($tvnfo, "<studio>", "</studio>",0)

		If StringInStr($Rename, "{title}") Then

			$Rename = StringReplace($Rename, "{title}", $title1[0])

		EndIf

		If StringInStr($Rename, "{season}") Then

			$Rename = StringReplace($Rename, "{season}", StringFormat("%02s", $season1[0]))

		EndIf

		If StringInStr($Rename, "{episode}") Then

			$Rename = StringReplace($Rename, "{episode}", StringFormat("%02s",$episode1[0]))

		EndIf

		If StringInStr($Rename, "{showtitle}") Then

			$Rename = StringReplace($Rename, "{showtitle}", $showtitle1[0])

		EndIf

		If StringInStr($Rename, "{genre}") Then

			$Rename = StringReplace($Rename, "{genre}", $genre1[0])

		EndIf

		If StringInStr($Rename, "{year}") Then

			$Rename = StringReplace($Rename, "{year}", $year1[0])

		EndIf

		If StringInStr($Rename, "{studio}") Then

			$Rename = StringReplace($Rename, "{studio}", $studio1[0])

		EndIf

		If  _ElementExists($title1, 0) Then

			Sleep(100)

			$Ifile1 = FileOpen($episodenfo, 2)

			FileWrite($Ifile1, $tvnfo)

			FileClose($Ifile1)

			If $json_Rename_RenameFiles = "True" Then

				If _ElementExists($episode, 1) Then

				Else

					If $Rename1 <> $iPathSplit[3] Then

						FileMove($iPathSplit[1] & $iPathSplit[2] & $iPathSplit[3] & ".nfo", $iPathSplit[1] & $iPathSplit[2] & _FixPath($Rename) & ".nfo")

						FileMove($iPathSplit[1] & $iPathSplit[2] & $iPathSplit[3] & $iPathSplit[4], $iPathSplit[1] & $iPathSplit[2] & _FixPath($Rename) & $iPathSplit[4])

						FileMove($iPathSplit[1] & $iPathSplit[2] & $iPathSplit[3] & ".jpg", $iPathSplit[1] & $iPathSplit[2] & _FixPath($Rename) & ".jpg")

						FileMove($iPathSplit[1] & $iPathSplit[2] & $iPathSplit[3] & "-thumb.jpg", $iPathSplit[1] & $iPathSplit[2] & _FixPath($Rename) & "-thumb.jpg")

						$state = GUICtrlRead($listview_110_01)

						Dim $WorkArra

						GUICtrlDelete($listview_110_01)

						$listview_110_01 = GUICtrlCreateList("", 20, 230, 260, 380, $LBS_DISABLENOSCROLL + $WS_BORdeR + $WS_VSCROLL, $ES_READONLY)

						$WorkArray = _FileListToArrayRec($InDir & "\" & $in_series, $extstring2, 1, 1, 1)


						_GUICtrlListView_BeginUpdate($listview_110_01)

						For $i = 1 To UBound($WorkArray) - 1

							$iPathSplit = _PathSplit($WorkArray[$i], $sDrive, $sDir, $sFilename, $sExtension)

							If $ini_gen_folder = "1" Then

								_ArrayAdd($seasonfolder, $iPathSplit[2])

							EndIf

							_ArrayAdd($episode, $iPathSplit[3])

							GUICtrlSetData($listview_110_01, $WorkArray[$i], $state)

						Next

						_GUICtrlListView_EndUpdate($listview_110_01)

						Sleep(50)

						GUICtrlSetState($listview_110_01, $GUI_FOCUS)



					EndIf

				EndIf

			EndIf

		EndIf

	EndIf

	Return

EndFunc

;Function to Write Edited Data in Afterwork Window
Func _WriteData_120($listitem)

	Local $InDir = GUICtrlRead($input_62_01), $nfo, $Ifile, $i, $moviepath, $count, $count2, $Ifile1
	Local $iPathSplit, $sDrive, $sDir, $sFilename, $sExtension, $series, $episodenfo, $iFileExists
	Local $title, $title1, $status, $genre, $plot, $showtitle, $year, $rating, $studio, $value, $Ifile1
	Local $id, $tmdbid, $originaltitle, $tagline, $set, $country, $imdbid, $nfofile, $mov, $set1, $setnew = 0
	Dim $movie[1]
	Dim $movie1[1]
	Dim $moviefolder[1]
	Dim $movieext[1]
	Local $array

	$WorkArray = _FileListToArrayRec($InDir, $extstring2, 1, 1, 1)

	For $i = 1 To UBound($WorkArray) - 1

		$iPathSplit = _PathSplit($WorkArray[$i], $sDrive, $sDir, $sFilename, $sExtension)

		If StringInStr($iPathSplit[3], "-trailer",0) < 1  Then

			_ArrayAdd($movie, $iPathSplit[3])

			_ArrayAdd($moviefolder, $iPathSplit[2])

			_ArrayAdd($movieext, $iPathSplit[4])

		EndIf

	Next

	$i = _ArraySearch($movie, $listitem)

	$mov = $i

	If $i > 0 Then

		$nfofile = $InDir & "\" & $moviefolder[$i] & $movie[$i] & ".nfo"

		$moviepath = $InDir & "\" & $moviefolder[$i]

		$iFileExists = FileExists($nfofile)

		If $iFileExists = 1 Then

			$Ifile = FileOpen($nfofile, 0)

			$nfo = FileRead($Ifile)

			FileClose($Ifile)

			$title = _StringBetween($nfo, "<title>", "</title>",0)

			$sorttitle = _StringBetween($nfo, "<sorttitle>", "</sorttitle>",0)

			$genre = _StringBetween($nfo, "<genre>", "</genre>",0)

			$plot = _StringBetween($nfo, "<plot>", "</plot>",0)

			$mpaa = _StringBetween($nfo, "<mpaa>", "</mpaa>",0)

;~ 			_ArrayDisplay($mpaa)

			$id = _StringBetween($nfo, "<id>", "</id>",0)

			If $json_use_uniqueID = "true" Then

				$tmdb = _StringBetween($nfo, '<uniqueid type="tmdb">', '</uniqueid>',0)

				$imdb = _StringBetween($nfo, '<uniqueid type="imdb">', '</uniqueid>',0)

			Else

				$tmdb = _StringBetween($nfo, '<tmdbid>', '</tmdbid>',0)

				$imdb = _StringBetween($nfo, '<imdbid>', '</imdbid>',0)

			EndIf

			$originaltitle = _StringBetween($nfo, "<originaltitle>", "</originaltitle>",0)

			$tagline = _StringBetween($nfo, "<tagline>", "</tagline>",0)

			$set1 = _StringBetween($nfo, "<set>", "</set>",0)

			$studio = _StringBetween($nfo, "<studio>", "</studio>",0)

;~ 			_ArrayDisplay($studio)

			$country = _StringBetween($nfo, "<country>", "</country>",0)

			$year = _StringBetween($nfo, "<year>", "</year>",0)

			$rating = _StringBetween($nfo, "<rating>", "</rating>",0)

			$status = _StringBetween($nfo, "<status>", "</status>",0)

			If  _ElementExists($title, 0) Then

				$nfo = StringReplace($nfo, "<title>" & $title[0] & "</title>", "<title>" & GUICtrlRead($input_120_01) & "</title>", 0, 0)

			Else

				$nfo = StringReplace($nfo, "</movie>", "<title>" & GUICtrlRead($input_120_01) & "</title>" & @CRLF & "</movie>", 0, 0)

			EndIf

			If  _ElementExists($sorttitle, 0) Then

				$nfo = StringReplace($nfo, "<sorttitle>" & $sorttitle[0] & "</sorttitle>", "<sorttitle>" & GUICtrlRead($input_120_02) & "</sorttitle>", 0, 0)

			Else

				$nfo = StringReplace($nfo, "</movie>", "<sorttitle>" & GUICtrlRead($input_120_02) & "</sorttitle>" & @CRLF & "</movie>", 0, 0)

			EndIf

			If  _ElementExists($originaltitle, 0) Then

				$nfo = StringReplace($nfo, "<originaltitle>" & $originaltitle[0] & "</originaltitle>", "<originaltitle>" & GUICtrlRead($input_120_03) & "</originaltitle>", 0, 0)

			Else

				$nfo = StringReplace($nfo, "</movie>", "<originaltitle>" & GUICtrlRead($input_120_03) & "</originaltitle>" & @CRLF & "</movie>", 0, 0)

			EndIf

			If  _ElementExists($tagline, 0) Then

				$nfo = StringReplace($nfo, "<tagline>" & $tagline[0] & "</tagline>", "<tagline>" & GUICtrlRead($input_120_04) & "</tagline>", 0, 0)

			Else

				$nfo = StringReplace($nfo, "</movie>", "<tagline>" & GUICtrlRead($input_120_04) & "</tagline>" & @CRLF & "</movie>", 0, 0)

			EndIf

			If  _ElementExists($plot, 0) Then

				$nfo = StringReplace($nfo, "<plot>" & $plot[0] & "</plot>", "<plot>" & GUICtrlRead($edit_120_08) & "</plot>", 0, 0)

			Else

				$nfo = StringReplace($nfo, "</movie>", "<plot>" & GUICtrlRead($edit_120_08) & "</plot>" & @CRLF & "</movie>", 0, 0)

			EndIf

			If $json_use_uniqueID = "true" Then

				If  _ElementExists($imdb, 0) Then

					$nfo = StringReplace($nfo, '<uniqueid type="imdb">' & $imdb[0] & '</uniqueid>', '<uniqueid type="imdb">' & GUICtrlRead($input_120_11) & '</uniqueid>', 0, 0)

				Else

					$nfo = StringReplace($nfo, "</movie>", '<uniqueid type="imdb">' & GUICtrlRead($input_120_11) & '</uniqueid>' & @CRLF & "</movie>", 0, 0)

				EndIf

				If  _ElementExists($tmdb, 0) Then

					$nfo = StringReplace($nfo, '<uniqueid type="tmdb">' & $tmdb[0] & '</uniqueid>', '<uniqueid type="tmdb">' & GUICtrlRead($input_120_12) & '</uniqueid>', 0, 0)

				Else

					$nfo = StringReplace($nfo, "</movie>", '<uniqueid type="tmdb">' & GUICtrlRead($input_120_12) & '</uniqueid>' & @CRLF & "</movie>", 0, 0)

				EndIf

				If  _ElementExists($set1, 0) Then

					$nfo = StringReplace($nfo, "<set>" & $set1[0] & "</set>", "<set>" & @CRLF & "    <name>" & GUICtrlRead($input_120_05) & "</name>" & @CRLF & "  </set>", 0, 0)

				Else

					$nfo = StringReplace($nfo, "</movie>",  "<set>" & @CRLF & "    <name>" & GUICtrlRead($input_120_05) & "</name>" & @CRLF & "</set>" & @CRLF & "</movie>", 0, 0)

				EndIf

			Else

				If  _ElementExists($id, 0) Then

					$nfo = StringReplace($nfo, "<id>" & $id[0] & "</id>", "<id>" & GUICtrlRead($input_120_11) & "</id>", 0, 0)

				Else

					$nfo = StringReplace($nfo, "</movie>", "<id>" & GUICtrlRead($input_120_11) & "</id>" & @CRLF & "</movie>", 0, 0)

				EndIf

				If  _ElementExists($imdbid, 0) Then

					$nfo = StringReplace($nfo, "<imdbid>" & $id[0] & "</imdbid>", "<imdbid>" & GUICtrlRead($input_120_11) & "</imdbid>", 0, 0)

				Else

					$nfo = StringReplace($nfo, "</movie>", "<imdbid>" & GUICtrlRead($input_120_11) & "</imdbid>" & @CRLF & "</movie>", 0, 0)

				EndIf

				If  _ElementExists($tmdbid, 0) Then

					$nfo = StringReplace($nfo, "<tmdbid>" & $tmdbid[0] & "</tmdbid>", "<tmdbid>" & GUICtrlRead($input_120_12) & "</tmdbid>", 0, 0)

				Else

					$nfo = StringReplace($nfo, "</movie>", "<tmdbid>" & GUICtrlRead($input_120_12) & "</tmdbid>" & @CRLF & "</movie>", 0, 0)

				EndIf

				If  _ElementExists($set1, 0) Then

					$nfo = StringReplace($nfo, "<set>" & $set1[0] & "</set>", "<set>" & GUICtrlRead($input_120_05) & "</set>", 0, 0)

				Else

					$nfo = StringReplace($nfo, "</movie>", "<set>" & GUICtrlRead($input_120_05) & "</set>" & @CRLF & "</movie>", 0, 0)

				EndIf

			EndIf


			If  _ElementExists($mpaa, 0) Then


				$nfo = StringReplace($nfo, "<mpaa>" & $mpaa[0] & "</mpaa>", "<mpaa>" & GUICtrlRead($input_120_13) & "</mpaa>", 0, 0)

			Else

				$nfo = StringReplace($nfo, "</movie>", "<mpaa>" & GUICtrlRead($input_120_13) & "</mpaa>" & @CRLF & "</movie>", 0, 0)

			EndIf

			If  _ElementExists($year, 0) Then

				$nfo = StringReplace($nfo, "<year>" & $year[0] & "</year>", "<year>" & GUICtrlRead($input_120_15) & "</year>", 0, 0)

			Else

				$nfo = StringReplace($nfo, "</movie>", "<year>" & GUICtrlRead($input_120_15) & "</year>" & @CRLF & "</movie>", 0, 0)

			EndIf

			If  _ElementExists($rating, 0) Then

				$nfo = StringReplace($nfo, "<rating>" & $rating[0] & "</rating>", "<rating>" & GUICtrlRead($input_120_16) & "</rating>", 0, 0)

			Else

				$nfo = StringReplace($nfo, "</movie>", "<rating>" & GUICtrlRead($input_120_16) & "</rating>" & @CRLF & "</movie>", 0, 0)

			EndIf

			If  _ElementExists($status, 0) Then

				$nfo = StringReplace($nfo, "<status>" & $status[0] & "</status>", "<status>" & GUICtrlRead($input_120_17) & "</status>", 0, 0)

			Else

				$nfo = StringReplace($nfo, "</movie>", "<status>" & GUICtrlRead($input_120_17) & "</status>" & @CRLF & "</movie>", 0, 0)

			EndIf

			$array = StringSplit(GUICtrlRead($input_120_06), "|", 2)

			$count = UBound($array) - 1

			$count2 = UBound($genre) - 1

			If $count = $count2 Then

				For $i = 0 To $count

					$nfo = StringReplace($nfo, "<genre>" & $genre[$i] & "</genre>", "<genre>" & $array[$i] & "</genre>", 0, 0)

				Next

			EndIf

			If $count < $count2 Then

				For $i = 0 To $count2

						$nfo = StringReplace($nfo, "<genre>" & $genre[$i] & "</genre>" & @CRLF, "", 0, 0)

				Next

				For $i = 0 To $count

					$nfo = StringReplace($nfo, "</movie>", "<genre>" & $array[$i] & "</genre>" & @CRLF & "</movie>", 0, 0)

				Next

			EndIf

			If $count > $count2 Then

				For $i = 0 To $count2

						$nfo = StringReplace($nfo, "<genre>" & $genre[$i] & "</genre>", "<genre>" & $array[$i] & "</genre>", 0, 0)

				Next

				For $i = $count2 + 1 To $count

					$nfo = StringReplace($nfo, "</movie>", "<genre>" & $array[$i] & "</genre>" & @CRLF & "</movie>", 0, 0)

				Next

			EndIf


			$array = StringSplit(GUICtrlRead($input_120_14), "|", 2)

			$count = UBound($array) - 1

			$count2 = UBound($country) - 1

			If $count = $count2 Then

				For $i = 0 To $count

					$nfo = StringReplace($nfo, "<country>" & $country[$i] & "</country>", "<country>" & $array[$i] & "</country>", 0, 0)

				Next

			EndIf

			If $count < $count2 Then

				For $i = 0 To $count2

						$nfo = StringReplace($nfo, "<country>" & $country[$i] & "</country>" & @CRLF, "", 0, 0)

				Next

				For $i = 0 To $count

					$nfo = StringReplace($nfo, "</movie>", "<country>" & $array[$i] & "</country>" & @CRLF & "</movie>", 0, 0)

				Next

			EndIf

			If $count > $count2 Then

				For $i = 0 To $count2

						$nfo = StringReplace($nfo, "<country>" & $country[$i] & "</country>", "<country>" & $array[$i] & "</country>", 0, 0)

				Next

				For $i = $count2 + 1 To $count

					$nfo = StringReplace($nfo, "</movie>", "<country>" & $array[$i] & "</country>" & @CRLF & "</movie>", 0, 0)

				Next

			EndIf


			$array = StringSplit(GUICtrlRead($input_120_07), "|", 2)

			$count = UBound($array) - 1

			$count2 = UBound($studio) - 1

			If $count = $count2 Then

				For $i = 0 To $count

					$nfo = StringReplace($nfo, "<studio>" & $studio[$i] & "</studio>", "<studio>" & $array[$i] & "</studio>", 0, 0)

				Next

			EndIf

			If $count < $count2 Then

				For $i = 0 To $count2

						$nfo = StringReplace($nfo, "<studio>" & $studio[$i] & "</studio>" & @CRLF, "", 0, 0)

				Next

				For $i = 0 To $count

					$nfo = StringReplace($nfo, "</movie>", "<studio>" & $array[$i] & "</studio>" & @CRLF & "</movie>", 0, 0)

				Next

			EndIf

			If $count > $count2 Then

				For $i = 0 To $count2

						$nfo = StringReplace($nfo, "<studio>" & $studio[$i] & "</studio>", "<studio>" & $array[$i] & "</studio>", 0, 0)

				Next

				For $i = $count2 + 1 To $count

					$nfo = StringReplace($nfo, "</movie>", "<studio>" & $array[$i] & "</studio>" & @CRLF & "</movie>", 0, 0)

				Next

			EndIf


			$title1 = _StringBetween($nfo, "<title>", "</title>",0)

			If  _ElementExists($title1, 0) Then

				Sleep(100)

				$Ifile1 = FileOpen($nfofile, 2)

				FileWrite($Ifile1, $nfo)

				FileClose($Ifile1)

				If $listitem = _FixPath($title1[0]) Then



				Else

					$iPathSplit = _PathSplit($InDir & "\" & $WorkArray[$mov], $sDrive, $sDir, $sFilename, $sExtension)

					FileMove($nfofile, $moviepath & _FixPath($title1[0]) & ".nfo")

					FileMove($iPathSplit[1] & $iPathSplit[2] & $iPathSplit[3] & $iPathSplit[4], $iPathSplit[1] & $iPathSplit[2] & _FixPath($title1[0]) & $iPathSplit[4])

					DirMove($iPathSplit[1] & $iPathSplit[2], $InDir & "\" & StringReplace($moviefolder[$mov], $iPathSplit[3], _FixPath($title1[0])))

					$WorkArray = _FileListToArrayRec($InDir, $extstring2, 1, 1, 1)

					For $i = 1 To UBound($WorkArray) - 1

						$iPathSplit = _PathSplit($WorkArray[$i], $sDrive, $sDir, $sFilename, $sExtension)

						_ArrayAdd($movie1, $iPathSplit[3])

					Next

					GUICtrlDelete($listview_120_01)

					$listview_120_01 = GUICtrlCreateList("", 20, 230, 260, 380, $LBS_DISABLENOSCROLL + $WS_BORdeR + $WS_VSCROLL, $ES_READONLY)

					For $i = 1 To UBound($movie1) - 1

						GUICtrlSetData($listview_120_01, $movie1[$i])

					Next

;~ 					GUICtrlSetState($listview_120_01, $GUI_SHOW)

				EndIf

			EndIf

		EndIf

	EndIf

	Return

EndFunc

;Function to Write Edited Data in Afterwork Window
Func _WriteData_130($listitem)

	Local $InDir = GUICtrlRead($input_63_01), $nfo, $Ifile, $file, $i, $moviepath, $count, $count2, $Ifile1
	Local $iPathSplit, $sDrive, $sDir, $sFilename, $sExtension, $series, $episodenfo, $iFileExists
	Local $title, $title1, $status, $genre, $plot, $showtitle, $year, $rating, $studio, $value, $Ifile1
	Local $id, $tmdbid, $originaltitle, $tagline, $set, $country, $imdbid, $nfofile
	Dim $movie[1]
	Dim $moviefolder[1]
	Dim $moviefile[1]
	Local $array

	$WorkArray = _FileListToArrayRec($InDir, $extstring2, 1, 1, 1)

	For $i = 1 To UBound($WorkArray) - 1

		$iPathSplit = _PathSplit($WorkArray[$i], $sDrive, $sDir, $sFilename, $sExtension)

		_ArrayAdd($movie, $iPathSplit[3])

		_ArrayAdd($moviefolder, $iPathSplit[2])

		_ArrayAdd($moviefile, $iPathSplit[3] & $iPathSplit[4])

	Next

	$i = _ArraySearch($movie, $listitem)

	If $i > 0 Then

		$nfofile = $InDir & "\" & $moviefolder[$i] & $movie[$i] & ".nfo"

		$moviepath = $InDir & "\" & $moviefolder[$i]

		$file = $InDir & "\" & $moviefolder[$i] & $moviefile[$i]

		$iFileExists = FileExists($nfofile)

		If $iFileExists = 1 Then

			$Ifile = FileOpen($nfofile, 0)

			$nfo = FileRead($Ifile)

			FileClose($Ifile)

			$title = _StringBetween($nfo, "<title>", "</title>",0)

			$sorttitle = _StringBetween($nfo, "<sorttitle>", "</sorttitle>",0)

			$genre = _StringBetween($nfo, "<genre>", "</genre>",0)

			$plot = _StringBetween($nfo, "<plot>", "</plot>",0)

			$year = _StringBetween($nfo, "<year>", "</year>",0)

			If  _ElementExists($title, 0) Then

				$nfo = StringReplace($nfo, "<title>" & $title[0] & "</title>", "<title>" & GUICtrlRead($input_130_01) & "</title>", 0, 0)

			Else

				$nfo = StringReplace($nfo, "</movie>", "<title>" & GUICtrlRead($input_130_01) & "</title>" & @CRLF & "</movie>", 0, 0)

			EndIf

			If  _ElementExists($sorttitle, 0) Then

				$nfo = StringReplace($nfo, "<sorttitle>" & $sorttitle[0] & "</sorttitle>", "<sorttitle>" & GUICtrlRead($input_130_02) & "</sorttitle>", 0, 0)

			Else

				$nfo = StringReplace($nfo, "</movie>", "<sorttitle>" & GUICtrlRead($input_130_02) & "</sorttitle>" & @CRLF & "</movie>", 0, 0)

			EndIf

			If  _ElementExists($year, 0) Then

				$nfo = StringReplace($nfo, "<year>" & $year[0] & "</year>", "<year>" & GUICtrlRead($input_130_04) & "</year>", 0, 0)

			Else

				$nfo = StringReplace($nfo, "</movie>", "<year>" & GUICtrlRead($input_130_04) & "</year>" & @CRLF & "</movie>", 0, 0)

			EndIf

			If  _ElementExists($plot, 0) Then

				$nfo = StringReplace($nfo, "<plot>" & $plot[0] & "</plot>", "<plot>" & GUICtrlRead($edit_130_05) & "</plot>", 0, 0)

			Else

				$nfo = StringReplace($nfo, "</movie>", "<plot>" & GUICtrlRead($edit_130_05) & "</plot>" & @CRLF & "</movie>", 0, 0)

			EndIf

			$array = StringSplit(GUICtrlRead($input_130_03), "|")

			$count = UBound($array) - 2

			$count2 = UBound($genre) - 1

			If $count = $count2 Then

				For $i = 0 To $count

					$nfo = StringReplace($nfo, $genre[$i], $array[$i + 1], $i, 0)

				Next

			EndIf

			If $count < $count2 Then

				For $i = 0 To $count2

					$nfo = StringReplace($nfo, "<genre>" & $genre[$i] & "</genre>" & @CRLF, "", $i, 0)

				Next

				For $i = 0 To $count

					$nfo = StringReplace($nfo, "</movie>", "<genre>" & $array[$i + 1] & "</genre>" & @CRLF & "</movie>", 0, 0)

				Next

			EndIf

			If $count > $count2 Then

				For $i = 0 To $count2

					$nfo = StringReplace($nfo, $genre[$i], $array[$i + 1], $i, 0)

				Next

				For $i = $count2 + 1 To $count

					$nfo = StringReplace($nfo, "</movie>", "<genre>" & $array[$i + 1] & "</genre>" & @CRLF & "</movie>", 0, 0)

				Next

			EndIf

			$title1 = _StringBetween($nfo, "<title>", "</title>",0)

			If  _ElementExists($title1, 0) Then

				Sleep(100)

				$Ifile1 = FileOpen($nfofile, 2)

				FileWrite($Ifile1, $nfo)

				FileClose($Ifile1)

			EndIf

		EndIf

	EndIf

	Return $file

EndFunc

;Function to Write Edited Data in Afterwork Window
Func _WriteData_140($listitem)

	Local $InDir = GUICtrlRead($input_64_01), $artist, $Ifile, $iFileExists, $gender
	Local $name, $genre, $nfo, $born, $bio, $formed, $died, $disbanded, $name1

	$artist = $InDir & "\" & $listitem & "\artist.nfo"

	$iFileExists = FileExists($artist)

	If $iFileExists = 1 Then

		$Ifile = FileOpen($artist, 128)

		$nfo = FileRead($Ifile)

		FileClose($Ifile)

		$name = _StringBetween($nfo, "<name>", "</name>",0)

		$mbid = _StringBetween($nfo, "<musicBrainzArtistID>", "</musicBrainzArtistID>",0)

		$born = _StringBetween($nfo, "<born>", "</born>",0)

		$bio = _StringBetween($nfo, "<biography>", "</biography>",0)

		$formed = _StringBetween($nfo, "<formed>", "</formed>",0)

		$died = _StringBetween($nfo, "died>", "</died>",0)

		$disbanded = _StringBetween($nfo, "<disbanded>", "</disbanded>",0)

		$disambiguation = _StringBetween($nfo, "<disambiguation>", "</disambiguation>",0)

		$genre = _StringBetween($nfo, "<genre>", "</genre>",0)

		$gender = _StringBetween($nfo, "<gender>", "</gender>",0)


		If  _ElementExists($name, 0) Then

			$nfo = StringReplace($nfo, "<name>" & $name[0] & "</name>", "<name>" & GUICtrlRead($input_140_01) & "</name>", 0, 0)

		Else

			$nfo = StringReplace($nfo, "</artist>", " <name>" & GUICtrlRead($input_140_01) & "</name>" & @CRLF & "</artist>", 0, 0)

		EndIf

		If  _ElementExists($mbid, 0) Then

			$nfo = StringReplace($nfo, "<musicBrainzArtistID>" & $mbid[0] & "</musicBrainzArtistID>", "<musicBrainzArtistID>" & GUICtrlRead($input_140_02) & "</musicBrainzArtistID>", 0, 0)

		Else

			$nfo = StringReplace($nfo, "</artist>", " <musicBrainzArtistID>" & GUICtrlRead($input_140_02) & "</musicBrainzArtistID>" & @CRLF & "</artist>", 0, 0)

		EndIf

		If  _ElementExists($born, 0) Then

			$nfo = StringReplace($nfo, "<born>" & $born[0] & "</born>", "<born>" & GUICtrlRead($input_140_03) & "</born>", 0, 0)

		Else

			$nfo = StringReplace($nfo, "</artist>", " <born>" & GUICtrlRead($input_140_03) & "</born>" & @CRLF & "</artist>", 0, 0)

		EndIf

		If  _ElementExists($bio, 0) Then

			$nfo = StringReplace($nfo, "<biography>" & $bio[0] & "</biography>", "<biography>" & GUICtrlRead($edit_140_04) & "</biography>", 0, 0)

		Else

			$nfo = StringReplace($nfo, "</artist>", " <biography>" & GUICtrlRead($edit_140_04) & "</biography>" & @CRLF & "</artist>", 0, 0)

		EndIf

		If  _ElementExists($formed, 0) Then

			$nfo = StringReplace($nfo, "<formed>" & $formed[0] & "</formed>", "<formed>" & GUICtrlRead($input_140_04) & "</formed>", 0, 0)

		Else

			$nfo = StringReplace($nfo, "</artist>", " <formed>" & GUICtrlRead($input_140_04) & "</formed>" & @CRLF & "</artist>", 0, 0)

		EndIf

		If  _ElementExists($died, 0) Then

			$nfo = StringReplace($nfo, "<died>" & $died[0] & "</died>", "<died>" & GUICtrlRead($input_140_13) & "</died>", 0, 0)

		Else

			$nfo = StringReplace($nfo, "</artist>", " <died>" & GUICtrlRead($input_140_13) & "</died>" & @CRLF & "</artist>", 0, 0)

		EndIf

		If  _ElementExists($disbanded, 0) Then

			$nfo = StringReplace($nfo, "<disbanded>" & $disbanded[0] & "</disbanded>", "<disbanded>" & GUICtrlRead($input_140_14) & "</disbanded>", 0, 0)

		Else

			$nfo = StringReplace($nfo, "</artist>", " <disbanded>" & GUICtrlRead($input_140_14) & "</disbanded>" & @CRLF & "</artist>", 0, 0)

		EndIf

		If  _ElementExists($disambiguation, 0) Then

			$nfo = StringReplace($nfo, "<disambiguation>" & $disambiguation[0] & "</disambiguation>", "<disambiguation>" & GUICtrlRead($input_140_09) & "</disambiguation>", 0, 0)

		Else

			$nfo = StringReplace($nfo, "</artist>", " <disambiguation>" & GUICtrlRead($input_140_09) & "</disambiguation>" & @CRLF & "</artist>", 0, 0)

		EndIf


		If  _ElementExists($genre, 0) Then

			$nfo = StringReplace($nfo, "<genre>" & $genre[0] & "</genre>", "<genre>" & GUICtrlRead($input_140_07) & "</genre>", 0, 0)

		Else

			$nfo = StringReplace($nfo, "</artist>", " <genre>" & GUICtrlRead($input_140_07) & "</genre>" & @CRLF & "</artist>", 0, 0)

		EndIf

		If  _ElementExists($gender, 0) Then

			$nfo = StringReplace($nfo, "<gender>" & $gender[0] & "</gender>", "<gender>" & GUICtrlRead($input_140_08) & "</gender>", 0, 0)

		Else

			$nfo = StringReplace($nfo, "</artist>", " <gender>" & GUICtrlRead($input_140_07) & "</gender>" & @CRLF & "</artist>", 0, 0)

		EndIf

		$name1 = _StringBetween($nfo, "<name>", "</name>",0)

		If  _ElementExists($name1, 0) Then

			Sleep(100)

			$Ifile1 = FileOpen($artist, 2)

			FileWrite($Ifile1, $nfo)

			FileClose($Ifile1)

		EndIf

	EndIf

	Return

EndFunc

;Function to Write Edited Data in Afterwork Window
Func _WriteData_150($listitem, $in_artist)

	Local $InDir = GUICtrlRead($input_64_01), $album, $Ifile, $iFileExists, $test = 0
	Local $title, $genre, $nfo, $style, $compilation, $year, $mood, $review, $label
	Local $theme, $name1, $musicBrainzArtistID, $artist

	$album = $InDir  & "\" & $in_artist & "\" & $listitem & "\album.nfo"

	_WriteLog("_WriteData_150 - Working On  " & $album)

	$iFileExists = FileExists($album)

	If $iFileExists = 1 Then

		$Ifile = FileOpen($album, 128)

		$nfo = FileRead($Ifile)

		FileClose($Ifile)

		$title = _StringBetween($nfo, "<title>", "</title>",0)

		$genre = _StringBetween($nfo, "<genre>", "</genre>",0)

		$compilation = _StringBetween($nfo, "<compilation>", "</compilation>",0)

		$style = _StringBetween($nfo, "<style>", "</style>",0)

		$mood = _StringBetween($nfo, "<mood>", "</mood>",0)

		$year = _StringBetween($nfo, "<year>", "</year>",0)

		$review = _StringBetween($nfo, "<review>", "</review>",0)

		$label = _StringBetween($nfo, "<label>", "</label>",0)

		$theme = _StringBetween($nfo, "<theme>", "</theme>",0)

		$artist = _StringBetween($nfo, "<artist>", "</artist>",0)

		$musicBrainzArtistID = _StringBetween($nfo, "<musicBrainzArtistID>", "</musicBrainzArtistID>",0)

		If  _ElementExists($title, 0) Then

			$nfo = StringReplace($nfo, "<title>" & $title[0] & "</title>", "<title>" & GUICtrlRead($input_150_01) & "</title>", 0, 0)

		Else

			$nfo = StringReplace($nfo, "</album>", " <title>" & GUICtrlRead($input_150_01) & "</title>" & @CRLF & "</album>", 0, 0)

		EndIf

		If  _ElementExists($genre, 0) Then

			$nfo = StringReplace($nfo, "<genre>" & $genre[0] & "</genre>", "<genre>" & GUICtrlRead($input_150_13) & "</genre>", 0, 0)

		Else

			$nfo = StringReplace($nfo, "</album>", " <genre>" & GUICtrlRead($input_150_13) & "</genre>" & @CRLF & "</album>", 0, 0)

		EndIf

		If  _ElementExists($style, 0) Then

			$nfo = StringReplace($nfo, "<style>" & $style[0] & "</style>", "<style>" & GUICtrlRead($input_150_04) & "</style>", 0, 0)

		Else

			$nfo = StringReplace($nfo, "</album>", " <style>" & GUICtrlRead($input_150_04) & "</style>" & @CRLF & "</album>", 0, 0)

		EndIf

		If  _ElementExists($mood, 0) Then

			$nfo = StringReplace($nfo, "<mood>" & $mood[0] & "</mood>", "<mood>" & GUICtrlRead($input_150_14) & "</mood>", 0, 0)

		Else

			$nfo = StringReplace($nfo, "</album>", " <mood>" & GUICtrlRead($input_150_14) & "</mood>" & @CRLF & "</album>", 0, 0)

		EndIf

		If  _ElementExists($year, 0) Then

			$nfo = StringReplace($nfo, "<year>" & $year[0] & "</year>", "<year>" & GUICtrlRead($input_150_05) & "</year>", 0, 0)

		Else

			$nfo = StringReplace($nfo, "</album>", " <year>" & GUICtrlRead($input_150_05) & "</year>" & @CRLF & "</album>", 0, 0)

		EndIf

		If  _ElementExists($review, 0) Then

			$nfo = StringReplace($nfo, "<review>" & $review[0] & "</review>", "<review>" & GUICtrlRead($Edit_150_06) & "</review>", 0, 0)

		Else

			$nfo = StringReplace($nfo, "</album>", " <review>" & GUICtrlRead($Edit_150_06) & "</review>" & @CRLF & "</album>", 0, 0)

		EndIf

		If  _ElementExists($label, 0) Then

			$nfo = StringReplace($nfo, "<label>" & $label[0] & "</label>", "<label>" & GUICtrlRead($input_150_15) & "</label>", 0, 0)

		Else

			$nfo = StringReplace($nfo, "</album>", " <label>" & GUICtrlRead($input_150_15) & "</label>" & @CRLF & "</album>", 0, 0)

		EndIf

		If  _ElementExists($theme, 0) Then

			$nfo = StringReplace($nfo, "<theme>" & $theme[0] & "</theme>", "<theme>" & GUICtrlRead($input_150_03) & "</theme>", 0, 0)

		Else

			$nfo = StringReplace($nfo, "</album>", " <theme>" & GUICtrlRead($input_150_03) & "</theme>" & @CRLF & "</album>", 0, 0)

		EndIf

		If  _ElementExists($artist, 0) Then

			$nfo = StringReplace($nfo, "<artist>" & $artist[0] & "</artist>", "<artist>" & GUICtrlRead($input_150_02) & "</artist>", 0, 0)

		Else

			$nfo = StringReplace($nfo, "</albumArtistCredits>", " <artist>" & GUICtrlRead($input_150_02) & "</artist>" & @CRLF & "</albumArtistCredits>", 0, 0)

		EndIf

		If  _ElementExists($musicBrainzArtistID, 0) Then

			$nfo = StringReplace($nfo, "<musicBrainzArtistID>" & $musicBrainzArtistID[0] & "</musicBrainzArtistID>", "<musicBrainzArtistID>" & GUICtrlRead($input_150_03) & "</musicBrainzArtistID>", 0, 0)

		Else

			$nfo = StringReplace($nfo, "</albumArtistCredits>", " <musicBrainzArtistID>" & GUICtrlRead($input_150_03) & "</musicBrainzArtistID>" & @CRLF & "</albumArtistCredits>", 0, 0)

		EndIf

		Sleep(100)

		$Ifile1 = FileOpen($album, 2)

		FileWrite($Ifile1, $nfo)

		FileClose($Ifile1)

	EndIf

	Return

EndFunc

;Function to Write Edited Data in Afterwork Window
Func _Tag_Again($type, $InFile = "")

	Local $InDir, $ini_meta_series_refresh_nfo1, $ini_meta_series_refresh_gfx1, $ini_series_metadata_inputfolder1
	Local $ini_meta_movies_refresh_nfo1, $ini_meta_movies_refresh_gfx1, $ini_movies_metadata_inputfolder1
	Local $ini_videos_metadata_inputfolder1, $fanart_nocover, $fanart_nobackdrop, $fanart_nonfo, $t

	_WriteLog("Tag_Again - Started ")

	If $type = "series" Then

		$InDir = IniRead(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_series_correction_inputfolder", @MyDocumentsDir)

		$ini_meta_series_refresh_nfo1 = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_meta_series_refresh_nfo", "1")
		$ini_meta_series_refresh_gfx1 = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_meta_series_refresh_gfx", "1")
		$ini_series_metadata_inputfolder1 = IniRead(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_series_metadata_inputfolder", @MyDocumentsDir)

		IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_meta_series_refresh_nfo", "4")
		IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_meta_series_refresh_gfx", "4")
		IniWrite(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_series_metadata_inputfolder", $InDir)

		_ClearGUI($Array_GUI_Elements_61)

		GUICtrlSetState($Pic_31_01, $GUI_HIDE)
		GUICtrlSetState($Pic_06_01, $GUI_HIDE)

		GUISetState(@SW_HIde, $Afterworkwindow)
		GUISetState(@SW_SHOW, $Mainwindow)

		_Metadata_Series()

		IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_meta_series_refresh_nfo", $ini_meta_series_refresh_nfo1)
		IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_meta_series_refresh_gfx", $ini_meta_series_refresh_gfx1)
		IniWrite(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_series_metadata_inputfolder", $ini_series_metadata_inputfolder1)



	EndIf

	If $type = "movies" Then

		$InDir = IniRead(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_movies_correction_inputfolder", @MyDocumentsDir)

		$ini_meta_movies_refresh_nfo1 = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_meta_movies_refresh_nfo", "1")
		$ini_meta_movies_refresh_gfx1 = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_meta_movies_refresh_gfx", "1")
		$ini_movies_metadata_inputfolder1 = IniRead(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_movies_metadata_inputfolder", @MyDocumentsDir)

		IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_meta_movies_refresh_nfo", "4")
		IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_meta_movies_refresh_gfx", "4")
		IniWrite(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_movies_metadata_inputfolder", $InDir)

		_ClearGUI($Array_GUI_Elements_62)

		GUICtrlSetState($Pic_32_01, $GUI_HIDE)
		GUICtrlSetState($Pic_06_01, $GUI_HIDE)

		GUISetState(@SW_HIde, $Afterworkwindow)
		GUISetState(@SW_SHOW, $Mainwindow)

		_Metadata_Movies()

		IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_meta_movies_refresh_nfo", $ini_meta_movies_refresh_nfo1)
		IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_meta_movies_refresh_gfx", $ini_meta_movies_refresh_gfx1)
		IniWrite(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_movies_metadata_inputfolder", $ini_movies_metadata_inputfolder1)

	EndIf

	If $type = "videos" Then

		_WriteLog("Tag_Again - Start working on " & $InFile)

		$InDir = IniRead(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_videos_correction_inputfolder", @MyDocumentsDir)

		$ini_videos_metadata_inputfolder1 = IniRead(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_videos_metadata_inputfolder", @MyDocumentsDir)
		$fanart_nocover = GUICtrlRead($check_95_01)
		$fanart_nobackdrop = GUICtrlRead($check_95_02)
		$fanart_nonfo = GUICtrlRead($check_95_03)


		If GUICtrlRead($check_130_01) = 1 Then

			GUICtrlSetState($check_95_01, $GUI_UNCHECKED)

		Else

			GUICtrlSetState($check_95_01, $GUI_CHECKED)

		EndIf

		If GUICtrlRead($check_130_02) = 1 Then

			GUICtrlSetState($check_95_02, $GUI_UNCHECKED)

		Else

			GUICtrlSetState($check_95_02, $GUI_CHECKED)

		EndIf

		GUICtrlSetState($check_95_03, $GUI_CHECKED)

		IniWrite(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_videos_metadata_inputfolder", $InDir)

		_ClearGUI($Array_GUI_Elements_63)

		GUICtrlSetState($Pic_33_01, $GUI_HIDE)
		GUICtrlSetState($Pic_06_01, $GUI_HIDE)

		GUISetState(@SW_HIde, $Afterworkwindow)
		GUISetState(@SW_SHOW, $Mainwindow)

			If  GUICtrlRead($check_130_11) = 1 And GUICtrlRead($check_130_01) = 1 Then

				_Metadata_Videos_Manual($InFile, $fanart_nocover)

				If GUICtrlRead($check_130_02) = 1 Then

					GUICtrlSetState($check_95_01, $GUI_CHECKED)

					IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_fanart_nocover", "1")

					_Metadata_Videos($InFile, "false")

					IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_fanart_nocover", $fanart_nocover)

				EndIf

			Else

				_Metadata_Videos($InFile, "false")

			EndIf


		IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_fanart_nocover", $fanart_nocover)
		IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_fanart_nobackdrop", $fanart_nobackdrop)
		IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_fanart_nonfo", $fanart_nonfo)
		IniWrite(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_videos_metadata_inputfolder", $ini_videos_metadata_inputfolder1)

		If $fanart_nocover = 1 Then

			GUICtrlSetState($check_95_01, $GUI_CHECKED)

		Else

			GUICtrlSetState($check_95_01, $GUI_UNCHECKED)

		EndIf

		If $fanart_nobackdrop = 1 Then

			GUICtrlSetState($check_95_02, $GUI_CHECKED)

		Else

			GUICtrlSetState($check_95_02, $GUI_UNCHECKED)

		EndIf

		If $fanart_nonfo = 1 Then

			GUICtrlSetState($check_95_03, $GUI_CHECKED)

		Else

			GUICtrlSetState($check_95_03, $GUI_UNCHECKED)

		EndIf


		_WriteLog("Tag_Again - Finished working on " & $InFile)

		GUICtrlSetState($Pic_33_01, $GUI_SHOW)
		GUICtrlSetState($Pic_06_01, $GUI_SHOW)

		_ShowGUI($Array_GUI_Elements_63)

		GUISetState(@SW_HIde, $Mainwindow)
		GUISetState(@SW_SHOW, $Afterworkwindow)

	EndIf

	_WriteLog("Tag_Again - Finished ")

	_LastModule()

	Return

EndFunc

#EndRegion

#Region ;Foreign Functions

#Region ;Large File Copy
; #FUNCTION# ====================================================================================================
; Name...........:  _LargeFileCopyUnbuffered
; Description....:  Copy large files in such a way as to keep AutoIt GUIs responsive
; Syntax.........:  _LargeFileCopyUnbuffered($sSrc, $sDest[, $iFlags = 0[, $iToRead = 2097152[, $iAlg = $CALG_MD5[, $sFunction = ""[, $vUserVar = Default]]]]])
; Parameters.....:  $sSrc       - Source file name
;                   $sDest      - Destination: may be a file name or directory
;                   $iFlags     - [Optional] Combine flags with BitOR
;                               |   1 - Overwrite existing file
;                               |   2 - Create destination directory structure
;                               |   8 - Verify source and destination are identical via bit by bit comparison
;                               |  16 - Verify source and destination are identical via MD5 hash
;                               |  64 - Copy source file attributes (NOT including Compression or Encryption)
;                               | 128 - Copy source file Creation time
;                               | 256 - Copy source file Last Accessed time
;                               | 512 - Copy source file Modified time
;                               |1024 - Copy source file Security Descriptors and Ownership
;                               |2048 - Copy source compression state
;                               |4096 - Copy source encryption state
;                               + If more than one verify flag is set, the smallest flag will take precedence
;                   $iToRead    - [Optional] Size of the read buffer (Default = 8 MB)
;                   $iAlg       - [Optional] Algorithm to use for file verification (Default = $CALG_MD5)
;                               + Available algorithms: $CALG_MD2, $CALG_MD4, $CALG_MD5, $CALG_SHA1
;                   $sFunction  - [Optional] Function to be called after each write operation (Default = "")
;                               + Function will be called with the following parameters:
;                               | 1 - Total bytes written
;                               | 2 - Total file size in bytes
;                               | 3 - Optional user variable
;                   $vUserVar   - [Optional] User variable to pass to function (Default = Default)
;
; Return values..:  Success     - 1
;                   Failure     - 0 and sets @error
;                               | 1 - Failed to open source file, or source was a directory
;                               | 2 - Destination file exists and overwrite flag not set
;                               | 3 - Failed to create destination file
;                               | 4 - Read error during copy
;                               | 5 - Write error during copy
;                               | 6 - Verify failed
;                               | 7 - Failed to set destination file size
; Author.........:  Erik Pilsits
; Modified.......:
; Remarks........:
; Related........:
; Link...........:
; Example........:
; ===============================================================================================================
Func _LargeFileCopy($sSrc, $sDest, $iFlags = 0, $iToRead = 2097152, $iAlg = $CALG_MD5, $sFunction = "", $vUserVar = Default, $button = "0000")

	Local $break = 0, $a

    ; check / fix source and dest path syntax
    _LFC_FixPathEx($sSrc, $sDest)

    ; open file for reading, fail if it doesn't exist or directory
    Local $hSrc = _FileEx_CreateFile($sSrc, $GENERIC_READ, $FILE_SHARE_READ, $OPEN_EXISTING, 0)
    If Not $hSrc Then Return SetError(1, 0, 0)

    ; set option flags
    Local $fOverwrite = (BitAND($iFlags, 1) = 1)
    Local $fCreate = (BitAND($iFlags, 2) = 2)
    Local $fVerify = 0
    If (BitAND($iFlags, 8) = 8) Then
        ; bit by bit
        $fVerify = 1
    ElseIf (BitAND($iFlags, 16) = 16) Then
        ; hash
        $fVerify = 2
    EndIf
    Local $fAttr = (BitAND($iFlags, 64) = 64)
    Local $fTimeC = (BitAND($iFlags, 128) = 128)
    Local $fTimeA = (BitAND($iFlags, 256) = 256)
    Local $fTimeM = (BitAND($iFlags, 512) = 512)
    Local $fACL = (BitAND($iFlags, 1024) = 1024)
    Local $fCompress = (BitAND($iFlags, 2048) = 2048)
    Local $fEncrypt = (BitAND($iFlags, 4096) = 4096)

    ; check destination
    _LFC_CheckDestination($sSrc, $sDest, $fOverwrite, $fCreate)
    If @error Then
        _WinAPI_CloseHandle($hSrc)
        Return SetError(2, 0, 0)
    EndIf

    ; check source and destination file systems and disable NTFS specific features if $fACL or $fCompress or $fEncrypt is true
    If ($fACL Or $fCompress Or $fEncrypt) And _
            ((DriveGetFileSystem(_FileEx_PathGetRoot($sSrc)) <> "NTFS") Or (DriveGetFileSystem(_FileEx_PathGetRoot($sDest)) <> "NTFS")) Then
        $fACL = False
        $fCompress = False
        $fEncrypt = False
    EndIf

    ; get source attributes only if needed
    Local $iAttr = 0
    If $fAttr Or $fCompress Or $fEncrypt Then
        $iAttr = _FileEx_GetAttributes($sSrc)
    EndIf

    ; ACL operations require full Admin access, ie #RequireAdmin on Vista+
    ; check for proper elevation and attempt to get the SeSecurityPrivilege right
    Local $iSeSecurity
    If $fACL Then
        $iSeSecurity = _LFC_CheckACLAdmin()
        If @error Then $fACL = False
    EndIf

    ; create destination file
    ; check encryption / compression attributes if NTFS, they are mutually exclusive
    Local $hDest
    If $fCompress And (BitAND($iAttr, 0x800) = 0x800) Then ; FILE_ATTRIBUTE_COMPRESSED
        ; compression is not an attribute
        $hDest = _LFC_CreateCompressedFile($sDest, 0xA0000000)
    ElseIf $fEncrypt And (BitAND($iAttr, 0x4000) = 0x4000) Then ; FILE_ATTRIBUTE_ENCRYPTED
        $hDest = _FileEx_CreateFile($sDest, BitOR($GENERIC_READ, $GENERIC_WRITE), 0, $CREATE_ALWAYS, 0xA0004000)
    Else
        ; normal file
        ; FILE_FLAG_NO_BUFFERING | FILE_FLAG_WRITE_THROUGH
        $hDest = _FileEx_CreateFile($sDest, BitOR($GENERIC_READ, $GENERIC_WRITE), 0, $CREATE_ALWAYS, 0xA0000000)
    EndIf
    ;
    If Not $hDest Then
        _WinAPI_CloseHandle($hSrc)
        Return SetError(3, 0, 0)
    EndIf

    ; check for 0 byte source file
    Local $iSize = _WinAPI_GetFileSizeEx($hSrc)
    If $iSize = 0 Then
        ; nothing to copy, close handles
        _WinAPI_CloseHandle($hDest)
        _WinAPI_CloseHandle($hSrc)
    Else
        ; get destination disk cluster size for unbuffered i/o
        Local $ClusterSize = _FileEx_GetDiskClusterSize($sDest)
        ; if error, default to 512 and hope for the best, at worst the write operation will fail later on
        If @error Then $ClusterSize = 512

        ; perform copy
        Local $iRead, $iWritten, $bytesRead = 0, $iTotal = 0, $mSrc = 0, $iReadError = 0, $iWriteError = 0, $iVerifyError = 0
        ; create aligned buffer
        $iToRead = Floor($iToRead / $ClusterSize) * $ClusterSize
        If $iToRead = 0 Then $iToRead = $ClusterSize
        Local $apBuffers = _LFC_CreateBuffers($iToRead)
        Local $pBuffer = $apBuffers[0]
        Local $pvBuffer = $apBuffers[1]
        Local $alignedWrite = $iToRead

        While $bytesRead < $iSize


            If $iToRead > ($iSize - $bytesRead) Then $iToRead = $iSize - $bytesRead
            If Not _WinAPI_ReadFile($hSrc, $pBuffer, $iToRead, $iRead) Or ($iToRead <> $iRead) Then
                $iReadError = 1
                ExitLoop
            EndIf
            ; set aligned write size for final pass
            If $iRead < $alignedWrite Then $iRead = Ceiling($iRead / $ClusterSize) * $ClusterSize
            If Not _WinAPI_WriteFile($hDest, $pBuffer, $iRead, $iWritten) Or ($iRead <> $iWritten) Then
                $iWriteError = 1
                ExitLoop
            EndIf
            If $sFunction Then
                $iTotal += $iToRead
                Call($sFunction, $iTotal, $iSize, $vUserVar)
            EndIf
            If $fVerify = 1 Then
                ; compare data, using $iRead because it must be a cluster sized block of data
                If Not _LFC_BitCompare($hDest, $pBuffer, $pvBuffer, $iRead) Then
                    $iVerifyError = 1
                    ExitLoop
                EndIf
            ElseIf $fVerify = 2 Then
                ; hash source inline
                $mSrc = _LFC_ChunkHash($mSrc, $pBuffer, $iToRead, $iAlg)
            EndIf
            $bytesRead += $iToRead
			$a = GUIGetCursorInfo()

			If IsArray($a) Then

				If $a[2] = 1 And $a[4] = $button Then

					$value = MsgBox(19, $lng_cancel, $lng_cancel1 & @CRLF & $lng_areyousure & "." & @CRLF & @CRLF & $lng_cancel2 & @CRLF & $lng_cancel3 & @CRLF & $lng_cancel4)

					If $value = 2 Then ;Instantly Abort

						_WriteLog("LargeFileCopy - Triggered Instant Abort")

						$break = 1

						ExitLoop

					EndIf

					If $value = 6 Then ;Finish File and Abort

						_WriteLog("LargeFileCopy - Triggered Abort After Recent File")

						$break = 1

					EndIf

				EndIf

			EndIf

		WEnd

        ; close handles
        _WinAPI_CloseHandle($hSrc)
        _WinAPI_CloseHandle($hDest)
        If $fVerify = 2 Then
            ; finalize hash
            $mSrc = _LFC_ChunkHashFinal($mSrc)
        EndIf

        ; don't bother if errors above
        If (Not $iReadError) And (Not $iWriteError) And (Not $iVerifyError) Then
            ; set correct destination file size
            $hDest = _FileEx_CreateFile($sDest, BitOR($GENERIC_READ, $GENERIC_WRITE), 0, $OPEN_EXISTING, 0)
            If $hDest Then
                DllCall("kernel32.dll", "bool", "SetFilePointerEx", "handle", $hDest, "int64", $iSize, "ptr", 0, "dword", 0)
                _WinAPI_SetEndOfFile($hDest)
                _WinAPI_CloseHandle($hDest)
            Else
                Return $break; SetError(7, 0, 0)
            EndIf
        EndIf

        ; close dest handle
        _WinAPI_CloseHandle($hDest)

        If $iReadError Then
            Return $break; SetError(4, 0, 0)
        ElseIf $iWriteError Then
            Return $break; SetError(5, 0, 0)
        Else
            If ($fVerify = 1) Then
                If $iVerifyError Then Return $break; SetError(6, 0, 0)
            ElseIf ($fVerify = 2) Then
                ; hash destination and verify
                Local $mDest = _LFC_HashFile($sDest, $iAlg)
                If ($mSrc = "") Or ($mDest = "") Or ($mSrc <> $mDest) Then Return $break; SetError(6, 0, 0)
            EndIf
        EndIf
    EndIf

    ; copy security descriptors
    If $fACL Then _LFC_CopyPathSD($sSrc, $sDest, $iSeSecurity)
    ; copy file times
    If $fTimeC Or $fTimeA Or $fTimeM Then
        Local $tC, $tA, $tM
        _FileEx_GetFileTime($sSrc, $tC, $tA, $tM)
        If Not $fTimeC Then $tC = 0
        If Not $fTimeA Then $tA = 0
        If Not $fTimeM Then $tM = 0
        _FileEx_SetFileTime($sDest, $tC, $tA, $tM)
    EndIf
    ; copy attributes (does not affect file times)
    If $fAttr Then _FileEx_SetAttributes($sDest, $iAttr)

    Return $break

EndFunc   ;==>_LargeFileCopyUnbuffered

Func _LFC_FixPath(ByRef $sPath)
    ; check for drive and make sure it ends in \
    If StringRight($sPath, 1) = ":" Then
        $sPath &= "\"
    Else
		; expand any relative path components
		; _PathFull follows same rules as FileExists
        $sPath = _PathFull($sPath)
    EndIf
EndFunc   ;==>_LFC_FixPath

Func _LFC_FixPathEx(ByRef $sSrc, ByRef $sDest)
    ; fix possible forward /
    $sSrc = StringReplace($sSrc, "/", "\")
    $sDest = StringReplace($sDest, "/", "\")
    ; remove trailing \'s from source only
    $sSrc = StringRegExpReplace($sSrc, "\\+$", "")
    ; convert to full paths
    _LFC_FixPath($sSrc)
    _LFC_FixPath($sDest)
EndFunc   ;==>_LFC_FixPathEx

Func _LFC_CheckDestination($sSrc, ByRef $sDest, $fOverwrite, $fCreate)
    Local $iAttr = _FileEx_GetAttributes($sDest)
    Local $iErr = @error

    If ($iErr And (StringRight($sDest, 1) = "\")) Or ((Not $iErr) And (BitAND($iAttr, 0x10) = 0x10)) Then
        ; destination does not exist and should be a directory
        ; OR destination does exist and is a directory
        If $sSrc = "" Then
            ; raw copy, must provide a file name
            Return SetError(2)
        Else
            ; use source file name
            If StringRight($sDest, 1) <> "\" Then $sDest &= "\" ; add trailing \
            $sDest &= StringRegExpReplace($sSrc, ".*\\", "")
        EndIf
    ElseIf $iErr And $fCreate Then
        ; destination does not exist and should be a file
        ; create destination *parent directory*
        _FileEx_CreateDirectory(StringRegExpReplace($sDest, "^(.*)\\.*?$", "${1}"))
    ElseIf Not $iErr Then
        ; destination exists and is a file
        ; check overwrite
        If $fOverwrite Then
            ; set FILE_ATTRIBUTE_NORMAL before attempting delete
            _FileEx_SetAttributes($sDest, 0x80)
            If Not FileDelete($sDest) Then Return SetError(1)
        Else
            Return SetError(1)
        EndIf
    EndIf
    ; else do nothing
    ; ie, destination is a file that doesn't exist and $fCreate is false
    ; if parent directory does not exist and is not created, CreateFile will fail
EndFunc   ;==>_LFC_CheckDestination

Func _LFC_CheckACLAdmin()
    Static Local $fChecked = False, $iSeSecurity = 0

    ; check for admin rights and acquire SeSecurityPrivilege only once
    ; on successive calls, return previous value of $iSeSecurity or error
    If Not $fChecked Then
        $fChecked = True
        If IsAdmin() Then
            If _LFC_GetSESECURITYNAME() Then
                ; include SACL_SECURITY_INFORMATION
                $iSeSecurity = 0xF
            Else
                $iSeSecurity = 7
            EndIf
        EndIf
    EndIf

    If $iSeSecurity Then
        Return $iSeSecurity
    Else
        Return SetError(1)
    EndIf
EndFunc   ;==>_LFC_CheckACLAdmin

Func _LFC_CreateCompressedFile($sPath, $iFlag = 0)
    ; create 0 byte file
    Local $hFile = _FileEx_CreateFile($sPath, BitOR($GENERIC_READ, $GENERIC_WRITE), 0, $CREATE_ALWAYS, $iFlag)
    If Not $hFile Then Return SetError(1, 0, 0)
    ; set compression state
    Local $aRet = DllCall("kernel32.dll", "bool", "DeviceIoControl", "handle", $hFile, "dword", 0x0009C040, "ushort*", 1, "dword", 2, _
            "ptr", 0, "dword", 0, "dword*", 0, "ptr", 0)
    If @error Or (Not $aRet[0]) Then
        _WinAPI_CloseHandle($hFile)
        FileDelete($sPath)
        Return SetError(2, 0, 0)
    Else
        Return $hFile
    EndIf
EndFunc   ;==>_LFC_CreateCompressedFile

Func _LFC_CreateBuffers($iBuffSize)
    Return _LFC_ControlBuffers($iBuffSize)
EndFunc   ;==>_LFC_CreateBuffers

Func _LFC_BitCompare($hDest, $pSrc, $pVerify, $iToVerify)
    ; if there are any errors at all, FAIL
    ; check memory ranges
    Local $ret = DllCall("kernel32.dll", "bool", "IsBadReadPtr", "ptr", $pSrc, "uint_ptr", $iToVerify)
    If @error Or $ret[0] Then Return SetError(1, 0, 0)
    $ret = DllCall("kernel32.dll", "bool", "IsBadReadPtr", "ptr", $pVerify, "uint_ptr", $iToVerify)
    If @error Or $ret[0] Then Return SetError(2, 0, 0)
    ; first move file pointer back by $iToVerify bytes
    $ret = DllCall("kernel32.dll", "bool", "SetFilePointerEx", "handle", $hDest, "int64", -$iToVerify, "ptr", 0, "dword", 1) ; FILE_CURRENT
    If @error Or (Not $ret[0]) Then Return SetError(3, 0, 0)
    ; read data just written to destination
    Local $iRead
    If Not _WinAPI_ReadFile($hDest, $pVerify, $iToVerify, $iRead) Or ($iRead <> $iToVerify) Then Return SetError(4, 0, 0)
    ; compare data=
    If Not _LFC_RtlCompareMemory($pSrc, $pVerify, $iToVerify) Then
        Return SetError(5, 0, 0)
    Else
        Return 1
    EndIf
EndFunc   ;==>_LFC_BitCompare

Func _LFC_ChunkHash($hCryptHash, $pSrc, $iSize, $iAlg = $CALG_MD5)
    Local $aRet
    If $hCryptHash = 0 Then
        ; Create Hash object
        $aRet = DllCall(__Crypt_DllHandle(), "bool", "CryptCreateHash", "handle", __Crypt_Context(), "uint", $iAlg, "ptr", 0, "dword", 0, "handle*", 0)
        If @error Or (Not $aRet[0]) Then Return SetError(1, 0, -1)
        $hCryptHash = $aRet[5]
    ElseIf $hCryptHash = -1 Then
        ; previous error
        Return SetError(3, 0, -1)
    EndIf

    $aRet = DllCall(__Crypt_DllHandle(), "bool", "CryptHashData", "handle", $hCryptHash, "ptr", $pSrc, "dword", $iSize, "dword", $CRYPT_USERDATA)
    If @error Or (Not $aRet[0]) Then
        DllCall(__Crypt_DllHandle(), "bool", "CryptDestroyHash", "handle", $hCryptHash)
        Return SetError(2, 0, -1)
    EndIf

    Return $hCryptHash
EndFunc   ;==>_LFC_ChunkHash

Func _LFC_ChunkHashFinal($hCryptHash)
    Local $iError, $vReturn
    If $hCryptHash = -1 Then
        ; previous error
        $iError = 1
        $vReturn = ""
        $hCryptHash = 0
    Else
        ; get hash size, in $aRet[3]
        Local $aRet = DllCall(__Crypt_DllHandle(), "bool", "CryptGetHashParam", "handle", $hCryptHash, "dword", $HP_HASHSIZE, "dword*", 0, "dword*", 4, "dword", 0)
        If @error Or (Not $aRet[0]) Then
            $iError = 2
            $vReturn = ""
        Else
            ; get hash
            Local $hBuff = DllStructCreate("byte[" & $aRet[3] & "]")
            $aRet = DllCall(__Crypt_DllHandle(), "bool", "CryptGetHashParam", "handle", $hCryptHash, "dword", $HP_HASHVAL, "ptr", DllStructGetPtr($hBuff), "dword*", DllStructGetSize($hBuff), "dword", 0)
            If @error Or (Not $aRet[0]) Then
                $iError = 3
                $vReturn = ""
            Else
                $iError = 0
                $vReturn = DllStructGetData($hBuff, 1)
            EndIf
        EndIf
    EndIf

    ; Cleanup and return hash
    If $hCryptHash <> 0 Then DllCall(__Crypt_DllHandle(), "bool", "CryptDestroyHash", "handle", $hCryptHash)
    Return SetError($iError, 0, $vReturn)
EndFunc   ;==>_LFC_ChunkHashFinal

Func _LFC_CopyPathSD($sSrc, $sDest, $iSeSecurity)
	Local $pOwner, $pGroup, $pDACL, $pSACL, $pSD, $iProtect
	; copy source security info
	_LFC_GetPathSD($sSrc, $pOwner, $pGroup, $pDACL, $pSACL, $pSD, $iProtect, $iSeSecurity)
	If @error Then Return SetError(1, 0, 0)
	; set destination security info
	Local $iErr = 0
	_LFC_SetPathSD($sDest, $pOwner, $pGroup, $pDACL, $pSACL, $iProtect, $iSeSecurity)
	If @error Then $iErr = @error
	DllCall("kernel32.dll", "handle", "LocalFree", "handle", $pSD)
	Return SetError($iErr, 0, (Not $iErr))
EndFunc   ;==>_LFC_CopyPathSD

Func _LFC_HashFile($sFile, $iAlg = $CALG_MD5)
    ; check target exists and is a file
    If Not FileExists($sFile) Or StringInStr(FileGetAttrib($sFile), "D") Then Return SetError(1, 0, "")
    Local $sHash = _LFC_HashFileInternal($sFile, $iAlg)
    If @error Or ($sHash = "") Then
        Return SetError(2, 0, "")
    Else
        Return $sHash
    EndIf
EndFunc   ;==>_LFC_HashFile

Func _LFC_GetSESECURITYNAME()
	Local $return = False
    Local $tagLUIDANDATTRIB = "int64 Luid;dword Attributes"
    Local $count = 1
    Local $tagTOKENPRIVILEGES = "dword PrivilegeCount;byte LUIDandATTRIB[" & $count * 12 & "]" ; count of LUID structs * sizeof LUID struct
    Local $TOKEN_ADJUST_PRIVILEGES = 0x20
	Local $SE_PRIVILEGE_ENABLED = 0x2
	Local $curProc = DllCall("kernel32.dll", "ptr", "GetCurrentProcess")
    If @error Then Return False
	Local $call = DllCall("advapi32.dll", "int", "OpenProcessToken", "ptr", $curProc[0], "dword", $TOKEN_ADJUST_PRIVILEGES, "ptr*", 0)
	If (@error Or (Not $call[0])) Then Return False
    Local $hToken = $call[3]
    $call = DllCall("advapi32.dll", "int", "LookupPrivilegeValueW", "ptr", 0, "wstr", "SeSecurityPrivilege", "int64*", 0)
    If ((Not @error) And $call[0]) Then
		Local $iLuid = $call[3]
		Local $TP = DllStructCreate($tagTOKENPRIVILEGES)
		Local $LUID = DllStructCreate($tagLUIDANDATTRIB, DllStructGetPtr($TP, "LUIDandATTRIB"))
		DllStructSetData($TP, "PrivilegeCount", $count)
		DllStructSetData($LUID, "Luid", $iLuid)
		DllStructSetData($LUID, "Attributes", $SE_PRIVILEGE_ENABLED)
		$call = DllCall("advapi32.dll", "int", "AdjustTokenPrivileges", "ptr", $hToken, "int", 0, "ptr", DllStructGetPtr($TP), "dword", 0, "ptr", 0, "ptr", 0)
		If Not @error Then $return = ($call[0] <> 0) ; $call[0] <> 0 is success
	EndIf
	DllCall("kernel32.dll", "int", "CloseHandle", "ptr", $hToken)
	Return SetError(Number(Not $return), 0, $return)
EndFunc   ;==>_LFC_GetSESECURITYNAME

Func _LFC_ControlBuffers($iBuffSize, $fCreate = True)
    Static Local $iPrevSize = 0, $apBuffers = 0

    If $fCreate Then
        If (Not IsArray($apBuffers)) Or ($iBuffSize > $iPrevSize) Then
            _LFC_ControlBuffers(0, False)
            $iPrevSize = $iBuffSize
            _LFC_AllocBuffers($apBuffers, $iBuffSize)
            ; init crypt library, only once
            If Not __Crypt_RefCount() Then _Crypt_Startup()
        EndIf

        Return $apBuffers
    Else
        If IsArray($apBuffers) Then
            _MemVirtualFree($apBuffers[0], 0, $MEM_RELEASE)
            _MemVirtualFree($apBuffers[1], 0, $MEM_RELEASE)
        EndIf
        $iPrevSize = 0
        $apBuffers = 0
    EndIf
EndFunc   ;==>_LFC_ControlBuffers

Func _LFC_RtlCompareMemory($pSrc1, $pSrc2, $iSize)
    Local $ret = DllCall("ntdll.dll", "ulong_ptr", "RtlCompareMemory", "ptr", $pSrc1, "ptr", $pSrc2, "ulong_ptr", $iSize)
    If @error Or ($ret[0] <> $iSize) Then
        Return SetError(1, 0, 0)
    Else
        Return 1
    EndIf
EndFunc   ;==>_LFC_RtlCompareMemory

Func _LFC_GetPathSD($sPath, ByRef $pOwner, ByRef $pGroup, ByRef $pDACL, ByRef $pSACL, ByRef $pSD, ByRef $iProtect, $iSeSecurity)
	Local $aRet = DllCall("advapi32.dll", "dword", "GetNamedSecurityInfoW", "wstr", $sPath, "int", 1, "dword", $iSeSecurity, _
			"ptr*", 0, "ptr*", 0, "ptr*", 0, "ptr*", 0, "ptr*", 0)
	If @error Or $aRet[0] Then Return SetError(1, 0, 0)
	$pOwner = $aRet[4]
	$pGroup = $aRet[5]
	$pDACL = $aRet[6]
	$pSACL = $aRet[7]
	$pSD = $aRet[8]
	$iProtect = 0 ; default no change
	; query SACL, DACL protected states and set flags
	$aRet = DllCall("advapi32.dll", "bool", "GetSecurityDescriptorControl", "ptr", $pSD, "word*", 0, "dword*", 0)
	If Not @error And $aRet[0] Then
		If BitAND($aRet[2], 0x1000) Then
			; DACL protected
			$iProtect = BitOR($iProtect, 0x80000000)
		Else
			; unprotected
			$iProtect = BitOR($iProtect, 0x20000000)
		EndIf
		If BitAND($aRet[2], 0x2000) Then
			; SACL protected
			$iProtect = BitOR($iProtect, 0x40000000)
		Else
			; unprotected
			$iProtect = BitOR($iProtect, 0x10000000)
		EndIf
	EndIf
	Return 1
EndFunc   ;==>_LFC_GetPathSD

Func _LFC_SetPathSD($sPath, $pOwner, $pGroup, $pDACL, $pSACL, $iProtect, $iSeSecurity)
	Local $aRet = DllCall("advapi32.dll", "dword", "SetNamedSecurityInfoW", "wstr", $sPath, "int", 1, "dword", BitOR($iProtect, $iSeSecurity), _
			"ptr", $pOwner, "ptr", $pGroup, "ptr", $pDACL, "ptr", $pSACL)
    If @error Or $aRet[0] Then Return SetError(2, 0, 0)
	Return 1
EndFunc   ;==>_LFC_SetPathSD

Func _LFC_HashFileInternal($sFile, $iAlg = $CALG_MD5)
    Local $hSrc = _FileEx_CreateFile($sFile, $GENERIC_READ, $FILE_SHARE_READ, $OPEN_EXISTING, 0)
    If Not $hSrc Then Return SetError(1, 0, "")

    Local $iSize = _WinAPI_GetFileSizeEx($hSrc)
    Local $iRead, $iReadError = 0, $sHash = 0, $iToRead = (1024 ^ 2) * 2
    ; create 2M hashing buffer only once
    Static Local $pBuffer = _MemVirtualAlloc(0, $iToRead, $MEM_COMMIT, $PAGE_READWRITE)

    Local $bytesRead = 0
    While $bytesRead < $iSize
        If $iToRead > ($iSize - $bytesRead) Then $iToRead = $iSize - $bytesRead
        If Not _WinAPI_ReadFile($hSrc, $pBuffer, $iToRead, $iRead) Then
            $iReadError = 1
            ExitLoop
        EndIf
        $sHash = _LFC_ChunkHash($sHash, $pBuffer, $iRead, $iAlg)
        If @error Then
            $iReadError = 1
            ExitLoop
        EndIf
        $bytesRead += $iRead
    WEnd
    _WinAPI_CloseHandle($hSrc)
    $sHash = _LFC_ChunkHashFinal($sHash)

    If $iReadError Then
        Return SetError(2, 0, "")
    Else
        Return $sHash
    EndIf
EndFunc   ;==>_LFC_HashFileInternal

Func _LFC_AllocBuffers(ByRef $apBuffers, $iBuffSize)
    Dim $apBuffers[2] = [ _
            _MemVirtualAlloc(0, $iBuffSize, $MEM_COMMIT, $PAGE_READWRITE), _
            _MemVirtualAlloc(0, $iBuffSize, $MEM_COMMIT, $PAGE_READWRITE) _
            ]
EndFunc   ;==>_LFC_AllocBuffers

#EndRegion

#Region ;File Ex
Func _FileEx_CreateFile($sPath, $iAccess, $iShareMode, $iCreation, $iFlags)
    ; open the file with existing HIDdeN or SYSTEM attributes to avoid failure when using CREATE_ALWAYS
    If $iCreation = $CREATE_ALWAYS Then
        ; FILE_ATTRIBUTE_HIDdeN = 0x2, FILE_ATTRIBUTE_SYSTEM = 0x4
        Local $iAttr = _FileEx_GetAttributes($sPath)
        If Not @error Then
            If (BitAND($iAttr, 0x2) = 0x2) Then $iFlags = BitOR($iFlags, 0x2)
            If (BitAND($iAttr, 0x4) = 0x4) Then $iFlags = BitOR($iFlags, 0x4)
        EndIf
    EndIf
    Local $hFile = DllCall("kernel32.dll", "handle", "CreateFileW", "wstr", $sPath, "dword", $iAccess, "dword", $iShareMode, "ptr", 0, _
            "dword", $iCreation, "dword", $iFlags, "ptr", 0)
    If @error Or ($hFile[0] = Ptr(-1)) Then Return SetError(1, 0, 0)
    Return $hFile[0]
EndFunc   ;==>_FileEx_CreateFile

Func _FileEx_PathGetRoot($sPath)
    Local $sRoot = _FileEx_PathStripToRoot($sPath)
    If StringRight($sRoot, 1) <> "\" Then $sRoot &= "\"
    Return $sRoot
EndFunc   ;==>_FileEx_PathGetRoot

Func _FileEx_GetAttributes($sPath)
    Local $ret = DllCall("kernel32.dll", "dword", "GetFileAttributesW", "wstr", $sPath)
    If @error Or ($ret[0] = 4294967295) Then Return SetError(1, 0, -1)
    Return $ret[0]
EndFunc   ;==>_FileEx_GetAttributes

Func _FileEx_SetAttributes($sPath, $iAttr)
    Local $ret = DllCall("kernel32.dll", "bool", "SetFileAttributesW", "wstr", $sPath, "dword", _FileEx_AttrSettable($iAttr))
    If @error Or (Not $ret[0]) Then Return SetError(1, 0, 0)
    Return 1
EndFunc   ;==>_FileEx_SetAttributes

Func _FileEx_GetDiskClusterSize($sPath)
    Local $aRet = DllCall("kernel32.dll", "bool", "GetDiskFreeSpaceW", "wstr", _FileEx_PathGetRoot($sPath), "dword*", 0, "dword*", 0, "dword*", 0, "dword*", 0)
    If @error Or (Not $aRet[0]) Then Return SetError(1, 0, 0)
    Return ($aRet[2] * $aRet[3])
EndFunc   ;==>_FileEx_GetDiskClusterSize

Func _FileEx_GetFileTime($sPath, ByRef $tCreated, ByRef $tAccessed, ByRef $tModified)
    $tCreated = DllStructCreate("dword;dword")
    $tAccessed = DllStructCreate("dword;dword")
    $tModified = DllStructCreate("dword;dword")
    ; FILE_FLAG_BACKUP_SEMANTICS so we can get dir handles
    Local $hFile = _FileEx_CreateFile($sPath, $GENERIC_READ, $FILE_SHARE_READ, $OPEN_EXISTING, 0x02000000)
    Local $err = 0
    Local $ret = DllCall("kernel32.dll", "bool", "GetFileTime", "handle", $hFile, "struct*", $tCreated, "struct*", $tAccessed, "struct*", $tModified)
    If @error Or (Not $ret[0]) Then $err = 1
    _WinAPI_CloseHandle($hFile)
    Return SetError($err, 0, Abs($err - 1))
EndFunc   ;==>_FileEx_GetFileTime

Func _FileEx_SetFileTime($sPath, Const ByRef $tCreated, Const ByRef $tAccessed, Const ByRef $tModified)
    ; check structs, get pointers
    Local $pC = 0, $pA = 0, $pM = 0
    If IsDllStruct($tCreated) Then $pC = $tCreated
    If IsDllStruct($tAccessed) Then $pA = $tAccessed
    If IsDllStruct($tModified) Then $pM = $tModified
    ; FILE_FLAG_BACKUP_SEMANTICS so we can set dir handles
    Local $hFile = _FileEx_CreateFile($sPath, BitOR($GENERIC_READ, $GENERIC_WRITE), BitOR($FILE_SHARE_READ, $FILE_SHARE_WRITE), $OPEN_EXISTING, 0x02000000)
    Local $err = 0
    Local $ret = DllCall("kernel32.dll", "bool", "SetFileTime", "handle", $hFile, "struct*", $pC, "struct*", $pA, "struct*", $pM)
    If @error Or (Not $ret[0]) Then $err = 1
    _WinAPI_CloseHandle($hFile)
    Return SetError($err, 0, Abs($err - 1))
EndFunc   ;==>_FileEx_SetFileTime

Func _FileEx_CreateDirectory($sPath, $fCheckExists = True)
    ; check path already exists
    ; it is possible to save some overhead if you know in advance the directory
    ; does not exist, by setting $fCheckExists = False
    If $fCheckExists Then
        Local $iAttr = _FileEx_GetAttributes($sPath)
        If Not @error Then
            ; check if it is a direcotry
            If BitAND($iAttr, 0x10) = 0x10 Then
                Return 1
            Else
                Return SetError(1, 0, 0)
            EndIf
        EndIf
    EndIf
    ;
    ; remove any terminations
    $sPath = StringRegExpReplace($sPath, "\\+$", "")
    Local $aPath = _FileEx_CrackPath($sPath)
    ; make sure root exists
    Local $sSegment = $aPath[0]
    If Not FileExists($sSegment) Then Return SetError(2, 0, 0)
    Local $ret
    For $i = 1 To UBound($aPath) - 1
        $sSegment &= $aPath[$i] & "\"
        If Not FileExists($sSegment) Then
            ; create sub-path
            $ret = DllCall("kernel32.dll", "bool", "CreateDirectoryW", "wstr", $sSegment, "ptr", 0)
            If @error Or (Not $ret[0]) Then Return SetError(3, 0, 0)
        EndIf
    Next
    Return 1
EndFunc   ;==>_FileEx_CreateDirectory

Func _FileEx_PathStripToRoot($sPath)
    Local $r = DllCall("shlwapi.dll", "bool", "PathStripToRootW", "wstr", $sPath)
    If @error Or ($r[0] = 0) Then
        Return SetError(1, 0, "")
    Else
        Return $r[1]
    EndIf
EndFunc   ;==>_FileEx_PathStripToRoot

Func _FileEx_AttrSettable($iAttr)
    Return BitAND($iAttr, 0x31A7)
EndFunc   ;==>_FileEx_AttrSettable

Func _FileEx_CrackPath($sPath, $fRootOnly = False)
    ; make sure path is terminated
    $sPath = StringRegExpReplace($sPath, "\\+$", "") & "\"
    ; get prefix
    Local $aRet = StringRegExp($sPath, "(?i)^\\\\\?\\unc\\|\\\\\?\\|\\\\", 1)
    If Not IsArray($aRet) Then
        $aRet = ""
    Else
        $aRet = $aRet[0]
    EndIf
    ; capture and remove the root
    If ($aRet = "\\") Or ($aRet = "\\?\UNC\") Then
        ; UNC network path
        $aRet = StringRegExp($sPath, "(?i)^(" & StringReplace(StringReplace($aRet, "\", "\\"), "?", "\?") & ".*?\\.*?\\)", 1)
    Else
        ; $aRet = "" or \\?\ => local path
        Local $iTrim = StringLen($aRet) + 3
        Local $aRet[1] = [StringLeft($sPath, $iTrim)]
    EndIf
    If Not $fRootOnly Then
        Local $aPath = StringTrimLeft($sPath, StringLen($aRet[0]))
        ; check if path given was just a root
        If $aPath <> "" Then
            ; crack path, prepend \ to get first segment
            $aPath = StringRegExp("\" & $aPath, "\\(.*?)(?=\\)", 3)
            ReDim $aRet[UBound($aPath) + 1]
            For $i = 0 To UBound($aPath) - 1
                $aRet[$i + 1] = $aPath[$i]
            Next
        EndIf
    EndIf
    ;
    Return $aRet
EndFunc   ;==>_FileEx_CrackPath
#EndRegion

;Function Get size of an image
Func _ImageGetSize($Filename)
	Local $size[2], $hImg
	_GDIPlus_Startup()
	$hImg = _GDIPlus_ImageLoadFromFile($Filename)
	$size[0] = _GDIPlus_ImageGetWidth($hImg)
	$size[1] = _GDIPlus_ImageGetHeight($hImg)
	_GDIPlus_ImageDispose($hImg)
	_GDIPlus_Shutdown()
	Return $size
EndFunc   ;==>_ImageGetSize

;Function to Resize Images
; #FUNCTION# =========================================================================================
; Name...........: _ImageResize
; Description....: Resize an image and optionally convert it to the format you want.
; Syntax.........: _ImageResize($sInImage, $sOutImage, $iW, $iH)
; Parameters ....: $sInImage  - Full path to the image to resize / convert.
;                               In types: *.bmp, *.gif, *.ico, *.jpg, *.jpeg, *.png, *.tif, *.tiff
;                  $sOutImage - Full path where to save the resized / converted image.
;                               Out types: *.bmp, *.gif, *.jpg, *.jpeg, *.png, *.tif, *.tiff
;                  $iW        - Width to resize image to.
;                  $iH        - Height to resize image to.
; Return values .: Success    - Return 1 and @error 0
;                  Failure    - Return 0 and @error 1~5
;                               @error 1 = In File does not exist
;                               @error 2 = In File format not supported
;                               @error 3 = Out File path does not exist
;                               @error 4 = Out file format not supported
;                               @error 5 = Resize Width or Height not an integer
; Author ........: smashly
; ====================================================================================================
Func _ImageResize($sInImage, $sOutImage, $iW, $iH)
	Local $sOP, $sOF, $sInExt, $Ext, $hBitmap, $hImage1, $hImage2, $hGraphic, $CLSID, $i = 0
	Local $sType = "BMP|GIF|ICO|JPG|JPEG|PNG|TIF|TIFF"
	If Not FileExists($sInImage) Then
		_WriteLog("Error - No Image Found In: " & $sInImage)
		Return SetError(1, 0, 0)
	EndIf
	$sInExt = StringUpper(StringTrimLeft($sInImage, StringInStr($sInImage, ".", 0, -1)))
	If Not StringRegExp($sInExt, "\A(" & $sType & ")\z", 0) Then Return SetError(2, 0, 0)

	;OutFile path, to use later on.
	$sOP = StringLeft($sOutImage, StringInStr($sOutImage, "", 0, -1))
	;If Not FileExists($sOP) Then Return SetError(3, 0, 0)

	;OutFile name, to use later on.
	$sOF = StringTrimLeft($sOutImage, StringInStr($sOutImage, "", 0, -1))

	;OutFile extension , to use for the encoder later on.
	$Ext = StringUpper(StringTrimLeft($sOutImage, StringInStr($sOutImage, ".", 0, -1)))
	If Not StringRegExp($Ext, "\A(" & $sType & ")\z", 0) Or $Ext = "ICO" Then
		_WriteLog("Error - While Processing Image: " & $sInImage)
		Return SetError(4, 0, 0)
	EndIf

	If Not IsInt($iW) And Not IsInt($iH) Then
		_WriteLog("Error - While Processing Image: " & $sInImage)
		Return SetError(5, 0, 0)

	EndIf

	; WinAPI to create blank bitmap at the width and height to put your resized image on.
	$hBitmap = _WinAPI_CreateBitmap($iW, $iH, 1, 32)

	;Start GDIPlus
	_GDIPlus_Startup()

	;Get the handle of blank bitmap you created above as an image
	$hImage1 = _GDIPlus_BitmapCreateFromHBITMAP($hBitmap)

	;Load the image you want to resize.
	$hImage2 = _GDIPlus_ImageLoadFromFile($sInImage)

	;Get the graphic context of the blank bitmap
	$hGraphic = _GDIPlus_ImageGetGraphicsContext($hImage1)

	;Draw the loaded image onto the blank bitmap at the size you want
	_GDIPlus_GraphicsDrawImageRect($hGraphic, $hImage2, 0, 0, $iW, $iH)

	;Get the encoder of to save the resized image in the format you want.
	$CLSID = _GDIPlus_EncodersGetCLSID($Ext)

	;Generate a number for out file that doesn't already exist, so you don't overwrite an existing image.
	Do
		$i += 1
	Until (Not FileExists($sOP & $i & "_" & $sOF))

	;Prefix the number to the begining of the output filename
	;$sOutImage = $sOP & $i & "_" & $sOF
	$sOutImage = $sOP & $sOF

	;Save the new resized image.
	_GDIPlus_ImageSaveToFileEx($hImage1, $sOutImage, $CLSID)

	;Clean up and shutdown GDIPlus.
	_GDIPlus_ImageDispose($hImage1)
	_GDIPlus_ImageDispose($hImage2)
	_GDIPlus_GraphicsDispose($hGraphic)
	_WinAPI_DeleteObject($hBitmap)
	_GDIPlus_Shutdown()

	_WriteLog("Successfully Resized Image: " & $sOutImage)
	Return SetError(0, 0, 1)
EndFunc   ;==>_ImageResize

;Function OEM 2 Ansi
Func _OEMToAnsi($sOEM)
Local $a_AnsiFName = DllCall('user32.dll', 'Int', 'OemToChar', 'str', $sOEM, 'str', '')
If @error = 0 Then $sAnsi = $a_AnsiFName[2]
Return $sAnsi
EndFunc ;==>_OEMToAnsi

;Function to Write Logfile
;~ /**
;~  * Function for writing an user-defined status/error message into a log file
;~  * (Requires Date.au3)
;~  *
;~  * @author BjÃƒÂ¶rn Bastian (http://aufschnur.de)
;~  * @version 2014-01-27
;~  * @param	Message		the data to be written into the log file
;~  * @param	Filepath	an user-defined logfile path (optional, default = <scriptdir>\<scriptname>.log)
;~  * @param	Timestamp	a boolean trigger for adding the timestamp (optional, default = True)
;~  * @return	Result of logging as boolean (Success/Fail)
;~  */
Func _WriteLog($Message, $Filepath = "", $Timestamp = True)
	; Use default logfile path if no user-defined is set
	If $Filepath == "" Then
		$Filepath = @ScriptDir & '\Log\' & StringTrimRight(@ScriptName, 4) & ".log"
	EndIf
	; Add timestamp if desired
	If $Timestamp == True Then
		$Message = _Now() & ' - ' & $Message
	EndIf
	; Save data to log file
	Local $Logfile = FileOpen($Filepath, 1)
	If $Logfile <> -1 Then
		FileWriteLine($Logfile, $Message)
		FileClose($Logfile)
		Return True
	Else
		Return False
	EndIf
EndFunc   ;==>_WriteLog

;===============================================================================
; Function Name:   _RecursiveFileListToArray($sPath, $sPattern, $iFlag = 0, $iFormat = 1, $sDelim = @CRLF)
; Description::    gibt Verzeichnisse und/oder Dateien (rekursiv) zurück, die
;                  einem RegExp-Pattern entsprechen
; Parameter(s):    $sPath = Startverzeichnis
;                  $sPattern = ein beliebiges RexExp-Pattern für die Auswahl
;                  $iFlag = Auswahl
;                           0 = Dateien & Verzeichnisse
;                           1 = nur Dateien
;                           2 = nur Verzeichnisse
;                  $iFormat = Rückgabeformat
;                             0 = String
;                             1 = Array mit [0] = Anzahl
;                             2 = Nullbasiertes Array
;                  $sDelim = Trennzeichen für die String-Rückgabe
; Requirement(s):  AutoIt 3.3.0.0
; Return Value(s): Array/String mit den gefundenen Dateien/Verzeichnissen
; Author(s):       Oscar (www.autoit.de)
;                  Anregungen von: bernd670 (www.autoit.de)
;===============================================================================
Func _RecursiveFileListToArray($sPath, $sPattern, $iFlag = 0, $iFormat = 1, $sDelim = @CRLF)
	Local $hSearch, $sFile, $sReturn = ''
	If StringRight($sPath, 1) <> '\' Then $sPath &= '\'
	$hSearch = FileFindFirstFile($sPath & '*.*')
	If @error Or $hSearch = -1 Then Return SetError(0, 0, $sReturn)
	While True
		$sFile = FileFindNextFile($hSearch)
		If @error Then ExitLoop
		If StringInStr(FileGetAttrib($sPath & $sFile), 'D') Then
			If StringRegExp($sPath & $sFile, $sPattern) And ($iFlag = 0 Or $iFlag = 2) Then $sReturn &= $sPath & $sFile & '\' & $sDelim
			$sReturn &= _RecursiveFileListToArray($sPath & $sFile & '\', $sPattern, $iFlag, 0)
			ContinueLoop
		EndIf
		If StringRegExp($sFile, $sPattern) And ($iFlag = 0 Or $iFlag = 1) Then $sReturn &= $sPath & $sFile & $sDelim
	WEnd
	FileClose($hSearch)
	If $iFormat Then Return StringSplit(StringTrimRight($sReturn, StringLen($sDelim)), $sDelim, $iFormat)
	Return $sReturn
EndFunc   ;==>_RecursiveFileListToArray

#EndRegion

#Region ;Generic Functions

;Function to Abort external Processes
Func _CloseProcess($PID)

	Local $cPID

	_WriteLog("CloseProcess - Begin Abort Process")

	$PidFile = _FileListToArray(@ScriptDir, "*.pid", 1)

	If IsArray($PidFile) Then

		If FileExists($PidFile[1]) Then

			$cPID = FileReadLine($PidFile[1], 1)

		Else

			_WriteLog("CloseProcess - Error: Process " & $PidFile[1] & " with PID: " & $cPID & " did not exist.")

			MsgBox(0, "Error", "Process " & $PidFile[1] & " with PID: " & $cPID & " did not exist.")

			Return

		EndIf

	EndIf

	ProcessClose($PID)

	ProcessWaitClose($PID, 10)

	_WriteLog("CloseProcess - Finished Abort Process: " & $PID)

	ProcessClose($cPID)

	ProcessWaitClose($cPID, 10)

	_WriteLog("CloseProcess - Finished Abort Process: " & $cPID)

	Return

EndFunc

;Function to copy Artist fanart and .nfo to central folder (Kodi)
Func _CopyArtistFanart($InDir)

	Local $i, $Split, $row, $season, $file, $j, $folder, $path, $Array, $flag

	_WriteLog("CopyArtistFanart - Start Working On  " & $InDir)

	If $ini_artistfolderoverwrite = "1" Then

		$flag = 9

	Else

		$flag = 8

	EndIf

	$Array = _FileListToArrayRec($InDir, "artist.nfo", 1, 1, 1, 1)

	If _ElementExists($Array,0) Then

		For $i = 1 To $Array[0]

			$split = StringSplit($Array[$i], "\")

			If _ElementExists($split,1) Then

				FileCopy($InDir & "\" & $split[1] & "\artist.nfo", $json_artist_folder & "\" & $split[1] & "\artist.nfo", $flag)

				FileCopy($InDir & "\" & $split[1] & "\banner.jpg", $json_artist_folder & "\" & $split[1] & "\banner.jpg", $flag)

				FileCopy($InDir & "\" & $split[1] & "\clearlogo.png", $json_artist_folder & "\" & $split[1] & "\clearlogo.png", $flag)

				FileCopy($InDir & "\" & $split[1] & "\fanart.jpg", $json_artist_folder & "\" & $split[1] & "\fanart.jpg", $flag)

				FileCopy($InDir & "\" & $split[1] & "\folder.jpg", $json_artist_folder & "\" & $split[1] & "\folder.jpg", $flag)

			EndIf

		Next

	EndIf

	Return

EndFunc

;Function to copy banner or poster as missing season banner or poster
Func _CopyBannerPoster($InDir)

	Local $i, $BannerSplit, $row, $season, $file, $j, $folder, $path

	_WriteLog("CopyBannerPoster - Start Working On  " & $InDir)

	$BannerArray = _FileListToArrayRec($InDir, $json_TVShow_FolderSeason & "*", 2, 1, 1, 1)

	If $ini_space_attach = "1" Then

		$folder = $json_TVShow_FolderSeason & " "

	Else

		$folder = $json_TVShow_FolderSeason

	EndIf

	If _ElementExists($BannerArray,0) Then

		For $i = 1 To $BannerArray[0]

			If StringInStr($BannerArray[$i], "\" & $folder, 0) Then

				$BannerSplit = StringSplit($BannerArray[$i], "\", 1)

				$row = $BannerSplit[0]

				$season = StringReplace($BannerSplit[$row], $folder, "")

				If $season = "00" Then $season = "-specials"

				$path = $InDir & "\" & $BannerSplit[1] & "\"

				If $row > 2 Then

					For $j = 1 to $row - 2

						$path = $path & $BannerSplit[$j] & "\"

					Next

				EndIf

				$file = $path & "season" & $season & "-banner.jpg"

				If Not FileExists($file) Then FileCopy($path & "banner.jpg", $file)

				$file = $path & "season" & $season & "-poster.jpg"

				If Not FileExists($file) Then FileCopy($path & "poster.jpg", $file)

			EndIf

		Next

	EndIf

	_WriteLog("CopyBannerposter - Finished Working On  " & $InDir)

	Return

EndFunc

;Function to copy clearlogo files to clearart
Func _CopyClearlogo($InDir)

	Local $WorkArray = _FileListToArrayRec($InDir, "*.png", 1, 1, 1)

	If Not IsArray($WorkArray) Then Return

	For $i = 1 To $WorkArray[0]

		Local $split = StringSplit($WorkArray[$i], "\")

		If $split[2] = "clearlogo.png" Then

 			FileCopy($InDir & "\" & $split[1] & "\clearlogo.png", $InDir & "\" & $split[1] & "\clearart.png", 8)

		EndIf

	Next

	MsgBox(0,"", "Fertig")

EndFunc

;Function to copy Exif Metadata to files in output folder
Func _CopyExif()

	Local $WorkArray, $i, $InDir, $Outdir, $sDrive, $sDir, $sFilename, $sExtension, $ipathsplit, $oWorkArray

	IniWrite(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_graphics_metadata_inputfolder", GUICtrlRead($input_35_01))

	IniWrite(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_graphics_metadata_outputfolder", GUICtrlRead($input_35_02))

	$InDir = IniRead(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_graphics_metadata_inputfolder", @MyDocumentsDir)

	$Outdir = IniRead(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_graphics_metadata_outputfolder", @MyDocumentsDir)

	_WriteLog("CopyExif - Start Working On  " & $InDir)

	_SetLabel($Label02, $lng_working)

	$WorkArray = _FileListToArrayRec($InDir, $gextstring, 1, 1, 1)

	$oWorkArray = _FileListToArrayRec($OutDir, $gextstring, 1, 1, 1)

	If Not IsArray($WorkArray) Then Return

	For $i = 1 To $WorkArray[0]

		_SetLabel($Label02, $lng_workingon & ": " & $InDir & "\" & $WorkArray[$i])

		$ipathsplit = _PathSplit($InDir & "\" & $WorkArray[$i], $sDrive, $sDir, $sFilename, $sExtension)

		$iout = _ArraySearch($oWorkArray, $ipathsplit[3], 0, 0, 0, 1)

		If $iout > 0 Then

			$option = '-tagsfromfile "' & $InDir & "\" & $WorkArray[$i] & '" "' & $OutDir & "\" & $oWorkArray[$iout] & '"'

			ShellExecuteWait(@ScriptDir & "\exiftool.exe", $option, "", "", @SW_HIde)

			Sleep(20)

			FileDelete($OutDir & "\" & $oWorkArray[$iout] & "_original")

		EndIf

	Next

	_SetLabel($Label02, $lng_waiting)

	_WriteLog("CopyExif - Finished Working On  " & $InDir)

	MsgBox(0, "", $lng_sucess, 2)

	Return

EndFunc

;Function to copy all Movieset- Fanart to match Kodi naming scheme
Func _CopyMovieset($InDir)

 	Local $i, $Split, $row, $season, $file, $j, $sDrive, $sDir, $sFilename, $sExtension, $folder

 	Local $FanartArray, $PosterArray, $nfoArray, $nfo, $hnfo, $movieset, $movieset1, $idt, $flag

 	_WriteLog("CopyMovieset - Start Working On  " & $InDir)

 	$nfoArray = _FileListToArrayRec($InDir, "*.nfo", 1,1)

	_WriteLog("CopyMovieset - FileListToArrayRec: Finished ")

 	If _ElementExists($nfoArray, 0) Then

 		For $i = 1 To $nfoArray[0]

 			$Split = _PathSplit($nfoArray[$i], $sDrive, $sDir, $sFilename, $sExtension)

 			$file = $InDir & $Split[2] & "movieset-fanart.jpg"

 			If FileExists($file) Then

 				$hnfo = FileOpen($InDir & $nfoArray[$i], 0)

 				$nfo = FileRead($hnfo)

 				FileClose($hnfo)

				$idt = _StringBetween($nfo, "<set>", "</set>")

				If _ElementExists($idt, 0) Then

					$movieset = StringReplace($idt[0], "<" , "_")

					$movieset1 = StringReplace($movieset, ">" , "_")

					$movieset = StringReplace($movieset1, "?" , "_")

					$movieset1 = StringReplace($movieset, '"' , "_")

					$movieset = StringReplace($movieset1, ":" , "_")

					$movieset1 = StringReplace($movieset, "|" , "_")

					$movieset = StringReplace($movieset1, "\" , "_")

					$movieset1 = StringReplace($movieset, "/" , "_")

					$movieset = StringReplace($movieset1, "*" , "_")

					FileMove($file, $ini_moviesetfolder & "\" & $movieset & "\fanart.jpg", 9)

					_WriteLog("CopyMovieset - Processed:  " & $file)

				EndIf

 			EndIf

 			$file = $InDir & $Split[2] & "movieset-poster.jpg"

 			If FileExists($file) Then

 				$hnfo = FileOpen($InDir & $nfoArray[$i], 0)

 				$nfo = FileRead($hnfo)

 				FileClose($hnfo)

 				$idt = _StringBetween($nfo, "<set>", "</set>")

				If _ElementExists($idt, 0) Then

					$movieset = StringReplace($idt[0], "<" , "_")

					$movieset1 = StringReplace($movieset, ">" , "_")

					$movieset = StringReplace($movieset1, "?" , "_")

					$movieset1 = StringReplace($movieset, '"' , "_")

					$movieset = StringReplace($movieset1, ":" , "_")

					$movieset1 = StringReplace($movieset, "|" , "_")

					$movieset = StringReplace($movieset1, "\" , "_")

					$movieset1 = StringReplace($movieset, "/" , "_")

					$movieset = StringReplace($movieset1, "*" , "_")

					FileMove($file, $ini_moviesetfolder & "\" & $movieset & "\poster.jpg", 9)

					_WriteLog("CopyMovieset - Processed:  " & $file)

				EndIf

			EndIf

			$hnfo = FileOpen($InDir & $nfoArray[$i], 0)

			$nfo = FileRead($hnfo)

			FileClose($hnfo)

			$idt = _StringBetween($nfo, "<title>", "</title>")

			If _ElementExists($idt, 0) Then

				$file = $InDir & $Split[2] & $idt & $Split[3] & "-landscape.jpg"

				If FileExists($file) Then FileMove($file, $InDir & $Split[2] & "landscape.jpg", 9)

				_WriteLog("CopyMovieset - Processed:  " & $file)

				$file = $InDir & $Split[2] & $idt & $Split[3] & "-banner.jpg"

				If FileExists($file) Then FileMove($file, $InDir & $Split[2] & "banner.jpg", 9)

				_WriteLog("CopyMovieset - Processed:  " & $file)

				$file = $InDir & $Split[2] &  "thumb.jpg"

				If FileExists($file) Then FileMove($file, $InDir & $Split[2] & "keyart.jpg", 9)

				_WriteLog("CopyMovieset - Processed:  " & $file)

				$file = $InDir & $Split[2] & $idt & $Split[3] & "-thumb.jpg"

				If FileExists($file) Then FileMove($file, $InDir & $Split[2] & "keyart.jpg", 9)

				_WriteLog("CopyMovieset - Processed:  " & $file)

				$file = $InDir & $Split[2] & $idt & $Split[3] & "-keyart.jpg"

				If FileExists($file) Then FileMove($file, $InDir & $Split[2] & "keyart.jpg", 9)

				_WriteLog("CopyMovieset - Processed:  " & $file)

				$file = $InDir & $Split[2] & "disc.png"

				If FileExists($file) Then FileMove($file, $InDir & $Split[2] & "discart.png", 9)

				_WriteLog("CopyMovieset - Processed:  " & $file)

			EndIf

		Next


 	EndIf

	_WriteLog("CopyMovieset - Finished Working On  " & $InDir)

EndFunc

;Function to copy MediaStub files to output folder
Func _CopyStubs($InDir, $Outdir)

	If $stubext = "" Then Return

	Local $WorkArray = _FileListToArrayRec($InDir, $stubext, 1, 1, 1)

	If Not IsArray($WorkArray) Then Return

	For $i = 1 To $WorkArray[0]

		FileCopy($InDir & "\" & $WorkArray[$i], $OutDir & "\" & $WorkArray[$i], 9)

	Next

EndFunc

;Function Countdown
Func _Countdown()

	Local $value = MsgBox(292, $lng_sucess, $lng_autoend1 & @CRLF & @CRLF & $lng_autoend2, 30)

	If $value = -1 Or $value = 6 Then
		_Exit()
	EndIf

	_LastModule()

EndFunc

;Function to display scaled PNG
Func _Display_PNG($infile)

	Local $output, $i, $hImage, $sCLSID
	Local $PathSplit, $sDrive, $sDir, $sFilename, $sExtension

	$PathSplit = _PathSplit($infile, $sDrive, $sDir, $sFilename, $sExtension)

	_GDIPlus_Startup()

	$hImage = _GDIPlus_ImageLoadFromFile($infile)

	$sCLSID = _GDIPlus_EncodersGetCLSID("BMP")

	_GDIPlus_ImageSaveToFileEx($hImage, $tempdir & "\" & $PathSplit[3] & ".bmp", $sCLSID)

	_GDIPlus_ImageDispose($hImage)

	_GDIPlus_ShutDown()

	$output = $tempdir & "\" & $sFilename & ".bmp"

	Return $output

EndFunc

;Function EditRatings
Func _EditRatings()

	Local $number, $fsk, $value, $ratings3, $Json_file, $exit

	If GUICtrlRead($radio_53_41) = 1 Then IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_ratings", "1")
	If GUICtrlRead($radio_53_42) = 1 Then IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_ratings", "2")
	If GUICtrlRead($radio_53_43) = 1 Then IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_ratings", "3")

	_SaveJSON()

	$ini_ratings = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_ratings", "1")

	_WriteLog("------------------")
	_WriteLog("Info - Begin editing Ratings")

	If $ini_ratings = 2 Then

		$Json_file = FileOpen(@ScriptDir & "\nfo4HTPCv2.Settings.json", 268)

		Local $JsonString = FileRead($Json_file)

		Local $iPosition = StringInStr($JsonString, '"Ratings": [')

		Local $iPosition2 = StringInStr($JsonString, '"Image": {', 0, 1, $iPosition)

		Local $JsonStringL = StringLeft ($JsonString, $iPosition-1)

		Local $JsonStringLenght = StringLen($JsonString)

		Local $JsonStringR = StringRight ($JsonString, $JsonStringLenght - $iPosition2 + 1)

		FileClose($Json_file)

		Local $file = FileOpen(@ScriptDir & "\nfo4HTPCv2.Settings.json", 2)

		FileWrite($file, $JsonStringL)

		FileClose($file)

		$file = FileOpen(@ScriptDir & "\nfo4HTPCv2.Settings.json", 1)

		FileWriteLine($file, '"Ratings": [')

		$number = InputBox($lng_input, "Wie viele Altersklassen?", "5", "", 350, 160)

		For $i = 1 To $number - 1

			$fsk = InputBox($lng_input, "Bezeichnung der Altersklasse?", "FSK 0", "", 350, 160)

			$value = InputBox($lng_input, 'Werte zu der Altersklasse ' & $fsk & @CRLF & 'Bitte in "" und mit , getrennt eingeben.' & @CRLF & 'Wildcards * ? usw. sind erlaubt', '"0","*-0","* 0","G","TV-G","TV-Y","NR"', "", 350, 160)

			FileWriteLine($file, @TAB & @TAB & '{"SetRating": "' & $fsk & '",')

			FileWriteLine($file, @TAB & @TAB & '"ContainsRating": [' & $value & ']},')

		Next

			$fsk = InputBox($lng_input, $lng_mpaa1, "FSK 0", "", 350, 160)

			$value = InputBox($lng_input, $lng_mpaa2 & $fsk & @CRLF & $lng_mpaa3 & @CRLF & $lng_mpaa4, '"0","*-0","* 0","G","TV-G","TV-Y","NR"', "", 350, 160)

			FileWriteLine($file, @TAB & @TAB & '{"SetRating": "' & $fsk & '",')

			FileWriteLine($file, @TAB & @TAB & '"ContainsRating": [' & $value & ']}')

		FileWriteLine($file, @TAB & " ]},")

		FileWrite($file, @TAB & $JsonStringR)

		FileClose($file)

	EndIf

	If $ini_ratings = 3 Then

		$Json_file = FileOpen(@ScriptDir & "\nfo4HTPCv2.Settings.json", 268)

		Local $JsonString = FileRead($Json_file)

		Local $iPosition = StringInStr($JsonString, '"Ratings": [')

		Local $iPosition2 = StringInStr($JsonString, '"Image": {', 0, 1, $iPosition)

		Local $JsonStringL = StringLeft ($JsonString, $iPosition-1)

		Local $JsonStringLenght = StringLen($JsonString)

		Local $JsonStringR = StringRight ($JsonString, $JsonStringLenght - $iPosition2 + 1)

		FileClose($Json_file)

		Local $file = FileOpen(@ScriptDir & "\nfo4HTPCv2.Settings.json", 2)

		FileWrite($file, $JsonStringL)

		FileClose($file)

		$file = FileOpen(@ScriptDir & "\nfo4HTPCv2.Settings.json", 1)

		FileWrite($file, '"Ratings": [')
		FileWriteLine($file, @TAB & @TAB & '{"SetRating": "FSK 0",')
		FileWriteLine($file, @TAB & @TAB & '"ContainsRating": ["0","*-0","* 0","G","TV-G","TV-Y","NR"]},')
		FileWriteLine($file, @TAB & @TAB & '{"SetRating": "FSK 6",')
		FileWriteLine($file, @TAB & @TAB & '"ContainsRating": ["6","*-6","* 6","PG","TV-Y7","TV-Y7-FV","TV-PG"]},')
		FileWriteLine($file, @TAB & @TAB & '{"SetRating": "FSK 12",')
		FileWriteLine($file, @TAB & @TAB & '"ContainsRating": ["12","*-12","* 12","PG-13","TV-14"]},')
		FileWriteLine($file, @TAB & @TAB & '{"SetRating": "FSK 16",')
		FileWriteLine($file, @TAB & @TAB & '"ContainsRating": ["16","*-16","* 16","NC-17"]},')
		FileWriteLine($file, @TAB & @TAB & '{"SetRating": "FSK 18",')
		FileWriteLine($file, @TAB & @TAB & '"ContainsRating": ["18","*-18","* 18","R","X","TV-MA"]}')
		FileWriteLine($file, @TAB & ']},')
		FileWrite($file, @TAB & $JsonStringR)

		FileClose($file)

	EndIf

	_WriteLog("Info - End editing Ratings")

	$exit = MsgBox(1, $lng_save, $lng_saveconfig & @CRLF & @CRLF & $lng_saveexit & @CRLF & $lng_savenot)

	If $exit = 1 Then

		_WriteLog("------------------")
		_WriteLog("Info - Begin Shuting Down Media-Buddy")

		_SaveSettings()

		_WriteLog("Info - Saved Settings")

		_SQLite_Close(-1)

		_SQLite_Shutdown()

		_WriteLog("Info - SQlite Shut Down")

		If ProcessExists("DontSleep_x64.exe") Then

			If @Compiled = 1 Then ShellExecuteWait(@ScriptDir & "\DontSleep_x64.exe", "exit")

			If @Compiled = 1 Then _WriteLog("Info - DontSleep Shut Down")

		EndIf

		If @Compiled = 1 Then DirRemove($tempdir, 1)

		If @Compiled = 1 Then _WriteLog("Info - Removed Working Directory")

		_WriteLog("Info - Shutting Down Media-Buddy")

		_Restart()

	EndIf

EndFunc   ;==>_Exit

;Function to check if an array element exists
Func _ElementExists($array, $element)

	If $element > UBound($array) - 1 Then Return False ; element is out of the array bounds
	Return True ; element is in array bounds

EndFunc   ;==>_elementExists

;Function Exit
Func _Exit($restart = 0)

	FileDelete(@ScriptDir & "\*.pid")

	_WriteLog("------------------")
	_WriteLog("Info - Begin Shuting Down Media-Buddy")

	_SaveJSON()

	_SaveSettings()

	_WriteLog("Info - Saved Settings")

	_SQLite_Close(-1)

	_SQLite_Shutdown()

	_WriteLog("Info - SQlite Shut Down")

	If ProcessExists("DontSleep_x64.exe") Then

		If @Compiled = 1 Then ShellExecuteWait(@ScriptDir & "\DontSleep_x64.exe", "exit")

		If @Compiled = 1 Then _WriteLog("Info - DontSleep Shut Down")

	EndIf

	If @Compiled = 1 Then DirRemove($tempdir, 1)

	If @Compiled = 1 Then _WriteLog("Info - Removed Working Directory")

	_WriteLog("Info - Shutting Down Media-Buddy")

	If $restart = 1 Then _Restart()

	If $restart = 2 Then _Shutdown()

	If $restart = 3 Then  _Standby()

	If $restart = 4 Then  _Hibernate()

	Exit

EndFunc   ;==>_Exit

;Function to delete Input Files
Func _FileDeleteFromDB()

	_WriteLog("FileDeleteFromDB - Start deleting input files")

	Local $i, $query, $aResult, $iRows, $iColumns, $iRval, $FileToDelete

	$query = "SELECT * FROM FileList;"

	$iRval = _SQLite_GetTable2d(-1, $query, $aResult, $iRows, $iColumns)

	_SQLite_QueryFinalize($iRval)

	For $i = 1 to UBound($aResult)-1

		$FileToDelete = $aResult[$i][1] & $aResult[$i][2] & $aResult[$i][3]

		FileDelete($FileToDelete)

		_WriteLog("FileDeleteFromDB - FileToDelete = " & $FileToDelete)

	Next

	_WriteLog("FileDeleteFromDB - Finished deleting input files")

	Return

EndFunc

;Function to read FileList into Database
Func _FileListToDB($Array, $InDir)

	_WriteLog("FileListToDB - Start reading files to Database")

	Local $PathSplit, $sDrive, $sDir, $sFilename, $sExtension, $i, $Index, $year0, $year1, $year2

	_SQLite_Exec(-1, "DROP TABLE IF EXISTS FileList;")

	_WriteLog("Info - Cleared File List")

	_SQLite_Exec(-1, "CREATE TABLE IF NOT EXISTS FileList (ID INTEGER PRIMARY KEY,Path Text,Filename Text,Extension Text,Year Text,Year1 Text,Year2 Text);")

	For $i = 1 To $Array[0]

		$PathSplit = _PathSplit($InDir & "\" & $Array[$i], $sDrive, $sDir, $sFilename, $sExtension)

		$Index = StringInStr($extstring2, StringReplace($PathSplit[4], ".", ""))

		$year0 = FileGetTime($InDir & "\" & $Array[$i],0,1)
		$year1 = FileGetTime($InDir & "\" & $Array[$i],1,1)
		$year2 = FileGetTime($InDir & "\" & $Array[$i],2,1)

		If $Index > -1 Then

			_SQLite_Exec(-1, 'INSERT INTO FileList (Path,Filename,Extension,Year,Year1,Year2) VALUES ("' & $PathSplit[1] & $PathSplit[2] & '","' & $PathSplit[3] & '","' & $PathSplit[4] & '","' & $year0 & '","' & $year1 & '","' & $year2 & '");')

			If @error Then

				_WriteLog("FileListToDB - Error reading files to Database")

				Return -1

			EndIf

		EndIf

	Next

	_WriteLog("FileListToDB - Finished reading files to Database")

	Return

EndFunc

;Function to fix , and . decimal notation in.nfo
Func _FixNotation($Indir)

 	Local $nfoArray, $i, $hnfo, $nfo, $nfo1, $iPosition, $tPosition, $title = "", $Infile = ""

	dim $nfo2[1], $nfo3[1]

 	_WriteLog("FixNotation - Start Working On  " & $Indir)

	_SetLabel($Label02, $lng_workingon & ": " & $Indir)

;~ 	$dotreturn = 0

	$nfoArray = _FileListToArrayRec($InDir, "*.nfo", 1,1)

	If IsArray($nfoArray) Then

		If	$nfoArray[0] > 0 Then

			For $i = 1 to $nfoArray[0]

				$Infile = $Indir & "\" & $nfoArray[$i]

				_SetLabel($Label02, $lng_workingon & ": " & $Infile)

				If $Infile <> "" Then

					$hnfo = FileOpen($Infile, 256)

					$nfo1 = FileRead($hnfo)

					FileClose($hnfo)

					$nfo = StringReplace($nfo1, "&amp;", "&")

					$tPosition = StringInStr($nfo, "<rating>")

					If $tPosition > 0 Then

						$nfo3 = _StringBetween($nfo, "<rating>", "</rating>")

						$nfo2 = StringReplace($nfo3[0], ",", ".")

						$hnfo = FileOpen($Infile, 2)

						$nfo1 = StringReplace($nfo, "<rating>" & $nfo3[0] & "</rating>", "<rating>" & $nfo2 & "</rating>")

						$hnfo = FileOpen($Infile, 2)

						Filewrite($hnfo,$nfo1)

						FileClose($hnfo)

					EndIf

				EndIf

			Next

		EndIf

	Else

		$dotreturn = 2

	EndIf

	_WriteLog("FixNotation - Finished Working On  " & $Infile)

	_SetLabel($Label02, $lng_waiting)

	Return

EndFunc

;Function FixPath Chars
Func _FixPath($string)

	Local $i, $Rename1, $Rename2

	$Rename1 = StringReplace($string, "?", "")
	$Rename2 = StringReplace($Rename1, ":", " -")
	$Rename1 = StringReplace($Rename2, "\", "-")
	$Rename2 = StringReplace($Rename1, "<", "")
	$Rename1 = StringReplace($Rename2, ">", "")
	$Rename2 = StringReplace($Rename1, "|", "-")
	$Rename1 = StringReplace($Rename2, "/", "-")
	$Rename2 = StringReplace($Rename1, "*", "")
	$Rename1 = StringReplace($Rename2, '"', "")

	Return $Rename1

EndFunc   ;==>_FixPath

;Function FixUnicode
Func _FixUnicode($string)

	Local $i, $split, $out_string

	For $i = 0 To UBound($ArrayUnicode) - 1

		$split = StringSplit($ArrayUnicode[$i], "\", 3)

		$out_string = StringReplace($string, "\" & $split[1], $split[0])

		$string = $out_string

	Next

	Return $string

EndFunc   ;==>_FixUnicode

;Function to decide which Audio Tracks to Keep
Func _GetAudioTracks($InFile, $tracks = 1)

	_WriteLog("GetAudioTracks - Start Working On  " & $InFile)

	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_audiolanguages", GUICtrlRead($input_90_10))

	$ini_audiolanguages = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_audiolanguages", "en")

	Local $Languages, $Index, $i, $Returnstring = "", $c = 0, $j, $k, $l, $Returnstring1, $var, $var1, $counter

	Local $hQuery, $aRow, $iRval, $query, $aResult, $iRows, $iColumns, $bResult, $cResult, $y, $tracksperlanguage_audio

	Local $audiolanguages = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_audiolanguages", "en")

	$Languages = StringSplit($audiolanguages, ",")

	If IsArray($Languages) Then

		For $i = 1 To $Languages[0]

			$tracksperlanguage_audio = $tracks

			$c = 0

			If $ini_channelovercodec = 1 Then

				$query = 'SELECT Channels FROM Audio WHERE Language Like "' & $Languages[$i] & '" ORdeR BY Channels deSC;'

				$iRval = _SQLite_GetTable2d(-1, $query, $aResult, $iRows, $iColumns)

				If $tracksperlanguage_audio > UBound($aResult) - 1 Then

					$counter = UBound($aResult) - 1

				Else

					$counter = $tracksperlanguage_audio

				EndIf

				;Channel Loop
				For $k = 1 to $counter

					$query = 'SELECT AudioID FROM Audio WHERE Channels Like "' & $aResult[$k][0] & '" AND Language LIKE "' & $Languages[$i] & '" ORdeR BY FormatID ASC;'

					$iRval = _SQLite_GetTable2d(-1, $query, $bResult, $iRows, $iColumns)

					;Codec Loop per Channel #
					For $l = 1 to $counter

						$Returnstring = $Returnstring & "," & $bResult[$l][0]
						$c = $c + 1

						If UBound($bResult) > 2 And $c < $counter Then

							For $y = 2 To UBound($bResult) - 1

								$Returnstring = $Returnstring & "," & $bResult[$y][0]
								$c = $c + 1

								If $c = $counter Then ExitLoop

							Next

						EndIf

						If $c = $counter Then ExitLoop

					Next

					If $c = $counter Then ExitLoop

				Next

			Else

				$query = 'SELECT Format FROM Audio WHERE Language Like "' & $Languages[$i] & '" ORdeR BY FormatID ASC;'

				$iRval = _SQLite_GetTable2d(-1, $query, $aResult, $iRows, $iColumns)

				If $tracksperlanguage_audio > UBound($aResult) - 1 Then

					$counter = UBound($aResult) - 1

				Else

					$counter = $tracksperlanguage_audio

				EndIf

				;Codec Loop
					$query = 'SELECT AudioID FROM Audio WHERE Format Like "' & $aResult[$k][0] & '" AND Language LIKE "' & $Languages[$i] & '" ORdeR BY Channels deSC;'

					$iRval = _SQLite_GetTable2d(-1, $query, $bResult, $iRows, $iColumns)

				For $k = 1 to $counter

					;Channel Loop per Codec #
					For $l = 1 to $counter

						$Returnstring = $Returnstring & "," & $bResult[$l][0]
						$c = $c + 1

						If UBound($bResult) > 2 And $c < $counter Then

							For $y = 2 To UBound($bResult) - 1

								$Returnstring = $Returnstring & "," & $bResult[$y][0]
								$c = $c + 1

								If $c = $counter Then ExitLoop

							Next

						EndIf

						If $c = $counter Then ExitLoop

					Next

					If $c = $counter Then ExitLoop

				Next

			EndIf

		Next

	EndIf

	$Returnstring = StringReplace($Returnstring, ",,", ",")

	$var = StringRight($Returnstring, 1)

	If $var = "," Then $Returnstring = StringTrimRight($Returnstring, 1)

	$var1 = StringLeft($Returnstring, 1)

	If $var1 = "," Then $Returnstring = StringTrimLeft($Returnstring, 1)

	_WriteLog("GetAudioTracks - Finished Working On " & $InFile)

	Return $Returnstring

EndFunc

;Function to decide which Forced Subtitle Tracks to Keep
Func _GetForcedSubtitleTracks($InFile, $tracks = 1)

	_WriteLog("GetForcedSubtitleTracks - Start Working On  " & $InFile)

	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_tracksperlanguage_forced", GUICtrlRead($input_90_05))

	$ini_tracksperlanguage_forced = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_tracksperlanguage_forced", "1")

	$sublanguages = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_sublanguages", "en")

	Local $tracksperlanguage_forced = $tracks

	Local $Index, $i, $Returnstring = "", $query, $bResult, $iRows, $iColumns, $iRval, $j, $c = 0

	Local $Languages = StringSplit($sublanguages, ",", 1)

	If IsArray($Languages) Then

		For $i = 1 To $Languages[0]

			If NOT $Returnstring = "" Then $Returnstring = $Returnstring & ","

			$c = 0

			$query = 'SELECT TextID FROM Text WHERE Forced LIKE "Yes" AND Language Like "' & $Languages[$i] & '";'

			$iRval = _SQLite_GetTable2d(-1, $query, $bResult, $iRows, $iColumns)

			_SQLite_QueryFinalize($iRval)

			If $tracksperlanguage_forced > UBound($bResult) - 1 Then $tracksperlanguage_forced = UBound($bResult) - 1

			If UBound($bResult) > 1 And $c < $tracksperlanguage_forced Then

 				$Returnstring = $Returnstring & "," & $bResult[1][0]

				$c = $c + 1

				If UBound($bResult) > 2 And $c < $tracksperlanguage_forced Then

					For $j = 2 To $tracksperlanguage_forced

						If $c = $tracksperlanguage_forced Then ExitLoop

						$Returnstring = $Returnstring & "," & $bResult[$j][0]

						$c = $c + 1

					Next

				EndIf

			EndIf

		Next

	EndIf

	$Returnstring = StringReplace($Returnstring, ",,", ",")

	$var = StringRight($Returnstring, 1)

	If $var = "," Then $Returnstring = StringTrimRight($Returnstring, 1)

	$var1 = StringLeft($Returnstring, 1)

	If $var1 = "," Then $Returnstring = StringTrimLeft($Returnstring, 1)

	_WriteLog("GetForcedSubtitleTracks - Finished Working On  " & $InFile)

	Return $Returnstring

EndFunc

;Function to decide which Subtitle Tracks to Keep
Func _GetSubtitleTracks($InFile, $tracks = 1)

	_WriteLog("GetSubtitleTracks - Start Working On  " & $InFile)

	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_tracksperlanguage_sub", GUICtrlRead($input_90_06))

	$ini_tracksperlanguage_sub = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_tracksperlanguage_sub", "0")

	Local $Languages, $Index, $i, $Returnstring = "", $c = 0, $j, $k

	Local $hQuery, $aRow, $iRval, $query, $aResult, $iRows, $iColumns, $bResult

	Local $tracksperlanguage_sub = $tracks

	Local $sublanguages = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_sublanguages", "en")

	$Languages = StringSplit($sublanguages, ",", 1)

	If IsArray($Languages) Then

		For $i = 1 To $Languages[0]

			$tracksperlanguage_sub = $tracks

			If NOT $Returnstring = "" Then $Returnstring = $Returnstring & ","

			$c = 0

			$query = 'SELECT TextID FROM Text WHERE Forced LIKE "No" AND Language Like "' & $Languages[$i] & '";'

			$iRval = _SQLite_GetTable2d(-1, $query, $aResult, $iRows, $iColumns)

			_SQLite_QueryFinalize($iRval)


			If $tracksperlanguage_sub > UBound($aResult) - 1 Then $tracksperlanguage_sub = UBound($aResult) - 1

			If UBound($aResult) > 1 And $c < $tracksperlanguage_sub Then

				$Returnstring = $Returnstring & $aResult[1][0]

				$c = $c + 1

			EndIf

			If UBound($aResult) > 2 And $c < $tracksperlanguage_sub Then

				For $k = 2 To $tracksperlanguage_sub

					If $c = $tracksperlanguage_sub Then ExitLoop

					$Returnstring = $Returnstring & "," & $aResult[$k][0]
					$c = $c + 1

				Next

			EndIf

		Next

	EndIf

	$Returnstring = StringReplace($Returnstring, ",,", ",")

	$var = StringRight($Returnstring, 1)

	If $var = "," Then $Returnstring = StringTrimRight($Returnstring, 1)

	$var1 = StringLeft($Returnstring, 1)

	If $var1 = "," Then $Returnstring = StringTrimLeft($Returnstring, 1)

	_WriteLog("GetSubtitleTracks - Finished Working On  " & $InFile)

	Return $Returnstring

EndFunc

;Function to read recent Time
Func _GetTime()

	Local $newtime = @HOUR & ":" & @MIN

	If $newtime = $Clock Then
		Return
	Else
		$Clock = $newtime
		GUICtrlSetData($Label03, $newtime)
		GUICtrlSetData($Label193, $newtime)
		Return
	EndIf

EndFunc ;Get Time

;Function to grab music artist metadata and fanart
Func _GrabArtist($InDir = GUICtrlRead($input_34_01), $progressbar = "", $label = "")

	Local $WorkArray, $sDrive, $sDir, $sFilename, $sExtension, $PathSplit, $File0, $nfo ,$vRow, $aRow, $output1, $step1
	Local $Artist, $Year, $Album, $Disc, $Genre, $Track, $Title, $Output, $Music_FolderStructure, $search, $json
	Local $a_String, $a_Object, $a_name, $a_musicbrainzartistid, $a_Formed, $a_Born, $a_Died, $a_Disbanded
	Local $b_String, $b_Object, $b_background, $b_poster, $b_logo, $b_banner
	Local $a_Style, $a_Genre, $a_mood, $a_get, $a_biography, $a_poster, $a_fanart, $a_banner, $a_clearart, $a_gender
	Local $query, $aResult, $iRows, $iColumns, $b_String, $j, $d_cover, $d_disc, $Path, $iPID, $option, $url
	Local $d_genre, $d_title, $d_style, $d_mood, $d_theme, $d_review, $d_type, $d_label, $d_rating, $d_votes, $d_year

	Dim $AlbumArtist[0]
	Dim $Artist1[0]
	Dim $Album[0]
	Dim $Partpass[0]

	IniWrite(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_audio_metadata_inputfolder", $InDir)

	_WriteLog("Grab_Audio_Artist - Start working on " & $InDir)

	_SQLite_Exec(-1, "DROP TABLE IF EXISTS Album;")

	_SQLite_Exec(-1, "CREATE TABLE IF NOT EXISTS Album(AlbumArtist TEXT NOT NULL ON CONFLICT IGNORE, Album TEXT NOT NULL ON CONFLICT IGNORE, Path TEXT NOT NULL ON CONFLICT IGNORE);")

	$WorkArray = _FileListToArrayRec($InDir, $aextstring, 1, 1, 1)

	If Not IsArray($WorkArray) Then

		MsgBox(0, "", $lng_nofiles)
		_LastModule()
		Return 1

	EndIf

	$step1 = 20 / $WorkArray[0]

	$p = 20

	For $i = 1 To $WorkArray[0]

		_GetTime()

		_SetData($progressbar, Round($p + $step1 * $i))

		$PathSplit = _PathSplit($InDir & "\" & $WorkArray[$i], $sDrive, $sDir, $sFilename, $sExtension)

		$File = $PathSplit[1] & $PathSplit[2] & $PathSplit[3]

		$Partpass = StringSplit($PathSplit[2], $ini_Music_Renaming_MultiDisc, 1)

 		$Path = $PathSplit[1] & $Partpass[1]

		_MediaInfoAudio($InDir & "\" & $WorkArray[$i])

		_SQLite_QuerySingleRow(-1,"SELECT * FROM Music LIMIT 1;",$vRow)

		_ArrayAdd($AlbumArtist, $vRow[0])

		_ArrayAdd($Artist1, $vRow[1])

		_SQLite_Exec(-1, "INSERT INTO Album (AlbumArtist,Album,Path) VALUES ('" & StringReplace($vRow[0],"'","''") & "','" & StringReplace($vRow[2],"'","''") & "','" & StringReplace($Path,"'","''") & "');")

		_SetData($Label02, $lng_readmeta & " " & $File)

	Next

	;; Artist NFO
	If IsArray($AlbumArtist) Then

		$Artist = _ArrayUnique($AlbumArtist)

		If $ini_artist = "2" Then

			If IsArray($Artist1) Then

				$Artist = _ArrayUnique($Artist1)

			EndIf

		EndIf

		$p = 40

		$step1 = 55 / $Artist[0]

		For $i = 1 To $Artist[0]

			_SetData($progressbar, Round($p + $step1 * $i))

			$artist1 = $Artist[$i]

			$search = StringRegExpReplace($artist1, '[<>?":|\/*]', "_")

			_SetData($Label02, $lng_loadingartist & " " & $Artist[$i])

			_WriteLog("Grab_Audio_Artist - Working on " & $Artist[$i])

			InetGet('http://musicbrainz.org/ws/2/artist/?query=artist:"' & $search & '"&fmt=json', $tempdir  & '\' & $search & '.json')

 			_WriteLog('Grab_Audio_Artist - Search = "' & $search & '"')

			$fle_hwnd = FileOpen($tempdir  & '\' & $search & '.json', 256)

			$a_String = FileRead($fle_hwnd)

			FileClose($fle_hwnd)

			$a_Object = _JSON_Parse($a_String)

			$a_name = _JSON_Get($a_Object, ".artists[0].name")

			$a_musicbrainzartistid = _JSON_Get($a_Object, ".artists[0].id")

			$a_disambiguation = _JSON_Get($a_Object, ".artists[0].disambiguation")

			$a_type = _JSON_Get($a_Object, ".artists[0].type")

			$a_Born = _JSON_Get($a_Object, ".artists[0]life-span.begin")

			$a_Died = _JSON_Get($a_Object, ".artists[0]life-span.ended")

			$a_gender = _JSON_Get($a_Object, ".artists[0].gender")

			$a_type = _JSON_Get($a_Object, ".artists[0].type")

			$fle_hwnd = FileOpen($InDir & "\" & $Artist[$i] & "\artist.nfo", 10)

			FileWrite($fle_hwnd, '<?xml version="1.0" encoding="UTF-8" standalone="yes"?>'  & @CRLF & '<!--created on ' & _Now() & ' - Media-Buddy ' & $version & ' -->'  & @CRLF & '<artist>' & @CRLF)

			FileWrite($fle_hwnd, '  <name>' & $a_name & '</name>' & @CRLF)

			FileWrite($fle_hwnd, '  <sortname>' & $a_name & '</sortname>' & @CRLF)

			FileWrite($fle_hwnd, '  <musicBrainzArtistID>' & $a_musicbrainzartistid & '</musicBrainzArtistID>' & @CRLF)

			FileWrite($fle_hwnd, '  <type>' & $a_type & '</type>' & @CRLF)

			FileWrite($fle_hwnd, '  <gender>' & $a_gender & '</gender>' & @CRLF)

			FileWrite($fle_hwnd, '  <disambiguation>' & $a_disambiguation & '</disambiguation>' & @CRLF)

			If $a_type = "Group" Then

				FileWrite($fle_hwnd, '  <formed>' & $a_Born & '</formed>' & @CRLF)

				FileWrite($fle_hwnd, '  <disbanded>' & $a_Died & '</disbanded>' & @CRLF)

				FileWrite($fle_hwnd, '  <born></born>' & @CRLF)

				FileWrite($fle_hwnd, '  <died></died>' & @CRLF)

			Else

				FileWrite($fle_hwnd, '  <formed></formed>' & @CRLF)

				FileWrite($fle_hwnd, '  <disbanded></disbanded>' & @CRLF)

				FileWrite($fle_hwnd, '  <born>' & $a_Born & '</born>' & @CRLF)

				FileWrite($fle_hwnd, '  <died>' & $a_Died & '</died>' & @CRLF)

			EndIf

			FileWrite($fle_hwnd, '</artist>' & @CRLF)

			FileClose($fle_hwnd)

			$option = " --type:fanart --id:mbid:" & $a_musicbrainzartistid & ' --output:"' & $tempdir  & '\' & $search & '_images.json"'

			_WriteLog("nfo4HTPCv2 - " & $option)

			ShellExecuteWait(@ScriptDir & "\nfo4HTPCv2.exe", $option, "", "", @SW_HIde)

			$fle_hwnd = FileOpen($tempdir  & '\' & $search & '_images.json', 256)

			$b_String = FileRead($fle_hwnd)

			FileClose($fle_hwnd)

			$b_Object = _JSON_Parse($b_String)

			$b_poster = _JSON_Get($b_Object, ".artistthumb[0].url")

			InetGet($b_poster, $InDir  & '\' & $Artist[$i] & '\folder.jpg')

			$b_background = _JSON_Get($b_Object, ".artistbackground[0].url")

			InetGet($b_background, $InDir  & '\' & $Artist[$i] & '\fanart.jpg')

			$b_logo = _JSON_Get($b_Object, ".hdmusiclogo[0].url")

			If StringLen($b_logo) < 10 Then

				$b_logo = _JSON_Get($b_Object, ".musiclogo[0].url")

			EndIf

			InetGet($b_logo, $InDir  & '\' & $Artist[$i] & '\clearlogo.png')

			$b_banner = _JSON_Get($b_Object, ".musicbanner[0].url")

			InetGet($b_banner, $InDir  & '\' & $Artist[$i] & '\banner.jpg')

		Next

		_SetData($Label02, $lng_extractmissing)

		$Album = _ArrayUnique($WorkArray)

		$p = 95

		$step1 = 5 / $Album[0]


		For $i = 2 To $Album[0]

			_GetTime()

			_SetData($progressbar, Round($p + $step1 * $i))

			$split = StringSplit($Album[$i],"\")

			$path = $indir & "\" & $split[1] & "\" & $split[2] & "\"

			If $split[0] = 3 Then

				 $file = $split[3]

			EndIf

			If $split[0] = 4 Then

				$file = $split[3] & "\" & $split[4]

			EndIf

			If NOT FileExists($path & "folder.jpg") Then

				$option = ' -i "' & $path & $file & '" -y -c:v copy "' & $path & '\folder.jpg"'

				ShellExecuteWait($ini_ffmpeg_path, $option, "", "", @SW_HIde)

			EndIf

		Next

	EndIf

	_WriteLog("Grab_Audio_Artist - Finished working ")

	_SetData($Label02, $lng_waiting)

	Return

EndFunc

;Function To Hibernate PC
Func _Hibernate()

	Local $value = MsgBox(292, $lng_sucess, $lng_autoend6 & @CRLF & @CRLF & $lng_autoend2, 30)

	If $value = -1 Or $value = 6 Then

		Shutdown(84)

	EndIf

	_LastModule()

EndFunc

;Function To Refresh Movieset Fanart in Kodi
Func _KodiRefreshMovieset()

	If StringInStr($ini_moviesetfolder, ":") > 0  Then

		MsgBox($MB_SYSTEMMODAL, $lng_error, $lng_nounc)

		_GUI_Show_Settings()

		_GUI_Settings_Metadata()

		Return

	EndIf

	If GUICtrlRead($radio_44_01) = 1 Then

		IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_kodi_database", "SQlite")

		_KodiRefreshMoviesetSQLite()

	EndIf

	If GUICtrlRead($radio_44_02) = 1 Then

		IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_kodi_database", "MySQL")

		_KodiRefreshMoviesetMySQL()

	EndIf

EndFunc

;Function To Refresh Movieset Fanart in Kodi MySQL DB
Func _KodiRefreshMoviesetMySQL()

	Local $movieset, $Path, $art, $art2, $sDrive, $sDir, $sFileName, $sExtension, $i, $res, $InDir, $set, $set1

 	Local $Split, $row, $season, $file, $j, $folder, $nfoArray, $nfo, $hnfo, $movieset1, $idt, $flag

	Local $tvdb, $query, $Rows, $Columns, $Rval, $KodiArtArray, $MysqlConn, $connected, $errno

	_WriteLog("Info - Refresh Kodi Movieset Art: Started")

	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_kodi_MySQL_server", GUICtrlRead($input_44_13))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_kodi_MySQL_port", GUICtrlRead($input_44_14))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_kodi_MySQL_user", GUICtrlRead($input_44_15))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_kodi_MySQL_pass", GUICtrlRead($input_44_16))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_kodi_MySQL_database", GUICtrlRead($input_44_17))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_koditools_inputfolder", GUICtrlRead($input_44_01))

	$ini_kodi_MySQL_database = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_kodi_MySQL_database", "MyVideos116")
	$ini_kodi_MySQL_pass = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_kodi_MySQL_pass", "kodi")
	$ini_kodi_MySQL_port = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_kodi_MySQL_port", "3306")
	$ini_kodi_MySQL_server = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_kodi_MySQL_server", "localhost")
	$ini_kodi_MySQL_user = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_kodi_MySQL_user", "kodi")
	$ini_koditools_inputfolder = IniRead(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_koditools_inputfolder", @MyDocumentsDir)

	$InDir = $ini_koditools_inputfolder

	; MYSQL start
	_MySQL_InitLibrary()

	If @error Then

		MsgBox($MB_SYSTEMMODAL, "MySQL Error", "No libmysql.dll found")

		Exit -1

	EndIf

	$MysqlConn = _MySQL_Init()

	$connected = _MySQL_Real_Connect($MysqlConn, $ini_kodi_MySQL_server, $ini_kodi_MySQL_user, $ini_kodi_MySQL_pass, $ini_kodi_MySQL_database, $ini_kodi_MySQL_port)

	If $connected = 0 Then

		$errno = _MySQL_errno($MysqlConn)

		MsgBox(0,"Error:",$errno & @LF & _MySQL_error($MysqlConn), 2)

		Return -1

	Endif

	If $ini_moviesetfolderuse = "1" Then

		_WriteLog("Refresh Kodi Movieset Art - Start Working On  " & $InDir)

		If StringRight($ini_kodi_MySQL_database,3) > 117 Then

			$nfoArray = _FileListToArrayRec($InDir, "*", 2,0)

			_WriteLog("Refresh Kodi Movieset Art - FileListToArrayRec: Finished ")

			If _ElementExists($nfoArray, 0) Then

				For $i = 1 To $nfoArray[0]

					_SetData($Label02, $lng_workingon & " " & $nfoArray[$i])

					_WriteLog("Refresh Kodi Movieset Art - Working On  " & $nfoArray[$i])

					$query = 'SELECT idSet FROM sets WHERE strSet LIKE "' & $nfoArray[$i] & '"'

					_MySQL_Real_Query($MysqlConn, $query)

					$res = _MySQL_Store_Result($MysqlConn)

					$KodiArtArray = _MySQL_Fetch_Result_StringArray($res)

					If Not IsArray($KodiArtArray) Then

						$set1 = StringReplace($nfoArray[$i], "_", ":")

						$query = 'SELECT idSet FROM sets WHERE strSet LIKE "' & $set1 & '"'

						_MySQL_Real_Query($MysqlConn, $query)

						$res = _MySQL_Store_Result($MysqlConn)

						$KodiArtArray = _MySQL_Fetch_Result_StringArray($res)

					EndIf

						If IsArray($KodiArtArray) Then

							$query = 'deLETE FROM art WHERE media_type LIKE "set" AND media_id LIKE "' & $KodiArtArray[1][0] & '"'

							_MySQL_Real_Query($MysqlConn, $query)


							$art = $ini_moviesetfolder & "\" & $nfoArray[$i] & "\poster.jpg"
							$art2 = StringReplace($art, "\", "/")

							If FileExists($art) Then $Rval = _MySQL_Real_Query($MysqlConn, 'INSERT INTO art (media_id,media_type,type,url) VALUES (' & $KodiArtArray[1][0] & ', "set", "poster", "smb:' & $art2 & '")')

							$art = $ini_moviesetfolder & "\" & $nfoArray[$i] & "\banner.jpg"
							$art2 = StringReplace($art, "\", "/")

							If FileExists($art) Then $Rval = _MySQL_Real_Query($MysqlConn, 'INSERT INTO art (media_id,media_type,type,url) VALUES (' & $KodiArtArray[1][0] & ', "set", "banner", "smb:' & $art2 & '")')

							$art = $ini_moviesetfolder & "\" & $nfoArray[$i] & "\clearart.png"
							$art2 = StringReplace($art, "\", "/")

							If FileExists($art) Then $Rval = _MySQL_Real_Query($MysqlConn, 'INSERT INTO art (media_id,media_type,type,url) VALUES (' & $KodiArtArray[1][0] & ', "set", "clearart", "smb:' & $art2 & '")')

							$art = $ini_moviesetfolder & "\" & $nfoArray[$i] & "\clearlogo.png"
							$art2 = StringReplace($art, "\", "/")

							If FileExists($art) Then $Rval = _MySQL_Real_Query($MysqlConn, 'INSERT INTO art (media_id,media_type,type,url) VALUES (' & $KodiArtArray[1][0] & ', "set", "clearlogo", "smb:' & $art2 & '")')

							$art = $ini_moviesetfolder & "\" & $nfoArray[$i] & "\fanart.jpg"
							$art2 = StringReplace($art, "\", "/")

							If FileExists($art) Then $Rval = _MySQL_Real_Query($MysqlConn, 'INSERT INTO art (media_id,media_type,type,url) VALUES (' & $KodiArtArray[1][0] & ', "set", "fanart", "smb:' & $art2 & '")')

							$art = $ini_moviesetfolder & "\" & $nfoArray[$i] & "\keyart.jpg"
							$art2 = StringReplace($art, "\", "/")

							If FileExists($art) Then $Rval = _MySQL_Real_Query($MysqlConn, 'INSERT INTO art (media_id,media_type,type,url) VALUES (' & $KodiArtArray[1][0] & ', "set", "keyart", "smb:' & $art2& '")')

							$art = $ini_moviesetfolder & "\" & $nfoArray[$i] & "\landscape.jpg"
							$art2 = StringReplace($art, "\", "/")

							If FileExists($art) Then $Rval = _MySQL_Real_Query($MysqlConn, 'INSERT INTO art (media_id,media_type,type,url) VALUES (' & $KodiArtArray[1][0] & ', "set", "landscape", "smb:' & $art2 & '")')

						EndIf

				Next

			EndIf

		Else

			$nfoArray = _FileListToArrayRec($InDir, "*.nfo", 1,1)

			_WriteLog("Refresh Kodi Movieset Art - FileListToArrayRec: Finished ")

			If _ElementExists($nfoArray, 0) Then

				For $i = 1 To $nfoArray[0]

					$file = FileRead($InDir & "\" & $nfoArray[$i])

					$iPosition = StringInStr($file, "<set>")

					If $iPosition > 0 Then

						$set = _StringBetween($file, "<set>", "</set>")

						_SetData($Label02, $lng_workingon & " " & $set[0])

						_WriteLog("Refresh Kodi Movieset Art - Working On  " & $set[0])

						$query = 'SELECT idSet FROM sets WHERE strSet LIKE "' & $set[0] & '"'

						_MySQL_Real_Query($MysqlConn, $query)

						$res = _MySQL_Store_Result($MysqlConn)

						$KodiArtArray = _MySQL_Fetch_Result_StringArray($res)

						If Not IsArray($KodiArtArray) Then

							$set1 = StringReplace($set[0], "_", ":")

							$query = 'SELECT idSet FROM sets WHERE strSet LIKE "' & $set1 & '"'

							_MySQL_Real_Query($MysqlConn, $query)

							$res = _MySQL_Store_Result($MysqlConn)

							$KodiArtArray = _MySQL_Fetch_Result_StringArray($res)

						EndIf

						If IsArray($KodiArtArray) Then

							$query = 'deLETE FROM art WHERE media_type LIKE "set" AND media_id LIKE "' & $KodiArtArray[1][0] & '"'

							_MySQL_Real_Query($MysqlConn, $query)


							$art = $ini_moviesetfolder & "\" & $set[0] & "\poster.jpg"
							$art2 = StringReplace($art, "\", "/")

							If FileExists($art) Then $Rval = _MySQL_Real_Query($MysqlConn, 'INSERT INTO art (media_id,media_type,type,url) VALUES (' & $KodiArtArray[1][0] & ', "set", "poster", "smb:' & $art2 & '")')

							$art = $ini_moviesetfolder & "\" & $set[0] & "\banner.jpg"
							$art2 = StringReplace($art, "\", "/")

							If FileExists($art) Then $Rval = _MySQL_Real_Query($MysqlConn, 'INSERT INTO art (media_id,media_type,type,url) VALUES (' & $KodiArtArray[1][0] & ', "set", "banner", "smb:' & $art2 & '")')

							$art = $ini_moviesetfolder & "\" & $set[0] & "\clearart.png"
							$art2 = StringReplace($art, "\", "/")

							If FileExists($art) Then $Rval = _MySQL_Real_Query($MysqlConn, 'INSERT INTO art (media_id,media_type,type,url) VALUES (' & $KodiArtArray[1][0] & ', "set", "clearart", "smb:' & $art2 & '")')

							$art = $ini_moviesetfolder & "\" & $set[0] & "\clearlogo.png"
							$art2 = StringReplace($art, "\", "/")

							If FileExists($art) Then $Rval = _MySQL_Real_Query($MysqlConn, 'INSERT INTO art (media_id,media_type,type,url) VALUES (' & $KodiArtArray[1][0] & ', "set", "clearlogo", "smb:' & $art2 & '")')

							$art = $ini_moviesetfolder & "\" & $set[0] & "\fanart.jpg"
							$art2 = StringReplace($art, "\", "/")

							If FileExists($art) Then $Rval = _MySQL_Real_Query($MysqlConn, 'INSERT INTO art (media_id,media_type,type,url) VALUES (' & $KodiArtArray[1][0] & ', "set", "fanart", "smb:' & $art2 & '")')

							$art = $ini_moviesetfolder & "\" & $set[0] & "\keyart.jpg"
							$art2 = StringReplace($art, "\", "/")

							If FileExists($art) Then $Rval = _MySQL_Real_Query($MysqlConn, 'INSERT INTO art (media_id,media_type,type,url) VALUES (' & $KodiArtArray[1][0] & ', "set", "keyart", "smb:' & $art2& '")')

							$art = $ini_moviesetfolder & "\" & $set[0] & "\landscape.jpg"
							$art2 = StringReplace($art, "\", "/")

							If FileExists($art) Then $Rval = _MySQL_Real_Query($MysqlConn, 'INSERT INTO art (media_id,media_type,type,url) VALUES (' & $KodiArtArray[1][0] & ', "set", "landscape", "smb:' & $art2 & '")')

						EndIf

					EndIf

				Next

			EndIf

		EndIf

		Else

		$query = 'SELECT type, url FROM art WHERE media_type LIKE "set"'

		_MySQL_Real_Query($MysqlConn, $query)

		$res = _MySQL_Store_Result($MysqlConn)

		$KodiArtArray = _MySQL_Fetch_Result_StringArray($res)

		_WriteLog("Info - Read Art data from Kodi Database")

		If _ElementExists($KodiArtArray, 2) Then

			For $i = 1 to UBound($KodiArtArray) -1

				$Path = StringTrimLeft($KodiArtArray[$i][1], 4)

				$art = _PathSplit($Path, $sDrive, $sDir, $sFileName, $sExtension)

				$movieset = "/" & $art[2] & "movieset-" & $art[3] & $art[4]

				_SetData($Label02, $lng_workingon & " " & $art[2] & $art[3] & $art[4])

				If FileExists($movieset) Then

					$Rval = _MySQL_Real_Query($MysqlConn, 'UPDATE art SET url = "smb:' & $movieset & '" WHERE media_type LIKE "set" AND url LIKE "' & $KodiArtArray[$i][1] & '" ')

				EndIf

			Next

		EndIf

	EndIf

	_SetData($Label02, $lng_waiting)

	_MySQL_Free_Result($res)

	; Shutdown MySQL
	_MySQL_Close($MysqlConn)

	_MySQL_EndLibrary()

	_WriteLog("Info - Refresh Kodi Movieset Art: Finished")

	MsgBox(0, "", $lng_sucess, 3)

EndFunc

;Function To Refresh Movieset Fanart in Kodi SQLite DB
Func _KodiRefreshMoviesetSQLite()

	Local $movieset, $Path, $art, $sDrive, $sDir, $sFileName, $sExtension, $i

	Local $tvdb, $query, $Rows, $Columns, $Rval, $KodiArtArray, $InDir

	IniWrite(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_koditools_inputfolder", GUICtrlRead($input_44_01))

	$ini_koditools_inputfolder = IniRead(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_koditools_inputfolder", @MyDocumentsDir)

	_WriteLog("Info - Refresh Kodi Movieset Art: Started")

	$InDir = $ini_koditools_inputfolder

	$ini_kodi_SQLite_database = GUICtrlRead($input_44_12)

	_WriteLog("Info - Read Available Kodi Art data from SQLite: Started")

	$iFileExists = FileExists($ini_kodi_SQLite_database)

    If $iFileExists Then

		$tvdb = _SQLite_Open($ini_kodi_SQLite_database)

		If $ini_moviesetfolderuse = "1" Then

			_WriteLog("Refresh Kodi Movieset Art - Start Working On  " & $InDir)

			If StringLeft((StringRight($ini_kodi_SQLite_database,6)),3) > 117 Then

			$nfoArray = _FileListToArrayRec($InDir, "*", 2,0)

			_WriteLog("Refresh Kodi Movieset Art - FileListToArrayRec: Finished ")

			If _ElementExists($nfoArray, 0) Then

				For $i = 1 To $nfoArray[0]

					_SetData($Label02, $lng_workingon & " " & $nfoArray[$i])

					_WriteLog("Refresh Kodi Movieset Art - Working On  " & $nfoArray[$i])

					$query = 'SELECT idSet FROM sets WHERE strSet LIKE "' & $nfoArray[$i] & '"'

					$res = _SQLite_GetTable2d($tvdb, $query, $KodiArtArray, $Rows, $Rows, $Columns)

					If Not IsArray($KodiArtArray) Then

						$set1 = StringReplace($nfoArray[$i], "_", ":")

						$query = 'SELECT idSet FROM sets WHERE strSet LIKE "' & $set1 & '"'

						$res = _SQLite_GetTable2d($tvdb, $query, $KodiArtArray, $Rows, $Rows, $Columns)

					EndIf

					If $KodiArtArray[1][0] <> "" Then

						$query = 'deLETE FROM art WHERE media_type LIKE "set" AND media_id LIKE "' & $KodiArtArray[1][0] & '"'

						_SQLite_Exec($tvdb, $query)

						$art = $ini_moviesetfolder & "\" & $nfoArray[$i] & "\poster.jpg"
						$art2 = StringReplace($art, "\", "/")

						If FileExists($art) Then _SQLite_Exec($tvdb, 'INSERT INTO art (media_id,media_type,type,url) VALUES (' & $KodiArtArray[1][0] & ', "set", "poster", "smb:' & $art2 & '")')

						$art = $ini_moviesetfolder & "\" & $nfoArray[$i] & "\banner.jpg"
						$art2 = StringReplace($art, "\", "/")

						If FileExists($art) Then _SQLite_Exec($tvdb, 'INSERT INTO art (media_id,media_type,type,url) VALUES (' & $KodiArtArray[1][0] & ', "set", "banner", "smb:' & $art2 & '")')

						$art = $ini_moviesetfolder & "\" & $nfoArray[$i] & "\clearart.png"
						$art2 = StringReplace($art, "\", "/")

						If FileExists($art) Then _SQLite_Exec($tvdb, 'INSERT INTO art (media_id,media_type,type,url) VALUES (' & $KodiArtArray[1][0] & ', "set", "clearart", "smb:' & $art2 & '")')

						$art = $ini_moviesetfolder & "\" & $nfoArray[$i] & "\clearlogo.png"
							$art2 = StringReplace($art, "\", "/")

						If FileExists($art) Then _SQLite_Exec($tvdb, 'INSERT INTO art (media_id,media_type,type,url) VALUES (' & $KodiArtArray[1][0] & ', "set", "clearlogo", "smb:' & $art2 & '")')

						$art = $ini_moviesetfolder & "\" & $nfoArray[$i] & "\fanart.jpg"
						$art2 = StringReplace($art, "\", "/")

						If FileExists($art) Then _SQLite_Exec($tvdb, 'INSERT INTO art (media_id,media_type,type,url) VALUES (' & $KodiArtArray[1][0] & ', "set", "fanart", "smb:' & $art2 & '")')

						$art = $ini_moviesetfolder & "\" & $nfoArray[$i] & "\keyart.jpg"
						$art2 = StringReplace($art, "\", "/")

						If FileExists($art) Then _SQLite_Exec($tvdb, 'INSERT INTO art (media_id,media_type,type,url) VALUES (' & $KodiArtArray[1][0] & ', "set", "keyart", "smb:' & $art2 & '")')

						$art = $ini_moviesetfolder & "\" & $nfoArray[$i] & "\landscape.jpg"
						$art2 = StringReplace($art, "\", "/")

						If FileExists($art) Then _SQLite_Exec($tvdb, 'INSERT INTO art (media_id,media_type,type,url) VALUES (' & $KodiArtArray[1][0] & ', "set", "landscape", "smb:' & $art2 & '")')

					EndIf

				Next

			Else
				$nfoArray = _FileListToArrayRec($InDir, "*.nfo", 1,1)

				_WriteLog("Refresh Kodi Movieset Art - FileListToArrayRec: Finished ")

				If _ElementExists($nfoArray, 0) Then

					For $i = 1 To $nfoArray[0]

						$file = FileRead($InDir & "\" & $nfoArray[$i])

						$iPosition = StringInStr($file, "<set>")

						If $iPosition > 0 Then

							$set = _StringBetween($file, "<set>", "</set>")

							_SetData($Label02, $lng_workingon & " " & $set[0])

							_WriteLog("Refresh Kodi Movieset Art - Working On  " & $set[0])

							$query = 'SELECT idSet FROM sets WHERE strSet LIKE "' & $set[0] & '"'

							$res = _SQLite_GetTable2d($tvdb, $query, $KodiArtArray, $Rows, $Rows, $Columns)

							If Not IsArray($KodiArtArray) Then

								$set1 = StringReplace($set[0], "_", ":")

								$query = 'SELECT idSet FROM sets WHERE strSet LIKE "' & $set1 & '"'

								$res = _SQLite_GetTable2d($tvdb, $query, $KodiArtArray, $Rows, $Rows, $Columns)

							EndIf


							If $KodiArtArray[1][0] <> "" Then

								$query = 'deLETE FROM art WHERE media_type LIKE "set" AND media_id LIKE "' & $KodiArtArray[1][0] & '"'

								_SQLite_Exec($tvdb, $query)

								$art = $ini_moviesetfolder & "\" & $set[0] & "\poster.jpg"
								$art2 = StringReplace($art, "\", "/")

								If FileExists($art) Then _SQLite_Exec($tvdb, 'INSERT INTO art (media_id,media_type,type,url) VALUES (' & $KodiArtArray[1][0] & ', "set", "poster", "smb:' & $art2 & '")')

								$art = $ini_moviesetfolder & "\" & $set[0] & "\banner.jpg"
								$art2 = StringReplace($art, "\", "/")

								If FileExists($art) Then _SQLite_Exec($tvdb, 'INSERT INTO art (media_id,media_type,type,url) VALUES (' & $KodiArtArray[1][0] & ', "set", "banner", "smb:' & $art2 & '")')

								$art = $ini_moviesetfolder & "\" & $set[0] & "\clearart.png"
								$art2 = StringReplace($art, "\", "/")

								If FileExists($art) Then _SQLite_Exec($tvdb, 'INSERT INTO art (media_id,media_type,type,url) VALUES (' & $KodiArtArray[1][0] & ', "set", "clearart", "smb:' & $art2 & '")')

								$art = $ini_moviesetfolder & "\" & $set[0] & "\clearlogo.png"
								$art2 = StringReplace($art, "\", "/")

								If FileExists($art) Then _SQLite_Exec($tvdb, 'INSERT INTO art (media_id,media_type,type,url) VALUES (' & $KodiArtArray[1][0] & ', "set", "clearlogo", "smb:' & $art2 & '")')

								$art = $ini_moviesetfolder & "\" & $set[0] & "\fanart.jpg"
								$art2 = StringReplace($art, "\", "/")

								If FileExists($art) Then _SQLite_Exec($tvdb, 'INSERT INTO art (media_id,media_type,type,url) VALUES (' & $KodiArtArray[1][0] & ', "set", "fanart", "smb:' & $art2 & '")')

								$art = $ini_moviesetfolder & "\" & $set[0] & "\keyart.jpg"
								$art2 = StringReplace($art, "\", "/")

								If FileExists($art) Then _SQLite_Exec($tvdb, 'INSERT INTO art (media_id,media_type,type,url) VALUES (' & $KodiArtArray[1][0] & ', "set", "keyart", "smb:' & $art2 & '")')

								$art = $ini_moviesetfolder & "\" & $set[0] & "\landscape.jpg"
								$art2 = StringReplace($art, "\", "/")

								If FileExists($art) Then _SQLite_Exec($tvdb, 'INSERT INTO art (media_id,media_type,type,url) VALUES (' & $KodiArtArray[1][0] & ', "set", "landscape", "smb:' & $art2 & '")')

							EndIf

						EndIf

					Next

				EndIf

			EndIf

		Else

			$query = 'SELECT type, url FROM art WHERE media_type LIKE "set" ;'

			$Rval = _SQLite_GetTable2d($tvdb, $query, $KodiArtArray, $Rows, $Columns)

			_WriteLog("Info - Read Art data from Kodi Database")

			_WriteLog("Info - Read Available Kodi Art data from SQLite: Finished")

			If _ElementExists($KodiArtArray, 1) Then

				For $i = 1 to UBound($KodiArtArray) -1

					$Path = StringTrimLeft($KodiArtArray[$i][1], 4)

					$art = _PathSplit($Path, $sDrive, $sDir, $sFileName, $sExtension)

					$movieset = "/" & $art[2] & "movieset-" & $art[3] & $art[4]

					_SetData($Label02, $lng_workingon & " " & $art[2] & $art[3] & $art[4])

					If FileExists($movieset) Then

						_SQLite_Exec($tvdb, 'UPDATE art SET url = "smb:' & $movieset & '" WHERE media_type LIKE "set" AND url LIKE "' & $KodiArtArray[$i][1] & '" ;')

					EndIf

				Next

			EndIf

		EndIf

		EndIf

		_SQLite_Close($ini_kodi_SQLite_database)

	EndIf

	_WriteLog("Info - Refresh Kodi Movieset Art: Finished")

	_SetData($Label02, $lng_waiting)

	MsgBox(0, "", $lng_sucess, 3)

EndFunc

;Function To Refresh Movieset Fanart in Kodi MySQL DB
Func _KodiRefreshClearartMySQL()

	Local $movieset, $Path, $art, $art2, $sDrive, $sDir, $sFileName, $sExtension, $i, $res, $InDir, $set, $set1

 	Local $Split, $row, $season, $file, $j, $folder, $nfoArray, $nfo, $hnfo, $movieset1, $idt, $flag

	Local $tvdb, $query, $Rows, $Columns, $Rval, $KodiArtArray, $MysqlConn, $connected, $errno, $KodiClearArtArray

	_WriteLog("Info - Refresh Kodi ClearArt: Started")

	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_kodi_MySQL_server", GUICtrlRead($input_44_13))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_kodi_MySQL_port", GUICtrlRead($input_44_14))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_kodi_MySQL_user", GUICtrlRead($input_44_15))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_kodi_MySQL_pass", GUICtrlRead($input_44_16))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_kodi_MySQL_database", GUICtrlRead($input_44_17))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_koditools_inputfolder", GUICtrlRead($input_44_01))

	$ini_kodi_MySQL_database = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_kodi_MySQL_database", "MyVideos116")
	$ini_kodi_MySQL_pass = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_kodi_MySQL_pass", "kodi")
	$ini_kodi_MySQL_port = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_kodi_MySQL_port", "3306")
	$ini_kodi_MySQL_server = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_kodi_MySQL_server", "localhost")
	$ini_kodi_MySQL_user = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_kodi_MySQL_user", "kodi")
	$ini_koditools_inputfolder = IniRead(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_koditools_inputfolder", @MyDocumentsDir)

	$InDir = $ini_koditools_inputfolder

	; MYSQL start
	_MySQL_InitLibrary()

	If @error Then

		MsgBox($MB_SYSTEMMODAL, "MySQL Error", "No libmysql.dll found")

		Exit -1

	EndIf

	$MysqlConn = _MySQL_Init()

	$connected = _MySQL_Real_Connect($MysqlConn, $ini_kodi_MySQL_server, $ini_kodi_MySQL_user, $ini_kodi_MySQL_pass, $ini_kodi_MySQL_database, $ini_kodi_MySQL_port)

	If $connected = 0 Then

		$errno = _MySQL_errno($MysqlConn)

		MsgBox(0,"Error:",$errno & @LF & _MySQL_error($MysqlConn), 2)

		Return -1

	Endif

	$query = 'SELECT media_id, url FROM art WHERE media_type LIKE "tvshow" AND type LIKE "clearlogo"'

	_MySQL_Real_Query($MysqlConn, $query)

	$res = _MySQL_Store_Result($MysqlConn)

	$KodiArtArray = _MySQL_Fetch_Result_StringArray($res)

	_SetData($Label02, "Arbeite")

	For $i = 1 to ubound($KodiArtArray) -1

		$query = 'SELECT url FROM art WHERE media_type LIKE "tvshow" AND type LIKE "clearart" AND media_id LIKE "' & $i & '"'

		_MySQL_Real_Query($MysqlConn, $query)

		$res = _MySQL_Store_Result($MysqlConn)

		$KodiClearArtArray = _MySQL_Fetch_Result_StringArray($res)

		If IsArray($KodiClearArtArray) Then


		Else

			_SetData($Label02, 'INSERT INTO art(media_id,media_type,type,url) VALUES("' & $KodiArtArray[$i][0] & '", "tvshow", "clearart","' & $KodiArtArray[$i][1] & '")')

			$query = 'INSERT INTO art (media_id,media_type,type,url) VALUES ("' & $KodiArtArray[$i][0] & '", "tvshow", "clearart", "' & $KodiArtArray[$i][1] & '")'

			$Rval = _MySQL_Real_Query($MysqlConn, $query)

			_MySQL_Store_Result($MysqlConn)

		EndIf

	Next

	_SetData($Label02, $lng_waiting)

	_MySQL_Free_Result($res)

	; Shutdown MySQL
	_MySQL_Close($MysqlConn)

	_MySQL_EndLibrary()

	_WriteLog("Info - Refresh Kodi ClearArt: Finished")

	MsgBox(0, "", $lng_sucess, 3)

EndFunc

;Function to select last used module
Func _LastModule()

	_ClearFuncGUI()

	$ini_lastmodule = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_lastmodule", "1-1")

	Select
		Case $ini_lastmodule = "1-1"
			_GUI_Show_Wizards()
			_GUI_Wizard_Series()

		Case $ini_lastmodule = "1-2"
			_GUI_Show_Wizards()
			_GUI_Wizard_Movies()

		Case $ini_lastmodule = "1-3"
			_GUI_Show_Wizards()
			_GUI_Wizard_Videos()

		Case $ini_lastmodule = "1-4"
			_GUI_Show_Wizards()
			_GUI_Wizard_Audios()

		Case $ini_lastmodule = "2-1"
			_GUI_Show_Conversion()
			_GUI_Videos_Recode()

		Case $ini_lastmodule = "2-2"
			_GUI_Show_Conversion()
			_GUI_Videos_Remux()

		Case $ini_lastmodule = "2-3"
			_GUI_Show_Conversion()
			_GUI_Videos_Append()

		Case $ini_lastmodule = "2-4"
			_GUI_Show_Conversion()
			_GUI_Audio_Recode()

		Case $ini_lastmodule = "2-5"
			_GUI_Show_Conversion()
			_GUI_Audio_Normalize()

		Case $ini_lastmodule = "2-6"
			_GUI_Show_Conversion()
			_GUI_Graphics()

		Case $ini_lastmodule = "3-1"
			_GUI_Show_Metadata()
			_GUI_Show_Series_Metadata()

		Case $ini_lastmodule = "3-2"
			_GUI_Show_Metadata()
			_GUI_Show_Movies_Metadata()

		Case $ini_lastmodule = "3-3"
			_GUI_Show_Metadata()
			_GUI_Show_Videos_Metadata()

		Case $ini_lastmodule = "3-4"
			_GUI_Show_Metadata()
			_GUI_Show_Audio_Metadata()

		Case $ini_lastmodule = "3-5"
			_GUI_Show_Metadata()
			_GUI_Show_Graphics_Metadata()

		Case $ini_lastmodule = "3-6"
			_GUI_Show_Metadata()
			_GUI_Show_Prepare_Metadata()

		Case $ini_lastmodule = "4-1"
			_GUI_Show_Tools()
			_GUI_Tools_Fix()

		Case $ini_lastmodule = "4-2"
			_GUI_Show_Tools()
			_GUI_Tools_3D()

		Case $ini_lastmodule = "4-3"
			_GUI_Show_Tools()
			_GUI_Tools_Extract()

		Case $ini_lastmodule = "4-4"
			_GUI_Show_Tools()
			_GUI_Tools_Kodi()

		Case $ini_lastmodule = "4-7"
			_GUI_Show_Tools()
			_GUI_Tools_Stub()

		Case $ini_lastmodule = "4-8"
			_GUI_Show_Tools()
			_GUI_Tools_Audio()

		Case $ini_lastmodule = "5-1"
			_GUI_Show_Settings()
			_GUI_Settings_Program()

		Case $ini_lastmodule = "5-2"
			_GUI_Show_Settings()
			_GUI_Settings_Video()

		Case $ini_lastmodule = "5-3"
			_GUI_Show_Settings()
			_GUI_Settings_Metadata()

		Case $ini_lastmodule = "5-4"
			_GUI_Show_Settings()
			_GUI_Settings_Filenames()

		Case $ini_lastmodule = "5-6"
			_GUI_Show_Settings()
			_GUI_Settings_Audio()

		Case $ini_lastmodule = "5-7"
			_GUI_Show_Settings()
			_GUI_Settings_Graphics()

		Case $ini_lastmodule = "6-1"
			_GUI_Show_Corection()
			_GUI_Show_Series_Correction()

		Case $ini_lastmodule = "6-2"
			_GUI_Show_Corection()
			_GUI_Show_Movies_Correction()

		Case $ini_lastmodule = "6-3"
			_GUI_Show_Corection()
			_GUI_Show_Videos_Correction()

		Case $ini_lastmodule = "6-4"
			_GUI_Show_Corection()
			_GUI_Show_Audio_Correction()

	EndSelect

EndFunc

;Function to Generate Audio Folder
Func _Make_Audio_Folder($copy = 1, $InDir = GUICtrlRead($input_48_01), $OutDir = GUICtrlRead($input_48_02))

	Local $WorkArray, $sDrive, $sDir, $sFilename, $sExtension, $PathSplit, $File0, $nfo ,$vRow, $output1
	Local $Artist, $Year, $Album, $Disc, $Genre, $Track, $Title, $AlbumArtist, $Output, $Part, $TrackOut, $TrackOut1

	IniWrite(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_audiotools_inputfolder", GUICtrlRead($input_48_01))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_audiotools_outputfolder", GUICtrlRead($input_48_02))

	_WriteLog("Make_Audio_Folder - Start working on " & $InDir)

	If StringInStr("{AlbumArtist}\" & $ini_Music_FolderStructure, "Artist}\") < 1 Then

		MsgBox(16, "", $lng_noartist)

		_LastModule()

		Return

	EndIf

	$WorkArray = _FileListToArrayRec($InDir, $aextstring, 1, 1, 1)

	If Not IsArray($WorkArray) Then

		MsgBox(16, "", $lng_nofiles)

		_LastModule()

		Return

	EndIf

	For $i = 1 To $WorkArray[0]

		$PathSplit = _PathSplit($InDir & "\" & $WorkArray[$i], $sDrive, $sDir, $sFilename, $sExtension)

		$File = $PathSplit[1] & $PathSplit[2] & $PathSplit[3]

		_MediaInfoAudio($InDir & "\" & $WorkArray[$i])

		_SQLite_QuerySingleRow(-1,"SELECT * FROM Music LIMIT 1;",$vRow)

		$AlbumArtist = StringReplace($vRow[0], '/', '-')
		$Artist = StringReplace($vRow[1], '/', '-')
		$Year = $vRow[5]
		$Album = $vRow[2]
		$Track = StringFormat("%02s", $vRow[4])
		$Title = $vRow[3]
		$Genre = $vRow[6]
		$Part = $vRow[7]

		If StringInStr($String_VariousArtists, $AlbumArtist) <> 0 Then

			$AlbumArtist = "Various Artists"

		EndIf

		If $AlbumArtist = "none" Then  $AlbumArtist = $Artist

		If $AlbumArtist = "none" Then

			_WriteLog("Make_Audio_Folder - Warning: File " & $InDir & "\" & $WorkArray[$i] & " is not properly tagged and will not be processed")

		Else

			If $part > 0 Then

				$Output1 = StringReplace("{AlbumArtist}\" & $ini_Music_FolderStructure_MultipleDisc, "{AlbumArtist}", $AlbumArtist)

				$Output = StringReplace($Output1, "{Disc}", $ini_Music_Renaming_MultiDisc & " " & StringFormat("%02s", $vRow[7]))

			Else

				$Output = StringReplace("{AlbumArtist}\" & $ini_Music_FolderStructure, "{AlbumArtist}", $AlbumArtist)

			EndIf

			If StringInStr("{AlbumArtist}\" & $ini_Music_FolderStructure, "{AlbumArtist}") < 1 Then $Output = StringReplace("{AlbumArtist}\" & $ini_Music_FolderStructure, "{Artist}", $AlbumArtist)

			If $Year <> "0000" Then

				$Output1 = StringReplace($Output, "{Year}", $Year)

			Else

				$Output1 = StringReplace($Output, "{Year}", "1900")

			EndIf

			If $Album <> "none" Then

				$Output = StringReplace($Output1, "{Album}", $Album)

			Else

				$Output = StringReplace($Output1, "{Album}", "")

			EndIf

			If $Genre <> "none" Then

				$Output1 = StringReplace($Output, "{Genre}", $Genre)

			Else

				$Output1 = StringReplace($Output, "{Genre}", "")

			EndIf

			; Album Rename

			If StringInStr($String_VariousArtists, $AlbumArtist) <> 0 Then

				$TrackOut = StringReplace($ini_Music_Renaming_VariousArtists, "{Title}", $Title)

			Else

				$TrackOut = StringReplace($ini_Music_Renaming, "{Title}", $Title)

			EndIf

			$TrackOut1 = StringReplace($TrackOut, "{Track}", $Track)

			$TrackOut = StringReplace($TrackOut1, "{Artist}", $Artist)

			$TrackOut1 = StringReplace($TrackOut, "{Year}", $Year)

			$TrackOut = StringReplace($TrackOut1, "{Album}", $Album)

			$TrackOut1 = StringReplace($TrackOut, "{Genre}", $Genre)

			$Output = $OutDir & "\" & $Output1 & "\" & $TrackOut1 & $PathSplit[4]

				If $copy = 1 Then

					FileCopy($InDir & "\" & $WorkArray[$i], $Output, 9)

				Else

					FileMove($InDir & "\" & $WorkArray[$i], $Output, 9)

				EndIf



		EndIf

		If $ini_artist = "2" Then

			If $Artist = "none" Then

				_WriteLog("Make_Audio_Folder - Warning: File " & $InDir & "\" & $WorkArray[$i] & " is not properly tagged and will not be processed")

			Else

				DirCreate ($outDir & "\" & $Artist)

			EndIf

		EndIf

		_SetData($Label02, $lng_workingon & " " & $File)

	Next

	_WriteLog("Make_Audio_Folder - Finished working on " & $InDir)

	_SetData($Label02, $lng_waiting)

	Return

EndFunc

;Function to Generate Cover
Func _Make_Cover($InFile, $time)

	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_fanart_design", GUICtrlRead($combo_95_01))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_fanart_font", GUICtrlRead($combo_95_02))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_fanart_covertemplate", GUICtrlRead($combo_95_03))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_fanart_bordertemplate", GUICtrlRead($combo_95_05))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_fanart_bordercolor", GUICtrlRead($input_95_07))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_fanart_nocover", GUICtrlRead($check_95_01))

	$ini_fanart_font = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_fanart_font", "Comic-Sans-MS-Bold")
	$ini_fanart_design = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_fanart_design", "1-3")
	$ini_fanart_covertemplate = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_fanart_covertemplate", "---------")
	$ini_fanart_bordertemplate = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_fanart_bordertemplate", "---------")
	$ini_fanart_bordercolor = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_fanart_bordercolor", "IndianRed4")

	Local $path, $break, $option3, $width, $height, $aRow, $fOutput, $sDrive, $sDir, $sFilename, $sExtension, $vRow
	Local $split1, $minutes, $hour, $length, $per, $peri, $ss, $h, $per1, $p2, $p, $step1, $option2, $text, $save
	Local $backdroppath, $coverpath, $v, $seconds, $second, $t

	$path = _PathSplit($InFile, $sDrive, $sDir, $sFilename, $sExtension)

	$design = StringSplit($ini_fanart_design, "-")

	If $design[1] = 2 Then GUICtrlSetState($Cover_Combo_02, $GUI_ENABLE)
	If $design[1] = 1 Then GUICtrlSetState($Cover_Combo_02, $GUI_DISABLE)
	If $design[1] = 2 Then GUICtrlSetState($Cover_Combo_Label_02, $GUI_ENABLE)
	If $design[1] = 1 Then GUICtrlSetState($Cover_Combo_Label_02, $GUI_DISABLE)

	GUICtrlSetState($Cover_Combo_01, $GUI_HIDE)
	GUICtrlSetState($Cover_Combo_02, $GUI_HIDE)
	GUICtrlSetState($Cover_Combo_03, $GUI_HIDE)

	GUICtrlSetState($Cover_Combo_Label_01, $GUI_HIDE)
	GUICtrlSetState($Cover_Combo_Label_02, $GUI_HIDE)
	GUICtrlSetState($Cover_Combo_Label_03, $GUI_HIDE)

	GUICtrlSetState($Cover_Progress_01, $GUI_SHOW)

	_SetData($Cover_Progress_01, 0)

	$skip = _Mediainfo($InFile)

	If $skip = "skip" Then Return

	;Video Options

	_SQLite_QuerySingleRow(-1,"SELECT * FROM Video LIMIT 1;",$vRow)

	; Audio Options

	_SQLite_QuerySingleRow(-1,"SELECT * FROM Audio LIMIT 1;",$aRow)

	_SetData($Cover_Progress_01, 5)


	If $ini_fanart_bordertemplate = $lng_color Then

		$option2 = ' -mattecolor ' & $ini_fanart_bordercolor & ' -frame 10x10+5+5'

	EndIf

	If $ini_fanart_bordertemplate = $lng_random Then

		$option2 = ' -mattecolor #' & Hex(Random(0, 255, 1), 2) & Hex(Random(0, 255, 1), 2) & Hex(Random(0, 255, 1), 2) & ' -frame 10x10+5+5'

	EndIf

	If $ini_fanart_covertemplate = "---------" Then

		$h = GUICtrlRead($Cover_Combo_03)

		$option = '"' & $tempdir & '\fanart_' & $h & '.jpg" -resize 600x900^  -gravity center -extent 600x900 -normalize -blur 10x10 -depth 32 "' & $tempdir & '\cover_base.png"'

		ShellExecuteWait(@ScriptDir & '\convert.exe', $option, "", "", @SW_HIde)

		$covertemplate = $tempdir & "\cover_base.png"

	Else

		$covertemplate = @ScriptDir & "\Templates\Cover\" & $ini_fanart_covertemplate

	EndIf

	_SetData($Cover_Progress_01, 5)

	$a = GUICtrlRead($Cover_Combo_01)

	$option = '"' & $tempdir & '\fanart_' & $a & '.jpg" -resize 550x320^ -gravity center -extent 550x320 -normalize -unsharp 0x1' & $option2 & ' -depth 32 "' & $tempdir & '\CoverX_1.png"'

	ShellExecuteWait(@ScriptDir & '\convert.exe', $option, "", "", @SW_HIde)

	If FileExists(@ScriptDir & "\Templates\Border\" & $ini_fanart_bordertemplate) Then

		$option = '"' & @ScriptDir & '\Templates\Border\' & $ini_fanart_bordertemplate & '" -resize 550x320! -depth 32 "' &  $tempdir & '\CoverX_0.png"'

		ShellExecuteWait(@ScriptDir & '\convert.exe', $option, "", "", @SW_HIde)

		$option = '"' & $tempdir & '\CoverX_1.png" "' & $tempdir & '\CoverX_0.png" -compose src-over -composite -depth 32 "' & $tempdir & '\cover_X.png"'

		ShellExecuteWait(@ScriptDir & '\convert.exe', $option, "", "", @SW_HIde)

		FileMove($tempdir & '\cover_X.png', $tempdir & '\CoverX_1.png', 1)

	EndIf

	_SetData($Cover_Progress_01, 10)

	If $design[1] = 2 Then

		$b = GUICtrlRead($Cover_Combo_02)

		$option = '"' & $tempdir & '\fanart_' & $b & '.jpg" -resize 550x320^ -gravity center -extent 550x320 -normalize -unsharp 0x1' & $option2 & ' -depth 32 "' & $tempdir & '\CoverX_2.png"'

		ShellExecuteWait(@ScriptDir & '\convert.exe', $option, "", "", @SW_HIde)

		If FileExists(@ScriptDir & "\Templates\Border\" & $ini_fanart_bordertemplate) Then

			$option = '"' & $tempdir & '\CoverX_2.png" "' & $tempdir & '\CoverX_0.png" -compose src-over -composite -depth 32 "' & $tempdir & '\cover_X.png"'

			ShellExecuteWait(@ScriptDir & '\convert.exe', $option, "", "", @SW_HIde)

			FileMove($tempdir & '\cover_X.png', $tempdir & '\coverX_2.png', 1)

		EndIf

	EndIf

	$option = '-background none -fill snow2 -font "' & $ini_fanart_font & '" -size 580x105 -gravity center -stroke black -strokewidth 1 caption:"' & $path[3] & '" -depth 32 "' & $tempdir & '\cover_T.png"'

	ShellExecuteWait(@ScriptDir & '\convert.exe', $option, "", "", @SW_HIde)

	If FileExists(@ScriptDir & "\Templates\Logos\" & $vRow[2] & ".png") Then

		$codec = '"' & @ScriptDir & "\Templates\Logos\" & $vRow[2] & '.png"'

	Else

		$codec = '"' & @ScriptDir & '\Templates\Logos\unknown.png"'

	EndIf

	_SetData($Cover_Progress_01, 20)

	If $vRow[7] < 3.2 And $vRow[7] > 1.5 Then

		$ratio = '"' & @ScriptDir & '\Templates\Logos\16_9.png"'

		$v = "16:9"

	ElseIf $vRow[7] <= 1.5 Then

		$ratio = '"' & @ScriptDir & '\Templates\Logos\4_3.png"'

		$v = "4:3"

	Else

		$ratio = '"' & @ScriptDir & '\Templates\Logos\unknown.png"'

		$v = "21:9"

	EndIf

	If FileExists(@ScriptDir & "\Templates\Logos\" & $aRow[2] & ".png") Then

		$acodec = '"' & @ScriptDir & "\Templates\Logos\" & $aRow[2] & '.png"'

	Else

		$acodec = '"' & @ScriptDir & '\Templates\Logos\unknown.png"'

	EndIf

	If FileExists(@ScriptDir & "\Templates\Logos\" & $aRow[4] & " channels.png") Then

		$channels = '"' & @ScriptDir & '\Templates\Logos\' & $aRow[4] & ' channels.png"'

	Else

		$channels = '"' & @ScriptDir & '\Templates\Logos\unknown.png"'

	EndIf

	If FileExists(@ScriptDir & '\Templates\Logos\' & $aRow[5] & ".png") Then

		$language = '"' & @ScriptDir & '\Templates\Logos\' & $aRow[5] & '.png"'

	Else

		$language = '"' & @ScriptDir & '\Templates\Logos\unknown.png"'

	EndIf

	$option = $codec & ' -background none -gravity center -extent 122x96 -matte -bordercolor none -depth 32 "' & $tempdir & '\codec.png"'

	ShellExecuteWait(@ScriptDir & '\convert.exe', $option, "", "", @SW_HIde)

	_SetData($Cover_Progress_01, 30)

	$option = $ratio & ' -background none -gravity center -extent 364x96 -matte -bordercolor none -depth 32 "' & $tempdir & '\ratio.png"'

	ShellExecuteWait(@ScriptDir & '\convert.exe', $option, "", "", @SW_HIde)

	_SetData($Cover_Progress_01, 35)

	$option = $language & ' -background none -gravity center -extent 122x96 -matte -bordercolor none -depth 32 "' & $tempdir & '\language.png"'

	ShellExecuteWait(@ScriptDir & '\convert.exe', $option, "", "", @SW_HIde)

	_SetData($Cover_Progress_01, 45)

	$option = $channels & ' -background none -gravity center -extent 364x96 -matte -bordercolor none -depth 32 "' & $tempdir & '\channels.png"'

	ShellExecuteWait(@ScriptDir & '\convert.exe', $option, "", "", @SW_HIde)

	_SetData($Cover_Progress_01, 55)

	$option = $acodec & ' -background none -gravity center -extent 122x96 -matte -bordercolor none -depth 32 "' & $tempdir & '\acodec.png"'

	ShellExecuteWait(@ScriptDir & '\convert.exe', $option, "", "", @SW_HIde)

	_SetData($Cover_Progress_01, 65)

	$text = $time &  " - " & $vRow[5] & "x" &  $vRow[6] &  " - " & $vRow[8] & " fps" &  " - " & StringLeft($vRow[10],4)

	$option = '-background none -fill snow2 -font "' & $ini_fanart_font & '" -size 580x40 -gravity Center -stroke black -strokewidth 1 caption:"' & $text & '" -matte -bordercolor none -border 80 -depth 32 "' & $tempdir & '\cover_T2.png"'

	ShellExecuteWait(@ScriptDir & '\convert.exe', $option, "", "", @SW_HIde)

	_SetData($Cover_Progress_01, 75)

	If $design[1] = 1 Then

		$option = '"' & $tempdir & '\CoverX_1.png" -resize 550x320^  -gravity center -extent 550x320 -background #ff000000  -matte -bordercolor none -border 180 -depth 32 "' & $tempdir & '\CoverX_1.png"'

		ShellExecuteWait(@ScriptDir & '\convert.exe', $option, "", "", @SW_HIde)

	_SetData($Cover_Progress_01, 80)

		$option = '"' & $covertemplate & '" "' & $tempdir & '\CoverX_1.png" -gravity North -composite "' & $tempdir & '\Cover_T.png" -gravity North -composite "' & $tempdir & '\Cover_T2.png" -gravity South -composite -depth 32 "'& $tempdir & '\cover_X.png"'

		ShellExecuteWait(@ScriptDir & '\convert.exe', $option, "", "", @SW_HIde)

	_SetData($Cover_Progress_01, 85)

		$save = $path[1] & $path[2] & StringReplace($ini_fanart_cover, "{movie}",$path[3])

		$coverpath = $save

		$option = '"' & $tempdir & '\cover_X.png" "' & $tempdir & '\codec.png" -gravity Southwest -composite "' & $tempdir & '\ratio.png" -gravity Southwest -composite "' & $tempdir & '\acodec.png" -gravity Southeast -composite "' & $tempdir & '\channels.png" -gravity Southeast -composite "' & $tempdir & '\language.png" -gravity South -composite -depth 32 "' & $save & '"'

		ShellExecuteWait(@ScriptDir & '\convert.exe', $option, "", "", @SW_HIde)

	_SetData($Cover_Progress_01, 90)

	EndIf

	_SetData($Cover_Progress_01, 100)

	If $design[1] = 2 Then

		$option = '"' & $tempdir & '\CoverX_1.png" -resize 550x320^  -gravity center -extent 550x320 -background #ff000000  -matte -bordercolor none -border 102 -depth 32 "' & $tempdir & '\CoverX_1.png"'

		ShellExecuteWait(@ScriptDir & '\convert.exe', $option, "", "", @SW_HIde)

		$option = '"' & $tempdir & '\CoverX_2.png" -resize 550x320^  -gravity center -extent 550x320 -background #ff000000  -matte -bordercolor none -border 105 -depth 32 "' & $tempdir & '\CoverX_2.png"'

		ShellExecuteWait(@ScriptDir & '\convert.exe', $option, "", "", @SW_HIde)

		$option = '"' & $covertemplate & '" "' & $tempdir & '\CoverX_1.png" -gravity North -composite "' & $tempdir & '\CoverX_2.png" -gravity South -composite "' & $tempdir & '\Cover_T.png" -gravity North -composite "' & $tempdir & '\Cover_T2.png" -gravity Center -composite -depth 32 "'& $tempdir & '\cover_X.png"'

		ShellExecuteWait(@ScriptDir & '\convert.exe', $option, "", "", @SW_HIde)

		$save = $path[1] & $path[2] & StringReplace($ini_fanart_cover, "{movie}",$path[3])

		$coverpath = $save

		$option = '"' & $tempdir & '\cover_X.png" "' & $tempdir & '\codec.png" -gravity Southwest -composite "' & $tempdir & '\ratio.png" -gravity Southeast -composite "' & $tempdir & '\acodec.png" -gravity Southeast -composite "' & $tempdir & '\channels.png" -gravity Southwest -composite  "' & $tempdir & '\language.png" -gravity South -composite -depth 32 "' & $save & '"'

		ShellExecuteWait(@ScriptDir & '\convert.exe', $option, "", "", @SW_HIde)

	EndIf

	_Optimize_Graphics_File($save)

	GUICtrlSetState($Cover_Combo_01, $GUI_SHOW)
	GUICtrlSetState($Cover_Combo_02, $GUI_SHOW)
	GUICtrlSetState($Cover_Combo_03, $GUI_SHOW)

	GUICtrlSetState($Cover_Combo_Label_01, $GUI_SHOW)
	GUICtrlSetState($Cover_Combo_Label_02, $GUI_SHOW)
	GUICtrlSetState($Cover_Combo_Label_03, $GUI_SHOW)

	GUICtrlSetState($Cover_Progress_01, $GUI_HIDE)

	Return

EndFunc

;Function to Generate Fanart
Func _MakeFanart($InFile, $InDir, $progressbar = "0000", $progressbar2 = "0000", $count = 1, $i_global = 1)

	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_fanart_design", GUICtrlRead($combo_95_01))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_fanart_font", GUICtrlRead($combo_95_02))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_fanart_covertemplate", GUICtrlRead($combo_95_03))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_fanart_backdroptemplate", GUICtrlRead($combo_95_04))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_fanart_bordertemplate", GUICtrlRead($combo_95_05))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_fanart_bordercolor", GUICtrlRead($input_95_07))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_fanart_nocover", GUICtrlRead($check_95_01))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_fanart_nobackdrop", GUICtrlRead($check_95_02))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_fanart_nonfo", GUICtrlRead($check_95_03))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_fanart_genrefolder", GUICtrlRead($check_95_04))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_fanart_mediainfo", GUICtrlRead($check_95_05))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_fanart_plot", GUICtrlRead($edit_95_01))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_fanart_genre", GUICtrlRead($input_95_08))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_fanart_background", GUICtrlRead($input_54_07))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_fanart_cover", GUICtrlRead($input_54_08))

	$ini_fanart_font = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_fanart_font", "Comic-Sans-MS-Bold")
	$ini_fanart_design = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_fanart_design", "1-3")
	$ini_fanart_covertemplate = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_fanart_covertemplate", "---------")
	$ini_fanart_backgroundtemplate = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_fanart_backdroptemplate", "---------")
	$ini_fanart_bordertemplate = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_fanart_bordertemplate", "---------")
	$ini_fanart_bordercolor = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_fanart_bordercolor", "IndianRed4")
	$ini_fanart_nocover = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_fanart_nocover", "4")
	$ini_fanart_nobackdrop = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_fanart_nobackdrop", "4")
	$ini_fanart_nonfo = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_fanart_nonfo", "4")
	$ini_fanart_genrefolder = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_fanart_genrefolder", "1")
	$ini_fanart_mediainfo = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_fanart_mediainfo", "1")
	$ini_fanart_plot = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_fanart_plot", "")
	$ini_fanart_genre = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_fanart_genre", "")

	Local $path, $break, $option3, $width, $height, $aRow, $fOutput, $sDrive, $sDir, $sFilename, $sExtension, $vRow
	Local $split1, $minutes, $hour, $length, $per, $peri, $ss, $h, $per1, $p2, $p, $step1, $option2, $text, $save
	Local $backdroppath, $coverpath, $time, $v, $seconds, $second, $t

	Dim $index[0]

	_WriteLog("Make_Fanart - Start working on " & $InFile)

	$progressbar = "0000"

	$progressbar2 = "0000"

	$path = _PathSplit($InFile, $sDrive, $sDir, $sFilename, $sExtension)

	$skip = _Mediainfo($InFile)

	If $skip = "skip" Then Return

	;Video Options

	_SQLite_QuerySingleRow(-1,"SELECT * FROM Video LIMIT 1;",$vRow)

	; Audio Options

	_SQLite_QuerySingleRow(-1,"SELECT * FROM Audio LIMIT 1;",$aRow)

	$design = StringSplit($ini_fanart_design, "-")

	$t = Random(10, 20 , 1)

	If $t > 0 Then

		$length = $vRow[3] / 1000

		$hour = Floor($length / 3600)

		$minutes = Floor($length / 60) - ($hour * 60)

		$second = Round($length - ($minutes * 60) - ($hour * 3600))

		$time = StringFormat("%02s", $hour) & ':' & StringFormat("%02s", $minutes)

		$peri = Round($length / ($t + 1))

		For $i = 1 to $t

			_ArrayAdd($index, $i)

			$per = $peri * $i

			$hour = Floor($per / 3600)

			$minutes = Floor($per / 60) - ($hour * 60)

			$second = $per - ($minutes * 60) - ($hour * 3600)

			$ss = ' -ss ' & StringFormat("%02s", $hour) & ':' & StringFormat("%02s", $minutes) & ':' & StringFormat("%02s", $second) & '.000'

			$option = $ss & ' -i "' & $InFile & '" -y -frames:v 1 "' & $tempdir & '\fanart_' & $i & '.jpg"'

			ShellExecuteWait($ini_ffmpeg_path, $option, "", "", @SW_HIde)

			_SetLabel($Label02, $lng_workingon  & " - " & $path[3] & "   " & $lng_makestills & " " & StringFormat("%02s", $i))

			$step1 = 100 / $Count

			$p2 = Round((($i-1) /  $t) * 33 )

			$p = ($step1 * ($i_global - 1)) + Round($p2 / $Count)

			_SetData($progressbar2, $p)

			_SetData($progressbar, $p2)

		Next

		_WriteLog("Make_Fanart - Image Creation ready")

		_SetLabel($Label02, $lng_workingon  & " - " & $path[3] & "   " & $lng_makecover)

		$step1 = 100 / $Count

		$p = ($step1 * ($i_global - 1)) + Round(60 / $Count)

		_SetData($progressbar2, $p)

		_SetData($progressbar, 32)

		If $ini_fanart_bordertemplate = $lng_color Then

			$option2 = ' -mattecolor ' & $ini_fanart_bordercolor & ' -frame 10x10+5+5'

		EndIf

		If $ini_fanart_bordertemplate = $lng_random Then

			$option2 = ' -mattecolor #' & Hex(Random(0, 255, 1), 2) & Hex(Random(0, 255, 1), 2) & Hex(Random(0, 255, 1), 2) & ' -frame 10x10+5+5'

		EndIf

		If $ini_fanart_nocover <> 1 Then

			If $ini_fanart_covertemplate = "---------" Then

				$a = Random(0, UBound($index) - 1 , 1)

				$option = '"' & $tempdir & '\fanart_' & $index[$a] & '.jpg" -resize 600x900^  -gravity center -extent 600x900 -normalize -blur 10x10 -depth 32 "' & $tempdir & '\cover_base.png"'

				ShellExecuteWait(@ScriptDir & '\convert.exe', $option, "", "", @SW_HIde)

				$covertemplate = $tempdir & "\cover_base.png"

				_ArrayDelete($index,$a)

			Else

				$covertemplate = @ScriptDir & "\Templates\Cover\" & $ini_fanart_covertemplate

			EndIf

			$a = Random(0, UBound($index) - 1 , 1)

			$option = '"' & $tempdir & '\fanart_' & $index[$a] & '.jpg" -resize 550x320^ -gravity center -extent 550x320 -normalize -unsharp 0x1' & $option2 & ' -depth 32 "' & $tempdir & '\CoverX_1.png"'

			ShellExecuteWait(@ScriptDir & '\convert.exe', $option, "", "", @SW_HIde)

			If FileExists(@ScriptDir & "\Templates\Border\" & $ini_fanart_bordertemplate) Then

				$option = '"' & @ScriptDir & '\Templates\Border\' & $ini_fanart_bordertemplate & '" -resize 550x320! -depth 32 "' &  $tempdir & '\CoverX_0.png"'

				ShellExecuteWait(@ScriptDir & '\convert.exe', $option, "", "", @SW_HIde)

				$option = '"' & $tempdir & '\CoverX_1.png" "' & $tempdir & '\CoverX_0.png" -compose src-over -composite -depth 32 "' & $tempdir & '\cover_X.png"'

				ShellExecuteWait(@ScriptDir & '\convert.exe', $option, "", "", @SW_HIde)

				FileMove($tempdir & '\cover_X.png', $tempdir & '\CoverX_1.png', 1)

			EndIf

			_ArrayDelete($index,$a)

			If $design[1] = 2 Then

				$a = Random(0, UBound($index) - 1 , 1)

				$option = '"' & $tempdir & '\fanart_' & $index[$a] & '.jpg" -resize 550x320^ -gravity center -extent 550x320 -normalize -unsharp 0x1' & $option2 & ' -depth 32 "' & $tempdir & '\CoverX_2.png"'

				ShellExecuteWait(@ScriptDir & '\convert.exe', $option, "", "", @SW_HIde)

				If FileExists(@ScriptDir & "\Templates\Border\" & $ini_fanart_bordertemplate) Then

					$option = '"' & $tempdir & '\CoverX_2.png" "' & $tempdir & '\CoverX_0.png" -compose src-over -composite -depth 32 "' & $tempdir & '\cover_X.png"'

					ShellExecuteWait(@ScriptDir & '\convert.exe', $option, "", "", @SW_HIde)

					FileMove($tempdir & '\cover_X.png', $tempdir & '\coverX_2.png', 1)

				EndIf

				_ArrayDelete($index,$a)

			EndIf

			$option = '-background none -fill snow2 -font "' & $ini_fanart_font & '" -size 580x105 -gravity center -stroke black -strokewidth 1 caption:"' & $path[3] & '" -depth 32 "' & $tempdir & '\cover_T.png"'

			ShellExecuteWait(@ScriptDir & '\convert.exe', $option, "", "", @SW_HIde)

			_SetData($progressbar, 35)

			If FileExists(@ScriptDir & "\Templates\Logos\" & $vRow[2] & ".png") Then

				$codec = '"' & @ScriptDir & "\Templates\Logos\" & $vRow[2] & '.png"'

			Else

				$codec = '"' & @ScriptDir & '\Templates\Logos\unknown.png"'

			EndIf

			If $vRow[7] < 3.2 And $vRow[7] > 1.5 Then

				$ratio = '"' & @ScriptDir & '\Templates\Logos\16_9.png"'

				$v = "16:9"

			ElseIf $vRow[7] <= 1.5 Then

				$ratio = '"' & @ScriptDir & '\Templates\Logos\4_3.png"'

				$v = "4:3"

			Else

				$ratio = '"' & @ScriptDir & '\Templates\Logos\unknown.png"'

				$v = "21:9"

			EndIf

			If FileExists(@ScriptDir & "\Templates\Logos\" & $aRow[2] & ".png") Then

				$acodec = '"' & @ScriptDir & "\Templates\Logos\" & $aRow[2] & '.png"'

			Else

				$acodec = '"' & @ScriptDir & '\Templates\Logos\unknown.png"'

			EndIf

			If FileExists(@ScriptDir & "\Templates\Logos\" & $aRow[4] & " channels.png") Then

				$channels = '"' & @ScriptDir & '\Templates\Logos\' & $aRow[4] & ' channels.png"'

			Else

				$channels = '"' & @ScriptDir & '\Templates\Logos\unknown.png"'

			EndIf

			If FileExists(@ScriptDir & '\Templates\Logos\' & $aRow[5] & ".png") Then

				$language = '"' & @ScriptDir & '\Templates\Logos\' & $aRow[5] & '.png"'

			Else

				$language = '"' & @ScriptDir & '\Templates\Logos\unknown.png"'

			EndIf

 			$option = $codec & ' -background none -gravity center -extent 122x96 -matte -bordercolor none -depth 32 "' & $tempdir & '\codec.png"'

			ShellExecuteWait(@ScriptDir & '\convert.exe', $option, "", "", @SW_HIde)

			_SetData($progressbar, 38)

			$option = $ratio & ' -background none -gravity center -extent 364x96 -matte -bordercolor none -depth 32 "' & $tempdir & '\ratio.png"'

			ShellExecuteWait(@ScriptDir & '\convert.exe', $option, "", "", @SW_HIde)

			_SetData($progressbar, 40)

			$option = $language & ' -background none -gravity center -extent 122x96 -matte -bordercolor none -depth 32 "' & $tempdir & '\language.png"'

			ShellExecuteWait(@ScriptDir & '\convert.exe', $option, "", "", @SW_HIde)

			_SetData($progressbar, 42)

			$option = $channels & ' -background none -gravity center -extent 364x96 -matte -bordercolor none -depth 32 "' & $tempdir & '\channels.png"'

			ShellExecuteWait(@ScriptDir & '\convert.exe', $option, "", "", @SW_HIde)

			$option = $acodec & ' -background none -gravity center -extent 122x96 -matte -bordercolor none -depth 32 "' & $tempdir & '\acodec.png"'

			ShellExecuteWait(@ScriptDir & '\convert.exe', $option, "", "", @SW_HIde)

			$text = $time &  " - " & $vRow[5] & "x" &  $vRow[6] &  " - " & $vRow[8] & " fps" &  " - " & StringLeft($vRow[10],4)

			_SetData($progressbar, 44)

			$option = '-background none -fill snow2 -font "' & $ini_fanart_font & '" -size 580x40 -gravity Center -stroke black -strokewidth 1 caption:"' & $text & '" -matte -bordercolor none -border 80 -depth 32 "' & $tempdir & '\cover_T2.png"'

			ShellExecuteWait(@ScriptDir & '\convert.exe', $option, "", "", @SW_HIde)

			_SetData($progressbar, 46)

			If $design[1] = 1 Then

				$option = '"' & $tempdir & '\CoverX_1.png" -resize 550x320^  -gravity center -extent 550x320 -background #ff000000  -matte -bordercolor none -border 180 -depth 32 "' & $tempdir & '\CoverX_1.png"'

				ShellExecuteWait(@ScriptDir & '\convert.exe', $option, "", "", @SW_HIde)

				_SetData($progressbar, 50)

				$option = '"' & $covertemplate & '" "' & $tempdir & '\CoverX_1.png" -gravity North -composite "' & $tempdir & '\Cover_T.png" -gravity North -composite "' & $tempdir & '\Cover_T2.png" -gravity South -composite -depth 32 "'& $tempdir & '\cover_X.png"'

				ShellExecuteWait(@ScriptDir & '\convert.exe', $option, "", "", @SW_HIde)

				_SetData($progressbar, 54)

				$save = $path[1] & $path[2] & StringReplace($ini_fanart_cover, "{movie}",$path[3])

				$coverpath = $save

				$option = '"' & $tempdir & '\cover_X.png" "' & $tempdir & '\codec.png" -gravity Southwest -composite "' & $tempdir & '\ratio.png" -gravity Southwest -composite "' & $tempdir & '\acodec.png" -gravity Southeast -composite "' & $tempdir & '\channels.png" -gravity Southeast -composite "' & $tempdir & '\language.png" -gravity South -composite -depth 32 "' & $save & '"'

				ShellExecuteWait(@ScriptDir & '\convert.exe', $option, "", "", @SW_HIde)

				_SetData($progressbar, 58)

			EndIf

			If $design[1] = 2 Then

				$option = '"' & $tempdir & '\CoverX_1.png" -resize 550x320^  -gravity center -extent 550x320 -background #ff000000  -matte -bordercolor none -border 102 -depth 32 "' & $tempdir & '\CoverX_1.png"'

				ShellExecuteWait(@ScriptDir & '\convert.exe', $option, "", "", @SW_HIde)

				_SetData($progressbar, 48)

				$option = '"' & $tempdir & '\CoverX_2.png" -resize 550x320^  -gravity center -extent 550x320 -background #ff000000  -matte -bordercolor none -border 105 -depth 32 "' & $tempdir & '\CoverX_2.png"'

				ShellExecuteWait(@ScriptDir & '\convert.exe', $option, "", "", @SW_HIde)

				_SetData($progressbar, 51)

				$option = '"' & $covertemplate & '" "' & $tempdir & '\CoverX_1.png" -gravity North -composite "' & $tempdir & '\CoverX_2.png" -gravity South -composite "' & $tempdir & '\Cover_T.png" -gravity North -composite "' & $tempdir & '\Cover_T2.png" -gravity Center -composite -depth 32 "'& $tempdir & '\cover_X.png"'

				ShellExecuteWait(@ScriptDir & '\convert.exe', $option, "", "", @SW_HIde)

				_SetData($progressbar, 54)

				$save = $path[1] & $path[2] & StringReplace($ini_fanart_cover, "{movie}",$path[3])

				$coverpath = $save

				$option = '"' & $tempdir & '\cover_X.png" "' & $tempdir & '\codec.png" -gravity Southwest -composite "' & $tempdir & '\ratio.png" -gravity Southeast -composite "' & $tempdir & '\acodec.png" -gravity Southeast -composite "' & $tempdir & '\channels.png" -gravity Southwest -composite  "' & $tempdir & '\language.png" -gravity South -composite -depth 32 "' & $save & '"'

				ShellExecuteWait(@ScriptDir & '\convert.exe', $option, "", "", @SW_HIde)

				_SetData($progressbar, 57)

			EndIf

			_Optimize_Graphics_File($save)

		EndIf

		$step1 = 100 / $Count

		$p = ($step1 * ($i_global - 1)) + Round(90 / $Count)

		_SetData($progressbar2, $p)

		_SetLabel($Label02, $lng_workingon  & " - " & $path[3] & "   " & $lng_makebackdrop)

		If $ini_fanart_nobackdrop <> 1 Then

			If $ini_fanart_backgroundtemplate = "---------" Then

				$a = Random(0, UBound($index) - 1 , 1)

				$option = '"' & $tempdir & '\fanart_' & $index[$a] & '.jpg" -resize 1920x1080^  -gravity center -extent 1920x1080 -normalize -blur 10x10 -depth 32 "' & $tempdir & '\backdrop_base.png"'

				ShellExecuteWait(@ScriptDir & '\convert.exe', $option, "", "", @SW_HIde)

				$backdroptemplate = $tempdir & "\backdrop_base.png"

				_ArrayDelete($index,$a)

			Else

				$backdroptemplate = @ScriptDir & "\Templates\Backdrop\" & $ini_fanart_backgroundtemplate

			EndIf

			_SetData($progressbar, 65)

			For $i = 1 To UBound($index)

			$a = Random(0, UBound($index) - 1 , 1)

			$option = '"' & $tempdir & '\fanart_' & $index[$a] & '.jpg" -resize 700x400^ -gravity center -extent 700x400 -normalize -unsharp 0x1' & $option2 & ' -depth 32 "' & $tempdir & '\backdropX_' & $i & '.png"'

			ShellExecuteWait(@ScriptDir & '\convert.exe', $option, "", "", @SW_HIde)

			_SetData($progressbar, 67)

			If FileExists(@ScriptDir & "\Templates\Border\" & $ini_fanart_bordertemplate) Then

				$option = '"' & @ScriptDir & '\Templates\Border\' & $ini_fanart_bordertemplate & '" -resize 700x400! -depth 32 "' &  $tempdir & '\backdropX_0.png"'

				ShellExecuteWait(@ScriptDir & '\convert.exe', $option, "", "", @SW_HIde)

				$option = '"' & $tempdir & '\backdropX_' & $i & '.png" "' & $tempdir & '\backdropX_0.png" -compose src-over -composite -depth 32 "' & $tempdir & '\backdrop_X.png"'

				ShellExecuteWait(@ScriptDir & '\convert.exe', $option, "", "", @SW_HIde)

				Sleep(200)

				FileMove($tempdir & '\backdrop_X.png', $tempdir & '\backdropX_' & $i & '.png', 1)

			EndIf

			_ArrayDelete($index,$a)

			Next

			If $design[2] = 2 Then

				$option = '"' & $tempdir & '\backdropX_1.png" -resize 750 -gravity center -extent 750 -background #ff000000 -rotate 5 -matte -bordercolor none -border 70x200 -depth 32 "' & $tempdir & '\backdropX_1.png"'

				ShellExecuteWait(@ScriptDir & '\convert.exe', $option, "", "", @SW_HIde)

				_SetData($progressbar, 80)

				$option = '"' & $tempdir & '\backdropX_2.png" -resize 750 -gravity center -extent 750 -background #ff000000 -rotate 355 -matte -bordercolor none -border 70x200 -depth 32 "' & $tempdir & '\backdropX_2.png"'

				ShellExecuteWait(@ScriptDir & '\convert.exe', $option, "", "", @SW_HIde)

				_SetData($progressbar, 85)

				$save = $path[1] & $path[2] & StringReplace($ini_fanart_background, "{movie}",$path[3])

				$backdroppath = $save

				$option = '"' & $backdroptemplate & '" "' & $tempdir & '\backdropX_1.png" -gravity SouthWest -composite "' & $tempdir & '\backdropX_2.png" -gravity SouthEast -composite -depth 32 "' & $save & '"'

				ShellExecuteWait(@ScriptDir & '\convert.exe', $option, "", "", @SW_HIde)

				_SetData($progressbar, 90)

			EndIf

			If $design[2] = 3 Then

				$option = '"' & $tempdir & '\backdropX_1.png" -resize 750 -gravity center -extent 750 -background #ff000000 -rotate 3 -matte -bordercolor none -border 140x40 "' & $tempdir & '\backdropX_1.png"'

				ShellExecuteWait(@ScriptDir & '\convert.exe', $option, "", "", @SW_HIde)

				_SetData($progressbar, 78)

				$option = '"' & $tempdir & '\backdropX_2.png" -resize 750 -gravity center -extent 750 -background #ff000000 -rotate 357 -matte -bordercolor none -border 140x40 "' & $tempdir & '\backdropX_2.png"'

				ShellExecuteWait(@ScriptDir & '\convert.exe', $option, "", "", @SW_HIde)

				_SetData($progressbar, 83)

				$option = '"' & $tempdir & '\backdropX_3.png" -resize 750 -gravity center -extent 750 -background #ff000000 -matte -bordercolor none -border 40 "' & $tempdir & '\backdropX_3.png"'

				ShellExecuteWait(@ScriptDir & '\convert.exe', $option, "", "", @SW_HIde)

				_SetData($progressbar, 87)

				$save = $path[1] & $path[2] & StringReplace($ini_fanart_background, "{movie}",$path[3])

				$backdroppath = $save

				$option = '"' & $backdroptemplate & '" "' & $tempdir & '\backdropX_1.png" -gravity SouthWest -composite "' & $tempdir & '\backdropX_2.png" -gravity SouthEast -composite "' & $tempdir & '\backdropX_3.png" -gravity North -composite "' & $save & '"'

				ShellExecuteWait(@ScriptDir & '\convert.exe', $option, "", "", @SW_HIde)

				_SetData($progressbar, 90)

			EndIf

			If $design[2] = 4 Then

				$option = '"' & $tempdir & '\backdropX_1.png" -resize 500 -gravity center -extent 500 -background #ff000000 -rotate 357 -matte -bordercolor none -border 450x30 "' & $tempdir & '\backdropX_1.png"'

				ShellExecuteWait(@ScriptDir & '\convert.exe', $option, "", "", @SW_HIde)

				_SetData($progressbar, 79)

				$option = '"' & $tempdir & '\backdropX_2.png" -resize 500 -gravity center -extent 500 -background #ff000000 -rotate 5 -matte -bordercolor none -border 445x30 "' & $tempdir & '\backdropX_2.png"'

				ShellExecuteWait(@ScriptDir & '\convert.exe', $option, "", "", @SW_HIde)

				_SetData($progressbar, 82)

				$option = '"' & $tempdir & '\backdropX_3.png" -resize 500 -gravity center -extent 500 -background #ff000000 -rotate 30 -matte -bordercolor none -border 140x290 "' & $tempdir & '\backdropX_3.png"'

				ShellExecuteWait(@ScriptDir & '\convert.exe', $option, "", "", @SW_HIde)

				_SetData($progressbar, 85)

				$option = '"' & $tempdir & '\backdropX_4.png" -resize 500 -gravity center -extent 500 -background #ff000000 -rotate 300 -matte -bordercolor none -border 140x260 "' & $tempdir & '\backdropX_4.png"'

				ShellExecuteWait(@ScriptDir & '\convert.exe', $option, "", "", @SW_HIde)

				_SetData($progressbar, 88)

				$save = $path[1] & $path[2] & StringReplace($ini_fanart_background, "{movie}",$path[3])

				$backdroppath = $save

				$option = '"' & $backdroptemplate & '" "' & $tempdir & '\backdropX_4.png" -gravity NorthEast -composite "' & $tempdir & '\backdropX_3.png" -gravity SouthWest -composite "' & $tempdir & '\backdropX_2.png" -gravity SouthEast -composite "' & $tempdir & '\backdropX_1.png" -gravity SouthWest -composite "' & $save & '"'

				ShellExecuteWait(@ScriptDir & '\convert.exe', $option, "", "", @SW_HIde)

				_SetData($progressbar, 90)

			EndIf

			If $design[2] = 5 Then

				$option = '"' & $tempdir & '\backdropX_1.png" -resize 500 -gravity center -extent 500 -background #ff000000 -rotate 348 -matte -bordercolor none -border 200x30 "' & $tempdir & '\backdropX_1.png"'

				ShellExecuteWait(@ScriptDir & '\convert.exe', $option, "", "", @SW_HIde)

				_SetData($progressbar, 79)

				$option = '"' & $tempdir & '\backdropX_2.png" -resize 500 -gravity center -extent 500 -background #ff000000 -rotate 10 -matte -bordercolor none -border 195x30 "' & $tempdir & '\backdropX_2.png"'

				ShellExecuteWait(@ScriptDir & '\convert.exe', $option, "", "", @SW_HIde)

				_SetData($progressbar, 81)

				$option = '"' & $tempdir & '\backdropX_3.png" -resize 500 -gravity center -extent 500 -background #ff000000 -rotate 10 -matte -bordercolor none -border 140x350 "' & $tempdir & '\backdropX_3.png"'

				ShellExecuteWait(@ScriptDir & '\convert.exe', $option, "", "", @SW_HIde)

				_SetData($progressbar, 83)

				$option = '"' & $tempdir & '\backdropX_4.png" -resize 500 -gravity center -extent 500 -background #ff000000 -rotate 300 -matte -bordercolor none -border 140x240 "' & $tempdir & '\backdropX_4.png"'

				ShellExecuteWait(@ScriptDir & '\convert.exe', $option, "", "", @SW_HIde)

				_SetData($progressbar, 86)

				$option = '"' & $tempdir & '\backdropX_5.png" -resize 500 -gravity center -extent 500 -background #ff000000 -matte -bordercolor none -border 30 "' & $tempdir & '\backdropX_5.png"'

				ShellExecuteWait(@ScriptDir & '\convert.exe', $option, "", "", @SW_HIde)

				_SetData($progressbar, 88)

				$save = $path[1] & $path[2] & StringReplace($ini_fanart_background, "{movie}",$path[3])

				$backdroppath = $save

				$option = '"' & $backdroptemplate & '" "' & $tempdir & '\backdropX_4.png" -gravity NorthEast -composite "' & $tempdir & '\backdropX_2.png" -gravity SouthEast -composite "' & $tempdir & '\backdropX_5.png" -gravity South -composite "' & $tempdir & '\backdropX_1.png" -gravity SouthWest -composite "' & $tempdir & '\backdropX_3.png" -gravity NorthWest -composite "' & $save & '"'

				ShellExecuteWait(@ScriptDir & '\convert.exe', $option, "", "", @SW_HIde)

				_SetData($progressbar, 90)

			EndIf

			If $design[2] = 6 Then

				$option = '"' & $tempdir & '\backdropX_1.png" -resize 500 -gravity center -extent 500 -background #ff000000 -rotate 348 -matte -bordercolor none -border 200x30 -depth 32 "' & $tempdir & '\backdropX_1.png"'

				ShellExecuteWait(@ScriptDir & '\convert.exe', $option, "", "", @SW_HIde)

				_SetData($progressbar, 78)

				$option = '"' & $tempdir & '\backdropX_2.png" -resize 500 -gravity center -extent 500 -background #ff000000 -rotate 10 -matte -bordercolor none -border 195x30 -depth 32 "' & $tempdir & '\backdropX_2.png"'

				ShellExecuteWait(@ScriptDir & '\convert.exe', $option, "", "", @SW_HIde)

				_SetData($progressbar, 80)

				$option = '"' & $tempdir & '\backdropX_3.png" -resize 500 -gravity center -extent 500 -background #ff000000 -rotate 10 -matte -bordercolor none -border 140x350 -depth 32 "' & $tempdir & '\backdropX_3.png"'

				ShellExecuteWait(@ScriptDir & '\convert.exe', $option, "", "", @SW_HIde)

				_SetData($progressbar, 82)

				$option = '"' & $tempdir & '\backdropX_4.png" -resize 500 -gravity center -extent 500 -background #ff000000 -rotate 300 -matte -bordercolor none -border 140x240 -depth 32 "' & $tempdir & '\backdropX_4.png"'

				ShellExecuteWait(@ScriptDir & '\convert.exe', $option, "", "", @SW_HIde)

				_SetData($progressbar, 85)

				$option = '"' & $tempdir & '\backdropX_5.png" -resize 500 -gravity center -extent 500 -background #ff000000 -matte -bordercolor none -border 30 -depth 32 "' & $tempdir & '\backdropX_5.png"'

				ShellExecuteWait(@ScriptDir & '\convert.exe', $option, "", "", @SW_HIde)

				_SetData($progressbar, 88)

				$option = '"' & $tempdir & '\backdropX_6.png" -resize 500 -gravity center -extent 500 -background #ff000000 -rotate 3 -matte -bordercolor none -border 685x350 -depth 32 "' & $tempdir & '\backdropX_6.png"'

				ShellExecuteWait(@ScriptDir & '\convert.exe', $option, "", "", @SW_HIde)

				$save = $path[1] & $path[2] & StringReplace($ini_fanart_background, "{movie}",$path[3])

				$backdroppath = $save

				_SetData($progressbar, 90)

				$option = '"' & $backdroptemplate & '" "' & $tempdir & '\backdropX_4.png" -gravity NorthEast -composite "' & $tempdir & '\backdropX_2.png" -gravity NorthEast -composite -depth 32 "' & $tempdir & '\backdropX_6.png" -gravity West -composite "' & $tempdir & '\backdropX_5.png" -gravity North -composite "' & $tempdir & '\backdropX_1.png" -gravity NorthWest -composite "' & $tempdir & '\backdropX_3.png" -gravity NorthWest -composite "' & $save & '"'

				ShellExecuteWait(@ScriptDir & '\convert.exe', $option, "", "", @SW_HIde)

			EndIf

			_Optimize_Graphics_File($save)

		EndIf

	EndIf

	; nfo erzeugen

	Local $File_NFO, $tCur, $filetime, $fanart_genre, $plot, $plot1

	If $ini_fanart_nonfo <> 1 Then

		_SetLabel($Label02, $lng_workingon  & " - " & $path[3] & "   " & $lng_refreshnfo)

		If $json_Filenaming_Movie_File_NFO = "{movie}.nfo" Then

			$File_NFO = $path[3] & ".nfo"

		Else

			$File_NFO = $json_Filenaming_Movie_File_NFO

		EndIf

		If $ini_fanart_genrefolder = "1" Then

			$fanart_genre = StringReplace(StringReplace(StringReplace($path[1] & $path[2], $InDir, ""),"\",""),"_!_",":")

		Else

			$fanart_genre = $ini_fanart_genre

		EndIf

		$plot1 = $ini_fanart_plot

		If Not $plot1 = "" Then $plot1 = $plot1 & @CRLF & @CRLF

		If $ini_fanart_mediainfo = "1" Then

			$plot = $path[3] & @CRLF & @CRLF & "Genre:" & @CRLF & $fanart_genre & @CRLF & @CRLF & "Video:" & @CRLF & $plot1 & $vRow[2] & " - " & $time & @CRLF & $vRow[5] & "x"  & $vRow[6] & " - " & $v & @CRLF & @CRLF & "Audio:" & @CRLF & $aRow[2] & " - " & $aRow[4] & " " & $lng_channels

		EndIf

		$tCur = _Date_Time_GetLocalTime()

		$filetime = FileGetTime(@ScriptFullPath,0)

		$fle_hwnd = FileOpen($path[1] & $path[2] & "\" & $File_NFO, 130)

		FileWrite($fle_hwnd, '<?xml version="1.0" encoding="UTF-8" standalone="yes"?>' & @CRLF)
		FileWrite($fle_hwnd, '<!-- created on ' & _Date_Time_SystemTimeToDateTimeStr($tCur) & ' by ' & $Title & ' ( ' & $filetime[1] & '/' & $filetime[2] & '/' & $filetime[0] & '  ' & $filetime[3] & ':' & $filetime[4] & ':' & $filetime[5] & ' ) -->' & @CRLF)
		FileWrite($fle_hwnd, '<movie>' & @CRLF)
		FileWrite($fle_hwnd, '<id> </id>' & @CRLF)
		FileWrite($fle_hwnd, '<tmdbid> </tmdbid>' & @CRLF)
		FileWrite($fle_hwnd, '<title>' & $path[3] & '</title>' & @CRLF & '<originaltitle>' & $path[3] & '</originaltitle>' & @CRLF & '<sorttitle>' & $path[3] & '</sorttitle>' & @CRLF)
		FileWrite($fle_hwnd, '<year>' & StringLeft($vRow[10],4) & '</year>' & @CRLF)
		FileWrite($fle_hwnd, '<genre>' & $fanart_genre & '</genre>' & @CRLF)
		FileWrite($fle_hwnd, '<plot>' & $plot & '</plot>' & @CRLF)
		FileWrite($fle_hwnd, '</movie>')
		FileClose($fle_hwnd)

		_SetData($progressbar, 95)

		; Tagging
		_SetLabel($Label02, $lng_workingon  & " - " & $path[3] & "   " & $lng_tag)


		If  StringLower($Path[4]) = ".mkv" Or StringLower($Path[4]) = ".mk3d" Then

			$option = '"' & $InFile & '" --tags all: --delete-attachment "mime-type:application/octet-stream" --delete-attachment "mime-type:application/xml" --delete-attachment "mime-type:text/xml" --delete-attachment "mime-type:image/jpeg" --delete-attachment "mime-type:image/png"'

			ShellExecuteWait($ini_mkvpropedit_path, $option, "", "", @SW_HIde)

			$fle_hwnd = FileOpen($tempdir & "\" & "tag.xml", 130)

			FileWrite($fle_hwnd, '<?xml version="1.0" encoding="UTF-8" standalone="yes"?>' & @CRLF & '<Tags>' & @CRLF & '  <Tag>' & @CRLF & '    <Targets>' & @CRLF & '      <TargetTypeValue>50</TargetTypeValue>' & @CRLF & '    </Targets>' & @CRLF & '    <Simple>' & @CRLF & '      <Name>TITLE</Name>')
			FileWrite($fle_hwnd, @CRLF & '      <String>' & $path[3] & '</String>' & @CRLF & '      <TagLanguage>und</TagLanguage>' & @CRLF & '      <DefaultLanguage>1</DefaultLanguage>' & @CRLF & '    </Simple>' & @CRLF & '    <Simple>' & @CRLF & '      <Name>IMDB</Name>')
			FileWrite($fle_hwnd, @CRLF & '      <String> </String>' & @CRLF & '      <TagLanguage>und</TagLanguage>' & @CRLF & '      <DefaultLanguage>1</DefaultLanguage>' & @CRLF & '    </Simple>' & @CRLF & '    <Simple>' & @CRLF & '      <Name>TMDB</Name>')
			FileWrite($fle_hwnd, @CRLF & '      <String> </String>' & @CRLF & '      <TagLanguage>und</TagLanguage>' & @CRLF & '      <DefaultLanguage>1</DefaultLanguage>' & @CRLF & '    </Simple>' & @CRLF & '    <Simple>' & @CRLF & '      <Name>DATE_RELEASED</Name>')
			FileWrite($fle_hwnd, @CRLF & '      <String>' & StringLeft($vRow[10],4) & '</String>' & @CRLF & '      <TagLanguage>und</TagLanguage>' & @CRLF & '      <DefaultLanguage>1</DefaultLanguage>' & @CRLF & '    </Simple>' & @CRLF & '    <Simple>' & @CRLF & '      <Name>SUMMARY</Name>')
			FileWrite($fle_hwnd, @CRLF & '      <String>' & $plot & '</String>' & @CRLF & '      <TagLanguage>und</TagLanguage>' & @CRLF & '      <DefaultLanguage>1</DefaultLanguage>' & @CRLF & '    </Simple>' & @CRLF & '    <Simple>' & @CRLF & '      <Name>LAW_RATING</Name>')
			FileWrite($fle_hwnd, @CRLF & '      <String> </String>' & @CRLF & '      <TagLanguage>und</TagLanguage>' & @CRLF & '      <DefaultLanguage>1</DefaultLanguage>' & @CRLF & '    </Simple>' & @CRLF & '  </Tag>' & @CRLF & '</Tags>')
			FileClose($fle_hwnd)

			$option = '"' & $InFile & '" --tags global:"' & $tempdir & '\tag.xml"'

			ShellExecuteWait($ini_mkvpropedit_path, $option, "", "", @SW_HIde)

			If FileExists($coverpath) Then

				$option = '"' & $InFile & '" --add-attachment "' & $coverpath & '"'

				ShellExecuteWait($ini_mkvpropedit_path, $option, "", "", @SW_HIde)

			EndIf

			If FileExists($backdroppath) Then

				$option = '"' & $InFile & '" --add-attachment "' & $backdroppath & '"'

				ShellExecuteWait($ini_mkvpropedit_path, $option, "", "", @SW_HIde)

			EndIf

		EndIf

	EndIf

	_SetData($progressbar, 100)

	_WriteLog("Make_Fanart - Finished working on " & $InFile)

	Return $break

EndFunc

;Function to make movie.nfo Kodi19 compatible
Func _MakeMovieNfoKodi19($InDir="")

 	Local $i, $Split, $row, $season, $file, $j, $sDrive, $sDir, $sFilename, $sExtension, $folder

 	Local $FanartArray, $PosterArray, $nfoArray, $nfo, $hnfo, $movieset, $movieset1, $flag

	local $id, $id1, $iPosition, $idt, $idt1, $nfo1, $kodi19_inputfolder, $iset

	dim $nfo2[1], $nfo3[1]

	$kodi19_inputfolder = IniRead(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_kodi19_inputfolder1", @MyDocumentsDir)

	If $InDir = "" Then $InDir = $kodi19_inputfolder

 	_WriteLog("MakeMovieNfoKodi19 - Start Working On  " & $InDir)

	_SetLabel($Label02, $lng_working)

	$nfoArray = _FileListToArrayRec($InDir, "*.nfo", 1,1)

	_WriteLog("MakeMovieNfoKodi19 - FileListToArrayRec: Finished ")

 	If _ElementExists($nfoArray, 0) Then

 		For $i = 1 To $nfoArray[0]

			_SetLabel($Label02, $lng_workingon & ": " & $nfoArray[$i])

			$hnfo = FileOpen($InDir & "\" & $nfoArray[$i], 256)

			$nfo = FileRead($hnfo)

			FileClose($hnfo)

			$nfo1 = StringReplace($nfo, "&amp;", "&")

			$hnfo = FileOpen($InDir & "\" & $nfoArray[$i], 2)

			Filewrite($hnfo,$nfo1)

			FileClose($hnfo)

			$nfo1 = ""

			$hnfo = FileOpen($InDir & "\" & $nfoArray[$i], 0)

			$nfo = FileRead($hnfo)

			FileClose($hnfo)

			If $hnfo = -1 Then _WriteLog("MakeMovieNfoKodi19 - Error opening file: " & $InDir & "\" & $nfoArray[$i])

			$nfo = StringReplace($nfo, "&amp;", "&")

			If $iPosition = 0 And StringLeft($nfo, 5) = "<?xml" Then $nfo1 = "Foo"

			$iPosition = StringInStr($nfo, "<id>")

			If $iPosition > 0 Then

				$nfo2 = _StringBetween($nfo, "<id>", "</id>")

				$nfo1 = $nfo2[0]

			EndIf

			If $iPosition = 0 And StringLeft($nfo, 5) = "<?xml" Then $nfo1 = "Foo"

			If $nfo1 = "" Then

				_WriteLog("MakeMovieNfoKodi19 - $nfo already compatible for: " & $InDir & "\" & $nfoArray[$i])

			Else

				$iPosition = StringInStr($nfo, "<id>")

				If $iPosition > 0 Then

					$idt = _StringBetween($nfo, "<id>", "</id>")

					$id = $idt[0]

				EndIf

				$nfo1 = StringReplace($nfo, $id, "")

				$iPosition = StringInStr($nfo, "<imdbid>")

				If $iPosition > 0 Then

					$idt1 = _StringBetween($nfo, "<id>", "</id>")

					If IsArray($idt1) Then

						$id1 = $idt1[0]

						If StringInStr($id1, "tt") Then

							$nfo2 = StringReplace($nfo1, '<imdbid>', '<uniqueid type="imdb">' & $id1)

							$nfo1 = StringReplace($nfo2, '</imdbid>', '</uniqueid>')

						EndIf

					EndIf

				Else

					If StringInStr($id, "tt") Then

						$nfo1 = StringReplace($nfo1, '</id>', '</id>'& @CRLF & '<uniqueid type="imdb">' & $id & '</uniqueid>')

					EndIf

				EndIf

				$iPosition = StringInStr($nfo, "<tmdbid>")

				If $iPosition > 0 Then

					$nfo2 = StringReplace($nfo1, '<tmdbid>', '<uniqueid type="tmdb">')

					$nfo1 = StringReplace($nfo2, '</tmdbid>', '</uniqueid>')

				Else

					If StringInStr($id, "tt") Then

					Else

						$nfo1 = StringReplace($nfo1, '</id>', '</id>'& @CRLF & '<uniqueid type="tmdb">' & $id & '</uniqueid>')

					EndIf

				EndIf

				If $hnfo = -1 Then

					_WriteLog("MakeMovieNfoKodi19 - Error opening file: " & $InDir & "\" & $nfoArray[$i])

				Else

					If StringLeft($nfo1, 5) = "<?xml" Then

						$hnfo = FileOpen($InDir & "\" & $nfoArray[$i], 2)

						Filewrite($hnfo,$nfo1)

						FileClose($hnfo)

					EndIf

				EndIf

			EndIf

			$hnfo = FileOpen($InDir & "\" & $nfoArray[$i], 0)

			$nfo = FileRead($hnfo)

			FileClose($hnfo)

			If $hnfo = -1 Then _WriteLog("MakeMovieNfoKodi19 - Error opening file: " & $InDir & "\" & $nfoArray[$i])


			$iset = StringInStr($nfo, "<set>")

			If $iset > 0 Then

				$nfo3 = _StringBetween($nfo, "<set>", "</set>")

			EndIf

			If StringInStr($nfo3[0], "<name>") Then

				_WriteLog("MakeMovieNfoKodi19 - $nfo already movieset compatible for: " & $InDir & "\" & $nfoArray[$i])

			Else

				$nfo1 = StringReplace($nfo, "<set>", "<set>" & @CRLF & "    <name>")

				$nfo = StringReplace($nfo1, "</set>", "</name>" & @CRLF & "  </set>")

				If StringLeft($nfo, 5) = "<?xml" Then

					$hnfo = FileOpen($InDir & "\" & $nfoArray[$i], 2)

					Filewrite($hnfo,$nfo)

					FileClose($hnfo)

				EndIf

			EndIf

			If $ini_remove_sorttitle = 1 Then _RemoveSorttitle($InDir & "\" & $nfoArray[$i])

		Next

	EndIf

	_WriteLog("MakeMovieNfoKodi19 - Finished Working On  " & $InDir)

	_SetLabel($Label02, $lng_waiting)

EndFunc

;Function to make Tvshow.nfo Kodi19 compatible
Func _MakeTVShowNfoKodi19($InDir="")

 	Local $i, $Split, $row, $season, $file, $j, $sDrive, $sDir, $sFilename, $sExtension, $folder

 	Local $FanartArray, $PosterArray, $nfoArray, $nfo, $hnfo, $movieset, $movieset1, $flag

	local $id, $iPosition, $idt, $blanfo1, $nfo2, $kodi19_inputfolder

	$kodi19_inputfolder = IniRead(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_kodi19_inputfolder", @MyDocumentsDir)

	If $InDir = "" Then $InDir = $kodi19_inputfolder

	_SetLabel($Label02, $lng_working)

 	_WriteLog("MakeTVShowNfoKodi19 - Start Working On  " & $InDir)

 	$nfoArray = _FileListToArrayRec($InDir, "*.nfo", 1,1)

	_WriteLog("MakeTVShowNfoKodi19 - FileListToArrayRec: Finished ")

 	If _ElementExists($nfoArray, 0) Then

 		For $i = 1 To $nfoArray[0]

			_SetLabel($Label02, $lng_workingon & ": " & $nfoArray[$i])

			$hnfo = FileOpen($InDir & "\" & $nfoArray[$i], 256)

			$nfo = FileRead($hnfo)

			FileClose($hnfo)

			$nfo1 = StringReplace($nfo, "&amp;", "&")

			$hnfo = FileOpen($InDir & "\" & $nfoArray[$i], 2)

			Filewrite($hnfo,$nfo1)

			FileClose($hnfo)

			$hnfo = FileOpen($InDir & "\" & $nfoArray[$i], 256)

			$nfo1 = FileRead($hnfo)

			FileClose($hnfo)

			If $hnfo = -1 Then _WriteLog("MakeMovieNfoKodi19 - Error opening file: " & $InDir & "\" & $nfoArray[$i])

			$nfo1 = StringReplace($nfo, "&amp;", "&")

			$nfo2 = _StringBetween($nfo1, "<id>", "</id>")

			If _ElementExists($nfo2,0) Then

				If $nfo2[0] = "" Then

					_WriteLog("MakeTVShowNfoKodi19 - $nfo already compatible for: " & $InDir & "\" & $nfoArray[$i])

				Else

					$iPosition = StringInStr($nfo1, "<id>")

					If $iPosition > 0 Then

						$idt = _StringBetween($nfo1, "<id>", "</id>")

						$id = $idt[0]

						$nfo1 = StringReplace($nfo1, $id, "")

					EndIf

					$iPosition = StringInStr($nfo1, "<tvdbid>")

					If $iPosition > 0 Then

						$nfo1 = StringReplace($nfo1, '<tvdbid>', '<uniqueid type="tvdb">' & $id)

						$nfo1 = StringReplace($nfo1, '</tvdbid>', '</uniqueid>')

					Else

						$nfo1 = StringReplace($nfo1, '</id>', '</id>'& @CRLF & '<uniqueid type="tvdb">' & $id & '</uniqueid>')

					EndIf

					$iPosition = 0

					$iPosition = StringInStr($nfo1, "<tmdbid>")

					If $iPosition > 0 Then

						$nfo1 = StringReplace($nfo1, '<tmdbid>', '<uniqueid type="tmdb">')

						$nfo1 = StringReplace($nfo1, '</tmdbid>', '</uniqueid>')

					EndIf

					$iPosition = StringInStr($nfo1, "<imdbid>")

					If $iPosition > 0 Then

						$nfo1 = StringReplace($nfo1, '<imdbid>', '<uniqueid type="imdb">')

						$nfo1 = StringReplace($nfo1, '</imdbid>', '</uniqueid>')

					EndIf

					If $hnfo = -1 Then

						_WriteLog("MakeTVShowNfoKodi19 - Error opening file: " & $InDir & "\" & $nfoArray[$i])

					Else

						$hnfo = FileOpen($InDir & "\" & $nfoArray[$i], 2)

						Filewrite($hnfo,$nfo1)

						FileClose($hnfo)

					EndIf

				EndIf

			EndIf

		Next

	EndIf

	_WriteLog("MakeTVShowNfoKodi19 - Finished Working On  " & $InDir)

	_SetLabel($Label02, $lng_waiting)

	Return

EndFunc

;Function to Generate MediaStub files
Func _Make_MediaStub()

	Local $file, $title, $Message, $hndl, $x=0, $ext

	IniWrite(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_mediastub_outputfolder", GUICtrlRead($input_47_01))

	$ini_mediastub_outputfolder = IniRead(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_mediastub_outputfolder", @MyDocumentsDir)

	$file = GUICtrlRead($input_47_02)

	$ext = GUICtrlRead($combo_47_02)

	$title = GUICtrlRead($input_47_03)

	$Message = GUICtrlRead($edit_47_04)

	If $file = "" Then

		MsgBox($MB_SYSTEMMODAL, $lng_errmsg, $lng_nofilename)

		Return

	EndIf

	$hndl = FileOpen($ini_mediastub_outputfolder & "\" & $file & $ext, 2)

	If $title = "" Then $x = 1

	If $Message = "" Then $x = 1

	If $x = 0 Then

		FileWrite($hndl, '<discstub>' & @CRLF & ' <title>' & $title & '</title>' & @CRLF &  ' <message>' & $Message & '</message>' & @CRLF & '</discstub>')

	EndIf

	FileClose($hndl)

	MsgBox(0, "", $lng_sucess, 3)

	Return

EndFunc

;Function to Generate Season Folder
Func _make_season_folder($InDir)

	_WriteLog("make_season_folder - Start working on " & $InDir)

	$ini_space_attach = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_space_attach", "1")
	$json_TVShow_FolderSeason = GUICtrlRead($input_53_03)

	Local $WorkArray, $sDrive, $sDir, $sFilename, $sExtension, $PathSplit, $File0, $nfo, $season, $File, $s, $i, $path1
	Local $year0, $year1, $year2, $thumbname, $file1

	$WorkArray = _FileListToArrayRec($InDir, $extstring2, 1, 1, 1)

	If Not IsArray($WorkArray) Then

		MsgBox(0, "", $lng_nofiles)
		_LastModule()
		Return

	EndIf

	For $i = 1 To $WorkArray[0]

		$PathSplit = _PathSplit($InDir & "\" & $WorkArray[$i], $sDrive, $sDir, $sFilename, $sExtension)
		$File = $PathSplit[1] & $PathSplit[2] & $PathSplit[3]

		If $ini_KeepFileDate = "1" Then

			$year0 = FileGetTime($WorkArray[$i],0,1)
			$year1 = FileGetTime($WorkArray[$i],1,1)
			$year2 = FileGetTime($WorkArray[$i],2,1)

		EndIf

		$File0 = $File & ".nfo"

		If FileExists($File0) Then

			$nfo = FileRead($File0)
			$season = _StringBetween($nfo, "<season>", "</season>")

			If Not @error Then

				$s = StringFormat("%02s", $season[0])

				If $ini_space_attach = "1" Then

					$staffel = $json_TVShow_FolderSeason & " " & $s

				Else

					$staffel = $json_TVShow_FolderSeason & $s

				EndIf

				If StringInStr($PathSplit[2], $staffel) Then

					$path1 = $PathSplit[1] & $PathSplit[2]

				Else

					$path1 = $PathSplit[1] & $PathSplit[2] & $staffel & "\"

				EndIf

				DirCreate($path1)

				$file1 = $PathSplit[1] & $PathSplit[2] & StringReplace($json_Filenaming_TVShow_Image_Episode, "{episodefile}", $PathSplit[3])

				$thumbname = StringReplace($json_Filenaming_TVShow_Image_Episode, "{episodefile}", $PathSplit[3])

				FileMove($file1, $path1 & $thumbname, 9)
				FileMove($File & ".nfo", $path1 & $PathSplit[3] & ".nfo", 9)
				FileMove($File & $PathSplit[4], $path1 & $PathSplit[3] & $PathSplit[4], 9)

				If $ini_KeepFileDate = "1" Then

					FileSetTime($WorkArray[$i],$year0,1)
					FileSetTime($WorkArray[$i],$year1,1)
					FileSetTime($WorkArray[$i],$year2,1)

				EndIf

			Else

				_WriteLog("Error - NFO for " & $PathSplit[3] & $PathSplit[4] & " could not be found")

			EndIf

		EndIf

	Next

	_WriteLog("make_season_folder - Finished working on " & $InDir)

	_CopyBannerPoster($InDir)

	Return

EndFunc

;Function to read Media Infos from a File
Func _MediaInfo($File)

	Local $wIndex, $width, $hIndex, $height, $frIndex, $framerate, $dIndex, $duration, $dur, $sIndex, $ScanType, $Progre
	Local $AspectRatio, $asr, $rIndex, $bIndex, $bitrate, $bit, $fIndex, $vIndex, $format, $cod, $AudioIndexArray, $VideoIndexArray
	Local $AudioIndexArray, $AudioIndex, $audio_format, $audio_channels, $audio_language, $codec, $video_cid, $video_id, $hdr
	Local $Audio_fIndex, $Audio_cIndex, $Audio_lIndex, $audio_cod, $audio_cha, $audio_lang, $Text_id, $Video_iIndex, $external = ""
	Local $TextIndexArray, $TextIndex, $Text_format, $Text_channels, $Text_language, $aIndex, $audio_id, $audio_cid, $hdrIndex
	Local $Text_fIndex, $Text_cIndex, $Text_lIndex, $Text_nIndex, $Text_cod, $Text_cha, $Text_lang, $stop, $Text_cid, $jhandle, $jfile
	Local $path, $sDrive, $sDir, $sFilename, $sExtension, $vPosition, $aPosition, $video_id1, $audio_id1, $MediaInfo, $split, $test

	Local $externalindex[0]
	Local $year[1] = [1900]

	_SQLite_Exec(-1, "DROP TABLE IF EXISTS Video;")
	_SQLite_Exec(-1, "DROP TABLE IF EXISTS Audio;")
	_SQLite_Exec(-1, "DROP TABLE IF EXISTS Text;")

	_SQLite_Exec(-1, "CREATE TABLE Video (ID INTEGER PRIMARY KEY, VideoID TEXT UNIQUE ON CONFLICT IGNORE, Format Text,Duration Text,Bitrate Text,Width Text,Height Text,AspectRatio Text,Framerate Text,ScanType Text,Year Text,Year1 Text,Year2 Text);")
	_SQLite_Exec(-1, "CREATE TABLE Audio (ID INTEGER PRIMARY KEY,AudioID Text,Format Text,FormatID Text,Channels Text,Language Text);")
	_SQLite_Exec(-1, "CREATE TABLE Text (ID INTEGER PRIMARY KEY,TextID Text,Format Text,Language Text,Forced Text,External Text);")

	RunWait(@ComSpec & ' /c mediainfo.exe --Full "' & $File & '" >"' & $tempdir & '\mediainfo.txt"', @ScriptDir, @SW_HIde, $STdeRR_CHILD + $STDOUT_CHILD)

	$jhandle = FileOpen($tempdir & '\mediainfo.txt')

	$jfile = FileRead($jhandle)

	FileClose($jhandle)

	$test = StringInStr($jfile, "General", 0)

	If $test < 0 Then

		Return "skip"

	EndIf

	$MediaInfo = StringSplit($jfile, @CRLF, $STR_ENTIRESPLIT)

	If IsArray ($MediaInfo) Then

		$hdr = 0

		;Video Options
		$vIndex = _ArraySearch($MediaInfo, "Video", 0, 0, 0, 0)

		If @error Then

			$vIndex = _ArraySearch($MediaInfo, "Video #1", 0, 0, 0, 0)

			If $vIndex < 1 Then

				_WriteLog("Error - Reading Media Info From " & $File)

				sleep(100)

				$count = $count +1

				If $count < 5 Then

					_WriteLog("Try Again - Reading Media Info From " & $File)

					_MediaInfo($File)

				Else

					MsgBox($MB_SYSTEMMODAL, "Error", "Error - Reading Media Info From " & $File, 10)

					Return "skip"

				EndIf

			EndIf

			$VideoIndexArray = _ArrayFindAll($MediaInfo, "Video #", 0, 0, 0, 1, 1)

			$aIndex = _ArraySearch($MediaInfo, "Audio     ", 0, 0, 0, 0)

			If @error Then $aIndex = _ArraySearch($MediaInfo, "Audio #1", 0, 0, 0, 1)

			$Video_iIndex = _ArraySearch($MediaInfo, "StreamOrder", $vIndex, 999999999, 0,1)

			If @error Then

				$video_id = ""

			Else

				For $i = 0  To UBound($VideoIndexArray) - 1

					If _ElementExists($VideoIndexArray, $i + 1) Then

						$stop = $VideoIndexArray[$i + 1]

					Else

						$stop = $aIndex

					EndIf

					$vIndex = _ArraySearch($MediaInfo, "Video #" & $i+1, 0, 0, 0, 0)

					$Video_iIndex = _ArraySearch($MediaInfo, "StreamOrder", $VideoIndexArray[$i], 99999999999, 0, 1)

					If @error Then

						$Video_id = ""

					Else

						$Video_cid = StringSplit($MediaInfo[$Video_iIndex], ": ", 1)

						$aPosition = StringInStr($Video_cid[2],"-")

						If $aPosition > 0 Then

							$Video_id1 = StringSplit($Video_cid[2], "-")

							$Video_id = $Video_id1[2]

						Else

							$Video_id = $Video_cid[2]

						EndIf

					EndIf

					;Get width of video
					Local $wIndex = _ArraySearch($MediaInfo, "Width", $vIndex, 0, 0, 1)

					If @error Then
						$width = ""
					Else
						$width = StringRegExpReplace($MediaInfo[$wIndex], "[^0-9]", "")
					EndIf

					;Get height of video
					$hIndex = _ArraySearch($MediaInfo, "Height", $vIndex, 0, 0, 1)

					If @error Then
						$height = ""
					Else
						$height = StringRegExpReplace($MediaInfo[$hIndex], "[^0-9]", "")
					EndIf

					;Get Framerate
					$frIndex = _ArraySearch($MediaInfo, "fps", $vIndex, 0, 0, 1)

					If @error Then
						$framerate = ""
					Else
						$framerate = StringRegExpReplace($MediaInfo[$frIndex], "[^0-9.]", "")
					EndIf

					;Get Duration
					$dIndex = _ArraySearch($MediaInfo, "Duration", 0, 0, 0, 1)

					If @error Then
						$duration = 0
					Else
						$dur = StringSplit($MediaInfo[$dIndex], ": ", 1)

						$duration = $dur[2]

					EndIf

					;Get Scan Type
					$sIndex = _ArraySearch($MediaInfo, "Scan type", $vIndex, 0, 0, 1)

					If @error Then
						$ScanType = "Interlaced"
					Else
						$Progre = StringInStr($MediaInfo[$sIndex], "Progressive", 0)
						If $Progre <> 0 Then
							$ScanType = "Progressive"
						Else
							$ScanType = "Interlaced"
						EndIf
					EndIf

					;Get Display aspect ratio
					$rIndex = _ArraySearch($MediaInfo, "Display aspect ratio", $vIndex, 0, 0, 1)

					If @error Then
						$AspectRatio = 0
					Else
						$asr = StringSplit($MediaInfo[$rIndex], ": ", 1)

						If _ElementExists($asr, 3) Then

							$AspectRatio = $asr[2] & ":" & $asr[3]

						Else

							$AspectRatio = $asr[2]

						EndIf

					EndIf

					;Get Bitrate
					$bIndex = _ArraySearch($MediaInfo, "Overall bit rate   ", $vIndex, $aIndex, 0, 1)

					If @error Then

						$bIndex = _ArraySearch($MediaInfo, "bit rate   ", 0, $aIndex, 0, 1)

					EndIf

					If @error Then
						$bitrate = 0
					Else
						$bit = StringSplit($MediaInfo[$bIndex], ": ", 1)

						$bitrate = $bit[2]

					EndIf

					;Get Codec
					$fIndex = _ArraySearch($MediaInfo, "Format ", $vIndex, 99999999999, 0, 1)

					If @error Then
						$format = 0
					Else

						$cod = StringSplit($MediaInfo[$fIndex], ": ", 1)

						$format = $cod[2]

					EndIf

					$year0 = FileGetTime($File,0,1)
					$year1 = FileGetTime($File,1,1)
					$year2 = FileGetTime($File,2,1)

					_SQLite_Exec(-1, "INSERT INTO Video (VideoID,Format,Duration,Bitrate,Width,Height,AspectRatio,Framerate,ScanType,Year,Year1,Year2) VALUES ('" & $video_id & "','" & $format & "','" & $duration & "','" & $bitrate & "','" & $width & "','" & $height & "','" & $AspectRatio & "','" & $framerate & "','" & $ScanType & "','" & $year0 & "','" & $year1 & "','" & $year2 & "');")

					If @error Then

						MsgBox(0,"", "SQLite Error")

						Return "skip"

					EndIf

				Next

			EndIf

		Else

			$aIndex = _ArraySearch($MediaInfo, "Audio    ", 0, 0, 0, 0)

			If @error Then $aIndex = _ArraySearch($MediaInfo, "Audio #1", 0, 0, 0, 1)

			$Video_iIndex = _ArraySearch($MediaInfo, "StreamOrder", $vIndex, 999999999, 0,1)

			If @error Then

				$video_id = ""

			Else

				$video_cid = StringSplit($MediaInfo[$Video_iIndex], ": ", 1)

				$vPosition = StringInStr($video_cid[2],"-")

				If $vPosition > 0 Then

					$video_id1 = StringSplit($video_cid[2], "-")

					$video_id = $video_id1[2]

				Else

					$video_id = $video_cid[2]

				EndIf

			EndIf

			;Get width of video
			Local $wIndex = _ArraySearch($MediaInfo, "Width", $vIndex, 0, 0, 1)

			If @error Then
				$width = ""
			Else
				$width = StringRegExpReplace($MediaInfo[$wIndex], "[^0-9]", "")
			EndIf

			;Get height of video
			$hIndex = _ArraySearch($MediaInfo, "Height", $vIndex, 0, 0, 1)

			If @error Then
				$height = ""
			Else
				$height = StringRegExpReplace($MediaInfo[$hIndex], "[^0-9]", "")
			EndIf

			;Get Framerate
			$frIndex = _ArraySearch($MediaInfo, "fps", $vIndex, 0, 0, 1)

			If @error Then
				$framerate = ""
			Else
				$framerate = StringRegExpReplace($MediaInfo[$frIndex], "[^0-9.]", "")
			EndIf

			;Get Duration
			$dIndex = _ArraySearch($MediaInfo, "Duration", 0, 0, 0, 1)

			If @error Then
				$duration = 0
			Else
				$dur = StringSplit($MediaInfo[$dIndex], ": ", 1)

				$duration = $dur[2]

			EndIf

			;Get Scan Type
			$sIndex = _ArraySearch($MediaInfo, "Scan type", $vIndex, 0, 0, 1)

			If @error Then
				$ScanType = "Interlaced"
			Else
				$Progre = StringInStr($MediaInfo[$sIndex], "Progressive", 0)
				If $Progre <> 0 Then
					$ScanType = "Progressive"
				Else
					$ScanType = "Interlaced"
				EndIf
			EndIf

			;Get Display aspect ratio
			$rIndex = _ArraySearch($MediaInfo, "Display aspect ratio", $vIndex, 0, 0, 1)

			If @error Then
				$AspectRatio = 0
			Else
				$asr = StringSplit($MediaInfo[$rIndex], ": ", 1)

				If _ElementExists($asr, 3) Then

					$AspectRatio = $asr[2] & ":" & $asr[3]

				Else

					$AspectRatio = $asr[2]

				EndIf

			EndIf

			;Get Bitrate
			$bIndex = _ArraySearch($MediaInfo, "Overall bit rate   ", $vIndex, $aIndex, 0, 1)

			If @error Then

				$bIndex = _ArraySearch($MediaInfo, "bit rate   ", 0, $aIndex, 0, 1)

			EndIf

			If @error Then
				$bitrate = 0
			Else
				$bit = StringSplit($MediaInfo[$bIndex], ": ", 1)

				$bitrate = $bit[2]

			EndIf

			;Get Codec
			$fIndex = _ArraySearch($MediaInfo, "Format ", $vIndex, 99999999999, 0, 1)

			If @error Then
				$format = 0
			Else

				$cod = StringSplit($MediaInfo[$fIndex], ": ", 1)

				$format = $cod[2]

			EndIf

			$year0 = FileGetTime($File,0,1)
			$year1 = FileGetTime($File,1,1)
			$year2 = FileGetTime($File,2,1)

			_SQLite_Exec(-1, "INSERT INTO Video (VideoID,Format,Duration,Bitrate,Width,Height,AspectRatio,Framerate,ScanType,Year,Year1,Year2) VALUES ('" & $video_id & "','" & $format & "','" & $duration & "','" & $bitrate & "','" & $width & "','" & $height & "','" & $AspectRatio & "','" & $framerate & "','" & $ScanType & "','" & $year0 & "','" & $year1 & "','" & $year2 & "');")

			If @error Then

				MsgBox(0,"", "SQLite Error")

				Return "skip"

			EndIf

		EndIf

		If @error Then
			_WriteLog("Error - Reading Media Info From " & $File)
			Return -1
		EndIf

		_WriteLog("MediaInfo - Read Video MediaInfos")

		;Audio Options
		;Find all Audio Tracks

		$AudioIndexArray = _ArrayFindAll($MediaInfo, "Audio #", 0, 0, 0, 1, 1)

		If Not IsArray($AudioIndexArray) Then

			$TextIndexArray = _ArrayFindAll($MediaInfo, "Text #", 0, 0, 0, 1, 1)

			If Not IsArray($TextIndexArray) Then

				$TextIndex = _ArraySearch($MediaInfo, "Text", 0, 0, 0, 0)

			Else

				$TextIndex = _ArraySearch($MediaInfo, "Text #", 0, 0, 0, 0)

			EndIf

			$AudioIndex = _ArraySearch($MediaInfo, "Audio", 0, 0, 0, 0)

			If @error Then
				$audio_format = ""
				$audio_channels = ""
				$audio_language = "und"
				$audio_id = ""

			Else

				$Audio_iIndex = _ArraySearch($MediaInfo, "StreamOrder", $AudioIndex, 99999999999, 0, 1)

				If @error Then

					$audio_id = ""

				Else

					$audio_cid = StringSplit($MediaInfo[$Audio_iIndex], ": ", 1)

					$aPosition = StringInStr($audio_cid[2],"-")

					$audio_id = StringSplit($audio_cid[2], "-")

					If $aPosition > 0 Then

						$audio_id1 = StringSplit($audio_cid[2], "-")

						$audio_id = $audio_id1[2]

					Else

						$audio_id = $audio_cid[2]

					EndIf

				EndIf

				$Audio_fIndex = _ArraySearch($MediaInfo, "Format  ", $AudioIndex, 999999999999, 0, 1)

				If @error Then

					$audio_format = ""

				Else

					$audio_cod = StringSplit($MediaInfo[$Audio_fIndex], ": ", 1)

					$audio_format = $audio_cod[2]

				EndIf

				$Audio_cIndex = _ArraySearch($MediaInfo, "Channel(s)", $AudioIndex, 99999999999999, 0, 1)

				If @error Then

					$audio_channels = ""

				Else

					$audio_cha = StringSplit($MediaInfo[$Audio_cIndex], ": ", 1)

					$audio_channels = $audio_cha[2]

				EndIf

				$Audio_lIndex = _ArraySearch($MediaInfo, "Language", $AudioIndex, 0, 0, 1)

				If @error Then

					$audio_language  = "Undefined"

				Else

					$audio_lang = StringSplit($MediaInfo[$Audio_lIndex], ": ", 1)

					$audio_language  = $audio_lang[2]

				EndIf


			EndIf

			$codec = 5

			If $audio_format = $ini_codec1 Then $codec = 1
			If $audio_format = $ini_codec2 Then $codec = 2
			If $audio_format = $ini_codec3 Then $codec = 3
			If $audio_format = $ini_codec4 Then $codec = 4
			If $audio_format = $ini_codec5 Then $codec = 5

			_SQLite_Exec(-1, "INSERT INTO Audio (AudioID,Format,FormatID,Channels,Language) VALUES ('" & $audio_id & "','" & $audio_format & "','"  & $codec & "','" & $audio_channels & "','" & $audio_language & "');")

			If @error Then Return -1
			_WriteLog("MediaInfo - Read Audio MediaInfos")

		Else

			$TextIndexArray = _ArrayFindAll($MediaInfo, "Text #", 0, 0, 0, 1, 1)

			If Not IsArray($TextIndexArray) Then

				$TextIndex = _ArraySearch($MediaInfo, "Text", 0, 0, 0, 0)

			Else

				$TextIndex = _ArraySearch($MediaInfo, "Text #", 0, 0, 0, 0)

			EndIf

 			For $i = 0  To UBound($AudioIndexArray) - 1

				If _ElementExists($AudioIndexArray, $i + 1) Then

					$stop = $AudioIndexArray[$i + 1]

				Else

					$stop = $TextIndex

				EndIf

				$Audio_iIndex = _ArraySearch($MediaInfo, "StreamOrder", $AudioIndexArray[$i], 99999999999, 0, 1)

				If @error Then

					$audio_id = ""

				Else

					$audio_cid = StringSplit($MediaInfo[$Audio_iIndex], ": ", 1)

					$aPosition = StringInStr($audio_cid[2],"-")

					If $aPosition > 0 Then

						$audio_id1 = StringSplit($audio_cid[2], "-")

						$audio_id = $audio_id1[2]

					Else

						$audio_id = $audio_cid[2]

					EndIf

				EndIf

				$Audio_fIndex = _ArraySearch($MediaInfo, "Format   ", $AudioIndexArray[$i], $stop, 0, 1)

				If @error Then

					$audio_format = ""

				Else

					$audio_cod = StringSplit($MediaInfo[$Audio_fIndex], ": ", 1)

					$audio_format = $audio_cod[2]

				EndIf

				$Audio_cIndex = _ArraySearch($MediaInfo, "Channel(s)", $AudioIndexArray[$i], $stop, 0, 1)

				If @error Then

					$audio_channels = ""

				Else

					$audio_cha = StringSplit($MediaInfo[$Audio_cIndex], ": ", 1)

					$audio_channels = $audio_cha[2]

				EndIf

				$Audio_lIndex = _ArraySearch($MediaInfo, "Language", $AudioIndexArray[$i], $stop, 0, 1)

				If @error Then

					$audio_language  = "Und"

				Else

					$audio_lang = StringSplit($MediaInfo[$Audio_lIndex], ": ", 1)

					$audio_language  = $audio_lang[2]

				EndIf

				$codec = 5

				If $audio_format = $ini_codec1 Then $codec = 1
				If $audio_format = $ini_codec2 Then $codec = 2
				If $audio_format = $ini_codec3 Then $codec = 3
				If $audio_format = $ini_codec4 Then $codec = 4
				If $audio_format = $ini_codec5 Then $codec = 5

				_SQLite_Exec(-1, "INSERT INTO Audio (AudioID,Format,FormatID,Channels,Language) VALUES ('" & $audio_id & "','" & $audio_format & "','"  & $codec & "','" & $audio_channels & "','" & $audio_language & "');")

				If @error Then Return "skip"

			Next

		EndIf


		;Subtitle Options
		;Find all Subtitle Tracks

		$TextIndexArray = _ArrayFindAll($MediaInfo, "Text #", $TextIndex -1, 0, 0, 1, 1)

		If Not IsArray($TextIndexArray) Then

			If $TextIndex < 1 Then

				$Text_format = ""

				$Text_channels = "No"

				$Text_language = ""

				$Text_id = ""

			Else

				$Text_iIndex = _ArraySearch($MediaInfo, "StreamOrder", $TextIndex, 0, 0, 1)

				If @error Then

					$Text_id = ""

				Else

					$Text_cid = StringSplit($MediaInfo[$Text_iIndex], ": ", 1)

					$Text_id = $Text_cid[2]

				EndIf


				$Text_fIndex = _ArraySearch($MediaInfo, "Codec ID/Info", $TextIndex, 0, 0, 1)

				If @error Then

					$Text_format = ""

				Else

					$Text_cod = StringSplit($MediaInfo[$Text_fIndex], ": ", 1)

					$Text_format = $Text_cod[2]

				EndIf

				$Text_nIndex = _ArraySearch($MediaInfo, "Name      ", $TextIndex, 0, 0, 1)

				$Text_cIndex = _ArraySearch($MediaInfo, "Forced        ", $Text_nIndex + 1, 0, 0, 1)

				If @error Then

					$Text_channels = "No"

				Else

					$split = StringSplit($MediaInfo[$Text_cIndex], ":", 1)

					$Text_channels = StringStripWS($split[2], 3)

				EndIf

				$Text_lIndex = _ArraySearch($MediaInfo, "Language ", $TextIndex, 0, 0, 1)

				If @error Then

					$Text_language  = ""

				Else

					$Text_lang = StringSplit($MediaInfo[$Text_lIndex], ": ", 1)

					$Text_language  = $Text_lang[2]

				EndIf

			EndIf

			_SQLite_Exec(-1, "INSERT INTO Text (TextID,Format,Forced,Language,External) VALUES ('" & $Text_id & "','" & $Text_format & "','" & $Text_channels & "','" & $Text_language  & "','');")

			If @error Then Return "skip"
			_WriteLog("MediaInfo - Read Subtitle MediaInfos")

		Else

 			For $i = 0  To UBound($TextIndexArray) - 1

				$Text_iIndex = _ArraySearch($MediaInfo, "ID                     ", $TextIndexArray[$i], 0, 0, 1)

				If @error Then

					$Text_id = ""

				Else

					$Text_cid = StringSplit($MediaInfo[$Text_iIndex], ": ", 1)

					$Text_id = Int($Text_cid[2]) - 1

				EndIf

				$Text_fIndex = _ArraySearch($MediaInfo, "Format   ", $TextIndexArray[$i], 0, 0, 1)

				If @error Then

					$Text_format = ""

				Else

					$Text_cod = StringSplit($MediaInfo[$Text_fIndex], ": ", 1)

					$Text_format = $Text_cod[2]

				EndIf

				$Text_cIndex = _ArraySearch($MediaInfo, "Forced  ", $TextIndexArray[$i], 0, 0, 1)

				If @error Then

					$Text_channels = "No"

				Else

					$split = StringSplit($MediaInfo[$Text_cIndex], ":", 1)

					$Text_channels = StringStripWS($split[2], 3)

				EndIf

				$Text_lIndex = _ArraySearch($MediaInfo, "Language ", $TextIndexArray[$i], 0, 0, 1)

				If @error Then

					$Text_language  = ""

				Else

					$Text_lang = StringSplit($MediaInfo[$Text_lIndex], ": ", 1)

					$Text_language  = $Text_lang[2]

				EndIf

				_SQLite_Exec(-1, "INSERT INTO Text (TextID,Format,Forced,Language) VALUES ('" & $Text_id & "','" & $Text_format & "','" & $Text_channels & "','" & $Text_language & "');")

				If @error Then Return "skip"

			Next

		EndIf

		; Find external .srt Subtitles

		If $ini_mux_external = "1" Then

			$PathSplit = _PathSplit($File, $sDrive, $sDir, $sFilename, $sExtension)

			Local $search = FileFindFirstFile($PathSplit[1] & $PathSplit[2] & $PathSplit[3] & "*" & ".srt")

			While 1
				$file = FileFindNextFile($search)
				If @error Then Exitloop
				_ArrayAdd($externalindex, $PathSplit[1] & $PathSplit[2] & $file)
			WEnd

			FileClose($search)

			Local $search2 = FileFindFirstFile($PathSplit[1] & $PathSplit[2] & "subs\" & $PathSplit[3] & "*" & ".srt")

			While 1
				$file = FileFindNextFile($search2)
				If @error Then Exitloop
				_ArrayAdd($externalindex, $PathSplit[1] & $PathSplit[2] & "subs\"  & $file)
			WEnd

			FileClose($search2)

			For $i = 0 To UBound($externalindex) - 1

				$PathSplit = _PathSplit($externalindex[$i], $sDrive, $sDir, $sFilename, $sExtension)

				$Text_format = StringReplace($PathSplit[4], ".", "")

				$Text_channels = "No"

				$Text_language = ""

				$Text_id = ""

				$external = $externalindex[$i]

				If StringInStr($externalindex[$i], "forced") Then $Text_channels = "Yes"

				_SQLite_Exec(-1, "INSERT INTO Text (TextID,Format,Forced,Language,External) VALUES ('" & $Text_id & "','" & $Text_format & "','" & $Text_channels & "','" & $Text_language  & "','" & $external & "');")

			Next

		EndIf

		_WriteLog("MediaInfo - Successfully Read Media Info From " & $File)

		Return $MediaInfo

	Else

		_WriteLog("Error - Reading Media Info From " & $File)

		Return "skip"

	EndIf

EndFunc

;Function to read Media Infos from an Audio File
Func _MediaInfoAudio($File)

	Local $MediaInfo, $tIndex, $aIndex, $apIndex, $tnIndex, $tpIndex, $pIndex, $dIndex, $prIndex, $gIndex, $ppIndex, $ptIndex
	Local $AlbumPerformer, $Performer, $Album, $TrackName, $Position, $RecordedDate, $Producer, $split, $Genre, $Part= "none"
	Local $sDrive, $sDir, $sFilename, $sExtension, $PathSplit
	Dim $Pos[0]

	_SQLite_Exec(-1, "DROP TABLE IF EXISTS Music;")

	_SQLite_Exec(-1, "CREATE TABLE Music (AlbumPerformer TEXT NOT NULL ON CONFLICT IGNORE COLLATE NOCASE, Performer TEXT COLLATE NOCASE, Album TEXT COLLATE NOCASE, TrackName TEXT, Position INT, RecordedDate TEXT, Genre TEXT, Part TEXT);")

	RunWait(@ComSpec & ' /c mediainfo.exe --Full "' & $File & '" >"' & $tempdir & '\mediainfoaudio.txt"', @ScriptDir, @SW_HIde, $STdeRR_CHILD + $STDOUT_CHILD)

	$jhandle = FileOpen($tempdir & '\mediainfoaudio.txt', 256)

	$jfile = FileRead($jhandle)

	FileClose($jhandle)

	$MediaInfo = StringSplit($jfile, @CRLF, $STR_ENTIRESPLIT)

	$PathSplit = _PathSplit($File, $sDrive, $sDir, $sFilename, $sExtension)

	If IsArray ($MediaInfo) Then

		;Album Options
		$tIndex = _ArraySearch($MediaInfo, "Title", 0, 0, 0, 1)

		If @error Then

			$tIndex = ""

		EndIf

		$aIndex = _ArraySearch($MediaInfo, "Album   ", $tIndex, 0, 0, 1)

		If @error Then

			$aIndex = ""

		EndIf

		$apIndex = _ArraySearch($MediaInfo, "Album/Performer", $tIndex, 0, 0, 1)

		If @error Then

			$apIndex = ""

		EndIf

		$ppIndex = _ArraySearch($MediaInfo, "Part", $tIndex, 0, 0, 1)

		If @error Then

			$ppIndex = ""

		EndIf

		$ptIndex = _ArraySearch($MediaInfo, "Part/Total", $tIndex, 0, 0, 1)

		If @error Then

			$ptIndex = ""

		EndIf

		$tnIndex = _ArraySearch($MediaInfo, "Track name", $ppIndex, 0, 0, 1)

		If @error Then

			$tnIndex = ""

		EndIf

		$tpIndex = _ArraySearch($MediaInfo, "Track name/Position", $tIndex, 0, 0, 1)

		If @error Then

			$tpIndex = ""

		EndIf

		$pIndex = _ArraySearch($MediaInfo, "Performer", $apIndex + 1, 0, 0, 1)

		If @error Then

			$pIndex = ""

		EndIf



		$dIndex = _ArraySearch($MediaInfo, "Recorded date", $tIndex, 0, 0, 1)

		If @error Then

			$dIndex = ""

		EndIf

		$gIndex = _ArraySearch($MediaInfo, "Genre", $tIndex, 0, 0, 1)

		If @error Then

			$gIndex = ""

		EndIf


	EndIf

	$split = StringSplit($MediaInfo[$pIndex], ":")

	If _elementExists($split, 2) Then

		$Performer = StringStripWS(StringReplace($split[2],"'","''"),3)

	Else

		$Performer = "none"

	EndIf

	$split = StringSplit($MediaInfo[$apIndex], ":")

	If _elementExists($split, 2) Then

		$AlbumPerformer = StringStripWS(StringReplace($split[2],"'","''"),3)

	Else

		$AlbumPerformer = $Performer

	EndIf

	$split = StringSplit($MediaInfo[$aIndex], ":")

	If _elementExists($split, 2) Then

		$Album = StringStripWS(StringReplace($split[2],"'","''"),3)

	Else

			$Album = "none"

	EndIf

	$split = StringSplit($MediaInfo[$tnIndex], ":")

	If _elementExists($split, 2) Then

		$TrackName = StringStripWS(StringReplace($split[2],"'","''"),3)

	Else

		If $PathSplit[4] = ".ogg" Then

			$split = StringSplit($MediaInfo[$tIndex], ":")

			If _elementExists($split, 2) Then

				$TrackName = StringStripWS(StringReplace($split[2],"'","''"),3)

			Else

				$TrackName = "none"

			EndIf

		Else

			$TrackName = "none"

		EndIf

	EndIf

	$split = StringSplit($MediaInfo[$dIndex], ":")

	If _elementExists($split, 2) Then

		$RecordedDate = StringStripWS(StringReplace($split[2],"'","''"),3)

	Else

		$RecordedDate = "0000"

	EndIf

	$split = StringSplit($MediaInfo[$gIndex], ":")

	If _elementExists($split, 2) Then

		$Genre = StringStripWS(StringReplace($split[2],"'","''"),3)

	Else

		$Genre = "none"

	EndIf


	$split = StringSplit($MediaInfo[$tpIndex], ":")

	If _elementExists($split, 2) Then

		$Position = $split[2]

	Else

		If $PathSplit[4] = ".ogg" Then

			If StringInStr($String_VariousArtists, $AlbumPerformer) <> 0 Then

				$TrackOut1 = StringReplace($ini_Music_Renaming_VariousArtists, "{Title}", $TrackName)

			Else

				$TrackOut1 = StringReplace($ini_Music_Renaming, "{Title}", $TrackName)

			EndIf

			$TrackOut = StringReplace($TrackOut1, "{Artist}", $Performer)

			$TrackOut1 = StringReplace($TrackOut, "{Year}", $RecordedDate)

			$TrackOut = StringReplace($TrackOut1, "{Album}", $Album)

			$TrackOut1 = StringReplace($TrackOut, "{Genre}", $Genre)

			$split = StringSplit($TrackOut1, "{Track}", 1)

			$Pos = _StringBetween($PathSplit[3],$split[1],$split[2])

			$position = $Pos[0]

		Else

			$Position = "0"

		EndIf

	EndIf

	$split = StringSplit($MediaInfo[$ppIndex], ":")

	If _elementExists($split, 2) Then

		$Part = StringStripWS(StringReplace($split[2],"'","''"),3)

	Else

		$Part = "none"

	EndIf

	$split = StringSplit($MediaInfo[$ptIndex], ":")

	If _elementExists($split, 2) Then

		If $split[2] < 2 Then $Part = "none"

	EndIf

	_SQLite_Exec(-1, "INSERT INTO Music (AlbumPerformer,Performer,Album,TrackName,Position,RecordedDate,Genre,Part) VALUES ('" & StringRegExpReplace($AlbumPerformer, '[<>?":|\/*]', "_") & "','" & StringRegExpReplace($Performer, '[<>?":|\/*]', "_") & "','" & StringRegExpReplace($Album, '[<>?":|\/*]', "_") & "','" & StringRegExpReplace($TrackName, '[<>?":|\/*]', "_") & "','" & $Position & "','" & $RecordedDate & "','" & StringRegExpReplace($Genre, '[<>?":|\/*]', "_") & "','" & StringRegExpReplace($Part, '[<>?":|\/*]', "_") & "');")

	If @error Then

		MsgBox(0,"", "SQLite Error")

		Return -1

	EndIf

	Return $MediaInfo

EndFunc

;Function to Grab Metadata
Func _nfo4HTPC($InDir, $progressbar, $label, $button, $type)

	_WriteLog("nfo4HTPCv2 - Start working on " & $InDir)

	Local $refresh_nfo, $refresh_gfx, $option, $iPID, $a, $value, $sOutput, $result, $afstring

	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_meta_series_refresh_nfo", GUICtrlRead($check_92_06))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_meta_series_refresh_gfx", GUICtrlRead($check_92_05))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_meta_movies_refresh_nfo", GUICtrlRead($check_92_16))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_meta_movies_refresh_gfx", GUICtrlRead($check_92_15))

	If $type = "fanart" Then

	Else

		If $type = "series" Then
			$refresh_nfo = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_meta_series_refresh_nfo", "1")
			$refresh_gfx = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_meta_series_refresh_gfx", "1")
		EndIf

		If $type = "movies" Then
			$refresh_nfo = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_meta_movies_refresh_nfo", "1")
			$refresh_gfx = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_meta_movies_refresh_gfx", "1")
		EndIf

		$option = " --type:" & $type & ' --folder:"' & $InDir & '"'

		If $refresh_nfo = 1 And $refresh_gfx = 1 Then $option = $option & " --refresh:all --refreshtag:all"

		If $refresh_nfo = 1 And $refresh_gfx = 4 Then $option = $option & " --refresh:nfo --refreshtag:nfo"

		If $refresh_nfo = 4 And $refresh_gfx = 1 Then $option = $option & " --refresh:images --refreshtag:images"

		If $refresh_nfo = 4 And $refresh_gfx = 4 Then $option = $option & " --refresh:false"

		$option = $option & ' --toolbox:true'

		_WriteLog("nfo4HTPCv2 - " & $option)

		$iPID = Run(@ComSpec & ' /c nfo4HTPCv2' & $option , @ScriptDir, @SW_HIde, $STdeRR_CHILD + $STDOUT_CHILD + $RUN_CREATE_NEW_CONSOLE)

		While ProcessExists($iPID)

			_GetTime()

			$a = GUIGetCursorInfo()

			If IsArray($a) Then

				If $a[2] = 1 And $a[4] = $button Then

					$value = MsgBox(4, $lng_cancel, $lng_cancel1 & @CRLF & $lng_areyousure)

					If $value = 6 Then ;Instantly Abort

						_WriteLog("nfo4HTPCv2 - Triggered Abort")

						ProcessClose($iPID)

						ProcessWaitClose($iPID, 10)

						_WriteLog("nfo4HTPCv2 - Finished Abort Process: " & $iPID)

						Return 1

					EndIf

				EndIf

			EndIf

			$sOutput = _OEMToAnsi(StdoutRead($iPID))

			$result = StringInStr($sOutput, "#")

			If $result = 1 Then

				$StringLine = StringSplit($sOutput, @CRLF)
				$aString = StringSplit($StringLine[1], "|")

				_SetData($progressbar, Round($aString[4]))

				$afstring = StringReplace($aString[2], "TVDB - ", "")

				_SetLabel($Label, StringStripWS($aString[3],3))

				_SetLabel($Label02, $lng_workingon  & "   " & $afstring & " " & $aString[3]& " --- " & $lng_progress & ": " & $aString[4] & "% --- " & $lng_elapsed & ": " & $aString[5] & " --- " & $lng_total & ": " & $aString[6])

			EndIf

			If @error Then ExitLoop

			Sleep(200)

		WEnd

	EndIf

	If $ini_kodi_dot = 1 Then _FixNotation($Indir)

	_WriteLog("nfo4HTPCv2 - Finished working on " & $InDir)

	If $type = "series" Then  _TagSeries($InDir, "2")

	If $type = "series" Then  _TagSeries($InDir, "2")

	If $type = "movies" Then _Tagmovies($InDir)

	If $type = "movies" Then _Tagmovies($InDir)

	_TagNames($InDir)

	Return

EndFunc

;Function to Normalize Files
Func _NormalizeAudioFile($InFile, $OutFile, $Cancelbutton = "0000", $progressbar = "0000", $progressbar2 = "0000", $count = "1", $i_global = "1")

	Local $path, $aRow, $sDrive = "", $sDir = "", $sFilename = "", $sExtension = "", $query, $Res, $Rows, $Columns, $acodec
	Local $acompress, $Rval, $iPID, $option, $a, $value, $break, $sOutput, $result, $step1, $p, $len, $StringLine, $aString
	Local $br1 = "", $Pr = "", $astring1 = "00"

	If GUICtrlRead($radio_25_06) = 1 Then IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_normalize_audiocodec", "1")
	If GUICtrlRead($radio_25_07) = 1 Then IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_normalize_audiocodec", "2")
	If GUICtrlRead($radio_25_08) = 1 Then IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_normalize_audiocodec", "3")
	If GUICtrlRead($radio_25_09) = 1 Then IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_normalize_audiocodec", "4")
	If GUICtrlRead($radio_25_10) = 1 Then IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_normalize_audiocodec", "5")
	If GUICtrlRead($radio_25_11) = 1 Then IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_normalize_audiocodec", "6")
	If GUICtrlRead($radio_25_12) = 1 Then IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_normalize_audiocodec", "7")
	If GUICtrlRead($radio_25_13) = 1 Then IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_normalize_audiocodec", "8")

	$ini_recode_container = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_recode_container", "mkv")
	$ini_codec = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_codec", "AAC")
	$ini_normalize_audiocodec = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_normalize_audiocodec", "6")

	_WriteLog("NormalizeFile - Start Working On  " & $InFile)

	$path = _PathSplit($InFile, $sDrive, $sDir, $sFilename, $sExtension)

	; Audio Options

	$query = 'SELECT AudioID FROM Audio ;'

	$Rval = _SQLite_GetTable2d(-1, $query, $Res, $Rows, $Columns)

	_SQLite_QuerySingleRow(-1,"SELECT * FROM Audio LIMIT 1;",$aRow)

	If $ini_normalize_audiocodec = 1 Then $acodec = " -c:a ac3 -ar 48000"
	If $ini_normalize_audiocodec = 2 Then $acodec = " -c:a aac -ar 48000"
	If $ini_normalize_audiocodec = 3 Then $acodec = " -c:a libmp3lame -b:a 192k -ar 48000"
	If $ini_normalize_audiocodec = 4 Then $acodec = " -c:a flac -ar 48000"
	If $ini_normalize_audiocodec = 5 Then $acodec = " -c:a libopus -b:a 128k -af aformat=channel_layouts='7.1|5.1|stereo'"
	If $ini_normalize_audiocodec = 7 Then $acodec = " -c:a dca -strict -2"
	If $ini_normalize_audiocodec = 8 Then $acodec = " -c:a truehd -strict -2"
	If $ini_normalize_audiocodec = 6 Then

		Switch($aRow[2])

			Case $aRow[2] = "AAC"
				$acodec = " -c:a aac -ar 48000"

			Case $aRow[2] = "AC-3"
				$acodec = " -c:a ac3 -ar 48000"

			Case $aRow[2] = "E-AC-3"
				$acodec = " -c:a eac3 -ar 48000"

			Case $aRow[2] = "DTS"
				$acodec = " -c:a dca -strict -2"

			Case $aRow[2] = "MLP FBA"
				$acodec = " -c:a truehd -strict -2"

			Case Else

				If $ini_codec = "AAC" Then $acodec = " -c:a aac -ar 48000"
				If $ini_codec = "AC-3" Then $acodec = " -c:a ac3 -ar 48000"
				If $ini_codec = "MP3" Then $acodec = " -c:a libmp3lame -b:a 192k -ar 48000"
				If $ini_codec = "FLAC" Then $acodec = " -c:a flac -ar 48000"
				If $ini_codec = "OPUS" Then $acodec = " -c:a libopus -b:a 128k -af aformat=channel_layouts='7.1|5.1|stereo'"
				If $ini_codec = "DTS" Then $acodec = " -c:a dca -strict -2"
				If $ini_codec = "TrueHD" Then $acodec = " -c:a truehd -strict -2"

		EndSwitch

	EndIf

	If $ini_audio_compression = 0 Then $compress = ""
	If $ini_audio_compression = 1 Then $compress = ":s=22"
	If $ini_audio_compression = 2 Then $compress = ":s=15"
	If $ini_audio_compression = 3 Then $compress = ":s=11"
	If $ini_audio_compression = 4 Then $compress = ":s=7"

	$acompress = " -af dynaudnorm=p=" & StringReplace($ini_audio_db, ",", ".") & ":f=500:m=10" & $compress & ":g=11:r=" & StringReplace($ini_audio_db, ",", ".") & ":b=false"

	;Start Normalizing

	$option = " -y -i '" & $InFile & "' -max_muxing_queue_size 9999 -scodec copy -c:v copy" & $acodec & $acompress & " '" & $OutFile & "'"

	_WriteLog("NormalizeFile - $option = " & $option)

	$iPID = Run(@ComSpec & ' /c ToolBox.exe --filename:ffmpeg.exe --arguments:" ' & $option, @ScriptDir, @SW_HIde, $STdeRR_CHILD + $STDOUT_CHILD)

	While ProcessExists($iPID)

		_GetTime()

		$a = GUIGetCursorInfo()

		If IsArray($a) Then

			If $a[2] = 1 And $a[4] = $Cancelbutton Then

				$value = MsgBox(19, $lng_cancel, $lng_cancel1 & @CRLF & $lng_areyousure & "." & @CRLF & @CRLF & $lng_cancel2 & @CRLF & $lng_cancel3 & @CRLF & $lng_cancel4)

				If $value = 2 Then ;Instantly Abort

					_WriteLog("NormalizeFile - Triggered Instant Abort")

					_CloseProcess($iPID)

					_CloseProcess("ffmpeg.exe")

					$break = 1

				EndIf

				If $value = 6 Then ;Finish File and Abort

					_WriteLog("NormalizeFile - Triggered Abort After Recent File")

					$break = 1

				EndIf

			EndIf

		EndIf

		$sOutput =  _OEMToAnsi(StdoutRead($iPID))

		$result = StringInStr($sOutput, "#")

		If $result = 1 Then

			$StringLine = StringSplit($sOutput, @CRLF)
			$aString = StringSplit($StringLine[1], "|")
			If $aString[4] <> "" Then $aString1 = $aString[4]

			$step1 = 100 / $Count

			$p = ($step1 * ($i_global - 1)) + ($aString1 /  $Count)

			_SetData($progressbar2, $p)

			_SetData($progressbar,  $aString1)

			If StringLen($Path[3]) > 75 Then

				$len = StringLeft($Path[3], 70) & "... "

			Else

				$len = $Path[3]

			EndIf

			_SetLabel($Label02, $lng_workingon  & "   " & $len & $Path[4] & " --- " & $lng_progress & ": " & $aString[4] & "% --- " & $lng_elapsed & ": " & $aString[5] & " --- " & $lng_total & ": " & $aString[6] & " --- FPS: " & $aString[7])

		EndIf

		If @error Then ExitLoop

		Sleep(200)

	WEnd

	_WriteLog("NormalizeFile - Finished Working On  " & $InFile)

	Return $break

EndFunc

;Function to Rework Graphics Files
Func _Optimize_Graphics_File($InFile)

	Local $path, $sDrive, $sDir, $sFilename, $sExtension, $break

	Sleep(50)

	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_gfx_optjpg", GUICtrlRead($check_26_12))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_gfx_optpng", GUICtrlRead($check_26_11))

	_WriteLog("Optimize_Graphics_File - Working On  " & $InFile)

	$path = _PathSplit(StringReplace($InFile,"\'", "'"), $sDrive, $sDir, $sFilename, $sExtension)

	If $path[4] = ".png" Then

		If GUICtrlRead($check_26_11) = "1" Then

			ShellExecuteWait(@ScriptDir & "\optipng.exe", ' -fix -quiet "' & $InFile & '"', "", "", @SW_HIde)

		EndIf

	EndIf

	If $path[4] = ".jpg" Or $path[4] = ".jpeg" Then

		If GUICtrlRead($check_26_12) = "1" Then

			ShellExecuteWait(@ScriptDir & "\jpegoptim.exe", ' -q "' & $InFile & '"', "", "", @SW_HIde)

		EndIf

	EndIf

	Return

EndFunc

;Function to prepare Series metadata
Func _PrepareSeries()

	Local $i, $j, $series, $path, $idtype, $idvalue, $x, $tTime, $filetime, $Array
	Local $season_f, $season_t, $episodes_f, $episodes_t, $episode, $fle_hwnd, $k

	IniWrite(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_series_metadata_inputfolder", GUICtrlRead($input_36_02))

	$ini_series_metadata_inputfolder = IniRead(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_series_metadata_inputfolder", @MyDocumentsDir)

	$x = 0

	$path = GUICtrlRead($input_36_02)

	$series = GUICtrlRead($input_36_21)

	$idtype = GUICtrlRead($input_36_23)

	$idvalue = GUICtrlRead($input_36_24)

	$season_f = GUICtrlRead($input_36_31)

	$season_t = GUICtrlRead($input_36_32)

	$episodes_f = GUICtrlRead($input_36_41)

	$episodes_t = GUICtrlRead($input_36_42)

	$ext = GUICtrlRead($combo_47_02)

	If $idtype = "" Then $x = 1

	If $idvalue = "" Then $x = 1

	$filetime = FileGetTime(@ScriptFullPath,0)

	$tTime = _Date_Time_GetSystemTime()

	_WriteLog("_PrepareSeries - Start working on " & $series)

	If $series = "" Then

		MsgBox($MB_SYSTEMMODAL, $lng_errmsg, $lng_nofilename)

		Return

	EndIf

	If $series = $lng_series Then

		MsgBox($MB_SYSTEMMODAL, $lng_errmsg, $lng_nofilename)

		Return

	EndIf

	_SetLabel($label02, $lng_workingon & "   " & $series)

	;; Generate tvshow.nfo

	If Not FileExists($ini_series_metadata_inputfolder & "\" & $series & "\tvshow.nfo") Then

		$fle_hwnd = FileOpen($ini_series_metadata_inputfolder & "\" & $series & "\tvshow.nfo", 10)

		FileWrite($fle_hwnd, '<?xml version="1.0" encoding="UTF-8" standalone="yes"?>' & @CRLF)
		FileWrite($fle_hwnd, '<!-- created on ' & _Date_Time_SystemTimeToDateTimeStr($tTime) & ' by ' & $Title & ' (' & $filetime[1] & '/' & $filetime[2] & '/' & $filetime[0] & '  ' & $filetime[3] & ':' & $filetime[4] & ':' & $filetime[5] & ') -->' & @CRLF)
		FileWrite($fle_hwnd, '<tvshow>' & @CRLF)
		FileWrite($fle_hwnd, '<title>' & $series & '</title>' & @CRLF & '<sorttitle>' & $series & '</sorttitle>' & @CRLF)
		FileWrite($fle_hwnd, '<year>' & GUICtrlRead($input_36_22) & '</year>' & @CRLF)
		FileWrite($fle_hwnd, '<uniqueid type="tmdb"></uniqueid>' & @CRLF & '<uniqueid type="tvdb"></uniqueid>' & @CRLF & '<uniqueid type="imdb"></uniqueid>' & @CRLF)

		If $x = 0 Then

			FileWrite($fle_hwnd, '<uniqueid type="' & $idtype & '">' & $idvalue & '</uniqueid>' & @CRLF)

		EndIf

		FileWrite($fle_hwnd, '<mpaa>' & "" & '</mpaa>' & @CRLF)
		FileWrite($fle_hwnd, '<plot>' & "" & '</plot>' & @CRLF)
		FileWrite($fle_hwnd, '<genre>' & "" & '</genre>' & @CRLF)
		FileWrite($fle_hwnd, '</tvshow>')

		FileClose($fle_hwnd)

	EndIf

	;; Generate episodes stubs with .nfo

	For $i = $season_f To $season_t

		For $j = $episodes_f To $episodes_t

			$episode = StringReplace($json_Rename_TvShow, "{Showtitle}", $series)

			$episode = StringReplace($episode, "{Season}", StringFormat("%02i", $i))

			$episode = StringReplace($episode, "{Episode}", StringFormat("%02i", $j))

			$episode = StringReplace($episode, "{Title}", "Episode_" & StringFormat("%02i", $j))

			$Array = _StringBetween($episode, "{", "}")

			If IsArray($Array)  Then

				For $k = 0 To UBound($Array) - 1

	 				$episode = StringReplace($episode, "{" & $Array[$k] & "}", "")

				Next

			EndIf

			$episode = StringStripWS($episode, 7)

			$fle_hwnd = FileOpen($ini_series_metadata_inputfolder & "\" & $series & "\" & $episode & $ext, 10)

			FileClose($fle_hwnd)

			_WriteLog("_PrepareSeries - generate stub file - " & $episode & $ext)

			If Not FileExists($ini_series_metadata_inputfolder & "\" & $series & "\" & $episode & ".nfo") Then

				$fle_hwnd = FileOpen($ini_series_metadata_inputfolder & "\" & $series & "\" & $episode & ".nfo", 10)

				FileWrite($fle_hwnd, '<?xml version="1.0" encoding="UTF-8" standalone="yes"?>' & @CRLF)
				FileWrite($fle_hwnd, '<!-- created on ' & _Date_Time_SystemTimeToDateTimeStr($tTime) & ' by ' & $Title & ' (' & $filetime[1] & '/' & $filetime[2] & '/' & $filetime[0] & '  ' & $filetime[3] & ':' & $filetime[4] & ':' & $filetime[5] & ') -->' & @CRLF)
				FileWrite($fle_hwnd, '<episodedetails>' & @CRLF)
				FileWrite($fle_hwnd, '<title>' & "Episode_" & StringFormat("%02i", $j) & '</title>' & @CRLF & '<showtitle>' & $series & '</showtitle>' & @CRLF)
				FileWrite($fle_hwnd, '<season>' & $i & '</season>' & @CRLF)
				FileWrite($fle_hwnd, '<episode>' & $j & '</episode>' & @CRLF)

				FileWrite($fle_hwnd, '<year>' & GUICtrlRead($input_36_22) & '</year>' & @CRLF)
				FileWrite($fle_hwnd, '<uniqueid type="tmdb"></uniqueid>' & @CRLF & '<uniqueid type="tvdb"></uniqueid>' & @CRLF & '<uniqueid type="imdb"></uniqueid>' & @CRLF)

				If $x = 0 Then

					FileWrite($fle_hwnd, '<uniqueid type="' & $idtype & '">' & $idvalue & '</uniqueid>' & @CRLF)

				EndIf

				FileWrite($fle_hwnd, '<mpaa>' & "" & '</mpaa>' & @CRLF)
				FileWrite($fle_hwnd, '<plot>' & "" & '</plot>' & @CRLF)
				FileWrite($fle_hwnd, '<genre>' & "" & '</genre>' & @CRLF)
				FileWrite($fle_hwnd, '</episodedetails>')

				FileClose($fle_hwnd)

			EndIf

			_WriteLog("_PrepareSeries - generate nfo file - " & $episode & ".nfo")

			Sleep(100)

		Next

	Next

	;; finished

	_WriteLog("_PrepareSeries - Finished working on " & $series)

	MsgBox(0, "", $lng_sucess, 3)

	_SetLabel($label02,$lng_waiting)

	_SetData($input_61_01, $path)

	_GUI_Show_Corection()

	_GUI_Show_Series_Correction()

	_Metadata_Correction_Series()

	Return

EndFunc

;Function to prepare Movies metadata
Func _PrepareMovies()

	Local $i, $j, $path, $movies, $year, $idtype, $idvalue, $x, $tTime, $filetime, $name, $fle_hwnd, $Array

	IniWrite(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_movies_metadata_inputfolder", GUICtrlRead($input_36_01))

	$ini_movies_metadata_inputfolder = IniRead(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_movies_metadata_inputfolder", @MyDocumentsDir)

	$x = 0

	$path = GUICtrlRead($input_36_01)

	$movies = GUICtrlRead($input_36_11)

	$year = GUICtrlRead($input_36_12)

	$idtype = GUICtrlRead($input_36_13)

	$idvalue = GUICtrlRead($input_36_14)

	$ext = GUICtrlRead($combo_47_02)

	If $idtype = "" Then $x = 1

	If $idvalue = "" Then $x = 1

	$filetime = FileGetTime(@ScriptFullPath,0)

	$tTime = _Date_Time_GetSystemTime()

	_WriteLog("_PrepareMovies - Start working on " & $movies)

	If $movies = "" Then

		MsgBox($MB_SYSTEMMODAL, $lng_errmsg, $lng_nofilename)

		Return

	EndIf

	If $movies = $lng_movies Then

		MsgBox($MB_SYSTEMMODAL, $lng_errmsg, $lng_nofilename)

		Return

	EndIf

	_SetLabel($label02, $lng_workingon & "   " & $movies)

	;; creating .nfo and .stub

	$name = StringReplace($json_Rename_Movie, "{title}", $movies)

	$name = StringReplace($name, "{year}", $year)

	$Array = _StringBetween($name, "{", "}")

	If IsArray($Array)  Then

		For $i = 0 To UBound($Array) - 1

			$name = StringReplace($name, "{" & $Array[$i] & "}", "")

		Next

	EndIf

	$name = StringStripWS($name, 7)

	_WriteLog("_PrepareMovies - generate stub file - " &  $name & $ext)

	$fle_hwnd = FileOpen($path & "\" & $name & $ext, 10)

	FileClose($fle_hwnd)

	If Not FileExists($path & "\" & $name & ".nfo") Then

		$fle_hwnd = FileOpen($path & "\" & $name & ".nfo", 10)

		FileWrite($fle_hwnd, '<?xml version="1.0" encoding="UTF-8" standalone="yes"?>' & @CRLF)
		FileWrite($fle_hwnd, '<!-- created on ' & _Date_Time_SystemTimeToDateTimeStr($tTime) & ' by ' & $Title & ' (' & $filetime[1] & '/' & $filetime[2] & '/' & $filetime[0] & '  ' & $filetime[3] & ':' & $filetime[4] & ':' & $filetime[5] & ') -->' & @CRLF)
		FileWrite($fle_hwnd, '<movie>' & @CRLF)
		FileWrite($fle_hwnd, '<title>' & $movies & '</title>' & @CRLF & '<sorttitle>' & $movies & '</sorttitle>' & @CRLF & '<originaltitle>' & $movies & '</originaltitle>' & @CRLF)
		If $x = 0 Then FileWrite($fle_hwnd, '<uniqueid type="' & $idtype & '">' & $idvalue & '</uniqueid>' & @CRLF)
		FileWrite($fle_hwnd, '<year>' & $year & '</year>' & @CRLF)
		FileWrite($fle_hwnd, '<mpaa>' & "" & '</mpaa>' & @CRLF)
		FileWrite($fle_hwnd, '<plot>' & "" & '</plot>' & @CRLF)
		FileWrite($fle_hwnd, '<premiered>' & "" & '</premiered>' & @CRLF)
		FileWrite($fle_hwnd, '<aired>' & "" & '</aired>' & @CRLF)
		FileWrite($fle_hwnd, '<tagline>' & "" & '</tagline>' & @CRLF)
		FileWrite($fle_hwnd, '<genre>' & "" & '</genre>' & @CRLF)
		FileWrite($fle_hwnd, '</movie>')

		FileClose($fle_hwnd)

	EndIf

	;; finished

	_WriteLog("_PrepareMovies - Finished working on " & $movies)

	MsgBox(0, "", $lng_sucess, 3)

	_SetLabel($label02,$lng_waiting)

	_SetData($input_62_01, $path)

	_GUI_Show_Corection()

	_GUI_Show_Movies_Correction()

	_Metadata_Correction_Movies()

	Return

EndFunc

;Function to remove sorttitle from .nfo
Func _RemoveSorttitle($Infile)

 	Local $i, $hnfo, $nfo, $nfo1, $iPosition, $tPosition, $title = ""

	dim $nfo2[1], $nfo3[1]

 	_WriteLog("RemoveSorttitle - Start Working On  " & $Infile)

	_SetLabel($Label02, $lng_workingon & ": " & $Infile)

	$hnfo = FileOpen($Infile, 256)

	$nfo1 = FileRead($hnfo)

	FileClose($hnfo)

	$nfo = StringReplace($nfo1, "&amp;", "&")

	$tPosition = StringInStr($nfo, "<title>")

	If $tPosition > 0 Then

		$nfo3 = _StringBetween($nfo, "<title>", "</title>")

		$title = $nfo3[0]

	EndIf

	$iPosition = StringInStr($nfo, "<sorttitle>")

	If $iPosition > 0 Then

		$nfo2 = _StringBetween($nfo, "<sorttitle>", "</sorttitle>")

		$nfo1 = StringReplace($nfo, $nfo2[0], $title)

	EndIf

	$hnfo = FileOpen($Infile, 2)

	Filewrite($hnfo,$nfo1)

	FileClose($hnfo)

	_WriteLog("RemoveSorttitle - Finished Working On  " & $Infile)

	_SetLabel($Label02, $lng_waiting)

EndFunc

;Function to Rework Graphics Files
Func _Rework_Graphics_File($InFile)

	If GUICtrlRead($radio_26_11) = 1 Then IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_gfxnormalize_type", "1")
	If GUICtrlRead($radio_26_12) = 1 Then IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_gfxnormalize_type", "2")

	$ini_gfxnormalize_type = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_gfxnormalize_type", "1")

	If $ini_gfxnormalize_type = "1" Then _Rework_Graphics_File_NC($InFile)
	If $ini_gfxnormalize_type = "2" Then _Rework_Graphics_File_IM($InFile)

EndFunc

;Function to Rework Graphics Files with NConvert
Func _Rework_Graphics_File_NC($InFile)

	Local $path, $sDrive, $sDir, $sFilename, $sExtension, $break, $freefolder, $ext
	Local $option, $option1, $option2, $option3, $iPID, $eoption, $value_unsharp

	_WriteLog("Rework_Graphics_File - Working On  " & $InFile)

	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_gfx_optpng", GUICtrlRead($check_26_11))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_gfx_optjpg", GUICtrlRead($check_26_12))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_gfx4k", GUICtrlRead($check_26_21))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_gfx1080", GUICtrlRead($check_26_22))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_gfx720", GUICtrlRead($check_26_23))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_gfx600", GUICtrlRead($check_26_24))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_gfxfree", GUICtrlRead($check_26_25))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_gfxorg", GUICtrlRead($check_26_26))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_gfxnormalize", GUICtrlRead($check_26_31))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_gfxunsharp", GUICtrlRead($check_26_32))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_gfx_freesize", GUICtrlRead($input_26_25))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_gfx_format_4k", GUICtrlRead($combo_26_21))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_gfx_format_1080", GUICtrlRead($combo_26_22))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_gfx_format_720", GUICtrlRead($combo_26_23))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_gfx_format_600", GUICtrlRead($combo_26_24))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_gfx_format_free", GUICtrlRead($combo_26_25))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_gfx_format_org", GUICtrlRead($combo_26_26))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_gfx_value_unsharp", GUICtrlRead($combo_26_32))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_gfx_moveorg", GUICtrlRead($check_57_21))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_gfx_optorg", GUICtrlRead($check_57_22))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_gfx_rotate", GUICtrlRead($check_57_23))
	If GUICtrlRead($radio_26_31) = 1 Then IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_gfx_color", "1")
	If GUICtrlRead($radio_26_32) = 1 Then IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_gfx_color", "1|2")
	If GUICtrlRead($radio_26_33) = 1 Then IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_gfx_color", "1|3")
	If GUICtrlRead($radio_26_34) = 1 Then IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_gfx_color", "1|2|3")
	If GUICtrlRead($radio_26_35) = 1 Then IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_gfx_color", "2")
	If GUICtrlRead($radio_26_36) = 1 Then IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_gfx_color", "3")
	If GUICtrlRead($radio_26_37) = 1 Then IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_gfx_color", "2|3")


	$ini_gfx_optjpg = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_gfx_optjpg", "1")
	$ini_gfx_optpng = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_gfx_optpng", "1")
	$ini_gfx_moveorg = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_gfx_moveorg", "1")
	$ini_gfx_rotate = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_gfx_rotate", "1")
	$ini_gfx_optorg = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_gfx_optorg", "4")
	$ini_gfx4k = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_gfx4k", "1")
	$ini_gfx1080 = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_gfx1080", "4")
	$ini_gfx720 = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_gfx720", "4")
	$ini_gfx600 = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_gfx600", "1")
	$ini_gfxfree = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_gfxfree", "4")
	$ini_gfxorg = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_gfxorg", "4")
	$ini_gfxnormalize = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_gfxnormalize", "1")
	$ini_gfxunsharp = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_gfxunsharp", "1")
	$ini_gfx_value_unsharp = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_gfx_value_unsharp", "2")
	$ini_gfx_freesize = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_gfx_freesize", "1280x1024")
	$ini_gfx_format_4k = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_gfx_format_4k", "jpg")
	$ini_gfx_format_1080 = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_gfx_format_1080", "jpg")
	$ini_gfx_format_720 = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_gfx_format_720", "jpg")
	$ini_gfx_format_600 = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_gfx_format_600", "jpg")
	$ini_gfx_format_free = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_gfx_format_free", "jpg")
	$ini_gfx_format_org = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_gfx_format_org", "tif")
	$ini_gfx_color = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_gfx_color", "1")

	$path = _PathSplit(StringReplace($InFile,"\'", "'"), $sDrive, $sDir, $sFilename, $sExtension)

	If $ini_gfx_moveorg = "1" Then DirCreate($path[1] & $path[2] & "\Original")
	If $ini_gfx_moveorg = "1" Then DirCreate($path[1] & $path[2] & "\Raw")

	If $ini_gfx_value_unsharp = "1" then $value_unsharp = "2 0.5 0 "
	If $ini_gfx_value_unsharp = "2" then $value_unsharp = "5 0.5 0 "
	If $ini_gfx_value_unsharp = "3" then $value_unsharp = "7 0.5 0 "
	If $ini_gfx_value_unsharp = "4" then $value_unsharp = "10 0.8 2 "
	If $ini_gfx_value_unsharp = "5" then $value_unsharp = "20 1 3 "


	If StringInStr($ini_gfx_color,"1") Then

		If $ini_gfx4k = "1" Then DirCreate($path[1] & $path[2] & "\2160")
		If $ini_gfx1080 = "1" Then DirCreate($path[1] & $path[2] & "\1080")
		If $ini_gfx720 = "1" Then DirCreate($path[1] & $path[2] & "\720")
		If $ini_gfx600 = "1" Then DirCreate($path[1] & $path[2] & "\600")
		If $ini_gfxorg = "1" Then DirCreate($path[1] & $path[2] & "\Org")
		If $ini_gfxfree = "1" Then

			$freefolder = StringSplit($ini_gfx_freesize, "x")

			If _ElementExists($freefolder, 2) Then DirCreate($path[1] & $path[2] & "\" & $freefolder[2])

		EndIf

	EndIf

	If StringInStr($ini_gfx_color,"2") Then

		If $ini_gfx4k = "1" Then DirCreate($path[1] & $path[2] & "\" & $lng_grey & "-2160")
		If $ini_gfx1080 = "1" Then DirCreate($path[1] & $path[2] & "\" & $lng_grey & "-1080")
		If $ini_gfx720 = "1" Then DirCreate($path[1] & $path[2] & "\" & $lng_grey & "-720")
		If $ini_gfx600 = "1" Then DirCreate($path[1] & $path[2] & "\" & $lng_grey & "-600")
		If $ini_gfxOrg = "1" Then DirCreate($path[1] & $path[2] & "\" & $lng_grey & "-Org")
		If $ini_gfxfree = "1" Then

			$freefolder = StringSplit($ini_gfx_freesize, "x")

			If _ElementExists($freefolder, 2) Then DirCreate($path[1] & $path[2] & "\" & $lng_grey & "-" & $freefolder[2])

		EndIf

	EndIf

	If StringInStr($ini_gfx_color,"3") Then

		If $ini_gfx4k = "1" Then DirCreate($path[1] & $path[2] & "\Sepia-2160")
		If $ini_gfx1080 = "1" Then DirCreate($path[1] & $path[2] & "\Sepia-1080")
		If $ini_gfx720 = "1" Then DirCreate($path[1] & $path[2] & "\Sepia-720")
		If $ini_gfx600 = "1" Then DirCreate($path[1] & $path[2] & "\Sepia-600")
		If $ini_gfxorg = "1" Then DirCreate($path[1] & $path[2] & "\Sepia-Org")
		If $ini_gfxfree = "1" Then

			$freefolder = StringSplit($ini_gfx_freesize, "x")

			If _ElementExists($freefolder, 2) Then DirCreate($path[1] & $path[2] & "\Sepia-" & $freefolder[2])

		EndIf

	EndIf


	$option1 = "-ratio "

	$option2 = '-overwrite "' & $InFile & '"'

	If $ini_gfxnormalize = "1" Then $option1 = $option1 & ' -autolevels -autocontrast '

	If $ini_gfxunsharp = "1" Then $option1 = $option1 & ' -unsharp ' & $value_unsharp

	If $ini_gfx_rotate = "1" Then $option1 = $option1 & ' -rflag orient '

	If $ini_gfxorg = "1" Then

		If $ini_gfx_format_org = "jpg" Then

			$ext = "jpeg"

		ElseIf $ini_gfx_format_org = "tif" Then

			$ext = "tiff"

		Else

			$ext = $ini_gfx_format_org

		EndIf

		If StringInStr($ini_gfx_color,"1") Then

			$option3 = $option1 & ' -out ' & $ext & ' -o "' & $path[1] & $path[2] &  "Org\" & $path[3] & "." & $ini_gfx_format_org & '"'

			If $ini_gfx_format_org = "tif" Then

				$option = $option3 & " -c 2 " &  $option2

			Else

				$option = $option3 & " " &  $option2

			EndIf

			_WriteLog("Rework_Graphics_File -$option = " & $option)

			ShellExecuteWait(@ScriptDir & '\nconvert.exe', $option, @ScriptDir, "", @SW_HIDE)

		EndIf

		If StringInStr($ini_gfx_color,"2") Then

			$option3 = $option1 & ' -out ' & $ext & ' -o "' & $path[1] & $path[2] &  $lng_grey & "-Org\" & $path[3] & "." & $ini_gfx_format_org & '"'

			If $ini_gfx_format_org = "tif" Then

				$option = " -grey 256 " & $option3 & " -c 2 " &  $option2

			Else

				$option = " -grey 256 " & $option3 & " " &  $option2

			EndIf

			_WriteLog("Rework_Graphics_File -$option = " & $option)

			ShellExecuteWait(@ScriptDir & '\nconvert.exe', $option, @ScriptDir, "", @SW_HIde)

		EndIf

		If StringInStr($ini_gfx_color,"3") Then

			$option3 = $option1 & ' -out ' & $ext & ' -o "' & $path[1] & $path[2] &  "Sepia-Org\" & $path[3] & "." & $ini_gfx_format_org & '"'

			If $ini_gfx_format_org = "tif" Then

				$option = $option3 & " -c 2 " &  " -sepia 80 " & $option2

			Else

				$option = $option3 & " " &  " -sepia 80 " & $option2

			EndIf

			_WriteLog("Rework_Graphics_File -$option = " & $option)

			ShellExecuteWait(@ScriptDir & '\nconvert.exe', $option, @ScriptDir, "", @SW_HIde)

		EndIf

	EndIf

	$option2 = '-overwrite "' & $InFile & '"'

	If $ini_gfx4k = "1" Then

		If $ini_gfx_format_4k = "jpg" Then

			$ext = "jpeg"

		ElseIf $ini_gfx_format_4k = "tif" Then

			$ext = "tiff"

		Else

			$ext = $ini_gfx_format_4k

		EndIf

		If StringInStr($ini_gfx_color,"1") Then

			$option3 = $option1 & ' -out ' & $ext & ' -resize 3840 2160 -o "' & $path[1] & $path[2] &  "2160\" & $path[3] & "." & $ini_gfx_format_4k & '"'

			If $ini_gfx_format_4k = "tif" Then

				$option = $option3 & " -c 2 " &  $option2

			Else

				$option = $option3 & " " &  $option2

			EndIf

			_WriteLog("Rework_Graphics_File -$option = " & $option)

			ShellExecuteWait(@ScriptDir & '\nconvert.exe', $option, @ScriptDir, "", @SW_HIde)

		EndIf

		If StringInStr($ini_gfx_color,"2") Then

			$option3 = $option1 & ' -out ' & $ext & ' -resize 3840 2160 -o "' & $path[1] & $path[2] &  $lng_grey & "-2160\" & $path[3] & "." & $ini_gfx_format_4k & '"'

			If $ini_gfx_format_4k = "tif" Then

				$option = " -grey 256 " & $option3 & " -c 2 " &  $option2

			Else

				$option = " -grey 256 " & $option3 & " " &  $option2

			EndIf

			_WriteLog("Rework_Graphics_File -$option = " & $option)

			ShellExecuteWait(@ScriptDir & '\nconvert.exe', $option, @ScriptDir, "", @SW_HIde)

		EndIf

		If StringInStr($ini_gfx_color,"3") Then

			$option3 = $option1 & ' -out ' & $ext & ' -resize 3840 2160 -o "' & $path[1] & $path[2] &  "Sepia-2160\" & $path[3] & "." & $ini_gfx_format_4k & '"'

			If $ini_gfx_format_4k = "tif" Then

				$option = $option3 & " -c 2 " &  " -sepia 80 " & $option2

			Else

				$option = $option3 & " " &  " -sepia 80 " & $option2

			EndIf

			_WriteLog("Rework_Graphics_File -$option = " & $option)

			ShellExecuteWait(@ScriptDir & '\nconvert.exe', $option, @ScriptDir, "", @SW_HIde)

		EndIf

	EndIf

	$option2 = '-overwrite "' & $InFile & '"'

	If $ini_gfx1080 = "1" Then

		If $ini_gfx_format_1080 = "jpg" Then

			$ext = "jpeg"

		ElseIf $ini_gfx_format_1080 = "tif" Then

			$ext = "tiff"

		Else

			$ext = $ini_gfx_format_1080

		EndIf

		If StringInStr($ini_gfx_color,"1") Then

			$option3 = $option1 & ' -out ' & $ext & ' -resize 1920 1080 -o "' & $path[1] & $path[2] &  "1080\" & $path[3] & "." & $ini_gfx_format_1080 & '"'

			If $ini_gfx_format_1080 = "tif" Then

				$option = $option3 & " -c 2 " &  $option2

			Else

				$option = $option3 & " " &  $option2

			EndIf

			_WriteLog("Rework_Graphics_File -$option = " & $option)

			ShellExecuteWait(@ScriptDir & '\nconvert.exe', $option, @ScriptDir, "", @SW_HIde)

		EndIf

		If StringInStr($ini_gfx_color,"2") Then

			$option3 = $option1 & ' -out ' & $ext & ' -resize 1920 1080 -o "' & $path[1] & $path[2] &  $lng_grey & "-1080\" & $path[3] & "." & $ini_gfx_format_1080 & '"'

			If $ini_gfx_format_1080 = "tif" Then

				$option = " -grey 256 " & $option3 & " -c 2 " &  $option2

			Else

				$option = " -grey 256 " & $option3 & " " &  $option2

			EndIf

			_WriteLog("Rework_Graphics_File -$option = " & $option)

			ShellExecuteWait(@ScriptDir & '\nconvert.exe', $option, @ScriptDir, "", @SW_HIde)

		EndIf

		If StringInStr($ini_gfx_color,"3") Then

			$option3 = $option1 & ' -out ' & $ext & ' -resize 1920 1080 -o "' & $path[1] & $path[2] &  "Sepia-1080\" & $path[3] & "." & $ini_gfx_format_1080 & '"'

			If $ini_gfx_format_1080 = "tif" Then

				$option = $option3 & " -c 2 " &  " -sepia 80 " & $option2

			Else

				$option = $option3 & " " &  " -sepia 80 " & $option2

			EndIf

			_WriteLog("Rework_Graphics_File -$option = " & $option)

			ShellExecuteWait(@ScriptDir & '\nconvert.exe', $option, @ScriptDir, "", @SW_HIde)

		EndIf

	EndIf

	$option2 = '-overwrite "' & $InFile & '"'

	If $ini_gfx720 = "1" Then


		If $ini_gfx_format_720 = "jpg" Then

			$ext = "jpeg"

		ElseIf $ini_gfx_format_720 = "tif" Then

			$ext = "tiff"

		Else

			$ext = $ini_gfx_format_720

		EndIf

		If StringInStr($ini_gfx_color,"1") Then

			$option3 = $option1 & ' -out ' & $ext & ' -resize 1280 720 -o "' & $path[1] & $path[2] &  "720\" & $path[3] & "." & $ini_gfx_format_720 & '"'

			If $ini_gfx_format_720 = "tif" Then

				$option = $option3 & " -c 2 " &  $option2

			Else

				$option = $option3 & " " &  $option2

			EndIf

			_WriteLog("Rework_Graphics_File -$option = " & $option)

			ShellExecuteWait(@ScriptDir & '\nconvert.exe', $option, @ScriptDir, "", @SW_HIde)

		EndIf

		If StringInStr($ini_gfx_color,"2") Then

			$option3 = $option1 & ' -out ' & $ext & ' -resize 1280 720 -o "' & $path[1] & $path[2] &  $lng_grey & "-720\" & $path[3] & "." & $ini_gfx_format_720 & '"'

			If $ini_gfx_format_720 = "tif" Then

				$option = " -grey 256 " & $option3 & " -c 2 " &  $option2

			Else

				$option = " -grey 256 " & $option3 & " " &  $option2

			EndIf

			_WriteLog("Rework_Graphics_File -$option = " & $option)

			ShellExecuteWait(@ScriptDir & '\nconvert.exe', $option, @ScriptDir, "", @SW_HIde)

		EndIf

		If StringInStr($ini_gfx_color,"3") Then

			$option3 = $option1 & ' -out ' & $ext & ' -resize 1280 720 -o "' & $path[1] & $path[2] &  "Sepia-720\" & $path[3] & "." & $ini_gfx_format_720 & '"'

			If $ini_gfx_format_720 = "tif" Then

				$option = $option3 & " -c 2 " &  " -sepia 80 " & $option2

			Else

				$option = $option3 & " " &  " -sepia 80 " & $option2

			EndIf

			_WriteLog("Rework_Graphics_File -$option = " & $option)

			ShellExecuteWait(@ScriptDir & '\nconvert.exe', $option, @ScriptDir, "", @SW_HIde)

		EndIf

	EndIf

	$option2 = '-overwrite "' & $InFile & '"'

	If $ini_gfx600 = "1" Then

		If $ini_gfx_format_600 = "jpg" Then

			$ext = "jpeg"

		ElseIf $ini_gfx_format_600 = "tif" Then

			$ext = "tiff"

		Else

			$ext = $ini_gfx_format_600

		EndIf

		If StringInStr($ini_gfx_color,"1") Then

			$option3 = $option1 & ' -out ' & $ext & ' -resize 800 600 -o "' & $path[1] & $path[2] &  "600\" & $path[3] & "." & $ini_gfx_format_600 & '"'

			If $ini_gfx_format_600 = "tif" Then

				$option = $option3 & " -c 2 " &  $option2

			Else

				$option = $option3 & " " &  $option2

			EndIf

			_WriteLog("Rework_Graphics_File -$option = " & $option)

			ShellExecuteWait(@ScriptDir & '\nconvert.exe', $option, @ScriptDir, "", @SW_HIde)

		EndIf

		If StringInStr($ini_gfx_color,"2") Then

			$option3 = $option1 & ' -resize 800 600 -o "' & $path[1] & $path[2] &  $lng_grey & "-600\" & $path[3] & "." & $ini_gfx_format_600 & '"'

			If $ini_gfx_format_600 = "tif" Then

				$option = " -grey 256 " & $option3 & " -c 2 " &  $option2

			Else

				$option = " -grey 256 " & $option3 & " " &  $option2

			EndIf

			_WriteLog("Rework_Graphics_File -$option = " & $option)

			ShellExecuteWait(@ScriptDir & '\nconvert.exe', $option, @ScriptDir, "", @SW_HIde)

		EndIf

		If StringInStr($ini_gfx_color,"3") Then

			$option3 = $option1 & ' -resize 800 600 -o "' & $path[1] & $path[2] &  "Sepia-600\" & $path[3] & "." & $ini_gfx_format_600 & '"'

			If $ini_gfx_format_600 = "tif" Then

				$option = $option3 & " -c 2 " &  " -sepia 80 " & $option2

			Else

				$option = $option3 & " " &  " -sepia 80 " & $option2

			EndIf

			_WriteLog("Rework_Graphics_File -$option = " & $option)

			ShellExecuteWait(@ScriptDir & '\nconvert.exe', $option, @ScriptDir, "", @SW_HIde)

		EndIf

	EndIf

	$option2 = '-overwrite "' & $InFile & '"'

	If $ini_gfxfree = "1" Then

		If $ini_gfx_format_free = "jpg" Then

			$ext = "jpeg"

		ElseIf $ini_gfx_format_free = "tif" Then

			$ext = "tiff"

		Else

			$ext = $ini_gfx_format_free

		EndIf


		If StringInStr($ini_gfx_color,"1") Then

			$option3 = $option1 & ' -out ' & $ext & ' -resize ' & $freefolder[1] & " " & $freefolder[2] & ' -o "' & $path[1] & $path[2] & $freefolder[2] & "\"  & $path[3] & "." & $ini_gfx_format_free & '"'

			If $ini_gfx_format_free = "tif" Then

				$option = $option3 & " -c 2 " &  $option2

			Else

				$option = $option3 & " " &  $option2

			EndIf

			_WriteLog("Rework_Graphics_File -$option = " & $option)

			ShellExecuteWait(@ScriptDir & '\nconvert.exe', $option, @ScriptDir, "", @SW_HIde)

		EndIf

		If StringInStr($ini_gfx_color,"2") Then

			$option3 = $option1 & ' -out ' & $ext & ' -resize ' & $freefolder[1] & " " & $freefolder[2] & ' -o "' & $path[1] & $path[2] &  $lng_grey & "-" & $freefolder[2] & "\"& $path[3] & "." & $ini_gfx_format_free & '"'

			If $ini_gfx_format_free = "tif" Then

				$option = " -grey 256 " & $option3 & " -c 2 " &  $option2

			Else

				$option = " -grey 256 " & $option3 & " " &  $option2

			EndIf

			_WriteLog("Rework_Graphics_File -$option = " & $option)

			ShellExecuteWait(@ScriptDir & '\nconvert.exe', $option, @ScriptDir, "", @SW_HIde)

		EndIf

		If StringInStr($ini_gfx_color,"3") Then

			$option3 = $option1 & ' -out ' & $ext & ' -resize ' & $freefolder[1] & " " & $freefolder[2] & ' -o "' & $path[1] & $path[2] &  "Sepia-" & $freefolder[2] & "\" & $path[3] & "." & $ini_gfx_format_free & '"'

			If $ini_gfx_format_free = "tif" Then

				$option = $option3 & " -c 2 " &  " -sepia 80 " & $option2

			Else

				$option = $option3 & " " &  " -sepia 80 " & $option2

			EndIf

			_WriteLog("Rework_Graphics_File -$option = " & $option)

			ShellExecuteWait(@ScriptDir & '\nconvert.exe', $option, @ScriptDir, "", @SW_HIde)

		EndIf

	EndIf

EndFunc

;Function to Rework Graphics Files with ImageMagick
Func _Rework_Graphics_File_IM($InFile)

	Local $path, $sDrive, $sDir, $sFilename, $sExtension, $break, $freefolder
	Local $option, $option1, $option2, $iPID

	_WriteLog("Rework_Graphics_File - Working On  " & $InFile)

	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_gfx_optpng", GUICtrlRead($check_26_11))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_gfx_optjpg", GUICtrlRead($check_26_12))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_gfx4k", GUICtrlRead($check_26_21))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_gfx1080", GUICtrlRead($check_26_22))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_gfx720", GUICtrlRead($check_26_23))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_gfx600", GUICtrlRead($check_26_24))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_gfxfree", GUICtrlRead($check_26_25))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_gfxorg", GUICtrlRead($check_26_26))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_gfxnormalize", GUICtrlRead($check_26_31))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_gfxunsharp", GUICtrlRead($check_26_32))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_gfx_freesize", GUICtrlRead($input_26_25))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_gfx_format_4k", GUICtrlRead($combo_26_21))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_gfx_format_1080", GUICtrlRead($combo_26_22))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_gfx_format_720", GUICtrlRead($combo_26_23))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_gfx_format_600", GUICtrlRead($combo_26_24))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_gfx_format_free", GUICtrlRead($combo_26_25))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_gfx_format_org", GUICtrlRead($combo_26_26))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_gfx_value_unsharp", GUICtrlRead($combo_26_32))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_gfx_moveorg", GUICtrlRead($check_57_21))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_gfx_optorg", GUICtrlRead($check_57_22))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_gfx_rotate", GUICtrlRead($check_57_23))
	If GUICtrlRead($radio_26_31) = 1 Then IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_gfx_color", "1")
	If GUICtrlRead($radio_26_32) = 1 Then IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_gfx_color", "1|2")
	If GUICtrlRead($radio_26_33) = 1 Then IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_gfx_color", "1|3")
	If GUICtrlRead($radio_26_34) = 1 Then IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_gfx_color", "1|2|3")
	If GUICtrlRead($radio_26_35) = 1 Then IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_gfx_color", "2")
	If GUICtrlRead($radio_26_36) = 1 Then IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_gfx_color", "3")
	If GUICtrlRead($radio_26_37) = 1 Then IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_gfx_color", "2|3")


	$ini_gfx_optjpg = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_gfx_optjpg", "1")
	$ini_gfx_optpng = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_gfx_optpng", "1")
	$ini_gfx_moveorg = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_gfx_moveorg", "1")
	$ini_gfx_rotate = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_gfx_rotate", "1")
	$ini_gfx_optorg = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_gfx_optorg", "4")
	$ini_gfx4k = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_gfx4k", "1")
	$ini_gfx1080 = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_gfx1080", "4")
	$ini_gfx720 = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_gfx720", "4")
	$ini_gfx600 = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_gfx600", "1")
	$ini_gfxfree = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_gfxfree", "4")
	$ini_gfxorg = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_gfxorg", "4")
	$ini_gfxnormalize = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_gfxnormalize", "1")
	$ini_gfxunsharp = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_gfxunsharp", "1")
	$ini_gfx_value_unsharp = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_gfx_value_unsharp", "2")
	$ini_gfx_freesize = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_gfx_freesize", "1280x1024")
	$ini_gfx_format_4k = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_gfx_format_4k", "jpg")
	$ini_gfx_format_1080 = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_gfx_format_1080", "jpg")
	$ini_gfx_format_720 = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_gfx_format_720", "jpg")
	$ini_gfx_format_600 = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_gfx_format_600", "jpg")
	$ini_gfx_format_free = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_gfx_format_free", "jpg")
	$ini_gfx_format_org = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_gfx_format_org", "tif")
	$ini_gfx_color = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_gfx_color", "1")

	$path = _PathSplit(StringReplace($InFile,"\'", "'"), $sDrive, $sDir, $sFilename, $sExtension)

	If $ini_gfx_moveorg = "1" Then DirCreate($path[1] & $path[2] & "\Original")
	If $ini_gfx_moveorg = "1" Then DirCreate($path[1] & $path[2] & "\Raw")

	If $ini_gfx_value_unsharp = "1" then $value_unsharp = "2 0.5 0 "
	If $ini_gfx_value_unsharp = "2" then $value_unsharp = "5 0.5 0 "
	If $ini_gfx_value_unsharp = "3" then $value_unsharp = "7 0.5 0 "
	If $ini_gfx_value_unsharp = "4" then $value_unsharp = "10 0.8 2 "
	If $ini_gfx_value_unsharp = "5" then $value_unsharp = "20 1 3 "


	If StringInStr($ini_gfx_color,"1") Then

		If $ini_gfx4k = "1" Then DirCreate($path[1] & $path[2] & "\2160")
		If $ini_gfx1080 = "1" Then DirCreate($path[1] & $path[2] & "\1080")
		If $ini_gfx720 = "1" Then DirCreate($path[1] & $path[2] & "\720")
		If $ini_gfx600 = "1" Then DirCreate($path[1] & $path[2] & "\600")
		If $ini_gfxorg = "1" Then DirCreate($path[1] & $path[2] & "\Org")
		If $ini_gfxfree = "1" Then

			$freefolder = StringSplit($ini_gfx_freesize, "x")

			If _ElementExists($freefolder, 2) Then DirCreate($path[1] & $path[2] & "\" & $freefolder[2])

		EndIf

	EndIf

	If StringInStr($ini_gfx_color,"2") Then

		If $ini_gfx4k = "1" Then DirCreate($path[1] & $path[2] & "\" & $lng_grey & "-2160")
		If $ini_gfx1080 = "1" Then DirCreate($path[1] & $path[2] & "\" & $lng_grey & "-1080")
		If $ini_gfx720 = "1" Then DirCreate($path[1] & $path[2] & "\" & $lng_grey & "-720")
		If $ini_gfx600 = "1" Then DirCreate($path[1] & $path[2] & "\" & $lng_grey & "-600")
		If $ini_gfxOrg = "1" Then DirCreate($path[1] & $path[2] & "\" & $lng_grey & "-Org")
		If $ini_gfxfree = "1" Then

			$freefolder = StringSplit($ini_gfx_freesize, "x")

			If _ElementExists($freefolder, 2) Then DirCreate($path[1] & $path[2] & "\" & $lng_grey & "-" & $freefolder[2])

		EndIf

	EndIf

	If StringInStr($ini_gfx_color,"3") Then

		If $ini_gfx4k = "1" Then DirCreate($path[1] & $path[2] & "\Sepia-2160")
		If $ini_gfx1080 = "1" Then DirCreate($path[1] & $path[2] & "\Sepia-1080")
		If $ini_gfx720 = "1" Then DirCreate($path[1] & $path[2] & "\Sepia-720")
		If $ini_gfx600 = "1" Then DirCreate($path[1] & $path[2] & "\Sepia-600")
		If $ini_gfxorg = "1" Then DirCreate($path[1] & $path[2] & "\Sepia-Org")
		If $ini_gfxfree = "1" Then

			$freefolder = StringSplit($ini_gfx_freesize, "x")

			If _ElementExists($freefolder, 2) Then DirCreate($path[1] & $path[2] & "\Sepia-" & $freefolder[2])

		EndIf

	EndIf

	$option1 = ""

	$option2 = '"' & $InFile & '"'

	If $ini_gfxnormalize = "1" Then $option1 = $option1 & ' -normalize '

	If $ini_gfxunsharp = "1" Then $option1 = $option1 & ' -unsharp ' & $ini_gfx_value_unsharp & " "

	If $ini_gfx_rotate = "1" Then $option1 = $option1 & ' -auto-orient '

	If $ini_gfxorg = "1" Then

		If StringInStr($ini_gfx_color,"1") Then

			$option1 = $option1 & '"' & $path[1] & $path[2] &  "Org\" & $path[3] & "." & $ini_gfx_format_org & '"'

			$option = $option2 & $option1

			_WriteLog("Rework_Graphics_File -$option = " & $option)

			ShellExecuteWait(@ScriptDir & '\convert.exe', $option, @ScriptDir, "", @SW_HIde)

			$option = '-overwrite_original_in_place -tagsfromfile "' & $InFile & '" "' & $path[1] & $path[2] &  "Org\" & $path[3] & "." & $ini_gfx_format_org & '"'

			ShellExecuteWait(@ScriptDir & "\exiftool.exe", $option, "", "", @SW_HIde)


		EndIf

		$option1 = ""

		$option2 = '"' & $InFile & '"'

		If $ini_gfxnormalize = "1" Then $option1 = $option1 & ' -normalize '

		If $ini_gfxunsharp = "1" Then $option1 = $option1 & ' -unsharp ' & $ini_gfx_value_unsharp & " "

		If $ini_gfx_rotate = "1" Then $option1 = $option1 & ' -auto-orient '

		If StringInStr($ini_gfx_color,"2") Then

			$option1 = $option1 & '"' & $path[1] & $path[2] &  $lng_grey & "-Org\" & $path[3] & "." & $ini_gfx_format_org & '"'

			$option = $option2 & " -colorspace Gray " &  $option1

			_WriteLog("Rework_Graphics_File -$option = " & $option)

			ShellExecuteWait(@ScriptDir & '\convert.exe', $option, @ScriptDir, "", @SW_HIde)

			$option = '-overwrite_original_in_place -tagsfromfile "' & $InFile & '" "' & $path[1] & $path[2] &  $lng_grey & "-Org\" & $path[3] & "." & $ini_gfx_format_org & '"'

			ShellExecuteWait(@ScriptDir & "\exiftool.exe", $option, "", "", @SW_HIde)

		EndIf

		$option1 = ""

		$option2 = '"' & $InFile & '"'

		If $ini_gfxnormalize = "1" Then $option1 = $option1 & ' -normalize '

		If $ini_gfxunsharp = "1" Then $option1 = $option1 & ' -unsharp ' & $ini_gfx_value_unsharp & " "

		If $ini_gfx_rotate = "1" Then $option1 = $option1 & ' -auto-orient '

		If StringInStr($ini_gfx_color,"3") Then

			$option1 = $option1 & '"' & $path[1] & $path[2] &  "Sepia-Org\" & $path[3] & "." & $ini_gfx_format_org & '"'

			$option = $option2 & " -sepia-tone 82% " &  $option1

			_WriteLog("Rework_Graphics_File -$option = " & $option)

			ShellExecuteWait(@ScriptDir & '\convert.exe', $option, @ScriptDir, "", @SW_HIde)

			$option = '-overwrite_original_in_place -tagsfromfile "' & $InFile & '" "' & $path[1] & $path[2] &  "Sepia-Org\" & $path[3] & "." & $ini_gfx_format_org & '"'

			ShellExecuteWait(@ScriptDir & "\exiftool.exe", $option, "", "", @SW_HIde)

		EndIf

	EndIf

		$option1 = ""

		$option2 = '"' & $InFile & '"'

		If $ini_gfxnormalize = "1" Then $option1 = $option1 & ' -normalize '

		If $ini_gfxunsharp = "1" Then $option1 = $option1 & ' -unsharp ' & $ini_gfx_value_unsharp & " "

		If $ini_gfx_rotate = "1" Then $option1 = $option1 & ' -auto-orient '

	If $ini_gfx4k = "1" Then

		If StringInStr($ini_gfx_color,"1") Then

			$option1 = $option1 & '"' & $path[1] & $path[2] &  "2160\" & $path[3] & "." & $ini_gfx_format_4k & '"'

			$option = $option2 & " -filter Lanczos2 -resize 3840x2160 " &  $option1

			_WriteLog("Rework_Graphics_File -$option = " & $option)

			ShellExecuteWait(@ScriptDir & '\convert.exe', $option, @ScriptDir, "", @SW_HIde)

			$option = '-overwrite_original_in_place -tagsfromfile "' & $InFile & '" "' & $path[1] & $path[2] &  "2160\" & $path[3] & "." & $ini_gfx_format_4k & '"'

			ShellExecuteWait(@ScriptDir & "\exiftool.exe", $option, "", "", @SW_HIde)

		EndIf

		$option1 = ""

		$option2 = '"' & $InFile & '"'

		If $ini_gfxnormalize = "1" Then $option1 = $option1 & ' -normalize '

		If $ini_gfxunsharp = "1" Then $option1 = $option1 & ' -unsharp ' & $ini_gfx_value_unsharp & " "

		If $ini_gfx_rotate = "1" Then $option1 = $option1 & ' -auto-orient '

		If StringInStr($ini_gfx_color,"2") Then

			$option1 = $option1 & '"' & $path[1] & $path[2] &  $lng_grey & "-2160\" & $path[3] & "." & $ini_gfx_format_4k & '"'

			$option = $option2 & " -colorspace Gray -filter Lanczos2 -resize 3840x2160 " &  $option1

			_WriteLog("Rework_Graphics_File -$option = " & $option)

			ShellExecuteWait(@ScriptDir & '\convert.exe', $option, @ScriptDir, "", @SW_HIde)

			$option = '-overwrite_original_in_place -tagsfromfile "' & $InFile & '" "' & $path[1] & $path[2] & $lng_grey & "-2160\" & $path[3] & "." & $ini_gfx_format_4k & '"'

			ShellExecuteWait(@ScriptDir & "\exiftool.exe", $option, "", "", @SW_HIde)

		EndIf

		$option1 = ""

		$option2 = '"' & $InFile & '"'

		If $ini_gfxnormalize = "1" Then $option1 = $option1 & ' -normalize '

		If $ini_gfxunsharp = "1" Then $option1 = $option1 & ' -unsharp ' & $ini_gfx_value_unsharp & " "

		If $ini_gfx_rotate = "1" Then $option1 = $option1 & ' -auto-orient '

		If StringInStr($ini_gfx_color,"3") Then

			$option1 = $option1 & '"' & $path[1] & $path[2] &  "Sepia-2160\" & $path[3] & "." & $ini_gfx_format_4k & '"'

			$option = $option2 & " -sepia-tone 82% -filter Lanczos2 -resize 3840x2160 " &  $option1

			_WriteLog("Rework_Graphics_File -$option = " & $option)

			ShellExecuteWait(@ScriptDir & '\convert.exe', $option, @ScriptDir, "", @SW_HIde)

			$option = '-overwrite_original_in_place -tagsfromfile "' & $InFile & '" "' & $path[1] & $path[2] &  "Sepia-2160\" & $path[3] & "." & $ini_gfx_format_4k & '"'

			ShellExecuteWait(@ScriptDir & "\exiftool.exe", $option, "", "", @SW_HIde)

		EndIf

	EndIf

		$option1 = ""

		$option2 = '"' & $InFile & '"'

		If $ini_gfxnormalize = "1" Then $option1 = $option1 & ' -normalize '

		If $ini_gfxunsharp = "1" Then $option1 = $option1 & ' -unsharp ' & $ini_gfx_value_unsharp & " "

		If $ini_gfx_rotate = "1" Then $option1 = $option1 & ' -auto-orient '

	If $ini_gfx1080 = "1" Then

		If StringInStr($ini_gfx_color,"1") Then

			$option1 = $option1 & '"' & $path[1] & $path[2] &  "1080\" & $path[3] & "." & $ini_gfx_format_1080 & '"'

			$option = $option2 & " -filter Lanczos2 -resize 1920x1080 " &  $option1

			_WriteLog("Rework_Graphics_File -$option = " & $option)

			ShellExecuteWait(@ScriptDir & '\convert.exe', $option, @ScriptDir, "", @SW_HIde)

			$option = '-overwrite_original_in_place -tagsfromfile "' & $InFile & '" "' & $path[1] & $path[2] &  "1080\" & $path[3] & "." & $ini_gfx_format_1080 & '"'

			ShellExecuteWait(@ScriptDir & "\exiftool.exe", $option, "", "", @SW_HIde)

		EndIf

		$option1 = ""

		$option2 = '"' & $InFile & '"'

		If $ini_gfxnormalize = "1" Then $option1 = $option1 & ' -normalize '

		If $ini_gfxunsharp = "1" Then $option1 = $option1 & ' -unsharp ' & $ini_gfx_value_unsharp & " "

		If $ini_gfx_rotate = "1" Then $option1 = $option1 & ' -auto-orient '

		If StringInStr($ini_gfx_color,"2") Then

			$option1 = $option1 & '"' & $path[1] & $path[2] &  $lng_grey & "-1080\" & $path[3] & "." & $ini_gfx_format_1080 & '"'

			$option = $option2 & " -colorspace Gray -filter Lanczos2 -resize 1920x1080 " &  $option1

			_WriteLog("Rework_Graphics_File -$option = " & $option)

			ShellExecuteWait(@ScriptDir & '\convert.exe', $option, @ScriptDir, "", @SW_HIde)

			$option = '-overwrite_original_in_place -tagsfromfile "' & $InFile & '" "' & $path[1] & $path[2] &  $lng_grey & "-1080\" & $path[3] & "." & $ini_gfx_format_1080 & '"'

			ShellExecuteWait(@ScriptDir & "\exiftool.exe", $option, "", "", @SW_HIde)

		EndIf

		$option1 = ""

		$option2 = '"' & $InFile & '"'

		If $ini_gfxnormalize = "1" Then $option1 = $option1 & ' -normalize '

		If $ini_gfxunsharp = "1" Then $option1 = $option1 & ' -unsharp ' & $ini_gfx_value_unsharp & " "

		If $ini_gfx_rotate = "1" Then $option1 = $option1 & ' -auto-orient '

		If StringInStr($ini_gfx_color,"3") Then

			$option1 = $option1 & '"' & $path[1] & $path[2] &  "Sepia-1080\" & $path[3] & "." & $ini_gfx_format_1080 & '"'

			$option = $option2 & " -sepia-tone 82% -filter Lanczos2 -resize 1920x1080 " &  $option1

			_WriteLog("Rework_Graphics_File -$option = " & $option)

			ShellExecuteWait(@ScriptDir & '\convert.exe', $option, @ScriptDir, "", @SW_HIde)

			$option = '-overwrite_original_in_place -tagsfromfile "' & $InFile & '" "' & $path[1] & $path[2] &  "Sepia-1080\" & $path[3] & "." & $ini_gfx_format_1080 & '"'

			ShellExecuteWait(@ScriptDir & "\exiftool.exe", $option, "", "", @SW_HIde)

		EndIf

	EndIf

		$option1 = ""

		$option2 = '"' & $InFile & '"'

		If $ini_gfxnormalize = "1" Then $option1 = $option1 & ' -normalize '

		If $ini_gfxunsharp = "1" Then $option1 = $option1 & ' -unsharp ' & $ini_gfx_value_unsharp & " "

		If $ini_gfx_rotate = "1" Then $option1 = $option1 & ' -auto-orient '

	If $ini_gfx720 = "1" Then

		If StringInStr($ini_gfx_color,"1") Then

			$option1 = $option1 & '"' & $path[1] & $path[2] &  "720\" & $path[3] & "." & $ini_gfx_format_720 & '"'

			$option = $option2 & " -filter Lanczos2 -resize 1280x720 " &  $option1

			_WriteLog("Rework_Graphics_File -$option = " & $option)

			ShellExecuteWait(@ScriptDir & '\convert.exe', $option, @ScriptDir, "", @SW_HIde)

			$option = '-overwrite_original_in_place -tagsfromfile "' & $InFile & '" "' & $path[1] & $path[2] &  "720\" & $path[3] & "." & $ini_gfx_format_720 & '"'

			ShellExecuteWait(@ScriptDir & "\exiftool.exe", $option, "", "", @SW_HIde)

		EndIf

		$option1 = ""

		$option2 = '"' & $InFile & '"'

		If $ini_gfxnormalize = "1" Then $option1 = $option1 & ' -normalize '

		If $ini_gfxunsharp = "1" Then $option1 = $option1 & ' -unsharp ' & $ini_gfx_value_unsharp & " "

		If $ini_gfx_rotate = "1" Then $option1 = $option1 & ' -auto-orient '

		If StringInStr($ini_gfx_color,"2") Then

			$option1 = $option1 & '"' & $path[1] & $path[2] &  $lng_grey & "-720\" & $path[3] & "." & $ini_gfx_format_720 & '"'

			$option = $option2 & " -colorspace Gray -filter Lanczos2 -resize 1280x720 " &  $option1

			_WriteLog("Rework_Graphics_File -$option = " & $option)

			ShellExecuteWait(@ScriptDir & '\convert.exe', $option, @ScriptDir, "", @SW_HIde)

			$option = '-overwrite_original_in_place -tagsfromfile "' & $InFile & '" "' & $path[1] & $path[2] &  $lng_grey & "-720\" & $path[3] & "." & $ini_gfx_format_720 & '"'

			ShellExecuteWait(@ScriptDir & "\exiftool.exe", $option, "", "", @SW_HIde)

		EndIf

		$option1 = ""

		$option2 = '"' & $InFile & '"'

		If $ini_gfxnormalize = "1" Then $option1 = $option1 & ' -normalize '

		If $ini_gfxunsharp = "1" Then $option1 = $option1 & ' -unsharp ' & $ini_gfx_value_unsharp & " "

		If $ini_gfx_rotate = "1" Then $option1 = $option1 & ' -auto-orient '

		If StringInStr($ini_gfx_color,"3") Then

			$option1 = $option1 & '"' & $path[1] & $path[2] &  "Sepia-720\" & $path[3] & "." & $ini_gfx_format_720 & '"'

			$option = $option2 & " -sepia-tone 82% -filter Lanczos2 -resize 1280x720 " &  $option1

			_WriteLog("Rework_Graphics_File -$option = " & $option)

			ShellExecuteWait(@ScriptDir & '\convert.exe', $option, @ScriptDir, "", @SW_HIde)

			$option = '-overwrite_original_in_place -tagsfromfile "' & $InFile & '" "' & $path[1] & $path[2] &  "Sepia-720\" & $path[3] & "." & $ini_gfx_format_720 & '"'

			ShellExecuteWait(@ScriptDir & "\exiftool.exe", $option, "", "", @SW_HIde)

		EndIf

	EndIf

		$option1 = ""

		$option2 = '"' & $InFile & '"'

		If $ini_gfxnormalize = "1" Then $option1 = $option1 & ' -normalize '

		If $ini_gfxunsharp = "1" Then $option1 = $option1 & ' -unsharp ' & $ini_gfx_value_unsharp & " "

		If $ini_gfx_rotate = "1" Then $option1 = $option1 & ' -auto-orient '

	If $ini_gfx600 = "1" Then

		If StringInStr($ini_gfx_color,"1") Then

			$option1 = $option1 & '"' & $path[1] & $path[2] &  "600\" & $path[3] & "." & $ini_gfx_format_600 & '"'

			$option = $option2 & " -filter Lanczos2 -resize 800x600 " &  $option1

			_WriteLog("Rework_Graphics_File -$option = " & $option)

			ShellExecuteWait(@ScriptDir & '\convert.exe', $option, @ScriptDir, "", @SW_HIde)

			$option = '-overwrite_original_in_place -tagsfromfile "' & $InFile & '" "' & $path[1] & $path[2] &  "600\" & $path[3] & "." & $ini_gfx_format_600 & '"'

			ShellExecuteWait(@ScriptDir & "\exiftool.exe", $option, "", "", @SW_HIde)

		EndIf

		$option1 = ""

		$option2 = '"' & $InFile & '"'

		If $ini_gfxnormalize = "1" Then $option1 = $option1 & ' -normalize '

		If $ini_gfxunsharp = "1" Then $option1 = $option1 & ' -unsharp ' & $ini_gfx_value_unsharp & " "

		If $ini_gfx_rotate = "1" Then $option1 = $option1 & ' -auto-orient '

		If StringInStr($ini_gfx_color,"2") Then

			$option1 = $option1 & '"' & $path[1] & $path[2] &  $lng_grey & "-600\" & $path[3] & "." & $ini_gfx_format_600 & '"'

			$option = $option2 & " -colorspace Gray -filter Lanczos2 -resize 800x600 " &  $option1

			_WriteLog("Rework_Graphics_File -$option = " & $option)

			ShellExecuteWait(@ScriptDir & '\convert.exe', $option, @ScriptDir, "", @SW_HIde)

			$option = '-overwrite_original_in_place -tagsfromfile "' & $InFile & '" "' & $path[1] & $path[2] &  $lng_grey & "-600\" & $path[3] & "." & $ini_gfx_format_600 & '"'

			ShellExecuteWait(@ScriptDir & "\exiftool.exe", $option, "", "", @SW_HIde)

		EndIf

		$option1 = ""

		$option2 = '"' & $InFile & '"'

		If $ini_gfxnormalize = "1" Then $option1 = $option1 & ' -normalize '

		If $ini_gfxunsharp = "1" Then $option1 = $option1 & ' -unsharp ' & $ini_gfx_value_unsharp & " "

		If $ini_gfx_rotate = "1" Then $option1 = $option1 & ' -auto-orient '

		If StringInStr($ini_gfx_color,"3") Then

			$option1 = $option1 & '"' & $path[1] & $path[2] &  "Sepia-600\" & $path[3] & "." & $ini_gfx_format_600 & '"'

			$option = $option2 & " -sepia-tone 82% -filter Lanczos2 -resize 800x600 " &  $option1

			_WriteLog("Rework_Graphics_File -$option = " & $option)

			ShellExecuteWait(@ScriptDir & '\convert.exe', $option, @ScriptDir, "", @SW_HIde)

			$option = '-overwrite_original_in_place -tagsfromfile "' & $InFile & '" "' & $path[1] & $path[2] &  "Sepia-600\" & $path[3] & "." & $ini_gfx_format_600 & '"'

			ShellExecuteWait(@ScriptDir & "\exiftool.exe", $option, "", "", @SW_HIde)

		EndIf

	EndIf

		$option1 = ""

		$option2 = '"' & $InFile & '"'

		If $ini_gfxnormalize = "1" Then $option1 = $option1 & ' -normalize '

		If $ini_gfxunsharp = "1" Then $option1 = $option1 & ' -unsharp ' & $ini_gfx_value_unsharp & " "

		If $ini_gfx_rotate = "1" Then $option1 = $option1 & ' -auto-orient '

	If $ini_gfxfree = "1" Then

		If StringInStr($ini_gfx_color,"1") Then

			$option1 = $option1 & '"' & $path[1] & $path[2] & $freefolder[2] & "\" & $path[3] & "." & $ini_gfx_format_free & '"'

			$option = $option2 & " -filter Lanczos2 -resize " & $ini_gfx_freesize & " " &  $option1

			_WriteLog("Rework_Graphics_File -$option = " & $option)

			ShellExecuteWait(@ScriptDir & '\convert.exe', $option, @ScriptDir, "", @SW_HIde)

			$option = '-overwrite_original_in_place -tagsfromfile "' & $InFile & '" "' & $path[1] & $path[2] & $freefolder[2] & "\" & $path[3] & "." & $ini_gfx_format_free & '"'

			ShellExecuteWait(@ScriptDir & "\exiftool.exe", $option, "", "", @SW_HIde)

		EndIf

		$option1 = ""

		$option2 = '"' & $InFile & '"'

		If $ini_gfxnormalize = "1" Then $option1 = $option1 & ' -normalize '

		If $ini_gfxunsharp = "1" Then $option1 = $option1 & ' -unsharp ' & $ini_gfx_value_unsharp & " "

		If $ini_gfx_rotate = "1" Then $option1 = $option1 & ' -auto-orient '

		If StringInStr($ini_gfx_color,"2") Then

			$option1 = $option1 & '"' & $path[1] & $path[2] & $lng_grey & "-" & $freefolder[2] & "\" & $path[3] & "." & $ini_gfx_format_free & '"'

			$option = $option2 & " -colorspace Gray -filter Lanczos2 -resize " & $ini_gfx_freesize & " " &  $option1

			_WriteLog("Rework_Graphics_File -$option = " & $option)

			ShellExecuteWait(@ScriptDir & '\convert.exe', $option, @ScriptDir, "", @SW_HIde)

			$option = '-overwrite_original_in_place -tagsfromfile "' & $InFile & '" "' & $path[1] & $path[2] & $lng_grey & "-" & $freefolder[2] & "\" & $path[3] & "." & $ini_gfx_format_free & '"'

			ShellExecuteWait(@ScriptDir & "\exiftool.exe", $option, "", "", @SW_HIde)

		EndIf

		$option1 = ""

		$option2 = '"' & $InFile & '"'

		If $ini_gfxnormalize = "1" Then $option1 = $option1 & ' -normalize '

		If $ini_gfxunsharp = "1" Then $option1 = $option1 & ' -unsharp ' & $ini_gfx_value_unsharp & " "

		If $ini_gfx_rotate = "1" Then $option1 = $option1 & ' -auto-orient '

		If StringInStr($ini_gfx_color,"3") Then

			$option1 = $option1 & '"' & $path[1] & $path[2] & "Sepia-" & $freefolder[2] & "\" & $path[3] & "." & $ini_gfx_format_free & '"'

			$option = $option2 & " -sepia-tone 82% -filter Lanczos2 -resize " & $ini_gfx_freesize & " " &  $option1

			_WriteLog("Rework_Graphics_File -$option = " & $option)

			ShellExecuteWait(@ScriptDir & '\convert.exe', $option, @ScriptDir, "", @SW_HIde)

			$option = '-overwrite_original_in_place -tagsfromfile "' & $InFile & '" "' & $path[1] & $path[2] & "Sepia-" & $freefolder[2] & "\" & $path[3] & "." & $ini_gfx_format_free & '"'

			ShellExecuteWait(@ScriptDir & "\exiftool.exe", $option, "", "", @SW_HIde)

		EndIf

	EndIf

EndFunc

;Function to Transcode Audio Files
Func _RecodeAudioFile($InFile1, $OutFile, $progressbar = "0000", $Cancelbutton = "0000", $count = 1, $i_global = 1)

	Local $path, $query, $iRval, $aResult, $iRows, $iColumns, $sDrive, $sDir, $sFilename, $sExtension, $option
	Local $bitrate, $sampling, $break = 0, $iPID, $a, $split, $ogg, $acompress, $compress, $InFile

	If GUICtrlRead($radio_14_11) = 1 Then IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_arecode_container", "mp3")
	If GUICtrlRead($radio_14_21) = 1 Then IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_arecode_container", "flac")
	If GUICtrlRead($radio_14_31) = 1 Then IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_arecode_container", "wav")
	If GUICtrlRead($radio_14_41) = 1 Then IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_arecode_container", "ogg")

	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_arecode_bitrate_mp3", GUICtrlRead($combo_14_21))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_arecode_bitrate_flac", GUICtrlRead($combo_14_22))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_arecode_bitrate_opus", GUICtrlRead($combo_14_24))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_arecode_samplingrate_mp3", GUICtrlRead($combo_14_31))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_arecode_samplingrate_flac", GUICtrlRead($combo_14_32))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_arecode_samplingrate_wav", GUICtrlRead($combo_14_33))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_arecode_quality_opus", GUICtrlRead($combo_14_34))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_aaudio_compression", GUICtrlRead($combo_98_01))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_aaudio_db", GUICtrlRead($input_98_01))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_aaudio_normalize", Int(GUICtrlRead($check_98_01)))

	$ini_arecode_container = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_arecode_container", "flac")
	$ini_arecode_autoend = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_arecode_autoend", "4")
	$ini_arecode_bitrate_mp3 = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_arecode_bitrate_mp3", "128")
	$ini_arecode_bitrate_flac = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_arecode_bitrate_flac", "768")
	$ini_arecode_bitrate_opus = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_arecode_bitrate_opus", "128")
	$ini_arecode_samplingrate_mp3 = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_arecode_samplingrate_mp3", "48000")
	$ini_arecode_samplingrate_flac = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_arecode_samplingrate_flac", "48000")
	$ini_arecode_samplingrate_wav = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_arecode_samplingrate_wav", "44100")
	$ini_arecode_quality_opus = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_arecode_quality_opus", "3")
	$ini_aaudio_compression = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_aaudio_compression", "0")
	$ini_aaudio_db = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_aaudio_db", "0,95")
	$ini_aaudio_normalize = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_aaudio_normalize", "0")

	$InFile = StringReplace($InFile1,"'", "''")

	_WriteLog("AudioRecodeFile - Start Working On  " & $InFile)

	$path = _PathSplit(StringReplace($InFile,"\'", "'"), $sDrive, $sDir, $sFilename, $sExtension)

 	If $path[4] = ".ogg" Then

		$ogg = " -max_muxing_queue_size 10000 -map_metadata 0:s:0 "

	Else

		$ogg = ""

	EndIf

	If $ini_arecode_container = "flac" Then

		$bitrate = " -compression_level " & ($ini_arecode_bitrate_flac)

		$sampling = " -ar " & $ini_arecode_samplingrate_flac

	EndIf

	If $ini_arecode_container = "mp3" Then

		$bitrate = " -c:a libmp3lame -b:a " & $ini_arecode_bitrate_mp3 & "k"

		$sampling = " -ar " & $ini_arecode_samplingrate_mp3

	EndIf

	If $ini_arecode_container = "wav" Then

		$bitrate = ""

		$sampling = " -ar " & $ini_arecode_samplingrate_wav

	EndIf

	If $ini_arecode_container = "ogg" Then

		$bitrate = "-c:a libopus  -af aformat=channel_layouts='7.1|5.1|stereo' -b:a " & (int($ini_arecode_bitrate_opus) * 1000)

		$sampling = " -compression_level " & $ini_arecode_quality_opus

	EndIf

	If $ini_aaudio_normalize = 1 Then

		If $ini_aaudio_compression = 0 Then $compress = ""
		If $ini_aaudio_compression = 1 Then $compress = ":s=22"
		If $ini_aaudio_compression = 2 Then $compress = ":s=15"
		If $ini_aaudio_compression = 3 Then $compress = ":s=11"
		If $ini_aaudio_compression = 4 Then $compress = ":s=7"

		$acompress = ' -af dynaudnorm=p=' & StringReplace($ini_aaudio_db, ",", ".") & ':f=500:m=10' & $compress & ':g=11:r=' & StringReplace($ini_aaudio_db, ",", ".") & ':b=false'

	Else

		$acompress = ""

	EndIf

	;Start Transcoding

	$split = _PathSplit($OutFile, $sDrive, $sDir, $sFilename, $sExtension)

	DirCreate($split[1] & $split[2])

	$option = ' -i "' & $InFile & '" -y ' & $ogg & $bitrate & $sampling & $acompress & ' "' & $OutFile & '"'

	_WriteLog("AudioRecodeFile - $option =   " & $option)

	$iPID = ShellExecute($ini_ffmpeg_path, $option, "", "", @SW_HIde)

	Sleep(10000)

	While ProcessExists("ffmpeg.exe")

		_GetTime()

		$a = GUIGetCursorInfo()

		If IsArray($a) Then

			If $a[2] = 1 And $a[4] = $Cancelbutton Then

				$value = MsgBox(19, $lng_cancel, $lng_cancel1 & @CRLF & $lng_areyousure & "." & @CRLF & @CRLF & $lng_cancel2 & @CRLF & $lng_cancel3 & @CRLF & $lng_cancel4)

				If $value = 2 Then ;Instantly Abort

					_WriteLog("AudioRecodeFile - Triggered Instant Abort")

					_CloseProcess($iPID)

					$break = 1

				EndIf

				If $value = 6 Then ;Finish File and Abort

					_WriteLog("AudioRecodeFile - Triggered Abort After Recent File")

					$break = 1

				EndIf

			EndIf

		EndIf

		Sleep(200)

	WEnd

	$step1 = 100 / $Count

	$p = ($step1 * $i_global)

	_SetData($progressbar, $p)

	_WriteLog("AudioRecodeFile - Finished Working On  " & $InFile)

	Return $break

EndFunc

;Function to Transcode Files
Func _RecodeFile($InFile, $OutFile, $codec = 1, $Cancelbutton = "0000", $progressbar = "0000", $progressbar2 = "0000", $count = 1, $i_global = 1)

	Local $path, $MediaInfo, $aRow, $width, $height, $fOutput, $framerate, $pos, $len, $length, $Progre, $ScanType, $br, $br1, $video, $Pr = "", $hw
	Local $query, $iRval, $aResult, $iRows, $iColumns, $TrueHD, $DTS, $AC3, $AAC, $MP3, $NeedFallback, $trackNumbers, $audio, $acodec, $acode, $hwcodec
	Local $ForcedNumbers, $bResult, $i, $textNumbers, $option, $iPID, $a, $value, $break, $sOutput, $result, $StringLine, $aString, $astring1 = "00"
	Local $Forced, $option3, $option4, $sDrive = "", $sDir = "", $sFilename = "", $sExtension = "", $txtNumbers, $subtitle, $step1, $p, $acompress
	Local $videomap, $Rows, $Columns, $tracks, $Res, $vtrack, $Rval, $seek = "", $externalsubs = "", $forced = "", $subs = "", $dvb = 0, $compress
	Local $simplecut = "0", $ss = "", $to = "", $aMyTime, $bMyTime, $time = "", $hh, $mm, $se, $time, $fle_hwnd, $cutpoints


	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_audiolanguages", GUICtrlRead($input_90_10))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_sublanguages", GUICtrlRead($input_90_11))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_useoptimizer", GUICtrlRead($check_90_01))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_useoptimizer_subs", GUICtrlRead($check_90_02))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_tracksperlanguage_audio", GUICtrlRead($input_90_04))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_tracksperlanguage_forced", GUICtrlRead($input_90_05))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_tracksperlanguage_sub", GUICtrlRead($input_90_06))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_tracks_video", GUICtrlRead($input_90_12))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_useoptimizer_video", GUICtrlRead($check_90_12))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_codec", GUICtrlRead($combo_52_05))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_recode_quality_sd", GUICtrlRead($input_21_03))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_recode_quality_720", GUICtrlRead($input_21_04))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_recode_quality_1080", GUICtrlRead($input_21_06))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_recode_quality_4k", GUICtrlRead($input_21_08))

	If GUICtrlRead($radio_21_06) = 1 Then IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_recode_audiocodec", "1")
	If GUICtrlRead($radio_21_07) = 1 Then IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_recode_audiocodec", "2")
	If GUICtrlRead($radio_21_08) = 1 Then IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_recode_audiocodec", "3")
	If GUICtrlRead($radio_21_09) = 1 Then IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_recode_audiocodec", "4")
	If GUICtrlRead($radio_21_10) = 1 Then IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_recode_audiocodec", "5")
	If GUICtrlRead($radio_21_11) = 1 Then IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_recode_audiocodec", "6")
	If GUICtrlRead($radio_21_12) = 1 Then IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_recode_audiocodec", "7")

	$ini_recode_audiocodec = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_recode_audiocodec", "1")
	$ini_recode_audiofallback = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_recode_audiofallback", "3")
	$ini_recode_quality_sd = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_recode_quality_sd", "26")
	$ini_recode_quality_720 = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_recode_quality_720", "22")
	$ini_recode_quality_1080 = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_recode_quality_1080", "21")
	$ini_recode_quality_4k = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_recode_quality_4k", "17")
	$ini_tracksperlanguage_audio = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_tracksperlanguage_audio", "1")
	$ini_tracksperlanguage_sub = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_tracksperlanguage_sub", "0")
	$ini_tracksperlanguage_forced = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_tracksperlanguage_forced", "1")
	$ini_useoptimizer = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_useoptimizer", "1")
	$ini_useoptimizer_subs = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_useoptimizer_subs", "1")
	$ini_useoptimizer_video = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_useoptimizer_video", "1")
	$ini_recode_container = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_recode_container", "mkv")
	$ini_tracks_video = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_tracks_video", "1")
	$ini_codec = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_codec", "AAC")
	$ini_audio_normalize = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_audio_normalize", "1")

	If GUICtrlRead($radio_52_01) = 1 Then $hwcodec = ""
	If GUICtrlRead($radio_52_02) = 1 Then $hwcodec = "_amf"
	If GUICtrlRead($radio_52_03) = 1 Then $hwcodec = "_qsv"
	If GUICtrlRead($radio_52_04) = 1 Then $hwcodec = "_nvenc"

	_WriteLog("RecodeFile - Start Working On  " & $InFile)

	$videomap = ""

	$path = _PathSplit(StringReplace($InFile,"\'", "'"), $sDrive, $sDir, $sFilename, $sExtension)

	If FileExists($path[1] & $path[2] & $path[3] & ".csv") Then

		$fle_hwnd = FileOpen($path[1] & $path[2] & $path[3] & ".csv", 0)

		$time = FileRead($fle_hwnd)

		FileClose($fle_hwnd)

		$cutpoints = StringSplit($time,",")

	ElseIf FileExists($path[1] & $path[2] & $path[3] & $path[4] & ".csv") Then

		$fle_hwnd = FileOpen($path[1] & $path[2] & $path[3] & $path[4] & ".csv", 0)

		$time = FileRead($fle_hwnd)

		FileClose($fle_hwnd)

		$cutpoints = StringSplit($time,",")

	EndIf

	If $time <> "" Then

		If $cutpoints[0] < 4 And $cutpoints[0] > 0 Then

			$simplecut = 1

		ElseIf $cutpoints[0] > 3 Then

			$simplecut = 2

		EndIf

	Else

		$simplecut = 0

	EndIf

	; Test if DVB subtitle are existing

	$query = 'SELECT * FROM Text WHERE Format LIKE "DVB Subtitle" ;'

	$iRval = _SQLite_GetTable2d(-1, $query, $aResult, $iRows, $iColumns)

	_SQLite_QueryFinalize($iRval)

	If UBound($aResult) > 1 Then $dvb = 1

	; Test if Teletext subtitle are existing

	$query = 'SELECT * FROM Text WHERE Format LIKE "Teletext Subtitle" ;'

	$iRval = _SQLite_GetTable2d(-1, $query, $aResult, $iRows, $iColumns)

	_SQLite_QueryFinalize($iRval)

	If UBound($aResult) > 1 Then $dvb = 1

	If $dvb = 1	Then $seek = $seek & " -fix_sub_duration"

	; Test if PGS subtitle are existing

	$query = 'SELECT * FROM Text WHERE Format LIKE "PGS" ;'

	$iRval = _SQLite_GetTable2d(-1, $query, $aResult, $iRows, $iColumns)

	_SQLite_QueryFinalize($iRval)

	If UBound($aResult) > 1 Then $seek = $seek & " -analyzeduration 2000M -probesize 2000M"

	;Video Options

	$query = 'SELECT VideoID FROM Video ;'

	$Rval = _SQLite_GetTable2d(-1, $query, $Res, $Rows, $Columns)

	_SQLite_QuerySingleRow(-1,"SELECT * FROM Video LIMIT 1;",$aRow)

	$vtrack = $aRow[1]

	$width = $aRow[5]

	$height = $aRow[6]

	$fOutput = StringRegExpReplace($aRow[7], "[^0-9.]", "")
	$framerate = StringReplace($fOutput, ".000", "")

	$pos = StringInStr($aRow[3], "h")
	If $pos = 0 Then
		$length = 0
	Else
		$length = 1
	EndIf

	$Progre = $aRow[9]
	If $Progre = "Progressive" Then

		$Pr = ""

	Else
		$Pr = ' -filter:v yadif'

	EndIf

	If $width < 900 Then

		$br = $ini_recode_quality_sd

		$codec = GUICtrlRead($combo_21_01)

	EndIf

	If $width > 899 And $width < 1400 Then

		$br = $ini_recode_quality_720

		$codec = GUICtrlRead($combo_21_02)

	EndIf

	If $width > 1399 And $width < 2500 Then

		$br = $ini_recode_quality_1080

		$codec = GUICtrlRead($combo_21_04)

	EndIf

	If $width > 2499 Then $br = $ini_recode_quality_4k

	$br1 = ' -q:v ' & $br

	If $codec = "h264 AVC" Then

		$video = ' -c:v h264' & $hwcodec

	EndIf

	If $codec = "h265 HEVC" Then

		$video = ' -c:v hevc' & $hwcodec

	EndIf

	If $ini_useoptimizer_video = 1 Then

		If UBound($Res) > 2 Then

			For $i = 1 To $ini_tracks_video

 				$videomap = $videomap & " -map 0:" & $Res[$i][0]

			Next

		Else

 			$videomap = " -map 0:" & $vtrack

		EndIf

 	EndIf

	If $ini_useoptimizer_video = 4 Then

 		$videomap = " -map 0:" & $vtrack

	EndIf

	; Audio Options

	$query = 'SELECT AudioID FROM Audio ;'

	$Rval = _SQLite_GetTable2d(-1, $query, $Res, $Rows, $Columns)

	_SQLite_QuerySingleRow(-1,"SELECT * FROM Audio LIMIT 1;",$aRow)

	If GUICtrlRead($radio_21_06) = 1 Then $acodec = " -c:a ac3 -ar 48000"
	If GUICtrlRead($radio_21_07) = 1 Then $acodec = " -c:a aac -ar 48000"
	If GUICtrlRead($radio_21_08) = 1 Then $acodec = " -c:a libmp3lame -b:a 192k -ar 48000"
	If GUICtrlRead($radio_21_09) = 1 Then $acodec = " -c:a flac -ar 48000"
	If GUICtrlRead($radio_21_10) = 1 Then $acodec = " -c:a libopus -b:a 128k -af aformat=channel_layouts='7.1|5.1|stereo'"
	If GUICtrlRead($radio_21_12) = 1 Then $acodec = " -c:a dca -strict -2"
	If GUICtrlRead($radio_21_13) = 1 Then $acodec = " -c:a truehd -strict -2"
	If GUICtrlRead($radio_21_11) = 1 Then

;~ _ArrayDisplay($ArrayAudioWhitelist)

		If $ini_transcode_allaudio = 1 Then

			If _ArraySearch($ArrayAudioWhitelist, $aRow[2]) > -1 Then
;~ 			If _ArraySearch($ArrayAudioWhitelist, $aRow[2]) > -1 And $ini_audio_normalize = 0 Then


				$acodec = " -c:a copy"

			Else

				If $ini_codec = "AAC" Then $acodec = " -c:a aac -ar 48000"
				If $ini_codec = "AC-3" Then $acodec = " -c:a ac3 -ar 48000"
				If $ini_codec = "MP3" Then $acodec = " -c:a libmp3lame -b:a 192k -ar 48000"
				If $ini_codec = "FLAC" Then $acodec = " -c:a flac -ar 48000"
				If $ini_codec = "OPUS" Then $acodec = " -c:a libopus -b:a 128k -af aformat=channel_layouts='7.1|5.1|stereo'"
				If $ini_codec = "DTS" Then $acodec = " -c:a dca -strict -2"
				If $ini_codec = "TrueHD" Then $acodec = " -c:a truehd -strict -2"

			EndIf

		ElseIf $ini_audio_normalize = 0 Then

			$acodec = " -c:a copy"

		Else

			If $ini_codec = "AAC" Then $acodec = " -c:a aac -ar 48000"
			If $ini_codec = "AC-3" Then $acodec = " -c:a ac3 -ar 48000"
			If $ini_codec = "MP3" Then $acodec = " -c:a libmp3lame -b:a 192k -ar 48000"
			If $ini_codec = "FLAC" Then $acodec = " -c:a flac -ar 48000"
			If $ini_codec = "OPUS" Then $acodec = " -c:a libopus -b:a 128k -af aformat=channel_layouts='7.1|5.1|stereo'"
			If $ini_codec = "DTS" Then $acodec = " -c:a dca -strict -2"
			If $ini_codec = "TrueHD" Then $acodec = " -c:a truehd -strict -2"

		EndIf

	EndIf

	$trackNumbers = _GetAudioTracks($InFile, $ini_tracksperlanguage_audio)

	$tracks = StringSplit($trackNumbers, ",", 3)

 	If $ini_useoptimizer = 1 Then

		If UBound($tracks) > 1 Then

			For $i = 0 To UBound($tracks) -1

				$audio = $audio & " -map 0:" & $tracks[$i]

			Next

		Else

			If $trackNumbers = "" Then

				$audio = " -map 0:a?"

			Else

				$audio = " -map 0:" & $tracks[0]

			EndIf

		EndIf

 	EndIf

	If $ini_useoptimizer = 4 Then

		$audio = " -map 0:a?"

	EndIf

;~ MsgBox(0,"", $ini_audio_normalize)

;~ MsgBox(0,"", $acodec)


	If $ini_audio_normalize = 1 Then

		if $acodec = " -c:a copy" Then

			If $aRow[2] = "AAC" Then $acodec = " -c:a aac -ar 48000"
			If $aRow[2] = "AC-3" Then $acodec = " -c:a ac3 -ar 48000"
			If $aRow[2] = "E-AC-3" Then $acodec = " -c:a eac3 -ar 48000"
			If $aRow[2] = "MPEG Audio" Then $acodec = " -c:a libmp3lame -b:a 192k -ar 48000"
			If $aRow[2] = "MP3" Then $acodec = "k -ar 48000"
			If $aRow[2] = "FLAC" Then $acodec = " -c:a flac -ar 48000"
			If $aRow[2] = "OPUS" Then $acodec = " -c:a libopus -b:a 128k -af aformat=channel_layouts='7.1|5.1|stereo'"
			If $aRow[2] = "DTS" Then $acodec = " -c:a dca -strict -2"
			If $aRow[2] = "MLP FBA" Then $acodec = " -c:a truehd -strict -2"

		EndIf

;~ MsgBox(0,"", $acodec)

		If $ini_audio_compression = 0 Then $compress = ""
		If $ini_audio_compression = 1 Then $compress = ":s=22"
		If $ini_audio_compression = 2 Then $compress = ":s=15"
		If $ini_audio_compression = 3 Then $compress = ":s=11"
		If $ini_audio_compression = 4 Then $compress = ":s=7"

		$acompress = " -af dynaudnorm=p=" & StringReplace($ini_audio_db, ",", ".") & ":f=500:m=10" & $compress & ":g=11:r=" & StringReplace($ini_audio_db, ",", ".") & ":b=false"

	Else

		$acompress = ""

	EndIf

	;Subtitle Options

	If $ini_useoptimizer_subs = 1 And $ini_tracksperlanguage_forced > 0 Then

		$ForcedNumbers = _GetForcedSubtitleTracks($InFile, $ini_tracksperlanguage_forced)

		If NOT $ForcedNumbers = "" Then

			$tracks = StringSplit($ForcedNumbers, ",", 1)

			If UBound($tracks) > 1 Then

				For $i = 1 To UBound($tracks) -1

					$forced = $forced & " -map 0:" & $tracks[$i]

					$query = 'SELECT Format FROM Text WHERE textID LIKE "' & $tracks[$i] & '" ;'

					$iRval = _SQLite_GetTable(-1, $query, $aResult, $iRows, $iColumns)

					_SQLite_QueryFinalize($iRval)

				Next

			Else

				$forced = " -map 0:" & $tracks[0]

			EndIf

		EndIf

	EndIf

	If $ini_useoptimizer_subs = 1 And $ini_tracksperlanguage_sub > 0  Then

		$textNumbers = _GetSubtitleTracks($InFile, $ini_tracksperlanguage_sub)

		If NOT $textNumbers = "" Then

			$tracks = StringSplit($textNumbers, ",", 1)

			If UBound($tracks) > 1 Then


				For $i = 1 To UBound($tracks) -1

					$subs = $subs & " -map 0:" & $tracks[$i]

				Next

			Else

				$subs = " -map 0:" & $tracks[0]

			EndIf

		EndIf

	EndIf

	If $ini_useoptimizer_subs = 4 Then

		$subs = " -map 0:s? "

		If $ini_mux_external = "1" Then

			$externalsubs = ""

			$query = 'SELECT External FROM Text WHERE External IS NOT NULL ;'

			$iRval = _SQLite_GetTable(-1, $query, $aResult, $iRows, $iColumns)

			_SQLite_QueryFinalize($iRval)

			$result = $aResult[0]

			For $i = 3 To $aResult[0]

				$externalsubs = $externalsubs & " -f srt -i '" & $aResult[$i] & "' "

			Next

		EndIf

	EndIf


	;Start Transcoding

	If $simplecut = 1 Then

		$aMyTime = StringSplit($cutpoints[2], ":")

		$bMyTime = StringSplit($cutpoints[1], ":")

		$hh = $aMyTime[1] - $bMyTime[1]

		$mm = $aMyTime[2] - $bMyTime[2]

		$se = $aMyTime[3] - $bMyTime[3]

		If $se < 0 Then

			$mm = $mm - 1

			$se = $se + 60

		EndIf

		If $mm < 0 Then

			$hh = $hh - 1

			$mm = $mm + 60

		EndIf

		$ss = " -ss " & $cutpoints[1]

		$to = " -t " & StringFormat("%02i", $hh) & ":" & StringFormat("%02i", $mm) & ":" & StringFormat("%02.3f", $se)

	EndIf

	If $simplecut = 2 Then

		Local $list = FileOpen($tempdir & "\list.txt", 2)

		For $i = 1 To $cutpoints[0]-1 Step 2

			Local $tempfile = StringReplace($tempdir, "\", "\\") & "\\" & "Temp_" & $i & ".mkv"

			FileWriteLine($list, "file " & $tempfile)

			$aMyTime = StringSplit($cutpoints[$i+1], ":")

			$bMyTime = StringSplit($cutpoints[$i], ":")

			$hh = $aMyTime[1] - $bMyTime[1]

			$mm = $aMyTime[2] - $bMyTime[2]

			$se = $aMyTime[3] - $bMyTime[3]

			If $se < 0 Then

				$mm = $mm - 1

				$se = $se + 60

			EndIf

			If $mm < 0 Then

				$hh = $hh - 1

				$mm = $mm + 60

			EndIf

			$ss = " -ss " & $cutpoints[$i]

			$to = " -t " & StringFormat("%02i", $hh) & ":" & StringFormat("%02i", $mm) & ":" & StringFormat("%02.3f", $se)

			If $audioonlycode = 1 Then

				$video = ' -c:v copy'
				$br1 = ""
				$Pr = ""

			EndIf

			If $ini_mux_external = "1" AND $ini_useoptimizer_subs = 4 Then

				If $Result > 2 Then

					$audio1 = StringReplace($audio, "-map 0:", "-map " & $Result - 2 & ":")

					$videomap1 = StringReplace($videomap, "-map 0:", "-map " & $Result - 2 & ":")

					$subs = ""

					For $i = 0 To $Result - 2

						$subs = $subs & " -map " & $i & ":s"

					Next

					$option = $seek & " " & $externalsubs & " -y" & $ss & " -i '" & $InFile & "' -scodec copy" & $videomap1 & $video & $br1 & $Pr & $audio1 & $acodec & $acompress & $forced & $subs & " -c:s copy -max_muxing_queue_size 10000" & $to & " '" & $tempfile & "'"

				Else

					$option = $seek & " -y" & $ss & " -i '" & $InFile & "' -scodec copy" & $videomap & $video & $br1 & $Pr & $audio & $acodec & $acompress & $forced & $subs & " -c:s copy -max_muxing_queue_size 10000" & $to & " '" & $tempfile & "'"

				EndIf


			Else

				$option = $seek & " -y" & $ss & " -i '" & $InFile & "' -scodec copy" & $videomap & $video & $br1 & $Pr & $audio & $acodec & $acompress & $forced & $subs & " -c:s copy -max_muxing_queue_size 10000" & $to & " '" & $tempfile & "'"

			EndIf


			_WriteLog("RecodeFile - $option = " & $option)

			$iPID = Run(@ComSpec & ' /c ToolBox.exe --filename:ffmpeg.exe --arguments:" ' & $option, @ScriptDir, @SW_HIde, $STdeRR_CHILD + $STDOUT_CHILD)

			Sleep(10000)

			While ProcessExists("ffmpeg.exe")

				_GetTime()

				$a = GUIGetCursorInfo()

				If IsArray($a) Then

					If $a[2] = 1 And $a[4] = $Cancelbutton Then

						$value = MsgBox(19, $lng_cancel, $lng_cancel1 & @CRLF & $lng_areyousure & "." & @CRLF & @CRLF & $lng_cancel2 & @CRLF & $lng_cancel3 & @CRLF & $lng_cancel4)

						If $value = 2 Then ;Instantly Abort

							_WriteLog("RecodeFile - Triggered Instant Abort")

							_CloseProcess($iPID)

							_CloseProcess("ffmpeg.exe")

							$break = 1

						EndIf

						If $value = 6 Then ;Finish File and Abort

							_WriteLog("RecodeFile - Triggered Abort After Recent File")

							$break = 1

						EndIf

					EndIf

				EndIf

				$sOutput =  _OEMToAnsi(StdoutRead($iPID))

				$result = StringInStr($sOutput, "#")

				If $result = 1 Then

					$StringLine = StringSplit($sOutput, @CRLF)
					$aString = StringSplit($StringLine[1], "|")


					If $aString[4] <> "" Then $aString1 = $aString[4]

					$step1 = 100 / $Count

					$p = ($step1 * ($i_global - 1)) + ($aString1 /  $Count)

					_SetData($progressbar2, $p)

					_SetData($progressbar,  $aString1)

					If StringLen($Path[3]) > 75 Then

						$len = StringLeft($Path[3], 70) & "... "

					Else

						$len = $Path[3]

					EndIf

					_SetLabel($Label02, $lng_workingon  & "   " & $len & $Path[4] & " --- " & $lng_progress & ": " & $aString[4] & "% --- " & $lng_elapsed & ": " & $aString[5] & " --- " & $lng_total & ": " & $aString[6] & " --- FPS: " & $aString[7])

				EndIf

				If @error Then ExitLoop

				Sleep(200)

			WEnd






		Next

		FileClose($list)

 		Local $coption = ' -f concat -safe 0 -i "' & $tempdir & "\list.txt" & '" -c copy ' & $outfile

		_WriteLog("RecodeCut - $coption = " & $coption)

		$iPID = RunWait(@ComSpec & ' /c ToolBox.exe --filename:ffmpeg.exe --arguments:" ' & $coption, @ScriptDir, @SW_HIde, $STdeRR_CHILD + $STDOUT_CHILD)

		Sleep(1000)

		FileDelete($tempdir & "\list.txt")
		FileDelete($tempdir & "\*.mkv")

	Else

	   If $audioonlycode = 1 Then

		  $video = ' -c:v copy'
		  $br1 = ""
		  $Pr = ""

	   EndIf

		If $ini_mux_external = "1" AND $ini_useoptimizer_subs = 4 Then

			If $Result > 2 Then

				$audio1 = StringReplace($audio, "-map 0:", "-map " & $Result - 2 & ":")

				$videomap1 = StringReplace($videomap, "-map 0:", "-map " & $Result - 2 & ":")

				$subs = ""

				For $i = 0 To $Result - 2

					$subs = $subs & " -map " & $i & ":s"

				Next

				$option = $seek & " " & $externalsubs & " -y" & $ss & " -i '" & $InFile & "' -scodec copy" & $videomap1 & $video & $br1 & $Pr & $audio1 & $acodec & $acompress & $forced & $subs & " -c:s copy -max_muxing_queue_size 10000" & $to & " '" & $OutFile & "'"

			Else

				$option = $seek & " -y" & $ss & " -i '" & $InFile & "' -scodec copy" & $videomap & $video & $br1 & $Pr & $audio & $acodec & $acompress & $forced & $subs & " -c:s copy -max_muxing_queue_size 10000" & $to & " '" & $OutFile & "'"

			EndIf


		Else

			$option = $seek & " -y" & $ss & " -i '" & $InFile & "' -scodec copy" & $videomap & $video & $br1 & $Pr & $audio & $acodec & $acompress & $forced & $subs & " -c:s copy -max_muxing_queue_size 10000" & $to & " '" & $OutFile & "'"

		EndIf


		_WriteLog("RecodeFile - $option = " & $option)

		$iPID = Run(@ComSpec & ' /c ToolBox.exe --filename:ffmpeg.exe --arguments:" ' & $option, @ScriptDir, @SW_HIde, $STdeRR_CHILD + $STDOUT_CHILD)

		Sleep(10000)

		While ProcessExists("ffmpeg.exe")

			_GetTime()

			$a = GUIGetCursorInfo()

			If IsArray($a) Then

				If $a[2] = 1 And $a[4] = $Cancelbutton Then

					$value = MsgBox(19, $lng_cancel, $lng_cancel1 & @CRLF & $lng_areyousure & "." & @CRLF & @CRLF & $lng_cancel2 & @CRLF & $lng_cancel3 & @CRLF & $lng_cancel4)

					If $value = 2 Then ;Instantly Abort

						_WriteLog("RecodeFile - Triggered Instant Abort")

						_CloseProcess($iPID)

						_CloseProcess("ffmpeg.exe")

						$break = 1

					EndIf

					If $value = 6 Then ;Finish File and Abort

						_WriteLog("RecodeFile - Triggered Abort After Recent File")

						$break = 1

					EndIf

				EndIf

			EndIf

			$sOutput =  _OEMToAnsi(StdoutRead($iPID))

			$result = StringInStr($sOutput, "#")

			If $result = 1 Then

				$StringLine = StringSplit($sOutput, @CRLF)
				$aString = StringSplit($StringLine[1], "|")


				If $aString[4] <> "" Then $aString1 = $aString[4]

				$step1 = 100 / $Count

				$p = ($step1 * ($i_global - 1)) + ($aString1 /  $Count)

				_SetData($progressbar2, $p)

				_SetData($progressbar,  $aString1)

				If StringLen($Path[3]) > 75 Then

					$len = StringLeft($Path[3], 70) & "... "

				Else

					$len = $Path[3]

				EndIf

				_SetLabel($Label02, $lng_workingon  & "   " & $len & $Path[4] & " --- " & $lng_progress & ": " & $aString[4] & "% --- " & $lng_elapsed & ": " & $aString[5] & " --- " & $lng_total & ": " & $aString[6] & " --- FPS: " & $aString[7])

			EndIf

			If @error Then ExitLoop

			Sleep(200)

		WEnd

	EndIf

	; Set "default" and "forced" flag to matching subtitles...

	If  $break < 1 Then

		If NOT $ForcedNumbers = "" Then

			$option4 = '"' & $OutFile & '"'

			$option4 =  $option4 & ' --edit track:s1 --set flag-default=1'

			ShellExecuteWait($ini_mkvpropedit_path, $option4, "", "", @SW_HIde)

			Local $len = StringInStr($ForcedNumbers, ",")

			If $len > 0 Then

				$Forced = StringSplit($ForcedNumbers, ",")

				$option4 = ''

				$option4 = '"' & $OutFile & '"'

				For $i = 1 To $Forced[0]

					$option4 =  $option4 & ' --edit track:s' & $Forced[$i] & ' --set flag-forced=1'

				Next

				ShellExecuteWait($ini_mkvpropedit_path, $option4, "", "", @SW_HIde)

			Else

				$option4 = '"' & $OutFile & '"'

				$option4 =  $option4 & ' --edit track:s1 --set flag-forced=1'

				ShellExecuteWait($ini_mkvpropedit_path, $option4, "", "", @SW_HIde)

			EndIf

		EndIf

	EndIf

	If $ini_KeepFileDate = "1" Then

		_SetTimeSegment($InFile, $OutFile)

	EndIf

	_WriteLog("RecodeFile - Finished Working On  " & $InFile)

	Return $break

EndFunc

;Function to Remux Files
Func _RemuxFile($InFile, $OutFile, $Cancelbutton = "0000", $progressbar = "0000", $progressbar2 = "0000", $count = 1, $i_global = 1)

	Local $path, $MediaInfo, $sDrive, $sDir, $sFilename, $sExtension, $numbers, $break, $subtotal
	Local $trackNumbers, $i, $ForcedNumbers, $textNumbers, $txtNumbers, $subtitle = 0, $seek, $videomap
	Local $value, $sOutput, $result, $StringLine, $aString, $step1, $p, $Forced, $option3, $option4, $iPID, $a
	Local $query, $Rval, $Res, $Rows, $Columns, $arow, $aResult, $iRows, $iColumns, $acodec, $dvb = 0

	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_audiolanguages", GUICtrlRead($input_90_10))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_sublanguages", GUICtrlRead($input_90_11))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_useoptimizer", GUICtrlRead($check_90_01))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_useoptimizer_subs", GUICtrlRead($check_90_02))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_tracksperlanguage_audio", GUICtrlRead($input_90_04))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_tracksperlanguage_forced", GUICtrlRead($input_90_05))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_tracksperlanguage_sub", GUICtrlRead($input_90_06))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_tracks_video", GUICtrlRead($input_90_12))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_useoptimizer_video", GUICtrlRead($check_90_12))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_codec", GUICtrlRead($combo_52_05))

	$ini_tracksperlanguage_audio = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_tracksperlanguage_audio", "1")
	$ini_tracksperlanguage_forced = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_tracksperlanguage_forced", "1")
	$ini_tracksperlanguage_sub = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_tracksperlanguage_sub", "0")
	$ini_useoptimizer = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_useoptimizer", "1")
	$ini_useoptimizer_subs = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_useoptimizer_subs", "1")
	$ini_codec = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_codec", "AAC")
	$ini_sublanguages = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_sublanguages", "en")
	$ini_audiolanguages = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_audiolanguages", "en")
	$ini_tracks_video = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_tracks_video", "1")
	$ini_useoptimizer_video = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_useoptimizer_video", "1")

	_WriteLog("RemuxFile - Start Working On  " & $InFile)

	$videomap = ""

	$path = _PathSplit(StringReplace($InFile,"\'", "'"), $sDrive, $sDir, $sFilename, $sExtension)

	; Test if DVB subtitle are existing

	$query = 'SELECT * FROM Text WHERE Format LIKE "DVB Subtitle" ;'

	$iRval = _SQLite_GetTable2d(-1, $query, $aResult, $iRows, $iColumns)

	_SQLite_QueryFinalize($iRval)

	If UBound($aResult) > 1 Then $dvb = 1

	; Test if Teletext subtitle are existing

	$query = 'SELECT * FROM Text WHERE Format LIKE "Teletext Subtitle" ;'

	$iRval = _SQLite_GetTable2d(-1, $query, $aResult, $iRows, $iColumns)

	_SQLite_QueryFinalize($iRval)

	If UBound($aResult) > 1 Then $dvb = 1

	If $dvb = 1	Then $seek = $seek & " -fix_sub_duration"

	; Test if PGS subtitle are existing

	$query = 'SELECT * FROM Text WHERE Format LIKE "PGS" ;'

	$iRval = _SQLite_GetTable2d(-1, $query, $aResult, $iRows, $iColumns)

	_SQLite_QueryFinalize($iRval)

	If UBound($aResult) > 1 Then $seek = $seek & " -analyzeduration 2000M -probesize 2000M"

	;Video Options

	$query = 'SELECT VideoID FROM Video ;'

	$Rval = _SQLite_GetTable2d(-1, $query, $Res, $Rows, $Columns)

	_SQLite_QuerySingleRow(-1,"SELECT * FROM Video LIMIT 1;",$aRow)

	$vtrack = $aRow[1]

	If $ini_useoptimizer_video = 1 Then

		If UBound($Res) > 2 Then

			For $i = 1 To $ini_tracks_video

 				$videomap = $videomap & " -map 0:" & $Res[$i][0]

			Next

		Else

 			$videomap = " -map 0:" & $vtrack

		EndIf

 	EndIf

	If $ini_useoptimizer_video = 4 Then

 		$videomap = " -map 0:" & $vtrack

	EndIf


	If NOT $ini_useoptimizer_subs = 1 Then

		;External Subtitle Options

		If $ini_mux_external = "1" Then

			$query = 'SELECT External FROM Text WHERE External IS NOT NULL ;'

			$iRval = _SQLite_GetTable(-1, $query, $aResult, $iRows, $iColumns)

			_SQLite_QueryFinalize($iRval)

			$option = $seek & " -y -i '" & $InFile

			For $i = 2 To $aResult[0]

				$option = $option & " -i '" & $aResult[$i] & "' "

			Next

			$option = $option & "' -scodec copy" & $videomap & " -c:v copy"

		Else

			$option = $seek & " -y -i '" & $InFile & "' -scodec copy" & $videomap & " -c:v copy"

		EndIf

	Else

		$option = $seek & " -y -i '" & $InFile & "' -scodec copy" & $videomap & " -c:v copy"

	EndIf

	; Audio Options

	$query = 'SELECT AudioID FROM Audio ;'

	$Rval = _SQLite_GetTable2d(-1, $query, $Res, $Rows, $Columns)


	_SQLite_QuerySingleRow(-1,"SELECT * FROM Audio LIMIT 1;",$aRow)

	If GUICtrlRead($radio_21_06) = 1 Then $acodec = " -c:a ac3 -ar 48000"
	If GUICtrlRead($radio_21_07) = 1 Then $acodec = " -c:a aac -ar 48000"
	If GUICtrlRead($radio_21_08) = 1 Then $acodec = " -c:a libmp3lame -b:a 192k -ar 48000"
	If GUICtrlRead($radio_21_09) = 1 Then $acodec = " -c:a flac -ar 48000"
	If GUICtrlRead($radio_21_10) = 1 Then $acodec = " -c:a libopus -b:a 128k -af aformat=channel_layouts='7.1|5.1|stereo'"
	If GUICtrlRead($radio_21_12) = 1 Then $acodec = " -c:a dca -strict -2"
	If GUICtrlRead($radio_21_13) = 1 Then $acodec = " -c:a truehd -strict -2"
	If GUICtrlRead($radio_21_11) = 1 Then

		If $ini_transcode_all = 1 Then

			If _ArraySearch($ArrayAudioWhitelist, $aRow[2]) > -1 Then

				$acodec = " -c:a copy"

			Else

				If $ini_codec = "AAC" Then $acodec = " -c:a aac -ar 48000"
				If $ini_codec = "AC-3" Then $acodec = " -c:a ac3 -ar 48000"
				If $ini_codec = "MP3" Then $acodec = " -c:a libmp3lame -b:a 192k -ar 48000"
				If $ini_codec = "FLAC" Then $acodec = " -c:a flac -ar 48000"
				If $ini_codec = "OPUS" Then $acodec = " -c:a libopus -b:a 128k -af aformat=channel_layouts='7.1|5.1|stereo'"
				If $ini_codec = "DTS" Then $acodec = " -c:a dca -strict -2"
				If $ini_codec = "TrueHD" Then $acodec = " -c:a truehd -strict -2"

			EndIf

		Else

			$acodec = " -c:a copy"

		EndIf

	EndIf

	$option = $option & $acodec

	If $ini_useoptimizer = 1 Then

		$trackNumbers = _GetAudioTracks($InFile, $ini_tracksperlanguage_audio)

		$numbers = StringSplit($trackNumbers, ",")

		If  Int($numbers[1]) > 0 Then

			For $i = 1 To $numbers[0]

				$option = $option & ' -map 0:a:' & $numbers[$i] - 1

			Next

		Else

			$option = $option & ' -map 0:a'

		EndIf

	EndIf

	If $ini_useoptimizer = 4 Then

 		$option = $option & ' -map 0:a'

	EndIf

	;Forced Subtitle Options

	If $ini_useoptimizer_subs = 1 And $ini_tracksperlanguage_forced > 0 Then

		$ForcedNumbers = _GetForcedSubtitleTracks($InFile, $ini_tracksperlanguage_forced)

		$numbers = StringSplit($ForcedNumbers, ",")

		If  Int($numbers[1]) > 0 Then

			For $i = 1 To $numbers[0]

				$option = $option & ' -map 0:' & $numbers[$i]

			Next

		EndIf

	EndIf

	;Subtitle Options

	If $ini_useoptimizer_subs = 1 And $ini_tracksperlanguage_sub > 0 Then

		$textNumbers = _GetSubtitleTracks($InFile, $ini_tracksperlanguage_sub)

		$numbers = StringSplit($textNumbers, ",")

		If  Int($numbers[1]) > 0 Then

			For $i = 1 To $numbers[0]

				$option = $option & ' -map 0:' & $numbers[$i]

			Next

		EndIf

	EndIf

	If $ini_useoptimizer_subs = 4 Then

		$option = $option & ' -map 0:s'

		If $ini_mux_external = "1" Then

			$query = 'SELECT External FROM Text WHERE External IS NOT NULL ;'

			$iRval = _SQLite_GetTable(-1, $query, $aResult, $iRows, $iColumns)

			_SQLite_QueryFinalize($iRval)

			For $i = 2 To $aResult[0]

				$externalsubs = " -i '" & $aResult[$i] & "' "

			Next

		EndIf

	EndIf

	$option = $option & " '" & $OutFile & "'"  & '"'

	_WriteLog("RemuxFile - $option = " & StringReplace($option, "'", '"'))

	$iPID = Run(@ComSpec & ' /c ToolBox.exe --filename:ffmpeg.exe --arguments:" ' & $option, @ScriptDir, @SW_HIde, $STdeRR_CHILD + $STDOUT_CHILD) ;  --debug

	$step1 = 100 / $Count

	Sleep(10000)

	While ProcessExists("ffmpeg.exe")

		$a = GUIGetCursorInfo()

		If IsArray($a) Then

			If $a[2] = 1 And $a[4] = $Cancelbutton Then

				$value = MsgBox(19, $lng_cancel, $lng_cancel1 & @CRLF & $lng_areyousure & "." & @CRLF & @CRLF & $lng_cancel2 & @CRLF & $lng_cancel3 & @CRLF & $lng_cancel4)

				If $value = 2 Then ;Instantly Abort

					_WriteLog("RemuxFile - Triggered Instant Abort")

					_CloseProcess($iPID)

					$break = 1

				EndIf

				If $value = 6 Then ;Finish File and Abort

					_WriteLog("RemuxFile - Triggered Abort After Recent File")

					$break = 1

				EndIf

			EndIf

		EndIf

		$sOutput =  _OEMToAnsi(StdoutRead($iPID))

		$result = StringInStr($sOutput, "#")

		If $result = 1 Then

			$StringLine = StringSplit($sOutput, @CRLF)
			$aString = StringSplit($StringLine[1], "|")

			$p = ($step1 * ($i_global - 1)) + (Round($aString[4]) / $Count)

			_SetData($progressbar2, $p)

			_SetData($progressbar, $aString[4])

			If StringLen($Path[3]) > 75 Then

				$len = StringLeft($Path[3], 70) & "... "

			Else

				$len = $Path[3]

			EndIf

			_SetLabel($Label02, $lng_workingon  & "   " & $len & $Path[4] & " --- " & $lng_progress & ": " & $aString[4] & "% --- " & $lng_elapsed & ": " & $aString[5] & " --- " & $lng_total & ": " & $aString[6])

		EndIf

		If @error Then

			_WriteLog("RemuxFile - Error Message = " & StderrRead($iPID))

			ExitLoop

		EndIf

		Sleep(100)

	WEnd


	; Set "default" and "forced" flag to matching subtitles...

	If  $break < 1 Then

		If NOT $ForcedNumbers = "" Then

			$option4 = '"' & $OutFile & '"'

			$option4 =  $option4 & ' --edit track:s1 --set flag-default=1'

			ShellExecuteWait($ini_mkvpropedit_path, $option4, "", "", @SW_HIde)

			Local $len = StringInStr($ForcedNumbers, ",")

			If $len > 0 Then

				$Forced = StringSplit($ForcedNumbers, ",")

				$option4 = ''

				$option4 = '"' & $OutFile & '"'

				For $i = 1 To $Forced[0]

					$option4 =  $option4 & ' --edit track:s' & $Forced[$i] & ' --set flag-forced=1'

				Next

				ShellExecuteWait($ini_mkvpropedit_path, $option4, "", "", @SW_HIde)

			Else

				$option4 = '"' & $OutFile & '"'

				$option4 =  $option4 & ' --edit track:s1 --set flag-forced=1'

				ShellExecuteWait($ini_mkvpropedit_path, $option4, "", "", @SW_HIde)

			EndIf

		EndIf

	EndIf

	If $ini_KeepFileDate = "1" Then

		_SetTimeSegment($InFile, $OutFile)

	EndIf

	_SetData($progressbar, 0)

	_WriteLog("RemuxFile - Finished Working On  " & $InFile)

	Return $break

EndFunc

;Function to Restart the program
Func _Restart()
    If @Compiled = 1 Then
        Run( FileGetShortName(@ScriptFullPath))
    Else
        Run( FileGetShortName(@AutoItExe) & " " & FileGetShortName(@ScriptFullPath))
    EndIf
    Exit
EndFunc

;Function to Save Settings in JSON files.
Func _SaveJSON()

	Local $file, $path, $sDrive, $sDir, $sFilename, $sExtension, $count = 0, $folder = "", $ext[0]
	Local $FolderStructure, $FolderStructure_MultipleDisc

	$path = _PathSplit($ini_mkvmerge_path, $sDrive, $sDir, $sFilename, $sExtension)

	$ini_naming_default = GUICtrlRead($check_54_01)
	$ini_naming_emby = GUICtrlRead($check_54_02)
	$ini_naming_mp1 = GUICtrlRead($check_54_03)

	If $ini_naming_default = 1 Then $count = $count + 1
	If $ini_naming_emby = 1 Then $count = $count + 1
	If $ini_naming_mp1 = 1 Then $count = $count + 1

	If GUICtrlRead($check_53_32) = 1 Then

		$folder = GUICtrlRead($input_53_32) & "\{set}\"

	Else

		$folder = "movieset-"

	EndIf

	$j_Object("Language") = StringLower(GUICtrlRead($input_94_01))

	$j_Object("Language_ThreeLetter") = StringLower(GUICtrlRead($input_94_04))

	$j_Object("FolderIgnore") = StringSplit(GUICtrlRead($input_94_02), "|", 3)

	$j_Object("FileIgnoreStrings") = StringSplit(GUICtrlRead($input_94_03), "|", 3)

	$ext = StringSplit(StringStripWS(GUICtrlRead($edit_52_11),2), @CRLF, 3)

	For $i = 1 To UBound($ArrayMediaStub) - 1

		_ArrayAdd($ext, $ArrayMediaStub[$i])

	Next

	$j_Object("FileExtensions") = $ext

	$j_Object.Item("Music").Item("FileExtensions") = StringSplit(StringStripWS(GUICtrlRead($edit_56_03),2), @CRLF, 3)

	$FolderStructure = StringRegExpReplace(GUICtrlRead($input_56_11), '[{}]', "")
	$FolderStructure_MultipleDisc = StringRegExpReplace(GUICtrlRead($input_56_12), '[{}]', "")

	$j_Object.Item("Music").Item("FolderStructure") = $FolderStructure
	$j_Object.Item("Music").Item("FolderStructure_MultipleDisc") = $FolderStructure_MultipleDisc
	$j_Object.Item("Music").Item("Disc") = GUICtrlRead($input_56_13)

	$j_Object.Item("Music").Item("File_Artist") = "artist.nfo"
	$j_Object.Item("Music").Item("File_Album") = "album.nfo"

	$j_Object.Item("TVShow").Item("SeriesIgnoreEpisodeNames") = StringSplit(GUICtrlRead($input_53_05), "|", 3)
	$j_Object.Item("TVShow").Item("FolderSeason") = GUICtrlRead($input_53_03)

	$j_Object.Item("Image").Item("Resize_Backdrop") = GUICtrlRead($input_53_21) & ", " & GUICtrlRead($input_53_24)
	$j_Object.Item("Image").Item("Resize_Poster") = GUICtrlRead($input_53_22) & ", " & GUICtrlRead($input_53_25)
	$j_Object.Item("Image").Item("Resize_Thumb") = GUICtrlRead($input_53_23) & ", " & GUICtrlRead($input_53_26)

	$j_Object.Item("Filenaming").Item("Movie").Item("Image_Thumb") = "landscape.jpg"
	$j_Object.Item("Filenaming").Item("Movie").Item("Image_Banner") = "banner.jpg"
	$j_Object.Item("Filenaming").Item("Movie").Item("Image_Fanart") = "fanart.jpg"
	$j_Object.Item("Filenaming").Item("Movie").Item("Image_ClearArt") = "clearart.png"
	$j_Object.Item("Filenaming").Item("Movie").Item("File_NFO") = "{movie}.nfo"

	$j_Object.Item("Filenaming").Item("Movie").Item("Image_MovieSetPoster") = $folder & "poster.jpg"
	$j_Object.Item("Filenaming").Item("Movie").Item("Image_MovieSetFanart") = $folder & "fanart.jpg"
	$j_Object.Item("Filenaming").Item("Movie").Item("Image_MovieSetBanner") = $folder & "banner.jpg"
	$j_Object.Item("Filenaming").Item("Movie").Item("Image_MovieSetClearArt") = $folder & "clearart.png"
	$j_Object.Item("Filenaming").Item("Movie").Item("Image_MovieSetThumb") = $folder & "landscape.jpg"

	$j_Object.Item("Filenaming").Item("TVShow").Item("Image_Fanart") = "fanart.jpg"
	$j_Object.Item("Filenaming").Item("TVShow").Item("Image_Poster") = "poster.jpg"
	$j_Object.Item("Filenaming").Item("TVShow").Item("Image_Banner") = "banner.jpg"
	$j_Object.Item("Filenaming").Item("TVShow").Item("Image_ClearArt") = "clearart.png"
	$j_Object.Item("Filenaming").Item("TVShow").Item("Image_Episode") = "{episodefile}-thumb.jpg"
	$j_Object.Item("Filenaming").Item("TVShow").Item("Image_Season_Poster") = "season{season}-poster.jpg"
	$j_Object.Item("Filenaming").Item("TVShow").Item("Image_Season_Banner") = "season{season}-banner.jpg"

	$j_Object.Item("Rename").Item("Movie") = GUICtrlRead($input_53_14)
	$j_Object.Item("Rename").Item("TvShow") = GUICtrlRead($input_53_04)
	$j_Object.Item("Rename").Item("Music") = GUICtrlRead($input_56_14)


	If GUICtrlRead($check_92_01) = 1 Then
		$j_Object("Download_Images") = true
	Else
		$j_Object("Download_Images") = false
	EndIf

	If GUICtrlRead($check_53_33) = 1 Then
		$j_Object("use_uniqueID") = true
	Else
		$j_Object("use_uniqueID") = false
	EndIf


	If GUICtrlRead($radio_53_41) = 1 Then

		$j_Object.Item("Rating").Item("OverwriteRating") = false

	EndIf

	If GUICtrlRead($radio_53_42) = 1 Then
		$j_Object.Item("Rating").Item("OverwriteRating") = true
	EndIf

	If GUICtrlRead($radio_53_43) = 1 Then
		$j_Object.Item("Rating").Item("OverwriteRating") = true
	EndIf


	If GUICtrlRead($check_93_01) = 1 Then
		$j_Object.Item("Movies").Item("Image_Backdrop") = true
	Else
		$j_Object.Item("Movies").Item("Image_Backdrop") = false
	EndIf

	If GUICtrlRead($check_93_02) = 1 Then
		$j_Object.Item("Movies").Item("Image_Poster") = true
	Else
		$j_Object.Item("Movies").Item("Image_Poster") = false
	EndIf

	If GUICtrlRead($check_93_07) = 1 Then
		$j_Object.Item("Movies").Item("Trailer_Download") = true
	Else
		$j_Object.Item("Movies").Item("Trailer_Download") = false
	EndIf

	If GUICtrlRead($check_93_03) = 1 Then
		If GUICtrlRead($check_93_01) = 1 Then $j_Object.Item("Movies").Item("Image_MovieSetFanart") = true
		If GUICtrlRead($check_93_02) = 1 Then $j_Object.Item("Movies").Item("Image_MovieSetPoster") = true
		If GUICtrlRead($check_93_04) = 1 Then
			$j_Object.Item("Movies").Item("Image_MovieSetBanner") = true
			$j_Object.Item("Movies").Item("Image_MovieSetThumb") = true
		EndIf
		If GUICtrlRead($check_93_05) = 1 Then
			$j_Object.Item("Movies").Item("Image_MovieSetClearLogo") = true
			$j_Object.Item("Movies").Item("Image_MovieSetClearArt") = true
		EndIf
	Else
		$j_Object.Item("Movies").Item("Image_MovieSetFanart") = false
		$j_Object.Item("Movies").Item("Image_MovieSetPoster") = false
		$j_Object.Item("Movies").Item("Image_MovieSetBanner") = false
		$j_Object.Item("Movies").Item("Image_MovieSetThumb") = false
		$j_Object.Item("Movies").Item("Image_MovieSetClearLogo") = false
		$j_Object.Item("Movies").Item("Image_MovieSetClearArt") = false
	EndIf

	If GUICtrlRead($check_93_04) = 1 Then
		$j_Object.Item("Movies").Item("Image_Banner") = true
		$j_Object.Item("Movies").Item("Image_Thumb") = true
	Else
		$j_Object.Item("Movies").Item("Image_Banner") = false
		$j_Object.Item("Movies").Item("Image_Thumb") = false
	EndIf

	If GUICtrlRead($check_93_05) = 1 Then
		$j_Object.Item("Movies").Item("Image_ClearLogo") = true
		$j_Object.Item("Movies").Item("Image_ClearArt") = true
		$j_Object.Item("Movies").Item("Image_Disc") = true
	Else
		$j_Object.Item("Movies").Item("Image_ClearLogo") = false
		$j_Object.Item("Movies").Item("Image_ClearArt") = false
		$j_Object.Item("Movies").Item("Image_Disc") = false
	EndIf

	If GUICtrlRead($check_91_01) = 1 Then
		$j_Object.Item("TVShow").Item("Image_Fanart") = true
	Else
		$j_Object.Item("TVShow").Item("Image_Fanart") = false
	EndIf

	If GUICtrlRead($check_91_03) = 1 Then
		$j_Object.Item("TVShow").Item("Image_Poster") = true
	Else
		$j_Object.Item("TVShow").Item("Image_Poster") = false
	EndIf

	If GUICtrlRead($check_91_02) = 1 Then
		$j_Object.Item("TVShow").Item("Image_Banner") = true
	Else
		$j_Object.Item("TVShow").Item("Image_Banner") = false
	EndIf

	If GUICtrlRead($check_91_05) = 1 Then
		$j_Object.Item("TVShow").Item("Image_Episode") = true
	Else
		$j_Object.Item("TVShow").Item("Image_Episode") = false
	EndIf

	If GUICtrlRead($check_91_06) = 1 Then
		$j_Object.Item("TVShow").Item("Image_SeasonPoster") = true
	Else
		$j_Object.Item("TVShow").Item("Image_SeasonPoster") = false
	EndIf

	If GUICtrlRead($check_91_04) = 1 Then
		$j_Object.Item("TVShow").Item("Image_ClearLogo") = true
		$j_Object.Item("TVShow").Item("Image_ClearArt") = true
	Else
		$j_Object.Item("TVShow").Item("Image_ClearLogo") = false
		$j_Object.Item("TVShow").Item("Image_ClearArt") = false
	EndIf

	If GUICtrlRead($radio_92_01) = 1 Then $j_Object.Item("TVShow").Item("Default_Grabber") = "TVDB"

	If GUICtrlRead($radio_92_02) = 1 Then $j_Object.Item("TVShow").Item("Default_Grabber") = "TMDB"


	If GUICtrlRead($check_53_04) = 1 Then
		$j_Object.Item("TVShow").Item("Create_Episode_NFO_On_Missing_Info") = true
	Else
		$j_Object.Item("TVShow").Item("Create_Episode_NFO_On_Missing_Info") = false
	EndIf

	If GUICtrlRead($check_53_20) = 1 Then
		$j_Object.Item("Image").Item("Resize") = true
	Else
		$j_Object.Item("Image").Item("Resize") = false
	EndIf

	If GUICtrlRead($check_93_06) = 1 Then
		$j_Object.Item("Chapter").Item("GrabChapter") = true
	Else
		$j_Object.Item("Chapter").Item("GrabChapter") = false
	EndIf

	If GUICtrlRead($check_53_01) = 1 Then
		$j_Object.Item("Rename").Item("RenameFiles") = true
	Else
		$j_Object.Item("Rename").Item("RenameFiles") = false
	EndIf

	If $count = 1 Then

		If $ini_naming_mp1 = 1 Then

			$j_Object.Item("Filenaming").Item("Movie").Item("Image_Poster") = "folder.jpg"

		Else

			$j_Object.Item("Filenaming").Item("Movie").Item("Image_Poster") = "poster.jpg"

		EndIf

		If $ini_naming_emby = 1 Then

			$j_Object.Item("Filenaming").Item("Movie").Item("Image_ClearLogo") = "logo.png"
			$j_Object.Item("Filenaming").Item("Movie").Item("Image_Disc") = "disc.png"
			$j_Object.Item("Filenaming").Item("Movie").Item("Image_MovieSetClearLogo") = $folder & "logo.png"
			$j_Object.Item("Filenaming").Item("TVShow").Item("Image_ClearLogo") = "logo.png"

		Else

			$j_Object.Item("Filenaming").Item("Movie").Item("Image_ClearLogo") = "clearlogo.png"
			$j_Object.Item("Filenaming").Item("Movie").Item("Image_Disc") = "discart.png"
			$j_Object.Item("Filenaming").Item("Movie").Item("Image_MovieSetClearLogo") = $folder & "clearlogo.png"
			$j_Object.Item("Filenaming").Item("TVShow").Item("Image_ClearLogo") = "clearlogo.png"

		EndIf


	Else

		If $ini_naming_mp1 = 1 Then

			$j_Object.Item("Filenaming").Item("Movie").Item("Image_Poster") = "poster.jpg|folder.jpg"

		Else

			$j_Object.Item("Filenaming").Item("Movie").Item("Image_Poster") = "poster.jpg"

		EndIf

		If $ini_naming_emby = 1 Then

			$j_Object.Item("Filenaming").Item("Movie").Item("Image_ClearLogo") = "clearlogo.png|logo.png"
			$j_Object.Item("Filenaming").Item("Movie").Item("Image_Disc") = "discart.png|disc.png"
			$j_Object.Item("Filenaming").Item("Movie").Item("Image_MovieSetClearLogo") = $folder & "clearlogo.png|" & $folder & "logo.png"
			$j_Object.Item("Filenaming").Item("TVShow").Item("Image_ClearLogo") = "clearlogo.png|logo.png"

		Else

			$j_Object.Item("Filenaming").Item("Movie").Item("Image_ClearLogo") = "clearlogo.png"
			$j_Object.Item("Filenaming").Item("Movie").Item("Image_Disc") = "discart.png"
			$j_Object.Item("Filenaming").Item("Movie").Item("Image_MovieSetClearLogo") = $folder & "clearlogo.png"
			$j_Object.Item("Filenaming").Item("TVShow").Item("Image_ClearLogo") = "clearlogo.png"

		EndIf


	Endif

	$file = FileOpen(@ScriptDir & "\nfo4HTPCv2.Settings.json", 2)

	FileWrite($file, _JSON_Generate($j_Object))

	FileClose($file)

EndFunc

;Function to Save Settings in INI files.
Func _SaveSettings()

	Local $path, $sDrive, $sDir, $sFilename, $sExtension

;~ 	;Folder Settings
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_append_inputfolder", GUICtrlRead($input_23_01))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_append_outputfolder", GUICtrlRead($input_23_02))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_extract_inputfolder", GUICtrlRead($input_43_01))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_kodidot_inputfolder", GUICtrlRead($input_44_40))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_kodi19_inputfolder", GUICtrlRead($input_44_20))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_koditools_audiofolder", GUICtrlRead($input_44_02))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_koditools_inputfolder", GUICtrlRead($input_44_01))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_fix_inputfolder", GUICtrlRead($input_41_01))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_fix_outputfolder", GUICtrlRead($input_41_02))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_3d_inputfolder", GUICtrlRead($input_42_01))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_anorm_outputfolder", GUICtrlRead($input_25_02))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_anorm_inputfolder", GUICtrlRead($input_25_01))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_arecode_outputfolder", GUICtrlRead($input_24_02))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_arecode_inputfolder", GUICtrlRead($input_24_01))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_artistfolder", GUICtrlRead($input_56_32))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_recode_inputfolder", GUICtrlRead($input_21_01))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_recode_outputfolder", GUICtrlRead($input_21_02))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_remux_inputfolder", GUICtrlRead($input_22_01))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_remux_outputfolder", GUICtrlRead($input_22_02))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_graphics_inputfolder", GUICtrlRead($input_26_01))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_mediastub_outputfolder", GUICtrlRead($input_47_01))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_moviesetfolder", GUICtrlRead($input_53_32))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_movies_metadata_inputfolder", GUICtrlRead($input_32_01))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_series_metadata_inputfolder", GUICtrlRead($input_31_01))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_videos_metadata_inputfolder", GUICtrlRead($input_33_01))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_wizard_movies_inputfolder", GUICtrlRead($input_12_01))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_wizard_movies_outputfolder", GUICtrlRead($input_12_02))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_wizard_series_inputfolder", GUICtrlRead($input_11_01))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_wizard_series_outputfolder", GUICtrlRead($input_11_02))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_wizard_videos_inputfolder", GUICtrlRead($input_13_01))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_wizard_videos_outputfolder", GUICtrlRead($input_13_02))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_wizard_audio_inputfolder", GUICtrlRead($input_14_01))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_wizard_audio_outputfolder", GUICtrlRead($input_14_02))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_movies_correction_inputfolder", GUICtrlRead($input_62_01))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_series_correction_inputfolder", GUICtrlRead($input_61_01))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_videos_correction_inputfolder", GUICtrlRead($input_63_01))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_audio_correction_inputfolder", GUICtrlRead($input_64_01))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_audio_metadata_inputfolder", GUICtrlRead($input_34_01))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_audiotools_inputfolder", GUICtrlRead($input_48_01))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_audiotools_outputfolder", GUICtrlRead($input_48_02))

;~ 	;Generic Settings
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_channelovercodec", GUICtrlRead( $check_52_21))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_codec", GUICtrlRead($combo_52_05))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_codec1", GUICtrlRead($combo_52_23))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_codec2", GUICtrlRead($combo_52_24))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_codec3", GUICtrlRead($combo_52_25))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_codec4", GUICtrlRead($combo_52_26))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_codec5", GUICtrlRead($combo_52_27))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_audiolanguages", GUICtrlRead($input_90_10))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_sublanguages", GUICtrlRead($input_90_11))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_gen_folder", GUICtrlRead($check_53_02))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_space_attach", GUICtrlRead($check_53_03))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_zerocode", GUICtrlRead($check_52_02))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_mux_external", GUICtrlRead($check_52_28))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_naming_default", GUICtrlRead($check_54_01))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_naming_emby", GUICtrlRead($check_54_02))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_naming_mp1", GUICtrlRead($check_54_03))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_language_flag", @ScriptDir & "\Images\Flags\" & GUICtrlRead($combo_51_09) & ".jpg")
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_language_flag_all", @ScriptDir & "\Images\Flags\" & GUICtrlRead($combo_51_07) & ".jpg")
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_meta_flag", @ScriptDir & "\Images\Flags\" & GUICtrlRead($input_94_01) & ".jpg")
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_meta_corrction_folder", GUICtrlRead($input_61_01))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_DontSleep", GUICtrlRead($check_51_11))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_DontSleep_standby", GUICtrlRead($check_51_12))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_DontSleep_shutdown", GUICtrlRead($check_51_13))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_tagging", GUICtrlRead($check_92_03))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_transcode_all", GUICtrlRead($check_52_03))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_transcode_allaudio", GUICtrlRead($check_52_04))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_KeepFileDate", GUICtrlRead($check_51_15))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_stub", "*" & GUICtrlRead($combo_47_02))


	If GUICtrlRead($radio_52_01) = 1 Then IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_hwcodec", "1")
	If GUICtrlRead($radio_52_02) = 1 Then IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_hwcodec", "2")
	If GUICtrlRead($radio_52_03) = 1 Then IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_hwcodec", "3")
	If GUICtrlRead($radio_52_04) = 1 Then IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_hwcodec", "4")
	If GUICtrlRead($radio_56_01) = 1 Then IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_artist", "1")
	If GUICtrlRead($radio_56_02) = 1 Then IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_artist", "2")
	If GUICtrlRead($radio_26_31) = 1 Then IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_gfx_color", "1")
	If GUICtrlRead($radio_26_32) = 1 Then IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_gfx_color", "1|2")
	If GUICtrlRead($radio_26_33) = 1 Then IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_gfx_color", "1|3")
	If GUICtrlRead($radio_26_34) = 1 Then IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_gfx_color", "1|2|3")
	If GUICtrlRead($radio_26_35) = 1 Then IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_gfx_color", "2")
	If GUICtrlRead($radio_26_36) = 1 Then IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_gfx_color", "3")
	If GUICtrlRead($radio_26_37) = 1 Then IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_gfx_color", "2|3")

	If GUICtrlRead($radio_26_11) = 1 Then IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_gfxnormalize_type", "1")
	If GUICtrlRead($radio_26_12) = 1 Then IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_gfxnormalize_type", "2")

	If GUICtrlRead($radio_53_41) = 1 Then IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_ratings", "1")
	If GUICtrlRead($radio_53_42) = 1 Then IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_ratings", "2")
	If GUICtrlRead($radio_53_43) = 1 Then IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_ratings", "3")


	$fle_hwnd = FileOpen(@ScriptDir & "\VideoWhitelist.txt", 10)
	FileWrite($fle_hwnd, GUICtrlRead($edit_52_01))
	FileClose($fle_hwnd)

	$fle_hwnd = FileOpen(@ScriptDir & "\AudioWhitelist.txt", 10)
	FileWrite($fle_hwnd, GUICtrlRead($edit_52_02))
	FileClose($fle_hwnd)

	$fle_hwnd = FileOpen(@ScriptDir & "\MediaStub.txt", 10)
	FileWrite($fle_hwnd, GUICtrlRead($edit_52_31))
	FileClose($fle_hwnd)

	$fle_hwnd = FileOpen(@ScriptDir & "\VariousArtists.txt", 10)
	FileWrite($fle_hwnd, GUICtrlRead($edit_56_33))
	FileClose($fle_hwnd)

	$fle_hwnd = FileOpen(@ScriptDir & "\Graphics.txt", 10)
	FileWrite($fle_hwnd, GUICtrlRead($edit_57_01))
	FileClose($fle_hwnd)

	$fle_hwnd = FileOpen(@ScriptDir & "\camera-raw.txt", 10)
	FileWrite($fle_hwnd, GUICtrlRead($edit_57_11))
	FileClose($fle_hwnd)


;~ 	;Language Settings
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "languages", "ini_language", GUICtrlRead($combo_51_09))

;~ 	;Optimizer Settings
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_useoptimizer", GUICtrlRead($check_90_01))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_useoptimizer_subs", GUICtrlRead($check_90_02))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_useoptimizer_video", GUICtrlRead($check_90_12))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_tracksperlanguage_audio", GUICtrlRead($input_90_04))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_tracksperlanguage_forced", GUICtrlRead($input_90_05))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_tracksperlanguage_sub", GUICtrlRead($input_90_06))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_tracks_video", GUICtrlRead($input_90_12))

;~ 	;MetaData Audio Config
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_artistfolderoverwrite", GUICtrlRead($check_56_33))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_artistfolderuse", GUICtrlRead($check_56_32))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_Music_FolderStructure_MultipleDisc", GUICtrlRead($input_56_12))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_Music_FolderStructure", GUICtrlRead($input_56_11))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_Music_Renaming", GUICtrlRead($input_56_14))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_Music_Renaming_VariousArtists", GUICtrlRead($input_56_15))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_Music_Renaming_MultiDisc", GUICtrlRead($input_56_13))

	If GUICtrlRead($radio_48_01) = 1 Then IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_audiotools_copy", "1")
	If GUICtrlRead($radio_48_02) = 1 Then IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_audiotools_copy", "4")


;~ 	;MetaData Series Config
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_meta_series_refresh_nfo", GUICtrlRead($check_92_06))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_meta_series_refresh_gfx", GUICtrlRead($check_92_05))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_Preferred_TVShow", GUICtrlRead($check_92_05))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_kodi19nfo", GUICtrlRead($check_53_33))

;~ 	;MetaData Movies Config
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_meta_movies_refresh_nfo", GUICtrlRead($check_92_16))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_meta_movies_refresh_gfx", GUICtrlRead($check_92_15))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_moviesetfolderuse", GUICtrlRead($check_53_32))

;~ 	;MetaData Videos Config
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_fanart_design", GUICtrlRead($combo_95_01))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_fanart_font", GUICtrlRead($combo_95_02))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_fanart_covermanual", GUICtrlRead($check_130_11))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_fanart_covertemplate", GUICtrlRead($combo_95_03))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_fanart_backdroptemplate", GUICtrlRead($combo_95_04))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_fanart_bordertemplate", GUICtrlRead($combo_95_05))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_fanart_bordercolor", GUICtrlRead($input_95_07))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_fanart_nocover", GUICtrlRead($check_95_01))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_fanart_nobackdrop", GUICtrlRead($check_95_02))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_fanart_nonfo", GUICtrlRead($check_95_03))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_fanart_genrefolder", GUICtrlRead($check_95_04))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_fanart_mediainfo", GUICtrlRead($check_95_05))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_fanart_plot", GUICtrlRead($edit_95_01))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_fanart_genre", GUICtrlRead($input_95_08))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_fanart_background", GUICtrlRead($input_54_07))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_fanart_cover", GUICtrlRead($input_54_08))

;~ 	;Video Normalize Config
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_audio_compression", GUICtrlRead($combo_97_01))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_audio_db", GUICtrlRead($input_97_01))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_audio_normalize", Int(GUICtrlRead($check_97_01)))

	If GUICtrlRead($radio_25_06) = 1 Then IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_normalize_audiocodec", "1")
	If GUICtrlRead($radio_25_07) = 1 Then IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_normalize_audiocodec", "2")
	If GUICtrlRead($radio_25_08) = 1 Then IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_normalize_audiocodec", "3")
	If GUICtrlRead($radio_25_09) = 1 Then IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_normalize_audiocodec", "4")
	If GUICtrlRead($radio_25_10) = 1 Then IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_normalize_audiocodec", "5")
	If GUICtrlRead($radio_25_11) = 1 Then IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_normalize_audiocodec", "6")
	If GUICtrlRead($radio_25_12) = 1 Then IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_normalize_audiocodec", "7")

;~ 	;Audio Normalize Config
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_aaudio_compression", GUICtrlRead($combo_98_01))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_aaudio_db", GUICtrlRead($input_98_01))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_aaudio_normalize", Int(GUICtrlRead($check_98_01)))

	;ARecode Config
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_arecode_bitrate_mp3", GUICtrlRead($combo_14_21))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_arecode_bitrate_flac", GUICtrlRead($combo_14_22))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_arecode_bitrate_opus", GUICtrlRead($combo_14_24))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_arecode_samplingrate_mp3", GUICtrlRead($combo_14_31))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_arecode_samplingrate_flac", GUICtrlRead($combo_14_32))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_arecode_samplingrate_wav", GUICtrlRead($combo_14_33))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_arecode_quality_opus", GUICtrlRead($combo_14_34))

	If GUICtrlRead($radio_14_11) = 1 Then IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_arecode_container", "mp3")
	If GUICtrlRead($radio_14_21) = 1 Then IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_arecode_container", "flac")
	If GUICtrlRead($radio_14_31) = 1 Then IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_arecode_container", "wav")
	If GUICtrlRead($radio_14_41) = 1 Then IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_arecode_container", "ogg")


	;Graphics Config
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_gfx_optpng", GUICtrlRead($check_26_11))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_gfx_optjpg", GUICtrlRead($check_26_12))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_gfx4k", GUICtrlRead($check_26_21))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_gfx1080", GUICtrlRead($check_26_22))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_gfx720", GUICtrlRead($check_26_23))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_gfx600", GUICtrlRead($check_26_24))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_gfxfree", GUICtrlRead($check_26_25))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_gfxorg", GUICtrlRead($check_26_26))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_gfxnormalize", GUICtrlRead($check_26_31))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_gfxunsharp", GUICtrlRead($check_26_32))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_gfx_freesize", GUICtrlRead($input_26_25))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_gfx_format_4k", GUICtrlRead($combo_26_21))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_gfx_format_1080", GUICtrlRead($combo_26_22))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_gfx_format_720", GUICtrlRead($combo_26_23))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_gfx_format_600", GUICtrlRead($combo_26_24))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_gfx_format_free", GUICtrlRead($combo_26_25))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_gfx_format_org", GUICtrlRead($combo_26_26))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_gfx_value_unsharp", GUICtrlRead($combo_26_32))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_gfx_moveorg", GUICtrlRead($check_57_21))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_gfx_optorg", GUICtrlRead($check_57_22))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_gfx_rotate", GUICtrlRead($check_57_23))

	;Recode Config
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_recode_quality_sd", GUICtrlRead($input_21_03))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_recode_quality_720", GUICtrlRead($input_21_04))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_recode_quality_1080", GUICtrlRead($input_21_06))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_recode_quality_4k", GUICtrlRead($input_21_08))

	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_recode_videocodec_SD", GUICtrlRead($combo_21_01))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_recode_videocodec_720", GUICtrlRead($combo_21_02))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_recode_videocodec_1080", GUICtrlRead($combo_21_04))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_recode_videocodec_4K", GUICtrlRead($combo_21_06))

	If GUICtrlRead($radio_21_04) = 1 Then IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_recode_container", "mkv")
	If GUICtrlRead($radio_21_05) = 1 Then IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_recode_container", "mp4")
	If GUICtrlRead($radio_21_06) = 1 Then IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_recode_audiocodec", "1")
	If GUICtrlRead($radio_21_07) = 1 Then IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_recode_audiocodec", "2")
	If GUICtrlRead($radio_21_08) = 1 Then IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_recode_audiocodec", "3")
	If GUICtrlRead($radio_21_09) = 1 Then IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_recode_audiocodec", "4")
	If GUICtrlRead($radio_21_10) = 1 Then IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_recode_audiocodec", "5")
	If GUICtrlRead($radio_21_11) = 1 Then IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_recode_audiocodec", "6")
	If GUICtrlRead($radio_21_12) = 1 Then IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_recode_audiocodec", "7")


	;Remux Config
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_tracksperlanguage_audio", GUICtrlRead($input_90_04))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_tracksperlanguage_forced", GUICtrlRead($input_90_05))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_tracksperlanguage_sub", GUICtrlRead($input_90_06))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_useoptimizer", GUICtrlRead($check_90_01))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_useoptimizer_subs", GUICtrlRead($check_90_02))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_simplemux", GUICtrlRead($check_22_01))


	;Kodi Tools Config
	If GUICtrlRead($radio_44_01) = 1 Then IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_kodi_database", "SQlite")
	If GUICtrlRead($radio_44_02) = 1 Then IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_kodi_database", "MySQL")

	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_kodi_SQLite_database", GUICtrlRead($input_44_12))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_kodi_MySQL_server", GUICtrlRead($input_44_13))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_kodi_MySQL_port", GUICtrlRead($input_44_14))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_kodi_MySQL_user", GUICtrlRead($input_44_15))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_kodi_MySQL_pass", GUICtrlRead($input_44_16))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_kodi_MySQL_database", GUICtrlRead($input_44_17))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_kodi_dot", GUICtrlRead($check_44_40))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_remove_sorttitle", GUICtrlRead($check_53_34))


	;Extract Config
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_extract_video", GUICtrlRead($check_43_01))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_extract_audio", GUICtrlRead($check_43_02))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_extract_subs", GUICtrlRead($check_43_03))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_extract_chapter", GUICtrlRead($check_43_04))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_extract_attachments", GUICtrlRead($check_43_05))

	;Audio Wizard Config
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_audio_not_mp3", GUICtrlRead($check_14_61))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_audio_not_flac", GUICtrlRead($check_14_62))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_audio_not_wav", GUICtrlRead($check_14_63))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_audio_not_opus", GUICtrlRead($check_14_64))

	;Movies Wizard Config
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_wizard_movies_refresh_nfo", GUICtrlRead($check_92_15))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_wizard_movies_refresh_gfx", GUICtrlRead($check_92_16))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_wizard_movies_bitrate_sd", GUICtrlRead($input_12_03))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_wizard_movies_bitrate_720", GUICtrlRead($input_12_04))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_wizard_movies_bitrate_1080", GUICtrlRead($input_12_05))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_wizard_movies_bitrate_4k", GUICtrlRead($input_12_06))

	;Series Wizard Config
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_wizard_series_refresh_nfo", GUICtrlRead($check_92_06))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_wizard_series_refresh_gfx", GUICtrlRead($check_92_05))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_wizard_series_bitrate_sd", GUICtrlRead($input_11_03))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_wizard_series_bitrate_720", GUICtrlRead($input_11_04))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_wizard_series_bitrate_1080", GUICtrlRead($input_11_05))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_wizard_series_bitrate_4k", GUICtrlRead($input_11_06))

	;Videos Wizard Config
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_wizard_videos_bitrate_sd", GUICtrlRead($input_13_03))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_wizard_videos_bitrate_720", GUICtrlRead($input_13_04))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_wizard_videos_bitrate_1080", GUICtrlRead($input_13_05))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_wizard_videos_bitrate_4k", GUICtrlRead($input_13_06))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_fanart_design", GUICtrlRead($combo_95_01))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_fanart_font", GUICtrlRead($combo_95_02))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_fanart_covertemplate", GUICtrlRead($combo_95_03))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_fanart_backdroptemplate", GUICtrlRead($combo_95_04))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_fanart_bordertemplate", GUICtrlRead($combo_95_05))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_fanart_bordercolor", GUICtrlRead($input_95_07))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_fanart_plot", GUICtrlRead($edit_95_01))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_fanart_genre", GUICtrlRead($input_95_08))

	;Tag3D Config
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_3d_mode", GUICtrlRead($combo_42_01))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_3d_rename", GUICtrlRead($check_42_01))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_3d_renamenfo", GUICtrlRead($check_42_03))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_3d_kodinaming", GUICtrlRead($check_42_02))

	;Path settings
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "path", "ini_ffmpeg_path", GUICtrlRead($input_51_03))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "path", "ini_mkvextract_path", GUICtrlRead($input_51_06))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "path", "ini_mkvmerge_path", GUICtrlRead($input_51_04))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "path", "ini_mkvpropedit_path", GUICtrlRead($input_51_05))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "path", "ini_workingdrive", GUICtrlRead($combo_51_08))

EndFunc

;Function to Update controls.
Func _SetData($cControl, $sData)

	If GUICtrlRead($cControl) <> $sData Then GUICtrlSetData($cControl, $sData)

EndFunc

;Function to Update controls.
Func _SetLabel($cControl, $sData)

	If GUICtrlRead($cControl) <> $sData Then GUICtrlSetData($cControl, StringReplace($sData, "&", "&&"))

EndFunc

;Function to Update controls.
Func _SetLanguages()

	Local $lang = GUICtrlRead($combo_51_07)

	Local $path, $sDrive, $sDir, $sFilename, $sExtension

	_WriteLog("Debug - Language to set:" & $lang)

	Select

		Case $lang = "English"

			_SetData($input_94_01, "en")
			_SetData($input_94_04, "eng")

		Case $lang = "deutsch"

			_SetData($input_94_01, "de")
			_SetData($input_94_04, "deu")

	EndSelect

	_SaveJSON()

	FileDelete(@ScriptDir & "\*.pid")

	_WriteLog("------------------")
	_WriteLog("Info - Begin Shuting Down Media-Buddy")

	;Folder Settings
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_append_inputfolder", GUICtrlRead($input_23_01))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_append_outputfolder", GUICtrlRead($input_23_02))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_extract_inputfolder", GUICtrlRead($input_43_01))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_fix_inputfolder", GUICtrlRead($input_41_01))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_fix_outputfolder", GUICtrlRead($input_41_02))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_3d_inputfolder", GUICtrlRead($input_42_01))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_arecode_outputfolder", GUICtrlRead($input_24_02))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_arecode_inputfolder", GUICtrlRead($input_24_01))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_recode_inputfolder", GUICtrlRead($input_21_01))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_recode_outputfolder", GUICtrlRead($input_21_02))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_remux_inputfolder", GUICtrlRead($input_22_01))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_remux_outputfolder", GUICtrlRead($input_22_02))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_movies_metadata_inputfolder", GUICtrlRead($input_32_01))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_series_metadata_inputfolder", GUICtrlRead($input_31_01))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_videos_metadata_inputfolder", GUICtrlRead($input_33_01))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_wizard_movies_inputfolder", GUICtrlRead($input_12_01))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_wizard_movies_outputfolder", GUICtrlRead($input_12_02))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_wizard_series_inputfolder", GUICtrlRead($input_11_01))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_wizard_series_outputfolder", GUICtrlRead($input_11_02))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_wizard_videos_inputfolder", GUICtrlRead($input_13_01))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_wizard_videos_outputfolder", GUICtrlRead($input_13_02))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_wizard_audio_inputfolder", GUICtrlRead($input_14_01))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_wizard_audio_outputfolder", GUICtrlRead($input_14_02))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_movies_correction_inputfolder", GUICtrlRead($input_62_01))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_series_correction_inputfolder", GUICtrlRead($input_61_01))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_videos_correction_inputfolder", GUICtrlRead($input_63_01))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_audio_correction_inputfolder", GUICtrlRead($input_64_01))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_audio_metadata_inputfolder", GUICtrlRead($input_34_01))

	;Generic Settings
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_channelovercodec", GUICtrlRead( $check_52_21))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_codec", GUICtrlRead($combo_52_05))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_codec1", GUICtrlRead($combo_52_23))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_codec2", GUICtrlRead($combo_52_24))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_codec3", GUICtrlRead($combo_52_25))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_codec4", GUICtrlRead($combo_52_26))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_codec5", GUICtrlRead($combo_52_27))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_gen_folder", GUICtrlRead($check_53_02))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_space_attach", GUICtrlRead($check_53_03))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_zerocode", GUICtrlRead($check_52_02))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_naming_default", GUICtrlRead($check_54_01))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_naming_emby", GUICtrlRead($check_54_02))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_naming_mp1", GUICtrlRead($check_54_03))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_language_flag", @ScriptDir & "\Images\Flags\" & GUICtrlRead($combo_51_09) & ".jpg")
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_language_flag_all", @ScriptDir & "\Images\Flags\" & GUICtrlRead($combo_51_07) & ".jpg")
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_meta_flag", @ScriptDir & "\Images\Flags\" & GUICtrlRead($input_94_01) & ".jpg")
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_meta_corrction_folder", GUICtrlRead($input_61_01))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_DontSleep", GUICtrlRead($check_51_11))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_DontSleep_standby", GUICtrlRead($check_51_12))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_DontSleep_shutdown", GUICtrlRead($check_51_13))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_transcode_all", GUICtrlRead($check_52_03))

	$fle_hwnd = FileOpen(@ScriptDir & "\VideoWhitelist.txt", 10)
	FileWrite($fle_hwnd, GUICtrlRead($edit_52_01))
	FileClose($fle_hwnd)

	$fle_hwnd = FileOpen(@ScriptDir & "\AudioWhitelist.txt", 10)
	FileWrite($fle_hwnd, GUICtrlRead($edit_52_02))
	FileClose($fle_hwnd)

	If GUICtrlRead($radio_52_01) = 1 Then IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_hwcodec", "1")
	If GUICtrlRead($radio_52_02) = 1 Then IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_hwcodec", "2")
	If GUICtrlRead($radio_52_03) = 1 Then IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_hwcodec", "3")
	If GUICtrlRead($radio_52_04) = 1 Then IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_hwcodec", "4")

	;Optimizer Settings
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_useoptimizer", GUICtrlRead($check_90_01))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_useoptimizer_subs", GUICtrlRead($check_90_02))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_tracksperlanguage_audio", GUICtrlRead($input_90_04))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_tracksperlanguage_forced", GUICtrlRead($input_90_05))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_tracksperlanguage_sub", GUICtrlRead($input_90_06))

	;MetaData Series Config
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_meta_series_refresh_nfo", GUICtrlRead($check_92_06))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_meta_series_refresh_gfx", GUICtrlRead($check_92_05))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_Preferred_TVShow", GUICtrlRead($check_92_05))

	;MetaData Movies Config
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_meta_movies_refresh_nfo", GUICtrlRead($check_92_16))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_meta_movies_refresh_gfx", GUICtrlRead($check_92_15))

	;MetaData Videos Config
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_fanart_design", GUICtrlRead($combo_95_01))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_fanart_font", GUICtrlRead($combo_95_02))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_fanart_covertemplate", GUICtrlRead($combo_95_03))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_fanart_backdroptemplate", GUICtrlRead($combo_95_04))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_fanart_bordertemplate", GUICtrlRead($combo_95_05))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_fanart_bordercolor", GUICtrlRead($input_95_07))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_fanart_nocover", GUICtrlRead($check_95_01))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_fanart_nobackdrop", GUICtrlRead($check_95_02))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_fanart_nonfo", GUICtrlRead($check_95_03))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_fanart_genrefolder", GUICtrlRead($check_95_04))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_fanart_mediainfo", GUICtrlRead($check_95_05))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_fanart_plot", GUICtrlRead($edit_95_01))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_fanart_genre", GUICtrlRead($input_95_08))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_fanart_background", GUICtrlRead($input_54_07))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_fanart_cover", GUICtrlRead($input_54_08))

	;ARecode Config
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_arecode_bitrate_mp3", GUICtrlRead($combo_14_21))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_arecode_bitrate_flac", GUICtrlRead($combo_14_22))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_arecode_samplingrate_mp3", GUICtrlRead($combo_14_31))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_arecode_samplingrate_flac", GUICtrlRead($combo_14_32))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_arecode_samplingrate_wav", GUICtrlRead($combo_14_33))

	If GUICtrlRead($radio_14_11) = 1 Then IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_arecode_container", "mp3")
	If GUICtrlRead($radio_14_21) = 1 Then IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_arecode_container", "flac")
	If GUICtrlRead($radio_14_31) = 1 Then IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_arecode_container", "wav")

	;Recode Config
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_recode_quality_sd", GUICtrlRead($input_21_03))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_recode_quality_720", GUICtrlRead($input_21_04))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_recode_quality_1080", GUICtrlRead($input_21_06))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_recode_quality_4k", GUICtrlRead($input_21_08))

	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_recode_videocodec_SD", GUICtrlRead($combo_21_01))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_recode_videocodec_720", GUICtrlRead($combo_21_02))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_recode_videocodec_1080", GUICtrlRead($combo_21_04))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_recode_videocodec_4K", GUICtrlRead($combo_21_06))

	If GUICtrlRead($radio_21_04) = 1 Then IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_recode_container", "mkv")
	If GUICtrlRead($radio_21_05) = 1 Then IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_recode_container", "mp4")

	If GUICtrlRead($radio_21_06) = 1 Then IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_recode_audiocodec", "1")
	If GUICtrlRead($radio_21_07) = 1 Then IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_recode_audiocodec", "2")
	If GUICtrlRead($radio_21_08) = 1 Then IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_recode_audiocodec", "3")
	If GUICtrlRead($radio_21_09) = 1 Then IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_recode_audiocodec", "4")

	;Remux Config
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_tracksperlanguage_audio", GUICtrlRead($input_90_04))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_tracksperlanguage_forced", GUICtrlRead($input_90_05))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_tracksperlanguage_sub", GUICtrlRead($input_90_06))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_useoptimizer", GUICtrlRead($check_90_01))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_useoptimizer_subs", GUICtrlRead($check_90_02))

	;Kodi Tools Config
	If GUICtrlRead($radio_44_01) = 1 Then IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_kodi_database", "SQlite")
	If GUICtrlRead($radio_44_02) = 1 Then IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_kodi_database", "MySQL")

	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_kodi_SQLite_database", GUICtrlRead($input_44_12))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_kodi_MySQL_server", GUICtrlRead($input_44_13))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_kodi_MySQL_port", GUICtrlRead($input_44_14))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_kodi_MySQL_user", GUICtrlRead($input_44_15))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_kodi_MySQL_pass", GUICtrlRead($input_44_16))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_kodi_MySQL_database", GUICtrlRead($input_44_17))

	;Extract Config
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_extract_video", GUICtrlRead($check_43_01))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_extract_audio", GUICtrlRead($check_43_02))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_extract_subs", GUICtrlRead($check_43_03))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_extract_chapter", GUICtrlRead($check_43_04))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_extract_attachments", GUICtrlRead($check_43_05))

	;Audio Wizard Config
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_audio_not_mp3", GUICtrlRead($check_14_61))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_audio_not_flac", GUICtrlRead($check_14_62))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_audio_not_wav", GUICtrlRead($check_14_63))

	;Movies Wizard Config
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_wizard_movies_refresh_nfo", GUICtrlRead($check_92_15))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_wizard_movies_refresh_gfx", GUICtrlRead($check_92_16))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_wizard_movies_bitrate_sd", GUICtrlRead($input_12_03))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_wizard_movies_bitrate_720", GUICtrlRead($input_12_04))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_wizard_movies_bitrate_1080", GUICtrlRead($input_12_05))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_wizard_movies_bitrate_4k", GUICtrlRead($input_12_06))

	;Series Wizard Config
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_wizard_series_refresh_nfo", GUICtrlRead($check_92_06))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_wizard_series_refresh_gfx", GUICtrlRead($check_92_05))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_wizard_series_bitrate_sd", GUICtrlRead($input_11_03))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_wizard_series_bitrate_720", GUICtrlRead($input_11_04))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_wizard_series_bitrate_1080", GUICtrlRead($input_11_05))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_wizard_series_bitrate_4k", GUICtrlRead($input_11_06))

	;Videos Wizard Config
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_wizard_videos_bitrate_sd", GUICtrlRead($input_13_03))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_wizard_videos_bitrate_720", GUICtrlRead($input_13_04))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_wizard_videos_bitrate_1080", GUICtrlRead($input_13_05))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_wizard_videos_bitrate_4k", GUICtrlRead($input_13_06))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_fanart_design", GUICtrlRead($combo_95_01))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_fanart_font", GUICtrlRead($combo_95_02))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_fanart_covertemplate", GUICtrlRead($combo_95_03))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_fanart_backdroptemplate", GUICtrlRead($combo_95_04))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_fanart_bordertemplate", GUICtrlRead($combo_95_05))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_fanart_bordercolor", GUICtrlRead($input_95_07))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_fanart_plot", GUICtrlRead($edit_95_01))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_fanart_genre", GUICtrlRead($input_95_08))

	;Tag3D Config
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_3d_mode", GUICtrlRead($combo_42_01))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_3d_rename", GUICtrlRead($check_42_01))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_3d_renamenfo", GUICtrlRead($check_42_03))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_3d_kodinaming", GUICtrlRead($check_42_02))

	;Path settings
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "path", "ini_ffmpeg_path", GUICtrlRead($input_51_03))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "path", "ini_mkvextract_path", GUICtrlRead($input_51_06))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "path", "ini_mkvmerge_path", GUICtrlRead($input_51_04))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "path", "ini_mkvpropedit_path", GUICtrlRead($input_51_05))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "path", "ini_workingdrive", GUICtrlRead($combo_51_08))

	Select

		Case $lang = "English"

			IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_audiolanguages", "en")
			IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_sublanguages", "en")
			IniWrite(@ScriptDir & "\Media-Buddy.ini", "languages", "ini_language", "English")

		Case $lang = "deutsch"

			IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_audiolanguages", "de")
			IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_sublanguages", "de")
			IniWrite(@ScriptDir & "\Media-Buddy.ini", "languages", "ini_language", "deutsch")

	EndSelect

	_SQLite_Close(-1)

	_SQLite_Shutdown()

	_WriteLog("Info - SQlite Shut Down")

	If ProcessExists("DontSleep_x64.exe") Then

		ShellExecuteWait(@ScriptDir & "\DontSleep_x64.exe", "exit")

		_WriteLog("Info - DontSleep Shut Down")

	EndIf

	DirRemove($tempdir, 1)

	_WriteLog("Info - Removed Working Directory")

	_WriteLog("Info - Shutting Down Media-Buddy")

	_Restart()

EndFunc

;Function to Update Metadata Flags.
Func _SetFlag()

	Local $ln, $la, $gl

	Local $language_flag = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_language_flag", @ScriptDir & "\Images\Flags\English.jpg")
	Local $language_flag_all = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_language_flag_all", @ScriptDir & "\Images\Flags\English.jpg")
	Local $meta_flag = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_meta_flag", @ScriptDir & "\Images\Flags\en.jpg")

	$ln = GUICtrlRead($input_94_01)
	$la = GUICtrlRead($combo_51_09)
	$gl = GUICtrlRead($combo_51_07)

	If $meta_flag <> @ScriptDir & "\Images\Flags\" & $ln & ".jpg" Then

		GUICtrlDelete($pic_94_01)
		GUICtrlDelete($pic_94_01a)

		$pic_94_01 = GUICtrlCreatePic(@ScriptDir & "\Images\Flags\" & $ln & ".jpg", 750, 421, 68, 40)
		GUICtrlSetState($pic_94_01, $GUI_HIDE)
		$pic_94_01a = GUICtrlCreatePic(@ScriptDir & "\Images\Flags\black.jpg", 749, 420, 70, 42)
		GUICtrlSetState($pic_94_01a, $GUI_HIDE)

		IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_meta_flag", @ScriptDir & "\Images\Flags\" & $ln & ".jpg")

	EndIf

	If $language_flag <> @ScriptDir & "\Images\Flags\" & $la & ".jpg" Then

		GUICtrlDelete($pic_51_01)
		GUICtrlDelete($pic_51_03)

		$pic_51_01 = GUICtrlCreatePic(@ScriptDir & "\Images\Flags\" & $la & ".jpg", 150, 281, 68, 40)
		$pic_51_03 = GUICtrlCreatePic(@ScriptDir & "\Images\Flags\black.jpg", 149, 280, 70, 42)

		IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_language_flag", @ScriptDir & "\Images\Flags\" & $la & ".jpg")

	EndIf

	If $language_flag_all <> @ScriptDir & "\Images\Flags\" & $gl & ".jpg" Then

		GUICtrlDelete($pic_51_02)
		GUICtrlDelete($pic_51_04)

		$pic_51_02 = GUICtrlCreatePic(@ScriptDir & "\Images\Flags\" & $gl & ".jpg", 150, 381, 68, 40)
		$pic_51_04 = GUICtrlCreatePic(@ScriptDir & "\Images\Flags\black.jpg", 149, 380, 70, 42)

		IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_language_flag_all", @ScriptDir & "\Images\Flags\" & $gl & ".jpg")

	EndIf

EndFunc

;Function to Set File Times
Func _SetTimeSegment($InFile, $OutFile)

	Local 	$path, $sDrive, $sDir, $sFilename, $sExtension, $Row

	$Path = _PathSplit(StringReplace($InFile, "\'", "''"), $sDrive, $sDir, $sFilename, $sExtension)

	_SQLite_QuerySingleRow(-1,'SELECT Year,Year1,Year2 FROM FileList WHERE Path Like "' & $Path[1] & $Path[2] & '" AND Filename LIKE "' & $Path[3] & '";',$Row)

	If UBound($Row) = 3 Then

		FileSetTime($OutFile,$Row[0],0)
		FileSetTime($OutFile,$Row[1],1)
		FileSetTime($OutFile,$Row[2],2)

	EndIf

EndFunc

;Function to Update Progressbar during LargeFileCopy.
Func _SetCopyProgress($bytes, $size, $progress)

	Local $percent, $split, $step1, $p, $timeticks, $timeelapsed, $timeelapsed1, $iHours, $iMins, $iSecs, $Time, $Timetotal, $Time1

	$split = StringSplit($progress, "|")

	$percent = Round(($bytes / $size) * 100, 2)

	$step1 = 100 / $split[4]

	$p = ($step1 * ($split[5] - 1)) + ($percent /  $split[4])

	$timeticks = _Timer_Diff($timer)

	$Timetotal = Round(($timeticks * 100)/$percent)

	$timeelapsed = _TicksToTime($timeticks, $iHours, $iMins, $iSecs)

	$Time = StringFormat("%02i:%02i:%02i", $iHours, $iMins, $iSecs)

	$timeelapsed1 = _TicksToTime($Timetotal, $iHours, $iMins, $iSecs)

	$Time1 = StringFormat("%02i:%02i:%02i", $iHours, $iMins, $iSecs)

	_SetData($split[1], $percent)

	_SetData($split[3], $p)

	_SetLabel($Label02, $lng_workingon  & " " & $lng_files & " " & $lng_copy & "   " & $split[2] & " --- " & $lng_progress & ": " & StringFormat("%00.2f", $percent) & "% --- " & $lng_elapsed & ": " & $Time & " --- " & $lng_total & ": " & $Time1)


EndFunc

;Function To Shutdown PC
Func _Shutdown()

	Local $value = MsgBox(292, $lng_sucess, $lng_autoend4 & @CRLF & @CRLF & $lng_autoend2, 30)

	If $value = -1 Or $value = 6 Then

		Shutdown(29)

	EndIf

	_LastModule()

EndFunc

;Function to Remux Files
Func _Simple_RemuxFile($InFile, $OutFile, $Cancelbutton = "0000", $progressbar = "0000", $progressbar2 = "0000", $count = 1, $i_global = 1)

	Local $path, $MediaInfo, $sDrive, $sDir, $sFilename, $sExtension, $numbers, $break, $subtotal
	Local $trackNumbers, $i, $ForcedNumbers, $textNumbers, $txtNumbers, $subtitle = 0, $seek, $videomap
	Local $value, $sOutput, $result, $StringLine, $aString, $step1, $p, $Forced, $option3, $option4, $iPID, $a
	Local $query, $Rval, $Res, $Rows, $Columns, $arow, $aResult, $iRows, $iColumns, $acodec, $dvb = 0

	_WriteLog("Simple_RemuxFile - Start Working On  " & $InFile)

	$path = _PathSplit(StringReplace($InFile,"\'", "'"), $sDrive, $sDir, $sFilename, $sExtension)

	$option = "-o " & $OutFile & " " & $InFile

	$iPID = Run(@ComSpec & ' /c ToolBox.exe --filename:mkvmerge.exe --arguments:" ' & $option, @ScriptDir, @SW_HIde, $STdeRR_CHILD + $STDOUT_CHILD) ;  --debug

	$step1 = 100 / $Count

	While ProcessExists($iPID)

		$a = GUIGetCursorInfo()

		If IsArray($a) Then

			If $a[2] = 1 And $a[4] = $Cancelbutton Then

				$value = MsgBox(19, $lng_cancel, $lng_cancel1 & @CRLF & $lng_areyousure & "." & @CRLF & @CRLF & $lng_cancel2 & @CRLF & $lng_cancel3 & @CRLF & $lng_cancel4)

				If $value = 2 Then ;Instantly Abort

					_WriteLog("Simple_RemuxFile - Triggered Instant Abort")

					_CloseProcess($iPID)

					$break = 1

				EndIf

				If $value = 6 Then ;Finish File and Abort

					_WriteLog("Simple_RemuxFile - Triggered Abort After Recent File")

					$break = 1

				EndIf

			EndIf

		EndIf

		$sOutput =  _OEMToAnsi(StdoutRead($iPID))

		$result = StringInStr($sOutput, "#")

		If $result = 1 Then

			$StringLine = StringSplit($sOutput, @CRLF)
			$aString = StringSplit($StringLine[1], "|")

			$p = ($step1 * ($i_global - 1)) + (Round($aString[4]) / $Count)

			_SetData($progressbar2, $p)

			_SetData($progressbar, $aString[4])

			If StringLen($Path[3]) > 75 Then

				$len = StringLeft($Path[3], 70) & "... "

			Else

				$len = $Path[3]

			EndIf

			_SetLabel($Label02, $lng_workingon  & "   " & $len & $Path[4] & " --- " & $lng_progress & ": " & $aString[4] & "% --- " & $lng_elapsed & ": " & $aString[5] & " --- " & $lng_total & ": " & $aString[6])

		EndIf

		If @error Then

			_WriteLog("Simple_RemuxFile - Error Message = " & StderrRead($iPID))

			ExitLoop

		EndIf

		Sleep(100)

	WEnd

	_SetData($progressbar, 0)

	_WriteLog("Simple_RemuxFile - Finished Working On  " & $InFile)

	Return $break

EndFunc

;Function To Standby PC
Func _Standby()

	Local $value = MsgBox(292, $lng_sucess, $lng_autoend5 & @CRLF & @CRLF & $lng_autoend2, 30)

	If $value = -1 Or $value = 6 Then

		Shutdown(52)

	EndIf

	_LastModule()

EndFunc

;Function to tag movies
Func _Tagmovies($InDir)

	Local $movies, $File0, $iFileExists, $Folder, $FileList, $Title, $year, $plot, $yeart, $mpaa, $plott
	Local $iFileExists, $iPosition, $iPosition1, $iPosition2, $aPathSplit, $option, $option2, $option3
	Local $sDrive = "", $sDir = "", $sFilename = "", $sExtension = "", $t, $idt, $idm, $idi, $i, $File1

	_WriteLog("Tag_Movies - Started")

	_SetLabel($Label02, "Tagging")

	_SetLabel($Label192, "Tagging")


	$movieslist = _FileListToArrayRec($indir, "*.nfo", 1, 1, 1)

	If _ElementExists($movieslist,0) Then

		For $i = 1 to $movieslist[0]

			$movie = StringSplit($movieslist[$i], "\")

			$File0 = $indir & "\" & $movieslist[$i]

			_SetLabel($Label02, "Tagging: " & $movieslist[$i])

			_SetLabel($Label192, "Tagging: " & $movieslist[$i])

			$iFileExists = FileExists($File0)

			If $iFileExists = 1 Then

				$Folder = $indir & "\"

				$FileList = _FileListToArrayRec($Folder, "*.mkv;*.mk3d", 1, 1, 1)

				If IsArray($FileList) Then

				_WriteLog("Tag_movies - $indir = " & $indir)

					$movnfo = FileRead($File0)

					If $json_use_uniqueID = "true" Then

						$iPosition = StringInStr($movnfo, '<uniqueid type="tmdb">')

						If $iPosition > 0 Then

							$idt1 = _StringBetween($movnfo, '<uniqueid type="tmdb">', '</uniqueid>')

							If _ElementExists($idt1,0) then

								$idm = $idt1[0]

							Else

								$idm = 0

							EndIf

						Else

							$idm = 0

						EndIf

						$iPosition = StringInStr($movnfo, '<uniqueid type="imdb">')

						If $iPosition > 0 Then

							$idt1 = _StringBetween($movnfo, ' <uniqueid type="imdb">', '</uniqueid>')

							If _ElementExists($idt1,0) then

								$idi = $idt1[0]

							Else

								$idi = 0

							EndIf

						Else

							$idi = 0

						EndIf

					Else

						$iPosition = StringInStr($movnfo, "<id>")

						If $iPosition > 0 Then

							$idt1 = _StringBetween($movnfo, "<id>", "</id>")

							$idi = $idt1[0]

						Else

							$idi = 0

						EndIf

					EndIf

					$iPosition = StringInStr($movnfo, "<mpaa>")

					If $iPosition > 0 Then

						$mpaa1 = _StringBetween($movnfo, "<mpaa>", "</mpaa>")
						$mpaa = $mpaa1[0]

					Else

						$mpaa = "NOT RATED"

					EndIf

					$titlet = _StringBetween($movnfo, "<title>", "</title>")

					$iPosition = StringInStr($movnfo, "<plot>")

					If $iPosition > 0 Then

						$plott1 = _StringBetween($movnfo, "<plot>", "</plot>")
						$plott = $plott1[0]

					Else

						$plott = "Unknown"

					EndIf

					$iPosition = StringInStr($movnfo, "<premiered>")

					If $iPosition > 0 Then

						$yeart1 = _StringBetween($movnfo, "<premiered>", "</premiered>")
						$yeart = $yeart1[0]

					Else

						$yeart = "Unknown"

					EndIf

					$File1 = $indir & "\" & $FileList[$i]

					$fle_hwnd = FileOpen(StringTrimRight($File1, 3) & "xml", 130)

					FileWrite($fle_hwnd, '<?xml version="1.0" encoding="UTF-8" standalone="yes"?>' & @CRLF & '<!--created on ' & _Now() & ' - Media-Buddy ' & $version & ' -->' & @CRLF & '<Tags>' & @CRLF & '  <Tag>' & @CRLF & '    <Targets>' & @CRLF & '      <TargetTypeValue>50</TargetTypeValue>' & @CRLF & '    </Targets>' & @CRLF)

					FileWrite($fle_hwnd, '    <Simple>' & @CRLF & '      <Name>TITLE</Name>' & @CRLF & '      <String>' & $titlet[0] & '</String>' & @CRLF & '      <TagLanguage>und</TagLanguage>' & @CRLF & '      <DefaultLanguage>1</DefaultLanguage>' & @CRLF & '    </Simple>' & @CRLF)

					If $idm <> "0" Then FileWrite($fle_hwnd, '    <Simple>' & @CRLF & '      <Name>TMDB</Name>' & @CRLF & '      <String>' & $idm & '</String>' & @CRLF & '      <TagLanguage>und</TagLanguage>' & @CRLF & '      <DefaultLanguage>1</DefaultLanguage>' & @CRLF & '    </Simple>' & @CRLF)

					If $idi <> "0" Then FileWrite($fle_hwnd, '    <Simple>' & @CRLF & '      <Name>IMDB</Name>' & @CRLF & '      <String>' & $idi & '</String>' & @CRLF & '      <TagLanguage>und</TagLanguage>' & @CRLF & '      <DefaultLanguage>1</DefaultLanguage>' & @CRLF & '    </Simple>' & @CRLF)

					FileWrite($fle_hwnd, '    <Simple>' & @CRLF & '      <Name>DATE_RELEASED</Name>' & @CRLF & '      <String>' & $yeart & '</String>' & @CRLF & '      <TagLanguage>und</TagLanguage>' & @CRLF & '      <DefaultLanguage>1</DefaultLanguage>' & @CRLF & '    </Simple>' & @CRLF)

					FileWrite($fle_hwnd, '    <Simple>' & @CRLF & '      <Name>LAW_RATING</Name>' & @CRLF & '      <String>' & $mpaa & '</String>' & @CRLF & '      <TagLanguage>und</TagLanguage>' & @CRLF & '      <DefaultLanguage>1</DefaultLanguage>' & @CRLF & '    </Simple>' & @CRLF)

					FileWrite($fle_hwnd, '    <Simple>' & @CRLF & '      <Name>SUMMARY</Name>' & @CRLF & '      <String>' & $plott & '</String>' & @CRLF & '      <TagLanguage>und</TagLanguage>' & @CRLF & '      <DefaultLanguage>1</DefaultLanguage>' & @CRLF & '    </Simple>' & @CRLF)

					FileWrite($fle_hwnd, '  </Tag>' & @CRLF)

					FileWrite($fle_hwnd, @CRLF & '</Tags>')

					FileClose($fle_hwnd)

					$option = '"' & $File1 & '" -t ' & 'all:"' & StringTrimRight($File1, 3) & "xml" & '"'

					_WriteLog("Tagmovies - $option = " & $option)

					ShellExecuteWait( $ini_mkvpropedit_path, $option, "", "", @SW_HIde)

					Sleep(50)

					ShellExecuteWait( $ini_mkvpropedit_path, $option, "", "", @SW_HIde)

					; Set Video name as Segment Name...

					$aPathSplit = _PathSplit($File1, $sDrive, $sDir, $sFilename, $sExtension)

					$option3 = '"' & $File1 & '"'

					$option3 = $option3 & ' --set "title=' & $aPathSplit[3] & '"';

					ShellExecuteWait( $ini_mkvpropedit_path, $option3, "", "", @SW_HIde)

					Sleep(50)

					FileDelete(StringTrimRight($File1, 3) & "xml")

				EndIf

			EndIf

			If $ini_remove_sorttitle = 1 Then _RemoveSorttitle($File0)

		Next

	EndIf

	_WriteLog("Tag_Movies - Finished")

	_SetLabel($Label02, $lng_waiting)

	_SetLabel($Label192, $lng_waiting)

	Return

EndFunc

;Function to tag series
Func _TagSeries($seriesdir = "", $type="1")

	Local $season, $episode, $Title, $multi, $year, $plot, $yeart, $network, $mpaa, $plott, $series
	Local $iFileExists, $iPosition, $iPosition1, $iPosition2, $aPathSplit, $option, $option2, $option3
	Local $sDrive = "", $sDir = "", $sFilename = "", $sExtension = "", $t, $idt, $idm, $idi, $indir

	Dim $titlet[1], $idt1[1], $season[1], $yeart1[1], $network1[1], $mpaa1[1], $plott1[1], $split2[1], $serieslist[0]

	_WriteLog("Tag_Series - Started")

	_WriteLog("Tag_Series - $type = " & $type)

	_SetLabel($Label02, "Tagging")

	_SetLabel($Label192, "Tagging")


	If $type = "1" Then

		$indir = IniRead(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_series_correction_inputfolder", @MyDocumentsDir) & "\" & $seriesdir

		$series =  $seriesdir

	Else

		$indir = $seriesdir

	EndIf

	$serieslist = _FileListToArrayRec($indir, "tvshow.nfo", 1, 1, 1)

	For $i = 1 to $serieslist[0]

		If $type = "2" Then

			$serie = StringSplit($serieslist[$i], "\")

			$series = $serie[1]

			$indir = $seriesdir & "\" & $series

		EndIf

		_SetLabel($Label02, "Tagging: " & $indir)

		_SetLabel($Label192, "Tagging: " & $indir)

		$File0 = $indir & "\tvshow.nfo"

		$iFileExists = FileExists($File0)

		If $iFileExists = 1 Then

			$Folder = $indir & "\"

			$FileList = _FileListToArrayRec($Folder, "*.mkv;*.mk3d", 1, 1, 1)

			If IsArray($FileList) Then

			_WriteLog("Tag_Series - $indir = " & $indir)

			If $FileList[1] <> "" Then

				$tvnfo = FileRead($File0)

				If $json_use_uniqueID = "true" Then

					$iPosition = StringInStr($tvnfo, '<uniqueid type="tvdb">')

					If $iPosition > 0 Then

						$idt1 = _StringBetween($tvnfo, '<uniqueid type="tvdb">', '</uniqueid>')

						If _ElementExists($idt1,0) then

							$idt = $idt1[0]

						Else

							$idt = 0

						EndIf

					Else

						$idt = 0

					EndIf

					$iPosition = StringInStr($tvnfo, '<uniqueid type="tmdb">')

					If $iPosition > 0 Then

						$idt1 = _StringBetween($tvnfo, '<uniqueid type="tmdb">', '</uniqueid>')

						If _ElementExists($idt1,0) then

							$idm = $idt1[0]

						Else

							$idm = 0

						EndIf

					Else

						$idm = 0

					EndIf

					$iPosition = StringInStr($tvnfo, '<uniqueid type="imdb">')

					If $iPosition > 0 Then

						$idt1 = _StringBetween($tvnfo, ' <uniqueid type="imdb">', '</uniqueid>')

						If _ElementExists($idt1,0) then

							$idi = $idt1[0]

						Else

							$idi = 0

						EndIf

					Else

						$idi = 0

					EndIf



				Else

					$iPosition = StringInStr($tvnfo, "<id>")

					If $iPosition > 0 Then

						$idt1 = _StringBetween($tvnfo, "<id>", "</id>")

						if _ElementExists($idt1,0) Then

							$idt = $idt1[0]

						Else

							$idt = 0

						EndIf

					Else

						$idt = 0

					EndIf

				EndIf

				$iPosition = StringInStr($tvnfo, "<mpaa>")

				If $iPosition > 0 Then

					$mpaa1 = _StringBetween($tvnfo, "<mpaa>", "</mpaa>")
					$mpaa = $mpaa1[0]

				Else

					$mpaa = "NOT RATED"

				EndIf

				$titlet = _StringBetween($tvnfo, "<title>", "</title>")

				$iPosition = StringInStr($tvnfo, "<plot>")

				If $iPosition > 0 Then

					$plott1 = _StringBetween($tvnfo, "<plot>", "</plot>")
					$plott = $plott1[0]

				Else

					$plott = "Unknown"

				EndIf

				$iPosition = StringInStr($tvnfo, "<premiered>")

				If $iPosition > 0 Then

					$yeart1 = _StringBetween($tvnfo, "<premiered>", "</premiered>")
					$yeart = $yeart1[0]

				Else

					$yeart = "Unknown"

				EndIf

				$iPosition = StringInStr($tvnfo, "<studio>")

				If $iPosition > 0 Then

					$network1 = _StringBetween($tvnfo, "<studio>", "</studio>")
					$network = $network1[0]

				Else

					$network = "Unknown"

				EndIf

				For $J = 1 To $FileList[0]

					$File1 = $indir & "\" & $FileList[$J]

					_SetLabel($Label02, "Tagging: " & $series & "\" & $FileList[$J])

					_SetLabel($Label192, "Tagging: " & $series & "\" & $FileList[$J])

					$split2 = StringSplit($FileList[$J], "\")

						_SetLabel($PR_label_04, $split2[1])
						If _ElementExists($split2, 2) Then _SetLabel($PR_label_05, $split2[2])

						$aPathSplit = _PathSplit($File1, $sDrive, $sDir, $sFilename, $sExtension)

						$File2 = $aPathSplit[1] & $aPathSplit[2] & $aPathSplit[3] & ".nfo"

						$iFileExists = FileExists($File2)

						If $iFileExists = 1 Then

							$nfo = FileRead($File2)

							$iPosition1 = StringInStr($nfo, "<season>")
							$iPosition2 = StringInStr($nfo, "<episode>")

							If $iPosition1 And $iPosition2 > 0 Then

								$season = _StringBetween($nfo, "<season>", "</season>")

								$episode = _StringBetween($nfo, "<episode>", "</episode>")

								$Title = _StringBetween($nfo, "<title>", "</title>")

								$multi = UBound($episode) - 1

								$year = _StringBetween($nfo, "<premiered>", "</premiered>")

								$plot = _StringBetween($nfo, "<plot>", "</plot>")

								$fle_hwnd = FileOpen(StringTrimRight($File1, 3) & "xml", 130)


								FileWrite($fle_hwnd, '<?xml version="1.0" encoding="UTF-8" standalone="yes"?>' & @CRLF & '<!--created on ' & _Now() & ' - Media-Buddy ' & $version & ' -->' & @CRLF & '<Tags>' & @CRLF & '  <Tag>' & @CRLF & '    <Targets>' & @CRLF & '      <TargetTypeValue>70</TargetTypeValue>' & @CRLF & '    </Targets>' & @CRLF)

								FileWrite($fle_hwnd, '    <Simple>' & @CRLF & '      <Name>TITLE</Name>' & @CRLF & '      <String>' & $titlet[0] & '</String>' & @CRLF & '      <TagLanguage>und</TagLanguage>' & @CRLF & '      <DefaultLanguage>1</DefaultLanguage>' & @CRLF & '    </Simple>' & @CRLF)

								If $idt <> "0" Then FileWrite($fle_hwnd, '    <Simple>' & @CRLF & '      <Name>TVDB</Name>' & @CRLF & '      <String>' & $idt & '</String>' & @CRLF & '      <TagLanguage>und</TagLanguage>' & @CRLF & '      <DefaultLanguage>1</DefaultLanguage>' & @CRLF & '    </Simple>' & @CRLF)

								If $idm <> "0" Then FileWrite($fle_hwnd, '    <Simple>' & @CRLF & '      <Name>TMDB</Name>' & @CRLF & '      <String>' & $idm & '</String>' & @CRLF & '      <TagLanguage>und</TagLanguage>' & @CRLF & '      <DefaultLanguage>1</DefaultLanguage>' & @CRLF & '    </Simple>' & @CRLF)

								If $idi <> "0" Then FileWrite($fle_hwnd, '    <Simple>' & @CRLF & '      <Name>IMDB</Name>' & @CRLF & '      <String>' & $idi & '</String>' & @CRLF & '      <TagLanguage>und</TagLanguage>' & @CRLF & '      <DefaultLanguage>1</DefaultLanguage>' & @CRLF & '    </Simple>' & @CRLF)

								FileWrite($fle_hwnd, '    <Simple>' & @CRLF & '      <Name>DATE_RELEASED</Name>' & @CRLF & '      <String>' & $yeart & '</String>' & @CRLF & '      <TagLanguage>und</TagLanguage>' & @CRLF & '      <DefaultLanguage>1</DefaultLanguage>' & @CRLF & '    </Simple>' & @CRLF)

								FileWrite($fle_hwnd, '    <Simple>' & @CRLF & '      <Name>NETWORK</Name>' & @CRLF & '      <String>' & $network & '</String>' & @CRLF & '      <TagLanguage>und</TagLanguage>' & @CRLF & '      <DefaultLanguage>1</DefaultLanguage>' & @CRLF & '    </Simple>' & @CRLF)

								FileWrite($fle_hwnd, '    <Simple>' & @CRLF & '      <Name>LAW_RATING</Name>' & @CRLF & '      <String>' & $mpaa & '</String>' & @CRLF & '      <TagLanguage>und</TagLanguage>' & @CRLF & '      <DefaultLanguage>1</DefaultLanguage>' & @CRLF & '    </Simple>' & @CRLF)

								FileWrite($fle_hwnd, '    <Simple>' & @CRLF & '      <Name>SUMMARY</Name>' & @CRLF & '      <String>' & $plott & '</String>' & @CRLF & '      <TagLanguage>und</TagLanguage>' & @CRLF & '      <DefaultLanguage>1</DefaultLanguage>' & @CRLF & '    </Simple>' & @CRLF)

								FileWrite($fle_hwnd, '  </Tag>' & @CRLF)

								FileWrite($fle_hwnd, '  <Tag>' & @CRLF & '    <Targets>' & @CRLF & '      <TargetTypeValue>60</TargetTypeValue>' & @CRLF & '    </Targets>' & @CRLF)

								FileWrite($fle_hwnd, '    <Simple>' & @CRLF & '      <Name>PART_NUMBER</Name>' & @CRLF & '      <String>' & $season[0] & '</String>' & @CRLF & '      <TagLanguage>und</TagLanguage>' & @CRLF & '      <DefaultLanguage>1</DefaultLanguage>' & @CRLF & '    </Simple>' & @CRLF)

								FileWrite($fle_hwnd, '  </Tag>' & @CRLF)

								For $k = 0 To $multi

									FileWrite($fle_hwnd, '  <Tag>' & @CRLF & '    <Targets>' & @CRLF & '      <TargetTypeValue>50</TargetTypeValue>' & @CRLF & '      <ChapterUID>12' & $k & '</ChapterUID>' & @CRLF & '    </Targets>' & @CRLF)

									If _elementExists($episode, $k) Then

										FileWrite($fle_hwnd, '    <Simple>' & @CRLF & '      <Name>PART_NUMBER</Name>' & @CRLF & '      <String>' & $episode[$k] & '</String>' & @CRLF & '      <TagLanguage>und</TagLanguage>' & @CRLF & '      <DefaultLanguage>1</DefaultLanguage>' & @CRLF & '    </Simple>' & @CRLF)

									Else

										MsgBox(0, "", "Error, found no Episodes Number in nfo for file" & $File1)
										FileWrite($fle_hwnd, '    <Simple>' & @CRLF & '      <Name>PART_NUMBER</Name>' & @CRLF & '      <String> </String>' & @CRLF & '      <TagLanguage>und</TagLanguage>' & @CRLF & '      <DefaultLanguage>1</DefaultLanguage>' & @CRLF & '    </Simple>' & @CRLF)

									EndIf

									If _elementExists($year, $k) Then

										FileWrite($fle_hwnd, '    <Simple>' & @CRLF & '      <Name>DATE_RELEASED</Name>' & @CRLF & '      <String>' & $year[$k] & '</String>' & @CRLF & '      <TagLanguage>und</TagLanguage>' & @CRLF & '      <DefaultLanguage>1</DefaultLanguage>' & @CRLF & '    </Simple>' & @CRLF)

									Else

										FileWrite($fle_hwnd, '    <Simple>' & @CRLF & '      <Name>DATE_RELEASED</Name>' & @CRLF & '      <String> </String>' & @CRLF & '      <TagLanguage>und</TagLanguage>' & @CRLF & '      <DefaultLanguage>1</DefaultLanguage>' & @CRLF & '    </Simple>' & @CRLF)

									EndIf

									If _elementExists($Title, $k) Then

										FileWrite($fle_hwnd, '    <Simple>' & @CRLF & '      <Name>TITLE</Name>' & @CRLF & '      <String>' & $Title[$k] & '</String>' & @CRLF & '      <TagLanguage>und</TagLanguage>' & @CRLF & '      <DefaultLanguage>1</DefaultLanguage>' & @CRLF & '    </Simple>' & @CRLF)

									Else

										FileWrite($fle_hwnd, '    <Simple>' & @CRLF & '      <Name>TITLE</Name>' & @CRLF & '      <String> </String>' & @CRLF & '      <TagLanguage>und</TagLanguage>' & @CRLF & '      <DefaultLanguage>1</DefaultLanguage>' & @CRLF & '    </Simple>' & @CRLF)

									EndIf

									If _elementExists($plot, 0) Then

										FileWrite($fle_hwnd, '    <Simple>' & @CRLF & '      <Name>SUMMARY</Name>' & @CRLF & '      <String>' & $plot[0] & '</String>' & @CRLF & '      <TagLanguage>und</TagLanguage>' & @CRLF & '      <DefaultLanguage>1</DefaultLanguage>' & @CRLF & '    </Simple>' & @CRLF & '  </Tag>')

									Else

										FileWrite($fle_hwnd, '    <Simple>' & @CRLF & '      <Name>SUMMARY</Name>' & @CRLF & '      <String> </String>' & @CRLF & '      <TagLanguage>und</TagLanguage>' & @CRLF & '      <DefaultLanguage>1</DefaultLanguage>' & @CRLF & '    </Simple>' & @CRLF & '  </Tag>')

									EndIf

								Next

								FileWrite($fle_hwnd, @CRLF & '</Tags>')

								FileClose($fle_hwnd)

							$option = '"' & $File1 & '" -t ' & 'all:"' & StringTrimRight($File1, 3) & "xml" & '"'

							_WriteLog("TagSeries - $option = " & $option)

							ShellExecuteWait( $ini_mkvpropedit_path, $option, "", "", @SW_HIde)

							Sleep(50)

							ShellExecuteWait( $ini_mkvpropedit_path, $option, "", "", @SW_HIde)

							; Set Video name as Segment Name...

							$aPathSplit = _PathSplit($File1, $sDrive, $sDir, $sFilename, $sExtension)

							$option3 = '"' & $File1 & '"'

							$option3 = $option3 & ' --set "title=' & $aPathSplit[3] & '"';

							ShellExecuteWait( $ini_mkvpropedit_path, $option3, "", "", @SW_HIde)

							Sleep(50)

							FileDelete(StringTrimRight($File1, 3) & "xml")

							EndIf

						EndIf

					Next

				EndIf

			EndIf

		EndIf

	Next

	_WriteLog("Tag_Series - Finished")

	_SetLabel($Label02, $lng_waiting)

	_SetLabel($Label192, $lng_waiting)

	If $type = "1" Then MsgBox(0, "", $lng_sucess, 3)

	Return

EndFunc   ;==>TagSeries

;Function To Tag Names into MKV
Func _TagNames($InDir)

	_WriteLog("Tag Names - Started Working On: " & $InDir)

	Local $WorkArray, $option, $Path, $sDrive, $sDir, $sFilename, $sExtension, $Time0, $Time1, $Time2

	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_3d_mode", GUICtrlRead($combo_42_01))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_3d_rename", GUICtrlRead($check_42_01))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_3d_renamenfo", GUICtrlRead($check_42_03))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_3d_kodinaming", GUICtrlRead($check_42_02))

	$ini_3d_mode = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_3d_mode", "mono")
	$ini_3d_kodinaming = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_3d_kodinaming", "4")
	$ini_3d_rename = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_3d_rename", "4")
	$ini_3d_renamenfo = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_3d_renamenfo", "1")

	$WorkArray = _FileListToArrayRec($InDir, "*mkv;*.mk3d", 1, 1)

	If Not IsArray($WorkArray) Then

		_WriteLog("Tag Names - No MKV files found in: " & $InDir)

		Return

	EndIf

	For $i = 1 To $WorkArray[0]

		$option = '"' & $InDir & "\" & $WorkArray[$i] & '"'

		$Path = _PathSplit($InDir & "\" & $WorkArray[$i], $sDrive, $sDir, $sFilename, $sExtension)

		$option = $option & ' --edit info --set title="' & $Path[3] & '"'

		ShellExecuteWait($ini_mkvpropedit_path, $option, "", "", @SW_HIde)

	Next

	_WriteLog("Tag Names - Finished Working On: " & $InDir)

	Return

EndFunc

#EndRegion ;Generic Functions

#Region ;Special Functions

;Function to Append Stacked Videos
Func _Append()

	_WriteLog("Append - Started")

	_SetData($Select_Label_21, $lng_video & "-" & $lng_conversion & ":  " & $lng_append)

	Dim $WorkArray[1]
	Dim $WorkDir[1]
	Dim $PathSplit[1]
	Local $InDir = GUICtrlRead($input_23_01)
	Local $OutDir = GUICtrlRead($input_23_02)
	Local $p = 0,	$sDrive = "", $sDir = "", $sFilename = "", $sExtension = "", $sOutput, $result, $i, $iPID, $break
	Local $Array, $option = "", $a, $step1, $j, $value, $aString, $StringLine, $k, $OutFile

	IniWrite(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_append_inputfolder", $InDir)
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_append_outputfolder", $OutDir)

	$ini_append_outputfolder = IniRead(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_append_outputfolder", @MyDocumentsDir)
	$ini_append_inputfolder = IniRead(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_append_inputfolder", @MyDocumentsDir)

	_ClearGUI($Array_GUI_Elements_23)

	_ShowGUI($Array_FUNC_23)

	_ShowGUI($Array_FUNC_99)

	_SetLabel($label_f23_02, $lng_append & " -- " & $lng_workingon & " " & $InDir)

	_SetData($progressbar_f23_01, 0)

	_SetData($progressbar_f23_02, 0)

	$WorkArray = _FileListToArrayRec($InDir, $extstring, 1, 1, 1)

	$WorkDir = _FileListToArrayRec($InDir, "*", 2, 0, 1)

	If Not IsArray($WorkArray) Then

		MsgBox(0, "", $lng_nofiles)
		_LastModule()
		Return

	EndIf

	If Not IsArray($WorkDir) Then

		MsgBox(0, "", $lng_nofolders)
		_LastModule()
		Return

	EndIf

	_FileListToDB($WorkArray, $InDir)

	For $i = 1 To $WorkDir[0]

		If Not @error Then

			_WriteLog("Append - Started Working On: " & $InDir & "\" & $WorkDir[$i])

			_SetLabel($label_f23_03, $lng_files & " "  & $i & " -- " & $WorkDir[0] & ": " & $WorkDir[$i])

			_SetLabel($label02, $lng_workingon & "   " & $InDir & "\" & $WorkDir[$i])

			$break = 0

			$Array = _FileListToArrayRec($InDir & "\" & $WorkDir[$i], $extstring, 1, 1, 1)

			$option = ""

			If IsArray($Array) Then

				If $Array[0] > 0 Then

				DirCreate($OutDir & "\" & $WorkDir[$i])

				$OutFile = StringReplace($OutDir & "\" & $WorkDir[$i] & "\" & $WorkDir[$i], "'", "\'")

				For $j = 1 To $Array[0]

					$option = "-o '" & $OutFile & ".mkv" & "' '" & StringReplace($InDir & "\" & $WorkDir[$i] & "\" & $Array[1], "'", "\'") & "'"

					If $Array[0] > 1 Then
						For $k = 2 To $Array[0]
							$option = $option & " + '" & StringReplace($InDir & "\" & $WorkDir[$i] & "\" & $Array[$k], "'", "\'") & "' "
						Next
					EndIf

				Next

				$option = $option & '"'

				$iPID = Run(@ComSpec & ' /c ToolBox.exe --filename:mkvmerge.exe --arguments:" ' & $option, @ScriptDir, @SW_HIde, $STdeRR_CHILD + $STDOUT_CHILD) ;  --debug

				$step1 = 100 / $WorkDir[0]

				While ProcessExists($iPID)

					$a = GUIGetCursorInfo()

					If IsArray($a) Then

						If $a[2] = 1 And $a[4] = $button_f23_01 Then

							$value = MsgBox(19, $lng_cancel, $lng_cancel1 & @CRLF & $lng_areyousure & "." & @CRLF & @CRLF & $lng_cancel2 & @CRLF & $lng_cancel3 & @CRLF & $lng_cancel4)

							If $value = 2 Then ;Instantly Abort

								_WriteLog("Append - Triggered Instant Abort")

								_CloseProcess($iPID)

								$break = 1

							EndIf

							If $value = 6 Then ;Finish File and Abort

								_WriteLog("Append - Triggered Abort After Recent File")

								$break = 1

							EndIf

						EndIf

					EndIf

					$sOutput =  _OEMToAnsi(StdoutRead($iPID))

					$result = StringInStr($sOutput, "#")

					If $result = 1 Then

						$StringLine = StringSplit($sOutput, @CRLF)
						$aString = StringSplit($StringLine[1], "|")

						$p = ($step1 * ($i - 1)) + (Round($aString[4]) / $WorkDir[0])

						If NOT $aString[4] = "" Then

							_SetData($progressbar_f23_01, $p)

							_SetData($progressbar_f23_02, $aString[4])

							_SetLabel($label02, $lng_workingon  & "   " & $WorkDir[$i] & ".mkv --- " & $lng_progress & ": " & $aString[4] & "% --- " & $lng_elapsed & ": " & $aString[5] & " --- " & $lng_total & ": " & $aString[6])

						EndIf

					EndIf

					If @error Then

						_WriteLog("Append - Error Message = " & StderrRead($iPID))

						ExitLoop

					EndIf

					Sleep(100)

				WEnd

			EndIf

			Else

				_WriteLog("Error - No Files in Folder: " & $InDir & "\" & $WorkDir[$i])

			EndIf

			If Not $break = -1 Then _WriteLog("Append - Finished Working On: " & $InDir & "\" & $WorkDir[$i])

		Else

			_WriteLog("Error - Could Not Process Folder: " & $InDir & "\" & $WorkDir[$i])

			Return -1

		EndIf

		If $break = 1 Then ExitLoop

		If $ini_KeepFileDate = "1" Then _SetTimeSegment($InDir & "\" & $WorkArray[$i], $OutDir & "\" & $WorkArray[$i])

	Next

	FileDelete($tempdir & "\mylist.txt")

	_TagNames($OutDir)

	_WriteLog("Append - Finished")

	If GUICtrlRead($radio_f99_01) = "1" Then

		MsgBox(0, "", $lng_sucess, 3)

	EndIf

	If GUICtrlRead($radio_f99_02) = "1" Then

		MsgBox(0, "", $lng_sucess, 3)

	EndIf

	If GUICtrlRead($radio_f99_03) = "1" Then

		_Countdown()

	EndIf

	If GUICtrlRead($radio_f99_04) = "1" Then

		_Exit(2)

	EndIf

	If GUICtrlRead($radio_f99_05) = "1" Then

		_Exit(3)

	EndIf

	If GUICtrlRead($radio_f99_06) = "1" Then

		_Exit(4)

	EndIf

	_ClearGUI($Array_FUNC_23)

	_ClearGUI($Array_FUNC_99)

	_SetLabel($label02,$lng_waiting)

	_SetData($Select_Label_21, "")

	_LastModule()

	Return

EndFunc

;Function to extract tracls from MKV files
Func _Extract()

	_WriteLog("Extract - Started")

	Dim $WorkArray[1]
	Dim $PathSplit[1]
	Dim $info[1]
	Local $InDir = GUICtrlRead($input_43_01)
	Local $p = 0,	$sDrive = "", $sDir = "", $sFilename = "", $sExtension = "", $sOutput, $option, $result, $i, $fl, $iPID, $break
	Local $track, $chap, $Input, $J = 2, $Tracktype, $tracknumber, $type, $inp, $Ext, $exten, $extension, $z, $option1

	IniWrite(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_extract_inputfolder", $InDir)
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_extract_video", GUICtrlRead($check_43_01))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_extract_audio", GUICtrlRead($check_43_02))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_extract_subs", GUICtrlRead($check_43_03))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_extract_chapter", GUICtrlRead($check_43_04))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_extract_attachments", GUICtrlRead($check_43_05))

	$ini_extract_inputfolder = IniRead(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_extract_inputfolder", @MyDocumentsDir)
	$ini_extract_video = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_extract_video", "1")
	$ini_extract_audio = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_extract_audio", "1")
	$ini_extract_subs = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_extract_subs", "1")
	$ini_extract_chapter = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_extract_chapter", "1")
	$ini_extract_attachments = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_extract_attachments", "1")

	_ClearGUI($Array_GUI_Elements_43)

	_ShowGUI($Array_FUNC_43)

	_ShowGUI($Array_FUNC_99)

	$WorkArray = _FileListToArrayRec($InDir, "*mkv;*.mk3d", 1, 1, 1)

	If Not IsArray($WorkArray) Then

		MsgBox(0, "", $lng_nofiles)
		_LastModule()
		Return

	EndIf

	_SetData($progressbar_f43_01,  0)

	_SetData($progressbar_f43_02,  0)

	_FileListToDB($WorkArray, $InDir)

	Local $step1 = 100 / $WorkArray[0]

	_SetLabel($label_f43_02, $lng_extract & " -- " & $lng_workingon & " " & $InDir)

	 For $i = 1 To $WorkArray[0]

		_SetData($progressbar_f43_01, $i * $step1)

		_WriteLog("Extract - Started Working On: " & $InDir & "\" & $WorkArray[$i])

		$PathSplit = _PathSplit($InDir & "\" & $WorkArray[$i], $sDrive, $sDir, $sFilename, $sExtension)

		If $PathSplit[1] & $PathSplit[2] = $InDir & "\" Then

			DirCreate($InDir & "\" & $PathSplit[3])
			FileMove($InDir & "\" & $WorkArray[$i], $InDir & "\" & $PathSplit[3] & "\"  & $WorkArray[$i])

			$file = StringReplace($InDir & "\" & $PathSplit[3] & "\" & $WorkArray[$i], "'", "\'")
			$Input = $InDir & "\" & $PathSplit[3] & "\" & $WorkArray[$i]

		Else

			$file = StringReplace($InDir & "\" & $WorkArray[$i], "'", "\'")
			$Input = $InDir & "\" & $WorkArray[$i]

		EndIf

		_SetLabel($Label02, $lng_workingon & "   " & $InDir & "\" & $WorkArray[$i])

		$break = 0

		$option = ' -i "' & $Input & '" --redirect-output "' & $tempdir & '\info.txt"'

		ShellExecuteWait($ini_mkvmerge_path, $option, '', '', @SW_HIde)

		$option = ""

		Dim $info[1]

		_FileReadToArray($tempdir & "\info.txt", $info)

		$track = _ArraySearch($info, "Track ID", 0, 0, 0, 1, 0)

		$chap = _ArraySearch($info, "Chapters", 0, 0, 0, 1)

		Local $option1 = " tracks '" & $Input & "' "

		$inp = _PathSplit($Input, $sDrive, $sDir, $sFilename, $sExtension)

		FileChangeDir($inp[1] & $inp[2])

		If $chap > 0 And $ini_extract_chapter = 1 Then

			$option = ' chapters "' & $Input & '"  --redirect-output chapters.xml'

			_SetLabel($label_f43_03, $lng_files & " "  & $i & " -- " & $lng_extract & ": " & $lng_set_chapter)

			ShellExecuteWait($ini_mkvextract_path, $option, '', '', @SW_HIde)

		EndIf

		If $ini_extract_attachments = 1 Then

			$option = ' attachments "' & $Input & '" 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15'

			_SetLabel($label_f43_03, $lng_files & " "  & $i & " -- " & $lng_extract & ": " & $lng_set_attach)

			ShellExecuteWait($ini_mkvextract_path, $option, '', '', @SW_HIde)

		EndIf

		$J = 2

		Do
			$Tracktype = StringSplit($info[$J], ":")

			$tracknumber = Int(StringTrimLeft($Tracktype[1], 9))

			$type = StringSplit($Tracktype[2], "(")

			If $type[0] > 1 Then
				$typ = StringStripWS($type[1], 3)
				$Ext = StringTrimRight($type[2], 1)
				$exten = StringSplit($Ext, "/")
				If StringInStr($Ext, "unknown") Then
					$extension = "unknown"
				ElseIf IsArray($exten) Then
					$z = $exten[0]
					$extension = StringReplace($exten[$z], ".", "")
				Else
					$extension = StringReplace($Ext, ".", "")
				EndIf

				If $ini_extract_video = "1" And $typ = "video" Then

					$option = $option1 & $tracknumber & ":'" & StringTrimRight($file, 4) & "_Video-" & $tracknumber & "." & $extension & "' "

					_SetLabel($label_f43_03, $lng_files & " "  & $i & " -- " & $lng_extract & ": " & $lng_set_video & " #" & $tracknumber)

					$iPID = Run(@ComSpec & ' /c ToolBox.exe --filename:mkvextract.exe --arguments:"' & $option & '"', @ScriptDir, @SW_HIde, $STdeRR_CHILD + $STDOUT_CHILD)

					While ProcessExists($iPID)

						Local $a = GUIGetCursorInfo()

						If IsArray($a) Then

							If $a[2] = 1 And $a[4] = $button_f43_01 Then

								$value = MsgBox(19, $lng_cancel, $lng_cancel1 & @CRLF & $lng_areyousure & "." & @CRLF & @CRLF & $lng_cancel2 & @CRLF & $lng_cancel3 & @CRLF & $lng_cancel4)
								If $value = 2 Then ;Instantly Abort

									_WriteLog("Extract - Triggered Abort Instantlly")

									_CloseProcess($iPID)

									$break = 1

								EndIf
								If $value = 6 Then ;Finish File and Abort

									_WriteLog("Extract - Triggered Abort After Recent File")

									$break = 1

								EndIf

							EndIf

						EndIf

						$sOutput =  _OEMToAnsi(StdoutRead($iPID))

						$result = StringInStr($sOutput, "#")

						If $result = 1 Then

							$StringLine = StringSplit($sOutput, @CRLF)
							$aString = StringSplit($StringLine[1], "|")

							_SetData($progressbar_f43_02,  $aString[4])

							_SetLabel($Label02, $lng_workingon  & "   " & $WorkArray[$i] & " - " & $lng_progress & ": " & $aString[4] & "% - " & $lng_elapsed & ": " & $aString[5] & " " & $lng_total & ": " & $aString[6])

						EndIf

						If @error Then ExitLoop

						Sleep(200)

					WEnd

				EndIf
				If $ini_extract_audio = "1" And $typ = "audio" Then
					$option = $option1 & $tracknumber & ":'" & StringTrimRight($file, 4) & "_Audio-" & $tracknumber & "." & $extension & "' "

					_SetLabel($label_f43_03, $lng_files & " "  & $i & " -- " & $lng_extract & ": " & $lng_set_audio & " #" & $tracknumber)

					$iPID = Run(@ComSpec & ' /c ToolBox.exe --filename:mkvextract.exe --arguments:"' & $option & '"', @ScriptDir, @SW_HIde, $STdeRR_CHILD + $STDOUT_CHILD)

					While ProcessExists($iPID)

						Local $a = GUIGetCursorInfo()

						If IsArray($a) Then

							If $a[2] = 1 And $a[4] = $button_f43_01 Then

								$value = MsgBox(19, $lng_cancel, $lng_cancel1 & @CRLF & $lng_areyousure & "." & @CRLF & @CRLF & $lng_cancel2 & @CRLF & $lng_cancel3 & @CRLF & $lng_cancel4)
								If $value = 2 Then ;Instantly Abort

									_WriteLog("Extract - Triggered Abort Instantlly")

									_CloseProcess($iPID)

									$break = 1

								EndIf
								If $value = 6 Then ;Finish File and Abort

									_WriteLog("Extract - Triggered Abort After Recent File")

									$break = 1

								EndIf

							EndIf

						EndIf

						$sOutput =  _OEMToAnsi(StdoutRead($iPID))

						$result = StringInStr($sOutput, "#")

						If $result = 1 Then

							$StringLine = StringSplit($sOutput, @CRLF)
							$aString = StringSplit($StringLine[1], "|")

							_SetData($progressbar_f43_02,  $aString[4])

							_SetLabel($label02, $lng_workingon  & "   " & $WorkArray[$i] & " - " & $lng_progress & ": " & $aString[4] & "% - " & $lng_elapsed & ": " & $aString[5] & " " & $lng_total & ": " & $aString[6])

						EndIf

						If @error Then ExitLoop

						Sleep(200)

					WEnd
				EndIf

				If $ini_extract_subs = "1" And $typ = "subtitles" Then
					$option = $option1 & $tracknumber & ":'" & StringTrimRight($file, 4) & "_Subtitle-" & $tracknumber & "." & $extension & "' "

					_SetLabel($label_f43_03, $lng_files & " "  & $i & " -- " & $lng_extract & ": " & $lng_set_subs & " #" & $tracknumber)

					$iPID = Run(@ComSpec & ' /c ToolBox.exe --filename:mkvextract.exe --arguments:"' & $option & '"', @ScriptDir, @SW_HIde, $STdeRR_CHILD + $STDOUT_CHILD)

					While ProcessExists($iPID)

						Local $a = GUIGetCursorInfo()

						If IsArray($a) Then

							If $a[2] = 1 And $a[4] = $button_f43_01 Then

								$value = MsgBox(19, $lng_cancel, $lng_cancel1 & @CRLF & $lng_areyousure & "." & @CRLF & @CRLF & $lng_cancel2 & @CRLF & $lng_cancel3 & @CRLF & $lng_cancel4)
								If $value = 2 Then ;Instantly Abort

									_WriteLog("Extract - Triggered Abort Instantlly")

									_CloseProcess($iPID)

									$break = 1

								EndIf
								If $value = 6 Then ;Finish File and Abort

									_WriteLog("Extract - Triggered Abort After Recent File")

									$break = 1

								EndIf

							EndIf

						EndIf

						$sOutput =  _OEMToAnsi(StdoutRead($iPID))

						$result = StringInStr($sOutput, "#")

						If $result = 1 Then

							$StringLine = StringSplit($sOutput, @CRLF)
							$aString = StringSplit($StringLine[1], "|")

							_SetData($progressbar_f43_02,  $aString[4])

							_SetLabel($label02, $lng_workingon  & "   " & $WorkArray[$i] & " - " & $lng_progress & ": " & $aString[4] & "% - " & $lng_elapsed & ": " & $aString[5] & " " & $lng_total & ": " & $aString[6])

						EndIf


						If @error Then ExitLoop

						Sleep(200)

					WEnd

				EndIf

			EndIf

			$J += 1

		Until $J = $track + 1

		FileDelete('"' & $tempdir & '\info.txt"')

		_WriteLog("Extract - Finished Working On: " & $InDir & "\" & $WorkArray[$i])

		If $break = 1 Then ExitLoop

	Next

	_ClearGUI($Array_FUNC_43)

	_ClearGUI($Array_FUNC_99)

	_SetLabel($label02,$lng_waiting)

	_WriteLog("Extract - Finished")

	If GUICtrlRead($radio_f99_01) = "1" Then

		MsgBox(0, "", $lng_sucess, 3)

	EndIf

	If GUICtrlRead($radio_f99_02) = "1" Then

		MsgBox(0, "", $lng_sucess, 3)

	EndIf

	If GUICtrlRead($radio_f99_03) = "1" Then

		_Countdown()

	EndIf

	If GUICtrlRead($radio_f99_04) = "1" Then

		_Shutdown()

	EndIf

	If GUICtrlRead($radio_f99_05) = "1" Then

		_Standby()

	EndIf

	If GUICtrlRead($radio_f99_06) = "1" Then

		_Hibernate()

	EndIf

	_LastModule()

	Return
EndFunc

;Function to fix MKV files
Func _Fix()

	_WriteLog("Fix MKV - Started")

	Dim $WorkArray[1]
	Dim $PathSplit[1]
	Local $InDir = GUICtrlRead($input_41_01)
	Local $OutDir = GUICtrlRead($input_41_02)
	Local $p = 0,	$sDrive = "", $sDir = "", $sFilename = "", $sExtension = "", $sOutput, $option, $result, $i, $fl, $iPID, $break

	IniWrite(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_fix_inputfolder", $InDir)
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_fix_outputfolder", $OutDir)

	$ini_fix_inputfolder = IniRead(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_fix_inputfolder", @MyDocumentsDir)
	$ini_fix_outputfolder = IniRead(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_fix_outputfolder", @MyDocumentsDir)

	_ClearGUI($Array_GUI_Elements_41)

	_ShowGUI($Array_FUNC_41)

	_ShowGUI($Array_FUNC_99)

	_SetData($progressbar_f41_01, 0)

	_SetData($progressbar_f41_02, 0)

	$WorkArray = _FileListToArrayRec($InDir, "*mkv;*.mk3d", 1, 1, 1)

	If Not IsArray($WorkArray) Then

		MsgBox(0, "", $lng_nofiles)
		_LastModule()
		Return

	EndIf

	_FileListToDB($WorkArray, $InDir)

	Local $step1 = 100 / $WorkArray[0]

	_SetLabel($label_f41_02, $lng_fix & " -- " & $lng_workingon & " " & $InDir)

	 For $i = 1 To $WorkArray[0]

		_WriteLog("Fix MKV - Started Working On: " & $InDir & "\" & $WorkArray[$i])

		_SetData($progressbar_f41_01, $p)

		_SetLabel($label_f41_03, $lng_files & " "  & $i & " -- " & $WorkArray[0] & ": " & $WorkArray[$i])

		_SetLabel($Label02, $lng_workingon & "   " & $InDir & "\" & $WorkArray[$i])

		$break = 0

		$option = ' -i ' & "'" & StringReplace($InDir & "\" & $WorkArray[$i], "'", "\'") & "'" & ' -o ' & "'" & StringReplace($OutDir & "\" & $WorkArray[$i], "'", "\'") & "'"

		$PathSplit = _PathSplit($OutDir & "\" & $WorkArray[$i], $sDrive, $sDir, $sFilename, $sExtension)

		DirCreate($PathSplit[1] & $PathSplit[2])

		$iPID = Run(@ComSpec & ' /c ToolBox.exe --filename:Meteorite.exe --arguments:"' & $option & '"', @ScriptDir, @SW_HIde, $STdeRR_CHILD + $STDOUT_CHILD)

		While ProcessExists($iPID)

			_GetTime()

			Local $a = GUIGetCursorInfo()

			If IsArray($a) Then

				If $a[2] = 1 And $a[4] = $button_f41_01 Then

					$value = MsgBox(19, $lng_cancel, $lng_cancel1 & @CRLF & $lng_areyousure & "." & @CRLF & @CRLF & $lng_cancel2 & @CRLF & $lng_cancel3 & @CRLF & $lng_cancel4)
					If $value = 2 Then ;Instantly Abort

						_WriteLog("Fix MKV - Triggered Abort Instantlly")

						_CloseProcess($iPID)

						$break = 1

					EndIf
					If $value = 6 Then ;Finish File and Abort

						_WriteLog("Fix MKV - Triggered Abort After Recent File")

						$break = 1

					EndIf

				EndIf

			EndIf

			$sOutput =  _OEMToAnsi(StdoutRead($iPID))

			$result = StringInStr($sOutput, "#")

			If $result = 1 Then

				$StringLine = StringSplit($sOutput, @CRLF)
				$aString = StringSplit($StringLine[1], "|")

				$p = ($step1 * ($i - 1)) + ($aString[4] / $WorkArray[0])

				_SetData($progressbar_f41_01, $p)

				_SetData($progressbar_f41_02,  $aString[4])

				_SetLabel($Label02, $lng_workingon  & "   " & $WorkArray[$i] & " - " & $lng_progress & ": " & $aString[4] & "% - " & $lng_elapsed & ": " & $aString[5] & " " & $lng_total & ": " & $aString[6])

			EndIf

			If @error Then ExitLoop

			Sleep(200)

		WEnd

		_WriteLog("Fix MKV - Finished Working On: " & $InDir & "\" & $WorkArray[$i])

		If $break = 1 Then ExitLoop

		If $ini_KeepFileDate = "1" Then _SetTimeSegment($InDir & "\" & $WorkArray[$i], $OutDir & "\" & $WorkArray[$i])

	Next

	_TagNames($OutDir)

	_ClearGUI($Array_FUNC_41)

	_ClearGUI($Array_FUNC_99)

	_SetLabel($label02,$lng_waiting)

	_WriteLog("Fix MKV - Finished")

	If GUICtrlRead($radio_f99_01) = "1" Then

		MsgBox(0, "", $lng_sucess, 3)

	EndIf

	If GUICtrlRead($radio_f99_02) = "1" Then

		MsgBox(0, "", $lng_sucess, 3)

	EndIf

	If GUICtrlRead($radio_f99_03) = "1" Then

		_Countdown()

	EndIf

	If GUICtrlRead($radio_f99_04) = "1" Then

		_Shutdown()

	EndIf

	If GUICtrlRead($radio_f99_05) = "1" Then

		_Standby()

	EndIf

	If GUICtrlRead($radio_f99_06) = "1" Then

		_Hibernate()

	EndIf


	_LastModule()

	Return

EndFunc

;Function to process graphics files
Func _Graphics()

	_WriteLog("Graphics - Started")

	Dim $WorkArray[0]
	Dim $DelArray[0]
	Dim $iPathSplit[0]
	Dim $oPathSplit[0]
	Local $InDir = GUICtrlRead($input_26_01)
	Local $p = 0, $sDrive = "", $sDir = "", $sFilename = "", $sExtension = "", $i, $break, $InFile, $OutFile, $value, $find

	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_gfx4k", GUICtrlRead($check_26_21))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_gfx1080", GUICtrlRead($check_26_22))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_gfx720", GUICtrlRead($check_26_23))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_gfx600", GUICtrlRead($check_26_24))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_gfxfree", GUICtrlRead($check_26_25))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_gfxnormalize", GUICtrlRead($check_26_31))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_gfxunsharp", GUICtrlRead($check_26_32))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_gfx_freesize", GUICtrlRead($input_26_25))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_gfx_format_4k", GUICtrlRead($combo_26_21))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_gfx_format_1080", GUICtrlRead($combo_26_22))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_gfx_format_720", GUICtrlRead($combo_26_23))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_gfx_format_600", GUICtrlRead($combo_26_24))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_gfx_format_free", GUICtrlRead($combo_26_25))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_gfx_value_unsharp", GUICtrlRead($combo_26_32))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_gfx_optjpg", GUICtrlRead($check_26_12))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_gfx_optpng", GUICtrlRead($check_26_11))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_graphics_inputfolder", GUICtrlRead($input_26_01))

	_SetLabel($Label02, "Graphics - Working")

	$WorkArray = _FileListToArrayRec($InDir, $gextstring, 1, 1, 1)

	If Not IsArray($WorkArray) Then

		MsgBox(0, "", $lng_nofiles)
		_LastModule()
		Return

	EndIf

	_FileListToDB($WorkArray, $InDir)

	For $i = 1 To $WorkArray[0]

		$iPathSplit = _PathSplit($InDir & "\" & $WorkArray[$i], $sDrive, $sDir, $sFilename, $sExtension)

		$InFile = StringReplace($InDir & "\" & $WorkArray[$i], "'", "\'")

		_SetLabel($Label02, "Graphics - " & $lng_workingon & ": " & $InFile)

		_Rework_Graphics_File($InFile)

		If $ini_gfx4k = "1" Then

			If GUICtrlRead($check_26_11) = "1" Or GUICtrlRead($check_26_12) = "1" Then _Optimize_Graphics_File($ipathsplit[1] & $ipathsplit[2] &  "2160\" & $ipathsplit[3] & $ipathsplit[4])

		EndIf

		If $ini_gfx1080 = "1" Then

			If GUICtrlRead($check_26_11) = "1" Or GUICtrlRead($check_26_12) = "1" Then _Optimize_Graphics_File($ipathsplit[1] & $ipathsplit[2] &  "1080\" & $ipathsplit[3] & $ipathsplit[4])

		EndIf

		If $ini_gfx720 = "1" Then

			If GUICtrlRead($check_26_11) = "1" Or GUICtrlRead($check_26_12) = "1" Then _Optimize_Graphics_File($ipathsplit[1] & $ipathsplit[2] &  "720\" & $ipathsplit[3] & $ipathsplit[4])

		EndIf

		If $ini_gfx600 = "1" Then

			If GUICtrlRead($check_26_11) = "1" Or GUICtrlRead($check_26_12) = "1" Then _Optimize_Graphics_File($ipathsplit[1] & $ipathsplit[2] &  "600\" & $ipathsplit[3] & $ipathsplit[4])

		EndIf

		If $ini_gfxfree = "1" Then

			$freefolder = StringSplit($ini_gfx_freesize, "x")

			If _ElementExists($freefolder, 2) Then

				If GUICtrlRead($check_26_11) = "1" Or GUICtrlRead($check_26_12) = "1" Then _Optimize_Graphics_File($ipathsplit[1] & $ipathsplit[2] & $freefolder[2] & "\" & $ipathsplit[3] & $ipathsplit[4])

			EndIf

		EndIf

		If $ini_gfx_moveorg = "1" Then

			$find = _ArraySearch($ArrayGraphics, StringReplace($ipathsplit[4],".",""))

			If $find > -1 Then

				FileMove($InFile, $ipathsplit[1] & $ipathsplit[2] &  "Original\" & $ipathsplit[3] & $ipathsplit[4])

				If $ini_gfx_optorg = "1" Then

					If GUICtrlRead($check_26_11) = "1" Or GUICtrlRead($check_26_12) = "1" Then _Optimize_Graphics_File($ipathsplit[1] & $ipathsplit[2] &  "Original\" & $ipathsplit[3] & $ipathsplit[4])

				EndIf

			EndIf

			$find = ""

			$find = _ArraySearch($ArrayRaw, StringReplace($ipathsplit[4],".",""))

			If $find > -1 Then

				FileMove($InFile, $ipathsplit[1] & $ipathsplit[2] &  "Raw\" & $ipathsplit[3] & $ipathsplit[4])

			EndIf

		Else

			If $ini_gfx_optorg = "1" Then

				If GUICtrlRead($check_26_11) = "1" Or GUICtrlRead($check_26_12) = "1" Then _Optimize_Graphics_File($ipathsplit[1] & $ipathsplit[2] & $ipathsplit[3] & $ipathsplit[4])

			EndIf

		EndIf

	Next

	$DelArray = _FileListToArrayRec($InDir, "*.*_original", 1, 1)

	If IsArray($DelArray) Then

		For $i = 1 to $DelArray[0]

			FileDelete($indir & "\" & $DelArray[$i])

		Next

	EndIf

	_SetLabel($Label02, $lng_waiting)

	Local $value = MsgBox(292, $lng_sucess, $lng_autoend5 & @CRLF & @CRLF & $lng_autoend2, 60)

	If $value = -1 Or $value = 6 Then

		_Exit()

	EndIf

	Return

EndFunc

;Function to process Audio Metadata
Func _Metadata_Audio()

	_WriteLog("Metadata Audio - Started")

	Local $WorkArray[1] = [0], $break
	Dim $PathSplit[1]
	Local $InDir = GUICtrlRead($input_34_01)

	_SaveJSON()

	_ClearGUI($Array_GUI_Elements_34)

	_ShowGUI($Array_FUNC_34)

	_ShowGUI($Array_FUNC_99)

	_SetData($progressbar_f34_01, 0)

	$WorkArray = _FileListToArrayRec($InDir, $aextstring, 1, 1, 1)

	If Not IsArray($WorkArray) Then

		MsgBox(0, "", $lng_nofiles)
		_LastModule()
		Return

	EndIf

	_SetLabel($label_f34_02, $lng_audio & "- " & $lng_metadata & " -- " & $lng_workingon & " " & $InDir)

	_SetLabel($label_f34_03, "")

	_SetData($progressbar_f34_01, 20)

	$break = _GrabArtist($InDir, $progressbar_f34_01, $label_f34_03)

	_ClearGUI($Array_FUNC_34)

	_ClearGUI($Array_FUNC_99)

	_SetLabel($label02,$lng_waiting)

	_WriteLog("Metadata Audio - Finished")

	If GUICtrlRead($radio_f99_01) = "1" Then

		MsgBox(0, "", $lng_sucess, 3)

	EndIf

	If GUICtrlRead($radio_f99_02) = "1" Then

		IniWrite(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_audio_correction_inputfolder", $InDir)

		_SetData($input_64_01, $InDir)

		_GUI_Show_Corection()

		_GUI_Show_Audio_Correction()

		_Metadata_Correction_Audio()

	EndIf

	If GUICtrlRead($radio_f99_03) = "1" Then

		_Countdown()

	EndIf

	If GUICtrlRead($radio_f99_04) = "1" Then

		_Exit(2)

	EndIf

	If GUICtrlRead($radio_f99_05) = "1" Then

		_Exit(3)

	EndIf

	If GUICtrlRead($radio_f99_06) = "1" Then

		_Exit(4)

	EndIf

	_LastModule()

	Return

EndFunc

;Function to process Movies Metadata
Func _Metadata_Movies()

	_WriteLog("Metadata Movies - Started")

	Local $WorkArray[1] = [0]
	Dim $PathSplit[1]

	Local $InDir = GUICtrlRead($input_32_01)

	_SaveJSON()

	;MetaData Movies Config
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_meta_movies_refresh_nfo", GUICtrlRead($check_92_16))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_meta_movies_refresh_gfx", GUICtrlRead($check_92_15))

	$ini_meta_movies_refresh_gfx = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_meta_movies_refresh_gfx", "1")
	$ini_meta_movies_refresh_nfo = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_meta_movies_refresh_nfo", "1")

	_ClearGUI($Array_GUI_Elements_32)

	_ShowGUI($Array_FUNC_32)

	_ShowGUI($Array_FUNC_99)

	_WriteLog("Metadata Movies - Start FileListTo Array")

	_SetData($progressbar_f32_01, 0)

	$WorkArray = _FileListToArrayRec($InDir, $extstring2, 1, 1, 1)

	_WriteLog("Metadata Movies - Finish FileListTo Array")

	If Not IsArray($WorkArray) Then

		MsgBox(0, "", $lng_nofiles)
		_LastModule()
		Return

	EndIf

	_SetLabel($label_f32_02, $lng_movies & "- " & $lng_metadata & " -- " & $lng_workingon & " " & $InDir)

	_SetLabel($label_f32_03, "")

	Local $break = _nfo4HTPC($InDir, $progressbar_f32_01, $label_f32_03, $button_f32_01, "movies")

	_ClearGUI($Array_FUNC_32)

	_ClearGUI($Array_FUNC_99)

	_SetLabel($label02,$lng_waiting)

	_WriteLog("Metadata Movies - Finished")

	If GUICtrlRead($radio_f99_01) = "1" Then

		MsgBox(0, "", $lng_sucess, 3)

	EndIf

	If GUICtrlRead($radio_f99_02) = "1" Then

		IniWrite(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_movies_correction_inputfolder", $InDir)

		_SetData($input_62_01, $InDir)

		_GUI_Show_Corection()

		_GUI_Show_Movies_Correction()

		_Metadata_Correction_Movies()

	EndIf

	If GUICtrlRead($radio_f99_03) = "1" Then

		_Countdown()

	EndIf

	If GUICtrlRead($radio_f99_04) = "1" Then

		_Exit(2)

	EndIf

	If GUICtrlRead($radio_f99_05) = "1" Then

		_Exit(3)

	EndIf

	If GUICtrlRead($radio_f99_06) = "1" Then

		_Exit(4)

	EndIf

	_LastModule()

	Return

EndFunc

;Function to process Series Metadata
Func _Metadata_Series()

	_WriteLog("Metadata Series - Started")

	Local $WorkArray[1] = [0]
	Dim $PathSplit[1]
	Local $InDir = GUICtrlRead($input_31_01)

	_SaveJSON()

	;MetaData Series Config
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_meta_series_refresh_nfo", GUICtrlRead($check_92_06))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_meta_series_refresh_gfx", GUICtrlRead($check_92_05))

	$ini_meta_series_refresh_gfx = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_meta_series_refresh_gfx", "1")
	$ini_meta_series_refresh_nfo = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_meta_series_refresh_nfo", "1")

	_ClearGUI($Array_GUI_Elements_31)

	_ShowGUI($Array_FUNC_31)

	_ShowGUI($Array_FUNC_99)

	_SetData($progressbar_f31_01, 0)

	$WorkArray = _FileListToArrayRec($InDir, $extstring2, 1, 1, 1)

	If Not IsArray($WorkArray) Then

		MsgBox(0, "", $lng_nofiles)
		_LastModule()
		Return

	EndIf

	_SetLabel($label_f31_02, $lng_series & "- " & $lng_metadata & " -- " & $lng_workingon & " " & $InDir)

	_SetLabel($label_f31_03, "")

	Local $break = _nfo4HTPC($InDir, $progressbar_f31_01, $label_f31_03, $button_f31_01, "series")

	If Not $break = 1 Then

		If $ini_gen_folder = 1 Then	_make_season_folder($InDir)

	EndIf

	_ClearGUI($Array_FUNC_31)

	_ClearGUI($Array_FUNC_99)

	_SetLabel($label02,$lng_waiting)

	_WriteLog("Metadata Series - Finished")

	If GUICtrlRead($radio_f99_01) = "1" Then

		MsgBox(0, "", $lng_sucess, 3)

	EndIf

	If GUICtrlRead($radio_f99_02) = "1" Then

		IniWrite(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_series_correction_inputfolder", $InDir)

		_SetData($input_61_01, $InDir)

		_GUI_Show_Corection()

		_GUI_Show_Series_Correction()

		_Metadata_Correction_Series()

	EndIf

	If GUICtrlRead($radio_f99_03) = "1" Then

		_Countdown()

	EndIf

	If GUICtrlRead($radio_f99_04) = "1" Then

		_Exit(2)

	EndIf

	If GUICtrlRead($radio_f99_05) = "1" Then

		_Exit(3)

	EndIf

	If GUICtrlRead($radio_f99_06) = "1" Then

		_Exit(4)

	EndIf


	_LastModule()

	Return

EndFunc

;Function to process Videos Metadata
Func _Metadata_Videos($InFile="", $continue="true")

	_WriteLog("Metadata Videos - Started")

	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_fanart_design", GUICtrlRead($combo_95_01))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_fanart_font", GUICtrlRead($combo_95_02))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_fanart_covertemplate", GUICtrlRead($combo_95_03))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_fanart_backdroptemplate", GUICtrlRead($combo_95_04))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_fanart_bordertemplate", GUICtrlRead($combo_95_05))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_fanart_bordercolor", GUICtrlRead($input_95_07))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_fanart_genrefolder", GUICtrlRead($check_95_04))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_fanart_mediainfo", GUICtrlRead($check_95_05))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_fanart_plot", GUICtrlRead($edit_95_01))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_fanart_genre", GUICtrlRead($input_95_08))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_fanart_nocover", GUICtrlRead($check_95_01))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_fanart_nobackdrop", GUICtrlRead($check_95_02))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_fanart_nonfo", GUICtrlRead($check_95_03))

	$ini_fanart_backgroundtemplate = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_fanart_backdroptemplate", "---------")
	$ini_fanart_bordercolor = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_fanart_bordercolor", "IndianRed4")
	$ini_fanart_bordertemplate = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_fanart_bordertemplate", "---------")
	$ini_fanart_covertemplate = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_fanart_covertemplate", "---------")
	$ini_fanart_design = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_fanart_design", "1-6")
	$ini_fanart_font = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_fanart_font", "Comic-Sans-MS-Bold")
	$ini_fanart_genre = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_fanart_genre", "")
	$ini_fanart_genrefolder = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_fanart_genrefolder", "1")
	$ini_fanart_mediainfo = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_fanart_mediainfo", "1")
	$ini_fanart_nobackdrop = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_fanart_nobackdrop", "4")
	$ini_fanart_nocover = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_fanart_nocover", "4")
	$ini_fanart_nonfo = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_fanart_nonfo", "4")
	$ini_fanart_plot = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_fanart_plot", "")

	Local $WorkArray[1] = [0]
	Dim $PathSplit[1]

	Local $InDir = GUICtrlRead($input_33_01)

	Local $iIndex, $sDrive, $sDir, $sFilename, $sExtension, $MediaInfo, $i, $break

	_ClearGUI($Array_GUI_Elements_33)

	_ShowGUI($Array_FUNC_33)

	_ShowGUI($Array_FUNC_99)

	$WorkArray = _FileListToArrayRec($InDir, $extstring2, 1, 1, 1)

	If Not IsArray($WorkArray) Then

		MsgBox(0, "", $lng_nofiles)
		_LastModule()
		Return

	EndIf

	_SetLabel($label_f33_02, $lng_video & "- " & $lng_metadata & " -- " & $lng_workingon & " " & $InDir)

	_SetLabel($label_f33_03, "")

	_SetData($progressbar_f33_01, 0)

	_SetData($progressbar_f33_02, 0)

	If $InFile = "" Then

		For $i = 1 To $WorkArray[0]

			If Not @error Then

				$PathSplit = _PathSplit($InDir & "\" & $WorkArray[$i], $sDrive, $sDir, $sFilename, $sExtension)

				$InFile = $InDir & "\" & $WorkArray[$i]

				$Index = StringInStr($extstring, StringReplace($PathSplit[4], ".", ""))

				If $iIndex > -1 Then

					_WriteLog("Metadata Videos - Started Working On: " & $InFile)

					_SetLabel($label_f33_03, $lng_files & " "  & $i & " -- " & $WorkArray[0] & ": " & $WorkArray[$i])

					_SetLabel($label02, $lng_workingon & "   " & $InFile)

					_SetData($progressbar_f33_02, 0)

					$break = 0

					$break = _MakeFanart($InFile, $ini_videos_metadata_inputfolder, $progressbar_f33_02, $progressbar_f33_01, $WorkArray[0], $i)

					If Not $break = -1 Then _WriteLog("Metadata Videos - Finished Working On: " & $InFile)

				EndIf

				If $break = 1 Then ExitLoop

			Else

				_WriteLog("Error - Could Not Process File: " & $InFile)

				Return -1

			EndIf

		Next

	Else

		_WriteLog("Metadata Videos - Started Working On: " & $InFile)

		_SetLabel($label_f33_03, $lng_files & " "  & $i & " -- " & $WorkArray[0] & ": " & $WorkArray[$i])

		_SetLabel($label02, $lng_workingon & "   " & $InFile)

		_SetData($progressbar_f33_02, 0)

		$break = 0

		$break = _MakeFanart($InFile, $ini_videos_metadata_inputfolder, $progressbar_f33_02, $progressbar_f33_01, $WorkArray[0], $i)

		If Not $break = -1 Then _WriteLog("Metadata Videos - Finished Working On: " & $InFile)

	EndIf

	_ClearGUI($Array_FUNC_33)

	_ClearGUI($Array_FUNC_99)

	_SetLabel($label02,$lng_waiting)

	_WriteLog("Metadata Videos - Finished")

	If GUICtrlRead($radio_f99_01) = "1" Then

		MsgBox(0, "", $lng_sucess, 3)

	EndIf

	If GUICtrlRead($radio_f99_02) = "1" Then

		If $continue = "true" Then

			IniWrite(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_videos_correction_inputfolder", $InDir)

			_SetData($input_63_01, $InDir)

			_GUI_Show_Corection()

			_GUI_Show_Videos_Correction()

			_Metadata_Correction_Videos()

		EndIf

	EndIf

	If GUICtrlRead($radio_f99_03) = "1" Then

		_Countdown()

	EndIf

	If GUICtrlRead($radio_f99_04) = "1" Then

		_Exit(2)

	EndIf

	If GUICtrlRead($radio_f99_05) = "1" Then

		_Exit(3)

	EndIf

	If GUICtrlRead($radio_f99_06) = "1" Then

		_Exit(4)

	EndIf

	_LastModule()

	Return

EndFunc

;Function to process Videos Metadata with maual image selction
Func _Metadata_Videos_Manual($InFile, $fanart_nocover)

	_WriteLog("Metadata Videos Manual - Started")

	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_fanart_design", GUICtrlRead($combo_95_01))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_fanart_font", GUICtrlRead($combo_95_02))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_fanart_covertemplate", GUICtrlRead($combo_95_03))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_fanart_backdroptemplate", GUICtrlRead($combo_95_04))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_fanart_bordertemplate", GUICtrlRead($combo_95_05))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_fanart_bordercolor", GUICtrlRead($input_95_07))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_fanart_genrefolder", GUICtrlRead($check_95_04))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_fanart_mediainfo", GUICtrlRead($check_95_05))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_fanart_plot", GUICtrlRead($edit_95_01))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_fanart_genre", GUICtrlRead($input_95_08))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_fanart_nocover", GUICtrlRead($check_95_01))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_fanart_nobackdrop", GUICtrlRead($check_95_02))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_fanart_nonfo", GUICtrlRead($check_95_03))

	$ini_fanart_backgroundtemplate = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_fanart_backdroptemplate", "---------")
	$ini_fanart_bordercolor = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_fanart_bordercolor", "IndianRed4")
	$ini_fanart_bordertemplate = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_fanart_bordertemplate", "---------")
	$ini_fanart_covertemplate = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_fanart_covertemplate", "---------")
	$ini_fanart_design = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_fanart_design", "1-6")
	$ini_fanart_font = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_fanart_font", "Comic-Sans-MS-Bold")
	$ini_fanart_genre = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_fanart_genre", "")
	$ini_fanart_genrefolder = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_fanart_genrefolder", "1")
	$ini_fanart_mediainfo = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_fanart_mediainfo", "1")
	$ini_fanart_nobackdrop = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_fanart_nobackdrop", "4")
	$ini_fanart_nocover = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_fanart_nocover", "4")
	$ini_fanart_nonfo = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_fanart_nonfo", "4")
	$ini_fanart_plot = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_fanart_plot", "")

	Local $WorkArray[1] = [0]
	Dim $PathSplit[1]

	Local $InDir = GUICtrlRead($input_33_01)

	Local $iIndex, $sDrive, $sDir, $sFilename, $sExtension, $MediaInfo, $i, $break

	_ClearGUI($Array_GUI_Elements_33)

	_ShowGUI($Array_FUNC_33)

	_ShowGUI($Array_FUNC_99)

	_SetLabel($label_f33_02, $lng_video & "- " & $lng_metadata & " -- " & $lng_workingon & " " & $InDir)

	_SetLabel($label_f33_03, "")

	_SetData($progressbar_f33_01, 0)

	_SetData($progressbar_f33_02, 0)

	_WriteLog("Metadata Videos - Started Working On: " & $InFile)

	_SetLabel($label_f33_03, $lng_files & " "  & $i & " -- " & $WorkArray[0] & ": " & $WorkArray[$i])

	_SetLabel($label02, $lng_workingon & "   " & $InFile)

	_SetData($progressbar_f33_02, 0)

	_Make_Cover_Manual($InFile)

	GUICtrlSetState($check_95_01, $GUI_CHECKED)

	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_fanart_nocover", "1")

	$break = 0

	If GUICtrlRead($check_130_02) = "1" Then

		$break = _MakeFanart($InFile, $ini_videos_metadata_inputfolder, $progressbar_f33_02, $progressbar_f33_01, $WorkArray[0], $i)

	EndIf

	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_fanart_nocover", $fanart_nocover)

	If $fanart_nocover = "4" Then GUICtrlSetState($check_95_01, $GUI_UNCHECKED)

	If Not $break = -1 Then _WriteLog("Metadata Videos Manual - Finished Working On: " & $InFile)

	_ClearGUI($Array_FUNC_33)

	_ClearGUI($Array_FUNC_99)

	_SetLabel($label02,$lng_waiting)

	_WriteLog("Metadata Videos Manual - Finished")

	_LastModule()

	Return

EndFunc

;Function to Transcode Videos
Func _Recode()

	_WriteLog("Recode - Started")

	Dim $WorkArray[1]
	Dim $PathSplit[1]
	Local $InDir = GUICtrlRead($input_21_01)
	Local $OutDir = GUICtrlRead($input_21_02)
	Local $p = 0, $sDrive = "", $sDir = "", $sFilename = "", $sExtension = "", $i, $break, $InFile, $OutFile, $value, $codec, $aRow

	_SetData($Select_Label_21, $lng_video & "-" & $lng_conversion & ":  " & $lng_videos & " " & $lng_recoding)

	;Save settings to ini
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_recode_inputfolder", $InDir)
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_recode_outputfolder", $OutDir)
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_recode_quality_sd", GUICtrlRead($input_21_03))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_recode_quality_720", GUICtrlRead($input_21_04))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_recode_quality_1080", GUICtrlRead($input_21_06))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_recode_quality_4k", GUICtrlRead($input_21_08))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_tracksperlanguage_audio", GUICtrlRead($input_90_04))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_tracksperlanguage_sub", GUICtrlRead($input_90_05))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_tracksperlanguage_forced", GUICtrlRead($input_90_06))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_useoptimizer", GUICtrlRead($check_90_01))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_useoptimizer_subs", GUICtrlRead($check_90_02))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_audiolanguages", GUICtrlRead($input_90_10))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_sublanguages", GUICtrlRead($input_90_11))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_recode_videocodec_SD", GUICtrlRead($combo_21_01))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_recode_videocodec_720", GUICtrlRead($combo_21_02))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_recode_videocodec_1080", GUICtrlRead($combo_21_04))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_recode_videocodec_4K", GUICtrlRead($combo_21_06))

	If GUICtrlRead($radio_21_04)  = 1 Then

		IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_recode_container", "mkv")
		$videocontainer = ".mkv"

	EndIf

	If GUICtrlRead($radio_21_05)  = 1 Then

		IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_recode_container", "mp4")
		$videocontainer = ".mp4"

	EndIf

	If GUICtrlRead($radio_21_06)  = 1 Then

		IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_recode_audiocodec", "1")
		$audiocodec = 1

	EndIf

	If GUICtrlRead($radio_21_07)  = 1 Then

		IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_recode_audiocodec", "2")
		$audiocodec = 2

	EndIf

	If GUICtrlRead($radio_21_08)  = 1 Then

		IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_recode_audiocodec", "3")
		$audiocodec = 3

	EndIf

	If GUICtrlRead($radio_21_09)  = 1 Then

		IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_recode_audiocodec", "4")
		$audiocodec = 4

	EndIf

	If GUICtrlRead($radio_21_11)  = 1 Then

		IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_recode_audiofallback", "1")
		$audiofallback = 1

	EndIf

	$ini_recode_inputfolder = IniRead(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_recode_inputfolder", @MyDocumentsDir)
	$ini_recode_outputfolder = IniRead(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_recode_outputfolder", @MyDocumentsDir)
	$ini_recode_videocodec_720 = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_recode_videocodec_720", "h264 AVC")
	$ini_recode_videocodec_1080 = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_recode_videocodec_1080", "h264 AVC")
	$ini_recode_videocodec_4K = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_recode_videocodec_4K", "h265 HEVC")
	$ini_recode_videocodec_SD = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_recode_videocodec_SD", "h264 AVC")
	$ini_tracksperlanguage_audio = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_tracksperlanguage_audio", "1")
	$ini_tracksperlanguage_forced = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_tracksperlanguage_forced", "1")
	$ini_tracksperlanguage_sub = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_tracksperlanguage_sub", "0")
	$ini_audiolanguages = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_audiolanguages", "en")
	$ini_sublanguages = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_sublanguages", "en")
	$ini_recode_audiocodec = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_recode_audiocodec", "6")
	$ini_recode_container = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_recode_container", "mkv")
	$ini_recode_quality_720 = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_recode_quality_720", "20")
	$ini_recode_quality_1080 = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_recode_quality_1080", "18")
	$ini_recode_quality_4k = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_recode_quality_4k", "16")
	$ini_recode_quality_sd = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_recode_quality_sd", "24")
	$ini_recode_videocodec_720 = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_recode_videocodec_720", "h264 AVC")
	$ini_recode_videocodec_1080 = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_recode_videocodec_1080", "h264 AVC")
	$ini_recode_videocodec_4K = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_recode_videocodec_4K", "h265 HEVC")
	$ini_recode_videocodec_SD = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_recode_videocodec_SD", "h264 AVC")

	_ClearGUI($Array_GUI_Elements_21)

	_ShowGUI($Array_FUNC_21)

	_ShowGUI($Array_FUNC_99)

	_SetLabel($label_f21_02, $lng_recoding & " -- " & $lng_workingon & " " & $InDir)

	_SetData($progressbar_f21_01, 0)

	_SetData($progressbar_f21_02, 0)

	$WorkArray = _FileListToArrayRec($InDir, $extstring, 1, 1, 1)

	If Not IsArray($WorkArray) Then

		MsgBox(0, "", $lng_nofiles)
		_LastModule()
		Return

	EndIf

	_FileListToDB($WorkArray, $InDir)

	For $i = 1 To $WorkArray[0]

		Sleep(25)

		$MediaInfo = _MediaInfo($InDir & "\" & $WorkArray[$i])

		If Not $MediaInfo = "skip" Then

			$iPathSplit = _PathSplit($InDir & "\" & $WorkArray[$i], $sDrive, $sDir, $sFilename, $sExtension)

			$InFile = StringReplace($InDir & "\" & $WorkArray[$i], "'", "\'")

			$oPathSplit = _PathSplit($OutDir & "\" & $WorkArray[$i], $sDrive, $sDir, $sFilename, $sExtension)

			$OutFile = StringReplace($oPathSplit[1] & $oPathSplit[2] & $oPathSplit[3] & $videocontainer, "'", "\'")

			DirCreate($oPathSplit[1] & $oPathSplit[2])

			$iIndex = StringInStr($extstring, StringReplace($iPathSplit[4], ".", ""))

			_SQLite_QuerySingleRow(-1,"SELECT * FROM Video LIMIT 1;",$aRow)

				$width = $aRow[5]

				If $width < 900 Then

					$br = $ini_wizard_series_bitrate_sd

					$codec = $ini_recode_videocodec_SD

				EndIf

				If $width > 899 And $width < 1400 Then

					$br = $ini_wizard_series_bitrate_720

					$codec = $ini_recode_videocodec_720

				EndIf

				If $width > 1399 And $width < 2800 Then

					$br = $ini_wizard_series_bitrate_1080

					$codec = $ini_recode_videocodec_1080

				EndIf

				If $width > 2800 Then

					$br = $ini_wizard_series_bitrate_4k

					$codec = $ini_recode_videocodec_4K

				EndIf


			If $iIndex > -1 Then

				_WriteLog("Recode - Started Working On: " & $InFile)

				_SetLabel($label_f21_03, $lng_files & " "  & $i & " -- " & $WorkArray[0] & ": " & $WorkArray[$i])

				_SetLabel($label02, $lng_workingon & "   " & $InFile)

				$break = 0

				$break = _RecodeFile($InFile, $OutFile, $codec, $button_f21_01, $progressbar_f21_02, $progressbar_f21_01, $WorkArray[0], $i)

				If Not $break = -1 Then _WriteLog("Recode - Finished Working On: " & $OutFile)

			EndIf

			If $break = 1 Then ExitLoop

			If $ini_KeepFileDate = "1" Then _SetTimeSegment($InDir & "\" & $WorkArray[$i], $OutDir & "\" & $WorkArray[$i])

		Else

			_WriteLog("Error - Could Not Process File: " & $InFile)

			Return -1

		EndIf

	Next

	$audioonlycode = 0

	_WriteLog("Recode - Finished")

	If GUICtrlRead($radio_f99_01) = "1" Then

		MsgBox(0, "", $lng_sucess, 3)

	EndIf

	If GUICtrlRead($radio_f99_02) = "1" Then

		MsgBox(0, "", $lng_sucess, 3)

	EndIf

	If GUICtrlRead($radio_f99_03) = "1" Then

		_Countdown()

	EndIf

	If GUICtrlRead($radio_f99_04) = "1" Then

		_Exit(2)

	EndIf

	If GUICtrlRead($radio_f99_05) = "1" Then

		_Exit(3)

	EndIf

	If GUICtrlRead($radio_f99_06) = "1" Then

		_Exit(4)

	EndIf

	_ClearGUI($Array_FUNC_21)

	_ClearGUI($Array_FUNC_99)

	_SetLabel($label02,$lng_waiting)

	_SetData($Select_Label_21, "")

	_LastModule()

	Return

EndFunc

;Function to Transcode Audio
Func _RecodeAudio()

	_WriteLog("AudioRecode - Started")

	Dim $WorkArray[1]
	Dim $PathSplit[1]
	Local $InDir = GUICtrlRead($input_24_01)
	Local $OutDir = GUICtrlRead($input_24_02)
	Local $p = 0, $sDrive = "", $sDir = "", $sFilename = "", $sExtension = "", $i, $break, $InFile, $OutFile, $value, $codec

	_SetData($Select_Label_21, $lng_audio & "-" & $lng_conversion & ":  " & $lng_audio & " " & $lng_recoding)

	;Save settings to ini
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_arecode_inputfolder", $InDir)
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_arecode_outputfolder", $OutDir)
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_arecode_bitrate_mp3", GUICtrlRead($combo_14_21))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_arecode_bitrate_flac", GUICtrlRead($combo_14_22))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_arecode_bitrate_opus", GUICtrlRead($combo_14_24))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_arecode_samplingrate_mp3", GUICtrlRead($combo_14_31))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_arecode_samplingrate_flac", GUICtrlRead($combo_14_32))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_arecode_samplingrate_wav", GUICtrlRead($combo_14_33))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_arecode_quality_opus", GUICtrlRead($combo_14_34))

	If GUICtrlRead($radio_14_11) = 1 Then IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_arecode_container", "mp3")
	If GUICtrlRead($radio_14_21) = 1 Then IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_arecode_container", "flac")
	If GUICtrlRead($radio_14_31) = 1 Then IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_arecode_container", "wav")
	If GUICtrlRead($radio_14_41) = 1 Then IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_arecode_container", "ogg")

	$ini_arecode_inputfolder = IniRead(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_arecode_inputfolder", @MyDocumentsDir)
	$ini_arecode_outputfolder = IniRead(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_arecode_outputfolder", @MyDocumentsDir)
	$ini_arecode_bitrate_mp3 = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_arecode_bitrate_mp3", "128")
	$ini_arecode_bitrate_flac = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_arecode_bitrate_flac", "10")
	$ini_arecode_bitrate_opus = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_arecode_bitrate_opus", "128")
	$ini_arecode_container = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_arecode_container", "flac")
	$ini_arecode_quality_opus = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_arecode_quality_opus", "3")
	$ini_arecode_samplingrate_mp3 = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_arecode_samplingrate_mp3", "48000")
	$ini_arecode_samplingrate_flac = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_arecode_samplingrate_flac", "48000")
	$ini_arecode_samplingrate_wav = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_arecode_samplingrate_wav", "44100")

	_ClearGUI($Array_GUI_Elements_24)

	_ShowGUI($Array_FUNC_24)

	_SetLabel($label_f24_02, $lng_recoding & " -- " & $lng_workingon & " " & $InDir)

	_SetData($progressbar_f24_01, 0)

	$WorkArray = _FileListToArrayRec($InDir, StringReplace($aextstring, ",", ";"), 1, 1, 1)

	If Not IsArray($WorkArray) Then

		MsgBox(0, "", $lng_nofiles)
		_LastModule()
		Return

	EndIf

	_FileListToDB($WorkArray, $InDir)

	For $i = 1 To $WorkArray[0]

		If Not @error Then

			$iPathSplit = _PathSplit($InDir & "\" & $WorkArray[$i], $sDrive, $sDir, $sFilename, $sExtension)

			$InFile = StringReplace($InDir & "\" & $WorkArray[$i], "'", "\'")

			$oPathSplit = _PathSplit($OutDir & "\" & $WorkArray[$i], $sDrive, $sDir, $sFilename, $sExtension)

			$OutFile = $oPathSplit[1] & $oPathSplit[2] & $oPathSplit[3] & "." & $ini_arecode_container

			DirCreate($oPathSplit[1] & $oPathSplit[2])

			$iIndex = _ArraySearch($json_Music_FileExtensions, StringReplace($iPathSplit[4], ".", "*."), 0, 0, 0, 1)

			If $iIndex > -1 Then

				_WriteLog("Audio Recode - Started Working On: " & $InFile)

				_SetLabel($label_f24_03, $lng_files & " "  & $i & " -- " & $WorkArray[0] & ": " & $WorkArray[$i])

				_SetLabel($label02, $lng_workingon & "   " & $InFile)

				$break = 0

				$break = _RecodeAudioFile($InFile, $OutFile, $progressbar_f24_01, $button_f24_01, $WorkArray[0], $i)

				If Not $break = -1 Then _WriteLog("Audio Recode - Finished Working On: " & $OutFile)

			EndIf

			If $break = 1 Then ExitLoop

			If $ini_KeepFileDate = "1" Then _SetTimeSegment($InDir & "\" & $WorkArray[$i], $OutDir & "\" & $WorkArray[$i])

		Else

			_WriteLog("Error - Could Not Process File: " & $InFile)

			Return -1

		EndIf

	Next

	_WriteLog("AudioRecode - Finished")

	If GUICtrlRead($radio_f99_01) = "1" Then

		MsgBox(0, "", $lng_sucess, 3)

	EndIf

	If GUICtrlRead($radio_f99_02) = "1" Then

		MsgBox(0, "", $lng_sucess, 3)

	EndIf

	If GUICtrlRead($radio_f99_03) = "1" Then

		_Countdown()

	EndIf

	If GUICtrlRead($radio_f99_04) = "1" Then

		_Shutdown()

	EndIf

	If GUICtrlRead($radio_f99_05) = "1" Then

		_Standby()

	EndIf

	If GUICtrlRead($radio_f99_06) = "1" Then

		_Hibernate()

	EndIf

	_ClearGUI($Array_FUNC_24)

	_SetLabel($label02,$lng_waiting)

	_SetData($Select_Label_21, "")

	_SetData($progressbar_f24_01, 0)

	_LastModule()

	Return

EndFunc

;Function to Normalize Audio
Func _NormalizeAudio()

	_WriteLog("AudioNormalize - Started")

	Dim $WorkArray[1]
	Dim $PathSplit[1]
	Local $InDir = GUICtrlRead($input_25_01)
	Local $OutDir = GUICtrlRead($input_25_02)
	Local $p = 0, $sDrive = "", $sDir = "", $sFilename = "", $sExtension = "", $i, $break, $InFile, $OutFile, $value, $codec

	_SetData($Select_Label_21, $lng_audio & "-" & $lng_conversion & ":  " & $lng_audionormalize)

	;Save settings to ini
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_anorm_inputfolder", $InDir)
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_anorm_outputfolder", $OutDir)
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_audio_compression", GUICtrlRead($combo_97_01))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_audio_db", GUICtrlRead($input_97_01))

	$ini_anorm_inputfolder = IniRead(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_anorm_inputfolder", @MyDocumentsDir)
	$ini_anorm_outputfolder = IniRead(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_anorm_outputfolder", @MyDocumentsDir)
	$ini_audio_compression = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_audio_compression", "2")
	$ini_audio_db = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_audio_db", "0,99")

	_ClearGUI($Array_GUI_Elements_25)

	_ShowGUI($Array_FUNC_25)

	_ShowGUI($Array_FUNC_99)

	_SetLabel($label_f25_02, $lng_recoding & " -- " & $lng_workingon & " " & $InDir)

	_SetData($progressbar_f25_01, 0)

	_SetData($progressbar_f25_02, 0)

	$WorkArray = _FileListToArrayRec($InDir, StringReplace($extstring, ",", ";"), 1, 1, 1)

	If Not IsArray($WorkArray) Then

		MsgBox(0, "", $lng_nofiles)
		_LastModule()
		Return

	EndIf

	_FileListToDB($WorkArray, $InDir)

	For $i = 1 To $WorkArray[0]

		Sleep(25)

		$MediaInfo = _MediaInfo($InDir & "\" & $WorkArray[$i])

		If Not @error Then

			$iPathSplit = _PathSplit($InDir & "\" & $WorkArray[$i], $sDrive, $sDir, $sFilename, $sExtension)

			$InFile = StringReplace($InDir & "\" & $WorkArray[$i], "'", "\'")

			$oPathSplit = _PathSplit($OutDir & "\" & $WorkArray[$i], $sDrive, $sDir, $sFilename, $sExtension)

			$OutFile = StringReplace($OutDir & "\" & $WorkArray[$i], "'", "\'")

			DirCreate($oPathSplit[1] & $oPathSplit[2])

			$iIndex = _ArraySearch($json_FileExtensions, StringReplace($iPathSplit[4], ".", "*."), 0, 0, 0, 1)

			If $iIndex > -1 Then

				_WriteLog("Audio Normalize - Started Working On: " & $InFile)

				_SetLabel($label_f25_03, $lng_files & " "  & $i & " -- " & $WorkArray[0] & ": " & $WorkArray[$i])

				_SetLabel($label02, $lng_workingon & "   " & $InFile)

				$break = 0

				$break = _NormalizeAudioFile($InFile, $OutFile, $button_f25_01, $progressbar_f25_02, $progressbar_f25_01, $WorkArray[0], $i)

				If Not $break = -1 Then _WriteLog("Audio Normalize - Finished Working On: " & $OutFile)

			EndIf

			If $break = 1 Then ExitLoop

			If $ini_KeepFileDate = "1" Then _SetTimeSegment($InDir & "\" & $WorkArray[$i], $OutDir & "\" & $WorkArray[$i])

		Else

			_WriteLog("Error - Could Not Process File: " & $InFile)

			Return -1

		EndIf

	Next

	_WriteLog("AudioNormalize - Finished")

	If GUICtrlRead($radio_f99_01) = "1" Then

		MsgBox(0, "", $lng_sucess, 3)

	EndIf

	If GUICtrlRead($radio_f99_02) = "1" Then

		MsgBox(0, "", $lng_sucess, 3)

	EndIf

	If GUICtrlRead($radio_f99_03) = "1" Then

		_Countdown()

	EndIf

	If GUICtrlRead($radio_f99_04) = "1" Then

		_Shutdown()

	EndIf

	If GUICtrlRead($radio_f99_05) = "1" Then

		_Standby()

	EndIf

	If GUICtrlRead($radio_f99_06) = "1" Then

		_Hibernate()

	EndIf

	_ClearGUI($Array_FUNC_25)

	_SetLabel($label02,$lng_waiting)

	_SetData($Select_Label_21, "")

	_SetData($progressbar_f25_01, 0)

	_LastModule()

	Return

EndFunc

;Function to Remux Videos
Func _Remux()

	_WriteLog("Remux - Started")

	Dim $WorkArray[0]
	Dim $iPathSplit[0]
	Dim $oPathSplit[0]
	Local $InDir = GUICtrlRead($input_22_01)
	Local $OutDir = GUICtrlRead($input_22_02)
	Local $p = 0, $sDrive = "", $sDir = "", $sFilename = "", $sExtension = "", $i, $break, $InFile, $OutFile, $value

	_SetData($Select_Label_21, $lng_video & "-" & $lng_conversion & ":  " & $lng_videos & " " & $lng_remux)

	;Save settings to ini
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_remux_inputfolder", $InDir)
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_remux_outputfolder", $OutDir)
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_tracksperlanguage_audio", GUICtrlRead($input_90_04))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_tracksperlanguage_sub", GUICtrlRead($input_90_05))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_tracksperlanguage_forced", GUICtrlRead($input_90_06))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_useoptimizer", GUICtrlRead($check_90_01))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_useoptimizer_subs", GUICtrlRead($check_90_02))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_audiolanguages", GUICtrlRead($input_90_10))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_sublanguages", GUICtrlRead($input_90_11))

	$ini_remux_inputfolder = IniRead(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_remux_inputfolder", @MyDocumentsDir)
	$ini_remux_outputfolder = IniRead(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_remux_outputfolder", @MyDocumentsDir)
	$ini_tracksperlanguage_audio = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_tracksperlanguage_audio", "1")
	$ini_tracksperlanguage_forced = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_tracksperlanguage_forced", "1")
	$ini_tracksperlanguage_sub = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_tracksperlanguage_sub", "0")
	$ini_audiolanguages = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_audiolanguages", "en")
	$ini_sublanguages = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_sublanguages", "en")

	_ClearGUI($Array_GUI_Elements_22)

	_ShowGUI($Array_FUNC_22)

	_ShowGUI($Array_FUNC_99)

	_SetLabel($label_f22_02, $lng_remux & " -- " & $lng_workingon & " " & $InDir)

	_SetData($progressbar_f22_01, 0)

	_SetData($progressbar_f22_02, 0)

	$WorkArray = _FileListToArrayRec($InDir, $extstring, 1, 1, 1)

	If Not IsArray($WorkArray) Then

		MsgBox(0, "", $lng_nofiles)
		_LastModule()
		Return

	EndIf

	_FileListToDB($WorkArray, $InDir)

	For $i = 1 To $WorkArray[0]

		Sleep(25)

		$MediaInfo = _MediaInfo($InDir & "\" & $WorkArray[$i])

		If Not $MediaInfo = "skip" Then

			$iPathSplit = _PathSplit($InDir & "\" & $WorkArray[$i], $sDrive, $sDir, $sFilename, $sExtension)

			$InFile = StringReplace($InDir & "\" & $WorkArray[$i], "'", "\'")

			$oPathSplit = _PathSplit($OutDir & "\" & $WorkArray[$i], $sDrive, $sDir, $sFilename, $sExtension)

			$OutFile = StringReplace($oPathSplit[1] & $oPathSplit[2] & $oPathSplit[3] & ".mkv", "'", "\'")

			DirCreate($oPathSplit[1] & $oPathSplit[2])

			$iIndex = StringInStr($extstring, StringReplace($iPathSplit[4], ".", ""))

			If $iIndex > -1 Then

				_WriteLog("Remux - Started Working On: " & $InFile)

				_SetLabel($label_f22_03, $lng_files & " "  & $i & " -- " & $WorkArray[0] & ": " & $WorkArray[$i])

				_SetLabel($label02, $lng_workingon & "   " & $InFile)

				$break = 0

				$break = _RemuxFile($InFile, $OutFile, $button_f22_01, $progressbar_f22_02, $progressbar_f22_01, $WorkArray[0], $i)

				If Not $break = -1 Then _WriteLog("Remux - Finished Working On: " & $OutFile)

			EndIf

			If $break = 1 Then ExitLoop

			If $ini_KeepFileDate = "1" Then _SetTimeSegment($InDir & "\" & $WorkArray[$i], $OutDir & "\" & $WorkArray[$i])

		Else

			_WriteLog("Error - Could Not Process File: " & $InFile)

			Return -1

		EndIf

	Next

	_WriteLog("Remux - Finished")

	If GUICtrlRead($radio_f99_01) = "1" Then

		MsgBox(0, "", $lng_sucess, 3)

	EndIf

	If GUICtrlRead($radio_f99_02) = "1" Then

		MsgBox(0, "", $lng_sucess, 3)

	EndIf

	If GUICtrlRead($radio_f99_03) = "1" Then

		_Countdown()

	EndIf

	If GUICtrlRead($radio_f99_04) = "1" Then

		_Exit(2)

	EndIf

	If GUICtrlRead($radio_f99_05) = "1" Then

		_Exit(3)

	EndIf

	If GUICtrlRead($radio_f99_06) = "1" Then

		_Exit(4)

	EndIf

	_ClearGUI($Array_FUNC_22)

	_ClearGUI($Array_FUNC_99)

	_SetLabel($label02,$lng_waiting)

	_SetData($Select_Label_21, "")

	_LastModule()

	Return

EndFunc

;Function to Remux Videos
Func _Simple_Remux()

	_WriteLog("Simple_Remux - Started")

	Dim $WorkArray[0]
	Dim $iPathSplit[0]
	Dim $oPathSplit[0]
	Local $InDir = GUICtrlRead($input_22_01)
	Local $OutDir = GUICtrlRead($input_22_02)
	Local $p = 0, $sDrive = "", $sDir = "", $sFilename = "", $sExtension = "", $i, $break, $InFile, $OutFile, $value

	_SetData($Select_Label_21, $lng_video & "-" & $lng_conversion & ":  " & $lng_videos & " Simple-" & $lng_remux)

	;Save settings to ini
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_remux_inputfolder", $InDir)
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_remux_outputfolder", $OutDir)

	$ini_remux_inputfolder = IniRead(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_remux_inputfolder", @MyDocumentsDir)
	$ini_remux_outputfolder = IniRead(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_remux_outputfolder", @MyDocumentsDir)

	_ClearGUI($Array_GUI_Elements_22)

	_ShowGUI($Array_FUNC_22)

	_ShowGUI($Array_FUNC_99)

	_SetLabel($label_f22_02, $lng_remux & " -- " & $lng_workingon & " " & $InDir)

	_SetData($progressbar_f22_01, 0)

	_SetData($progressbar_f22_02, 0)

	$WorkArray = _FileListToArrayRec($InDir, $extstring, 1, 1, 1)

	If Not IsArray($WorkArray) Then

		MsgBox(0, "", $lng_nofiles)
		_LastModule()
		Return

	EndIf

	_FileListToDB($WorkArray, $InDir)

	For $i = 1 To $WorkArray[0]

		$iPathSplit = _PathSplit($InDir & "\" & $WorkArray[$i], $sDrive, $sDir, $sFilename, $sExtension)

		$InFile = StringReplace($InDir & "\" & $WorkArray[$i], "'", "\'")

		$oPathSplit = _PathSplit($OutDir & "\" & $WorkArray[$i], $sDrive, $sDir, $sFilename, $sExtension)

		$OutFile = StringReplace($oPathSplit[1] & $oPathSplit[2] & $oPathSplit[3] & ".mkv", "'", "\'")

		DirCreate($oPathSplit[1] & $oPathSplit[2])

		$iIndex = StringInStr($extstring, StringReplace($iPathSplit[4], ".", ""))

		If $iIndex > -1 Then

			_WriteLog("Simple_Remux - Started Working On: " & $InFile)

			_SetLabel($label_f22_03, $lng_files & " "  & $i & " -- " & $WorkArray[0] & ": " & $WorkArray[$i])

			_SetLabel($label02, $lng_workingon & "   " & $InFile)

			$break = 0

			$break = _RemuxFile($InFile, $OutFile, $button_f22_01, $progressbar_f22_02, $progressbar_f22_01, $WorkArray[0], $i)

			If Not $break = -1 Then _WriteLog("Simple_Remux - Finished Working On: " & $OutFile)

		EndIf

		If $break = 1 Then ExitLoop

	Next

	_WriteLog("Simple_Remux - Finished")

	If GUICtrlRead($radio_f99_01) = "1" Then

		MsgBox(0, "", $lng_sucess, 3)

	EndIf

	If GUICtrlRead($radio_f99_02) = "1" Then

		MsgBox(0, "", $lng_sucess, 3)

	EndIf

	If GUICtrlRead($radio_f99_03) = "1" Then

		_Countdown()

	EndIf

	If GUICtrlRead($radio_f99_04) = "1" Then

		_Exit(2)

	EndIf

	If GUICtrlRead($radio_f99_05) = "1" Then

		_Exit(3)

	EndIf

	If GUICtrlRead($radio_f99_06) = "1" Then

		_Exit(4)

	EndIf

	_ClearGUI($Array_FUNC_22)

	_ClearGUI($Array_FUNC_99)

	_SetLabel($label02,$lng_waiting)

	_SetData($Select_Label_21, "")

	_LastModule()

	Return

EndFunc

;Function to Set 3D Related Tags
Func _Tag3D()

	_WriteLog("Tag3D - Started")

	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_3d_mode", GUICtrlRead($combo_42_01))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_3d_rename", GUICtrlRead($check_42_01))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_3d_renamenfo", GUICtrlRead($check_42_03))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_3d_kodinaming", GUICtrlRead($check_42_02))

	$ini_3d_mode = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_3d_mode", "mono")
	$ini_3d_kodinaming = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_3d_kodinaming", "4")
	$ini_3d_rename = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_3d_rename", "4")
	$ini_3d_renamenfo = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_3d_renamenfo", "1")

	Dim $WorkArray[1]
	Dim $PathSplit[1]
	Local $InDir = GUICtrlRead($input_42_01)

	Local $modus = "", $aPathSplit, $sDrive = "", $sDir = "", $sFilename = "", $sExtension = "", $dest = "", $FullPath = "", $fname = ""
	Local $p = 0, $sOutput, $option, $result, $i, $fl, $3D_ext="", $width, $height, $aRow, $ext = ".mkv", $iFileExists, $filename = ""

	$ini_3d_mode = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_3d_mode", "mono")
	$ini_3d_rename = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_3d_rename", "1")
	$ini_3d_kodinaming = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_3d_kodinaming", "4")
	$ini_3d_renamenfo = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_3d_renamenfo", "1")

	If $ini_3d_mode = "mono" Then $modus = 0
	If $ini_3d_mode = "side_by_side_left_first" Then $modus = 1
	If $ini_3d_mode = "top_bottom_right_first" Then $modus = 2
	If $ini_3d_mode = "top_bottom_left_first" Then $modus = 3
	If $ini_3d_mode = "checkerboard_right_first" Then $modus = 4
	If $ini_3d_mode = "checkerboard_left_first" Then $modus = 5
	If $ini_3d_mode = "row_interleaved_right_first" Then $modus = 6
	If $ini_3d_mode = "row_interleaved_left_first" Then $modus = 7
	If $ini_3d_mode = "column_interleaved_right_first" Then $modus = 8
	If $ini_3d_mode = "column_interleaved_left_first" Then $modus = 9
	If $ini_3d_mode = "anaglyph_cyan_red" Then $modus = 10
	If $ini_3d_mode = "side_by_side_right_first" Then $modus = 11
	If $ini_3d_mode = "anaglyph_green_magenta" Then $modus = 12
	If $ini_3d_mode = "both_eyes_laced_left_first" Then $modus = 13
	If $ini_3d_mode = "both_eyes_laced_right_first" Then $modus = 14

	IniWrite(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_3d_inputfolder", $InDir)

	_ClearGUI($Array_GUI_Elements_42)

	_ShowGUI($Array_FUNC_42)

	_ShowGUI($Array_FUNC_99)

	_SetLabel($label_f42_02, $lng_3D & " -- " & $lng_workingon & " " & $InDir)

	$WorkArray = _FileListToArrayRec($InDir, "*mkv;*.mk3d", 1, 1, 1)

	If Not IsArray($WorkArray) Then

		MsgBox(0, "", $lng_nofiles)
		_LastModule()
		Return

	EndIf

	Local $step1 = 100 / $WorkArray[0]

	$p += $step1

	For $i = 1 To $WorkArray[0]

		$FullPath = $InDir & "\" & $WorkArray[$i]

		_WriteLog("Tag3D - Started Working On: " & $FullPath)

		$skip = _MediaInfo($FullPath)

		If $skip = "skip" then Return -1

		_SetData($progressbar_f42_01, $p)

		_SetLabel($label_f42_03, $lng_files & " "  & $i & " -- " & $WorkArray[0] & ": " & $WorkArray[$i])

		_SetLabel($label02, $lng_workingon & "   " & $FullPath)

		$option = ' -e track:v1 -s stereo-mode=' & $modus & ' "' & $FullPath & '"'

		ShellExecuteWait($ini_mkvpropedit_path, $option, "", "", @SW_HIde)

		$aPathSplit = _PathSplit($FullPath, $sDrive, $sDir, $sFilename, $sExtension)

		$fname = $aPathSplit[1] & $aPathSplit[2] & $aPathSplit[3]

		$filename = $aPathSplit[3]

		If $modus = 0 Then

			If StringInStr($filename, " 3d", 0) > 0 Then $filename = StringReplace($filename, " 3d", "",0 ,0)

			If StringInStr($filename, "-3d", 0) > 0 Then $filename = StringReplace($filename, "-3d", "",0 ,0)

			If StringInStr($filename, ".3d", 0) > 0 Then $filename = StringReplace($filename, ".3d", "",0 ,0)

			If StringInStr($filename, "_3d", 0) > 0 Then $filename = StringReplace($filename, "_3d", "",0 ,0)

			If StringInStr($filename, " HSBS", 0) > 0 Then $filename = StringReplace($filename, " HSBS", "",0 ,0)

			If StringInStr($filename, "-HSBS", 0) > 0 Then $filename = StringReplace($filename, "-HSBS", "",0 ,0)

			If StringInStr($filename, ".HSBS", 0) > 0 Then $filename = StringReplace($filename, ".HSBS", "",0 ,0)

			If StringInStr($filename, "_HSBS", 0) > 0 Then $filename = StringReplace($filename, "_HSBS", "",0 ,0)

			If StringInStr($filename, " HTAB", 0) > 0 Then $filename = StringReplace($filename, " HTAB", "",0 ,0)

			If StringInStr($filename, "-HTAB", 0) > 0 Then $filename = StringReplace($filename, "-HTAB", "",0 ,0)

			If StringInStr($filename, ".HTAB", 0) > 0 Then $filename = StringReplace($filename, ".HTAB", "",0 ,0)

			If StringInStr($filename, "_HTAB", 0) > 0 Then $filename = StringReplace($filename, "_HTAB", "",0 ,0)

			If StringInStr($filename, " SBS", 0) > 0 Then $filename = StringReplace($filename, " SBS", "",0 ,0)

			If StringInStr($filename, "-SBS", 0) > 0 Then $filename = StringReplace($filename, "-SBS", "",0 ,0)

			If StringInStr($filename, ".SBS", 0) > 0 Then $filename = StringReplace($filename, ".SBS", "",0 ,0)

			If StringInStr($filename, "_SBS", 0) > 0 Then $filename = StringReplace($filename, "_SBS", "",0 ,0)

			If StringInStr($filename, " TAB", 0) > 0 Then $filename = StringReplace($filename, " TAB", "",0 ,0)

			If StringInStr($filename, "-TAB", 0) > 0 Then $filename = StringReplace($filename, "-TAB", "",0 ,0)

			If StringInStr($filename, ".TAB", 0) > 0 Then $filename = StringReplace($filename, ".TAB", "",0 ,0)

			If StringInStr($filename, "_TAB", 0) > 0 Then $filename = StringReplace($filename, "_MVC", "",0 ,0)

			If StringInStr($filename, " MVC", 0) > 0 Then $filename = StringReplace($filename, " MVC", "",0 ,0)

			If StringInStr($filename, "-MVC", 0) > 0 Then $filename = StringReplace($filename, "-MVC", "",0 ,0)

			If StringInStr($filename, ".MVC", 0) > 0 Then $filename = StringReplace($filename, ".MVC", "",0 ,0)

			If StringInStr($filename, "_MVC", 0) > 0 Then $filename = StringReplace($filename, "_MVC", "",0 ,0)

			_WriteLog("Debug - $filename = " & $filename)

			$dest = $aPathSplit[1] & $aPathSplit[2] & $filename & ".mkv"

			$fname = $aPathSplit[1] & $aPathSplit[2] & $filename

			FileMove($FullPath, $dest, 9)

			$iFileExists = FileExists($aPathSplit[1] & $aPathSplit[2] & $aPathSplit[3] & ".nfo")

			If $iFileExists Then

				FileMove($aPathSplit[1] & $aPathSplit[2] & $aPathSplit[3] & ".nfo", $fname & ".nfo", 9)

			EndIf

		Else

			If $ini_3d_kodinaming = "1" Then

				$3D_ext = ""

				_SQLite_QuerySingleRow(-1,"SELECT * FROM Video LIMIT 1;",$aRow)

				$width = $aRow[4]

				$height = $aRow[5]

				If $modus = "1" Then $3D_ext = $3D_ext & "_HSBS"
				If $modus = "11" Then $3D_ext = $3D_ext & "_HSBS"

				If $modus = "2" Then $3D_ext = $3D_ext & "_HTAB"
				If $modus = "3" Then $3D_ext = $3D_ext & "_HTAB"

				If $modus = "13" Then $3D_ext = $3D_ext & "_MVC"
				If $modus = "14" Then $3D_ext = $3D_ext & "_MVC"

				If $width < $height Then

					If $modus = "2" Then $3D_ext = $3D_ext & "_TAB"
					If $modus = "3" Then $3D_ext = $3D_ext & "_TAB"

				Endif

				If $width > $height * 2 Then

					If $modus = "1" Then $3D_ext = $3D_ext & "_SBS"
					If $modus = "11" Then $3D_ext = $3D_ext & "_SBS"

				EndIf

				If StringLower(StringRight($aPathSplit[3],2)) <> "3d" Then  $3D_ext = "_3D" & $3D_ext

				If $ini_3d_rename = "1" Then

					$ext = ".mk3d"

				EndIf

				$dest = $aPathSplit[1] & $aPathSplit[2] & $aPathSplit[3] & $3D_ext & $ext

				$fname = $aPathSplit[1] & $aPathSplit[2] & $aPathSplit[3] & $3D_ext

				FileMove($FullPath, $dest, 9)

			Else

				If $ini_3d_rename = "1" Then

					If StringLower($aPathSplit[4]) = ".mkv" Then

						$dest = $aPathSplit[1] & $aPathSplit[2] & $aPathSplit[3] & ".mk3d"

						FileMove($FullPath, $dest, 9)

					EndIf

				EndIf

			EndIf

			If $ini_3d_renamenfo = "1" Then

				$iFileExists = FileExists($aPathSplit[1] & $aPathSplit[2] & $aPathSplit[3] & ".nfo")

				If $iFileExists Then

					FileMove($aPathSplit[1] & $aPathSplit[2] & $aPathSplit[3] & ".nfo", $fname & ".nfo", 9)

				EndIf

			EndIf

		EndIf

		_WriteLog("Tag3D - Finished Working On: " & $FullPath)

		$p += $step1

	Next

	_TagNames($InDir)

	_ClearGUI($Array_FUNC_42)

	_ClearGUI($Array_FUNC_99)

	_SetLabel($label02,$lng_waiting)

	_WriteLog("Tag3D - Finished")

	_SetData($Select_Label_41, "")

	If GUICtrlRead($radio_f99_01) = "1" Then

		MsgBox(0, "", $lng_sucess, 3)

	EndIf

	If GUICtrlRead($radio_f99_02) = "1" Then

		MsgBox(0, "", $lng_sucess, 3)

	EndIf

	If GUICtrlRead($radio_f99_03) = "1" Then

		_Countdown()

	EndIf

	If GUICtrlRead($radio_f99_04) = "1" Then

		_Exit(2)

	EndIf

	If GUICtrlRead($radio_f99_05) = "1" Then

		_Exit(3)

	EndIf

	If GUICtrlRead($radio_f99_06) = "1" Then

		_Exit(4)

	EndIf

	_LastModule()

	Return

EndFunc

;Function Audio Wizard
Func _Wizard_Audio()

	_WriteLog("Wizard_Audio - Started")

	_SaveJSON()

	Dim $WorkArray[1]
	Local $InDir = GUICtrlRead($input_14_01)
	Local $OutDir = GUICtrlRead($input_14_02)
	Local $p, $sDrive = "", $sDir = "", $sFilename = "", $sExtension = "", $i, $break, $InFile, $OutFile
	Local $iPathSplit, $oPathSplit, $iIndex, $aRow, $width, $br, $bitrate, $bit, $Recode = 0, $copy, $vRow
	Local $iRval, $query, $aResult, $iRows, $iColumns, $atracks, $ftracks, $stracks, $parameter, $codec

	IniWrite(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_wizard_audio_inputfolder", GUICtrlRead($input_14_01))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_wizard_audio_outputfolder", GUICtrlRead($input_14_02))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_audio_not_mp3", GUICtrlRead($check_14_61))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_audio_not_flac", GUICtrlRead($check_14_62))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_audio_not_wav", GUICtrlRead($check_14_63))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_audio_not_opus", GUICtrlRead($check_14_64))

	If GUICtrlRead($radio_14_11) = 1 Then IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_arecode_container", "mp3")
	If GUICtrlRead($radio_14_21) = 1 Then IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_arecode_container", "flac")
	If GUICtrlRead($radio_14_31) = 1 Then IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_arecode_container", "wav")
	If GUICtrlRead($radio_14_41) = 1 Then IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_arecode_container", "ogg")

	$ini_wizard_audio_outputfolder = IniRead(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_wizard_audio_outputfolder", @MyDocumentsDir)
	$ini_wizard_audio_inputfolder = IniRead(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_wizard_audio_inputfolder", @MyDocumentsDir)
	$ini_audio_not_flac = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_audio_not_flac", "1")
	$ini_audio_not_mp3 = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_audio_not_mp3", "1")
	$ini_audio_not_opus = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_audio_not_opus", "1")
	$ini_audio_not_wav = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_audio_not_wav", "4")
	$ini_arecode_container = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_arecode_container", "flac")

	_SetData($Select_Label_11, $lng_wizards & ":  " & $lng_audio & "- " & $lng_rework)

	_ClearGUI($Array_GUI_Elements_14)

	_ShowGUI($Array_FUNC_14)

	_ShowGUI($Array_FUNC_99)

	_SetLabel($label_f14_02, $lng_audio & "- " & $lng_rework & " -- " & $lng_workingon & " " & $InDir)

	_SetData($progressbar_f14_01, 0)

	_SetData($progressbar_f14_02, 0)

	$WorkArray = _FileListToArrayRec($InDir, StringReplace($aextstring, ",", ";"), 1, 1, 1, 1)

	If Not IsArray($WorkArray) Then

		MsgBox(0, "", $lng_nofiles)
		_LastModule()
		Return

	EndIf

	_FileListToDB($WorkArray, $InDir)

	Local $step1 = Round(99 / $WorkArray[0], 2)

	$p = 1

	_SetData($progressbar_f14_02, 1)

	_SetData($progressbar_f14_01, 0)

	For $i = 1 To $WorkArray[0]

		_MediaInfoAudio($InDir & "\" & $WorkArray[$i])

		_SetData($progressbar_f14_02, $p)

		_SQLite_QuerySingleRow(-1,"SELECT * FROM Music LIMIT 1;",$vRow)

		$AlbumArtist = StringReplace($vRow[0], '/', '-')
		$Artist = StringReplace($vRow[1], '/', '-')
		$Year = $vRow[5]
		$Album = $vRow[2]
		$Track = StringFormat("%02s", $vRow[4])
		$Title = $vRow[3]
		$Genre = $vRow[6]
		$Part = $vRow[7]

		If StringInStr($String_VariousArtists, $AlbumArtist) <> 0 Then

			$AlbumArtist = "Various Artists"

		EndIf

		If $AlbumArtist = "none" Then $AlbumArtist = $Artist

		If $AlbumArtist = "none" Then

			_WriteLog("Wizard_Audio - Warning: File " & $InDir & "\" & $WorkArray[$i] & " is not properly tagged and will not be processed")

		Else

			$PathSplit = _PathSplit($InDir & "\" & $WorkArray[$i], $sDrive, $sDir, $sFilename, $sExtension)

			$File = $PathSplit[1] & $PathSplit[2] & $PathSplit[3]

			$iIndex = _ArraySearch($json_Music_FileExtensions, StringReplace($PathSplit[4], ".", "*."), 0, 0, 0, 1)

			If $iIndex > -1 Then

				If $part > 0 Then

					$Output1 = StringReplace("{AlbumArtist}\" & $ini_Music_FolderStructure_MultipleDisc, "{AlbumArtist}", $AlbumArtist)

					$Output = StringReplace($Output1, "{Disc}", $ini_Music_Renaming_MultiDisc & " " & StringFormat("%02s", $vRow[7]))

				Else

					$Output = StringReplace("{AlbumArtist}\" & $ini_Music_FolderStructure, "{AlbumArtist}", $AlbumArtist)

				EndIf

				If StringInStr("{AlbumArtist}\" & $ini_Music_FolderStructure, "{AlbumArtist}") < 1 Then $Output = StringReplace("{AlbumArtist}\" & $ini_Music_FolderStructure, "{Artist}", $AlbumArtist)

				If $Year <> "0000" Then

					$Output1 = StringReplace($Output, "{Year}", $Year)

				Else

					$Output1 = StringReplace($Output, "{Year}", "1900")

				EndIf

				If $Album <> "none" Then

					$Output = StringReplace($Output1, "{Album}", $Album)

				Else

					$Output = StringReplace($Output1, "{Album}", "")

				EndIf

				If $Genre <> "none" Then

					$Output1 = StringReplace($Output, "{Genre}", $Genre)

				Else

					$Output1 = StringReplace($Output, "{Genre}", "")

				EndIf
				; Album Rename

				If StringInStr($String_VariousArtists, $AlbumArtist) <> 0 Then

					$TrackOut = StringReplace($ini_Music_Renaming_VariousArtists, "{Title}", $Title)

				Else

					$TrackOut = StringReplace($ini_Music_Renaming, "{Title}", $Title)

				EndIf

				$TrackOut1 = StringReplace($TrackOut, "{Track}", $Track)

				$TrackOut = StringReplace($TrackOut1, "{Artist}", $Artist)

				$TrackOut1 = StringReplace($TrackOut, "{Year}", $Year)

				$TrackOut = StringReplace($TrackOut1, "{Album}", $Album)

				$TrackOut1 = StringReplace($TrackOut, "{Genre}", $Genre)

				$Output = $OutDir & "\" & $Output1 & "\" & $TrackOut1 & $PathSplit[4]

				; Wizard Start

				$InFile = $InDir & "\" & $WorkArray[$i]

				$OutFile = $OutDir & "\" & $Output1 & "\" & $TrackOut1 & "." & $ini_arecode_container

				If GUICtrlRead($check_14_61) = 1 AND $PathSplit[4] = ".mp3" Then $OutFile = $OutDir & "\" & $Output1 & "\" & $TrackOut1 & ".mp3"

				If GUICtrlRead($check_14_62) = 1 AND $PathSplit[4] = ".flac" Then $OutFile = $OutDir & "\" & $Output1 & "\" & $TrackOut1 & ".flac"

				If GUICtrlRead($check_14_63) = 1 AND $PathSplit[4] = ".wav" Then $OutFile = $OutDir & "\" & $Output1 & "\" & $TrackOut1 & ".wav"

				If GUICtrlRead($check_14_64) = 1 AND $PathSplit[4] = ".ogg" Then $OutFile = $OutDir & "\" & $Output1 & "\" & $TrackOut1 & ".ogg"

				DirCreate($OutDir & "\" & $Output1)

				_WriteLog("Wizard_Audio - Started Working On: " & $InFile)

				_SetLabel($label02, $lng_workingon & "   " & $InFile)

				_WriteLog("Wizard_Audio - $InFile: " & $InFile & " - $OutFile: " & $OutFile)

				$break = 0

				If GUICtrlRead($check_14_61) = 1 AND $PathSplit[4] = ".mp3" Then

					FileCopy($InFile, $OutFile)

				ElseIf GUICtrlRead($check_14_62) = 1 AND $PathSplit[4] = ".flac" Then

					FileCopy($InFile, $OutFile)

				ElseIf GUICtrlRead($check_14_63) = 1 AND $PathSplit[4] = ".wav" Then

					FileCopy($InFile, $OutFile)

				ElseIf GUICtrlRead($check_14_64) = 1 AND $PathSplit[4] = ".ogg" Then

					FileCopy($InFile, $OutFile)

				Else

					$break = _RecodeAudioFile($InFile, $OutFile, $progressbar_f14_01, $button_f14_01, $WorkArray[0], $i)

				EndIf

				If Not $break = -1 Then  _WriteLog("Wizard_Audio - Finished Working On: " & $OutFile)

			EndIf

		EndIf

		If $break = 1 Then

			MsgBox(0, "", $lng_cancel, 3)

			ExitLoop

		EndIf

		$p = $p + $step1

	Next

	If Not $break = 1 Then

		$break = _GrabArtist($OutDir, $progressbar_f14_01)

	EndIf

	_SetData($progressbar_f14_02, 100)

	If NOT $break = 1 Then

		If GUICtrlRead($radio_f99_01) = "1" Then

			MsgBox(0, "", $lng_sucess, 3)

		EndIf

		If GUICtrlRead($radio_f99_02) = "1" Then

			IniWrite(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_audio_correction_inputfolder", $OutDir)

			_SetData($input_64_01, $OutDir)

			_GUI_Show_Corection()

			_GUI_Show_Audio_Correction()

			_Metadata_Correction_Audio()

		EndIf

	EndIf

	If GUICtrlRead($radio_f99_03) = "1" Then

		_Countdown()

	EndIf

	If GUICtrlRead($radio_f99_04) = "1" Then

		_Exit(2)

	EndIf

	If GUICtrlRead($radio_f99_05) = "1" Then

		_Exit(3)

	EndIf

	If GUICtrlRead($radio_f99_06) = "1" Then

		_Exit(4)

	EndIf

	_ClearGUI($Array_FUNC_14)

	_ClearGUI($Array_FUNC_99)

	_SetLabel($label02,$lng_waiting)

	_SetData($Select_Label_11, "")

	_LastModule()


EndFunc

;Function Movies Wizard
Func _Wizard_Movies()

	_WriteLog("Wizard_Movies - Started")

	Dim $WorkArray[1]
	Local $InDir = GUICtrlRead($input_12_01)
	Local $OutDir = GUICtrlRead($input_12_02)
	Local $p = 0, $sDrive = "", $sDir = "", $sFilename = "", $sExtension = "", $i, $break, $InFile, $OutFile
	Local $iPathSplit, $oPathSplit, $iIndex, $aRow, $width, $br, $bitrate, $bit, $Recode = 0,  $codec
	Local $iRval, $query, $aResult, $iRows, $iColumns, $atracks, $ftracks, $stracks, $parameter, $HRecode

	_SetData($Select_Label_11, $lng_wizards & ":  " & $lng_movies & "- " & $lng_rework)

	_SaveJSON()

	;Save settings to ini
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_wizard_movies_inputfolder", GUICtrlRead($input_12_01))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_wizard_movies_outputfolder", GUICtrlRead($input_12_02))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_useoptimizer", GUICtrlRead($check_90_01))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_useoptimizer_subs", GUICtrlRead($check_90_02))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_wizard_movies_refresh_nfo", GUICtrlRead($check_92_15))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_wizard_movies_refresh_gfx", GUICtrlRead($check_92_16))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_wizard_movies_bitrate_sd", GUICtrlRead($input_12_03))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_wizard_movies_bitrate_720", GUICtrlRead($input_12_04))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_wizard_movies_bitrate_1080", GUICtrlRead($input_12_05))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_wizard_movies_bitrate_4k", GUICtrlRead($input_12_06))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_tracksperlanguage_audio", GUICtrlRead($input_90_04))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_tracksperlanguage_forced", GUICtrlRead($input_90_05))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_tracksperlanguage_sub", GUICtrlRead($input_90_06))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_audiolanguages", GUICtrlRead($input_90_10))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_sublanguages", GUICtrlRead($input_90_11))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_recode_videocodec_SD", GUICtrlRead($combo_21_01))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_recode_videocodec_720", GUICtrlRead($combo_21_02))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_recode_videocodec_1080", GUICtrlRead($combo_21_04))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_recode_videocodec_4K", GUICtrlRead($combo_21_06))

	$ini_wizard_movies_outputfolder = IniRead(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_wizard_movies_outputfolder", @MyDocumentsDir)
	$ini_wizard_movies_inputfolder = IniRead(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_wizard_movies_inputfolder", @MyDocumentsDir)
	$ini_useoptimizer = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_useoptimizer", "1")
	$ini_useoptimizer_subs = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_useoptimizer_subs", "1")
	$ini_wizard_movies_bitrate_720 = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_wizard_movies_bitrate_720", "7000")
	$ini_wizard_movies_bitrate_1080 = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_wizard_movies_bitrate_1080", "12000")
	$ini_wizard_movies_bitrate_4k = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_wizard_movies_bitrate_4k", "20000")
	$ini_wizard_movies_bitrate_sd = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_wizard_movies_bitrate_sd", "2500")
	$ini_wizard_movies_refresh_gfx = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_wizard_movies_refresh_gfx", "0")
	$ini_wizard_movies_refresh_nfo = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_wizard_movies_refresh_nfo", "0")
	$ini_recode_videocodec_720 = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_recode_videocodec_720", "h264 AVC")
	$ini_recode_videocodec_1080 = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_recode_videocodec_1080", "h264 AVC")
	$ini_recode_videocodec_4K = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_recode_videocodec_4K", "h265 HEVC")
	$ini_recode_videocodec_SD = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_recode_videocodec_SD", "h264 AVC")
	$ini_tracksperlanguage_audio = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_tracksperlanguage_audio", "1")
	$ini_tracksperlanguage_forced = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_tracksperlanguage_forced", "1")
	$ini_tracksperlanguage_sub = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_tracksperlanguage_sub", "0")
	$ini_audiolanguages = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_audiolanguages", "en")
	$ini_sublanguages = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_sublanguages", "en")

	_ClearGUI($Array_GUI_Elements_12)

	_ShowGUI($Array_FUNC_12)

	_ShowGUI($Array_FUNC_99)

	_SetLabel($label_f12_02, $lng_movies & "- " & $lng_rework & " -- " & $lng_workingon & " " & $InDir)

	_SetData($progressbar_f12_01, 0)

	_SetData($progressbar_f12_02, 0)


	$WorkArray = _FileListToArrayRec($InDir, $extstring2, 1, 1, 1)

	If Not IsArray($WorkArray) Then

		MsgBox(0, "", $lng_nofiles)
		_LastModule()
		Return

	EndIf

	_FileListToDB($WorkArray, $InDir)

	For $i = 1 To $WorkArray[0]

		Sleep(25)

		$skip = _MediaInfo($InDir & "\" & $WorkArray[$i])

		If Not $skip = "skip" Then

			$count = 0

			$iPathSplit = _PathSplit($InDir & "\" & $WorkArray[$i], $sDrive, $sDir, $sFilename, $sExtension)

			$InFile = StringReplace($InDir & "\" & $WorkArray[$i], "'", "\'")

			$oPathSplit = _PathSplit($OutDir & "\" & $WorkArray[$i], $sDrive, $sDir, $sFilename, $sExtension)

			$OutFile = StringReplace($oPathSplit[1] & $oPathSplit[2] & $oPathSplit[3] & ".mkv", "'", "\'")

			DirCreate($oPathSplit[1] & $oPathSplit[2])

			$iIndex = StringInStr($extstring2, StringReplace($iPathSplit[4], ".", ""))

			If $iIndex > -1 Then

				_WriteLog("Wizard_Movies - Started Working On: " & $InFile)

				_SetLabel($label_f12_03, $lng_files & " "  & $i & " -- " & $WorkArray[0] & ": " & $WorkArray[$i])

				_SetLabel($label02, $lng_workingon & "   " & $InFile)

				$break = 0

				$p = 0

				$audiocode = 0

			   If $ini_transcode_allaudio = 1 Then

   				  $query = "SELECT Format FROM Audio;"

				   $iRval = _SQLite_GetTable(-1, $query, $aResult, $iRows, $iColumns)

				   _SQLite_QueryFinalize($iRval)

					 If $aResult[0] > 1 Then

						For $j = 2 To $aResult[0]

						  If _ArraySearch($ArrayAudioWhitelist, $aResult[$j]) > -1 Then

							  $audiocode = 0

						  Else

							  $audiocode = 1

						  EndIf

						Next

					 EndIf

			   EndIf

			   If $ini_audio_normalize = 1 Then $audiocode = 1

				_SQLite_QuerySingleRow(-1,"SELECT * FROM Video LIMIT 1;",$aRow)

				$width = $aRow[5]

				If $width < 900 Then

					$br = $ini_wizard_movies_bitrate_sd

					$codec = $ini_recode_videocodec_SD

				EndIf

				If $width > 899 And $width < 1400 Then

					$br = $ini_wizard_movies_bitrate_720

					$codec = $ini_recode_videocodec_720

				EndIf

				If $width > 1399 And $width < 2800 Then

					$br = $ini_wizard_movies_bitrate_1080

					$codec = $ini_recode_videocodec_1080

				EndIf

				If $width > 2799 Then

					$br = $ini_wizard_movies_bitrate_4k

					$codec = $ini_recode_videocodec_4K

				EndIf

				$bit = StringReplace($aRow[4]," ", "")

				$bitrate = Number($bit) / 1024

				$Recode = 0

				If $ini_transcode_all = 1 Then

					If _ArraySearch($ArrayVideoWhitelist, $aRow[2]) > -1 Then

						$Recode = 0

					Else

						$Recode = 1

					EndIf

				EndIf

				If $bitrate = 0 And $ini_zerocode = 1 Then $Recode = 1

				If $bitrate > $br Then $Recode = 1

				If $Recode = 1 Then

					$break = _RecodeFile($InFile, $OutFile, $codec, $button_f12_01, $progressbar_f12_02, $progressbar_f12_01, $WorkArray[0], $i)

				Else

					 If $audiocode = 1 Then

						$audioonlycode = 1

						$break = _RecodeFile($InFile, $OutFile, $codec, $button_f12_01, $progressbar_f12_02, $progressbar_f12_01, $WorkArray[0], $i)

					 Else

						$query = "SELECT ID FROM Text Where Forced LIKE 'No';"

						$iRval = _SQLite_GetTable(-1, $query, $aResult, $iRows, $iColumns)

						_SQLite_QueryFinalize($iRval)

						$stracks = $iRows

						$query = "SELECT ID FROM Text Where Forced LIKE 'YES';"

						$iRval = _SQLite_GetTable(-1, $query, $aResult, $iRows, $iColumns)

						_SQLite_QueryFinalize($iRval)

						$ftracks = $iRows

						$query = "SELECT ID FROM Audio;"

						$iRval = _SQLite_GetTable(-1, $query, $aResult, $iRows, $iColumns)

						_SQLite_QueryFinalize($iRval)

						$atracks = $iRows

						If int($atracks) > $ini_tracksperlanguage_audio Then $p = $p + 1
						If int($ftracks) > $ini_tracksperlanguage_forced Then $p = $p + 1
						If int($stracks) > $ini_tracksperlanguage_sub Then $p = $p + 1
						If $ini_useoptimizer = 4 And $ini_useoptimizer_subs = 4 Then $p = 0

						If $p = 0 And ( StringLower($iPathSplit[4]) = ".mkv" Or StringLower($iPathSplit[4]) = ".mk3d" ) Then

						   $parameter = $progressbar_f12_02 & "|" & $iPathSplit[3]& "|" & $progressbar_f12_01 & "|" & $WorkArray[0] & "|" & $i

						   _Timer_SetTimer($Mainwindow)

						   $timer = _Timer_Init()

						   $break = _LargeFileCopy($InDir & "\" & $WorkArray[$i], $OutDir & "\" & $WorkArray[$i], BitOR(1, 2, 16, 64, 128, 256, 512), 2097152, $CALG_MD5, "_SetCopyProgress", $parameter, $button_f11_01)

						   _Timer_KillAllTimers($Mainwindow)

						Else

						   $break = _RemuxFile($InFile, $OutFile, $button_f12_01, $progressbar_f12_02, $progressbar_f12_01, $WorkArray[0], $i)

						EndIf

					 EndIf

				EndIf

				If Not $break = - 1 Then _WriteLog("Wizard_Movies - Finished Working On: " & $OutFile)

			EndIf

			If $break = 1 Then ExitLoop

			If $ini_KeepFileDate = "1" Then _SetTimeSegment($InDir & "\" & $WorkArray[$i], $OutDir & "\" & $WorkArray[$i])

		Else

			_WriteLog("Error - Could Not Process File: " & $InFile)

			Return -1

		EndIf

		$audioonlycode = 0

	Next

	_CopyStubs($InDir, $Outdir)

	GUICtrlSetState($progressbar_f12_01,$GUI_HIDE)

	_SetLabel($label_f12_02, $lng_movies & "- " & $lng_rework & " -- " & $lng_workingon & " " & $lng_metadata)

	If Not $break = 1 Then

		$break = _nfo4HTPC($OutDir, $progressbar_f12_02, $label_f12_03, $button_f12_01, "movies")

	EndIf

	If Not $break = 1 Then

		If $ini_tagging = "1" Then _TagMovies($OutDir)

	EndIf

	_WriteLog("Wizard_Movies - Finished")

	If GUICtrlRead($radio_f99_01) = "1" Then

		MsgBox(0, "", $lng_sucess, 3)

	EndIf

	If GUICtrlRead($radio_f99_02) = "1" Then

		IniWrite(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_movies_correction_inputfolder", $OutDir)

		_SetData($input_62_01, $OutDir)

		_GUI_Show_Corection()

		_GUI_Show_Movies_Correction()

		_Metadata_Correction_Movies()

	EndIf

	If GUICtrlRead($radio_f99_03) = "1" Then

		_Countdown()

	EndIf

	If GUICtrlRead($radio_f99_04) = "1" Then

		_Exit(2)

	EndIf

	If GUICtrlRead($radio_f99_05) = "1" Then

		_Exit(3)

	EndIf

	If GUICtrlRead($radio_f99_06) = "1" Then

		_Exit(4)

	EndIf

	_ClearGUI($Array_FUNC_12)

	_ClearGUI($Array_FUNC_99)

	_SetLabel($label02,$lng_waiting)

	_SetData($Select_Label_11, "")

	_LastModule()

	Return

EndFunc

;Function Series Wizard
Func _Wizard_Series()

	_WriteLog("Wizard_Series - Started")

	Local $WorkArray[1]
	Local $InDir = GUICtrlRead($input_11_01)
	Local $OutDir = GUICtrlRead($input_11_02)
	Local $p = 0, $sDrive = "", $sDir = "", $sFilename = "", $sExtension = "", $i, $break, $InFile, $OutFile, $j
	Local $iPathSplit, $oPathSplit, $iIndex, $aRow, $width, $br, $bitrate, $bit, $Recode = 0, $HRecode = 0
	Local $iRval, $query, $aResult, $iRows, $iColumns, $atracks, $ftracks, $stracks, $codec, $audiocode

	_SetData($Select_Label_11, $lng_wizards & ":  " & $lng_series & "- " & $lng_rework)

	_SaveJSON()

	;Save settings to ini
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_wizard_series_inputfolder", GUICtrlRead($input_11_01))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_wizard_series_outputfolder", GUICtrlRead($input_11_02))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_useoptimizer", GUICtrlRead($check_90_01))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_useoptimizer_subs", GUICtrlRead($check_90_02))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_wizard_series_refresh_nfo", GUICtrlRead($check_92_06))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_wizard_series_refresh_gfx", GUICtrlRead($check_92_05))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_wizard_series_bitrate_sd", GUICtrlRead($input_11_03))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_wizard_series_bitrate_720", GUICtrlRead($input_11_04))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_wizard_series_bitrate_1080", GUICtrlRead($input_11_05))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_wizard_series_bitrate_4k", GUICtrlRead($input_11_06))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_tracksperlanguage_audio", GUICtrlRead($input_90_04))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_tracksperlanguage_forced", GUICtrlRead($input_90_05))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_tracksperlanguage_sub", GUICtrlRead($input_90_06))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_audiolanguages", GUICtrlRead($input_90_10))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_sublanguages", GUICtrlRead($input_90_11))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_recode_videocodec_SD", GUICtrlRead($combo_21_01))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_recode_videocodec_720", GUICtrlRead($combo_21_02))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_recode_videocodec_1080", GUICtrlRead($combo_21_04))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_recode_videocodec_4K", GUICtrlRead($combo_21_06))
;~ 	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_transcode_hdr", GUICtrlRead($check_52_14))

	$ini_wizard_series_outputfolder = IniRead(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_wizard_series_outputfolder", @MyDocumentsDir)
	$ini_wizard_series_inputfolder = IniRead(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_wizard_series_inputfolder", @MyDocumentsDir)
	$ini_useoptimizer = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_useoptimizer", "1")
	$ini_useoptimizer_subs = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_useoptimizer_subs", "1")
	$ini_wizard_series_bitrate_720 = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_wizard_series_bitrate_720", "6000")
	$ini_wizard_series_bitrate_1080 = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_wizard_series_bitrate_1080", "10000")
	$ini_wizard_series_bitrate_4k = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_wizard_series_bitrate_4k", "20000")
	$ini_wizard_series_bitrate_sd = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_wizard_series_bitrate_sd", "2000")
	$ini_wizard_series_refresh_gfx = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_wizard_series_refresh_gfx", "0")
	$ini_wizard_series_refresh_nfo = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_wizard_series_refresh_nfo", "0")
	$ini_recode_videocodec_720 = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_recode_videocodec_720", "h264 AVC")
	$ini_recode_videocodec_1080 = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_recode_videocodec_1080", "h264 AVC")
	$ini_recode_videocodec_4K = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_recode_videocodec_4K", "h265 HEVC")
	$ini_recode_videocodec_SD = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_recode_videocodec_SD", "h264 AVC")
	$ini_tracksperlanguage_audio = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_tracksperlanguage_audio", "1")
	$ini_tracksperlanguage_forced = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_tracksperlanguage_forced", "1")
	$ini_tracksperlanguage_sub = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_tracksperlanguage_sub", "0")
	$ini_audiolanguages = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_audiolanguages", "en")
	$ini_sublanguages = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_sublanguages", "en")

	_ClearGUI($Array_GUI_Elements_11)

	_ShowGUI($Array_FUNC_11)

	_ShowGUI($Array_FUNC_99)

	_SetLabel($label_f11_02, $lng_series & "- " & $lng_rework & " -- " & $lng_workingon & " " & $InDir)

	_SetData($progressbar_f11_01, 0)

	_SetData($progressbar_f11_02, 0)

	$WorkArray = _FileListToArrayRec($InDir, $extstring, 1, 1, 1)

	If Not IsArray($WorkArray) Then

		MsgBox(0, "", $lng_nofiles)
		_LastModule()
		Return

	EndIf

	_FileListToDB($WorkArray, $InDir)


	For $i = 1 To $WorkArray[0]

		Sleep(25)

		_WriteLog("Wizard_Series - Send File to MediaInfo: " & $WorkArray[$i])

		$skip = _MediaInfo($InDir & "\" & $WorkArray[$i])

		If Not $skip = "skip" Then

			$count = 0

			$iPathSplit = _PathSplit($InDir & "\" & $WorkArray[$i], $sDrive, $sDir, $sFilename, $sExtension)

			$InFile = StringReplace($InDir & "\" & $WorkArray[$i], "'", "\'")

			$oPathSplit = _PathSplit($OutDir & "\" & $WorkArray[$i], $sDrive, $sDir, $sFilename, $sExtension)

			$OutFile = StringReplace($oPathSplit[1] & $oPathSplit[2] & $oPathSplit[3] & ".mkv", "'", "\'")

			DirCreate($oPathSplit[1] & $oPathSplit[2])

			$iIndex = StringInStr($extstring2, StringReplace($iPathSplit[4], ".", ""))

			If $iIndex > -1 Then

				_WriteLog("Wizard_Series - Started Working On: " & $InFile)

				_SetLabel($label_f11_03, $lng_files & " "  & $i & " -- " & $WorkArray[0] & ": " & $WorkArray[$i])

				_SetLabel($label02, $lng_workingon & "   " & $InFile)

				$break = 0

				$p = 0

			   If $ini_transcode_allaudio = 1 Then

   				  $query = "SELECT Format FROM Audio;"

				   $iRval = _SQLite_GetTable(-1, $query, $aResult, $iRows, $iColumns)

				   _SQLite_QueryFinalize($iRval)

					 If $aResult[0] > 1 Then

						For $j = 2 To $aResult[0]

						  If _ArraySearch($ArrayAudioWhitelist, $aResult[$j]) > -1 Then

							  $audiocode = 0

						  Else

							  $audiocode = 1

						  EndIf

						Next

					 EndIf

			   EndIf

			   If $ini_audio_normalize = 1 Then $audiocode = 1


				_SQLite_QuerySingleRow(-1,"SELECT * FROM Video LIMIT 1;",$aRow)

				$width = $aRow[5]

				If $width < 900 Then

					$br = $ini_wizard_series_bitrate_sd

					$codec = $ini_recode_videocodec_SD

				EndIf

				If $width > 899 And $width < 1400 Then

					$br = $ini_wizard_series_bitrate_720

					$codec = $ini_recode_videocodec_720

				EndIf

				If $width > 1399 And $width < 2800 Then

					$br = $ini_wizard_series_bitrate_1080

					$codec = $ini_recode_videocodec_1080

				EndIf

				If $width > 2800 Then

					$br = $ini_wizard_series_bitrate_4k

					$codec = $ini_recode_videocodec_4K

				EndIf

				$bit = StringReplace($aRow[4]," ", "")

				$bitrate = Number($bit) / 1024

				$Recode = 0

				If $ini_transcode_all = 1 Then

					If _ArraySearch($ArrayVideoWhitelist, $aRow[2]) > -1 Then

						$Recode = 0

					Else

						$Recode = 1

					EndIf

				EndIf

				If $bitrate = 0 And $ini_zerocode = 1 Then $Recode = 1

				If $bitrate > $br Then $Recode = 1

				If $Recode = 1 Then

					$break = _RecodeFile($InFile, $OutFile, $codec, $button_f11_01, $progressbar_f11_02, $progressbar_f11_01, $WorkArray[0], $i)

				Else

					 If $audiocode = 1 Then

						$audioonlycode = 1

						$break = _RecodeFile($InFile, $OutFile, $codec, $button_f11_01, $progressbar_f11_02, $progressbar_f11_01, $WorkArray[0], $i)

					 Else

						$query = "SELECT ID FROM Text Where Forced LIKE 'No';"

						$iRval = _SQLite_GetTable(-1, $query, $aResult, $iRows, $iColumns)

						_SQLite_QueryFinalize($iRval)

						$stracks = $iRows

						$query = "SELECT ID FROM Text Where Forced LIKE 'YES';"

						$iRval = _SQLite_GetTable(-1, $query, $aResult, $iRows, $iColumns)

						_SQLite_QueryFinalize($iRval)

						$ftracks = $iRows

						$query = "SELECT ID FROM Audio;"

						$iRval = _SQLite_GetTable(-1, $query, $aResult, $iRows, $iColumns)

						_SQLite_QueryFinalize($iRval)

						$atracks = $iRows

						If int($atracks) > $ini_tracksperlanguage_audio Then $p = $p + 1
						If int($ftracks) > $ini_tracksperlanguage_forced Then $p = $p + 1
						If int($stracks) > $ini_tracksperlanguage_sub Then $p = $p + 1
						If $ini_useoptimizer = 4 And $ini_useoptimizer_subs = 4 Then $p = 0

						If $p = 0 And ( StringLower($iPathSplit[4]) = ".mkv" Or StringLower($iPathSplit[4]) = ".mk3d" ) Then

						   $parameter = $progressbar_f11_02 & "|" & $iPathSplit[3]& "|" & $progressbar_f11_01 & "|" & $WorkArray[0] & "|" & $i

						   _Timer_SetTimer($Mainwindow)

						   $timer = _Timer_Init()

						   $break = _LargeFileCopy($InDir & "\" & $WorkArray[$i], $OutDir & "\" & $WorkArray[$i], BitOR(1, 2, 16, 64, 128, 256, 512), 2097152, $CALG_MD5, "_SetCopyProgress", $parameter, $button_f11_01)

						   _Timer_KillAllTimers($Mainwindow)

						Else

						   $break = _RemuxFile($InFile, $OutFile, $button_f11_01, $progressbar_f11_02, $progressbar_f11_01, $WorkArray[0], $i)

						EndIf

					 EndIf

				EndIf

				If Not $break = -1 Then _WriteLog("Wizard_Series - Finished Working On: " & $OutFile)

			EndIf

			If $break = 1 Then ExitLoop

			If $ini_KeepFileDate = "1" Then _SetTimeSegment($InDir & "\" & $WorkArray[$i], $OutDir & "\" & $WorkArray[$i])


		Else

			_WriteLog("Error - Could Not Process File: " & $InFile)

			Return -1

		EndIf

		$audioonlycode = 0

	Next

	_CopyStubs($InDir, $Outdir)

	GUICtrlSetState($progressbar_f11_01,$GUI_HIDE)

	_SetLabel($label_f11_02, $lng_series & "- " & $lng_rework & " -- " & $lng_workingon & " " & $lng_metadata)

	If Not $break = 1 Then

		$break = _nfo4HTPC($OutDir, $progressbar_f11_02, $label_f11_03, $button_f11_01, "series")

	EndIf

	If $ini_gen_folder = 1 Then	_make_season_folder($OutDir)

	_WriteLog("Wizard_Series - Finished")

	If GUICtrlRead($radio_f99_01) = "1" Then

		MsgBox(0, "", $lng_sucess, 3)

	EndIf

	If GUICtrlRead($radio_f99_02) = "1" Then

		IniWrite(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_series_correction_inputfolder", $OutDir)

		_SetData($input_61_01, $OutDir)

		_GUI_Show_Corection()

		_GUI_Show_Series_Correction()

		_Metadata_Correction_Series()

	EndIf

	If GUICtrlRead($radio_f99_03) = "1" Then

		_Countdown()

	EndIf

	If GUICtrlRead($radio_f99_04) = "1" Then

		_Exit(2)

	EndIf

	If GUICtrlRead($radio_f99_05) = "1" Then

		_Exit(3)

	EndIf

	If GUICtrlRead($radio_f99_06) = "1" Then

		_Exit(4)

	EndIf

	_ClearGUI($Array_FUNC_11)

	_ClearGUI($Array_FUNC_99)

	_SetLabel($label02,$lng_waiting)

	_SetData($Select_Label_11, "")

	_LastModule()

	$audioonlycode = 0

	Return

EndFunc

;Function Videos Wizard
Func _Wizard_Videos()

	_WriteLog("Wizard_Videos - Started")

	Dim $WorkArray[1]
	Local $InDir = GUICtrlRead($input_13_01)
	Local $OutDir = GUICtrlRead($input_13_02)
	Local $p = 0, $sDrive = "", $sDir = "", $sFilename = "", $sExtension = "", $i, $break, $InFile, $OutFile
	Local $iPathSplit, $oPathSplit, $iIndex, $aRow, $width, $br, $bitrate, $bit, $Recode = 0, $j, $HRecode
	Local $iRval, $query, $aResult, $iRows, $iColumns, $atracks, $ftracks, $stracks, $parameter, $codec

	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_useoptimizer", GUICtrlRead($check_90_01))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_useoptimizer_subs", GUICtrlRead($check_90_02))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_wizard_videos_inputfolder", GUICtrlRead($input_13_01))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_wizard_videos_outputfolder", GUICtrlRead($input_13_02))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_wizard_videos_bitrate_sd", GUICtrlRead($input_13_03))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_wizard_videos_bitrate_720", GUICtrlRead($input_13_04))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_wizard_videos_bitrate_1080", GUICtrlRead($input_13_05))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_wizard_videos_bitrate_4k", GUICtrlRead($input_13_06))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_tracksperlanguage_audio", GUICtrlRead($input_90_04))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_tracksperlanguage_forced", GUICtrlRead($input_90_05))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_tracksperlanguage_sub", GUICtrlRead($input_90_06))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_fanart_design", GUICtrlRead($combo_95_01))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_fanart_font", GUICtrlRead($combo_95_02))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_fanart_covertemplate", GUICtrlRead($combo_95_03))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_fanart_backdroptemplate", GUICtrlRead($combo_95_04))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_fanart_bordertemplate", GUICtrlRead($combo_95_05))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_fanart_bordercolor", GUICtrlRead($input_95_07))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_fanart_plot", GUICtrlRead($edit_95_01))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_fanart_genre", GUICtrlRead($input_95_08))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_audiolanguages", GUICtrlRead($input_90_10))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_sublanguages", GUICtrlRead($input_90_11))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_fanart_nocover", GUICtrlRead($check_95_01))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_fanart_nobackdrop", GUICtrlRead($check_95_02))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_fanart_nonfo", GUICtrlRead($check_95_03))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_recode_videocodec_SD", GUICtrlRead($combo_21_01))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_recode_videocodec_720", GUICtrlRead($combo_21_02))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_recode_videocodec_1080", GUICtrlRead($combo_21_04))
	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_recode_videocodec_4K", GUICtrlRead($combo_21_06))

	$ini_wizard_videos_after = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_wizard_videos_after", "4")
	$ini_wizard_videos_bitrate_720 = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_wizard_videos_bitrate_720", "6000")
	$ini_wizard_videos_bitrate_1080 = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_wizard_videos_bitrate_1080", "10000")
	$ini_wizard_videos_bitrate_4k = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_wizard_videos_bitrate_4k", "20000")
	$ini_wizard_videos_bitrate_sd = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_wizard_videos_bitrate_sd", "2000")
	$ini_tracksperlanguage_audio = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_tracksperlanguage_audio", "1")
	$ini_tracksperlanguage_forced = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_tracksperlanguage_forced", "1")
	$ini_tracksperlanguage_sub = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_tracksperlanguage_sub", "0")
	$ini_useoptimizer = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_useoptimizer", "1")
	$ini_useoptimizer_subs = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_useoptimizer_subs", "1")
	$ini_recode_videocodec_720 = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_recode_videocodec_720", "h264 AVC")
	$ini_recode_videocodec_1080 = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_recode_videocodec_1080", "h264 AVC")
	$ini_recode_videocodec_4K = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_recode_videocodec_4K", "h265 HEVC")
	$ini_recode_videocodec_SD = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_recode_videocodec_SD", "h264 AVC")
	$ini_fanart_backgroundtemplate = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_fanart_backdroptemplate", "---------")
	$ini_fanart_bordercolor = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_fanart_bordercolor", "IndianRed4")
	$ini_fanart_bordertemplate = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_fanart_bordertemplate", "---------")
	$ini_fanart_covertemplate = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_fanart_covertemplate", "---------")
	$ini_fanart_design = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_fanart_design", "1-6")
	$ini_fanart_font = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_fanart_font", "Comic-Sans-MS-Bold")
	$ini_fanart_genre = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_fanart_genre", "")
	$ini_fanart_genrefolder = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_fanart_genrefolder", "1")
	$ini_fanart_mediainfo = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_fanart_mediainfo", "1")
	$ini_fanart_nobackdrop = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_fanart_nobackdrop", "4")
	$ini_fanart_nocover = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_fanart_nocover", "4")
	$ini_fanart_nonfo = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_fanart_nonfo", "4")
	$ini_fanart_plot = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_fanart_plot", "")

	_SetData($Select_Label_11, $lng_wizards & ":  " & $lng_video & "- " & $lng_rework)

	_ClearGUI($Array_GUI_Elements_13)

	_ShowGUI($Array_FUNC_13)

	_ShowGUI($Array_FUNC_99)

	_SetLabel($label_f13_02, $lng_video & "- " & $lng_rework & " -- " & $lng_workingon & " " & $InDir)

	_SetData($progressbar_f13_01, 0)

	_SetData($progressbar_f13_02, 0)

	$WorkArray = _FileListToArrayRec($InDir, $extstring, 1, 1, 1)

	If Not IsArray($WorkArray) Then

		MsgBox(0, "", $lng_nofiles)
		_LastModule()
		Return

	EndIf

	_FileListToDB($WorkArray, $InDir)

	For $i = 1 To $WorkArray[0]

		Sleep(25)

		$skip = _MediaInfo($InDir & "\" & $WorkArray[$i])

		If Not $skip = "skip" Then

			$count = 0

			$iPathSplit = _PathSplit($InDir & "\" & $WorkArray[$i], $sDrive, $sDir, $sFilename, $sExtension)

			$InFile = StringReplace($InDir & "\" & $WorkArray[$i], "'", "\'")

			$oPathSplit = _PathSplit($OutDir & "\" & $WorkArray[$i], $sDrive, $sDir, $sFilename, $sExtension)

			$OutFile = StringReplace($oPathSplit[1] & $oPathSplit[2] & $oPathSplit[3] & ".mkv", "'", "\'")

			DirCreate($oPathSplit[1] & $oPathSplit[2])

			$iIndex = StringInStr($extstring2, StringReplace($iPathSplit[4], ".", ""))

			If $iIndex > -1 Then

				_WriteLog("Wizard_Videos - Started Working On: " & $InFile)

				_SetLabel($label_f13_03, $lng_files & " "  & $i & " -- " & $WorkArray[0] & ": " & $WorkArray[$i])

				_SetLabel($label02, $lng_workingon & "   " & $InFile)

				$break = 0

				$p = 0

			   If $ini_transcode_allaudio = 1 Then

   				  $query = "SELECT Format FROM Audio;"

				   $iRval = _SQLite_GetTable(-1, $query, $aResult, $iRows, $iColumns)

				   _SQLite_QueryFinalize($iRval)

					 If $aResult[0] > 1 Then

						For $j = 2 To $aResult[0]

						  If _ArraySearch($ArrayAudioWhitelist, $aResult[$j]) > -1 Then

							  $audiocode = 0

						  Else

							  $audiocode = 1

						  EndIf

						Next

					 EndIf

			   EndIf

			   If $ini_audio_normalize = 1 Then $audiocode = 1

				_SQLite_QuerySingleRow(-1,"SELECT * FROM Video LIMIT 1;",$aRow)

				$width = $aRow[5]

				If $width < 900 Then

					$br = $ini_wizard_videos_bitrate_sd

					$codec = $ini_recode_videocodec_SD

				EndIf

				If $width > 899 And $width < 1400 Then

					$br = $ini_wizard_videos_bitrate_720

					$codec = $ini_recode_videocodec_720

				EndIf

				If $width > 1399 And $width < 2800 Then

					$br = $ini_wizard_videos_bitrate_1080

					$codec = $ini_recode_videocodec_1080

				EndIf

				If $width > 2800 Then

					$br = $ini_wizard_videos_bitrate_4k

					$codec = $ini_recode_videocodec_4K

				EndIf

				$bit = StringReplace($aRow[4]," ", "")

				$bitrate = Number($bit) / 1024

				$Recode = 0

				If $ini_transcode_all = 1 Then

					If _ArraySearch($ArrayVideoWhitelist, $aRow[2]) > -1 Then

						$Recode = 0

					Else

						$Recode = 1

					EndIf

				EndIf

				If $bitrate = 0 And $ini_zerocode = 1 Then $Recode = 1

				If $bitrate > $br Then $Recode = 1

				If $Recode = 1 Then

					$break = _RecodeFile($InFile, $OutFile, $codec, $button_f13_01, $progressbar_f13_02, $progressbar_f13_01, $WorkArray[0], $i)

				Else

					 If $audiocode = 1 Then

						$audioonlycode = 1

						$break = _RecodeFile($InFile, $OutFile, $codec, $button_f13_01, $progressbar_f13_02, $progressbar_f13_01, $WorkArray[0], $i)

					 Else

						$query = "SELECT ID FROM Text Where Forced LIKE 'No';"

						$iRval = _SQLite_GetTable(-1, $query, $aResult, $iRows, $iColumns)

						_SQLite_QueryFinalize($iRval)

						$stracks = $iRows

						$query = "SELECT ID FROM Text Where Forced LIKE 'YES';"

						$iRval = _SQLite_GetTable(-1, $query, $aResult, $iRows, $iColumns)

						_SQLite_QueryFinalize($iRval)

						$ftracks = $iRows

						$query = "SELECT ID FROM Audio;"

						$iRval = _SQLite_GetTable(-1, $query, $aResult, $iRows, $iColumns)

						_SQLite_QueryFinalize($iRval)

						$atracks = $iRows

						If int($atracks) > $ini_tracksperlanguage_audio Then $p = $p + 1
						If int($ftracks) > $ini_tracksperlanguage_forced Then $p = $p + 1
						If int($stracks) > $ini_tracksperlanguage_sub Then $p = $p + 1
						If $ini_useoptimizer = 4 And $ini_useoptimizer_subs = 4 Then $p = 0

						If $p = 0 And ( StringLower($iPathSplit[4]) = ".mkv" Or StringLower($iPathSplit[4]) = ".mk3d" ) Then

						   $parameter = $progressbar_f13_02 & "|" & $iPathSplit[3]& "|" & $progressbar_f13_01 & "|" & $WorkArray[0] & "|" & $i

						   _Timer_SetTimer($Mainwindow)

						   $timer = _Timer_Init()

						   $break = _LargeFileCopy($InDir & "\" & $WorkArray[$i], $OutDir & "\" & $WorkArray[$i], BitOR(1, 2, 16, 64, 128, 256, 512), 2097152, $CALG_MD5, "_SetCopyProgress", $parameter, $button_f11_01)

						   _Timer_KillAllTimers($Mainwindow)

						Else

						   $break = _RemuxFile($InFile, $OutFile, $button_f13_01, $progressbar_f13_02, $progressbar_f13_01, $WorkArray[0], $i)

						EndIf

					 EndIf

				EndIf

				If Not $break = 1 Then

					_MakeFanart($oPathSplit[1] & $oPathSplit[2] & $oPathSplit[3] & ".mkv", $OutDir, $progressbar_f13_02, $progressbar_f13_01, $WorkArray[0], $i)

					If $ini_KeepFileDate = "1" Then

						_SetTimeSegment($InFile, $oPathSplit[1] & $oPathSplit[2] & $oPathSplit[3] & ".mkv")

					EndIf

				EndIf

				If Not $break = - 1 Then _WriteLog("wizard_movies - Finished Working On: " & $OutFile)

			EndIf

			If $break = 1 Then ExitLoop

			If $ini_KeepFileDate = "1" Then _SetTimeSegment($InDir & "\" & $WorkArray[$i], $OutDir & "\" & $WorkArray[$i])

		Else

			_WriteLog("Error - Could Not Process File: " & $InFile)

;~ 			Return -1

		EndIf

		$audioonlycode = 0

	Next

	GUICtrlSetState($progressbar_f13_01,$GUI_HIDE)

	_SetLabel($label_f13_02, $lng_video & "- " & $lng_rework & " -- " & $lng_workingon & " " & $lng_metadata)

	_WriteLog("Wizard_Videos - Finished")

	If GUICtrlRead($radio_f99_01) = "1" Then

		MsgBox(0, "", $lng_sucess, 3)

	EndIf

	If GUICtrlRead($radio_f99_02) = "1" Then

		IniWrite(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_videos_correction_inputfolder", $OutDir)

		_SetData($input_63_01, $OutDir)

		_GUI_Show_Corection()

		_GUI_Show_Videos_Correction()

		_Metadata_Correction_Videos()


	EndIf

	If GUICtrlRead($radio_f99_03) = "1" Then

		_Countdown()

	EndIf

	If GUICtrlRead($radio_f99_04) = "1" Then

		_Exit(2)

	EndIf

	If GUICtrlRead($radio_f99_05) = "1" Then

		_Exit(3)

	EndIf

	If GUICtrlRead($radio_f99_06) = "1" Then

		_Exit(4)

	EndIf

	_ClearGUI($Array_FUNC_13)

	_ClearGUI($Array_FUNC_99)

	_SetLabel($label02,$lng_waiting)

	_SetData($Select_Label_11, "")

	_LastModule()

	Return

EndFunc

#EndRegion ;Special Functions

#Region ;Afterwork GUI Functions

; Function To Show Series Correction GUI (100)
Func _GUI_Show_Corection_Series()

	_ClearGUI($Array_GUI_Elements_110)
	_ClearGUI($Array_GUI_Elements_120)
	_ClearGUI($Array_GUI_Elements_121)
	_ClearGUI($Array_GUI_Elements_122)
	_ClearGUI($Array_GUI_Elements_123)
	_ClearGUI($Array_GUI_Elements_130)
	_ClearGUI($Array_GUI_Elements_140)
	_ClearGUI($Array_GUI_Elements_150)

	_ShowGUI($Array_GUI_Elements_100)

EndFunc

; Function To Show Episodes Correction GUI (110)
Func _GUI_Show_Corection_Episodes()

	_ClearGUI($Array_GUI_Elements_100)
	_ClearGUI($Array_GUI_Elements_120)
	_ClearGUI($Array_GUI_Elements_121)
	_ClearGUI($Array_GUI_Elements_122)
	_ClearGUI($Array_GUI_Elements_123)
	_ClearGUI($Array_GUI_Elements_130)
	_ClearGUI($Array_GUI_Elements_140)
	_ClearGUI($Array_GUI_Elements_150)

	_ShowGUI($Array_GUI_Elements_110)

EndFunc

; Function To Show Movies Correction GUI (120)
Func _GUI_Show_Corection_Movies()

	_ClearGUI($Array_GUI_Elements_100)
	_ClearGUI($Array_GUI_Elements_110)
	_ClearGUI($Array_GUI_Elements_122)
	_ClearGUI($Array_GUI_Elements_123)
	_ClearGUI($Array_GUI_Elements_130)
	_ClearGUI($Array_GUI_Elements_140)
	_ClearGUI($Array_GUI_Elements_150)

	_ShowGUI($Array_GUI_Elements_120)
	_ShowGUI($Array_GUI_Elements_121)

EndFunc

; Function To Show Movies Correction GUI (120)
Func _GUI_Show_Corection_Movies_Fanart()

	_ClearGUI($Array_GUI_Elements_100)
	_ClearGUI($Array_GUI_Elements_110)
	_ClearGUI($Array_GUI_Elements_121)
	_ClearGUI($Array_GUI_Elements_123)
	_ClearGUI($Array_GUI_Elements_130)
	_ClearGUI($Array_GUI_Elements_140)
	_ClearGUI($Array_GUI_Elements_150)

	_ShowGUI($Array_GUI_Elements_120)
	_ShowGUI($Array_GUI_Elements_122)

EndFunc

; Function To Show Movieset Correction GUI (123)
Func _GUI_Show_Corection_Movieset_Fanart()

	_ClearGUI($Array_GUI_Elements_100)
	_ClearGUI($Array_GUI_Elements_110)
	_ClearGUI($Array_GUI_Elements_121)
	_ClearGUI($Array_GUI_Elements_122)
	_ClearGUI($Array_GUI_Elements_130)
	_ClearGUI($Array_GUI_Elements_140)
	_ClearGUI($Array_GUI_Elements_150)

	_ShowGUI($Array_GUI_Elements_120)
	_ShowGUI($Array_GUI_Elements_123)

EndFunc

; Function To Show Videos Correction GUI (130)
Func _GUI_Show_Corection_Videos()

	_ClearGUI($Array_GUI_Elements_100)
	_ClearGUI($Array_GUI_Elements_110)
	_ClearGUI($Array_GUI_Elements_120)
	_ClearGUI($Array_GUI_Elements_121)
	_ClearGUI($Array_GUI_Elements_122)
	_ClearGUI($Array_GUI_Elements_123)
	_ClearGUI($Array_GUI_Elements_140)
	_ClearGUI($Array_GUI_Elements_150)

	_ShowGUI($Array_GUI_Elements_130)

EndFunc

; Function To Show Audio Correction GUI (140)
Func _GUI_Show_Corection_Audio()

	_ClearGUI($Array_GUI_Elements_100)
	_ClearGUI($Array_GUI_Elements_110)
	_ClearGUI($Array_GUI_Elements_120)
	_ClearGUI($Array_GUI_Elements_121)
	_ClearGUI($Array_GUI_Elements_122)
	_ClearGUI($Array_GUI_Elements_123)
	_ClearGUI($Array_GUI_Elements_130)
	_ClearGUI($Array_GUI_Elements_150)

	_ShowGUI($Array_GUI_Elements_140)

EndFunc

; Function To Show Album Correction GUI (150)
Func _GUI_Show_Corection_Album()

	_ClearGUI($Array_GUI_Elements_100)
	_ClearGUI($Array_GUI_Elements_110)
	_ClearGUI($Array_GUI_Elements_120)
	_ClearGUI($Array_GUI_Elements_121)
	_ClearGUI($Array_GUI_Elements_122)
	_ClearGUI($Array_GUI_Elements_123)
	_ClearGUI($Array_GUI_Elements_130)
	_ClearGUI($Array_GUI_Elements_140)

	_ShowGUI($Array_GUI_Elements_150)

EndFunc

#EndRegion

#Region ;GUI Functions

;Function To Clear GUI Elements
Func _ClearGUI($dArray)

	For $i = 1 To UBound($dArray) - 1
		GUICtrlSetState($dArray[$i],$GUI_HIDE)
	Next

EndFunc

;Function To Clear Dynamic GUI Elements
Func _ClearFuncGUI()

	_ClearGUI($Array_FUNC_11)
	_ClearGUI($Array_FUNC_12)
	_ClearGUI($Array_FUNC_13)
	_ClearGUI($Array_FUNC_14)
	_ClearGUI($Array_FUNC_21)
	_ClearGUI($Array_FUNC_22)
	_ClearGUI($Array_FUNC_23)
	_ClearGUI($Array_FUNC_24)
	_ClearGUI($Array_FUNC_25)
;~ 	_ClearGUI($Array_FUNC_26)
	_ClearGUI($Array_FUNC_31)
	_ClearGUI($Array_FUNC_32)
	_ClearGUI($Array_FUNC_33)
	_ClearGUI($Array_FUNC_41)
	_ClearGUI($Array_FUNC_42)
	_ClearGUI($Array_FUNC_43)

EndFunc

;Function To Show GUI Elements
Func _ShowGUI($dArray)

	For $i = 1 To UBound($dArray) - 1
		GUICtrlSetState($dArray[$i], $GUI_SHOW)
	Next

EndFunc

; Function To Show Wizards GUI (1)
Func _GUI_Show_Wizards()

	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_lastmodule", "1-1")

	_ClearGUI($Array_GUI_Elements_02)
	_ClearGUI($Array_GUI_Elements_03)
	_ClearGUI($Array_GUI_Elements_04)
	_ClearGUI($Array_GUI_Elements_05)
	_ClearGUI($Array_GUI_Elements_06)

	_ClearGUI($Array_GUI_Elements_12)
	_ClearGUI($Array_GUI_Elements_13)
	_ClearGUI($Array_GUI_Elements_14)

	_ClearGUI($Array_GUI_Elements_21)
	_ClearGUI($Array_GUI_Elements_22)
	_ClearGUI($Array_GUI_Elements_23)
	_ClearGUI($Array_GUI_Elements_24)
	_ClearGUI($Array_GUI_Elements_25)
	_ClearGUI($Array_GUI_Elements_26)

	_ClearGUI($Array_GUI_Elements_31)
	_ClearGUI($Array_GUI_Elements_32)
	_ClearGUI($Array_GUI_Elements_33)
	_ClearGUI($Array_GUI_Elements_34)
	_ClearGUI($Array_GUI_Elements_35)
	_ClearGUI($Array_GUI_Elements_36)

	_ClearGUI($Array_GUI_Elements_41)
	_ClearGUI($Array_GUI_Elements_42)
	_ClearGUI($Array_GUI_Elements_43)
	_ClearGUI($Array_GUI_Elements_44)
	_ClearGUI($Array_GUI_Elements_47)
	_ClearGUI($Array_GUI_Elements_48)

	_ClearGUI($Array_GUI_Elements_51)
	_ClearGUI($Array_GUI_Elements_52)
	_ClearGUI($Array_GUI_Elements_53)
	_ClearGUI($Array_GUI_Elements_54)
	_ClearGUI($Array_GUI_Elements_56)
	_ClearGUI($Array_GUI_Elements_57)

	_ClearGUI($Array_GUI_Elements_61)
	_ClearGUI($Array_GUI_Elements_62)
	_ClearGUI($Array_GUI_Elements_63)
	_ClearGUI($Array_GUI_Elements_64)

	_ClearGUI($Array_FUNC_99)

	_ShowGUI($Array_GUI_Elements_01)
	_ShowGUI($Array_GUI_Elements_11)

EndFunc

;Function To Show Series Wizard GUI (1-1)
Func _GUI_Wizard_Series()

	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_lastmodule", "1-1")

	_ClearGUI($Array_GUI_Elements_12)
	_ClearGUI($Array_GUI_Elements_13)
	_ClearGUI($Array_GUI_Elements_14)

	_ShowGUI($Array_GUI_Elements_11)

EndFunc

;Function To Show Movies Wizard GUI (1-2)
Func _GUI_Wizard_Movies()

	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_lastmodule", "1-2")

	_ClearGUI($Array_GUI_Elements_11)
	_ClearGUI($Array_GUI_Elements_13)
	_ClearGUI($Array_GUI_Elements_14)

	_ShowGUI($Array_GUI_Elements_12)

EndFunc

;Function To Show Videos Wizard GUI (1-3)
Func _GUI_Wizard_Videos()

	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_lastmodule", "1-3")

	_ClearGUI($Array_GUI_Elements_11)
	_ClearGUI($Array_GUI_Elements_12)
	_ClearGUI($Array_GUI_Elements_14)

	_ShowGUI($Array_GUI_Elements_13)

EndFunc

;Function To Show Videos Wizard GUI (1-4)
Func _GUI_Wizard_Audios()

	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_lastmodule", "1-4")

	_ClearGUI($Array_GUI_Elements_11)
	_ClearGUI($Array_GUI_Elements_12)
	_ClearGUI($Array_GUI_Elements_13)

	_ShowGUI($Array_GUI_Elements_14)

EndFunc

; Function To Show Conversion GUI (2)
Func _GUI_Show_Conversion()

	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_lastmodule", "2-1")

	_ClearGUI($Array_GUI_Elements_01)
	_ClearGUI($Array_GUI_Elements_03)
	_ClearGUI($Array_GUI_Elements_04)
	_ClearGUI($Array_GUI_Elements_05)
	_ClearGUI($Array_GUI_Elements_06)

	_ClearGUI($Array_GUI_Elements_11)
	_ClearGUI($Array_GUI_Elements_12)
	_ClearGUI($Array_GUI_Elements_13)
	_ClearGUI($Array_GUI_Elements_14)

	_ClearGUI($Array_GUI_Elements_22)
	_ClearGUI($Array_GUI_Elements_23)
	_ClearGUI($Array_GUI_Elements_24)
	_ClearGUI($Array_GUI_Elements_25)
	_ClearGUI($Array_GUI_Elements_26)

	_ClearGUI($Array_GUI_Elements_31)
	_ClearGUI($Array_GUI_Elements_32)
	_ClearGUI($Array_GUI_Elements_33)
	_ClearGUI($Array_GUI_Elements_34)
	_ClearGUI($Array_GUI_Elements_35)
	_ClearGUI($Array_GUI_Elements_36)

	_ClearGUI($Array_GUI_Elements_41)
	_ClearGUI($Array_GUI_Elements_42)
	_ClearGUI($Array_GUI_Elements_43)
	_ClearGUI($Array_GUI_Elements_44)
	_ClearGUI($Array_GUI_Elements_47)
	_ClearGUI($Array_GUI_Elements_48)

	_ClearGUI($Array_GUI_Elements_51)
	_ClearGUI($Array_GUI_Elements_52)
	_ClearGUI($Array_GUI_Elements_53)
	_ClearGUI($Array_GUI_Elements_54)
	_ClearGUI($Array_GUI_Elements_56)
	_ClearGUI($Array_GUI_Elements_57)

	_ClearGUI($Array_GUI_Elements_61)
	_ClearGUI($Array_GUI_Elements_62)
	_ClearGUI($Array_GUI_Elements_63)
	_ClearGUI($Array_GUI_Elements_64)

	_ClearGUI($Array_FUNC_99)

	_ShowGUI($Array_GUI_Elements_02)
	_ShowGUI($Array_GUI_Elements_21)

EndFunc

;Function To Show Recode GUI (2-1)
Func _GUI_Videos_Recode()

	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_lastmodule", "2-1")

	_ClearGUI($Array_GUI_Elements_22)
	_ClearGUI($Array_GUI_Elements_23)
	_ClearGUI($Array_GUI_Elements_24)
	_ClearGUI($Array_GUI_Elements_25)
	_ClearGUI($Array_GUI_Elements_26)

	_ShowGUI($Array_GUI_Elements_21)

EndFunc

;Function To Show Remux GUI (2-2)
Func _GUI_Videos_Remux()

	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_lastmodule", "2-2")

	_ClearGUI($Array_GUI_Elements_21)
	_ClearGUI($Array_GUI_Elements_23)
	_ClearGUI($Array_GUI_Elements_24)
	_ClearGUI($Array_GUI_Elements_25)
	_ClearGUI($Array_GUI_Elements_26)

	_ShowGUI($Array_GUI_Elements_22)

EndFunc

;Function To Show Append GUI (2-3)
Func _GUI_Videos_Append()

	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_lastmodule", "2-3")

	_ClearGUI($Array_GUI_Elements_21)
	_ClearGUI($Array_GUI_Elements_22)
	_ClearGUI($Array_GUI_Elements_24)
	_ClearGUI($Array_GUI_Elements_25)
	_ClearGUI($Array_GUI_Elements_26)

	_ShowGUI($Array_GUI_Elements_23)

EndFunc

;Function To Show Audio Recode GUI (2-4)
Func _GUI_Audio_Recode()

	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_lastmodule", "2-4")

	_ClearGUI($Array_GUI_Elements_21)
	_ClearGUI($Array_GUI_Elements_22)
	_ClearGUI($Array_GUI_Elements_23)
	_ClearGUI($Array_GUI_Elements_25)
	_ClearGUI($Array_GUI_Elements_26)

	_ShowGUI($Array_GUI_Elements_24)

EndFunc

;Function To Show Audio Normalize GUI (2-5)
Func _GUI_Audio_Normalize()

	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_lastmodule", "2-5")

	_ClearGUI($Array_GUI_Elements_21)
	_ClearGUI($Array_GUI_Elements_22)
	_ClearGUI($Array_GUI_Elements_23)
	_ClearGUI($Array_GUI_Elements_24)
	_ClearGUI($Array_GUI_Elements_26)

	_ShowGUI($Array_GUI_Elements_25)

EndFunc

;Function To Show Simple Remux GUI (2-6)
Func _GUI_Graphics()

	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_lastmodule", "2-6")

	_ClearGUI($Array_GUI_Elements_21)
	_ClearGUI($Array_GUI_Elements_22)
	_ClearGUI($Array_GUI_Elements_23)
	_ClearGUI($Array_GUI_Elements_24)
	_ClearGUI($Array_GUI_Elements_25)

	_ShowGUI($Array_GUI_Elements_26)

EndFunc

; Function To Show Metadata GUI (3)
Func _GUI_Show_Metadata()

	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_lastmodule", "3-1")

	_ClearGUI($Array_GUI_Elements_01)
	_ClearGUI($Array_GUI_Elements_02)
	_ClearGUI($Array_GUI_Elements_04)
	_ClearGUI($Array_GUI_Elements_05)
	_ClearGUI($Array_GUI_Elements_06)

	_ClearGUI($Array_GUI_Elements_11)
	_ClearGUI($Array_GUI_Elements_12)
	_ClearGUI($Array_GUI_Elements_13)
	_ClearGUI($Array_GUI_Elements_14)

	_ClearGUI($Array_GUI_Elements_21)
	_ClearGUI($Array_GUI_Elements_22)
	_ClearGUI($Array_GUI_Elements_23)
	_ClearGUI($Array_GUI_Elements_24)
	_ClearGUI($Array_GUI_Elements_25)
	_ClearGUI($Array_GUI_Elements_26)

	_ClearGUI($Array_GUI_Elements_32)
	_ClearGUI($Array_GUI_Elements_33)
	_ClearGUI($Array_GUI_Elements_34)
	_ClearGUI($Array_GUI_Elements_35)
	_ClearGUI($Array_GUI_Elements_36)

	_ClearGUI($Array_GUI_Elements_41)
	_ClearGUI($Array_GUI_Elements_42)
	_ClearGUI($Array_GUI_Elements_43)
	_ClearGUI($Array_GUI_Elements_44)
	_ClearGUI($Array_GUI_Elements_47)
	_ClearGUI($Array_GUI_Elements_48)

	_ClearGUI($Array_GUI_Elements_51)
	_ClearGUI($Array_GUI_Elements_52)
	_ClearGUI($Array_GUI_Elements_53)
	_ClearGUI($Array_GUI_Elements_54)
	_ClearGUI($Array_GUI_Elements_56)
	_ClearGUI($Array_GUI_Elements_57)

	_ClearGUI($Array_GUI_Elements_61)
	_ClearGUI($Array_GUI_Elements_62)
	_ClearGUI($Array_GUI_Elements_63)
	_ClearGUI($Array_GUI_Elements_64)

	_ClearGUI($Array_FUNC_99)

	_ShowGUI($Array_GUI_Elements_03)
	_ShowGUI($Array_GUI_Elements_31)

EndFunc

; Function To Show Series Metadata GUI (3-1)
Func _GUI_Show_Series_Metadata()

	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_lastmodule", "3-1")

	_ClearGUI($Array_GUI_Elements_32)
	_ClearGUI($Array_GUI_Elements_33)
	_ClearGUI($Array_GUI_Elements_34)
	_ClearGUI($Array_GUI_Elements_35)
	_ClearGUI($Array_GUI_Elements_36)

	_ShowGUI($Array_GUI_Elements_31)

EndFunc

; Function To Show Movies Metadata GUI (3-2)
Func _GUI_Show_Movies_Metadata()

	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_lastmodule", "3-2")

	_ClearGUI($Array_GUI_Elements_31)
	_ClearGUI($Array_GUI_Elements_33)
	_ClearGUI($Array_GUI_Elements_34)
	_ClearGUI($Array_GUI_Elements_35)
	_ClearGUI($Array_GUI_Elements_36)

	_ShowGUI($Array_GUI_Elements_32)

EndFunc

; Function To Show Videos Metadata GUI (3-3)
Func _GUI_Show_Videos_Metadata()

	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_lastmodule", "3-3")

	_ClearGUI($Array_GUI_Elements_31)
	_ClearGUI($Array_GUI_Elements_32)
	_ClearGUI($Array_GUI_Elements_34)
	_ClearGUI($Array_GUI_Elements_35)

	_ShowGUI($Array_GUI_Elements_33)

EndFunc

; Function To Show Audio Metadata GUI (3-4)
Func _GUI_Show_Audio_Metadata()

	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_lastmodule", "3-4")

	_ClearGUI($Array_GUI_Elements_31)
	_ClearGUI($Array_GUI_Elements_32)
	_ClearGUI($Array_GUI_Elements_33)
	_ClearGUI($Array_GUI_Elements_35)
	_ClearGUI($Array_GUI_Elements_36)

	_ShowGUI($Array_GUI_Elements_34)

EndFunc

; Function To Show Graphics Metadata GUI (3-5)
Func _GUI_Show_Graphics_Metadata()

	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_lastmodule", "3-5")

	_ClearGUI($Array_GUI_Elements_31)
	_ClearGUI($Array_GUI_Elements_32)
	_ClearGUI($Array_GUI_Elements_33)
	_ClearGUI($Array_GUI_Elements_34)
	_ClearGUI($Array_GUI_Elements_36)

	_ShowGUI($Array_GUI_Elements_35)

EndFunc

; Function To Show Audio Metadata GUI (3-6)
Func _GUI_Show_Prepare_Metadata()

	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_lastmodule", "3-6")

	_ClearGUI($Array_GUI_Elements_31)
	_ClearGUI($Array_GUI_Elements_32)
	_ClearGUI($Array_GUI_Elements_33)
	_ClearGUI($Array_GUI_Elements_34)
	_ClearGUI($Array_GUI_Elements_35)

	_ShowGUI($Array_GUI_Elements_36)

EndFunc

; Function To Show Tools GUI (4)
Func _GUI_Show_Tools()

	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_lastmodule", "4-1")

	_ClearGUI($Array_GUI_Elements_01)
	_ClearGUI($Array_GUI_Elements_02)
	_ClearGUI($Array_GUI_Elements_03)
	_ClearGUI($Array_GUI_Elements_05)
	_ClearGUI($Array_GUI_Elements_06)

	_ClearGUI($Array_GUI_Elements_11)
	_ClearGUI($Array_GUI_Elements_12)
	_ClearGUI($Array_GUI_Elements_13)
	_ClearGUI($Array_GUI_Elements_14)

	_ClearGUI($Array_GUI_Elements_21)
	_ClearGUI($Array_GUI_Elements_22)
	_ClearGUI($Array_GUI_Elements_23)
	_ClearGUI($Array_GUI_Elements_24)
	_ClearGUI($Array_GUI_Elements_25)
	_ClearGUI($Array_GUI_Elements_26)

	_ClearGUI($Array_GUI_Elements_31)
	_ClearGUI($Array_GUI_Elements_32)
	_ClearGUI($Array_GUI_Elements_33)
	_ClearGUI($Array_GUI_Elements_34)
	_ClearGUI($Array_GUI_Elements_35)
	_ClearGUI($Array_GUI_Elements_36)

	_ClearGUI($Array_GUI_Elements_42)
	_ClearGUI($Array_GUI_Elements_43)
	_ClearGUI($Array_GUI_Elements_44)
	_ClearGUI($Array_GUI_Elements_47)
	_ClearGUI($Array_GUI_Elements_48)

	_ClearGUI($Array_GUI_Elements_51)
	_ClearGUI($Array_GUI_Elements_52)
	_ClearGUI($Array_GUI_Elements_53)
	_ClearGUI($Array_GUI_Elements_54)
	_ClearGUI($Array_GUI_Elements_56)
	_ClearGUI($Array_GUI_Elements_57)

	_ClearGUI($Array_GUI_Elements_61)
	_ClearGUI($Array_GUI_Elements_62)
	_ClearGUI($Array_GUI_Elements_63)
	_ClearGUI($Array_GUI_Elements_64)

	_ClearGUI($Array_FUNC_99)

	_ShowGUI($Array_GUI_Elements_04)
	_ShowGUI($Array_GUI_Elements_41)

EndFunc

;Function To Show Fix GUI (4-1)
Func _GUI_Tools_Fix()

	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_lastmodule", "4-1")

	_ClearGUI($Array_GUI_Elements_42)
	_ClearGUI($Array_GUI_Elements_43)
	_ClearGUI($Array_GUI_Elements_44)
	_ClearGUI($Array_GUI_Elements_47)
	_ClearGUI($Array_GUI_Elements_48)

	_ShowGUI($Array_GUI_Elements_41)

EndFunc

;Function To Show Fix GUI (4-2)
Func _GUI_Tools_3D()

	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_lastmodule", "4-2")

	_ClearGUI($Array_GUI_Elements_41)
	_ClearGUI($Array_GUI_Elements_43)
	_ClearGUI($Array_GUI_Elements_44)
	_ClearGUI($Array_GUI_Elements_47)
	_ClearGUI($Array_GUI_Elements_48)

	_ShowGUI($Array_GUI_Elements_42)

EndFunc

;Function To Show Extract GUI (4-3)
Func _GUI_Tools_Extract()

	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_lastmodule", "4-3")

	_ClearGUI($Array_GUI_Elements_41)
	_ClearGUI($Array_GUI_Elements_42)
	_ClearGUI($Array_GUI_Elements_44)
	_ClearGUI($Array_GUI_Elements_47)
	_ClearGUI($Array_GUI_Elements_48)

	_ShowGUI($Array_GUI_Elements_43)

EndFunc

;Function To Show Kodi GUI (4-4)
Func _GUI_Tools_Kodi()

	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_lastmodule", "4-4")

	_ClearGUI($Array_GUI_Elements_41)
	_ClearGUI($Array_GUI_Elements_42)
	_ClearGUI($Array_GUI_Elements_43)
	_ClearGUI($Array_GUI_Elements_47)
	_ClearGUI($Array_GUI_Elements_48)

	_ShowGUI($Array_GUI_Elements_44)

EndFunc

;Function To Show Stub GUI (4-7)
Func _GUI_Tools_Stub()

	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_lastmodule", "4-7")

	_ClearGUI($Array_GUI_Elements_41)
	_ClearGUI($Array_GUI_Elements_42)
	_ClearGUI($Array_GUI_Elements_43)
	_ClearGUI($Array_GUI_Elements_44)
	_ClearGUI($Array_GUI_Elements_48)

	_ShowGUI($Array_GUI_Elements_47)

EndFunc

;Function To Show Audiotool GUI (4-8)
Func _GUI_Tools_Audio()

	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_lastmodule", "4-8")

	_ClearGUI($Array_GUI_Elements_41)
	_ClearGUI($Array_GUI_Elements_42)
	_ClearGUI($Array_GUI_Elements_43)
	_ClearGUI($Array_GUI_Elements_44)
	_ClearGUI($Array_GUI_Elements_47)

	_ShowGUI($Array_GUI_Elements_48)

EndFunc

; Function To Show Settings GUI (5)
Func _GUI_Show_Settings()

	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_lastmodule", "5-1")

	_ClearGUI($Array_GUI_Elements_01)
	_ClearGUI($Array_GUI_Elements_02)
	_ClearGUI($Array_GUI_Elements_03)
	_ClearGUI($Array_GUI_Elements_04)
	_ClearGUI($Array_GUI_Elements_06)

	_ClearGUI($Array_GUI_Elements_11)
	_ClearGUI($Array_GUI_Elements_12)
	_ClearGUI($Array_GUI_Elements_13)
	_ClearGUI($Array_GUI_Elements_14)

	_ClearGUI($Array_GUI_Elements_21)
	_ClearGUI($Array_GUI_Elements_22)
	_ClearGUI($Array_GUI_Elements_23)
	_ClearGUI($Array_GUI_Elements_24)
	_ClearGUI($Array_GUI_Elements_25)
	_ClearGUI($Array_GUI_Elements_26)

	_ClearGUI($Array_GUI_Elements_31)
	_ClearGUI($Array_GUI_Elements_32)
	_ClearGUI($Array_GUI_Elements_33)
	_ClearGUI($Array_GUI_Elements_34)
	_ClearGUI($Array_GUI_Elements_35)
	_ClearGUI($Array_GUI_Elements_36)

	_ClearGUI($Array_GUI_Elements_41)
	_ClearGUI($Array_GUI_Elements_42)
	_ClearGUI($Array_GUI_Elements_43)
	_ClearGUI($Array_GUI_Elements_44)
	_ClearGUI($Array_GUI_Elements_47)
	_ClearGUI($Array_GUI_Elements_48)

	_ClearGUI($Array_GUI_Elements_52)
	_ClearGUI($Array_GUI_Elements_53)
	_ClearGUI($Array_GUI_Elements_54)
	_ClearGUI($Array_GUI_Elements_56)
	_ClearGUI($Array_GUI_Elements_57)

	_ClearGUI($Array_GUI_Elements_61)
	_ClearGUI($Array_GUI_Elements_62)
	_ClearGUI($Array_GUI_Elements_63)
	_ClearGUI($Array_GUI_Elements_64)

	_ClearGUI($Array_FUNC_99)

	_ShowGUI($Array_GUI_Elements_05)
	_ShowGUI($Array_GUI_Elements_51)

EndFunc

;Function To Show Program Settings GUI (5-1)
Func _GUI_Settings_Program()

	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_lastmodule", "5-1")

	_ClearGUI($Array_GUI_Elements_52)
	_ClearGUI($Array_GUI_Elements_53)
	_ClearGUI($Array_GUI_Elements_54)
	_ClearGUI($Array_GUI_Elements_56)
	_ClearGUI($Array_GUI_Elements_57)

	_ShowGUI($Array_GUI_Elements_51)

EndFunc

;Function To Show Video Settings GUI (5-2)
Func _GUI_Settings_Video()

	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_lastmodule", "5-2")

	_ClearGUI($Array_GUI_Elements_51)
	_ClearGUI($Array_GUI_Elements_53)
	_ClearGUI($Array_GUI_Elements_54)
	_ClearGUI($Array_GUI_Elements_56)
	_ClearGUI($Array_GUI_Elements_57)

	_ShowGUI($Array_GUI_Elements_52)

EndFunc

;Function To Show Metadata Settings GUI (5-3)
Func _GUI_Settings_Metadata()

	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_lastmodule", "5-3")

	_ClearGUI($Array_GUI_Elements_51)
	_ClearGUI($Array_GUI_Elements_52)
	_ClearGUI($Array_GUI_Elements_54)
	_ClearGUI($Array_GUI_Elements_56)
	_ClearGUI($Array_GUI_Elements_57)

	_ShowGUI($Array_GUI_Elements_53)

EndFunc

;Function To Show Filenames Settings GUI (5-4)
Func _GUI_Settings_Filenames()

	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_lastmodule", "5-4")

	_ClearGUI($Array_GUI_Elements_51)
	_ClearGUI($Array_GUI_Elements_52)
	_ClearGUI($Array_GUI_Elements_53)
	_ClearGUI($Array_GUI_Elements_56)
	_ClearGUI($Array_GUI_Elements_57)

	_ShowGUI($Array_GUI_Elements_54)

EndFunc

;Function To Show Audio Settings GUI (5-6)
Func _GUI_Settings_Audio()

	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_lastmodule", "5-6")

	_ClearGUI($Array_GUI_Elements_51)
	_ClearGUI($Array_GUI_Elements_52)
	_ClearGUI($Array_GUI_Elements_53)
	_ClearGUI($Array_GUI_Elements_54)
	_ClearGUI($Array_GUI_Elements_57)

	_ShowGUI($Array_GUI_Elements_56)

EndFunc

;Function To Show Graphics Settings GUI (5-6)
Func _GUI_Settings_Graphics()

	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_lastmodule", "5-7")

	_ClearGUI($Array_GUI_Elements_51)
	_ClearGUI($Array_GUI_Elements_52)
	_ClearGUI($Array_GUI_Elements_53)
	_ClearGUI($Array_GUI_Elements_54)
	_ClearGUI($Array_GUI_Elements_56)

	_ShowGUI($Array_GUI_Elements_57)

EndFunc

; Function To Show Series Correction GUI (6-1)
Func _GUI_Show_Series_Correction()

	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_lastmodule", "6-1")

	_ClearGUI($Array_GUI_Elements_62)
	_ClearGUI($Array_GUI_Elements_63)
	_ClearGUI($Array_GUI_Elements_64)

	_ShowGUI($Array_GUI_Elements_61)

EndFunc

; Function To Show Movies Correction GUI (6-2)
Func _GUI_Show_Movies_Correction()

	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_lastmodule", "6-2")

	_ClearGUI($Array_GUI_Elements_61)
	_ClearGUI($Array_GUI_Elements_63)
	_ClearGUI($Array_GUI_Elements_64)

	_ShowGUI($Array_GUI_Elements_62)

EndFunc

; Function To Show Videos Correction GUI (6-3)
Func _GUI_Show_Videos_Correction()

	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_lastmodule", "6-3")

	_ClearGUI($Array_GUI_Elements_61)
	_ClearGUI($Array_GUI_Elements_62)
	_ClearGUI($Array_GUI_Elements_64)

	_ShowGUI($Array_GUI_Elements_63)

EndFunc

; Function To Show Audio Correction GUI (6-4)
Func _GUI_Show_Audio_Correction()

	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_lastmodule", "6-4")

	_ClearGUI($Array_GUI_Elements_61)
	_ClearGUI($Array_GUI_Elements_62)
	_ClearGUI($Array_GUI_Elements_63)

	_ShowGUI($Array_GUI_Elements_64)

EndFunc

; Function To Show Correction GUI (6)
Func _GUI_Show_Corection()

	IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_lastmodule", "6-1")

	_ClearGUI($Array_GUI_Elements_01)
	_ClearGUI($Array_GUI_Elements_02)
	_ClearGUI($Array_GUI_Elements_03)
	_ClearGUI($Array_GUI_Elements_04)
	_ClearGUI($Array_GUI_Elements_05)

	_ClearGUI($Array_GUI_Elements_11)
	_ClearGUI($Array_GUI_Elements_12)
	_ClearGUI($Array_GUI_Elements_13)
	_ClearGUI($Array_GUI_Elements_14)

	_ClearGUI($Array_GUI_Elements_21)
	_ClearGUI($Array_GUI_Elements_22)
	_ClearGUI($Array_GUI_Elements_23)
	_ClearGUI($Array_GUI_Elements_24)
	_ClearGUI($Array_GUI_Elements_25)
	_ClearGUI($Array_GUI_Elements_26)

	_ClearGUI($Array_GUI_Elements_31)
	_ClearGUI($Array_GUI_Elements_32)
	_ClearGUI($Array_GUI_Elements_33)
	_ClearGUI($Array_GUI_Elements_34)
	_ClearGUI($Array_GUI_Elements_35)
	_ClearGUI($Array_GUI_Elements_36)

	_ClearGUI($Array_GUI_Elements_41)
	_ClearGUI($Array_GUI_Elements_42)
	_ClearGUI($Array_GUI_Elements_43)
	_ClearGUI($Array_GUI_Elements_44)
	_ClearGUI($Array_GUI_Elements_47)
	_ClearGUI($Array_GUI_Elements_48)

	_ClearGUI($Array_GUI_Elements_51)
	_ClearGUI($Array_GUI_Elements_52)
	_ClearGUI($Array_GUI_Elements_53)
	_ClearGUI($Array_GUI_Elements_54)
	_ClearGUI($Array_GUI_Elements_56)
	_ClearGUI($Array_GUI_Elements_57)

	_ClearGUI($Array_GUI_Elements_62)
	_ClearGUI($Array_GUI_Elements_63)
	_ClearGUI($Array_GUI_Elements_64)

	_ClearGUI($Array_FUNC_99)

	_ShowGUI($Array_GUI_Elements_06)
	_ShowGUI($Array_GUI_Elements_61)

EndFunc

#EndRegion ;GUI Functions

#Region ;GUI Loop

;Function to Create Main GUI
Func _GUI_Main()

	Global $Drive, $Dir, $Filename, $Extension

	While 1
		_GetTime()

		_SetFlag()

		Local $msg1 = GUIGetMsg(1)

		Select

			Case $msg1[0] = $infoitem
				MsgBox(0, $lng_about & " " & $Title, "Media-Buddy" & @CRLF & @CRLF & "(C) 2020 Lehmden" & @CRLF & @CRLF & "Version: " & $version)


;~ 			Case $msg1[0] = $helpitem
;~ 				If FileExists(@ScriptDir & "\Doc\" & $ini_language & "_Media-Buddy Help.chm") Then
;~ 					$lng = $ini_language
;~ 				Else
;~ 					$lng = "English"
;~ 				EndIf
;~ 				ShellExecute(@ScriptDir & "\Doc\" & $lng & "_Media-Buddy Help.chm")

;~ 			Case $msg1[0] = $docitem
;~ 				If FileExists(@ScriptDir & "\Doc\" & $ini_language & "_Media-Buddy Manual.pdf") Then
;~ 					$lng = $ini_language
;~ 				Else
;~ 					$lng = "English"
;~ 				EndIf
;~ 				ShellExecute(@ScriptDir & "\Doc\" & $lng & "_Media-Buddy Manual.pdf")

			Case $msg1[0] = $Button_11_04 Or $msg1[0] = $Button_12_04 Or $msg1[0] = $Button_13_04 Or $msg1[0] = $Button_14_04 Or $msg1[0] =  $Button_21_04 Or $msg1[0] = $Button_22_04 Or $msg1[0] = $Button_24_04 Or $msg1[0] = $Button_23_04 Or $msg1[0] = $Button_41_04 Or $msg1[0] = $Button_61_04 Or $msg1[0] = $Button_62_04 Or $msg1[0] = $Button_63_04 Or $msg1[0] = $Button_64_04

				$box = MsgBox(1, $lng_delorg, $lng_areyousure)
				If $box = "1" Then

					_FileDeleteFromDB()

				EndIf


			Case $msg1[0] = $Navigation_Button_01

				_GUI_Show_Wizards()


			Case $msg1[0] = $Navigation_Button_02

				_GUI_Show_Conversion()


			Case $msg1[0] = $Navigation_Button_03

				_GUI_Show_Metadata()


			Case $msg1[0] = $Navigation_Button_04

				_GUI_Show_Corection()


			Case $msg1[0] = $Navigation_Button_05

				_GUI_Show_Tools()


			Case $msg1[0] = $Navigation_Button_06

				_GUI_Show_Settings()


			Case $msg1[0] = $button_11_01

				_Wizard_Series()


			Case $msg1[0] = $button_11_02
				$IF1 = GUICtrlRead($input_11_01)
				$wizard_seriesInputFolder = FileSelectFolder($lng_inputfoldertext, $IF1, -1, $IF1)
				If $wizard_seriesInputFolder <> "" Then
					IniWrite(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_wizard_series_inputfolder", $wizard_seriesInputFolder)
					_SetData($input_11_01, $wizard_seriesInputFolder)
					_SetLabel($label_11_04, $lng_conversiontext1 & " " & $wizard_seriesInputFolder & $lng_conversiontext2)
				EndIf


			Case $msg1[0] = $button_11_03
				$IF1 = GUICtrlRead($input_11_02)
				$wizard_seriesOutputFolder = FileSelectFolder($lng_outputfoldertext, $IF1, -1, $IF1)
				If $wizard_seriesOutputFolder <> "" Then
					IniWrite(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_wizard_series_outputfolder", $wizard_seriesOutputFolder)
					_SetData($input_11_02, $wizard_seriesOutputFolder)
				EndIf


			Case $msg1[0] = $button_12_01

				_Wizard_Movies()


			Case $msg1[0] = $button_12_02
				$IF1 = GUICtrlRead($input_12_01)
				$wizard_moviesInputFolder = FileSelectFolder($lng_inputfoldertext, $IF1, -1, $IF1)
				If $wizard_moviesInputFolder <> "" Then
					IniWrite(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_wizard_movies_inputfolder", $wizard_moviesInputFolder)
					_SetData($input_12_01, $wizard_moviesInputFolder)
					_SetLabel($label_12_04, $lng_conversiontext1 & " " & $wizard_moviesInputFolder & $lng_conversiontext2)
				EndIf


			Case $msg1[0] = $button_12_03
				$IF1 = GUICtrlRead($input_12_02)
				$wizard_moviesOutputFolder = FileSelectFolder($lng_outputfoldertext, $IF1, -1, $IF1)
				If $wizard_moviesOutputFolder <> "" Then
					IniWrite(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_wizard_movies_outputfolder", $wizard_moviesOutputFolder)
					_SetData($input_12_02, $wizard_moviesOutputFolder)
				EndIf


			Case $msg1[0] = $button_13_01

				_Wizard_Videos()


			Case $msg1[0] = $button_13_02
				$IF1 = GUICtrlRead($input_13_01)
				$wizard_videosInputFolder = FileSelectFolder($lng_inputfoldertext, $IF1, -1, $IF1)
				If $wizard_videosInputFolder <> "" Then
					IniWrite(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_wizard_videos_inputfolder", $wizard_videosInputFolder)
					_SetData($input_13_01, $wizard_videosInputFolder)
					_SetLabel($label_13_04, $lng_conversiontext1 & " " & $wizard_videosInputFolder & $lng_conversiontext2)
				EndIf


			Case $msg1[0] = $button_13_03
				$IF1 = GUICtrlRead($input_13_02)
				$wizard_videosOutputFolder = FileSelectFolder($lng_outputfoldertext, $IF1, -1, $IF1)
				If $wizard_videosOutputFolder <> "" Then
					IniWrite(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_wizard_videos_outputfolder", $wizard_videosOutputFolder)
					_SetData($input_13_02, $wizard_videosOutputFolder)
				EndIf


			Case $msg1[0] = $button_14_01

				_Wizard_Audio()


			Case $msg1[0] = $button_14_02
				$IF1 = GUICtrlRead($input_14_01)
				$wizard_audioInputFolder = FileSelectFolder($lng_inputfoldertext, $IF1, -1, $IF1)
				If $wizard_audioInputFolder <> "" Then
					IniWrite(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_wizard_audio_inputfolder", $wizard_audioInputFolder)
					_SetData($input_14_01, $wizard_audioInputFolder)
					_SetLabel($label_14_04, $lng_conversiontext1 & " " & $wizard_audioInputFolder & $lng_conversiontext2)
				EndIf


			Case $msg1[0] = $button_14_03
				$IF1 = GUICtrlRead($input_14_02)
				$wizard_audioOutputFolder = FileSelectFolder($lng_outputfoldertext, $IF1, -1, $IF1)
				If $wizard_audioOutputFolder <> "" Then
					IniWrite(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_wizard_audio_outputfolder", $wizard_audioOutputFolder)
					_SetData($input_14_02, $wizard_audioOutputFolder)
				EndIf


			Case $msg1[0] = $Select_Button_11

				_GUI_Wizard_Series()


			Case $msg1[0] = $Select_Button_12

				_GUI_Wizard_Movies()


			Case $msg1[0] = $Select_Button_13

				_GUI_Wizard_Videos()


			Case $msg1[0] = $Select_Button_14

				_GUI_Wizard_Audios()


			Case $msg1[0] = $Select_Button_21

				_GUI_Videos_Recode()


			Case $msg1[0] = $button_21_01

				_Recode()


			Case $msg1[0] = $button_21_02
				$IF1 = GUICtrlRead($input_21_01)
				$RecodeInputFolder = FileSelectFolder($lng_inputfoldertext, $IF1, -1, $IF1)
				If $RecodeInputFolder <> "" Then
					IniWrite(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_recode_inputfolder", $RecodeInputFolder)
					_SetData($input_21_01, $RecodeInputFolder)
					_SetLabel($label_21_04, $lng_conversiontext1 & " " & $RecodeInputFolder & $lng_conversiontext2)
				EndIf


			Case $msg1[0] = $button_21_03
				$IF2 = GUICtrlRead($input_21_02)
				$RecodeOutputFolder = FileSelectFolder($lng_outputfoldertext, $IF2, -1, $IF2)
				If $RecodeOutputFolder <> "" Then
					IniWrite(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_recode_outputfolder", $RecodeOutputFolder)
					_SetData($input_21_02, $RecodeOutputFolder)
				EndIf


			Case $msg1[0] = $Select_Button_22

				_GUI_Videos_Remux()


			Case $msg1[0] = $button_22_01

				If GUICtrlRead($check_22_01) = "1" Then

					_Simple_Remux()

				Else

					_Remux()

				EndIf


			Case $msg1[0] = $button_22_02
				$IF1 = GUICtrlRead($input_22_01)
				$RemuxInputFolder = FileSelectFolder($lng_inputfoldertext, $IF1, -1, $IF1)
				If $RemuxInputFolder <> "" Then
					IniWrite(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_remux_inputfolder", $RemuxInputFolder)
					_SetData($input_22_01, $RemuxInputFolder)
					_SetLabel($label_22_04, $lng_conversiontext1 & " " & $RemuxInputFolder & $lng_conversiontext2)
				EndIf


			Case $msg1[0] = $button_22_03
				$IF2 = GUICtrlRead($input_22_02)
				$RemuxOutputFolder = FileSelectFolder($lng_outputfoldertext, $IF2, -1, $IF2)
				If $RemuxOutputFolder <> "" Then
					IniWrite(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_remux_outputfolder", $RemuxOutputFolder)
					_SetData($input_22_02, $RemuxOutputFolder)
				EndIf


			Case $msg1[0] = $Select_Button_23

				_GUI_Videos_Append()


			Case $msg1[0] = $button_23_01

				_Append()


			Case $msg1[0] = $button_23_02
				$IF1 = GUICtrlRead($input_23_01)
				$AppendInputFolder = FileSelectFolder($lng_inputfoldertext, $IF1, -1, $IF1)
				If $AppendInputFolder <> "" Then
					IniWrite(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_append_inputfolder", $AppendInputFolder)
					_SetData($input_23_01, $AppendInputFolder)
					_SetLabel($label_23_04, $lng_conversiontext1 & " " & $AppendInputFolder & $lng_conversiontext2)
				EndIf


			Case $msg1[0] = $button_23_03
				$IF2 = GUICtrlRead($input_23_02)
				$AppendOutputFolder = FileSelectFolder($lng_outputfoldertext, $IF2, -1, $IF2)
				If $AppendOutputFolder <> "" Then
					IniWrite(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_append_outputfolder", $AppendOutputFolder)
					_SetData($input_23_02, $AppendOutputFolder)
				EndIf


			Case $msg1[0] = $Select_Button_24

				_GUI_Audio_Recode()


			Case $msg1[0] = $button_24_01

				_RecodeAudio()


			Case $msg1[0] = $button_24_02
				$IF1 = GUICtrlRead($input_24_01)
				$ArecodeInputFolder = FileSelectFolder($lng_inputfoldertext, $IF1, -1, $IF1)
				If $ArecodeInputFolder <> "" Then
					IniWrite(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_arecode_inputfolder", $ArecodeInputFolder)
					_SetData($input_24_01, $ArecodeInputFolder)
					_SetLabel($label_24_04, $lng_conversiontext1 & " " & $ArecodeInputFolder & $lng_conversiontext2)
				EndIf


			Case $msg1[0] = $button_24_03
				$IF2 = GUICtrlRead($input_24_02)
				$ArecodeOutputFolder = FileSelectFolder($lng_outputfoldertext, $IF2, -1, $IF2)
				If $ArecodeOutputFolder <> "" Then
					IniWrite(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_arecode_outputfolder", $ArecodeOutputFolder)
					_SetData($input_24_02, $ArecodeOutputFolder)
				EndIf


			Case $msg1[0] = $Select_Button_25

				_GUI_Audio_Normalize()


			Case $msg1[0] = $button_25_01

				_NormalizeAudio()


			Case $msg1[0] = $button_25_02
				$IF1 = GUICtrlRead($input_25_01)
				$ANormInputFolder = FileSelectFolder($lng_inputfoldertext, $IF1, -1, $IF1)
				If $ANormInputFolder <> "" Then
					IniWrite(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_anorm_inputfolder", $ANormInputFolder)
					_SetData($input_25_01, $ANormInputFolder)
					_SetLabel($label_25_04, $lng_conversiontext1 & " " & $ANormInputFolder & $lng_conversiontext2)
				EndIf


			Case $msg1[0] = $button_25_03
				$IF2 = GUICtrlRead($input_25_02)
				$ArecodeNormFolder = FileSelectFolder($lng_outputfoldertext, $IF2, -1, $IF2)
				If $ArecodeNormFolder <> "" Then
					IniWrite(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_anorm_outputfolder", $ArecodeNormFolder)
					_SetData($input_25_02, $ArecodeNormFolder)
				EndIf


			Case $msg1[0] = $Select_Button_26

				_GUI_Graphics()


			Case $msg1[0] = $button_26_01

				_Graphics()


			Case $msg1[0] = $button_26_02
				$IF1 = GUICtrlRead($input_26_01)
				$RemuxInputFolder = FileSelectFolder($lng_inputfoldertext, $IF1, -1, $IF1)
				If $RemuxInputFolder <> "" Then
					IniWrite(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_graphics_inputfolder", $RemuxInputFolder)
					_SetData($input_26_01, $RemuxInputFolder)
					_SetLabel($label_26_04, $lng_conversiontext1 & " " & $RemuxInputFolder & $lng_conversiontext2)
				EndIf




			Case $msg1[0] = $Select_Button_31

				_GUI_Show_Series_Metadata()


			Case $msg1[0] = $button_31_02
				$IF1 = GUICtrlRead($input_31_01)
				$series_metadata_inputfolder = FileSelectFolder($lng_inputfoldertext, $IF1, -1, $IF1)
				If $series_metadata_inputfolder <> "" Then
					IniWrite(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_series_metadata_inputfolder", $series_metadata_inputfolder)
					_SetData($input_31_01, $series_metadata_inputfolder)
					_SetData($input_36_02, $series_metadata_inputfolder)
					_SetLabel($label_31_05, $lng_conversiontext1 & " " & $series_metadata_inputfolder & $lng_conversiontext2)
				EndIf


			Case $msg1[0] = $button_31_01

				IniWrite(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_series_metadata_inputfolder", GUICtrlRead($input_31_01))

				_Metadata_Series()

			Case $msg1[0] = $Select_Button_32

				_GUI_Show_Movies_Metadata()


			Case $msg1[0] = $button_32_02
				$IF1 = GUICtrlRead($input_32_01)
				$movies_metadata_inputfolder = FileSelectFolder($lng_inputfoldertext, $IF1, -1, $IF1)
				If $movies_metadata_inputfolder <> "" Then
					IniWrite(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_movies_metadata_inputfolder", $movies_metadata_inputfolder)
					_SetData($input_32_01, $movies_metadata_inputfolder)
					_SetData($input_36_01, $movies_metadata_inputfolder)
					_SetLabel($label_32_05, $lng_conversiontext1 & " " & $movies_metadata_inputfolder & $lng_conversiontext2)
				EndIf


			Case $msg1[0] = $button_32_01

				IniWrite(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_movies_metadata_inputfolder", GUICtrlRead($input_32_01))

				_Metadata_Movies()


			Case $msg1[0] = $Select_Button_33

				_GUI_Show_Videos_Metadata()


			Case $msg1[0] = $button_33_02
				$IF1 = GUICtrlRead($input_33_01)
				$videos_metadata_inputfolder = FileSelectFolder($lng_inputfoldertext, $IF1, -1, $IF1)
				If $videos_metadata_inputfolder <> "" Then
					IniWrite(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_videos_metadata_inputfolder", $videos_metadata_inputfolder)
					_SetData($input_33_01, $videos_metadata_inputfolder)
					_SetLabel($label_33_05, $lng_conversiontext1 & " " & $videos_metadata_inputfolder & $lng_conversiontext2)
				EndIf


			Case $msg1[0] = $button_33_01

				IniWrite(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_videos_metadata_inputfolder", GUICtrlRead($input_33_01))
				IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_fanart_nocover", GUICtrlRead($check_95_01))
				IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_fanart_nobackdrop", GUICtrlRead($check_95_02))
				IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_fanart_nonfo", GUICtrlRead($check_95_03))

				_Metadata_Videos()

			Case $msg1[0] = $Select_Button_34

 				_GUI_Show_Audio_Metadata()

			Case $msg1[0] = $button_34_01

				_Metadata_Audio()

			Case $msg1[0] = $button_34_02
				$IF1 = GUICtrlRead($input_34_01)
				$audio_metadata_inputfolder = FileSelectFolder($lng_inputfoldertext, $IF1, -1, $IF1)
				If $audio_metadata_inputfolder <> "" Then
					IniWrite(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_audio_metadata_inputfolder", $audio_metadata_inputfolder)
					_SetData($input_34_01, $audio_metadata_inputfolder)
					_SetLabel($label_34_05, $lng_conversiontext1 & " " & $audio_metadata_inputfolder & $lng_conversiontext2)
				EndIf

			Case $msg1[0] = $Select_Button_35

				_GUI_Show_Graphics_Metadata()


			Case $msg1[0] = $button_35_02
				$IF1 = GUICtrlRead($input_35_01)
				$ExifInputFolder = FileSelectFolder($lng_inputfoldertext, $IF1, -1, $IF1)
				If $ExifInputFolder <> "" Then
					IniWrite(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_graphics_metadata_inputfolder", $ExifInputFolder)
					_SetData($input_35_01, $ExifInputFolder)
					_SetLabel($label_35_04, $lng_conversiontext1 & " " & $ExifInputFolder & $lng_conversiontext2)
				EndIf


			Case $msg1[0] = $button_35_03
				$IF2 = GUICtrlRead($input_35_02)
				$ExifOutputFolder = FileSelectFolder($lng_outputfoldertext, $IF2, -1, $IF2)
				If $ExifOutputFolder <> "" Then
					IniWrite(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_graphics_metadata_outputfolder", $ExifOutputFolder)
					_SetData($input_35_02, $ExifOutputFolder)
				EndIf


			Case $msg1[0] = $button_35_01

				_CopyExif()


			Case $msg1[0] = $Select_Button_36

				_GUI_Show_Prepare_Metadata()


			Case $msg1[0] = $button_36_02
				$IF1 = GUICtrlRead($input_32_01)
				$movies_metadata_inputfolder = FileSelectFolder($lng_inputfoldertext, $IF1, -1, $IF1)
				If $movies_metadata_inputfolder <> "" Then
					IniWrite(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_movies_metadata_inputfolder", $movies_metadata_inputfolder)
					_SetData($input_32_01, $movies_metadata_inputfolder)
					_SetData($input_36_01, $movies_metadata_inputfolder)
					_SetLabel($label_32_05, $lng_conversiontext1 & " " & $movies_metadata_inputfolder & $lng_conversiontext2)
				EndIf


			Case $msg1[0] = $button_36_03
				$IF1 = GUICtrlRead($input_31_01)
				$series_metadata_inputfolder = FileSelectFolder($lng_inputfoldertext, $IF1, -1, $IF1)
				If $series_metadata_inputfolder <> "" Then
					IniWrite(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_series_metadata_inputfolder", $series_metadata_inputfolder)
					_SetData($input_31_01, $series_metadata_inputfolder)
					_SetData($input_36_02, $series_metadata_inputfolder)
					_SetLabel($label_31_05, $lng_conversiontext1 & " " & $series_metadata_inputfolder & $lng_conversiontext2)
				EndIf


			Case $msg1[0] = $button_36_01

				_PrepareSeries()


			Case $msg1[0] = $button_36_04

				_PrepareMovies()


			Case $msg1[0] = $Select_Button_41

				_GUI_Tools_Fix()


			Case $msg1[0] = $button_41_01

				_Fix()

			Case $msg1[0] = $button_41_02
				$IF1 = GUICtrlRead($input_41_01)
				$FixInputFolder = FileSelectFolder($lng_inputfoldertext, $IF1, -1, $IF1)
				If $FixInputFolder <> "" Then
					IniWrite(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_fix_inputfolder", $FixInputFolder)
					_SetData($input_41_01, $FixInputFolder)
					_SetLabel($label_41_04, $lng_conversiontext1 & " " & $FixInputFolder & $lng_conversiontext2)
				EndIf


			Case $msg1[0] = $button_41_03
				$IF2 = GUICtrlRead($input_41_02)
				$FixOutputFolder = FileSelectFolder($lng_outputfoldertext, $IF2, -1, $IF2)
				If $FixOutputFolder <> "" Then
					IniWrite(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_fix_outputfolder", $FixOutputFolder)
					_SetData($input_41_02, $FixOutputFolder)
				EndIf


			Case $msg1[0] = $Select_Button_42

				_GUI_Tools_3D()


			Case $msg1[0] = $button_42_01

				_Tag3D()


			Case $msg1[0] = $button_42_02
				$IF1 = GUICtrlRead($input_42_01)
				$3DInputFolder = FileSelectFolder($lng_inputfoldertext, $IF1, -1, $IF1)
				If $3DInputFolder <> "" Then
					IniWrite(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_3d_inputfolder", $3DInputFolder)
					_SetData($input_42_01, $3DInputFolder)
					_SetLabel($label_42_05, $lng_conversiontext1 & " " & $3DInputFolder & $lng_conversiontext2)
				EndIf


			Case $msg1[0] = $Select_Button_43

				_GUI_Tools_Extract()


			Case $msg1[0] = $button_43_01

				_Extract()


			Case $msg1[0] = $button_43_02
				$IF1 = GUICtrlRead($input_43_01)
				$ExtractInputFolder = FileSelectFolder($lng_inputfoldertext, $IF1, -1, $IF1)
				If $ExtractinputFolder <> "" Then
					IniWrite(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_extract_inputfolder", $ExtractInputFolder)
					_SetData($input_43_01, $ExtractinputFolder)
					_SetLabel($label_43_05, $lng_conversiontext1 & " " & $ExtractInputFolder & $lng_conversiontext2)
				EndIf



			Case $msg1[0] = $Select_Button_44

				_GUI_Tools_Kodi()


			Case $msg1[0] = $button_44_01

				_KodiRefreshMovieset()

			Case $msg1[0] = $button_44_02
				$IF1 = GUICtrlRead($input_44_01)
				$KodiToolsInputFolder = FileSelectFolder($lng_inputfoldertext, $IF1, -1, $IF1)
				If $KodiToolsInputFolder <> "" Then
					IniWrite(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_koditools_inputfolder", $KodiToolsInputFolder)
					_SetData($input_44_01, $KodiToolsInputFolder)
				EndIf

			Case $msg1[0] = $button_44_03

				_CopyArtistFanart(GUICtrlRead($input_44_02))

				MsgBox(0, "", $lng_sucess, 3)


			Case $msg1[0] = $button_44_04
				$IF1 = GUICtrlRead($input_44_02)
				$KodiToolsInputFolder = FileSelectFolder($lng_inputfoldertext, $IF1, -1, $IF1)
				If $KodiToolsInputFolder <> "" Then
					IniWrite(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_koditools_audiofolder", $KodiToolsInputFolder)
					_SetData($input_44_02, $KodiToolsInputFolder)
				EndIf


			Case $msg1[0] = $button_44_12
				$IF1 = _PathSplit(GUICtrlRead($input_44_12), $Drive, $Dir, $Filename, $Extension)
				$InputFolder = FileOpenDialog($lng_choose, $IF1[1] & $IF1[2], "db (*.db)")
				If $InputFolder <> "" Then
					IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_kodi_SQLite_database", $InputFolder)
					_SetData($input_44_12, $InputFolder)
				EndIf

			Case $msg1[0] = $button_44_20

				_MakeTVShowNfoKodi19()

				MsgBox(0, "", $lng_sucess, 3)


			Case $msg1[0] = $button_44_21
				$IF1 = GUICtrlRead($input_44_20)
				$kodi19_inputfolder = FileSelectFolder($lng_inputfoldertext, $IF1, -1, $IF1)
				If $kodi19_inputfolder <> "" Then
					IniWrite(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_kodi19_inputfolder", $kodi19_inputfolder)
					_SetData($input_44_20, $kodi19_inputfolder)
				EndIf

			Case $msg1[0] = $button_44_30

				_MakeMovieNfoKodi19()

				MsgBox(0, "", $lng_sucess, 3)


			Case $msg1[0] = $button_44_31
				$IF1 = GUICtrlRead($input_44_30)
				$kodi19_inputfolder1 = FileSelectFolder($lng_inputfoldertext, $IF1, -1, $IF1)
				If $kodi19_inputfolder1 <> "" Then
					IniWrite(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_kodi19_inputfolder1", $kodi19_inputfolder1)
					_SetData($input_44_30, $kodi19_inputfolder1)
				EndIf


			Case $msg1[0] = $button_44_40

				_FixNotation(GUICtrlRead($input_44_40))

				If $dotreturn = 2 then

					MsgBox(0, "", $lng_nofiles, 3)

				Else

					MsgBox(0, "", $lng_sucess, 3)

				EndIf


			Case $msg1[0] = $button_44_41
				$IF1 = GUICtrlRead($input_44_40)
				$kodidot_inputfolder1 = FileSelectFolder($lng_inputfoldertext, $IF1, -1, $IF1)
				If $kodidot_inputfolder1 <> "" Then
					IniWrite(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_kodidot_inputfolder", $kodidot_inputfolder1)
					_SetData($input_44_40, $kodidot_inputfolder1)
				EndIf



			Case $msg1[0] = $Select_Button_45

				_GUI_Tools_Stub()


			Case $msg1[0] = $Select_Button_46

				_GUI_Tools_Audio()


			Case $msg1[0] = $button_47_01

				_Make_MediaStub()


			Case $msg1[0] = $button_47_02
				$IF1 = GUICtrlRead($input_47_01)
				$InputFolder = FileSelectFolder($lng_inputfoldertext, $IF1, -1, $IF1)
				If $InputFolder <> "" Then
					IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_mediastub_outputfolder", $InputFolder)
					_SetData($input_47_01, $InputFolder)
				EndIf


			Case $msg1[0] = $button_48_01

				If GUICtrlRead($radio_48_01) = 1 Then IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_audiotools_copy", "1")
				If GUICtrlRead($radio_48_02) = 1 Then IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_audiotools_copy", "4")

				$ini_audiotools_copy = IniRead(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_audiotools_copy", "1")

				_Make_Audio_Folder($ini_audiotools_copy)

				MsgBox(0, "", $lng_sucess, 3)


			Case $msg1[0] = $button_48_02
				$IF1 = GUICtrlRead($input_48_01)
				$InputFolder = FileSelectFolder($lng_inputfoldertext, $IF1, -1, $IF1)
				If $InputFolder <> "" Then
					IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_audiotools_inputfolder", $InputFolder)
					_SetData($input_48_01, $InputFolder)
				EndIf

			Case $msg1[0] = $button_48_03
				$IF1 = GUICtrlRead($input_48_02)
				$InputFolder = FileSelectFolder($lng_outputfoldertext, $IF1, -1, $IF1)
				If $InputFolder <> "" Then
					IniWrite(@ScriptDir & "\Media-Buddy.ini", "settings", "ini_audiotools_outputfolder", $InputFolder)
					_SetData($input_48_02, $InputFolder)
				EndIf



			Case $msg1[0] = $Select_Button_51

				_GUI_Settings_Program()


			Case $msg1[0] = $Button_51

				Local $value = MsgBox(35, $lng_save, $lng_saveconfig & "." & @CRLF & $lng_langchange & @CRLF & @CRLF & $lng_saveexit & @CRLF & $lng_savenotexit & @CRLF & $lng_savenot)
				If $value = 6 Then

					_Exit(1)

				EndIf
				If $value = 7 Then

					_SaveSettings()

				EndIf


			Case $msg1[0] = $Button_51_01

				Local $value = MsgBox(33, $lng_save, $lng_saveconfig & "." & @CRLF & $lng_savelanguages & @CRLF & GUICtrlRead($combo_51_07) & @CRLF & $lng_savelanguages1)
				If $value = 1 Then

					_SetLanguages()

				EndIf


			Case $msg1[0] = $button_51_03
				$IF1 = _PathSplit(GUICtrlRead($input_51_03), $Drive, $Dir, $Filename, $Extension)
				$InputFolder = FileOpenDialog($lng_choose, $IF1[1] & $IF1[2], "Exe (*.exe)")
				If $InputFolder <> "" Then
					IniWrite(@ScriptDir & "\Media-Buddy.ini", "path", "ini_ffmpeg_path", $InputFolder)
					_SetData($input_51_03, $InputFolder)
				EndIf


			Case $msg1[0] = $button_51_04
				$IF1 = _PathSplit(GUICtrlRead($input_51_04), $Drive, $Dir, $Filename, $Extension)
				$InputFolder = FileOpenDialog($lng_choose, $IF1[1] & $IF1[2], "Exe (*.exe)")
				If $InputFolder <> "" Then
					IniWrite(@ScriptDir & "\Media-Buddy.ini", "path", "ini_mkvmerge_path", $InputFolder)
					_SetData($input_51_04, $InputFolder)
				EndIf


			Case $msg1[0] = $button_51_05
				$IF1 = _PathSplit(GUICtrlRead($input_51_05), $Drive, $Dir, $Filename, $Extension)
				$InputFolder = FileOpenDialog($lng_choose, $IF1[1] & $IF1[2], "Exe (*.exe)")
				If $InputFolder <> "" Then
					IniWrite(@ScriptDir & "\Media-Buddy.ini", "path", "ini_mkvpropedit_path", $InputFolder)
					_SetData($input_51_05, $InputFolder)
				EndIf


			Case $msg1[0] = $button_51_06
				$IF1 = _PathSplit(GUICtrlRead($input_51_06), $Drive, $Dir, $Filename, $Extension)
				$InputFolder = FileOpenDialog($lng_choose, $IF1[1] & $IF1[2], "Exe (*.exe)")
				If $InputFolder <> "" Then
					IniWrite(@ScriptDir & "\Media-Buddy.ini", "path", "ini_mkvextract_path", $InputFolder)
					_SetData($input_51_06, $InputFolder)
				EndIf


			Case $msg1[0] = $Select_Button_52

				_GUI_Settings_Video()


			Case $msg1[0] = $Select_Button_53

				_GUI_Settings_Metadata()


			Case $msg1[0] = $button_53_32

				$IF1 = GUICtrlRead($input_53_32)
				$InputFolder = FileSelectFolder($lng_inputfoldertext, $IF1, -1, $IF1)
				If $InputFolder <> "" Then
					IniWrite(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_moviesetfolder", $InputFolder)
					_SetData($input_53_32, $InputFolder)
				EndIf

			Case $msg1[0] = $button_53_42

				_EditRatings()


			Case $msg1[0] = $Select_Button_54

				_GUI_Settings_Filenames()


			Case $msg1[0] = $Select_Button_56

				_GUI_Settings_Audio()


			Case $msg1[0] = $button_56_32

				$IF1 = GUICtrlRead($input_56_32)
				$InputFolder = FileSelectFolder($lng_inputfoldertext, $IF1, -1, $IF1)
				If $InputFolder <> "" Then
					IniWrite(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_artistfolder", $InputFolder)
					_SetData($input_56_32, $InputFolder)
				EndIf


			Case $msg1[0] = $Select_Button_57

				_GUI_Settings_Graphics()


			Case $msg1[0] = $button_61_00

				_Metadata_Correction_Series()


			Case $msg1[0] = $button_62_00

				_Metadata_Correction_Movies()


			Case $msg1[0] = $button_63_00

				_Metadata_Correction_Videos()


			Case $msg1[0] = $button_64_00

				_Metadata_Correction_Audio()


			Case $msg1[0] = $Select_Button_61

				_GUI_Show_Series_Correction()


			Case $msg1[0] = $Select_Button_62

				_GUI_Show_Movies_Correction()


			Case $msg1[0] = $Select_Button_63

				_GUI_Show_Videos_Correction()


			Case $msg1[0] = $Select_Button_64

				_GUI_Show_Audio_Correction()


			Case $msg1[0] = $button_61_01
				$IF1 = GUICtrlRead($input_61_01)
				$MetadataCorrectionFolder = FileSelectFolder($lng_inputfoldertext, $IF1, -1, $IF1)
				If $MetadataCorrectionFolder <> "" Then
					IniWrite(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_series_correction_inputfolder", $MetadataCorrectionFolder)
					_SetData($input_61_01, $MetadataCorrectionFolder)
				Else
					IniWrite(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_series_correction_inputfolder", $IF1)
				EndIf

			Case $msg1[0] = $button_61_02

				_UpdateGenres(GUICtrlRead($input_61_01))


			Case $msg1[0] = $button_62_01
				$IF1 = GUICtrlRead($input_62_01)
				$MetadataCorrectionFolder = FileSelectFolder($lng_inputfoldertext, $IF1, -1, $IF1)
				If $MetadataCorrectionFolder <> "" Then
					IniWrite(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_movies_correction_inputfolder", $MetadataCorrectionFolder)
					_SetData($input_62_01, $MetadataCorrectionFolder)
				Else
					IniWrite(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_movies_correction_inputfolder", $IF1)
				EndIf


			Case $msg1[0] = $button_63_01
				$IF1 = GUICtrlRead($input_63_01)
				$MetadataCorrectionFolder = FileSelectFolder($lng_inputfoldertext, $IF1, -1, $IF1)
				If $MetadataCorrectionFolder <> "" Then
					IniWrite(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_videos_correction_inputfolder", $MetadataCorrectionFolder)
					_SetData($input_63_01, $MetadataCorrectionFolder)
				Else
					IniWrite(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_videos_correction_inputfolder", $IF1)
				EndIf


			Case $msg1[0] = $button_64_01
				$IF1 = GUICtrlRead($input_64_01)
				$MetadataCorrectionFolder = FileSelectFolder($lng_inputfoldertext, $IF1, -1, $IF1)
				If $MetadataCorrectionFolder <> "" Then
					IniWrite(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_audio_correction_inputfolder", $MetadataCorrectionFolder)
					_SetData($input_64_01, $MetadataCorrectionFolder)
				Else
					IniWrite(@ScriptDir & "\Media-Buddy.ini", "folder", "ini_audio_correction_inputfolder", $IF1)
				EndIf


			Case $msg1[0] = $GUI_EVENT_CLOSE Or $msg1[0] = $Exititem

				_Exit()


		EndSelect

		Sleep(20)

	WEnd

EndFunc
#EndRegion ;GUI Functions

;End of Program
